/*===========================================================================*/
/*   (Engine/interp.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>

extern obj_t _src_files__222_engine_param;
extern obj_t current_output_port;
extern obj_t find_file_path_55___os(obj_t, obj_t);
extern obj_t warning___error(obj_t);
extern obj_t interp_engine_interp(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t reverse___r4_pairs_and_lists_6_3(obj_t);
extern obj_t member___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t _interp_engine_interp(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_engine_interp(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___os(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t command_line;
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94_engine_interp();
extern bool_t bigloo_strcmp(obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_engine_interp();
static obj_t interp_parse_args_247_engine_interp(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t loadq___eval(obj_t);
extern obj_t repl___eval();
extern obj_t _bigloo_interpreter__95___reader;
static obj_t require_initialization_114_engine_interp = BUNSPEC;
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE(interp_env_241_engine_interp, _interp_engine_interp1163, _interp_engine_interp, 0L, 6);
DEFINE_STRING(string1161_engine_interp, string1161_engine_interp1164, "-i", 2);
DEFINE_STRING(string1159_engine_interp, string1159_engine_interp1165, "Can't file startup file -- ", 27);
DEFINE_STRING(string1160_engine_interp, string1160_engine_interp1166, "interp", 6);
DEFINE_STRING(string1158_engine_interp, string1158_engine_interp1167, "Welcome to the interpreter", 26);



/* module-initialization */
obj_t 
module_initialization_70_engine_interp(long checksum_81, char *from_82)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_engine_interp))
	{
	   require_initialization_114_engine_interp =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_engine_interp();
	   imported_modules_init_94_engine_interp();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_engine_interp()
{
   AN_OBJECT;
   {	/* Engine/interp.scm 14 */
      module_initialization_70___os(((long) 0), "ENGINE_INTERP");
      module_initialization_70___error(((long) 0), "ENGINE_INTERP");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "ENGINE_INTERP");
      module_initialization_70___r4_output_6_10_3(((long) 0), "ENGINE_INTERP");
      module_initialization_70___eval(((long) 0), "ENGINE_INTERP");
      module_initialization_70___reader(((long) 0), "ENGINE_INTERP");
      return BUNSPEC;
   }
}



/* interp */
obj_t 
interp_engine_interp(obj_t version_1, obj_t verbose_2, obj_t files_3, obj_t startup_4, obj_t path_5, obj_t args_6)
{
   AN_OBJECT;
   {	/* Engine/interp.scm 21 */
      _bigloo_interpreter__95___reader = BTRUE;
      {		/* Engine/interp.scm 23 */
	 bool_t test_94;
	 {	/* Engine/interp.scm 23 */
	    bool_t test_95;
	    {	/* ./Ieee/fixnum.scm 7133 */
	       long aux_96;
	       aux_96 =
		  (long) CINT(verbose_2);
	       test_95 =
		  (aux_96 >= ((long) 0));
	    }
	    if (test_95)
	      {		/* Engine/interp.scm 23 */
		 if (
		    PAIRP(files_3))
		   {	/* Engine/interp.scm 23 */
		      test_94 = ((bool_t) 0)
			 ;
		   }
		 else
		   {	/* Engine/interp.scm 23 */
		      test_94 = ((bool_t) 1)
			 ;
		   }
	      }
	    else
	      {		/* Engine/interp.scm 23 */
		 test_94 = ((bool_t) 0)
		    ;
	      }
	 }
	 if (test_94)
	   {	/* Engine/interp.scm 23 */
	      PROCEDURE_ENTRY(version_1) (version_1, BEOA);
	      display_2_122___r4_output_6_10_3(string1158_engine_interp, current_output_port);
	      {		/* ./Ieee/output.scm 9332 */
		 unsigned char aux_104;
		 aux_104 =
		    WRITE_CHAR(((unsigned char) '\n'), current_output_port);
		 BCHAR(aux_104);
	      }
	   }
	 else
	   {	/* Engine/interp.scm 23 */
	      BUNSPEC;
	   }
      }
      command_line =
	 interp_parse_args_247_engine_interp(args_6);
      if (
	 STRINGP(startup_4))
	{	/* Engine/interp.scm 31 */
	   obj_t path_15;
	   {	/* Engine/interp.scm 31 */
	      obj_t home_23;
	      {		/* ./Llib/os.scm 1260 */
		 bool_t test1187_54;
		 test1187_54 =
		    (long) getenv("HOME");
		 if (test1187_54)
		   {	/* ./Llib/os.scm 1261 */
		      char *aux_112;
		      aux_112 =
			 (char *) getenv("HOME");
		      home_23 =
			 string_to_bstring(aux_112);
		   }
		 else
		   {	/* ./Llib/os.scm 1260 */
		      home_23 = BFALSE;
		   }
	      }
	      if (
		 STRINGP(home_23))
		{	/* Engine/interp.scm 32 */
		   path_15 =
		      MAKE_PAIR(home_23, path_5);
		}
	      else
		{	/* Engine/interp.scm 32 */
		   path_15 = path_5;
		}
	   }
	   {	/* Engine/interp.scm 35 */
	      obj_t fstartup_16;
	      fstartup_16 =
		 find_file_path_55___os(startup_4, path_15);
	      if (
		 CBOOL(fstartup_16))
		{	/* Engine/interp.scm 36 */
		   loadq___eval(startup_4);
		}
	      else
		{	/* Engine/interp.scm 38 */
		   obj_t list1013_17;
		   {	/* Engine/interp.scm 38 */
		      obj_t arg1017_19;
		      {		/* Engine/interp.scm 38 */
			 obj_t arg1019_20;
			 {	/* Engine/interp.scm 38 */
			    obj_t arg1024_22;
			    arg1024_22 =
			       MAKE_PAIR(startup_4, BNIL);
			    arg1019_20 =
			       MAKE_PAIR(string1159_engine_interp, arg1024_22);
			 }
			 {	/* Engine/interp.scm 38 */
			    obj_t aux_124;
			    aux_124 =
			       BCHAR(((unsigned char) '\n'));
			    arg1017_19 =
			       MAKE_PAIR(aux_124, arg1019_20);
			 }
		      }
		      list1013_17 =
			 MAKE_PAIR(string1160_engine_interp, arg1017_19);
		   }
		   warning___error(list1013_17);
		}
	   }
	}
      else
	{	/* Engine/interp.scm 30 */
	   BUNSPEC;
	}
      if (
	 PAIRP(files_3))
	{
	   obj_t l1002_26;
	   {	/* Engine/interp.scm 43 */
	      bool_t aux_131;
	      l1002_26 = files_3;
	    lname1003_27:
	      if (
		 PAIRP(l1002_26))
		{	/* Engine/interp.scm 43 */
		   loadq___eval(
		      CAR(l1002_26));
		   {
		      obj_t l1002_136;
		      l1002_136 =
			 CDR(l1002_26);
		      l1002_26 = l1002_136;
		      goto lname1003_27;
		   }
		}
	      else
		{	/* Engine/interp.scm 43 */
		   aux_131 = ((bool_t) 1);
		}
	      BBOOL(aux_131);
	   }
	}
      else
	{	/* Engine/interp.scm 42 */
	   repl___eval();
	}
      return
	 BINT(((long) 0));
   }
}



/* _interp */
obj_t 
_interp_engine_interp(obj_t env_74, obj_t version_75, obj_t verbose_76, obj_t files_77, obj_t startup_78, obj_t path_79, obj_t args_80)
{
   AN_OBJECT;
   {	/* Engine/interp.scm 21 */
      return
	 interp_engine_interp(version_75, verbose_76, files_77, startup_78, path_79, args_80);
   }
}



/* interp-parse-args */
obj_t 
interp_parse_args_247_engine_interp(obj_t args_7)
{
   AN_OBJECT;
   {	/* Engine/interp.scm 50 */
      {
	 obj_t args_31;
	 obj_t res_32;
	 args_31 =
	    CDR(args_7);
	 res_32 = BNIL;
       loop_33:
	 if (
	    NULLP(args_31))
	   {	/* Engine/interp.scm 54 */
	      return
		 append_2_18___r4_pairs_and_lists_6_3(_src_files__222_engine_param,
		 reverse___r4_pairs_and_lists_6_3(res_32));
	   }
	 else
	   {	/* Engine/interp.scm 56 */
	      bool_t test1055_38;
	      {		/* ./Ieee/string.scm 8101 */
		 obj_t aux_146;
		 aux_146 =
		    CAR(args_31);
		 test1055_38 =
		    bigloo_strcmp(aux_146, string1161_engine_interp);
	      }
	      if (test1055_38)
		{	/* Engine/interp.scm 56 */
		   {
		      obj_t args_150;
		      args_150 =
			 CDR(args_31);
		      args_31 = args_150;
		      goto loop_33;
		   }
		}
	      else
		{	/* Engine/interp.scm 58 */
		   bool_t test1068_40;
		   {	/* Engine/interp.scm 58 */
		      obj_t aux_152;
		      aux_152 =
			 member___r4_pairs_and_lists_6_3(
			 CAR(args_31), _src_files__222_engine_param);
		      test1068_40 =
			 CBOOL(aux_152);
		   }
		   if (test1068_40)
		     {	/* Engine/interp.scm 58 */
			{
			   obj_t args_157;
			   args_157 =
			      CDR(args_31);
			   args_31 = args_157;
			   goto loop_33;
			}
		     }
		   else
		     {	/* Engine/interp.scm 58 */
			{	/* Engine/interp.scm 61 */
			   obj_t arg1138_42;
			   obj_t arg1142_43;
			   arg1138_42 =
			      CDR(args_31);
			   {	/* ./Ieee/pair-list.scm 5689 */
			      obj_t aux_160;
			      aux_160 =
				 CAR(args_31);
			      arg1142_43 =
				 MAKE_PAIR(aux_160, res_32);
			   }
			   {
			      obj_t res_164;
			      obj_t args_163;
			      args_163 = arg1138_42;
			      res_164 = arg1142_43;
			      res_32 = res_164;
			      args_31 = args_163;
			      goto loop_33;
			   }
			}
		     }
		}
	   }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_engine_interp()
{
   AN_OBJECT;
   {	/* Engine/interp.scm 14 */
      return
	 module_initialization_70_engine_param(((long) 0), "ENGINE_INTERP");
   }
}
