/*===========================================================================*/
/*   (Expand/case.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;


static obj_t method_init_76_expand_case();
static obj_t type_test_66_expand_case(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t mark_symbol_non_user__17_ast_ident(obj_t);
static obj_t _expand_case1464_252_expand_case(obj_t, obj_t, obj_t);
static obj_t do_cnst_case_140_expand_case(obj_t, obj_t, obj_t);
extern obj_t expand_case_249_expand_case(obj_t, obj_t);
static bool_t type_match__71_expand_case(obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t module_initialization_70_expand_case(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t general_expand_case(obj_t, obj_t);
static obj_t case_type_186_expand_case(obj_t, obj_t);
static obj_t imported_modules_init_94_expand_case();
static obj_t loop__120_expand_case(obj_t, obj_t, obj_t);
extern obj_t normalize_progn_143_tools_progn(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_expand_case();
extern obj_t open_input_string(obj_t);
static obj_t loop_expand_case(obj_t);
extern obj_t read___reader(obj_t);
static obj_t do_generic_case_59_expand_case(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_expand_case = BUNSPEC;
static obj_t cnst_init_137_expand_case();
static obj_t do_typed_case_38_expand_case(obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[20];

DEFINE_EXPORT_PROCEDURE(expand_case_env_215_expand_case, _expand_case1464_252_expand_case1475, _expand_case1464_252_expand_case, 0L, 2);
DEFINE_STRING(string1469_expand_case, string1469_expand_case1476, "Unknown `case' type", 19);
DEFINE_STRING(string1470_expand_case, string1470_expand_case1477, "MEMQ QUOTE EQ? CASE-VALUE C-FIXNUM? C-CHAR? LABELS CNST->INTEGER CNST? IF LET CASE AUX ELSE ETHEROGENEOUS FAIL-TYPE CNST CHAR LONG INTEGER ", 139);
DEFINE_STRING(string1468_expand_case, string1468_expand_case1478, "type-test", 9);
DEFINE_STRING(string1467_expand_case, string1467_expand_case1479, "case_else", 9);
DEFINE_STRING(string1466_expand_case, string1466_expand_case1480, "Illegal `case' form", 19);
DEFINE_STRING(string1465_expand_case, string1465_expand_case1481, "case", 4);



/* module-initialization */
obj_t 
module_initialization_70_expand_case(long checksum_814, char *from_815)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_expand_case))
	{
	   require_initialization_114_expand_case =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_expand_case();
	   cnst_init_137_expand_case();
	   imported_modules_init_94_expand_case();
	   method_init_76_expand_case();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_expand_case()
{
   AN_OBJECT;
   {	/* Expand/case.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "EXPAND_CASE");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "EXPAND_CASE");
      module_initialization_70___reader(((long) 0), "EXPAND_CASE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_expand_case()
{
   AN_OBJECT;
   {	/* Expand/case.scm 14 */
      {		/* Expand/case.scm 14 */
	 obj_t cnst_port_138_807;
	 cnst_port_138_807 =
	    open_input_string(string1470_expand_case);
	 {
	    long i_808;
	    i_808 = ((long) 19);
	  loop_809:
	    {	/* Expand/case.scm 14 */
	       bool_t test1471_810;
	       test1471_810 =
		  (i_808 == ((long) -1));
	       if (test1471_810)
		 {	/* Expand/case.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Expand/case.scm 14 */
		    {	/* Expand/case.scm 14 */
		       obj_t arg1472_811;
		       {	/* Expand/case.scm 14 */
			  obj_t list1473_812;
			  list1473_812 =
			     MAKE_PAIR(cnst_port_138_807, BNIL);
			  arg1472_811 =
			     read___reader(list1473_812);
		       }
		       CNST_TABLE_SET(i_808, arg1472_811);
		    }
		    {	/* Expand/case.scm 14 */
		       int aux_813;
		       {	/* Expand/case.scm 14 */
			  long aux_832;
			  aux_832 =
			     (i_808 - ((long) 1));
			  aux_813 =
			     (int) (aux_832);
		       }
		       {
			  long i_835;
			  i_835 =
			     (long) (aux_813);
			  i_808 = i_835;
			  goto loop_809;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* expand-case */
obj_t 
expand_case_249_expand_case(obj_t x_1, obj_t e_2)
{
   AN_OBJECT;
   {	/* Expand/case.scm 33 */
      {
	 obj_t value_73;
	 obj_t clauses_74;
	 if (
	    PAIRP(x_1))
	   {	/* Expand/case.scm 35 */
	      obj_t cdr_128_145_79;
	      cdr_128_145_79 =
		 CDR(x_1);
	      if (
		 PAIRP(cdr_128_145_79))
		{	/* Expand/case.scm 35 */
		   value_73 =
		      CAR(cdr_128_145_79);
		   clauses_74 =
		      CDR(cdr_128_145_79);
		   {	/* Expand/case.scm 37 */
		      obj_t case_value_58_83;
		      case_value_58_83 =
			 case_type_186_expand_case(x_1, clauses_74);
		      {		/* Expand/case.scm 37 */
			 bool_t test_843;
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_844;
			    aux_844 =
			       CNST_TABLE_REF(((long) 0));
			    test_843 =
			       (case_value_58_83 == aux_844);
			 }
			 if (test_843)
			   {	/* Expand/case.scm 37 */
			      return
				 do_typed_case_38_expand_case(
				 CNST_TABLE_REF(((long) 1)), value_73, clauses_74, e_2);
			   }
			 else
			   {	/* Expand/case.scm 37 */
			      bool_t test_849;
			      {		/* ./Ieee/equiv.scm 5508 */
				 obj_t aux_850;
				 aux_850 =
				    CNST_TABLE_REF(((long) 2));
				 test_849 =
				    (case_value_58_83 == aux_850);
			      }
			      if (test_849)
				{	/* Expand/case.scm 37 */
				   return
				      do_typed_case_38_expand_case(
				      CNST_TABLE_REF(((long) 2)), value_73, clauses_74, e_2);
				}
			      else
				{	/* Expand/case.scm 37 */
				   bool_t test_855;
				   {	/* ./Ieee/equiv.scm 5508 */
				      obj_t aux_856;
				      aux_856 =
					 CNST_TABLE_REF(((long) 3));
				      test_855 =
					 (case_value_58_83 == aux_856);
				   }
				   if (test_855)
				     {	/* Expand/case.scm 37 */
					return
					   do_cnst_case_140_expand_case(value_73, clauses_74, e_2);
				     }
				   else
				     {	/* Expand/case.scm 37 */
					return
					   do_generic_case_59_expand_case(value_73, clauses_74, e_2);
				     }
				}
			   }
		      }
		   }
		}
	      else
		{	/* Expand/case.scm 35 */
		 tag_121_151_76:
		   FAILURE(string1465_expand_case, string1466_expand_case, x_1);
		}
	   }
	 else
	   {	/* Expand/case.scm 35 */
	      goto tag_121_151_76;
	   }
      }
   }
}



/* _expand-case1464 */
obj_t 
_expand_case1464_252_expand_case(obj_t env_802, obj_t x_803, obj_t e_804)
{
   AN_OBJECT;
   {	/* Expand/case.scm 33 */
      return
	 expand_case_249_expand_case(x_803, e_804);
   }
}



/* case-type */
obj_t 
case_type_186_expand_case(obj_t x_3, obj_t clauses_4)
{
   AN_OBJECT;
   {	/* Expand/case.scm 64 */
      {
	 obj_t datum_93;
	 obj_t datums_95;
	 {
	    obj_t clauses_97;
	    obj_t type_98;
	    clauses_97 = clauses_4;
	    type_98 = BNIL;
	  loop_99:
	    if (
	       NULLP(clauses_97))
	      {		/* Expand/case.scm 109 */
		 return type_98;
	      }
	    else
	      {
		 obj_t exps_101;
		 obj_t datum_103;
		 obj_t exps_104;
		 {	/* Expand/case.scm 111 */
		    obj_t e_138_2_107;
		    e_138_2_107 =
		       CAR(clauses_97);
		    if (
		       PAIRP(e_138_2_107))
		      {		/* Expand/case.scm 111 */
			 bool_t test_870;
			 {	/* ./Ieee/equiv.scm 5508 */
			    obj_t aux_873;
			    obj_t aux_871;
			    aux_873 =
			       CNST_TABLE_REF(((long) 6));
			    aux_871 =
			       CAR(e_138_2_107);
			    test_870 =
			       (aux_871 == aux_873);
			 }
			 if (test_870)
			   {	/* Expand/case.scm 111 */
			      exps_101 =
				 CDR(e_138_2_107);
			      {		/* Expand/case.scm 113 */
				 bool_t test_876;
				 {	/* Expand/case.scm 113 */
				    bool_t test_877;
				    {	/* ./Ieee/pair-list.scm 5912 */
				       obj_t aux_878;
				       aux_878 =
					  CDR(clauses_97);
				       test_877 =
					  NULLP(aux_878);
				    }
				    if (test_877)
				      {		/* Expand/case.scm 113 */
					 test_876 =
					    NULLP(exps_101)
					    ;
				      }
				    else
				      {		/* Expand/case.scm 113 */
					 test_876 = ((bool_t) 1)
					    ;
				      }
				 }
				 if (test_876)
				   {	/* Expand/case.scm 113 */
				      FAILURE(string1465_expand_case, string1466_expand_case, x_3);
				   }
				 else
				   {	/* Expand/case.scm 113 */
				      return type_98;
				   }
			      }
			   }
			 else
			   {	/* Expand/case.scm 111 */
			      obj_t car_149_47_111;
			      car_149_47_111 =
				 CAR(e_138_2_107);
			      if (
				 (car_149_47_111 == BNIL))
				{	/* Expand/case.scm 111 */
				 tag_137_199_106:
				   FAILURE(string1465_expand_case, string1466_expand_case, x_3);
				}
			      else
				{	/* Expand/case.scm 111 */
				   datum_103 = car_149_47_111;
				   exps_104 =
				      CDR(e_138_2_107);
				   if (
				      NULLP(exps_104))
				     {	/* Expand/case.scm 118 */
					FAILURE(string1465_expand_case, string1466_expand_case, x_3);
				     }
				   else
				     {	/* Expand/case.scm 120 */
					obj_t dtype_120;
					datums_95 = datum_103;
					{
					   obj_t datums_138;
					   obj_t type_139;
					   datums_138 = datums_95;
					   type_139 = BNIL;
					 loop_140:
					   if (
					      NULLP(datums_138))
					     {	/* Expand/case.scm 94 */
						dtype_120 = type_139;
					     }
					   else
					     {	/* Expand/case.scm 94 */
						if (
						   PAIRP(datums_138))
						  {	/* Expand/case.scm 96 */
						     {	/* Expand/case.scm 102 */
							obj_t dtype_143;
							datum_93 =
							   CAR(datums_138);
							if (
							   INTEGERP(datum_93))
							  {	/* Expand/case.scm 83 */
							     dtype_143 =
								CNST_TABLE_REF(((long) 0));
							  }
							else
							  {	/* Expand/case.scm 83 */
							     if (
								CHARP(datum_93))
							       {	/* Expand/case.scm 85 */
								  dtype_143 =
								     CNST_TABLE_REF(((long) 2));
							       }
							     else
							       {	/* Expand/case.scm 85 */
								  if (
								     CNSTP(datum_93))
								    {	/* Expand/case.scm 87 */
								       dtype_143 =
									  CNST_TABLE_REF(((long) 3));
								    }
								  else
								    {	/* Expand/case.scm 87 */
								       dtype_143 =
									  CNST_TABLE_REF(((long) 4));
								    }
							       }
							  }
							if (
							   type_match__71_expand_case(dtype_143, type_139))
							  {
							     obj_t type_910;
							     obj_t datums_908;
							     datums_908 =
								CDR(datums_138);
							     type_910 =
								general_expand_case(dtype_143, type_139);
							     type_139 = type_910;
							     datums_138 = datums_908;
							     goto loop_140;
							  }
							else
							  {	/* Expand/case.scm 103 */
							     dtype_120 =
								CNST_TABLE_REF(((long) 4));
							  }
						     }
						  }
						else
						  {	/* Expand/case.scm 96 */
						     FAILURE(string1465_expand_case, string1466_expand_case, x_3);
						  }
					     }
					}
					if (
					   type_match__71_expand_case(dtype_120, type_98))
					  {
					     obj_t type_918;
					     obj_t clauses_916;
					     clauses_916 =
						CDR(clauses_97);
					     type_918 =
						general_expand_case(dtype_120, type_98);
					     type_98 = type_918;
					     clauses_97 = clauses_916;
					     goto loop_99;
					  }
					else
					  {	/* Expand/case.scm 121 */
					     return
						CNST_TABLE_REF(((long) 5));
					  }
				     }
				}
			   }
		      }
		    else
		      {		/* Expand/case.scm 111 */
			 goto tag_137_199_106;
		      }
		 }
	      }
	 }
      }
   }
}



/* type-match? */
bool_t 
type_match__71_expand_case(obj_t type1_87, obj_t type2_88)
{
   AN_OBJECT;
   {	/* Expand/case.scm 65 */
      {		/* Expand/case.scm 65 */
	 bool_t _ortest_1030_124;
	 _ortest_1030_124 =
	    NULLP(type1_87);
	 if (_ortest_1030_124)
	   {	/* Expand/case.scm 65 */
	      return _ortest_1030_124;
	   }
	 else
	   {	/* Expand/case.scm 66 */
	      bool_t _ortest_1031_125;
	      _ortest_1031_125 =
		 NULLP(type2_88);
	      if (_ortest_1031_125)
		{	/* Expand/case.scm 66 */
		   return _ortest_1031_125;
		}
	      else
		{	/* Expand/case.scm 67 */
		   bool_t test_926;
		   {	/* Expand/case.scm 67 */
		      bool_t test_927;
		      {		/* ./Ieee/equiv.scm 5508 */
			 obj_t aux_928;
			 aux_928 =
			    CNST_TABLE_REF(((long) 4));
			 test_927 =
			    (type1_87 == aux_928);
		      }
		      if (test_927)
			{	/* Expand/case.scm 67 */
			   test_926 = ((bool_t) 0)
			      ;
			}
		      else
			{	/* Expand/case.scm 67 */
			   test_926 = ((bool_t) 1)
			      ;
			}
		   }
		   if (test_926)
		     {	/* Expand/case.scm 68 */
			bool_t _ortest_1033_127;
			_ortest_1033_127 =
			   (type1_87 == type2_88);
			if (_ortest_1033_127)
			  {	/* Expand/case.scm 68 */
			     return _ortest_1033_127;
			  }
			else
			  {	/* Expand/case.scm 69 */
			     bool_t _ortest_1034_128;
			     {	/* Expand/case.scm 69 */
				bool_t test_933;
				{	/* ./Ieee/equiv.scm 5508 */
				   obj_t aux_934;
				   aux_934 =
				      CNST_TABLE_REF(((long) 3));
				   test_933 =
				      (type1_87 == aux_934);
				}
				if (test_933)
				  {	/* ./Ieee/equiv.scm 5508 */
				     obj_t aux_937;
				     aux_937 =
					CNST_TABLE_REF(((long) 2));
				     _ortest_1034_128 =
					(type2_88 == aux_937);
				  }
				else
				  {	/* Expand/case.scm 69 */
				     _ortest_1034_128 = ((bool_t) 0);
				  }
			     }
			     if (_ortest_1034_128)
			       {	/* Expand/case.scm 69 */
				  return _ortest_1034_128;
			       }
			     else
			       {	/* Expand/case.scm 71 */
				  bool_t test_941;
				  {	/* ./Ieee/equiv.scm 5508 */
				     obj_t aux_942;
				     aux_942 =
					CNST_TABLE_REF(((long) 2));
				     test_941 =
					(type1_87 == aux_942);
				  }
				  if (test_941)
				    {	/* ./Ieee/equiv.scm 5508 */
				       obj_t aux_945;
				       aux_945 =
					  CNST_TABLE_REF(((long) 3));
				       return
					  (type2_88 == aux_945);
				    }
				  else
				    {	/* Expand/case.scm 71 */
				       return ((bool_t) 0);
				    }
			       }
			  }
		     }
		   else
		     {	/* Expand/case.scm 67 */
			return ((bool_t) 0);
		     }
		}
	   }
      }
   }
}



/* general */
obj_t 
general_expand_case(obj_t type1_90, obj_t type2_91)
{
   AN_OBJECT;
   {	/* Expand/case.scm 73 */
      if (
	 (type1_90 == type2_91))
	{	/* Expand/case.scm 74 */
	   return type1_90;
	}
      else
	{	/* Expand/case.scm 76 */
	   bool_t test_950;
	   {	/* ./Ieee/equiv.scm 5508 */
	      obj_t aux_951;
	      aux_951 =
		 CNST_TABLE_REF(((long) 3));
	      test_950 =
		 (type1_90 == aux_951);
	   }
	   if (test_950)
	     {	/* Expand/case.scm 76 */
		return type1_90;
	     }
	   else
	     {	/* Expand/case.scm 76 */
		if (
		   NULLP(type2_91))
		  {	/* Expand/case.scm 78 */
		     return type1_90;
		  }
		else
		  {	/* Expand/case.scm 78 */
		     return type2_91;
		  }
	     }
	}
   }
}



/* do-typed-case */
obj_t 
do_typed_case_38_expand_case(obj_t type_5, obj_t value_6, obj_t clauses_7, obj_t e_8)
{
   AN_OBJECT;
   {	/* Expand/case.scm 131 */
      {		/* Expand/case.scm 132 */
	 obj_t else_body_107_148;
	 {
	    obj_t clauses_210;
	    clauses_210 = clauses_7;
	  loop_211:
	    if (
	       NULLP(clauses_210))
	      {		/* Expand/case.scm 134 */
		 obj_t list1239_213;
		 list1239_213 =
		    MAKE_PAIR(BFALSE, BNIL);
		 else_body_107_148 = list1239_213;
	      }
	    else
	      {
		 obj_t body_215;
		 {	/* Expand/case.scm 135 */
		    obj_t e_162_61_218;
		    e_162_61_218 =
		       CAR(clauses_210);
		    if (
		       (e_162_61_218 == BNIL))
		      {		/* Expand/case.scm 135 */
			 else_body_107_148 = BFALSE;
		      }
		    else
		      {		/* Expand/case.scm 135 */
			 if (
			    PAIRP(e_162_61_218))
			   {	/* Expand/case.scm 135 */
			      bool_t test_964;
			      {		/* ./Ieee/equiv.scm 5508 */
				 obj_t aux_967;
				 obj_t aux_965;
				 aux_967 =
				    CNST_TABLE_REF(((long) 6));
				 aux_965 =
				    CAR(e_162_61_218);
				 test_964 =
				    (aux_965 == aux_967);
			      }
			      if (test_964)
				{	/* Expand/case.scm 135 */
				   body_215 =
				      CDR(e_162_61_218);
				   if (
				      NULLP(body_215))
				     {	/* Expand/case.scm 139 */
					else_body_107_148 = BNIL;
				     }
				   else
				     {	/* Expand/case.scm 139 */
					obj_t head1039_227;
					head1039_227 =
					   MAKE_PAIR(BNIL, BNIL);
					{
					   obj_t l1037_228;
					   obj_t tail1040_229;
					   l1037_228 = body_215;
					   tail1040_229 = head1039_227;
					 lname1038_230:
					   if (
					      NULLP(l1037_228))
					     {	/* Expand/case.scm 139 */
						else_body_107_148 =
						   CDR(head1039_227);
					     }
					   else
					     {	/* Expand/case.scm 139 */
						obj_t newtail1041_232;
						{	/* Expand/case.scm 139 */
						   obj_t arg1250_234;
						   arg1250_234 =
						      PROCEDURE_ENTRY(e_8) (e_8,
						      CAR(l1037_228), e_8, BEOA);
						   newtail1041_232 =
						      MAKE_PAIR(arg1250_234, BNIL);
						}
						SET_CDR(tail1040_229, newtail1041_232);
						{
						   obj_t tail1040_983;
						   obj_t l1037_981;
						   l1037_981 =
						      CDR(l1037_228);
						   tail1040_983 = newtail1041_232;
						   tail1040_229 = tail1040_983;
						   l1037_228 = l1037_981;
						   goto lname1038_230;
						}
					     }
					}
				     }
				}
			      else
				{	/* Expand/case.scm 135 */
				 tag_161_123_217:
				   {
				      obj_t clauses_985;
				      clauses_985 =
					 CDR(clauses_210);
				      clauses_210 = clauses_985;
				      goto loop_211;
				   }
				}
			   }
			 else
			   {	/* Expand/case.scm 135 */
			      goto tag_161_123_217;
			   }
		      }
		 }
	      }
	 }
	 {	/* Expand/case.scm 132 */
	    obj_t else_name_111_149;
	    {	/* Expand/case.scm 142 */
	       obj_t arg1237_209;
	       arg1237_209 =
		  PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4, string1467_expand_case, BEOA);
	       else_name_111_149 =
		  mark_symbol_non_user__17_ast_ident(arg1237_209);
	    }
	    {	/* Expand/case.scm 142 */
	       obj_t aux_150;
	       {	/* Expand/case.scm 143 */
		  obj_t arg1236_208;
		  arg1236_208 =
		     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		     CNST_TABLE_REF(((long) 7)), BEOA);
		  aux_150 =
		     mark_symbol_non_user__17_ast_ident(arg1236_208);
	       }
	       {	/* Expand/case.scm 143 */

		  {	/* Expand/case.scm 144 */
		     obj_t case_151;
		     {	/* Expand/case.scm 144 */
			obj_t arg1185_152;
			obj_t arg1187_153;
			arg1185_152 =
			   CNST_TABLE_REF(((long) 8));
			{	/* Expand/case.scm 145 */
			   obj_t arg1188_154;
			   {	/* Expand/case.scm 145 */
			      obj_t arg1189_155;
			      arg1189_155 =
				 loop__120_expand_case(else_name_111_149, e_8, clauses_7);
			      arg1188_154 =
				 append_2_18___r4_pairs_and_lists_6_3(arg1189_155, BNIL);
			   }
			   arg1187_153 =
			      MAKE_PAIR(aux_150, arg1188_154);
			}
			case_151 =
			   MAKE_PAIR(arg1185_152, arg1187_153);
		     }
		     return
			type_test_66_expand_case(aux_150, type_5, value_6, case_151, else_body_107_148, else_name_111_149, e_8);
		  }
	       }
	    }
	 }
      }
   }
}



/* loop' */
obj_t 
loop__120_expand_case(obj_t else_name_111_806, obj_t e_805, obj_t clauses_157)
{
   AN_OBJECT;
   {	/* Expand/case.scm 145 */
      if (
	 NULLP(clauses_157))
	{	/* Expand/case.scm 146 */
	   {	/* Expand/case.scm 148 */
	      obj_t arg1192_160;
	      {		/* Expand/case.scm 148 */
		 obj_t arg1194_162;
		 obj_t arg1195_163;
		 arg1194_162 =
		    CNST_TABLE_REF(((long) 6));
		 arg1195_163 =
		    MAKE_PAIR(BFALSE, BNIL);
		 arg1192_160 =
		    MAKE_PAIR(arg1194_162, arg1195_163);
	      }
	      return
		 MAKE_PAIR(arg1192_160, BNIL);
	   }
	}
      else
	{
	   obj_t body_165;
	   obj_t datums_167;
	   obj_t body_168;
	   {	/* Expand/case.scm 149 */
	      obj_t e_173_18_171;
	      e_173_18_171 =
		 CAR(clauses_157);
	      if (
		 (e_173_18_171 == BNIL))
		{	/* Expand/case.scm 149 */
		   {	/* Expand/case.scm 151 */
		      obj_t arg1209_180;
		      {		/* Expand/case.scm 151 */
			 obj_t arg1213_182;
			 obj_t arg1214_183;
			 arg1213_182 =
			    CNST_TABLE_REF(((long) 6));
			 arg1214_183 =
			    MAKE_PAIR(BFALSE, BNIL);
			 arg1209_180 =
			    MAKE_PAIR(arg1213_182, arg1214_183);
		      }
		      return
			 MAKE_PAIR(arg1209_180, BNIL);
		   }
		}
	      else
		{	/* Expand/case.scm 149 */
		   if (
		      PAIRP(e_173_18_171))
		     {	/* Expand/case.scm 149 */
			bool_t test_1015;
			{	/* ./Ieee/equiv.scm 5508 */
			   obj_t aux_1018;
			   obj_t aux_1016;
			   aux_1018 =
			      CNST_TABLE_REF(((long) 6));
			   aux_1016 =
			      CAR(e_173_18_171);
			   test_1015 =
			      (aux_1016 == aux_1018);
			}
			if (test_1015)
			  {	/* Expand/case.scm 149 */
			     body_165 =
				CDR(e_173_18_171);
			     {	/* Expand/case.scm 153 */
				obj_t arg1215_184;
				{	/* Expand/case.scm 153 */
				   obj_t arg1217_186;
				   obj_t arg1220_187;
				   arg1217_186 =
				      CNST_TABLE_REF(((long) 6));
				   {	/* Expand/case.scm 153 */
				      obj_t arg1222_188;
				      arg1222_188 =
					 MAKE_PAIR(else_name_111_806, BNIL);
				      arg1220_187 =
					 MAKE_PAIR(arg1222_188, BNIL);
				   }
				   arg1215_184 =
				      MAKE_PAIR(arg1217_186, arg1220_187);
				}
				return
				   MAKE_PAIR(arg1215_184, BNIL);
			     }
			  }
			else
			  {	/* Expand/case.scm 149 */
			     datums_167 =
				CAR(e_173_18_171);
			     body_168 =
				CDR(e_173_18_171);
			     {	/* Expand/case.scm 155 */
				obj_t arg1224_190;
				obj_t arg1226_191;
				{	/* Expand/case.scm 155 */
				   obj_t arg1227_192;
				   {	/* Expand/case.scm 155 */
				      obj_t arg1228_193;
				      if (
					 NULLP(body_168))
					{	/* Expand/case.scm 155 */
					   arg1228_193 = BNIL;
					}
				      else
					{	/* Expand/case.scm 155 */
					   obj_t head1044_197;
					   head1044_197 =
					      MAKE_PAIR(BNIL, BNIL);
					   {
					      obj_t l1042_198;
					      obj_t tail1045_199;
					      l1042_198 = body_168;
					      tail1045_199 = head1044_197;
					    lname1043_200:
					      if (
						 NULLP(l1042_198))
						{	/* Expand/case.scm 155 */
						   arg1228_193 =
						      CDR(head1044_197);
						}
					      else
						{	/* Expand/case.scm 156 */
						   obj_t newtail1046_202;
						   {	/* Expand/case.scm 156 */
						      obj_t arg1233_204;
						      arg1233_204 =
							 PROCEDURE_ENTRY(e_805) (e_805,
							 CAR(l1042_198), e_805, BEOA);
						      newtail1046_202 =
							 MAKE_PAIR(arg1233_204, BNIL);
						   }
						   SET_CDR(tail1045_199, newtail1046_202);
						   {
						      obj_t tail1045_1040;
						      obj_t l1042_1038;
						      l1042_1038 =
							 CDR(l1042_198);
						      tail1045_1040 = newtail1046_202;
						      tail1045_199 = tail1045_1040;
						      l1042_198 = l1042_1038;
						      goto lname1043_200;
						   }
						}
					   }
					}
				      arg1227_192 =
					 append_2_18___r4_pairs_and_lists_6_3(arg1228_193, BNIL);
				   }
				   arg1224_190 =
				      MAKE_PAIR(datums_167, arg1227_192);
				}
				arg1226_191 =
				   loop__120_expand_case(else_name_111_806, e_805,
				   CDR(clauses_157));
				return
				   MAKE_PAIR(arg1224_190, arg1226_191);
			     }
			  }
		     }
		   else
		     {	/* Expand/case.scm 149 */
			FAILURE(string1465_expand_case, string1466_expand_case, clauses_157);
		     }
		}
	   }
	}
   }
}



/* do-cnst-case */
obj_t 
do_cnst_case_140_expand_case(obj_t value_9, obj_t clauses_10, obj_t e_11)
{
   AN_OBJECT;
   {	/* Expand/case.scm 172 */
      {		/* Expand/case.scm 173 */
	 obj_t aux_238;
	 {	/* Expand/case.scm 173 */
	    obj_t arg1296_284;
	    arg1296_284 =
	       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
	       CNST_TABLE_REF(((long) 7)), BEOA);
	    aux_238 =
	       mark_symbol_non_user__17_ast_ident(arg1296_284);
	 }
	 {	/* Expand/case.scm 173 */
	    obj_t value_239;
	    {	/* Expand/case.scm 174 */
	       obj_t arg1271_265;
	       obj_t arg1272_266;
	       arg1271_265 =
		  CNST_TABLE_REF(((long) 9));
	       {	/* Expand/case.scm 174 */
		  obj_t arg1273_267;
		  obj_t arg1274_268;
		  {	/* Expand/case.scm 174 */
		     obj_t arg1276_269;
		     {	/* Expand/case.scm 174 */
			obj_t arg1278_271;
			arg1278_271 =
			   MAKE_PAIR(value_9, BNIL);
			arg1276_269 =
			   MAKE_PAIR(aux_238, arg1278_271);
		     }
		     arg1273_267 =
			MAKE_PAIR(arg1276_269, BNIL);
		  }
		  {	/* Expand/case.scm 175 */
		     obj_t arg1280_272;
		     {	/* Expand/case.scm 175 */
			obj_t arg1282_274;
			obj_t arg1286_275;
			arg1282_274 =
			   CNST_TABLE_REF(((long) 10));
			{	/* Expand/case.scm 175 */
			   obj_t arg1287_276;
			   obj_t arg1289_277;
			   {	/* Expand/case.scm 175 */
			      obj_t arg1290_278;
			      obj_t arg1291_279;
			      arg1290_278 =
				 CNST_TABLE_REF(((long) 11));
			      arg1291_279 =
				 MAKE_PAIR(aux_238, BNIL);
			      arg1287_276 =
				 MAKE_PAIR(arg1290_278, arg1291_279);
			   }
			   {	/* Expand/case.scm 176 */
			      obj_t arg1292_280;
			      obj_t arg1293_281;
			      {		/* Expand/case.scm 176 */
				 obj_t arg1294_282;
				 obj_t arg1295_283;
				 arg1294_282 =
				    CNST_TABLE_REF(((long) 12));
				 arg1295_283 =
				    MAKE_PAIR(aux_238, BNIL);
				 arg1292_280 =
				    MAKE_PAIR(arg1294_282, arg1295_283);
			      }
			      {		/* ./Ieee/pair-list.scm 5689 */
				 obj_t aux_1064;
				 aux_1064 =
				    BINT(((long) -1));
				 arg1293_281 =
				    MAKE_PAIR(aux_1064, BNIL);
			      }
			      arg1289_277 =
				 MAKE_PAIR(arg1292_280, arg1293_281);
			   }
			   arg1286_275 =
			      MAKE_PAIR(arg1287_276, arg1289_277);
			}
			arg1280_272 =
			   MAKE_PAIR(arg1282_274, arg1286_275);
		     }
		     arg1274_268 =
			MAKE_PAIR(arg1280_272, BNIL);
		  }
		  arg1272_266 =
		     MAKE_PAIR(arg1273_267, arg1274_268);
	       }
	       value_239 =
		  MAKE_PAIR(arg1271_265, arg1272_266);
	    }
	    {	/* Expand/case.scm 174 */

	       {
		  obj_t c_240;
		  c_240 = clauses_10;
		loop_241:
		  if (
		     NULLP(c_240))
		    {	/* Expand/case.scm 181 */
		       return
			  do_typed_case_38_expand_case(
			  CNST_TABLE_REF(((long) 1)), value_239, clauses_10, e_11);
		    }
		  else
		    {	/* Expand/case.scm 183 */
		       obj_t clause_243;
		       clause_243 =
			  CAR(c_240);
		       {	/* Expand/case.scm 184 */
			  bool_t test_1078;
			  {	/* ./Ieee/equiv.scm 5508 */
			     obj_t aux_1081;
			     obj_t aux_1079;
			     aux_1081 =
				CNST_TABLE_REF(((long) 6));
			     aux_1079 =
				CAR(clause_243);
			     test_1078 =
				(aux_1079 == aux_1081);
			  }
			  if (test_1078)
			    {	/* Expand/case.scm 184 */
			       BUNSPEC;
			    }
			  else
			    {	/* Expand/case.scm 185 */
			       obj_t arg1255_245;
			       {	/* Expand/case.scm 185 */
				  obj_t l1047_246;
				  l1047_246 =
				     CAR(clause_243);
				  if (
				     NULLP(l1047_246))
				    {	/* Expand/case.scm 185 */
				       arg1255_245 = BNIL;
				    }
				  else
				    {	/* Expand/case.scm 185 */
				       obj_t head1049_248;
				       {	/* Expand/case.scm 185 */
					  long arg1264_259;
					  {	/* Expand/case.scm 185 */
					     obj_t aux_1087;
					     aux_1087 =
						CAR(l1047_246);
					     arg1264_259 =
						CCNST(aux_1087);
					  }
					  {	/* ./Ieee/pair-list.scm 5689 */
					     obj_t aux_1090;
					     aux_1090 =
						BINT(arg1264_259);
					     head1049_248 =
						MAKE_PAIR(aux_1090, BNIL);
					  }
				       }
				       {
					  obj_t l1047_249;
					  obj_t tail1050_250;
					  l1047_249 =
					     CDR(l1047_246);
					  tail1050_250 = head1049_248;
					lname1048_251:
					  if (
					     NULLP(l1047_249))
					    {	/* Expand/case.scm 185 */
					       arg1255_245 = head1049_248;
					    }
					  else
					    {	/* Expand/case.scm 185 */
					       obj_t newtail1051_254;
					       {	/* Expand/case.scm 185 */
						  long arg1260_256;
						  {	/* Expand/case.scm 185 */
						     obj_t aux_1095;
						     aux_1095 =
							CAR(l1047_249);
						     arg1260_256 =
							CCNST(aux_1095);
						  }
						  {	/* ./Ieee/pair-list.scm 5689 */
						     obj_t aux_1098;
						     aux_1098 =
							BINT(arg1260_256);
						     newtail1051_254 =
							MAKE_PAIR(aux_1098, BNIL);
						  }
					       }
					       SET_CDR(tail1050_250, newtail1051_254);
					       {
						  obj_t tail1050_1104;
						  obj_t l1047_1102;
						  l1047_1102 =
						     CDR(l1047_249);
						  tail1050_1104 = newtail1051_254;
						  tail1050_250 = tail1050_1104;
						  l1047_249 = l1047_1102;
						  goto lname1048_251;
					       }
					    }
				       }
				    }
			       }
			       SET_CAR(clause_243, arg1255_245);
			    }
		       }
		       {
			  obj_t c_1107;
			  c_1107 =
			     CDR(c_240);
			  c_240 = c_1107;
			  goto loop_241;
		       }
		    }
	       }
	    }
	 }
      }
   }
}



/* type-test */
obj_t 
type_test_66_expand_case(obj_t aux_12, obj_t type_13, obj_t value_14, obj_t case_15, obj_t else_body_107_16, obj_t else_name_111_17, obj_t e_18)
{
   AN_OBJECT;
   {	/* Expand/case.scm 191 */
      {		/* Expand/case.scm 193 */
	 bool_t test_1109;
	 {	/* ./Ieee/equiv.scm 5508 */
	    obj_t aux_1110;
	    aux_1110 =
	       CNST_TABLE_REF(((long) 2));
	    test_1109 =
	       (type_13 == aux_1110);
	 }
	 if (test_1109)
	   {	/* Expand/case.scm 193 */
	      {		/* Expand/case.scm 194 */
		 obj_t arg1298_286;
		 obj_t arg1299_287;
		 arg1298_286 =
		    CNST_TABLE_REF(((long) 13));
		 {	/* Expand/case.scm 194 */
		    obj_t arg1300_288;
		    obj_t arg1301_289;
		    {	/* Expand/case.scm 194 */
		       obj_t arg1302_290;
		       {	/* Expand/case.scm 194 */
			  obj_t arg1304_292;
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_1114;
			     aux_1114 =
				append_2_18___r4_pairs_and_lists_6_3(else_body_107_16, BNIL);
			     arg1304_292 =
				MAKE_PAIR(BNIL, aux_1114);
			  }
			  arg1302_290 =
			     MAKE_PAIR(else_name_111_17, arg1304_292);
		       }
		       arg1300_288 =
			  MAKE_PAIR(arg1302_290, BNIL);
		    }
		    {	/* Expand/case.scm 195 */
		       obj_t arg1308_295;
		       {	/* Expand/case.scm 195 */
			  obj_t arg1313_297;
			  obj_t arg1314_298;
			  arg1313_297 =
			     CNST_TABLE_REF(((long) 9));
			  {	/* Expand/case.scm 195 */
			     obj_t arg1315_299;
			     obj_t arg1317_300;
			     {	/* Expand/case.scm 195 */
				obj_t arg1318_301;
				{	/* Expand/case.scm 195 */
				   obj_t arg1320_303;
				   {	/* Expand/case.scm 195 */
				      obj_t arg1322_304;
				      arg1322_304 =
					 PROCEDURE_ENTRY(e_18) (e_18, value_14, e_18, BEOA);
				      arg1320_303 =
					 MAKE_PAIR(arg1322_304, BNIL);
				   }
				   arg1318_301 =
				      MAKE_PAIR(aux_12, arg1320_303);
				}
				arg1315_299 =
				   MAKE_PAIR(arg1318_301, BNIL);
			     }
			     {	/* Expand/case.scm 196 */
				obj_t arg1325_306;
				{	/* Expand/case.scm 196 */
				   obj_t arg1327_308;
				   obj_t arg1329_309;
				   arg1327_308 =
				      CNST_TABLE_REF(((long) 10));
				   {	/* Expand/case.scm 196 */
				      obj_t arg1330_310;
				      obj_t arg1331_311;
				      {		/* Expand/case.scm 196 */
					 obj_t arg1332_312;
					 obj_t arg1333_313;
					 arg1332_312 =
					    CNST_TABLE_REF(((long) 14));
					 arg1333_313 =
					    MAKE_PAIR(aux_12, BNIL);
					 arg1330_310 =
					    MAKE_PAIR(arg1332_312, arg1333_313);
				      }
				      {		/* Expand/case.scm 198 */
					 obj_t arg1334_314;
					 {	/* Expand/case.scm 198 */
					    obj_t arg1335_315;
					    arg1335_315 =
					       MAKE_PAIR(else_name_111_17, BNIL);
					    arg1334_314 =
					       MAKE_PAIR(arg1335_315, BNIL);
					 }
					 arg1331_311 =
					    MAKE_PAIR(case_15, arg1334_314);
				      }
				      arg1329_309 =
					 MAKE_PAIR(arg1330_310, arg1331_311);
				   }
				   arg1325_306 =
				      MAKE_PAIR(arg1327_308, arg1329_309);
				}
				arg1317_300 =
				   MAKE_PAIR(arg1325_306, BNIL);
			     }
			     arg1314_298 =
				MAKE_PAIR(arg1315_299, arg1317_300);
			  }
			  arg1308_295 =
			     MAKE_PAIR(arg1313_297, arg1314_298);
		       }
		       arg1301_289 =
			  MAKE_PAIR(arg1308_295, BNIL);
		    }
		    arg1299_287 =
		       MAKE_PAIR(arg1300_288, arg1301_289);
		 }
		 return
		    MAKE_PAIR(arg1298_286, arg1299_287);
	      }
	   }
	 else
	   {	/* Expand/case.scm 199 */
	      bool_t test_1140;
	      {		/* ./Ieee/equiv.scm 5508 */
		 obj_t aux_1141;
		 aux_1141 =
		    CNST_TABLE_REF(((long) 1));
		 test_1140 =
		    (type_13 == aux_1141);
	      }
	      if (test_1140)
		{	/* Expand/case.scm 199 */
		   {	/* Expand/case.scm 200 */
		      obj_t arg1338_318;
		      obj_t arg1339_319;
		      arg1338_318 =
			 CNST_TABLE_REF(((long) 13));
		      {		/* Expand/case.scm 200 */
			 obj_t arg1340_320;
			 obj_t arg1342_321;
			 {	/* Expand/case.scm 200 */
			    obj_t arg1343_322;
			    {	/* Expand/case.scm 200 */
			       obj_t arg1346_324;
			       {	/* ./Ieee/pair-list.scm 5689 */
				  obj_t aux_1145;
				  aux_1145 =
				     append_2_18___r4_pairs_and_lists_6_3(else_body_107_16, BNIL);
				  arg1346_324 =
				     MAKE_PAIR(BNIL, aux_1145);
			       }
			       arg1343_322 =
				  MAKE_PAIR(else_name_111_17, arg1346_324);
			    }
			    arg1340_320 =
			       MAKE_PAIR(arg1343_322, BNIL);
			 }
			 {	/* Expand/case.scm 201 */
			    obj_t arg1350_327;
			    {	/* Expand/case.scm 201 */
			       obj_t arg1355_329;
			       obj_t arg1356_330;
			       arg1355_329 =
				  CNST_TABLE_REF(((long) 9));
			       {	/* Expand/case.scm 201 */
				  obj_t arg1357_331;
				  obj_t arg1358_332;
				  {	/* Expand/case.scm 201 */
				     obj_t arg1359_333;
				     {	/* Expand/case.scm 201 */
					obj_t arg1363_335;
					{	/* Expand/case.scm 201 */
					   obj_t arg1365_336;
					   arg1365_336 =
					      PROCEDURE_ENTRY(e_18) (e_18, value_14, e_18, BEOA);
					   arg1363_335 =
					      MAKE_PAIR(arg1365_336, BNIL);
					}
					arg1359_333 =
					   MAKE_PAIR(aux_12, arg1363_335);
				     }
				     arg1357_331 =
					MAKE_PAIR(arg1359_333, BNIL);
				  }
				  {	/* Expand/case.scm 202 */
				     obj_t arg1367_338;
				     {	/* Expand/case.scm 202 */
					obj_t arg1371_340;
					obj_t arg1372_341;
					arg1371_340 =
					   CNST_TABLE_REF(((long) 10));
					{	/* Expand/case.scm 202 */
					   obj_t arg1373_342;
					   obj_t arg1374_343;
					   {	/* Expand/case.scm 202 */
					      obj_t arg1375_344;
					      obj_t arg1376_345;
					      arg1375_344 =
						 CNST_TABLE_REF(((long) 15));
					      arg1376_345 =
						 MAKE_PAIR(aux_12, BNIL);
					      arg1373_342 =
						 MAKE_PAIR(arg1375_344, arg1376_345);
					   }
					   {	/* Expand/case.scm 204 */
					      obj_t arg1377_346;
					      {		/* Expand/case.scm 204 */
						 obj_t arg1378_347;
						 arg1378_347 =
						    MAKE_PAIR(else_name_111_17, BNIL);
						 arg1377_346 =
						    MAKE_PAIR(arg1378_347, BNIL);
					      }
					      arg1374_343 =
						 MAKE_PAIR(case_15, arg1377_346);
					   }
					   arg1372_341 =
					      MAKE_PAIR(arg1373_342, arg1374_343);
					}
					arg1367_338 =
					   MAKE_PAIR(arg1371_340, arg1372_341);
				     }
				     arg1358_332 =
					MAKE_PAIR(arg1367_338, BNIL);
				  }
				  arg1356_330 =
				     MAKE_PAIR(arg1357_331, arg1358_332);
			       }
			       arg1350_327 =
				  MAKE_PAIR(arg1355_329, arg1356_330);
			    }
			    arg1342_321 =
			       MAKE_PAIR(arg1350_327, BNIL);
			 }
			 arg1339_319 =
			    MAKE_PAIR(arg1340_320, arg1342_321);
		      }
		      return
			 MAKE_PAIR(arg1338_318, arg1339_319);
		   }
		}
	      else
		{	/* Expand/case.scm 199 */
		   FAILURE(string1468_expand_case, string1469_expand_case, type_13);
		}
	   }
      }
   }
}



/* do-generic-case */
obj_t 
do_generic_case_59_expand_case(obj_t value_19, obj_t clauses_20, obj_t e_21)
{
   AN_OBJECT;
   {	/* Expand/case.scm 212 */
      {		/* Expand/case.scm 213 */
	 obj_t arg1380_349;
	 {	/* Expand/case.scm 213 */
	    obj_t arg1381_350;
	    obj_t arg1383_351;
	    arg1381_350 =
	       CNST_TABLE_REF(((long) 9));
	    {	/* Expand/case.scm 213 */
	       obj_t arg1384_352;
	       obj_t arg1385_353;
	       {	/* Expand/case.scm 213 */
		  obj_t arg1387_354;
		  {	/* Expand/case.scm 213 */
		     obj_t arg1390_356;
		     obj_t arg1391_357;
		     arg1390_356 =
			CNST_TABLE_REF(((long) 16));
		     arg1391_357 =
			MAKE_PAIR(value_19, BNIL);
		     arg1387_354 =
			MAKE_PAIR(arg1390_356, arg1391_357);
		  }
		  arg1384_352 =
		     MAKE_PAIR(arg1387_354, BNIL);
	       }
	       {	/* Expand/case.scm 214 */
		  obj_t arg1393_358;
		  arg1393_358 =
		     loop_expand_case(clauses_20);
		  arg1385_353 =
		     MAKE_PAIR(arg1393_358, BNIL);
	       }
	       arg1383_351 =
		  MAKE_PAIR(arg1384_352, arg1385_353);
	    }
	    arg1380_349 =
	       MAKE_PAIR(arg1381_350, arg1383_351);
	 }
	 return
	    PROCEDURE_ENTRY(e_21) (e_21, arg1380_349, e_21, BEOA);
      }
   }
}



/* loop */
obj_t 
loop_expand_case(obj_t clauses_360)
{
   AN_OBJECT;
   {	/* Expand/case.scm 214 */
      if (
	 NULLP(clauses_360))
	{	/* Expand/case.scm 215 */
	   return BFALSE;
	}
      else
	{
	   obj_t datums_366;
	   obj_t body_367;
	   obj_t datums_369;
	   obj_t body_370;
	   {	/* Expand/case.scm 217 */
	      obj_t e_198_24_372;
	      e_198_24_372 =
		 CAR(clauses_360);
	      if (
		 (e_198_24_372 == BNIL))
		{	/* Expand/case.scm 217 */
		   return BFALSE;
		}
	      else
		{	/* Expand/case.scm 217 */
		   if (
		      PAIRP(e_198_24_372))
		     {	/* Expand/case.scm 217 */
			bool_t test_1190;
			{	/* ./Ieee/equiv.scm 5508 */
			   obj_t aux_1193;
			   obj_t aux_1191;
			   aux_1193 =
			      CNST_TABLE_REF(((long) 6));
			   aux_1191 =
			      CAR(e_198_24_372);
			   test_1190 =
			      (aux_1191 == aux_1193);
			}
			if (test_1190)
			  {	/* Expand/case.scm 217 */
			     return
				normalize_progn_143_tools_progn(
				CDR(e_198_24_372));
			  }
			else
			  {	/* Expand/case.scm 217 */
			     obj_t car_211_103_377;
			     car_211_103_377 =
				CAR(e_198_24_372);
			     if (
				PAIRP(car_211_103_377))
			       {	/* Expand/case.scm 217 */
				  bool_t test_1201;
				  {	/* ./Ieee/pair-list.scm 5669 */
				     obj_t aux_1202;
				     aux_1202 =
					CDR(car_211_103_377);
				     test_1201 =
					PAIRP(aux_1202);
				  }
				  if (test_1201)
				    {	/* Expand/case.scm 217 */
				       datums_366 = car_211_103_377;
				       body_367 =
					  CDR(e_198_24_372);
				       {	/* Expand/case.scm 223 */
					  obj_t arg1424_397;
					  obj_t arg1425_398;
					  arg1424_397 =
					     CNST_TABLE_REF(((long) 10));
					  {	/* Expand/case.scm 223 */
					     obj_t arg1426_399;
					     obj_t arg1427_400;
					     {	/* Expand/case.scm 223 */
						obj_t arg1428_401;
						obj_t arg1430_402;
						arg1428_401 =
						   CNST_TABLE_REF(((long) 19));
						{	/* Expand/case.scm 223 */
						   obj_t arg1431_403;
						   obj_t arg1432_404;
						   arg1431_403 =
						      CNST_TABLE_REF(((long) 16));
						   {	/* Expand/case.scm 223 */
						      obj_t arg1433_405;
						      {		/* Expand/case.scm 223 */
							 obj_t arg1435_407;
							 obj_t arg1436_408;
							 arg1435_407 =
							    CNST_TABLE_REF(((long) 18));
							 arg1436_408 =
							    MAKE_PAIR(datums_366, BNIL);
							 arg1433_405 =
							    MAKE_PAIR(arg1435_407, arg1436_408);
						      }
						      arg1432_404 =
							 MAKE_PAIR(arg1433_405, BNIL);
						   }
						   arg1430_402 =
						      MAKE_PAIR(arg1431_403, arg1432_404);
						}
						arg1426_399 =
						   MAKE_PAIR(arg1428_401, arg1430_402);
					     }
					     {	/* Expand/case.scm 224 */
						obj_t arg1437_409;
						obj_t arg1438_410;
						arg1437_409 =
						   normalize_progn_143_tools_progn(body_367);
						{	/* Expand/case.scm 225 */
						   obj_t arg1439_411;
						   arg1439_411 =
						      loop_expand_case(
						      CDR(clauses_360));
						   arg1438_410 =
						      MAKE_PAIR(arg1439_411, BNIL);
						}
						arg1427_400 =
						   MAKE_PAIR(arg1437_409, arg1438_410);
					     }
					     arg1425_398 =
						MAKE_PAIR(arg1426_399, arg1427_400);
					  }
					  return
					     MAKE_PAIR(arg1424_397, arg1425_398);
				       }
				    }
				  else
				    {	/* Expand/case.scm 217 */
				       bool_t test_1222;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1223;
					  aux_1223 =
					     CDR(car_211_103_377);
					  test_1222 =
					     (aux_1223 == BNIL);
				       }
				       if (test_1222)
					 {	/* Expand/case.scm 217 */
					    datums_369 =
					       CAR(car_211_103_377);
					    body_370 =
					       CDR(e_198_24_372);
					  tag_197_205_371:
					    {	/* Expand/case.scm 227 */
					       obj_t arg1442_414;
					       obj_t arg1443_415;
					       arg1442_414 =
						  CNST_TABLE_REF(((long) 10));
					       {	/* Expand/case.scm 227 */
						  obj_t arg1444_416;
						  obj_t arg1445_417;
						  {	/* Expand/case.scm 227 */
						     obj_t arg1446_418;
						     obj_t arg1447_419;
						     arg1446_418 =
							CNST_TABLE_REF(((long) 17));
						     {	/* Expand/case.scm 227 */
							obj_t arg1449_420;
							obj_t arg1450_421;
							arg1449_420 =
							   CNST_TABLE_REF(((long) 16));
							{	/* Expand/case.scm 227 */
							   obj_t arg1451_422;
							   {	/* Expand/case.scm 227 */
							      obj_t arg1454_424;
							      obj_t arg1455_425;
							      arg1454_424 =
								 CNST_TABLE_REF(((long) 18));
							      arg1455_425 =
								 MAKE_PAIR(datums_369, BNIL);
							      arg1451_422 =
								 MAKE_PAIR(arg1454_424, arg1455_425);
							   }
							   arg1450_421 =
							      MAKE_PAIR(arg1451_422, BNIL);
							}
							arg1447_419 =
							   MAKE_PAIR(arg1449_420, arg1450_421);
						     }
						     arg1444_416 =
							MAKE_PAIR(arg1446_418, arg1447_419);
						  }
						  {	/* Expand/case.scm 228 */
						     obj_t arg1456_426;
						     obj_t arg1457_427;
						     arg1456_426 =
							normalize_progn_143_tools_progn(body_370);
						     {	/* Expand/case.scm 229 */
							obj_t arg1458_428;
							arg1458_428 =
							   loop_expand_case(
							   CDR(clauses_360));
							arg1457_427 =
							   MAKE_PAIR(arg1458_428, BNIL);
						     }
						     arg1445_417 =
							MAKE_PAIR(arg1456_426, arg1457_427);
						  }
						  arg1443_415 =
						     MAKE_PAIR(arg1444_416, arg1445_417);
					       }
					       return
						  MAKE_PAIR(arg1442_414, arg1443_415);
					    }
					 }
				       else
					 {	/* Expand/case.scm 217 */
					    return BFALSE;
					 }
				    }
			       }
			     else
			       {	/* Expand/case.scm 217 */
				  if (
				     PAIRP(car_211_103_377))
				    {	/* Expand/case.scm 217 */
				       bool_t test_1246;
				       {	/* ./Ieee/equiv.scm 5508 */
					  obj_t aux_1247;
					  aux_1247 =
					     CDR(car_211_103_377);
					  test_1246 =
					     (aux_1247 == BNIL);
				       }
				       if (test_1246)
					 {
					    obj_t body_1252;
					    obj_t datums_1250;
					    datums_1250 =
					       CAR(car_211_103_377);
					    body_1252 =
					       CDR(e_198_24_372);
					    body_370 = body_1252;
					    datums_369 = datums_1250;
					    goto tag_197_205_371;
					 }
				       else
					 {	/* Expand/case.scm 217 */
					    return BFALSE;
					 }
				    }
				  else
				    {	/* Expand/case.scm 217 */
				       return BFALSE;
				    }
			       }
			  }
		     }
		   else
		     {	/* Expand/case.scm 217 */
			return BFALSE;
		     }
		}
	   }
	}
   }
}



/* method-init */
obj_t 
method_init_76_expand_case()
{
   AN_OBJECT;
   {	/* Expand/case.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_expand_case()
{
   AN_OBJECT;
   {	/* Expand/case.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "EXPAND_CASE");
      module_initialization_70_tools_progn(((long) 0), "EXPAND_CASE");
      module_initialization_70_tools_error(((long) 0), "EXPAND_CASE");
      module_initialization_70_engine_param(((long) 0), "EXPAND_CASE");
      module_initialization_70_type_type(((long) 0), "EXPAND_CASE");
      return
	 module_initialization_70_ast_ident(((long) 0), "EXPAND_CASE");
   }
}
