/*===========================================================================*/
/*   (Expand/eps.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;


extern obj_t unwind_until__178___bexit(obj_t, obj_t);
static obj_t escape_1336_expand_eps(obj_t, obj_t);
static obj_t escape_1335_expand_eps(obj_t, obj_t);
static obj_t method_init_76_expand_eps();
static obj_t body1063_expand_eps(obj_t);
static obj_t body1055_expand_eps(obj_t);
static obj_t body1047_expand_eps(obj_t);
extern obj_t current_error_port;
extern obj_t exitd_top;
extern obj_t _nb_error_on_pass__70_tools_error;
static obj_t _add_macro_definition__254_expand_eps(obj_t, obj_t);
static obj_t _lexical_stack_103_expand_eps(obj_t);
extern obj_t get_compiler_expander_150___macro(obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t fast_id_of_id_130_ast_ident(obj_t, obj_t);
static obj_t handling_function1268_expand_eps(obj_t, obj_t, obj_t, obj_t);
static obj_t handling_function1256_expand_eps(obj_t, obj_t, obj_t, obj_t);
static obj_t handling_function1246_expand_eps(obj_t, obj_t, obj_t, obj_t);
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t get_eval_expander_232___macro(obj_t);
extern obj_t module_initialization_70_expand_eps(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_pass(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_expand_expander(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___macro(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t _identifier_expander__166_expand_eps(obj_t, obj_t);
static obj_t __application_expander__200_expand_eps(obj_t, obj_t, obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t _initial_expander_127_expand_eps(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_expand_eps();
extern obj_t expand_units_9_expand_eps(obj_t);
extern obj_t add_macro_definition__103_expand_eps(obj_t);
static obj_t handler_expand_eps(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t rhandler1062_expand_eps(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t rhandler1054_expand_eps(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t rhandler1046_expand_eps(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_expand_eps();
static obj_t initial_expander_162_expand_eps(obj_t, obj_t);
static obj_t _comptime_expand_once_1_expand_eps(obj_t, obj_t);
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t toplevel_init_63_expand_eps();
extern obj_t open_input_string(obj_t);
extern obj_t lexical_stack_189_expand_eps();
static obj_t _anonymous_1321__117_expand_eps(obj_t, obj_t, obj_t);
extern obj_t with_lexical_22_expand_eps(obj_t, obj_t, obj_t, obj_t);
extern obj_t comptime_expand_37_expand_eps(obj_t);
extern obj_t string_to_bstring(char *);
static obj_t _anonymous_1300__140_expand_eps(obj_t, obj_t, obj_t);
static obj_t loop_expand_eps(obj_t, obj_t, obj_t);
static obj_t _anonymous_1272__46_expand_eps(obj_t);
static obj_t _anonymous_1271__21_expand_eps(obj_t);
extern obj_t dynamic_wind_31___r4_control_features_6_9(obj_t, obj_t, obj_t);
static obj_t _anonymous_1260__161_expand_eps(obj_t);
static obj_t _anonymous_1259__73_expand_eps(obj_t);
static obj_t _expand_units_69_expand_eps(obj_t, obj_t);
static obj_t _macro__213_expand_eps = BUNSPEC;
static obj_t _anonymous_1251__213_expand_eps(obj_t);
static obj_t _anonymous_1250__207_expand_eps(obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
extern obj_t comptime_expand_once_113_expand_eps(obj_t);
extern obj_t remove_error_handler__102___error();
static obj_t _lexical_stack__25_expand_eps = BUNSPEC;
static obj_t _comptime_expand_212_expand_eps(obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t _application_expander__202_expand_eps(obj_t, obj_t);
extern obj_t find_location_120_tools_location(obj_t);
static obj_t escape_expand_eps(obj_t, obj_t);
extern obj_t add_error_handler__155___error(obj_t, obj_t);
static obj_t _with_lexical_64_expand_eps(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_expand_eps = BUNSPEC;
static obj_t __identifier_expander__134_expand_eps(obj_t, obj_t, obj_t);
static obj_t cnst_init_137_expand_eps();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t _current_pass__25_engine_pass;
extern obj_t find_o_expander_0_expand_expander(obj_t);
static obj_t __cnst[5];

DEFINE_STATIC_PROCEDURE(_identifier_expander__env_242_expand_eps, __identifier_expander__134_expand_eps1357, __identifier_expander__134_expand_eps, 0L, 2);
DEFINE_EXPORT_PROCEDURE(comptime_expand_once_env_39_expand_eps, _comptime_expand_once_1_expand_eps1358, _comptime_expand_once_1_expand_eps, 0L, 1);
DEFINE_STATIC_PROCEDURE(initial_expander_env_197_expand_eps, _initial_expander_127_expand_eps1359, _initial_expander_127_expand_eps, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1346_expand_eps, _anonymous_1321__117_expand_eps1360, _anonymous_1321__117_expand_eps, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1344_expand_eps, _anonymous_1300__140_expand_eps1361, _anonymous_1300__140_expand_eps, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1337_expand_eps, handler_expand_eps1362, handler_expand_eps, 0L, 4);
DEFINE_EXPORT_PROCEDURE(expand_units_env_107_expand_eps, _expand_units_69_expand_eps1363, _expand_units_69_expand_eps, 0L, 1);
DEFINE_EXPORT_PROCEDURE(add_macro_definition__env_21_expand_eps, _add_macro_definition__254_expand_eps1364, _add_macro_definition__254_expand_eps, 0L, 1);
DEFINE_STATIC_PROCEDURE(_application_expander__env_69_expand_eps, __application_expander__200_expand_eps1365, __application_expander__200_expand_eps, 0L, 2);
DEFINE_EXPORT_PROCEDURE(comptime_expand_env_121_expand_eps, _comptime_expand_212_expand_eps1366, _comptime_expand_212_expand_eps, 0L, 1);
DEFINE_EXPORT_PROCEDURE(lexical_stack_env_214_expand_eps, _lexical_stack_103_expand_eps1367, _lexical_stack_103_expand_eps, 0L, 0);
DEFINE_EXPORT_PROCEDURE(with_lexical_env_98_expand_eps, _with_lexical_64_expand_eps1368, _with_lexical_64_expand_eps, 0L, 4);
DEFINE_STRING(string1349_expand_eps, string1349_expand_eps1369, "(QUOTE ()) DEFINE-EXPANDER DEFINE-MACRO NOTHING PASS-STARTED ", 61);
DEFINE_STRING(string1348_expand_eps, string1348_expand_eps1370, "Type `extended pair' expected for expression", 44);
DEFINE_STRING(string1347_expand_eps, string1347_expand_eps1371, "cer", 3);
DEFINE_STRING(string1345_expand_eps, string1345_expand_eps1372, "Illegal form", 12);
DEFINE_STRING(string1343_expand_eps, string1343_expand_eps1373, "failure during postlude hook", 28);
DEFINE_STRING(string1342_expand_eps, string1342_expand_eps1374, " occured, ending ...", 20);
DEFINE_STRING(string1341_expand_eps, string1341_expand_eps1375, " error", 6);
DEFINE_STRING(string1339_expand_eps, string1339_expand_eps1376, "   . ", 5);
DEFINE_STRING(string1340_expand_eps, string1340_expand_eps1377, "failure during prelude hook", 27);
DEFINE_STRING(string1338_expand_eps, string1338_expand_eps1378, "Expand", 6);



/* module-initialization */
obj_t 
module_initialization_70_expand_eps(long checksum_656, char *from_657)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_expand_eps))
	{
	   require_initialization_114_expand_eps =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_expand_eps();
	   cnst_init_137_expand_eps();
	   imported_modules_init_94_expand_eps();
	   method_init_76_expand_eps();
	   toplevel_init_63_expand_eps();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_expand_eps()
{
   AN_OBJECT;
   {	/* Expand/eps.scm 16 */
      module_initialization_70___bexit(((long) 0), "EXPAND_EPS");
      module_initialization_70___macro(((long) 0), "EXPAND_EPS");
      module_initialization_70___r4_output_6_10_3(((long) 0), "EXPAND_EPS");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "EXPAND_EPS");
      module_initialization_70___r4_control_features_6_9(((long) 0), "EXPAND_EPS");
      module_initialization_70___error(((long) 0), "EXPAND_EPS");
      module_initialization_70___r4_numbers_6_5(((long) 0), "EXPAND_EPS");
      module_initialization_70___reader(((long) 0), "EXPAND_EPS");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_expand_eps()
{
   AN_OBJECT;
   {	/* Expand/eps.scm 16 */
      {		/* Expand/eps.scm 16 */
	 obj_t cnst_port_138_649;
	 cnst_port_138_649 =
	    open_input_string(string1349_expand_eps);
	 {
	    long i_650;
	    i_650 = ((long) 4);
	  loop_651:
	    {	/* Expand/eps.scm 16 */
	       bool_t test1350_652;
	       test1350_652 =
		  (i_650 == ((long) -1));
	       if (test1350_652)
		 {	/* Expand/eps.scm 16 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Expand/eps.scm 16 */
		    {	/* Expand/eps.scm 16 */
		       obj_t arg1354_653;
		       {	/* Expand/eps.scm 16 */
			  obj_t list1355_654;
			  list1355_654 =
			     MAKE_PAIR(cnst_port_138_649, BNIL);
			  arg1354_653 =
			     read___reader(list1355_654);
		       }
		       CNST_TABLE_SET(i_650, arg1354_653);
		    }
		    {	/* Expand/eps.scm 16 */
		       int aux_655;
		       {	/* Expand/eps.scm 16 */
			  long aux_680;
			  aux_680 =
			     (i_650 - ((long) 1));
			  aux_655 =
			     (int) (aux_680);
		       }
		       {
			  long i_683;
			  i_683 =
			     (long) (aux_655);
			  i_650 = i_683;
			  goto loop_651;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_expand_eps()
{
   AN_OBJECT;
   {	/* Expand/eps.scm 16 */
      _macro__213_expand_eps = BNIL;
      return (
	 _lexical_stack__25_expand_eps = BNIL, BUNSPEC);
   }
}



/* add-macro-definition! */
obj_t 
add_macro_definition__103_expand_eps(obj_t form_29)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 44 */
      {		/* Expand/eps.scm 45 */
	 obj_t obj2_381;
	 obj2_381 = _macro__213_expand_eps;
	 return (
	    _macro__213_expand_eps =
	    MAKE_PAIR(form_29, obj2_381), BUNSPEC);
      }
   }
}



/* _add-macro-definition! */
obj_t 
_add_macro_definition__254_expand_eps(obj_t env_507, obj_t form_508)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 44 */
      return
	 add_macro_definition__103_expand_eps(form_508);
   }
}



/* lexical-stack */
obj_t 
lexical_stack_189_expand_eps()
{
   AN_OBJECT;
   {	/* Expand/eps.scm 60 */
      return _lexical_stack__25_expand_eps;
   }
}



/* _lexical-stack */
obj_t 
_lexical_stack_103_expand_eps(obj_t env_509)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 60 */
      return
	 lexical_stack_189_expand_eps();
   }
}



/* with-lexical */
obj_t 
with_lexical_22_expand_eps(obj_t new_30, obj_t mark_31, obj_t loc_32, obj_t thunk_33)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 66 */
      {		/* Expand/eps.scm 67 */
	 obj_t new_id_27_114;
	 obj_t old_lexical_stack_210_115;
	 if (
	    NULLP(new_30))
	   {	/* Expand/eps.scm 67 */
	      new_id_27_114 = BNIL;
	   }
	 else
	   {	/* Expand/eps.scm 67 */
	      obj_t head1033_132;
	      head1033_132 =
		 MAKE_PAIR(BNIL, BNIL);
	      {
		 obj_t l1030_133;
		 obj_t tail1034_134;
		 l1030_133 = new_30;
		 tail1034_134 = head1033_132;
	       lname1032_135:
		 if (
		    NULLP(l1030_133))
		   {	/* Expand/eps.scm 67 */
		      new_id_27_114 =
			 CDR(head1033_132);
		   }
		 else
		   {	/* Expand/eps.scm 67 */
		      obj_t newtail1035_137;
		      {		/* Expand/eps.scm 67 */
			 obj_t arg1201_139;
			 arg1201_139 =
			    fast_id_of_id_130_ast_ident(
			    CAR(l1030_133), loc_32);
			 newtail1035_137 =
			    MAKE_PAIR(arg1201_139, BNIL);
		      }
		      SET_CDR(tail1034_134, newtail1035_137);
		      {
			 obj_t tail1034_700;
			 obj_t l1030_698;
			 l1030_698 =
			    CDR(l1030_133);
			 tail1034_700 = newtail1035_137;
			 tail1034_134 = tail1034_700;
			 l1030_133 = l1030_698;
			 goto lname1032_135;
		      }
		   }
	      }
	   }
	 old_lexical_stack_210_115 = _lexical_stack__25_expand_eps;
	 {	/* Expand/eps.scm 70 */
	    obj_t arg1189_116;
	    if (
	       NULLP(new_id_27_114))
	      {		/* Expand/eps.scm 70 */
		 arg1189_116 = BNIL;
	      }
	    else
	      {		/* Expand/eps.scm 70 */
		 obj_t head1038_119;
		 head1038_119 =
		    MAKE_PAIR(BNIL, BNIL);
		 {
		    obj_t l1036_120;
		    obj_t tail1039_121;
		    l1036_120 = new_id_27_114;
		    tail1039_121 = head1038_119;
		  lname1037_122:
		    if (
		       NULLP(l1036_120))
		      {		/* Expand/eps.scm 70 */
			 arg1189_116 =
			    CDR(head1038_119);
		      }
		    else
		      {		/* Expand/eps.scm 70 */
			 obj_t newtail1040_124;
			 {	/* Expand/eps.scm 70 */
			    obj_t arg1193_126;
			    {	/* ./Ieee/pair-list.scm 5689 */
			       obj_t aux_707;
			       aux_707 =
				  CAR(l1036_120);
			       arg1193_126 =
				  MAKE_PAIR(aux_707, mark_31);
			    }
			    newtail1040_124 =
			       MAKE_PAIR(arg1193_126, BNIL);
			 }
			 SET_CDR(tail1039_121, newtail1040_124);
			 {
			    obj_t tail1039_714;
			    obj_t l1036_712;
			    l1036_712 =
			       CDR(l1036_120);
			    tail1039_714 = newtail1040_124;
			    tail1039_121 = tail1039_714;
			    l1036_120 = l1036_712;
			    goto lname1037_122;
			 }
		      }
		 }
	      }
	    _lexical_stack__25_expand_eps =
	       append_2_18___r4_pairs_and_lists_6_3(arg1189_116, _lexical_stack__25_expand_eps);
	 }
	 {	/* Expand/eps.scm 71 */
	    obj_t res_129;
	    res_129 =
	       PROCEDURE_ENTRY(thunk_33) (thunk_33, BEOA);
	    _lexical_stack__25_expand_eps = old_lexical_stack_210_115;
	    return res_129;
	 }
      }
   }
}



/* _with-lexical */
obj_t 
_with_lexical_64_expand_eps(obj_t env_510, obj_t new_511, obj_t mark_512, obj_t loc_513, obj_t thunk_514)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 66 */
      return
	 with_lexical_22_expand_eps(new_511, mark_512, loc_513, thunk_514);
   }
}



/* expand-units */
obj_t 
expand_units_9_expand_eps(obj_t units_34)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 80 */
      {		/* Expand/eps.scm 88 */
	 obj_t handler_533;
	 handler_533 = proc1337_expand_eps;
	 {	/* Expand/eps.scm 80 */
	    obj_t list1203_143;
	    {	/* Expand/eps.scm 80 */
	       obj_t arg1206_145;
	       {	/* Expand/eps.scm 80 */
		  obj_t arg1209_147;
		  {	/* Expand/eps.scm 80 */
		     obj_t aux_719;
		     aux_719 =
			BCHAR(((unsigned char) '\n'));
		     arg1209_147 =
			MAKE_PAIR(aux_719, BNIL);
		  }
		  arg1206_145 =
		     MAKE_PAIR(string1338_expand_eps, arg1209_147);
	       }
	       list1203_143 =
		  MAKE_PAIR(string1339_expand_eps, arg1206_145);
	    }
	    verbose_tools_speek(
	       BINT(((long) 1)), list1203_143);
	 }
	 _nb_error_on_pass__70_tools_error =
	    BINT(((long) 0));
	 _current_pass__25_engine_pass = string1338_expand_eps;
	 {
	    obj_t hooks_148;
	    obj_t hnames_149;
	    hooks_148 = BNIL;
	    hnames_149 = BNIL;
	  loop_150:
	    if (
	       NULLP(hooks_148))
	      {		/* Expand/eps.scm 80 */
		 CNST_TABLE_REF(((long) 0));
	      }
	    else
	      {		/* Expand/eps.scm 80 */
		 bool_t test1216_155;
		 {	/* Expand/eps.scm 80 */
		    obj_t fun1225_161;
		    fun1225_161 =
		       CAR(hooks_148);
		    {	/* Expand/eps.scm 80 */
		       obj_t aux_731;
		       aux_731 =
			  PROCEDURE_ENTRY(fun1225_161) (fun1225_161, BEOA);
		       test1216_155 =
			  CBOOL(aux_731);
		    }
		 }
		 if (test1216_155)
		   {	/* Expand/eps.scm 80 */
		      {
			 obj_t hnames_738;
			 obj_t hooks_736;
			 hooks_736 =
			    CDR(hooks_148);
			 hnames_738 =
			    CDR(hnames_149);
			 hnames_149 = hnames_738;
			 hooks_148 = hooks_736;
			 goto loop_150;
		      }
		   }
		 else
		   {	/* Expand/eps.scm 80 */
		      internal_error_43_tools_error(string1338_expand_eps, string1340_expand_eps,
			 CAR(hnames_149));
		   }
	      }
	 }
	 {
	    obj_t l1041_162;
	    {	/* Expand/eps.scm 83 */
	       obj_t arg1226_164;
	       arg1226_164 =
		  reverse__39___r4_pairs_and_lists_6_3(_macro__213_expand_eps);
	       l1041_162 = arg1226_164;
	     lname1042_163:
	       if (
		  PAIRP(l1041_162))
		 {	/* Expand/eps.scm 83 */
		    initial_expander_162_expand_eps(
		       CAR(l1041_162), initial_expander_env_197_expand_eps);
		    {
		       obj_t l1041_747;
		       l1041_747 =
			  CDR(l1041_162);
		       l1041_162 = l1041_747;
		       goto lname1042_163;
		    }
		 }
	       else
		 {	/* Expand/eps.scm 83 */
		    ((bool_t) 1);
		 }
	    }
	 }
	 {
	    obj_t l1043_168;
	    l1043_168 = units_34;
	  lname1044_169:
	    if (
	       PAIRP(l1043_168))
	      {		/* Expand/eps.scm 90 */
		 {	/* Expand/eps.scm 91 */
		    obj_t unit_171;
		    unit_171 =
		       CAR(l1043_168);
		    {	/* Expand/eps.scm 91 */
		       bool_t test_752;
		       {	/* ./Ieee/control.scm 8599 */
			  obj_t aux_753;
			  aux_753 =
			     STRUCT_REF(unit_171, ((long) 2));
			  test_752 =
			     PROCEDUREP(aux_753);
		       }
		       if (test_752)
			 {	/* Expand/eps.scm 91 */
			    CNST_TABLE_REF(((long) 1));
			 }
		       else
			 {
			    obj_t src_173;
			    obj_t res_174;
			    src_173 =
			       STRUCT_REF(unit_171, ((long) 2));
			    res_174 = BNIL;
			  loop_175:
			    if (
			       NULLP(src_173))
			      {		/* Expand/eps.scm 98 */
				 obj_t arg1235_179;
				 arg1235_179 =
				    reverse__39___r4_pairs_and_lists_6_3(res_174);
				 {	/* ./Llib/struct.scm 1463 */
				    obj_t x_647;
				    x_647 =
				       STRUCT_SET(unit_171, ((long) 2), arg1235_179);
				    BUNSPEC;
				 }
			      }
			    else
			      {

				 {	/* Expand/eps.scm 99 */
				    obj_t e_123_126_183;
				    e_123_126_183 =
				       CAR(src_173);
				    if (
				       PAIRP(e_123_126_183))
				      {		/* Expand/eps.scm 99 */
					 bool_t test_764;
					 {	/* ./Ieee/equiv.scm 5508 */
					    obj_t aux_767;
					    obj_t aux_765;
					    aux_767 =
					       CNST_TABLE_REF(((long) 2));
					    aux_765 =
					       CAR(e_123_126_183);
					    test_764 =
					       (aux_765 == aux_767);
					 }
					 if (test_764)
					   {	/* Expand/eps.scm 99 */
					      {		/* Expand/eps.scm 101 */
						 obj_t armed1048_191;
						 obj_t handler1045_192;
						 armed1048_191 =
						    MAKE_CELL(BUNSPEC);
						 handler1045_192 =
						    MAKE_CELL(BUNSPEC);
						 {	/* Expand/eps.scm 101 */
						    obj_t body1047_529;
						    obj_t rhandler1046_531;
						    body1047_529 =
						       make_fx_procedure(body1047_expand_eps, ((long) 0), ((long) 1));
						    rhandler1046_531 =
						       make_fx_procedure(rhandler1046_expand_eps, ((long) 4), ((long) 2));
						    PROCEDURE_SET(body1047_529, ((long) 0), src_173);
						    PROCEDURE_SET(rhandler1046_531, ((long) 0), armed1048_191);
						    PROCEDURE_SET(rhandler1046_531, ((long) 1), handler1045_192);
						    CELL_SET(handler1045_192, handler_533);
						    CELL_SET(armed1048_191, BTRUE);
						    handling_function1246_expand_eps(body1047_529, rhandler1046_531, handler1045_192, armed1048_191);
						 }
					      }
					      {
						 obj_t src_776;
						 src_776 =
						    CDR(src_173);
						 src_173 = src_776;
						 goto loop_175;
					      }
					   }
					 else
					   {	/* Expand/eps.scm 99 */
					      bool_t test_778;
					      {		/* ./Ieee/equiv.scm 5508 */
						 obj_t aux_781;
						 obj_t aux_779;
						 aux_781 =
						    CNST_TABLE_REF(((long) 3));
						 aux_779 =
						    CAR(e_123_126_183);
						 test_778 =
						    (aux_779 == aux_781);
					      }
					      if (test_778)
						{	/* Expand/eps.scm 99 */
						   {	/* Expand/eps.scm 104 */
						      obj_t armed1056_217;
						      obj_t handler1053_218;
						      armed1056_217 =
							 MAKE_CELL(BUNSPEC);
						      handler1053_218 =
							 MAKE_CELL(BUNSPEC);
						      {		/* Expand/eps.scm 104 */
							 obj_t body1055_524;
							 obj_t rhandler1054_526;
							 body1055_524 =
							    make_fx_procedure(body1055_expand_eps, ((long) 0), ((long) 1));
							 rhandler1054_526 =
							    make_fx_procedure(rhandler1054_expand_eps, ((long) 4), ((long) 2));
							 PROCEDURE_SET(body1055_524, ((long) 0), src_173);
							 PROCEDURE_SET(rhandler1054_526, ((long) 0), armed1056_217);
							 PROCEDURE_SET(rhandler1054_526, ((long) 1), handler1053_218);
							 CELL_SET(handler1053_218, handler_533);
							 CELL_SET(armed1056_217, BTRUE);
							 handling_function1256_expand_eps(body1055_524, rhandler1054_526, handler1053_218, armed1056_217);
						      }
						   }
						   {
						      obj_t src_790;
						      src_790 =
							 CDR(src_173);
						      src_173 = src_790;
						      goto loop_175;
						   }
						}
					      else
						{	/* Expand/eps.scm 99 */
						 tag_122_225_182:
						   {	/* Expand/eps.scm 107 */
						      obj_t obody_243;
						      obody_243 =
							 CAR(src_173);
						      {		/* Expand/eps.scm 107 */
							 obj_t nbody_244;
							 {	/* Expand/eps.scm 108 */
							    obj_t armed1064_247;
							    obj_t handler1061_248;
							    armed1064_247 =
							       MAKE_CELL(BUNSPEC);
							    handler1061_248 =
							       MAKE_CELL(BUNSPEC);
							    {	/* Expand/eps.scm 108 */
							       obj_t body1063_516;
							       obj_t rhandler1062_521;
							       body1063_516 =
								  make_fx_procedure(body1063_expand_eps, ((long) 0), ((long) 1));
							       rhandler1062_521 =
								  make_fx_procedure(rhandler1062_expand_eps, ((long) 4), ((long) 2));
							       PROCEDURE_SET(body1063_516, ((long) 0), obody_243);
							       PROCEDURE_SET(rhandler1062_521, ((long) 0), armed1064_247);
							       PROCEDURE_SET(rhandler1062_521, ((long) 1), handler1061_248);
							       CELL_SET(handler1061_248, handler_533);
							       CELL_SET(armed1064_247, BTRUE);
							       nbody_244 =
								  handling_function1268_expand_eps(body1063_516, rhandler1062_521, handler1061_248, armed1064_247);
							    }
							 }
							 {	/* Expand/eps.scm 108 */

							    {	/* Expand/eps.scm 110 */
							       obj_t arg1265_245;
							       obj_t arg1267_246;
							       arg1265_245 =
								  CDR(src_173);
							       arg1267_246 =
								  MAKE_PAIR(nbody_244, res_174);
							       {
								  obj_t res_802;
								  obj_t src_801;
								  src_801 = arg1265_245;
								  res_802 = arg1267_246;
								  res_174 = res_802;
								  src_173 = src_801;
								  goto loop_175;
							       }
							    }
							 }
						      }
						   }
						}
					   }
				      }
				    else
				      {		/* Expand/eps.scm 99 */
					 goto tag_122_225_182;
				      }
				 }
			      }
			 }
		    }
		 }
		 {
		    obj_t l1043_804;
		    l1043_804 =
		       CDR(l1043_168);
		    l1043_168 = l1043_804;
		    goto lname1044_169;
		 }
	      }
	    else
	      {		/* Expand/eps.scm 90 */
		 ((bool_t) 1);
	      }
	 }
	 {	/* Expand/eps.scm 112 */
	    bool_t test1278_274;
	    {	/* Expand/eps.scm 112 */
	       long n1_451;
	       n1_451 =
		  (long) CINT(_nb_error_on_pass__70_tools_error);
	       test1278_274 =
		  (n1_451 > ((long) 0));
	    }
	    if (test1278_274)
	      {		/* Expand/eps.scm 112 */
		 display_2_122___r4_output_6_10_3(_nb_error_on_pass__70_tools_error, current_error_port);
		 display_2_122___r4_output_6_10_3(string1341_expand_eps, current_error_port);
		 {	/* Expand/eps.scm 112 */
		    char *arg1280_276;
		    {	/* Expand/eps.scm 112 */
		       bool_t test1281_277;
		       {	/* Expand/eps.scm 112 */
			  bool_t test1282_278;
			  {	/* Expand/eps.scm 112 */
			     obj_t obj_453;
			     obj_453 = _nb_error_on_pass__70_tools_error;
			     test1282_278 =
				INTEGERP(obj_453);
			  }
			  if (test1282_278)
			    {	/* Expand/eps.scm 112 */
			       test1281_277 =
				  _2__206___r4_numbers_6_5(_nb_error_on_pass__70_tools_error,
				  BINT(((long) 1)));
			    }
			  else
			    {	/* Expand/eps.scm 112 */
			       test1281_277 = ((bool_t) 0);
			    }
		       }
		       if (test1281_277)
			 {	/* Expand/eps.scm 112 */
			    arg1280_276 = "s";
			 }
		       else
			 {	/* Expand/eps.scm 112 */
			    arg1280_276 = "";
			 }
		    }
		    display_2_122___r4_output_6_10_3(
		       string_to_bstring(arg1280_276), current_error_port);
		 }
		 display_2_122___r4_output_6_10_3(string1342_expand_eps, current_error_port);
		 WRITE_CHAR(((unsigned char) '\n'), current_error_port);
		 {	/* Expand/eps.scm 112 */
		    obj_t res1333_456;
		    exit(((long) -1));
		    res1333_456 =
		       BINT(((long) -1));
		    return res1333_456;
		 }
	      }
	    else
	      {
		 obj_t hooks_279;
		 obj_t hnames_280;
		 hooks_279 = BNIL;
		 hnames_280 = BNIL;
	       loop_281:
		 if (
		    NULLP(hooks_279))
		   {	/* Expand/eps.scm 112 */
		      return units_34;
		   }
		 else
		   {	/* Expand/eps.scm 112 */
		      bool_t test1290_286;
		      {		/* Expand/eps.scm 112 */
			 obj_t fun1295_291;
			 fun1295_291 =
			    CAR(hooks_279);
			 {	/* Expand/eps.scm 112 */
			    obj_t aux_825;
			    aux_825 =
			       PROCEDURE_ENTRY(fun1295_291) (fun1295_291, BEOA);
			    test1290_286 =
			       CBOOL(aux_825);
			 }
		      }
		      if (test1290_286)
			{	/* Expand/eps.scm 112 */
			   {
			      obj_t hnames_832;
			      obj_t hooks_830;
			      hooks_830 =
				 CDR(hooks_279);
			      hnames_832 =
				 CDR(hnames_280);
			      hnames_280 = hnames_832;
			      hooks_279 = hooks_830;
			      goto loop_281;
			   }
			}
		      else
			{	/* Expand/eps.scm 112 */
			   return
			      internal_error_43_tools_error(_current_pass__25_engine_pass, string1343_expand_eps,
			      CAR(hnames_280));
			}
		   }
	      }
	 }
      }
   }
}



/* handling_function1246 */
obj_t 
handling_function1246_expand_eps(obj_t body1047_636, obj_t rhandler1046_635, obj_t handler1045_634, obj_t armed1048_633)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 101 */
      jmp_buf jmpbuf;
      obj_t an_exit1049_196;
      if (SET_EXIT(an_exit1049_196))
	{
	   RESTORE_TRACE();
	   return
	      _exit_value_;
	}
      else
	{
	   an_exit1049_196 =
	      (obj_t) jmpbuf;
	   {	/* Expand/eps.scm 101 */

	      PUSH_EXIT(an_exit1049_196, ((bool_t) 1));
	      {		/* Expand/eps.scm 101 */
		 obj_t an_exitd1050_197;
		 an_exitd1050_197 = exitd_top;
		 {	/* Expand/eps.scm 101 */
		    obj_t escape_530;
		    escape_530 =
		       make_fx_procedure(escape_1336_expand_eps, ((long) 1), ((long) 1));
		    PROCEDURE_SET(escape_530, ((long) 0), an_exitd1050_197);
		    {	/* Expand/eps.scm 101 */
		       obj_t res1052_200;
		       {	/* Expand/eps.scm 101 */
			  obj_t _anonymous_1251__213_528;
			  obj_t _anonymous_1250__207_532;
			  _anonymous_1251__213_528 =
			     make_fx_procedure(_anonymous_1251__213_expand_eps, ((long) 0), ((long) 1));
			  _anonymous_1250__207_532 =
			     make_fx_procedure(_anonymous_1250__207_expand_eps, ((long) 0), ((long) 5));
			  PROCEDURE_SET(_anonymous_1251__213_528, ((long) 0), armed1048_633);
			  PROCEDURE_SET(_anonymous_1250__207_532, ((long) 0), an_exitd1050_197);
			  PROCEDURE_SET(_anonymous_1250__207_532, ((long) 1), armed1048_633);
			  PROCEDURE_SET(_anonymous_1250__207_532, ((long) 2), handler1045_634);
			  PROCEDURE_SET(_anonymous_1250__207_532, ((long) 3), rhandler1046_635);
			  PROCEDURE_SET(_anonymous_1250__207_532, ((long) 4), escape_530);
			  res1052_200 =
			     dynamic_wind_31___r4_control_features_6_9(_anonymous_1250__207_532, body1047_636, _anonymous_1251__213_528);
		       }
		       POP_EXIT();
		       return res1052_200;
		    }
		 }
	      }
	   }
	}
   }
}



/* handling_function1256 */
obj_t 
handling_function1256_expand_eps(obj_t body1055_640, obj_t rhandler1054_639, obj_t handler1053_638, obj_t armed1056_637)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 104 */
      jmp_buf jmpbuf;
      obj_t an_exit1057_222;
      if (SET_EXIT(an_exit1057_222))
	{
	   RESTORE_TRACE();
	   return
	      _exit_value_;
	}
      else
	{
	   an_exit1057_222 =
	      (obj_t) jmpbuf;
	   {	/* Expand/eps.scm 104 */

	      PUSH_EXIT(an_exit1057_222, ((bool_t) 1));
	      {		/* Expand/eps.scm 104 */
		 obj_t an_exitd1058_223;
		 an_exitd1058_223 = exitd_top;
		 {	/* Expand/eps.scm 104 */
		    obj_t escape_525;
		    escape_525 =
		       make_fx_procedure(escape_1335_expand_eps, ((long) 1), ((long) 1));
		    PROCEDURE_SET(escape_525, ((long) 0), an_exitd1058_223);
		    {	/* Expand/eps.scm 104 */
		       obj_t res1060_226;
		       {	/* Expand/eps.scm 104 */
			  obj_t _anonymous_1260__161_523;
			  obj_t _anonymous_1259__73_527;
			  _anonymous_1260__161_523 =
			     make_fx_procedure(_anonymous_1260__161_expand_eps, ((long) 0), ((long) 1));
			  _anonymous_1259__73_527 =
			     make_fx_procedure(_anonymous_1259__73_expand_eps, ((long) 0), ((long) 5));
			  PROCEDURE_SET(_anonymous_1260__161_523, ((long) 0), armed1056_637);
			  PROCEDURE_SET(_anonymous_1259__73_527, ((long) 0), an_exitd1058_223);
			  PROCEDURE_SET(_anonymous_1259__73_527, ((long) 1), armed1056_637);
			  PROCEDURE_SET(_anonymous_1259__73_527, ((long) 2), handler1053_638);
			  PROCEDURE_SET(_anonymous_1259__73_527, ((long) 3), rhandler1054_639);
			  PROCEDURE_SET(_anonymous_1259__73_527, ((long) 4), escape_525);
			  res1060_226 =
			     dynamic_wind_31___r4_control_features_6_9(_anonymous_1259__73_527, body1055_640, _anonymous_1260__161_523);
		       }
		       POP_EXIT();
		       return res1060_226;
		    }
		 }
	      }
	   }
	}
   }
}



/* handling_function1268 */
obj_t 
handling_function1268_expand_eps(obj_t body1063_644, obj_t rhandler1062_643, obj_t handler1061_642, obj_t armed1064_641)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 108 */
      jmp_buf jmpbuf;
      obj_t an_exit1065_252;
      if (SET_EXIT(an_exit1065_252))
	{
	   RESTORE_TRACE();
	   return
	      _exit_value_;
	}
      else
	{
	   an_exit1065_252 =
	      (obj_t) jmpbuf;
	   {	/* Expand/eps.scm 108 */

	      PUSH_EXIT(an_exit1065_252, ((bool_t) 1));
	      {		/* Expand/eps.scm 108 */
		 obj_t an_exitd1066_253;
		 an_exitd1066_253 = exitd_top;
		 {	/* Expand/eps.scm 108 */
		    obj_t escape_520;
		    escape_520 =
		       make_fx_procedure(escape_expand_eps, ((long) 1), ((long) 1));
		    PROCEDURE_SET(escape_520, ((long) 0), an_exitd1066_253);
		    {	/* Expand/eps.scm 108 */
		       obj_t res1068_256;
		       {	/* Expand/eps.scm 108 */
			  obj_t _anonymous_1272__46_515;
			  obj_t _anonymous_1271__21_522;
			  _anonymous_1272__46_515 =
			     make_fx_procedure(_anonymous_1272__46_expand_eps, ((long) 0), ((long) 1));
			  _anonymous_1271__21_522 =
			     make_fx_procedure(_anonymous_1271__21_expand_eps, ((long) 0), ((long) 5));
			  PROCEDURE_SET(_anonymous_1272__46_515, ((long) 0), armed1064_641);
			  PROCEDURE_SET(_anonymous_1271__21_522, ((long) 0), an_exitd1066_253);
			  PROCEDURE_SET(_anonymous_1271__21_522, ((long) 1), armed1064_641);
			  PROCEDURE_SET(_anonymous_1271__21_522, ((long) 2), handler1061_642);
			  PROCEDURE_SET(_anonymous_1271__21_522, ((long) 3), rhandler1062_643);
			  PROCEDURE_SET(_anonymous_1271__21_522, ((long) 4), escape_520);
			  res1068_256 =
			     dynamic_wind_31___r4_control_features_6_9(_anonymous_1271__21_522, body1063_644, _anonymous_1272__46_515);
		       }
		       POP_EXIT();
		       return res1068_256;
		    }
		 }
	      }
	   }
	}
   }
}



/* _expand-units */
obj_t 
_expand_units_69_expand_eps(obj_t env_534, obj_t units_535)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 80 */
      return
	 expand_units_9_expand_eps(units_535);
   }
}



/* <anonymous:1272> */
obj_t 
_anonymous_1272__46_expand_eps(obj_t env_536)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 108 */
      {		/* Expand/eps.scm 108 */
	 obj_t armed1064_537;
	 armed1064_537 =
	    PROCEDURE_REF(env_536, ((long) 0));
	 {

	    {	/* Expand/eps.scm 108 */
	       bool_t test_883;
	       {	/* Expand/eps.scm 108 */
		  obj_t aux_884;
		  aux_884 =
		     CELL_REF(armed1064_537);
		  test_883 =
		     CBOOL(aux_884);
	       }
	       if (test_883)
		 {	/* Expand/eps.scm 108 */
		    CELL_SET(armed1064_537, BFALSE);
		    return
		       remove_error_handler__102___error();
		 }
	       else
		 {	/* Expand/eps.scm 108 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* body1063 */
obj_t 
body1063_expand_eps(obj_t env_539)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 108 */
      {		/* Expand/eps.scm 108 */
	 obj_t obody_540;
	 obody_540 =
	    PROCEDURE_REF(env_539, ((long) 0));
	 {

	    return
	       initial_expander_162_expand_eps(obody_540, initial_expander_env_197_expand_eps);
	 }
      }
   }
}



/* <anonymous:1271> */
obj_t 
_anonymous_1271__21_expand_eps(obj_t env_541)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 108 */
      {		/* Expand/eps.scm 108 */
	 obj_t rhandler1062_545;
	 obj_t escape_546;
	 rhandler1062_545 =
	    PROCEDURE_REF(env_541, ((long) 3));
	 escape_546 =
	    PROCEDURE_REF(env_541, ((long) 4));
	 {

	    return
	       add_error_handler__155___error(rhandler1062_545, escape_546);
	 }
      }
   }
}



/* escape */
obj_t 
escape_expand_eps(obj_t env_547, obj_t val1067_549)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 108 */
      {		/* Expand/eps.scm 108 */
	 obj_t an_exitd1066_548;
	 an_exitd1066_548 =
	    PROCEDURE_REF(env_547, ((long) 0));
	 {
	    obj_t val1067_254;
	    val1067_254 = val1067_549;
	    return
	       unwind_until__178___bexit(an_exitd1066_548, val1067_254);
	 }
      }
   }
}



/* rhandler1062 */
obj_t 
rhandler1062_expand_eps(obj_t env_550, obj_t esc_553, obj_t obj_554, obj_t proc_555, obj_t msg_556)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 108 */
      {		/* Expand/eps.scm 108 */
	 obj_t armed1064_551;
	 obj_t handler1061_552;
	 armed1064_551 =
	    PROCEDURE_REF(env_550, ((long) 0));
	 handler1061_552 =
	    PROCEDURE_REF(env_550, ((long) 1));
	 {
	    obj_t esc_263;
	    obj_t obj_264;
	    obj_t proc_265;
	    obj_t msg_266;
	    esc_263 = esc_553;
	    obj_264 = obj_554;
	    proc_265 = proc_555;
	    msg_266 = msg_556;
	    CELL_SET(armed1064_551, BFALSE);
	    remove_error_handler__102___error();
	    {	/* Expand/eps.scm 108 */
	       obj_t aux_898;
	       aux_898 =
		  CELL_REF(handler1061_552);
	       return
		  PROCEDURE_ENTRY(aux_898) (
		  CELL_REF(handler1061_552), esc_263, obj_264, proc_265, msg_266, BEOA);
	    }
	 }
      }
   }
}



/* <anonymous:1260> */
obj_t 
_anonymous_1260__161_expand_eps(obj_t env_558)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 104 */
      {		/* Expand/eps.scm 104 */
	 obj_t armed1056_559;
	 armed1056_559 =
	    PROCEDURE_REF(env_558, ((long) 0));
	 {

	    {	/* Expand/eps.scm 104 */
	       bool_t test_900;
	       {	/* Expand/eps.scm 104 */
		  obj_t aux_901;
		  aux_901 =
		     CELL_REF(armed1056_559);
		  test_900 =
		     CBOOL(aux_901);
	       }
	       if (test_900)
		 {	/* Expand/eps.scm 104 */
		    CELL_SET(armed1056_559, BFALSE);
		    return
		       remove_error_handler__102___error();
		 }
	       else
		 {	/* Expand/eps.scm 104 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* body1055 */
obj_t 
body1055_expand_eps(obj_t env_561)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 104 */
      {		/* Expand/eps.scm 104 */
	 obj_t src_562;
	 src_562 =
	    PROCEDURE_REF(env_561, ((long) 0));
	 {

	    return
	       initial_expander_162_expand_eps(
	       CAR(src_562), initial_expander_env_197_expand_eps);
	 }
      }
   }
}



/* <anonymous:1259> */
obj_t 
_anonymous_1259__73_expand_eps(obj_t env_563)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 104 */
      {		/* Expand/eps.scm 104 */
	 obj_t rhandler1054_567;
	 obj_t escape_568;
	 rhandler1054_567 =
	    PROCEDURE_REF(env_563, ((long) 3));
	 escape_568 =
	    PROCEDURE_REF(env_563, ((long) 4));
	 {

	    return
	       add_error_handler__155___error(rhandler1054_567, escape_568);
	 }
      }
   }
}



/* escape_1335 */
obj_t 
escape_1335_expand_eps(obj_t env_569, obj_t val1059_571)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 104 */
      {		/* Expand/eps.scm 104 */
	 obj_t an_exitd1058_570;
	 an_exitd1058_570 =
	    PROCEDURE_REF(env_569, ((long) 0));
	 {
	    obj_t val1059_224;
	    val1059_224 = val1059_571;
	    return
	       unwind_until__178___bexit(an_exitd1058_570, val1059_224);
	 }
      }
   }
}



/* rhandler1054 */
obj_t 
rhandler1054_expand_eps(obj_t env_572, obj_t esc_575, obj_t obj_576, obj_t proc_577, obj_t msg_578)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 104 */
      {		/* Expand/eps.scm 104 */
	 obj_t armed1056_573;
	 obj_t handler1053_574;
	 armed1056_573 =
	    PROCEDURE_REF(env_572, ((long) 0));
	 handler1053_574 =
	    PROCEDURE_REF(env_572, ((long) 1));
	 {
	    obj_t esc_233;
	    obj_t obj_234;
	    obj_t proc_235;
	    obj_t msg_236;
	    esc_233 = esc_575;
	    obj_234 = obj_576;
	    proc_235 = proc_577;
	    msg_236 = msg_578;
	    CELL_SET(armed1056_573, BFALSE);
	    remove_error_handler__102___error();
	    {	/* Expand/eps.scm 104 */
	       obj_t aux_916;
	       aux_916 =
		  CELL_REF(handler1053_574);
	       return
		  PROCEDURE_ENTRY(aux_916) (
		  CELL_REF(handler1053_574), esc_233, obj_234, proc_235, msg_236, BEOA);
	    }
	 }
      }
   }
}



/* <anonymous:1251> */
obj_t 
_anonymous_1251__213_expand_eps(obj_t env_580)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 101 */
      {		/* Expand/eps.scm 101 */
	 obj_t armed1048_581;
	 armed1048_581 =
	    PROCEDURE_REF(env_580, ((long) 0));
	 {

	    {	/* Expand/eps.scm 101 */
	       bool_t test_918;
	       {	/* Expand/eps.scm 101 */
		  obj_t aux_919;
		  aux_919 =
		     CELL_REF(armed1048_581);
		  test_918 =
		     CBOOL(aux_919);
	       }
	       if (test_918)
		 {	/* Expand/eps.scm 101 */
		    CELL_SET(armed1048_581, BFALSE);
		    return
		       remove_error_handler__102___error();
		 }
	       else
		 {	/* Expand/eps.scm 101 */
		    return BUNSPEC;
		 }
	    }
	 }
      }
   }
}



/* body1047 */
obj_t 
body1047_expand_eps(obj_t env_583)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 101 */
      {		/* Expand/eps.scm 101 */
	 obj_t src_584;
	 src_584 =
	    PROCEDURE_REF(env_583, ((long) 0));
	 {

	    return
	       initial_expander_162_expand_eps(
	       CAR(src_584), initial_expander_env_197_expand_eps);
	 }
      }
   }
}



/* <anonymous:1250> */
obj_t 
_anonymous_1250__207_expand_eps(obj_t env_585)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 101 */
      {		/* Expand/eps.scm 101 */
	 obj_t rhandler1046_589;
	 obj_t escape_590;
	 rhandler1046_589 =
	    PROCEDURE_REF(env_585, ((long) 3));
	 escape_590 =
	    PROCEDURE_REF(env_585, ((long) 4));
	 {

	    return
	       add_error_handler__155___error(rhandler1046_589, escape_590);
	 }
      }
   }
}



/* escape_1336 */
obj_t 
escape_1336_expand_eps(obj_t env_591, obj_t val1051_593)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 101 */
      {		/* Expand/eps.scm 101 */
	 obj_t an_exitd1050_592;
	 an_exitd1050_592 =
	    PROCEDURE_REF(env_591, ((long) 0));
	 {
	    obj_t val1051_198;
	    val1051_198 = val1051_593;
	    return
	       unwind_until__178___bexit(an_exitd1050_592, val1051_198);
	 }
      }
   }
}



/* rhandler1046 */
obj_t 
rhandler1046_expand_eps(obj_t env_594, obj_t esc_597, obj_t obj_598, obj_t proc_599, obj_t msg_600)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 101 */
      {		/* Expand/eps.scm 101 */
	 obj_t armed1048_595;
	 obj_t handler1045_596;
	 armed1048_595 =
	    PROCEDURE_REF(env_594, ((long) 0));
	 handler1045_596 =
	    PROCEDURE_REF(env_594, ((long) 1));
	 {
	    obj_t esc_207;
	    obj_t obj_208;
	    obj_t proc_209;
	    obj_t msg_210;
	    esc_207 = esc_597;
	    obj_208 = obj_598;
	    proc_209 = proc_599;
	    msg_210 = msg_600;
	    CELL_SET(armed1048_595, BFALSE);
	    remove_error_handler__102___error();
	    {	/* Expand/eps.scm 101 */
	       obj_t aux_934;
	       aux_934 =
		  CELL_REF(handler1045_596);
	       return
		  PROCEDURE_ENTRY(aux_934) (
		  CELL_REF(handler1045_596), esc_207, obj_208, proc_209, msg_210, BEOA);
	    }
	 }
      }
   }
}



/* handler */
obj_t 
handler_expand_eps(obj_t env_602, obj_t escape_603, obj_t proc_604, obj_t mes_605, obj_t obj_606)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 87 */
      {
	 obj_t escape_292;
	 obj_t proc_293;
	 obj_t mes_294;
	 obj_t obj_295;
	 escape_292 = escape_603;
	 proc_293 = proc_604;
	 mes_294 = mes_605;
	 obj_295 = obj_606;
	 {	/* Expand/eps.scm 88 */
	    obj_t arg1297_463;
	    {	/* Expand/eps.scm 88 */
	       obj_t list1298_464;
	       {	/* Expand/eps.scm 88 */
		  obj_t aux_935;
		  aux_935 =
		     CNST_TABLE_REF(((long) 4));
		  list1298_464 =
		     MAKE_PAIR(aux_935, BNIL);
	       }
	       arg1297_463 =
		  user_error_151_tools_error(proc_293, mes_294, obj_295, list1298_464);
	    }
	    return
	       PROCEDURE_ENTRY(escape_292) (escape_292, arg1297_463, BEOA);
	 }
      }
   }
}



/* comptime-expand */
obj_t 
comptime_expand_37_expand_eps(obj_t x_35)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 117 */
      return
	 initial_expander_162_expand_eps(x_35, initial_expander_env_197_expand_eps);
   }
}



/* _comptime-expand */
obj_t 
_comptime_expand_212_expand_eps(obj_t env_613, obj_t x_614)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 117 */
      return
	 comptime_expand_37_expand_eps(x_614);
   }
}



/* comptime-expand-once */
obj_t 
comptime_expand_once_113_expand_eps(obj_t x_36)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 123 */
      {		/* Expand/eps.scm 124 */
	 obj_t _anonymous_1300__140_615;
	 _anonymous_1300__140_615 = proc1344_expand_eps;
	 return
	    initial_expander_162_expand_eps(x_36, _anonymous_1300__140_615);
      }
   }
}



/* _comptime-expand-once */
obj_t 
_comptime_expand_once_1_expand_eps(obj_t env_616, obj_t x_617)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 123 */
      return
	 comptime_expand_once_113_expand_eps(x_617);
   }
}



/* <anonymous:1300> */
obj_t 
_anonymous_1300__140_expand_eps(obj_t env_618, obj_t x_619, obj_t e_620)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 124 */
      {
	 obj_t x_466;
	 obj_t e_467;
	 x_466 = x_619;
	 e_467 = e_620;
	 return x_466;
      }
   }
}



/* initial-expander */
obj_t 
initial_expander_162_expand_eps(obj_t x_37, obj_t e_38)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 129 */
      {		/* Expand/eps.scm 131 */
	 obj_t e1_305;
	 if (
	    SYMBOLP(x_37))
	   {	/* Expand/eps.scm 132 */
	      e1_305 = _identifier_expander__env_242_expand_eps;
	   }
	 else
	   {	/* Expand/eps.scm 132 */
	      if (
		 NULLP(x_37))
		{	/* Expand/eps.scm 134 */
		   FAILURE(BFALSE, string1345_expand_eps, BNIL);
		}
	      else
		{	/* Expand/eps.scm 134 */
		   if (
		      PAIRP(x_37))
		     {	/* Expand/eps.scm 138 */
			bool_t test_952;
			{	/* ./Ieee/symbol.scm 6015 */
			   obj_t aux_953;
			   aux_953 =
			      CAR(x_37);
			   test_952 =
			      SYMBOLP(aux_953);
			}
			if (test_952)
			  {	/* Expand/eps.scm 138 */
			     {	/* Expand/eps.scm 139 */
				obj_t id_317;
				{	/* Expand/eps.scm 139 */
				   obj_t arg1318_325;
				   obj_t arg1319_326;
				   arg1318_325 =
				      CAR(x_37);
				   arg1319_326 =
				      find_location_120_tools_location(x_37);
				   id_317 =
				      fast_id_of_id_130_ast_ident(arg1318_325, arg1319_326);
				}
				{	/* Expand/eps.scm 141 */
				   obj_t b_318;
				   b_318 = BUNSPEC;
				   {	/* Expand/eps.scm 143 */
				      bool_t test1311_319;
				      b_318 =
					 get_compiler_expander_150___macro(id_317);
				      test1311_319 =
					 CBOOL(b_318);
				      if (test1311_319)
					{	/* Expand/eps.scm 143 */
					   e1_305 = b_318;
					}
				      else
					{	/* Expand/eps.scm 147 */
					   bool_t test1312_320;
					   b_318 =
					      get_eval_expander_232___macro(id_317);
					   test1312_320 =
					      CBOOL(b_318);
					   if (test1312_320)
					     {	/* Expand/eps.scm 147 */
						e1_305 = b_318;
					     }
					   else
					     {	/* Expand/eps.scm 151 */
						bool_t test1313_321;
						{	/* Expand/eps.scm 151 */
						   obj_t arg1315_323;
						   {	/* Expand/eps.scm 151 */
						      obj_t arg1317_324;
						      arg1317_324 = _lexical_stack__25_expand_eps;
						      arg1315_323 =
							 assq___r4_pairs_and_lists_6_3(id_317, arg1317_324);
						   }
						   test1313_321 =
						      PAIRP(arg1315_323);
						}
						if (test1313_321)
						  {	/* Expand/eps.scm 151 */
						     e1_305 = _application_expander__env_69_expand_eps;
						  }
						else
						  {	/* Expand/eps.scm 153 */
						     bool_t test1314_322;
						     b_318 =
							find_o_expander_0_expand_expander(id_317);
						     test1314_322 =
							CBOOL(b_318);
						     if (test1314_322)
						       {	/* Expand/eps.scm 153 */
							  {	/* Expand/eps.scm 156 */
							     obj_t s_479;
							     s_479 = b_318;
							     e1_305 =
								STRUCT_REF(s_479, ((long) 1));
							  }
						       }
						     else
						       {	/* Expand/eps.scm 153 */
							  e1_305 = _application_expander__env_69_expand_eps;
						       }
						  }
					     }
					}
				   }
				}
			     }
			  }
			else
			  {	/* Expand/eps.scm 138 */
			     e1_305 = _application_expander__env_69_expand_eps;
			  }
		     }
		   else
		     {	/* Expand/eps.scm 136 */
			{	/* Expand/eps.scm 137 */
			   obj_t _anonymous_1321__117_621;
			   _anonymous_1321__117_621 = proc1346_expand_eps;
			   e1_305 = _anonymous_1321__117_621;
			}
		     }
		}
	   }
	 {	/* Expand/eps.scm 161 */
	    obj_t new_306;
	    new_306 =
	       PROCEDURE_ENTRY(e1_305) (e1_305, x_37, e_38, BEOA);
	    {	/* Expand/eps.scm 162 */
	       bool_t test1301_307;
	       if (
		  PAIRP(new_306))
		 {	/* Expand/eps.scm 163 */
		    bool_t test1306_312;
		    test1306_312 =
		       EXTENDED_PAIRP(new_306);
		    if (test1306_312)
		      {		/* Expand/eps.scm 163 */
			 test1301_307 = ((bool_t) 0);
		      }
		    else
		      {		/* Expand/eps.scm 163 */
			 test1301_307 =
			    EXTENDED_PAIRP(x_37);
		      }
		 }
	       else
		 {	/* Expand/eps.scm 162 */
		    test1301_307 = ((bool_t) 0);
		 }
	       if (test1301_307)
		 {	/* Expand/eps.scm 165 */
		    obj_t arg1302_308;
		    obj_t arg1303_309;
		    obj_t arg1304_310;
		    arg1302_308 =
		       CAR(new_306);
		    arg1303_309 =
		       CDR(new_306);
		    {	/* ./Ieee/pair-list.scm 5713 */
		       bool_t test1136_488;
		       test1136_488 =
			  EXTENDED_PAIRP(x_37);
		       if (test1136_488)
			 {	/* ./Ieee/pair-list.scm 5713 */
			    arg1304_310 =
			       CER(x_37);
			 }
		       else
			 {	/* ./Ieee/pair-list.scm 5713 */
			    FAILURE(string1347_expand_eps, string1348_expand_eps, x_37);
			 }
		    }
		    return
		       MAKE_EXTENDED_PAIR(arg1302_308, arg1303_309, arg1304_310);
		 }
	       else
		 {	/* Expand/eps.scm 162 */
		    return new_306;
		 }
	    }
	 }
      }
   }
}



/* _initial-expander */
obj_t 
_initial_expander_127_expand_eps(obj_t env_517, obj_t x_518, obj_t e_519)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 129 */
      return
	 initial_expander_162_expand_eps(x_518, e_519);
   }
}



/* <anonymous:1321> */
obj_t 
_anonymous_1321__117_expand_eps(obj_t env_622, obj_t x_623, obj_t e_624)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 137 */
      {
	 obj_t x_328;
	 obj_t e_329;
	 x_328 = x_623;
	 e_329 = e_624;
	 return x_328;
      }
   }
}



/* *identifier-expander* */
obj_t 
_identifier_expander__166_expand_eps(obj_t x_39, obj_t e_40)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 171 */
      return x_39;
   }
}



/* _*identifier-expander* */
obj_t 
__identifier_expander__134_expand_eps(obj_t env_625, obj_t x_626, obj_t e_627)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 171 */
      return
	 _identifier_expander__166_expand_eps(x_626, e_627);
   }
}



/* *application-expander* */
obj_t 
_application_expander__202_expand_eps(obj_t x_41, obj_t e_42)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 177 */
      return
	 loop_expand_eps(e_42, x_41, x_41);
   }
}



/* loop */
obj_t 
loop_expand_eps(obj_t e_632, obj_t x_631, obj_t x__12_331)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 178 */
      if (
	 PAIRP(x__12_331))
	{	/* Expand/eps.scm 180 */
	   {	/* Expand/eps.scm 181 */
	      obj_t arg1323_334;
	      arg1323_334 =
		 PROCEDURE_ENTRY(e_632) (e_632,
		 CAR(x__12_331), e_632, BEOA);
	      SET_CAR(x__12_331, arg1323_334);
	   }
	   {	/* Expand/eps.scm 182 */
	      obj_t arg1326_336;
	      arg1326_336 =
		 loop_expand_eps(e_632, x_631,
		 CDR(x__12_331));
	      SET_CDR(x__12_331, arg1326_336);
	   }
	   return x__12_331;
	}
      else
	{	/* Expand/eps.scm 180 */
	   if (
	      NULLP(x__12_331))
	     {	/* Expand/eps.scm 184 */
		return BNIL;
	     }
	   else
	     {	/* Expand/eps.scm 184 */
		FAILURE(BFALSE, string1345_expand_eps, x_631);
	     }
	}
   }
}



/* _*application-expander* */
obj_t 
__application_expander__200_expand_eps(obj_t env_628, obj_t x_629, obj_t e_630)
{
   AN_OBJECT;
   {	/* Expand/eps.scm 177 */
      return
	 _application_expander__202_expand_eps(x_629, e_630);
   }
}



/* method-init */
obj_t 
method_init_76_expand_eps()
{
   AN_OBJECT;
   {	/* Expand/eps.scm 16 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_expand_eps()
{
   AN_OBJECT;
   {	/* Expand/eps.scm 16 */
      module_initialization_70_tools_trace(((long) 0), "EXPAND_EPS");
      module_initialization_70_tools_speek(((long) 0), "EXPAND_EPS");
      module_initialization_70_tools_error(((long) 0), "EXPAND_EPS");
      module_initialization_70_engine_pass(((long) 0), "EXPAND_EPS");
      module_initialization_70_tools_progn(((long) 0), "EXPAND_EPS");
      module_initialization_70_tools_misc(((long) 0), "EXPAND_EPS");
      module_initialization_70_type_type(((long) 0), "EXPAND_EPS");
      module_initialization_70_ast_ident(((long) 0), "EXPAND_EPS");
      module_initialization_70_expand_expander(((long) 0), "EXPAND_EPS");
      return
	 module_initialization_70_tools_location(((long) 0), "EXPAND_EPS");
   }
}
