/*===========================================================================*/
/*   (Expand/exit.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;


static obj_t method_init_76_expand_exit();
extern obj_t mark_symbol_non_user__17_ast_ident(obj_t);
extern obj_t expand_set_exit_79_expand_exit(obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t module_initialization_70_expand_exit(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_progn(long, char *);
extern obj_t module_initialization_70_tools_args(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_expand_expander(long, char *);
extern obj_t module_initialization_70_expand_eps(long, char *);
extern obj_t module_initialization_70_expand_lambda(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t expand_jump_exit_91_expand_exit(obj_t, obj_t);
static obj_t imported_modules_init_94_expand_exit();
static obj_t _expand_bind_exit1375_210_expand_exit(obj_t, obj_t, obj_t);
extern obj_t normalize_progn_143_tools_progn(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_expand_exit();
static obj_t toplevel_init_63_expand_exit();
extern obj_t replace__160_tools_misc(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
static obj_t _expand_unwind_protect1376_218_expand_exit(obj_t, obj_t, obj_t);
static obj_t _expand_jump_exit1373_220_expand_exit(obj_t, obj_t, obj_t);
extern obj_t expand_unwind_protect_208_expand_exit(obj_t, obj_t);
static obj_t _expand_set_exit1374_39_expand_exit(obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t expand_bind_exit_231_expand_exit(obj_t, obj_t);
static obj_t require_initialization_114_expand_exit = BUNSPEC;
static obj_t cnst_init_137_expand_exit();
static obj_t __cnst[17];

DEFINE_EXPORT_PROCEDURE(expand_bind_exit_env_198_expand_exit, _expand_bind_exit1375_210_expand_exit1388, _expand_bind_exit1375_210_expand_exit, 0L, 2);
DEFINE_EXPORT_PROCEDURE(expand_jump_exit_env_87_expand_exit, _expand_jump_exit1373_220_expand_exit1389, _expand_jump_exit1373_220_expand_exit, 0L, 2);
DEFINE_EXPORT_PROCEDURE(expand_set_exit_env_141_expand_exit, _expand_set_exit1374_39_expand_exit1390, _expand_set_exit1374_39_expand_exit, 0L, 2);
DEFINE_EXPORT_PROCEDURE(expand_unwind_protect_env_54_expand_exit, _expand_unwind_protect1376_218_expand_exit1391, _expand_unwind_protect1376_218_expand_exit, 0L, 2);
DEFINE_STRING(string1383_expand_exit, string1383_expand_exit1392, "CDR CAR VAL-FROM-EXIT? IF POP-EXIT! BEGIN UNWIND-UNTIL! LABELS *EXITD-TOP* PUSH-EXIT! LET RES VAL AN_EXITD AN_EXIT SET-EXIT JUMP-EXIT ", 134);
DEFINE_STRING(string1382_expand_exit, string1382_expand_exit1393, "Illegal `unwind-protect' form", 29);
DEFINE_STRING(string1381_expand_exit, string1381_expand_exit1394, "Type `extended pair' expected for expression", 44);
DEFINE_STRING(string1379_expand_exit, string1379_expand_exit1395, "Illegal `bind-exit' form", 24);
DEFINE_STRING(string1380_expand_exit, string1380_expand_exit1396, "cer", 3);
DEFINE_STRING(string1378_expand_exit, string1378_expand_exit1397, "Illegal `set-exit' form", 23);
DEFINE_STRING(string1377_expand_exit, string1377_expand_exit1398, "Illegal 'jump-exit' form", 24);



/* module-initialization */
obj_t 
module_initialization_70_expand_exit(long checksum_547, char *from_548)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_expand_exit))
	{
	   require_initialization_114_expand_exit =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_expand_exit();
	   cnst_init_137_expand_exit();
	   imported_modules_init_94_expand_exit();
	   method_init_76_expand_exit();
	   toplevel_init_63_expand_exit();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_expand_exit()
{
   AN_OBJECT;
   {	/* Expand/exit.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "EXPAND_EXIT");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "EXPAND_EXIT");
      module_initialization_70___reader(((long) 0), "EXPAND_EXIT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_expand_exit()
{
   AN_OBJECT;
   {	/* Expand/exit.scm 14 */
      {		/* Expand/exit.scm 14 */
	 obj_t cnst_port_138_540;
	 cnst_port_138_540 =
	    open_input_string(string1383_expand_exit);
	 {
	    long i_541;
	    i_541 = ((long) 16);
	  loop_542:
	    {	/* Expand/exit.scm 14 */
	       bool_t test1384_543;
	       test1384_543 =
		  (i_541 == ((long) -1));
	       if (test1384_543)
		 {	/* Expand/exit.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Expand/exit.scm 14 */
		    {	/* Expand/exit.scm 14 */
		       obj_t arg1385_544;
		       {	/* Expand/exit.scm 14 */
			  obj_t list1386_545;
			  list1386_545 =
			     MAKE_PAIR(cnst_port_138_540, BNIL);
			  arg1385_544 =
			     read___reader(list1386_545);
		       }
		       CNST_TABLE_SET(i_541, arg1385_544);
		    }
		    {	/* Expand/exit.scm 14 */
		       int aux_546;
		       {	/* Expand/exit.scm 14 */
			  long aux_566;
			  aux_566 =
			     (i_541 - ((long) 1));
			  aux_546 =
			     (int) (aux_566);
		       }
		       {
			  long i_569;
			  i_569 =
			     (long) (aux_546);
			  i_541 = i_569;
			  goto loop_542;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_expand_exit()
{
   AN_OBJECT;
   {	/* Expand/exit.scm 14 */
      return BUNSPEC;
   }
}



/* expand-jump-exit */
obj_t 
expand_jump_exit_91_expand_exit(obj_t x_11, obj_t e_12)
{
   AN_OBJECT;
   {	/* Expand/exit.scm 35 */
      {
	 obj_t exit_80;
	 obj_t value_81;
	 if (
	    PAIRP(x_11))
	   {	/* Expand/exit.scm 36 */
	      obj_t cdr_128_145_86;
	      cdr_128_145_86 =
		 CDR(x_11);
	      if (
		 PAIRP(cdr_128_145_86))
		{	/* Expand/exit.scm 36 */
		   exit_80 =
		      CAR(cdr_128_145_86);
		   value_81 =
		      CDR(cdr_128_145_86);
		   {	/* Expand/exit.scm 38 */
		      obj_t new_90;
		      {		/* Expand/exit.scm 38 */
			 obj_t arg1142_91;
			 obj_t arg1144_92;
			 arg1142_91 =
			    CNST_TABLE_REF(((long) 0));
			 {	/* Expand/exit.scm 38 */
			    obj_t arg1145_93;
			    obj_t arg1150_94;
			    arg1145_93 =
			       PROCEDURE_ENTRY(e_12) (e_12, exit_80, e_12, BEOA);
			    {	/* Expand/exit.scm 38 */
			       obj_t arg1157_95;
			       {	/* Expand/exit.scm 38 */
				  obj_t arg1161_97;
				  arg1161_97 =
				     normalize_progn_143_tools_progn(value_81);
				  arg1157_95 =
				     PROCEDURE_ENTRY(e_12) (e_12, arg1161_97, e_12, BEOA);
			       }
			       arg1150_94 =
				  MAKE_PAIR(arg1157_95, BNIL);
			    }
			    arg1144_92 =
			       MAKE_PAIR(arg1145_93, arg1150_94);
			 }
			 new_90 =
			    MAKE_PAIR(arg1142_91, arg1144_92);
		      }
		      return
			 replace__160_tools_misc(x_11, new_90);
		   }
		}
	      else
		{	/* Expand/exit.scm 36 */
		 tag_121_151_83:
		   FAILURE(BFALSE, string1377_expand_exit, x_11);
		}
	   }
	 else
	   {	/* Expand/exit.scm 36 */
	      goto tag_121_151_83;
	   }
      }
   }
}



/* _expand-jump-exit1373 */
obj_t 
_expand_jump_exit1373_220_expand_exit(obj_t env_527, obj_t x_528, obj_t e_529)
{
   AN_OBJECT;
   {	/* Expand/exit.scm 35 */
      return
	 expand_jump_exit_91_expand_exit(x_528, e_529);
   }
}



/* expand-set-exit */
obj_t 
expand_set_exit_79_expand_exit(obj_t x_13, obj_t e_14)
{
   AN_OBJECT;
   {	/* Expand/exit.scm 46 */
      {
	 obj_t exit_98;
	 obj_t body_99;
	 if (
	    PAIRP(x_13))
	   {	/* Expand/exit.scm 47 */
	      obj_t cdr_143_124_104;
	      cdr_143_124_104 =
		 CDR(x_13);
	      if (
		 PAIRP(cdr_143_124_104))
		{	/* Expand/exit.scm 47 */
		   obj_t car_146_142_106;
		   car_146_142_106 =
		      CAR(cdr_143_124_104);
		   if (
		      PAIRP(car_146_142_106))
		     {	/* Expand/exit.scm 47 */
			bool_t test_598;
			{	/* ./Ieee/equiv.scm 5508 */
			   obj_t aux_599;
			   aux_599 =
			      CDR(car_146_142_106);
			   test_598 =
			      (aux_599 == BNIL);
			}
			if (test_598)
			  {	/* Expand/exit.scm 47 */
			     exit_98 =
				CAR(car_146_142_106);
			     body_99 =
				CDR(cdr_143_124_104);
			     {	/* Expand/exit.scm 49 */
				obj_t new_113;
				{	/* Expand/exit.scm 49 */
				   obj_t arg1187_114;
				   obj_t arg1188_115;
				   arg1187_114 =
				      CNST_TABLE_REF(((long) 1));
				   {	/* Expand/exit.scm 49 */
				      obj_t arg1189_116;
				      obj_t arg1190_117;
				      arg1189_116 =
					 MAKE_PAIR(exit_98, BNIL);
				      {		/* Expand/exit.scm 49 */
					 obj_t arg1192_118;
					 {	/* Expand/exit.scm 49 */
					    obj_t arg1194_120;
					    arg1194_120 =
					       normalize_progn_143_tools_progn(body_99);
					    arg1192_118 =
					       PROCEDURE_ENTRY(e_14) (e_14, arg1194_120, e_14, BEOA);
					 }
					 arg1190_117 =
					    MAKE_PAIR(arg1192_118, BNIL);
				      }
				      arg1188_115 =
					 MAKE_PAIR(arg1189_116, arg1190_117);
				   }
				   new_113 =
				      MAKE_PAIR(arg1187_114, arg1188_115);
				}
				return
				   replace__160_tools_misc(x_13, new_113);
			     }
			  }
			else
			  {	/* Expand/exit.scm 47 */
			   tag_136_187_101:
			     FAILURE(BFALSE, string1378_expand_exit, x_13);
			  }
		     }
		   else
		     {	/* Expand/exit.scm 47 */
			goto tag_136_187_101;
		     }
		}
	      else
		{	/* Expand/exit.scm 47 */
		   goto tag_136_187_101;
		}
	   }
	 else
	   {	/* Expand/exit.scm 47 */
	      goto tag_136_187_101;
	   }
      }
   }
}



/* _expand-set-exit1374 */
obj_t 
_expand_set_exit1374_39_expand_exit(obj_t env_530, obj_t x_531, obj_t e_532)
{
   AN_OBJECT;
   {	/* Expand/exit.scm 46 */
      return
	 expand_set_exit_79_expand_exit(x_531, e_532);
   }
}



/* expand-bind-exit */
obj_t 
expand_bind_exit_231_expand_exit(obj_t x_15, obj_t e_16)
{
   AN_OBJECT;
   {	/* Expand/exit.scm 57 */
      {
	 obj_t exit_121;
	 obj_t body_122;
	 if (
	    PAIRP(x_15))
	   {	/* Expand/exit.scm 58 */
	      obj_t cdr_161_14_127;
	      cdr_161_14_127 =
		 CDR(x_15);
	      if (
		 PAIRP(cdr_161_14_127))
		{	/* Expand/exit.scm 58 */
		   obj_t car_164_223_129;
		   car_164_223_129 =
		      CAR(cdr_161_14_127);
		   if (
		      PAIRP(car_164_223_129))
		     {	/* Expand/exit.scm 58 */
			bool_t test_623;
			{	/* ./Ieee/equiv.scm 5508 */
			   obj_t aux_624;
			   aux_624 =
			      CDR(car_164_223_129);
			   test_623 =
			      (aux_624 == BNIL);
			}
			if (test_623)
			  {	/* Expand/exit.scm 58 */
			     exit_121 =
				CAR(car_164_223_129);
			     body_122 =
				CDR(cdr_161_14_127);
			     {	/* Expand/exit.scm 60 */
				obj_t an_exit_46_136;
				obj_t an_exitd_79_137;
				obj_t val_138;
				obj_t res_139;
				{	/* Expand/exit.scm 60 */
				   obj_t arg1277_197;
				   arg1277_197 =
				      PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				      CNST_TABLE_REF(((long) 2)), BEOA);
				   an_exit_46_136 =
				      mark_symbol_non_user__17_ast_ident(arg1277_197);
				}
				{	/* Expand/exit.scm 61 */
				   obj_t arg1278_198;
				   arg1278_198 =
				      PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				      CNST_TABLE_REF(((long) 3)), BEOA);
				   an_exitd_79_137 =
				      mark_symbol_non_user__17_ast_ident(arg1278_198);
				}
				{	/* Expand/exit.scm 62 */
				   obj_t arg1280_199;
				   arg1280_199 =
				      PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				      CNST_TABLE_REF(((long) 4)), BEOA);
				   val_138 =
				      mark_symbol_non_user__17_ast_ident(arg1280_199);
				}
				{	/* Expand/exit.scm 63 */
				   obj_t arg1281_200;
				   arg1281_200 =
				      PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				      CNST_TABLE_REF(((long) 5)), BEOA);
				   res_139 =
				      mark_symbol_non_user__17_ast_ident(arg1281_200);
				}
				{	/* Expand/exit.scm 64 */
				   obj_t new_140;
				   {	/* Expand/exit.scm 64 */
				      obj_t arg1207_141;
				      {		/* Expand/exit.scm 64 */
					 obj_t arg1209_142;
					 obj_t arg1212_143;
					 arg1209_142 =
					    CNST_TABLE_REF(((long) 1));
					 {	/* Expand/exit.scm 64 */
					    obj_t arg1213_144;
					    obj_t arg1214_145;
					    arg1213_144 =
					       MAKE_PAIR(an_exit_46_136, BNIL);
					    {	/* Expand/exit.scm 65 */
					       obj_t arg1215_146;
					       {	/* Expand/exit.scm 65 */
						  obj_t arg1217_148;
						  obj_t arg1220_149;
						  arg1217_148 =
						     CNST_TABLE_REF(((long) 6));
						  {	/* Expand/exit.scm 65 */
						     obj_t arg1223_151;
						     {	/* Expand/exit.scm 66 */
							obj_t arg1224_152;
							obj_t arg1226_153;
							{	/* Expand/exit.scm 66 */
							   obj_t arg1227_154;
							   obj_t arg1228_155;
							   arg1227_154 =
							      CNST_TABLE_REF(((long) 7));
							   {	/* Expand/exit.scm 66 */
							      obj_t arg1229_156;
							      arg1229_156 =
								 MAKE_PAIR(BTRUE, BNIL);
							      arg1228_155 =
								 MAKE_PAIR(an_exit_46_136, arg1229_156);
							   }
							   arg1224_152 =
							      MAKE_PAIR(arg1227_154, arg1228_155);
							}
							{	/* Expand/exit.scm 67 */
							   obj_t arg1230_157;
							   {	/* Expand/exit.scm 67 */
							      obj_t arg1232_159;
							      obj_t arg1233_160;
							      arg1232_159 =
								 CNST_TABLE_REF(((long) 6));
							      {		/* Expand/exit.scm 67 */
								 obj_t arg1234_161;
								 obj_t arg1235_162;
								 {	/* Expand/exit.scm 67 */
								    obj_t arg1236_163;
								    {	/* Expand/exit.scm 67 */
								       obj_t arg1238_165;
								       {	/* ./Ieee/pair-list.scm 5689 */
									  obj_t aux_651;
									  aux_651 =
									     CNST_TABLE_REF(((long) 8));
									  arg1238_165 =
									     MAKE_PAIR(aux_651, BNIL);
								       }
								       arg1236_163 =
									  MAKE_PAIR(an_exitd_79_137, arg1238_165);
								    }
								    arg1234_161 =
								       MAKE_PAIR(arg1236_163, BNIL);
								 }
								 {	/* Expand/exit.scm 68 */
								    obj_t arg1240_166;
								    {	/* Expand/exit.scm 68 */
								       obj_t arg1243_168;
								       obj_t arg1245_169;
								       arg1243_168 =
									  CNST_TABLE_REF(((long) 9));
								       {	/* Expand/exit.scm 68 */
									  obj_t arg1246_170;
									  obj_t arg1248_171;
									  {	/* Expand/exit.scm 68 */
									     obj_t arg1249_172;
									     {	/* Expand/exit.scm 68 */
										obj_t arg1251_174;
										{	/* Expand/exit.scm 68 */
										   obj_t arg1252_175;
										   obj_t arg1253_176;
										   arg1252_175 =
										      MAKE_PAIR(val_138, BNIL);
										   {	/* Expand/exit.scm 69 */
										      obj_t arg1254_177;
										      {		/* Expand/exit.scm 69 */
											 obj_t arg1256_179;
											 obj_t arg1257_180;
											 arg1256_179 =
											    CNST_TABLE_REF(((long) 10));
											 {	/* Expand/exit.scm 69 */
											    obj_t arg1258_181;
											    arg1258_181 =
											       MAKE_PAIR(val_138, BNIL);
											    arg1257_180 =
											       MAKE_PAIR(an_exitd_79_137, arg1258_181);
											 }
											 arg1254_177 =
											    MAKE_PAIR(arg1256_179, arg1257_180);
										      }
										      arg1253_176 =
											 MAKE_PAIR(arg1254_177, BNIL);
										   }
										   arg1251_174 =
										      MAKE_PAIR(arg1252_175, arg1253_176);
										}
										arg1249_172 =
										   MAKE_PAIR(exit_121, arg1251_174);
									     }
									     arg1246_170 =
										MAKE_PAIR(arg1249_172, BNIL);
									  }
									  {	/* Expand/exit.scm 72 */
									     obj_t arg1259_182;
									     {	/* Expand/exit.scm 72 */
										obj_t arg1261_184;
										obj_t arg1263_185;
										arg1261_184 =
										   CNST_TABLE_REF(((long) 6));
										{	/* Expand/exit.scm 72 */
										   obj_t arg1264_186;
										   obj_t arg1265_187;
										   {	/* Expand/exit.scm 72 */
										      obj_t arg1267_188;
										      {		/* Expand/exit.scm 72 */
											 obj_t arg1269_190;
											 {	/* Expand/exit.scm 72 */
											    obj_t arg1270_191;
											    {	/* ./Ieee/pair-list.scm 5689 */
											       obj_t aux_669;
											       obj_t aux_667;
											       aux_669 =
												  append_2_18___r4_pairs_and_lists_6_3(body_122, BNIL);
											       aux_667 =
												  CNST_TABLE_REF(((long) 11));
											       arg1270_191 =
												  MAKE_PAIR(aux_667, aux_669);
											    }
											    arg1269_190 =
											       MAKE_PAIR(arg1270_191, BNIL);
											 }
											 arg1267_188 =
											    MAKE_PAIR(res_139, arg1269_190);
										      }
										      arg1264_186 =
											 MAKE_PAIR(arg1267_188, BNIL);
										   }
										   {	/* Expand/exit.scm 73 */
										      obj_t arg1274_195;
										      obj_t arg1276_196;
										      {		/* ./Ieee/pair-list.scm 5689 */
											 obj_t aux_675;
											 aux_675 =
											    CNST_TABLE_REF(((long) 12));
											 arg1274_195 =
											    MAKE_PAIR(aux_675, BNIL);
										      }
										      arg1276_196 =
											 MAKE_PAIR(res_139, BNIL);
										      arg1265_187 =
											 MAKE_PAIR(arg1274_195, arg1276_196);
										   }
										   arg1263_185 =
										      MAKE_PAIR(arg1264_186, arg1265_187);
										}
										arg1259_182 =
										   MAKE_PAIR(arg1261_184, arg1263_185);
									     }
									     arg1248_171 =
										MAKE_PAIR(arg1259_182, BNIL);
									  }
									  arg1245_169 =
									     MAKE_PAIR(arg1246_170, arg1248_171);
								       }
								       arg1240_166 =
									  MAKE_PAIR(arg1243_168, arg1245_169);
								    }
								    arg1235_162 =
								       MAKE_PAIR(arg1240_166, BNIL);
								 }
								 arg1233_160 =
								    MAKE_PAIR(arg1234_161, arg1235_162);
							      }
							      arg1230_157 =
								 MAKE_PAIR(arg1232_159, arg1233_160);
							   }
							   arg1226_153 =
							      MAKE_PAIR(arg1230_157, BNIL);
							}
							arg1223_151 =
							   MAKE_PAIR(arg1224_152, arg1226_153);
						     }
						     arg1220_149 =
							MAKE_PAIR(BNIL, arg1223_151);
						  }
						  arg1215_146 =
						     MAKE_PAIR(arg1217_148, arg1220_149);
					       }
					       arg1214_145 =
						  MAKE_PAIR(arg1215_146, BNIL);
					    }
					    arg1212_143 =
					       MAKE_PAIR(arg1213_144, arg1214_145);
					 }
					 arg1207_141 =
					    MAKE_PAIR(arg1209_142, arg1212_143);
				      }
				      new_140 =
					 PROCEDURE_ENTRY(e_16) (e_16, arg1207_141, e_16, BEOA);
				   }
				   return
				      replace__160_tools_misc(x_15, new_140);
				}
			     }
			  }
			else
			  {	/* Expand/exit.scm 58 */
			   tag_154_0_124:
			     FAILURE(BFALSE, string1379_expand_exit, x_15);
			  }
		     }
		   else
		     {	/* Expand/exit.scm 58 */
			goto tag_154_0_124;
		     }
		}
	      else
		{	/* Expand/exit.scm 58 */
		   goto tag_154_0_124;
		}
	   }
	 else
	   {	/* Expand/exit.scm 58 */
	      goto tag_154_0_124;
	   }
      }
   }
}



/* _expand-bind-exit1375 */
obj_t 
_expand_bind_exit1375_210_expand_exit(obj_t env_533, obj_t x_534, obj_t e_535)
{
   AN_OBJECT;
   {	/* Expand/exit.scm 57 */
      return
	 expand_bind_exit_231_expand_exit(x_534, e_535);
   }
}



/* expand-unwind-protect */
obj_t 
expand_unwind_protect_208_expand_exit(obj_t x_17, obj_t e_18)
{
   AN_OBJECT;
   {	/* Expand/exit.scm 83 */
      {
	 obj_t exp_201;
	 obj_t cleanup_202;
	 if (
	    PAIRP(x_17))
	   {	/* Expand/exit.scm 84 */
	      obj_t cdr_179_79_207;
	      cdr_179_79_207 =
		 CDR(x_17);
	      if (
		 PAIRP(cdr_179_79_207))
		{	/* Expand/exit.scm 84 */
		   obj_t cdr_183_92_209;
		   cdr_183_92_209 =
		      CDR(cdr_179_79_207);
		   if (
		      PAIRP(cdr_183_92_209))
		     {	/* Expand/exit.scm 84 */
			exp_201 =
			   CAR(cdr_179_79_207);
			cleanup_202 = cdr_183_92_209;
			{	/* Expand/exit.scm 86 */
			   obj_t val_212;
			   {	/* Expand/exit.scm 86 */
			      obj_t arg1367_281;
			      arg1367_281 =
				 PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				 CNST_TABLE_REF(((long) 4)), BEOA);
			      val_212 =
				 mark_symbol_non_user__17_ast_ident(arg1367_281);
			   }
			   {	/* Expand/exit.scm 86 */
			      obj_t an_exit_46_213;
			      {		/* Expand/exit.scm 87 */
				 obj_t arg1366_280;
				 arg1366_280 =
				    PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				    CNST_TABLE_REF(((long) 2)), BEOA);
				 an_exit_46_213 =
				    mark_symbol_non_user__17_ast_ident(arg1366_280);
			      }
			      {		/* Expand/exit.scm 87 */
				 obj_t valbis_214;
				 {	/* Expand/exit.scm 88 */
				    obj_t arg1365_279;
				    arg1365_279 =
				       PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				       CNST_TABLE_REF(((long) 4)), BEOA);
				    valbis_214 =
				       mark_symbol_non_user__17_ast_ident(arg1365_279);
				 }
				 {	/* Expand/exit.scm 88 */
				    obj_t eexp_215;
				    eexp_215 =
				       PROCEDURE_ENTRY(e_18) (e_18, exp_201, e_18, BEOA);
				    {	/* Expand/exit.scm 89 */
				       obj_t aux_216;
				       {	/* Expand/exit.scm 90 */
					  obj_t arg1350_270;
					  obj_t arg1354_271;
					  arg1350_270 =
					     CNST_TABLE_REF(((long) 6));
					  {	/* Expand/exit.scm 90 */
					     obj_t arg1355_272;
					     obj_t arg1356_273;
					     {	/* Expand/exit.scm 90 */
						obj_t arg1357_274;
						{	/* Expand/exit.scm 90 */
						   obj_t arg1359_276;
						   arg1359_276 =
						      MAKE_PAIR(eexp_215, BNIL);
						   arg1357_274 =
						      MAKE_PAIR(valbis_214, arg1359_276);
						}
						arg1355_272 =
						   MAKE_PAIR(arg1357_274, BNIL);
					     }
					     {	/* Expand/exit.scm 91 */
						obj_t arg1361_277;
						obj_t arg1363_278;
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_728;
						   aux_728 =
						      CNST_TABLE_REF(((long) 12));
						   arg1361_277 =
						      MAKE_PAIR(aux_728, BNIL);
						}
						arg1363_278 =
						   MAKE_PAIR(valbis_214, BNIL);
						arg1356_273 =
						   MAKE_PAIR(arg1361_277, arg1363_278);
					     }
					     arg1354_271 =
						MAKE_PAIR(arg1355_272, arg1356_273);
					  }
					  aux_216 =
					     MAKE_PAIR(arg1350_270, arg1354_271);
				       }
				       {	/* Expand/exit.scm 90 */
					  obj_t eaux_217;
					  {	/* Expand/exit.scm 93 */
					     bool_t test1344_266;
					     test1344_266 =
						EXTENDED_PAIRP(eexp_215);
					     if (test1344_266)
					       {	/* Expand/exit.scm 94 */
						  obj_t arg1346_267;
						  obj_t arg1347_268;
						  obj_t arg1348_269;
						  arg1346_267 =
						     CAR(aux_216);
						  arg1347_268 =
						     CDR(aux_216);
						  {	/* ./Ieee/pair-list.scm 5713 */
						     bool_t test1136_454;
						     test1136_454 =
							EXTENDED_PAIRP(eexp_215);
						     if (test1136_454)
						       {	/* ./Ieee/pair-list.scm 5713 */
							  arg1348_269 =
							     CER(eexp_215);
						       }
						     else
						       {	/* ./Ieee/pair-list.scm 5713 */
							  FAILURE(string1380_expand_exit, string1381_expand_exit, eexp_215);
						       }
						  }
						  eaux_217 =
						     MAKE_EXTENDED_PAIR(arg1346_267, arg1347_268, arg1348_269);
					       }
					     else
					       {	/* Expand/exit.scm 93 */
						  eaux_217 = aux_216;
					       }
					  }
					  {	/* Expand/exit.scm 93 */

					     {	/* Expand/exit.scm 96 */
						obj_t new_218;
						{	/* Expand/exit.scm 96 */
						   obj_t arg1287_219;
						   obj_t arg1289_220;
						   arg1287_219 =
						      CNST_TABLE_REF(((long) 6));
						   {	/* Expand/exit.scm 96 */
						      obj_t arg1290_221;
						      obj_t arg1291_222;
						      {		/* Expand/exit.scm 96 */
							 obj_t arg1292_223;
							 {	/* Expand/exit.scm 96 */
							    obj_t arg1294_225;
							    {	/* Expand/exit.scm 96 */
							       obj_t arg1295_226;
							       {	/* Expand/exit.scm 96 */
								  obj_t arg1297_228;
								  obj_t arg1298_229;
								  arg1297_228 =
								     CNST_TABLE_REF(((long) 1));
								  {	/* Expand/exit.scm 96 */
								     obj_t arg1299_230;
								     obj_t arg1300_231;
								     arg1299_230 =
									MAKE_PAIR(an_exit_46_213, BNIL);
								     {	/* Expand/exit.scm 97 */
									obj_t arg1301_232;
									{	/* Expand/exit.scm 97 */
									   obj_t arg1303_234;
									   obj_t arg1304_235;
									   arg1303_234 =
									      CNST_TABLE_REF(((long) 6));
									   {	/* Expand/exit.scm 97 */
									      obj_t arg1307_237;
									      {		/* Expand/exit.scm 98 */
										 obj_t arg1308_238;
										 obj_t arg1309_239;
										 {	/* Expand/exit.scm 98 */
										    obj_t arg1313_240;
										    obj_t arg1314_241;
										    arg1313_240 =
										       CNST_TABLE_REF(((long) 7));
										    {	/* Expand/exit.scm 98 */
										       obj_t arg1315_242;
										       arg1315_242 =
											  MAKE_PAIR(BFALSE, BNIL);
										       arg1314_241 =
											  MAKE_PAIR(an_exit_46_213, arg1315_242);
										    }
										    arg1308_238 =
										       MAKE_PAIR(arg1313_240, arg1314_241);
										 }
										 arg1309_239 =
										    MAKE_PAIR(aux_216, BNIL);
										 arg1307_237 =
										    MAKE_PAIR(arg1308_238, arg1309_239);
									      }
									      arg1304_235 =
										 MAKE_PAIR(BNIL, arg1307_237);
									   }
									   arg1301_232 =
									      MAKE_PAIR(arg1303_234, arg1304_235);
									}
									arg1300_231 =
									   MAKE_PAIR(arg1301_232, BNIL);
								     }
								     arg1298_229 =
									MAKE_PAIR(arg1299_230, arg1300_231);
								  }
								  arg1295_226 =
								     MAKE_PAIR(arg1297_228, arg1298_229);
							       }
							       arg1294_225 =
								  MAKE_PAIR(arg1295_226, BNIL);
							    }
							    arg1292_223 =
							       MAKE_PAIR(val_212, arg1294_225);
							 }
							 arg1290_221 =
							    MAKE_PAIR(arg1292_223, BNIL);
						      }
						      {		/* Expand/exit.scm 100 */
							 obj_t arg1317_243;
							 obj_t arg1318_244;
							 {	/* Expand/exit.scm 100 */
							    obj_t arg1319_245;
							    arg1319_245 =
							       normalize_progn_143_tools_progn(cleanup_202);
							    arg1317_243 =
							       PROCEDURE_ENTRY(e_18) (e_18, arg1319_245, e_18, BEOA);
							 }
							 {	/* Expand/exit.scm 101 */
							    obj_t arg1320_246;
							    {	/* Expand/exit.scm 101 */
							       obj_t arg1323_248;
							       obj_t arg1325_249;
							       arg1323_248 =
								  CNST_TABLE_REF(((long) 13));
							       {	/* Expand/exit.scm 101 */
								  obj_t arg1326_250;
								  obj_t arg1327_251;
								  {	/* Expand/exit.scm 101 */
								     obj_t arg1329_252;
								     obj_t arg1330_253;
								     arg1329_252 =
									CNST_TABLE_REF(((long) 14));
								     arg1330_253 =
									MAKE_PAIR(val_212, BNIL);
								     arg1326_250 =
									MAKE_PAIR(arg1329_252, arg1330_253);
								  }
								  {	/* Expand/exit.scm 102 */
								     obj_t arg1331_254;
								     obj_t arg1332_255;
								     {	/* Expand/exit.scm 102 */
									obj_t arg1333_256;
									obj_t arg1334_257;
									arg1333_256 =
									   CNST_TABLE_REF(((long) 10));
									{	/* Expand/exit.scm 102 */
									   obj_t arg1335_258;
									   obj_t arg1336_259;
									   {	/* Expand/exit.scm 102 */
									      obj_t arg1337_260;
									      obj_t arg1338_261;
									      arg1337_260 =
										 CNST_TABLE_REF(((long) 15));
									      arg1338_261 =
										 MAKE_PAIR(val_212, BNIL);
									      arg1335_258 =
										 MAKE_PAIR(arg1337_260, arg1338_261);
									   }
									   {	/* Expand/exit.scm 102 */
									      obj_t arg1339_262;
									      {		/* Expand/exit.scm 102 */
										 obj_t arg1342_264;
										 obj_t arg1343_265;
										 arg1342_264 =
										    CNST_TABLE_REF(((long) 16));
										 arg1343_265 =
										    MAKE_PAIR(val_212, BNIL);
										 arg1339_262 =
										    MAKE_PAIR(arg1342_264, arg1343_265);
									      }
									      arg1336_259 =
										 MAKE_PAIR(arg1339_262, BNIL);
									   }
									   arg1334_257 =
									      MAKE_PAIR(arg1335_258, arg1336_259);
									}
									arg1331_254 =
									   MAKE_PAIR(arg1333_256, arg1334_257);
								     }
								     arg1332_255 =
									MAKE_PAIR(val_212, BNIL);
								     arg1327_251 =
									MAKE_PAIR(arg1331_254, arg1332_255);
								  }
								  arg1325_249 =
								     MAKE_PAIR(arg1326_250, arg1327_251);
							       }
							       arg1320_246 =
								  MAKE_PAIR(arg1323_248, arg1325_249);
							    }
							    arg1318_244 =
							       MAKE_PAIR(arg1320_246, BNIL);
							 }
							 arg1291_222 =
							    MAKE_PAIR(arg1317_243, arg1318_244);
						      }
						      arg1289_220 =
							 MAKE_PAIR(arg1290_221, arg1291_222);
						   }
						   new_218 =
						      MAKE_PAIR(arg1287_219, arg1289_220);
						}
						return
						   replace__160_tools_misc(x_17, new_218);
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		   else
		     {	/* Expand/exit.scm 84 */
		      tag_172_8_204:
			FAILURE(BFALSE, string1382_expand_exit, x_17);
		     }
		}
	      else
		{	/* Expand/exit.scm 84 */
		   goto tag_172_8_204;
		}
	   }
	 else
	   {	/* Expand/exit.scm 84 */
	      goto tag_172_8_204;
	   }
      }
   }
}



/* _expand-unwind-protect1376 */
obj_t 
_expand_unwind_protect1376_218_expand_exit(obj_t env_536, obj_t x_537, obj_t e_538)
{
   AN_OBJECT;
   {	/* Expand/exit.scm 83 */
      return
	 expand_unwind_protect_208_expand_exit(x_537, e_538);
   }
}



/* method-init */
obj_t 
method_init_76_expand_exit()
{
   AN_OBJECT;
   {	/* Expand/exit.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_expand_exit()
{
   AN_OBJECT;
   {	/* Expand/exit.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "EXPAND_EXIT");
      module_initialization_70_tools_progn(((long) 0), "EXPAND_EXIT");
      module_initialization_70_tools_args(((long) 0), "EXPAND_EXIT");
      module_initialization_70_tools_speek(((long) 0), "EXPAND_EXIT");
      module_initialization_70_tools_misc(((long) 0), "EXPAND_EXIT");
      module_initialization_70_expand_expander(((long) 0), "EXPAND_EXIT");
      module_initialization_70_expand_eps(((long) 0), "EXPAND_EXIT");
      module_initialization_70_expand_lambda(((long) 0), "EXPAND_EXIT");
      module_initialization_70_engine_param(((long) 0), "EXPAND_EXIT");
      module_initialization_70_type_type(((long) 0), "EXPAND_EXIT");
      return
	 module_initialization_70_ast_ident(((long) 0), "EXPAND_EXIT");
   }
}
