/*===========================================================================*/
/*   (Tvector/tvector.scm)                                                   */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct tvec
  {
     struct type *item_type_130;
  }
    *tvec_bglt;


static obj_t method_init_76_tvector_tvector();
static obj_t _tvec_alias_set_1269_84_tvector_tvector(obj_t, obj_t, obj_t);
extern bool_t tvec_magic__235_tvector_tvector(type_bglt);
extern obj_t tvec___set__72_tvector_tvector(type_bglt, obj_t);
static obj_t _tvec__174_tvector_tvector(obj_t, obj_t);
static obj_t _widening_tvec1250_106_tvector_tvector(obj_t, obj_t);
static obj_t _tvec_class_set_1257_72_tvector_tvector(obj_t, obj_t, obj_t);
extern obj_t type_type_type;
extern obj_t tvec_init__set__63_tvector_tvector(type_bglt, bool_t);
static obj_t _tvec_tvector1274_157_tvector_tvector(obj_t, obj_t);
extern obj_t tvec_location_158_tvector_tvector(type_bglt);
static obj_t _tvec_magic__set_1265_168_tvector_tvector(obj_t, obj_t, obj_t);
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
obj_t tvec_tvector_tvector = BUNSPEC;
static obj_t _tvec_parents1262_107_tvector_tvector(obj_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t _tvec_location_set__99_tvector_tvector(obj_t, obj_t, obj_t);
extern obj_t tvec_name_set__198_tvector_tvector(type_bglt, obj_t);
extern obj_t tvec_coerce_to_set__84_tvector_tvector(type_bglt, obj_t);
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern tvec_bglt declare_tvector_type__101_tvector_tvector(obj_t, obj_t, obj_t);
static obj_t _tvec_id1252_215_tvector_tvector(obj_t, obj_t);
static obj_t _tvec___set_1267_180_tvector_tvector(obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_tvector_tvector(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_location(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
static obj_t _tvec_alias1270_176_tvector_tvector(obj_t, obj_t);
static obj_t _tvec_parents_set_1261_184_tvector_tvector(obj_t, obj_t, obj_t);
static obj_t _emit_tvector_types1249_55_tvector_tvector(obj_t, obj_t);
extern obj_t tvec_tvector_69_tvector_tvector(type_bglt);
static obj_t _tvec_init_1264_244_tvector_tvector(obj_t, obj_t);
extern obj_t tvec_size_218_tvector_tvector(type_bglt);
extern long class_num_218___object(obj_t);
extern obj_t tvec_pointed_to_by_set__49_tvector_tvector(type_bglt, obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
static obj_t _allocate_tvec_199_tvector_tvector(obj_t);
extern type_bglt find_type_26_type_env(obj_t);
extern obj_t tvec_name_219_tvector_tvector(type_bglt);
extern obj_t tvec_coerce_to_9_tvector_tvector(type_bglt);
static obj_t imported_modules_init_94_tvector_tvector();
static obj_t struct_object__object_tvec1078_3_tvector_tvector(obj_t, obj_t, obj_t);
static obj_t make_coercion_clause_209_tvector_tvector(obj_t);
static obj_t _make_tvec1251_174_tvector_tvector(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _tvec_item_type1275_112_tvector_tvector(obj_t, obj_t);
extern obj_t tvec_size_set__225_tvector_tvector(type_bglt, obj_t);
extern obj_t tvec_alias_set__17_tvector_tvector(type_bglt, obj_t);
extern obj_t produce_module_clause__172_module_module(obj_t);
static obj_t _tvec_magic_1266_43_tvector_tvector(obj_t, obj_t);
extern obj_t tvec_tvector_set__39_tvector_tvector(type_bglt, obj_t);
static obj_t _tvec_pointed_to_by1272_135_tvector_tvector(obj_t, obj_t);
static obj_t library_modules_init_112_tvector_tvector();
extern obj_t make_struct(obj_t, long, obj_t);
extern obj_t tvec___12_tvector_tvector(type_bglt);
extern type_bglt use_type__231_type_env(obj_t, obj_t);
static obj_t toplevel_init_63_tvector_tvector();
extern bool_t tvec_init__77_tvector_tvector(type_bglt);
static obj_t _tvec_size_set_1255_122_tvector_tvector(obj_t, obj_t, obj_t);
extern obj_t create_vector(long);
extern obj_t open_input_string(obj_t);
extern bool_t tvec__226_tvector_tvector(obj_t);
extern obj_t tvec_pointed_to_by_20_tvector_tvector(type_bglt);
extern obj_t tvec_class_set__119_tvector_tvector(type_bglt, obj_t);
extern obj_t tvec_location_set__219_tvector_tvector(type_bglt, obj_t);
static obj_t _tvec_location_125_tvector_tvector(obj_t, obj_t);
extern tvec_bglt widening_tvec_132_tvector_tvector(type_bglt);
extern obj_t tvec_class_217_tvector_tvector(type_bglt);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
extern obj_t emit_tvector_types_117_tvector_tvector(obj_t);
static obj_t object_init_111_tvector_tvector();
extern obj_t tvec_alias_117_tvector_tvector(type_bglt);
static obj_t _tvec_name_set_1253_85_tvector_tvector(obj_t, obj_t, obj_t);
static obj_t _tvec_coerce_to_set_1259_228_tvector_tvector(obj_t, obj_t, obj_t);
static obj_t _tvec_init__set_1263_196_tvector_tvector(obj_t, obj_t, obj_t);
static obj_t object__struct_tvec1076_16_tvector_tvector(obj_t, obj_t);
static obj_t _tvec_class1258_187_tvector_tvector(obj_t, obj_t);
static obj_t _tvec_tvector_set_1273_69_tvector_tvector(obj_t, obj_t, obj_t);
static obj_t _tvec_coerce_to1260_218_tvector_tvector(obj_t, obj_t);
static obj_t _tvec__1268_106_tvector_tvector(obj_t, obj_t);
static obj_t _tvec_name1254_90_tvector_tvector(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern type_bglt allocate_tvec_255_tvector_tvector();
extern tvec_bglt make_tvec_253_tvector_tvector(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, type_bglt);
static obj_t _tvec_pointed_to_by_set_1271_172_tvector_tvector(obj_t, obj_t, obj_t);
static obj_t _tvec_size1256_191_tvector_tvector(obj_t, obj_t);
extern obj_t find_location_120_tools_location(obj_t);
extern type_bglt tvec_item_type_215_tvector_tvector(tvec_bglt);
extern obj_t tvec_magic__set__41_tvector_tvector(type_bglt, bool_t);
extern obj_t tvec_parents_set__71_tvector_tvector(type_bglt, obj_t);
extern obj_t object__struct_50___object(object_bglt);
extern type_bglt declare_subtype__66_type_env(obj_t, obj_t, obj_t, obj_t);
static obj_t _declare_tvector_type_1247_220_tvector_tvector(obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_tvector_tvector = BUNSPEC;
static obj_t _tvector_type_list__188_tvector_tvector = BUNSPEC;
static obj_t cnst_init_137_tvector_tvector();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t tvec_id_66_tvector_tvector(type_bglt);
extern obj_t tvec_parents_196_tvector_tvector(type_bglt);
static obj_t __cnst[6];

DEFINE_EXPORT_PROCEDURE(tvec_location_set__env_11_tvector_tvector, _tvec_location_set__99_tvector_tvector1298, _tvec_location_set__99_tvector_tvector, 0L, 2);
DEFINE_EXPORT_PROCEDURE(emit_tvector_types_env_135_tvector_tvector, _emit_tvector_types1249_55_tvector_tvector1299, _emit_tvector_types1249_55_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_tvec_env_194_tvector_tvector, _allocate_tvec_199_tvector_tvector1300, _allocate_tvec_199_tvector_tvector, 0L, 0);
extern obj_t exp_env_94___r4_numbers_6_5;
DEFINE_EXPORT_PROCEDURE(make_tvec_env_31_tvector_tvector, _make_tvec1251_174_tvector_tvector1301, _make_tvec1251_174_tvector_tvector, 0L, 14);
DEFINE_EXPORT_PROCEDURE(tvec_item_type_env_167_tvector_tvector, _tvec_item_type1275_112_tvector_tvector1302, _tvec_item_type1275_112_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec_pointed_to_by_env_49_tvector_tvector, _tvec_pointed_to_by1272_135_tvector_tvector1303, _tvec_pointed_to_by1272_135_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec___set__env_13_tvector_tvector, _tvec___set_1267_180_tvector_tvector1304, _tvec___set_1267_180_tvector_tvector, 0L, 2);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(tvec_class_env_152_tvector_tvector, _tvec_class1258_187_tvector_tvector1305, _tvec_class1258_187_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec_location_env_48_tvector_tvector, _tvec_location_125_tvector_tvector1306, _tvec_location_125_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec_size_set__env_118_tvector_tvector, _tvec_size_set_1255_122_tvector_tvector1307, _tvec_size_set_1255_122_tvector_tvector, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tvec_init__set__env_111_tvector_tvector, _tvec_init__set_1263_196_tvector_tvector1308, _tvec_init__set_1263_196_tvector_tvector, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1292_tvector_tvector, struct_object__object_tvec1078_3_tvector_tvector1309, struct_object__object_tvec1078_3_tvector_tvector, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1291_tvector_tvector, object__struct_tvec1076_16_tvector_tvector1310, object__struct_tvec1076_16_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec__env_222_tvector_tvector, _tvec__174_tvector_tvector1311, _tvec__174_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_tvec_env_104_tvector_tvector, _widening_tvec1250_106_tvector_tvector1312, _widening_tvec1250_106_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec_tvector_set__env_230_tvector_tvector, _tvec_tvector_set_1273_69_tvector_tvector1313, _tvec_tvector_set_1273_69_tvector_tvector, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tvec_tvector_env_84_tvector_tvector, _tvec_tvector1274_157_tvector_tvector1314, _tvec_tvector1274_157_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec_name_set__env_207_tvector_tvector, _tvec_name_set_1253_85_tvector_tvector1315, _tvec_name_set_1253_85_tvector_tvector, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tvec_coerce_to_set__env_72_tvector_tvector, _tvec_coerce_to_set_1259_228_tvector_tvector1316, _tvec_coerce_to_set_1259_228_tvector_tvector, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tvec_alias_set__env_195_tvector_tvector, _tvec_alias_set_1269_84_tvector_tvector1317, _tvec_alias_set_1269_84_tvector_tvector, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tvec_magic__env_201_tvector_tvector, _tvec_magic_1266_43_tvector_tvector1318, _tvec_magic_1266_43_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec_id_env_86_tvector_tvector, _tvec_id1252_215_tvector_tvector1319, _tvec_id1252_215_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec_parents_env_105_tvector_tvector, _tvec_parents1262_107_tvector_tvector1320, _tvec_parents1262_107_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec_pointed_to_by_set__env_110_tvector_tvector, _tvec_pointed_to_by_set_1271_172_tvector_tvector1321, _tvec_pointed_to_by_set_1271_172_tvector_tvector, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tvec_name_env_11_tvector_tvector, _tvec_name1254_90_tvector_tvector1322, _tvec_name1254_90_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec_coerce_to_env_107_tvector_tvector, _tvec_coerce_to1260_218_tvector_tvector1323, _tvec_coerce_to1260_218_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec_class_set__env_51_tvector_tvector, _tvec_class_set_1257_72_tvector_tvector1324, _tvec_class_set_1257_72_tvector_tvector, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tvec_size_env_12_tvector_tvector, _tvec_size1256_191_tvector_tvector1325, _tvec_size1256_191_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(declare_tvector_type__env_25_tvector_tvector, _declare_tvector_type_1247_220_tvector_tvector1326, _declare_tvector_type_1247_220_tvector_tvector, 0L, 3);
DEFINE_EXPORT_PROCEDURE(tvec_magic__set__env_66_tvector_tvector, _tvec_magic__set_1265_168_tvector_tvector1327, _tvec_magic__set_1265_168_tvector_tvector, 0L, 2);
DEFINE_EXPORT_PROCEDURE(tvec_alias_env_135_tvector_tvector, _tvec_alias1270_176_tvector_tvector1328, _tvec_alias1270_176_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec___env_74_tvector_tvector, _tvec__1268_106_tvector_tvector1329, _tvec__1268_106_tvector_tvector, 0L, 1);
DEFINE_EXPORT_PROCEDURE(tvec_init__env_169_tvector_tvector, _tvec_init_1264_244_tvector_tvector1330, _tvec_init_1264_244_tvector_tvector, 0L, 1);
DEFINE_STRING(string1293_tvector_tvector, string1293_tvector_tvector1331, "TVEC TVECTOR COERCE TYPE BIGLOO OBJ ", 36);
DEFINE_STRING(string1289_tvector_tvector, string1289_tvector_tvector1332, "} * ", 4);
DEFINE_STRING(string1290_tvector_tvector, string1290_tvector_tvector1333, ";\n", 2);
DEFINE_STRING(string1288_tvector_tvector, string1288_tvector_tvector1334, " el0;", 5);
DEFINE_STRING(string1287_tvector_tvector, string1287_tvector_tvector1335, "   ", 3);
DEFINE_STRING(string1286_tvector_tvector, string1286_tvector_tvector1336, "   obj_t    descr;", 18);
DEFINE_STRING(string1285_tvector_tvector, string1285_tvector_tvector1337, "   long     length;", 19);
DEFINE_STRING(string1284_tvector_tvector, string1284_tvector_tvector1338, "   header_t header;", 19);
DEFINE_STRING(string1283_tvector_tvector, string1283_tvector_tvector1339, " {", 2);
DEFINE_STRING(string1282_tvector_tvector, string1282_tvector_tvector1340, "typedef ", 8);
DEFINE_STRING(string1281_tvector_tvector, string1281_tvector_tvector1341, "/* Tvector type definitions */", 30);
DEFINE_STRING(string1279_tvector_tvector, string1279_tvector_tvector1342, "declare-tvector-type!", 21);
DEFINE_STRING(string1280_tvector_tvector, string1280_tvector_tvector1343, "Unable to find `obj' type", 25);
DEFINE_EXPORT_PROCEDURE(tvec_parents_set__env_136_tvector_tvector, _tvec_parents_set_1261_184_tvector_tvector1344, _tvec_parents_set_1261_184_tvector_tvector, 0L, 2);
extern obj_t object__struct_env_210___object;



/* module-initialization */
obj_t 
module_initialization_70_tvector_tvector(long checksum_497, char *from_498)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_tvector_tvector))
	{
	   require_initialization_114_tvector_tvector =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_tvector_tvector();
	   cnst_init_137_tvector_tvector();
	   imported_modules_init_94_tvector_tvector();
	   object_init_111_tvector_tvector();
	   method_init_76_tvector_tvector();
	   toplevel_init_63_tvector_tvector();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_tvector_tvector()
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 14 */
      module_initialization_70___r4_numbers_6_5(((long) 0), "TVECTOR_TVECTOR");
      module_initialization_70___object(((long) 0), "TVECTOR_TVECTOR");
      module_initialization_70___r4_output_6_10_3(((long) 0), "TVECTOR_TVECTOR");
      module_initialization_70___reader(((long) 0), "TVECTOR_TVECTOR");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "TVECTOR_TVECTOR");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_tvector_tvector()
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 14 */
      {		/* Tvector/tvector.scm 14 */
	 obj_t cnst_port_138_490;
	 cnst_port_138_490 =
	    open_input_string(string1293_tvector_tvector);
	 {
	    long i_491;
	    i_491 = ((long) 5);
	  loop_492:
	    {	/* Tvector/tvector.scm 14 */
	       bool_t test1294_493;
	       test1294_493 =
		  (i_491 == ((long) -1));
	       if (test1294_493)
		 {	/* Tvector/tvector.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Tvector/tvector.scm 14 */
		    {	/* Tvector/tvector.scm 14 */
		       obj_t arg1295_494;
		       {	/* Tvector/tvector.scm 14 */
			  obj_t list1296_495;
			  list1296_495 =
			     MAKE_PAIR(cnst_port_138_490, BNIL);
			  arg1295_494 =
			     read___reader(list1296_495);
		       }
		       CNST_TABLE_SET(i_491, arg1295_494);
		    }
		    {	/* Tvector/tvector.scm 14 */
		       int aux_496;
		       {	/* Tvector/tvector.scm 14 */
			  long aux_519;
			  aux_519 =
			     (i_491 - ((long) 1));
			  aux_496 =
			     (int) (aux_519);
		       }
		       {
			  long i_522;
			  i_522 =
			     (long) (aux_496);
			  i_491 = i_522;
			  goto loop_492;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_tvector_tvector()
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 14 */
      return (
	 _tvector_type_list__188_tvector_tvector = BNIL, BUNSPEC);
   }
}



/* declare-tvector-type! */
tvec_bglt 
declare_tvector_type__101_tvector_tvector(obj_t tvect_id_86_1, obj_t item_id_36_2, obj_t src_3)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 37 */
      {		/* Tvector/tvector.scm 38 */
	 type_bglt obj_125;
	 obj_125 =
	    find_type_26_type_env(
	    CNST_TABLE_REF(((long) 0)));
	 {	/* Tvector/tvector.scm 39 */
	    bool_t test1079_126;
	    test1079_126 =
	       is_a__118___object(
	       (obj_t) (obj_125), type_type_type);
	    if (test1079_126)
	      {		/* Tvector/tvector.scm 41 */
		 type_bglt type_127;
		 type_bglt item_type_130_128;
		 {	/* Tvector/tvector.scm 42 */
		    obj_t arg1145_134;
		    obj_t arg1150_135;
		    obj_t arg1157_136;
		    arg1145_134 =
		       (((type_bglt) CREF(obj_125))->name);
		    {	/* Tvector/tvector.scm 43 */
		       obj_t list1158_137;
		       {	/* Tvector/tvector.scm 43 */
			  obj_t aux_530;
			  aux_530 =
			     CNST_TABLE_REF(((long) 0));
			  list1158_137 =
			     MAKE_PAIR(aux_530, BNIL);
		       }
		       arg1150_135 = list1158_137;
		    }
		    arg1157_136 =
		       CNST_TABLE_REF(((long) 1));
		    type_127 =
		       declare_subtype__66_type_env(tvect_id_86_1, arg1145_134, arg1150_135, arg1157_136);
		 }
		 {	/* Tvector/tvector.scm 45 */
		    obj_t arg1159_138;
		    arg1159_138 =
		       find_location_120_tools_location(src_3);
		    item_type_130_128 =
		       use_type__231_type_env(item_id_36_2, arg1159_138);
		 }
		 {	/* Tvector/tvector.scm 47 */
		    tvec_bglt obj1063_129;
		    obj1063_129 =
		       ((tvec_bglt) (type_127));
		    {	/* Tvector/tvector.scm 47 */
		       tvec_bglt arg1137_130;
		       {	/* Tvector/tvector.scm 47 */
			  tvec_bglt res1243_246;
			  {	/* Tvector/tvector.scm 22 */
			     tvec_bglt new1050_244;
			     new1050_244 =
				((tvec_bglt) BREF(GC_MALLOC(sizeof(struct tvec))));
			     ((((tvec_bglt) CREF(new1050_244))->item_type_130) = ((type_bglt) item_type_130_128), BUNSPEC);
			     res1243_246 = new1050_244;
			  }
			  arg1137_130 = res1243_246;
		       }
		       {	/* Tvector/tvector.scm 47 */
			  obj_t aux_542;
			  object_bglt aux_540;
			  aux_542 =
			     (obj_t) (arg1137_130);
			  aux_540 =
			     (object_bglt) (obj1063_129);
			  OBJECT_WIDENING_SET(aux_540, aux_542);
		       }
		    }
		    {	/* Tvector/tvector.scm 47 */
		       long arg1142_132;
		       arg1142_132 =
			  class_num_218___object(tvec_tvector_tvector);
		       {	/* Tvector/tvector.scm 47 */
			  obj_t obj_247;
			  obj_247 =
			     (obj_t) (obj1063_129);
			  (((obj_t) CREF(obj_247))->header = MAKE_HEADER(arg1142_132, 0), BUNSPEC);
		       }
		    }
		    obj1063_129;
		 }
		 {	/* Tvector/tvector.scm 49 */
		    obj_t arg1144_133;
		    arg1144_133 =
		       make_coercion_clause_209_tvector_tvector(tvect_id_86_1);
		    produce_module_clause__172_module_module(arg1144_133);
		 }
		 {	/* Tvector/tvector.scm 51 */
		    obj_t obj2_250;
		    obj2_250 = _tvector_type_list__188_tvector_tvector;
		    {	/* ./Ieee/pair-list.scm 5689 */
		       obj_t aux_550;
		       aux_550 =
			  (obj_t) (type_127);
		       _tvector_type_list__188_tvector_tvector =
			  MAKE_PAIR(aux_550, obj2_250);
		    }
		 }
		 {	/* Tvector/tvector.scm 53 */
		    obj_t val1012_252;
		    val1012_252 =
		       (obj_t) (type_127);
		    ((((type_bglt) CREF(item_type_130_128))->tvector) = ((obj_t) val1012_252), BUNSPEC);
		 }
		 return
		    (tvec_bglt) (type_127);
	      }
	    else
	      {		/* Tvector/tvector.scm 40 */
		 obj_t aux_556;
		 aux_556 =
		    user_error_151_tools_error(string1279_tvector_tvector, string1280_tvector_tvector, exp_env_94___r4_numbers_6_5, BNIL);
		 return
		    (tvec_bglt) (aux_556);
	      }
	 }
      }
   }
}



/* _declare-tvector-type!1247 */
obj_t 
_declare_tvector_type_1247_220_tvector_tvector(obj_t env_386, obj_t tvect_id_86_387, obj_t item_id_36_388, obj_t src_389)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 37 */
      {		/* Tvector/tvector.scm 37 */
	 tvec_bglt aux_559;
	 aux_559 =
	    declare_tvector_type__101_tvector_tvector(tvect_id_86_387, item_id_36_388, src_389);
	 return
	    (obj_t) (aux_559);
      }
   }
}



/* emit-tvector-types */
obj_t 
emit_tvector_types_117_tvector_tvector(obj_t oport_4)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 60 */
      {		/* Tvector/tvector.scm 61 */
	 bool_t test1162_140;
	 {	/* Tvector/tvector.scm 61 */
	    obj_t obj_253;
	    obj_253 = _tvector_type_list__188_tvector_tvector;
	    test1162_140 =
	       PAIRP(obj_253);
	 }
	 if (test1162_140)
	   {	/* Tvector/tvector.scm 61 */
	      display_2_122___r4_output_6_10_3(
		 BCHAR(((unsigned char) '\n')), oport_4);
	      display_2_122___r4_output_6_10_3(string1281_tvector_tvector, oport_4);
	      {		/* ./Ieee/output.scm 9332 */
		 unsigned char aux_567;
		 aux_567 =
		    WRITE_CHAR(((unsigned char) '\n'), oport_4);
		 BCHAR(aux_567);
	      }
	   }
	 else
	   {	/* Tvector/tvector.scm 61 */
	      BUNSPEC;
	   }
      }
      {
	 obj_t l1065_142;
	 {	/* Tvector/tvector.scm 71 */
	    obj_t arg1174_144;
	    arg1174_144 =
	       reverse__39___r4_pairs_and_lists_6_3(_tvector_type_list__188_tvector_tvector);
	    l1065_142 = arg1174_144;
	  lname1066_143:
	    if (
	       PAIRP(l1065_142))
	      {		/* Tvector/tvector.scm 63 */
		 {	/* Tvector/tvector.scm 64 */
		    obj_t tvector_146;
		    tvector_146 =
		       CAR(l1065_142);
		    {	/* Tvector/tvector.scm 64 */
		       obj_t item_type_name_150_147;
		       {	/* Tvector/tvector.scm 64 */
			  type_bglt arg1187_156;
			  {	/* Tvector/tvector.scm 64 */
			     tvec_bglt obj_257;
			     obj_257 =
				(tvec_bglt) (tvector_146);
			     {
				obj_t aux_575;
				{	/* Tvector/tvector.scm 24 */
				   object_bglt aux_576;
				   aux_576 =
				      (object_bglt) (obj_257);
				   aux_575 =
				      OBJECT_WIDENING(aux_576);
				}
				arg1187_156 =
				   (((tvec_bglt) CREF(aux_575))->item_type_130);
			     }
			  }
			  item_type_name_150_147 =
			     (((type_bglt) CREF(arg1187_156))->name);
		       }
		       display_2_122___r4_output_6_10_3(string1282_tvector_tvector, oport_4);
		       {	/* Tvector/tvector.scm 65 */
			  obj_t aux_582;
			  {	/* Tvector/tvector.scm 65 */
			     type_bglt obj_259;
			     obj_259 =
				(type_bglt) (tvector_146);
			     aux_582 =
				(((type_bglt) CREF(obj_259))->size);
			  }
			  display_2_122___r4_output_6_10_3(aux_582, oport_4);
		       }
		       display_2_122___r4_output_6_10_3(string1283_tvector_tvector, oport_4);
		       WRITE_CHAR(((unsigned char) '\n'), oport_4);
		       display_2_122___r4_output_6_10_3(string1284_tvector_tvector, oport_4);
		       WRITE_CHAR(((unsigned char) '\n'), oport_4);
		       display_2_122___r4_output_6_10_3(string1285_tvector_tvector, oport_4);
		       WRITE_CHAR(((unsigned char) '\n'), oport_4);
		       display_2_122___r4_output_6_10_3(string1286_tvector_tvector, oport_4);
		       WRITE_CHAR(((unsigned char) '\n'), oport_4);
		       display_2_122___r4_output_6_10_3(string1287_tvector_tvector, oport_4);
		       display_2_122___r4_output_6_10_3(item_type_name_150_147, oport_4);
		       display_2_122___r4_output_6_10_3(string1288_tvector_tvector, oport_4);
		       WRITE_CHAR(((unsigned char) '\n'), oport_4);
		       display_2_122___r4_output_6_10_3(string1289_tvector_tvector, oport_4);
		       {	/* Tvector/tvector.scm 70 */
			  obj_t arg1185_155;
			  {	/* Tvector/tvector.scm 70 */
			     type_bglt obj_265;
			     obj_265 =
				(type_bglt) (type_type_type);
			     arg1185_155 =
				(((type_bglt) CREF(obj_265))->name);
			  }
			  display_2_122___r4_output_6_10_3(arg1185_155, oport_4);
		       }
		       display_2_122___r4_output_6_10_3(string1290_tvector_tvector, oport_4);
		       WRITE_CHAR(((unsigned char) '\n'), oport_4);
		    }
		 }
		 {
		    obj_t l1065_604;
		    l1065_604 =
		       CDR(l1065_142);
		    l1065_142 = l1065_604;
		    goto lname1066_143;
		 }
	      }
	    else
	      {		/* Tvector/tvector.scm 63 */
		 ((bool_t) 1);
	      }
	 }
      }
      {		/* ./Ieee/output.scm 9332 */
	 unsigned char aux_606;
	 aux_606 =
	    WRITE_CHAR(((unsigned char) '\n'), oport_4);
	 return
	    BCHAR(aux_606);
      }
   }
}



/* _emit-tvector-types1249 */
obj_t 
_emit_tvector_types1249_55_tvector_tvector(obj_t env_392, obj_t oport_393)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 60 */
      return
	 emit_tvector_types_117_tvector_tvector(oport_393);
   }
}



/* make-coercion-clause */
obj_t 
make_coercion_clause_209_tvector_tvector(obj_t tvect_id_86_5)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 77 */
      {		/* Tvector/tvector.scm 78 */
	 obj_t arg1189_158;
	 obj_t arg1190_159;
	 arg1189_158 =
	    CNST_TABLE_REF(((long) 2));
	 {	/* Tvector/tvector.scm 78 */
	    obj_t arg1192_160;
	    obj_t arg1193_161;
	    {	/* Tvector/tvector.scm 78 */
	       obj_t arg1194_162;
	       obj_t arg1195_163;
	       arg1194_162 =
		  CNST_TABLE_REF(((long) 3));
	       {	/* Tvector/tvector.scm 78 */
		  obj_t arg1196_164;
		  {	/* Tvector/tvector.scm 78 */
		     obj_t arg1198_165;
		     obj_t arg1201_166;
		     arg1198_165 =
			CNST_TABLE_REF(((long) 4));
		     {	/* Tvector/tvector.scm 78 */
			obj_t arg1204_168;
			arg1204_168 =
			   MAKE_PAIR(BNIL, BNIL);
			arg1201_166 =
			   MAKE_PAIR(BNIL, arg1204_168);
		     }
		     arg1196_164 =
			MAKE_PAIR(arg1198_165, arg1201_166);
		  }
		  arg1195_163 =
		     MAKE_PAIR(tvect_id_86_5, arg1196_164);
	       }
	       arg1192_160 =
		  MAKE_PAIR(arg1194_162, arg1195_163);
	    }
	    {	/* Tvector/tvector.scm 79 */
	       obj_t arg1206_169;
	       {	/* Tvector/tvector.scm 79 */
		  obj_t arg1209_171;
		  obj_t arg1212_172;
		  arg1209_171 =
		     CNST_TABLE_REF(((long) 3));
		  {	/* Tvector/tvector.scm 79 */
		     obj_t arg1213_173;
		     obj_t arg1214_174;
		     arg1213_173 =
			CNST_TABLE_REF(((long) 4));
		     {	/* Tvector/tvector.scm 79 */
			obj_t arg1215_175;
			{	/* Tvector/tvector.scm 79 */
			   obj_t arg1217_177;
			   arg1217_177 =
			      MAKE_PAIR(BNIL, BNIL);
			   arg1215_175 =
			      MAKE_PAIR(BNIL, arg1217_177);
			}
			arg1214_174 =
			   MAKE_PAIR(tvect_id_86_5, arg1215_175);
		     }
		     arg1212_172 =
			MAKE_PAIR(arg1213_173, arg1214_174);
		  }
		  arg1206_169 =
		     MAKE_PAIR(arg1209_171, arg1212_172);
	       }
	       arg1193_161 =
		  MAKE_PAIR(arg1206_169, BNIL);
	    }
	    arg1190_159 =
	       MAKE_PAIR(arg1192_160, arg1193_161);
	 }
	 return
	    MAKE_PAIR(arg1189_158, arg1190_159);
      }
   }
}



/* object-init */
obj_t 
object_init_111_tvector_tvector()
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 14 */
      {		/* Tvector/tvector.scm 14 */
	 obj_t arg1220_178;
	 obj_t arg1222_179;
	 obj_t arg1226_182;
	 arg1220_178 =
	    CNST_TABLE_REF(((long) 5));
	 arg1222_179 = type_type_type;
	 {	/* Tvector/tvector.scm 14 */
	    obj_t v1073_183;
	    v1073_183 =
	       create_vector(((long) 0));
	    arg1226_182 = v1073_183;
	 }
	 tvec_tvector_tvector =
	    register_class__225___object(arg1220_178, arg1222_179, allocate_tvec_env_194_tvector_tvector, ((long) 17798), BUNSPEC, BFALSE, arg1226_182);
      }
      return BUNSPEC;
   }
}



/* allocate-tvec */
type_bglt 
allocate_tvec_255_tvector_tvector()
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      {		/* Tvector/tvector.scm 22 */
	 type_bglt new1055_184;
	 new1055_184 =
	    ((type_bglt) BREF(GC_MALLOC(sizeof(struct type))));
	 {	/* Tvector/tvector.scm 22 */
	    long arg1227_185;
	    arg1227_185 =
	       class_num_218___object(tvec_tvector_tvector);
	    {	/* Tvector/tvector.scm 22 */
	       obj_t obj_295;
	       obj_295 =
		  (obj_t) (new1055_184);
	       (((obj_t) CREF(obj_295))->header = MAKE_HEADER(arg1227_185, 0), BUNSPEC);
	    }
	 }
	 {	/* Tvector/tvector.scm 22 */
	    object_bglt aux_635;
	    aux_635 =
	       (object_bglt) (new1055_184);
	    OBJECT_WIDENING_SET(aux_635, BFALSE);
	 }
	 return new1055_184;
      }
   }
}



/* _allocate-tvec */
obj_t 
_allocate_tvec_199_tvector_tvector(obj_t env_394)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      {		/* Tvector/tvector.scm 22 */
	 type_bglt aux_638;
	 aux_638 =
	    allocate_tvec_255_tvector_tvector();
	 return
	    (obj_t) (aux_638);
      }
   }
}



/* tvec? */
bool_t 
tvec__226_tvector_tvector(obj_t obj_9)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      return
	 is_a__118___object(obj_9, tvec_tvector_tvector);
   }
}



/* _tvec? */
obj_t 
_tvec__174_tvector_tvector(obj_t env_395, obj_t obj_396)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      {		/* Tvector/tvector.scm 22 */
	 bool_t aux_642;
	 aux_642 =
	    tvec__226_tvector_tvector(obj_396);
	 return
	    BBOOL(aux_642);
      }
   }
}



/* widening-tvec */
tvec_bglt 
widening_tvec_132_tvector_tvector(type_bglt item_type_130_10)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      {		/* Tvector/tvector.scm 22 */
	 tvec_bglt new1050_297;
	 new1050_297 =
	    ((tvec_bglt) BREF(GC_MALLOC(sizeof(struct tvec))));
	 ((((tvec_bglt) CREF(new1050_297))->item_type_130) = ((type_bglt) item_type_130_10), BUNSPEC);
	 return new1050_297;
      }
   }
}



/* _widening-tvec1250 */
obj_t 
_widening_tvec1250_106_tvector_tvector(obj_t env_397, obj_t item_type_130_398)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      {		/* Tvector/tvector.scm 22 */
	 tvec_bglt aux_647;
	 aux_647 =
	    widening_tvec_132_tvector_tvector(
	    (type_bglt) (item_type_130_398));
	 return
	    (obj_t) (aux_647);
      }
   }
}



/* make-tvec */
tvec_bglt 
make_tvec_253_tvector_tvector(obj_t id_11, obj_t name_12, obj_t size_13, obj_t class_14, obj_t coerce_to_204_15, obj_t parents_16, bool_t init__47_17, bool_t magic__53_18, obj_t __57_19, obj_t alias_20, obj_t pointed_to_by_76_21, obj_t tvector_22, obj_t location_23, type_bglt item_type_130_24)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      {		/* Tvector/tvector.scm 22 */
	 type_bglt aux1053_299;
	 {	/* Tvector/tvector.scm 22 */
	    type_bglt res1244_333;
	    {	/* ./Type/type.scm 332 */
	       type_bglt new1014_316;
	       new1014_316 =
		  ((type_bglt) BREF(GC_MALLOC(sizeof(struct type))));
	       {	/* ./Type/type.scm 332 */
		  long arg1233_317;
		  arg1233_317 =
		     class_num_218___object(type_type_type);
		  {	/* ./Type/type.scm 332 */
		     obj_t obj_331;
		     obj_331 =
			(obj_t) (new1014_316);
		     (((obj_t) CREF(obj_331))->header = MAKE_HEADER(arg1233_317, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Type/type.scm 332 */
		  object_bglt aux_655;
		  aux_655 =
		     (object_bglt) (new1014_316);
		  OBJECT_WIDENING_SET(aux_655, BFALSE);
	       }
	       ((((type_bglt) CREF(new1014_316))->id) = ((obj_t) id_11), BUNSPEC);
	       ((((type_bglt) CREF(new1014_316))->name) = ((obj_t) name_12), BUNSPEC);
	       ((((type_bglt) CREF(new1014_316))->size) = ((obj_t) size_13), BUNSPEC);
	       ((((type_bglt) CREF(new1014_316))->class) = ((obj_t) class_14), BUNSPEC);
	       ((((type_bglt) CREF(new1014_316))->coerce_to_204) = ((obj_t) coerce_to_204_15), BUNSPEC);
	       ((((type_bglt) CREF(new1014_316))->parents) = ((obj_t) parents_16), BUNSPEC);
	       ((((type_bglt) CREF(new1014_316))->init__47) = ((bool_t) init__47_17), BUNSPEC);
	       ((((type_bglt) CREF(new1014_316))->magic__53) = ((bool_t) magic__53_18), BUNSPEC);
	       ((((type_bglt) CREF(new1014_316))->__57) = ((obj_t) __57_19), BUNSPEC);
	       ((((type_bglt) CREF(new1014_316))->alias) = ((obj_t) alias_20), BUNSPEC);
	       ((((type_bglt) CREF(new1014_316))->pointed_to_by_76) = ((obj_t) pointed_to_by_76_21), BUNSPEC);
	       ((((type_bglt) CREF(new1014_316))->tvector) = ((obj_t) tvector_22), BUNSPEC);
	       ((((type_bglt) CREF(new1014_316))->location) = ((obj_t) location_23), BUNSPEC);
	       res1244_333 = new1014_316;
	    }
	    aux1053_299 = res1244_333;
	 }
	 {	/* Tvector/tvector.scm 22 */
	    tvec_bglt new1054_300;
	    new1054_300 =
	       ((tvec_bglt) (aux1053_299));
	    {	/* Tvector/tvector.scm 22 */
	       long arg1228_301;
	       arg1228_301 =
		  class_num_218___object(tvec_tvector_tvector);
	       {	/* Tvector/tvector.scm 22 */
		  obj_t obj_334;
		  obj_334 =
		     (obj_t) (new1054_300);
		  (((obj_t) CREF(obj_334))->header = MAKE_HEADER(arg1228_301, 0), BUNSPEC);
	       }
	    }
	    {	/* Tvector/tvector.scm 22 */
	       tvec_bglt arg1229_302;
	       {	/* Tvector/tvector.scm 22 */
		  tvec_bglt res1245_339;
		  {	/* Tvector/tvector.scm 22 */
		     tvec_bglt new1050_337;
		     new1050_337 =
			((tvec_bglt) BREF(GC_MALLOC(sizeof(struct tvec))));
		     ((((tvec_bglt) CREF(new1050_337))->item_type_130) = ((type_bglt) item_type_130_24), BUNSPEC);
		     res1245_339 = new1050_337;
		  }
		  arg1229_302 = res1245_339;
	       }
	       {	/* Tvector/tvector.scm 22 */
		  obj_t aux_679;
		  object_bglt aux_677;
		  aux_679 =
		     (obj_t) (arg1229_302);
		  aux_677 =
		     (object_bglt) (new1054_300);
		  OBJECT_WIDENING_SET(aux_677, aux_679);
	       }
	    }
	    return new1054_300;
	 }
      }
   }
}



/* _make-tvec1251 */
obj_t 
_make_tvec1251_174_tvector_tvector(obj_t env_399, obj_t id_400, obj_t name_401, obj_t size_402, obj_t class_403, obj_t coerce_to_204_404, obj_t parents_405, obj_t init__47_406, obj_t magic__53_407, obj_t __57_408, obj_t alias_409, obj_t pointed_to_by_76_410, obj_t tvector_411, obj_t location_412, obj_t item_type_130_413)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      {		/* Tvector/tvector.scm 22 */
	 tvec_bglt aux_682;
	 aux_682 =
	    make_tvec_253_tvector_tvector(id_400, name_401, size_402, class_403, coerce_to_204_404, parents_405,
	    CBOOL(init__47_406),
	    CBOOL(magic__53_407), __57_408, alias_409, pointed_to_by_76_410, tvector_411, location_412,
	    (type_bglt) (item_type_130_413));
	 return
	    (obj_t) (aux_682);
      }
   }
}



/* tvec-id */
obj_t 
tvec_id_66_tvector_tvector(type_bglt obj_25)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 334 */
      return
	 (((type_bglt) CREF(obj_25))->id);
   }
}



/* _tvec-id1252 */
obj_t 
_tvec_id1252_215_tvector_tvector(obj_t env_414, obj_t obj_415)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 334 */
      return
	 tvec_id_66_tvector_tvector(
	 (type_bglt) (obj_415));
   }
}



/* tvec-name-set! */
obj_t 
tvec_name_set__198_tvector_tvector(type_bglt obj_26, obj_t val1038_27)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 336 */
      return
	 ((((type_bglt) CREF(obj_26))->name) = ((obj_t) val1038_27), BUNSPEC);
   }
}



/* _tvec-name-set!1253 */
obj_t 
_tvec_name_set_1253_85_tvector_tvector(obj_t env_416, obj_t obj_417, obj_t val1038_418)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 336 */
      return
	 tvec_name_set__198_tvector_tvector(
	 (type_bglt) (obj_417), val1038_418);
   }
}



/* tvec-name */
obj_t 
tvec_name_219_tvector_tvector(type_bglt obj_28)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 336 */
      return
	 (((type_bglt) CREF(obj_28))->name);
   }
}



/* _tvec-name1254 */
obj_t 
_tvec_name1254_90_tvector_tvector(obj_t env_419, obj_t obj_420)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 336 */
      return
	 tvec_name_219_tvector_tvector(
	 (type_bglt) (obj_420));
   }
}



/* tvec-size-set! */
obj_t 
tvec_size_set__225_tvector_tvector(type_bglt obj_29, obj_t val1039_30)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 338 */
      return
	 ((((type_bglt) CREF(obj_29))->size) = ((obj_t) val1039_30), BUNSPEC);
   }
}



/* _tvec-size-set!1255 */
obj_t 
_tvec_size_set_1255_122_tvector_tvector(obj_t env_421, obj_t obj_422, obj_t val1039_423)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 338 */
      return
	 tvec_size_set__225_tvector_tvector(
	 (type_bglt) (obj_422), val1039_423);
   }
}



/* tvec-size */
obj_t 
tvec_size_218_tvector_tvector(type_bglt obj_31)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 338 */
      return
	 (((type_bglt) CREF(obj_31))->size);
   }
}



/* _tvec-size1256 */
obj_t 
_tvec_size1256_191_tvector_tvector(obj_t env_424, obj_t obj_425)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 338 */
      return
	 tvec_size_218_tvector_tvector(
	 (type_bglt) (obj_425));
   }
}



/* tvec-class-set! */
obj_t 
tvec_class_set__119_tvector_tvector(type_bglt obj_32, obj_t val1040_33)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 340 */
      return
	 ((((type_bglt) CREF(obj_32))->class) = ((obj_t) val1040_33), BUNSPEC);
   }
}



/* _tvec-class-set!1257 */
obj_t 
_tvec_class_set_1257_72_tvector_tvector(obj_t env_426, obj_t obj_427, obj_t val1040_428)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 340 */
      return
	 tvec_class_set__119_tvector_tvector(
	 (type_bglt) (obj_427), val1040_428);
   }
}



/* tvec-class */
obj_t 
tvec_class_217_tvector_tvector(type_bglt obj_34)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 340 */
      return
	 (((type_bglt) CREF(obj_34))->class);
   }
}



/* _tvec-class1258 */
obj_t 
_tvec_class1258_187_tvector_tvector(obj_t env_429, obj_t obj_430)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 340 */
      return
	 tvec_class_217_tvector_tvector(
	 (type_bglt) (obj_430));
   }
}



/* tvec-coerce-to-set! */
obj_t 
tvec_coerce_to_set__84_tvector_tvector(type_bglt obj_35, obj_t val1041_36)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 343 */
      return
	 ((((type_bglt) CREF(obj_35))->coerce_to_204) = ((obj_t) val1041_36), BUNSPEC);
   }
}



/* _tvec-coerce-to-set!1259 */
obj_t 
_tvec_coerce_to_set_1259_228_tvector_tvector(obj_t env_431, obj_t obj_432, obj_t val1041_433)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 343 */
      return
	 tvec_coerce_to_set__84_tvector_tvector(
	 (type_bglt) (obj_432), val1041_433);
   }
}



/* tvec-coerce-to */
obj_t 
tvec_coerce_to_9_tvector_tvector(type_bglt obj_37)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 343 */
      return
	 (((type_bglt) CREF(obj_37))->coerce_to_204);
   }
}



/* _tvec-coerce-to1260 */
obj_t 
_tvec_coerce_to1260_218_tvector_tvector(obj_t env_434, obj_t obj_435)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 343 */
      return
	 tvec_coerce_to_9_tvector_tvector(
	 (type_bglt) (obj_435));
   }
}



/* tvec-parents-set! */
obj_t 
tvec_parents_set__71_tvector_tvector(type_bglt obj_38, obj_t val1042_39)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 345 */
      return
	 ((((type_bglt) CREF(obj_38))->parents) = ((obj_t) val1042_39), BUNSPEC);
   }
}



/* _tvec-parents-set!1261 */
obj_t 
_tvec_parents_set_1261_184_tvector_tvector(obj_t env_436, obj_t obj_437, obj_t val1042_438)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 345 */
      return
	 tvec_parents_set__71_tvector_tvector(
	 (type_bglt) (obj_437), val1042_438);
   }
}



/* tvec-parents */
obj_t 
tvec_parents_196_tvector_tvector(type_bglt obj_40)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 345 */
      return
	 (((type_bglt) CREF(obj_40))->parents);
   }
}



/* _tvec-parents1262 */
obj_t 
_tvec_parents1262_107_tvector_tvector(obj_t env_439, obj_t obj_440)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 345 */
      return
	 tvec_parents_196_tvector_tvector(
	 (type_bglt) (obj_440));
   }
}



/* tvec-init?-set! */
obj_t 
tvec_init__set__63_tvector_tvector(type_bglt obj_41, bool_t val1043_42)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      return
	 ((((type_bglt) CREF(obj_41))->init__47) = ((bool_t) val1043_42), BUNSPEC);
   }
}



/* _tvec-init?-set!1263 */
obj_t 
_tvec_init__set_1263_196_tvector_tvector(obj_t env_441, obj_t obj_442, obj_t val1043_443)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      return
	 tvec_init__set__63_tvector_tvector(
	 (type_bglt) (obj_442),
	 CBOOL(val1043_443));
   }
}



/* tvec-init? */
bool_t 
tvec_init__77_tvector_tvector(type_bglt obj_43)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      return
	 (((type_bglt) CREF(obj_43))->init__47);
   }
}



/* _tvec-init?1264 */
obj_t 
_tvec_init_1264_244_tvector_tvector(obj_t env_444, obj_t obj_445)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      {		/* Tvector/tvector.scm 22 */
	 bool_t aux_726;
	 aux_726 =
	    tvec_init__77_tvector_tvector(
	    (type_bglt) (obj_445));
	 return
	    BBOOL(aux_726);
      }
   }
}



/* tvec-magic?-set! */
obj_t 
tvec_magic__set__41_tvector_tvector(type_bglt obj_44, bool_t val1044_45)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 349 */
      return
	 ((((type_bglt) CREF(obj_44))->magic__53) = ((bool_t) val1044_45), BUNSPEC);
   }
}



/* _tvec-magic?-set!1265 */
obj_t 
_tvec_magic__set_1265_168_tvector_tvector(obj_t env_446, obj_t obj_447, obj_t val1044_448)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 349 */
      return
	 tvec_magic__set__41_tvector_tvector(
	 (type_bglt) (obj_447),
	 CBOOL(val1044_448));
   }
}



/* tvec-magic? */
bool_t 
tvec_magic__235_tvector_tvector(type_bglt obj_46)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 349 */
      return
	 (((type_bglt) CREF(obj_46))->magic__53);
   }
}



/* _tvec-magic?1266 */
obj_t 
_tvec_magic_1266_43_tvector_tvector(obj_t env_449, obj_t obj_450)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 349 */
      {		/* ./Type/type.scm 349 */
	 bool_t aux_735;
	 aux_735 =
	    tvec_magic__235_tvector_tvector(
	    (type_bglt) (obj_450));
	 return
	    BBOOL(aux_735);
      }
   }
}



/* tvec-$-set! */
obj_t 
tvec___set__72_tvector_tvector(type_bglt obj_47, obj_t val1045_48)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 351 */
      return
	 ((((type_bglt) CREF(obj_47))->__57) = ((obj_t) val1045_48), BUNSPEC);
   }
}



/* _tvec-$-set!1267 */
obj_t 
_tvec___set_1267_180_tvector_tvector(obj_t env_451, obj_t obj_452, obj_t val1045_453)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 351 */
      return
	 tvec___set__72_tvector_tvector(
	 (type_bglt) (obj_452), val1045_453);
   }
}



/* tvec-$ */
obj_t 
tvec___12_tvector_tvector(type_bglt obj_49)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 351 */
      return
	 (((type_bglt) CREF(obj_49))->__57);
   }
}



/* _tvec-$1268 */
obj_t 
_tvec__1268_106_tvector_tvector(obj_t env_454, obj_t obj_455)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 351 */
      return
	 tvec___12_tvector_tvector(
	 (type_bglt) (obj_455));
   }
}



/* tvec-alias-set! */
obj_t 
tvec_alias_set__17_tvector_tvector(type_bglt obj_50, obj_t val1046_51)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 353 */
      return
	 ((((type_bglt) CREF(obj_50))->alias) = ((obj_t) val1046_51), BUNSPEC);
   }
}



/* _tvec-alias-set!1269 */
obj_t 
_tvec_alias_set_1269_84_tvector_tvector(obj_t env_456, obj_t obj_457, obj_t val1046_458)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 353 */
      return
	 tvec_alias_set__17_tvector_tvector(
	 (type_bglt) (obj_457), val1046_458);
   }
}



/* tvec-alias */
obj_t 
tvec_alias_117_tvector_tvector(type_bglt obj_52)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 353 */
      return
	 (((type_bglt) CREF(obj_52))->alias);
   }
}



/* _tvec-alias1270 */
obj_t 
_tvec_alias1270_176_tvector_tvector(obj_t env_459, obj_t obj_460)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 353 */
      return
	 tvec_alias_117_tvector_tvector(
	 (type_bglt) (obj_460));
   }
}



/* tvec-pointed-to-by-set! */
obj_t 
tvec_pointed_to_by_set__49_tvector_tvector(type_bglt obj_53, obj_t val1047_54)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 355 */
      return
	 ((((type_bglt) CREF(obj_53))->pointed_to_by_76) = ((obj_t) val1047_54), BUNSPEC);
   }
}



/* _tvec-pointed-to-by-set!1271 */
obj_t 
_tvec_pointed_to_by_set_1271_172_tvector_tvector(obj_t env_461, obj_t obj_462, obj_t val1047_463)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 355 */
      return
	 tvec_pointed_to_by_set__49_tvector_tvector(
	 (type_bglt) (obj_462), val1047_463);
   }
}



/* tvec-pointed-to-by */
obj_t 
tvec_pointed_to_by_20_tvector_tvector(type_bglt obj_55)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 355 */
      return
	 (((type_bglt) CREF(obj_55))->pointed_to_by_76);
   }
}



/* _tvec-pointed-to-by1272 */
obj_t 
_tvec_pointed_to_by1272_135_tvector_tvector(obj_t env_464, obj_t obj_465)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 355 */
      return
	 tvec_pointed_to_by_20_tvector_tvector(
	 (type_bglt) (obj_465));
   }
}



/* tvec-tvector-set! */
obj_t 
tvec_tvector_set__39_tvector_tvector(type_bglt obj_56, obj_t val1048_57)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 358 */
      return
	 ((((type_bglt) CREF(obj_56))->tvector) = ((obj_t) val1048_57), BUNSPEC);
   }
}



/* _tvec-tvector-set!1273 */
obj_t 
_tvec_tvector_set_1273_69_tvector_tvector(obj_t env_466, obj_t obj_467, obj_t val1048_468)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 358 */
      return
	 tvec_tvector_set__39_tvector_tvector(
	 (type_bglt) (obj_467), val1048_468);
   }
}



/* tvec-tvector */
obj_t 
tvec_tvector_69_tvector_tvector(type_bglt obj_58)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 358 */
      return
	 (((type_bglt) CREF(obj_58))->tvector);
   }
}



/* _tvec-tvector1274 */
obj_t 
_tvec_tvector1274_157_tvector_tvector(obj_t env_469, obj_t obj_470)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 358 */
      return
	 tvec_tvector_69_tvector_tvector(
	 (type_bglt) (obj_470));
   }
}



/* tvec-location-set! */
obj_t 
tvec_location_set__219_tvector_tvector(type_bglt obj_59, obj_t val1049_60)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 360 */
      return
	 ((((type_bglt) CREF(obj_59))->location) = ((obj_t) val1049_60), BUNSPEC);
   }
}



/* _tvec-location-set! */
obj_t 
_tvec_location_set__99_tvector_tvector(obj_t env_471, obj_t obj_472, obj_t val1049_473)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 360 */
      return
	 tvec_location_set__219_tvector_tvector(
	 (type_bglt) (obj_472), val1049_473);
   }
}



/* tvec-location */
obj_t 
tvec_location_158_tvector_tvector(type_bglt obj_61)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 360 */
      return
	 (((type_bglt) CREF(obj_61))->location);
   }
}



/* _tvec-location */
obj_t 
_tvec_location_125_tvector_tvector(obj_t env_474, obj_t obj_475)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 360 */
      return
	 tvec_location_158_tvector_tvector(
	 (type_bglt) (obj_475));
   }
}



/* tvec-item-type */
type_bglt 
tvec_item_type_215_tvector_tvector(tvec_bglt obj_62)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 24 */
      {
	 obj_t aux_769;
	 {	/* Tvector/tvector.scm 24 */
	    object_bglt aux_770;
	    aux_770 =
	       (object_bglt) (obj_62);
	    aux_769 =
	       OBJECT_WIDENING(aux_770);
	 }
	 return
	    (((tvec_bglt) CREF(aux_769))->item_type_130);
      }
   }
}



/* _tvec-item-type1275 */
obj_t 
_tvec_item_type1275_112_tvector_tvector(obj_t env_476, obj_t obj_477)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 24 */
      {		/* Tvector/tvector.scm 24 */
	 type_bglt aux_774;
	 aux_774 =
	    tvec_item_type_215_tvector_tvector(
	    (tvec_bglt) (obj_477));
	 return
	    (obj_t) (aux_774);
      }
   }
}



/* method-init */
obj_t 
method_init_76_tvector_tvector()
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 14 */
      {		/* Tvector/tvector.scm 14 */
	 obj_t object__struct_tvec1076_16_482;
	 object__struct_tvec1076_16_482 = proc1291_tvector_tvector;
	 add_method__1___object(object__struct_env_210___object, tvec_tvector_tvector, object__struct_tvec1076_16_482);
      }
      {		/* Tvector/tvector.scm 14 */
	 obj_t struct_object__object_tvec1078_3_478;
	 struct_object__object_tvec1078_3_478 = proc1292_tvector_tvector;
	 return
	    add_method__1___object(struct_object__object_env_209___object, tvec_tvector_tvector, struct_object__object_tvec1078_3_478);
      }
   }
}



/* struct+object->object-tvec1078 */
obj_t 
struct_object__object_tvec1078_3_tvector_tvector(obj_t env_485, obj_t o_486, obj_t s_487)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      {
	 tvec_bglt o_228;
	 obj_t s_229;
	 {	/* Tvector/tvector.scm 22 */
	    tvec_bglt aux_780;
	    o_228 =
	       (tvec_bglt) (o_486);
	    s_229 = s_487;
	    {

	       {	/* Tvector/tvector.scm 22 */
		  obj_t old1060_232;
		  obj_t aux1061_233;
		  {	/* Tvector/tvector.scm 22 */
		     obj_t next_method1077_174_238;
		     next_method1077_174_238 =
			find_super_class_method_167___object(
			(object_bglt) (o_228), struct_object__object_env_209___object, tvec_tvector_tvector);
		     if (
			PROCEDUREP(next_method1077_174_238))
		       {	/* Tvector/tvector.scm 22 */
			  old1060_232 =
			     PROCEDURE_ENTRY(next_method1077_174_238) (next_method1077_174_238,
			     (obj_t) (o_228), s_229, BEOA);
		       }
		     else
		       {	/* Tvector/tvector.scm 22 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1077_174_238);
			  {	/* Tvector/tvector.scm 22 */
			     object_bglt aux_789;
			     aux_789 =
				struct_object__object_93___object(
				(object_bglt) (o_228), s_229);
			     old1060_232 =
				(obj_t) (aux_789);
			  }
		       }
		  }
		  aux1061_233 =
		     STRUCT_REF(s_229, ((long) 0));
		  {	/* Tvector/tvector.scm 22 */
		     tvec_bglt new1062_234;
		     new1062_234 =
			((tvec_bglt) (old1060_232));
		     {	/* Tvector/tvector.scm 22 */
			long arg1238_235;
			arg1238_235 =
			   class_num_218___object(tvec_tvector_tvector);
			{	/* Tvector/tvector.scm 22 */
			   obj_t obj_376;
			   obj_376 =
			      (obj_t) (new1062_234);
			   (((obj_t) CREF(obj_376))->header = MAKE_HEADER(arg1238_235, 0), BUNSPEC);
			}
		     }
		     {	/* Tvector/tvector.scm 22 */
			tvec_bglt arg1240_236;
			{	/* Tvector/tvector.scm 22 */
			   tvec_bglt res1246_383;
			   {	/* Tvector/tvector.scm 22 */
			      type_bglt item_type_130_380;
			      {		/* Tvector/tvector.scm 22 */
				 obj_t aux_798;
				 aux_798 =
				    STRUCT_REF(aux1061_233, ((long) 0));
				 item_type_130_380 =
				    (type_bglt) (aux_798);
			      }
			      {		/* Tvector/tvector.scm 22 */
				 tvec_bglt new1050_381;
				 new1050_381 =
				    ((tvec_bglt) BREF(GC_MALLOC(sizeof(struct tvec))));
				 ((((tvec_bglt) CREF(new1050_381))->item_type_130) = ((type_bglt) item_type_130_380), BUNSPEC);
				 res1246_383 = new1050_381;
			      }
			   }
			   arg1240_236 = res1246_383;
			}
			{	/* Tvector/tvector.scm 22 */
			   obj_t aux_805;
			   object_bglt aux_803;
			   aux_805 =
			      (obj_t) (arg1240_236);
			   aux_803 =
			      (object_bglt) (new1062_234);
			   OBJECT_WIDENING_SET(aux_803, aux_805);
			}
		     }
		     aux_780 = new1062_234;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_780);
	 }
      }
   }
}



/* object->struct-tvec1076 */
obj_t 
object__struct_tvec1076_16_tvector_tvector(obj_t env_488, obj_t obj1057_489)
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 22 */
      {
	 tvec_bglt obj1057_218;
	 obj1057_218 =
	    (tvec_bglt) (obj1057_489);
	 {

	    {	/* Tvector/tvector.scm 22 */
	       obj_t res1058_221;
	       {	/* Tvector/tvector.scm 22 */
		  obj_t next_method1075_119_226;
		  next_method1075_119_226 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1057_218), object__struct_env_210___object, tvec_tvector_tvector);
		  if (
		     PROCEDUREP(next_method1075_119_226))
		    {	/* Tvector/tvector.scm 22 */
		       res1058_221 =
			  PROCEDURE_ENTRY(next_method1075_119_226) (next_method1075_119_226,
			  (obj_t) (obj1057_218), BEOA);
		    }
		  else
		    {	/* Tvector/tvector.scm 22 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1075_119_226);
		       res1058_221 =
			  object__struct_50___object(
			  (object_bglt) (obj1057_218));
		    }
	       }
	       {	/* Tvector/tvector.scm 22 */
		  obj_t aux1059_222;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_820;
		     aux_820 =
			CNST_TABLE_REF(((long) 5));
		     aux1059_222 =
			make_struct(aux_820, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_823;
		     {	/* Tvector/tvector.scm 22 */
			type_bglt aux_824;
			{
			   obj_t aux_825;
			   {	/* Tvector/tvector.scm 24 */
			      object_bglt aux_826;
			      aux_826 =
				 (object_bglt) (obj1057_218);
			      aux_825 =
				 OBJECT_WIDENING(aux_826);
			   }
			   aux_824 =
			      (((tvec_bglt) CREF(aux_825))->item_type_130);
			}
			aux_823 =
			   (obj_t) (aux_824);
		     }
		     STRUCT_SET(aux1059_222, ((long) 0), aux_823);
		  }
		  STRUCT_SET(res1058_221, ((long) 0), aux1059_222);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_833;
		     aux_833 =
			STRUCT_KEY(res1058_221);
		     STRUCT_KEY_SET(aux1059_222, aux_833);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_836;
		     aux_836 =
			CNST_TABLE_REF(((long) 5));
		     STRUCT_KEY_SET(res1058_221, aux_836);
		  }
		  return res1058_221;
	       }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_tvector_tvector()
{
   AN_OBJECT;
   {	/* Tvector/tvector.scm 14 */
      module_initialization_70_type_type(((long) 0), "TVECTOR_TVECTOR");
      module_initialization_70_type_env(((long) 0), "TVECTOR_TVECTOR");
      module_initialization_70_tools_error(((long) 0), "TVECTOR_TVECTOR");
      module_initialization_70_module_module(((long) 0), "TVECTOR_TVECTOR");
      return
	 module_initialization_70_tools_location(((long) 0), "TVECTOR_TVECTOR");
   }
}
