/*===========================================================================*/
/*   (Ieee/char.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo2.1a.h>
#include <signal.h>

static obj_t _integer__char_ur1197_33___r4_characters_6_6(obj_t, obj_t);
extern obj_t string_to_symbol(char *);
static obj_t _char___1183_186___r4_characters_6_6(obj_t, obj_t, obj_t);
static obj_t _char___1184_27___r4_characters_6_6(obj_t, obj_t, obj_t);
static obj_t symbol1316___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1315___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1314___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1313___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1312___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1311___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1299___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1309___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1310___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1298___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1308___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1297___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1296___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1306___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1295___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1294___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1293___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1292___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1302___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1291___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1301___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1289___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1290___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1300___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1288___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1287___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1286___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1285___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1284___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1283___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1282___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1281___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1279___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1280___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1278___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1277___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1276___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1275___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1274___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1273___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1272___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1269___r4_characters_6_6 = BUNSPEC;
static obj_t _integer__char1196_4___r4_characters_6_6(obj_t, obj_t);
static obj_t symbol1268___r4_characters_6_6 = BUNSPEC;
static obj_t symbol1267___r4_characters_6_6 = BUNSPEC;
extern long char__integer_184___r4_characters_6_6(unsigned char);
extern unsigned char char_downcase_76___r4_characters_6_6(unsigned char);
extern bool_t char_alphabetic__208___r4_characters_6_6(unsigned char);
static obj_t _char_upper_case_1193_86___r4_characters_6_6(obj_t, obj_t);
static obj_t _char_ci__1186_234___r4_characters_6_6(obj_t, obj_t, obj_t);
extern obj_t bigloo_type_error_location_103___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern unsigned char char_or_106___r4_characters_6_6(unsigned char, unsigned char);
extern bool_t char_ci____41___r4_characters_6_6(unsigned char, unsigned char);
extern bool_t char_ci___21___r4_characters_6_6(unsigned char, unsigned char);
extern bool_t char_ci___242___r4_characters_6_6(unsigned char, unsigned char);
extern bool_t char_ci___112___r4_characters_6_6(unsigned char, unsigned char);
extern bool_t char_numeric__32___r4_characters_6_6(unsigned char);
extern obj_t debug_error_location_199___error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _char__1181_59___r4_characters_6_6(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70___r4_characters_6_6(long, char *);
extern obj_t module_initialization_70___error(long, char *);
static obj_t _char_ci__1185_39___r4_characters_6_6(obj_t, obj_t, obj_t);
extern unsigned char integer__char_ur_23___r4_characters_6_6(long);
extern bool_t char_ci____192___r4_characters_6_6(unsigned char, unsigned char);
static obj_t _char_or1200_195___r4_characters_6_6(obj_t, obj_t, obj_t);
static obj_t _char_ci___1188_94___r4_characters_6_6(obj_t, obj_t, obj_t);
static obj_t _char_lower_case_1194_211___r4_characters_6_6(obj_t, obj_t);
static obj_t _char_ci___1189_98___r4_characters_6_6(obj_t, obj_t, obj_t);
extern unsigned char integer__char_140___r4_characters_6_6(long);
static obj_t _char__134___r4_characters_6_6(obj_t, obj_t);
extern obj_t error_c_location_83___error(obj_t, obj_t, obj_t, char *, long);
static obj_t _char_upcase1198_8___r4_characters_6_6(obj_t, obj_t);
static obj_t _char__1180_122___r4_characters_6_6(obj_t, obj_t, obj_t);
extern bool_t char_lower_case__222___r4_characters_6_6(unsigned char);
static obj_t _char_ci__1187_201___r4_characters_6_6(obj_t, obj_t, obj_t);
static obj_t _char__integer1195_129___r4_characters_6_6(obj_t, obj_t);
extern bool_t char__59___r4_characters_6_6(obj_t);
static obj_t _char_whitespace_1192_84___r4_characters_6_6(obj_t, obj_t);
static obj_t _char_downcase1199_225___r4_characters_6_6(obj_t, obj_t);
static obj_t imported_modules_init_94___r4_characters_6_6();
static obj_t _char_numeric_1191_68___r4_characters_6_6(obj_t, obj_t);
extern bool_t char____252___r4_characters_6_6(unsigned char, unsigned char);
extern bool_t char___195___r4_characters_6_6(unsigned char, unsigned char);
extern bool_t char___215___r4_characters_6_6(unsigned char, unsigned char);
extern bool_t char___13___r4_characters_6_6(unsigned char, unsigned char);
extern bool_t char_whitespace__92___r4_characters_6_6(unsigned char);
static obj_t _char__1182_92___r4_characters_6_6(obj_t, obj_t, obj_t);
static obj_t require_initialization_114___r4_characters_6_6 = BUNSPEC;
extern bool_t char_upper_case__12___r4_characters_6_6(unsigned char);
static obj_t _char_alphabetic_1190_91___r4_characters_6_6(obj_t, obj_t);
extern bool_t char____152___r4_characters_6_6(unsigned char, unsigned char);
static obj_t cnst_init_137___r4_characters_6_6();
extern unsigned char char_upcase_134___r4_characters_6_6(unsigned char);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( char_ci___env_200___r4_characters_6_6, _char_ci__1185_39___r4_characters_6_61339, _char_ci__1185_39___r4_characters_6_6, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( integer__char_ur_env_241___r4_characters_6_6, _integer__char_ur1197_33___r4_characters_6_61340, _integer__char_ur1197_33___r4_characters_6_6, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( char_ci___env_123___r4_characters_6_6, _char_ci__1187_201___r4_characters_6_61341, _char_ci__1187_201___r4_characters_6_6, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( char_or_env_17___r4_characters_6_6, _char_or1200_195___r4_characters_6_61342, _char_or1200_195___r4_characters_6_6, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( char_upper_case__env_74___r4_characters_6_6, _char_upper_case_1193_86___r4_characters_6_61343, _char_upper_case_1193_86___r4_characters_6_6, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( char__integer_env_161___r4_characters_6_6, _char__integer1195_129___r4_characters_6_61344, _char__integer1195_129___r4_characters_6_6, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( char___env_34___r4_characters_6_6, _char__1181_59___r4_characters_6_61345, _char__1181_59___r4_characters_6_6, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( char_downcase_env_22___r4_characters_6_6, _char_downcase1199_225___r4_characters_6_61346, _char_downcase1199_225___r4_characters_6_6, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( char_numeric__env_250___r4_characters_6_6, _char_numeric_1191_68___r4_characters_6_61347, _char_numeric_1191_68___r4_characters_6_6, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( char_ci____env_142___r4_characters_6_6, _char_ci___1188_94___r4_characters_6_61348, _char_ci___1188_94___r4_characters_6_6, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( char_ci____env_66___r4_characters_6_6, _char_ci___1189_98___r4_characters_6_61349, _char_ci___1189_98___r4_characters_6_6, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( char___env_167___r4_characters_6_6, _char__1180_122___r4_characters_6_61350, _char__1180_122___r4_characters_6_6, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( char_lower_case__env_97___r4_characters_6_6, _char_lower_case_1194_211___r4_characters_6_61351, _char_lower_case_1194_211___r4_characters_6_6, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( integer__char_env_143___r4_characters_6_6, _integer__char1196_4___r4_characters_6_61352, _integer__char1196_4___r4_characters_6_6, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( char____env_114___r4_characters_6_6, _char___1183_186___r4_characters_6_61353, _char___1183_186___r4_characters_6_6, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( char____env_175___r4_characters_6_6, _char___1184_27___r4_characters_6_61354, _char___1184_27___r4_characters_6_6, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( char__env_119___r4_characters_6_6, _char__134___r4_characters_6_61355, _char__134___r4_characters_6_6, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( char___env_57___r4_characters_6_6, _char__1182_92___r4_characters_6_61356, _char__1182_92___r4_characters_6_6, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( char_upcase_env_199___r4_characters_6_6, _char_upcase1198_8___r4_characters_6_61357, _char_upcase1198_8___r4_characters_6_6, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( char_whitespace__env_29___r4_characters_6_6, _char_whitespace_1192_84___r4_characters_6_61358, _char_whitespace_1192_84___r4_characters_6_6, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( char_ci___env_202___r4_characters_6_6, _char_ci__1186_234___r4_characters_6_61359, _char_ci__1186_234___r4_characters_6_6, 0L, 2 );
DEFINE_STRING( string1307___r4_characters_6_6, string1307___r4_characters_6_61360, "LONG", 4 );
DEFINE_STRING( string1305___r4_characters_6_6, string1305___r4_characters_6_61361, "/home/tahoe2/serrano/tmp/bigloo/runtime/./Llib/error.scm", 56 );
DEFINE_STRING( string1304___r4_characters_6_6, string1304___r4_characters_6_61362, "integer out of range", 20 );
DEFINE_STRING( string1303___r4_characters_6_6, string1303___r4_characters_6_61363, "integer->char", 13 );
DEFINE_STRING( string1271___r4_characters_6_6, string1271___r4_characters_6_61364, "/home/tahoe2/serrano/tmp/bigloo/runtime/Ieee/char.scm", 53 );
DEFINE_STRING( string1270___r4_characters_6_6, string1270___r4_characters_6_61365, "UCHAR", 5 );
DEFINE_EXPORT_PROCEDURE( char_alphabetic__env_54___r4_characters_6_6, _char_alphabetic_1190_91___r4_characters_6_61366, _char_alphabetic_1190_91___r4_characters_6_6, 0L, 1 );



/* module-initialization */
obj_t module_initialization_70___r4_characters_6_6(long checksum_715, char * from_716)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___r4_characters_6_6))
{ 
require_initialization_114___r4_characters_6_6 = 
BBOOL(((bool_t)0)); 
cnst_init_137___r4_characters_6_6(); 
imported_modules_init_94___r4_characters_6_6(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___r4_characters_6_6()
{ AN_OBJECT;
{ /* Ieee/char.scm 14 */
symbol1267___r4_characters_6_6 = 
string_to_symbol("CHAR?"); 
symbol1268___r4_characters_6_6 = 
string_to_symbol("CHAR=?"); 
symbol1269___r4_characters_6_6 = 
string_to_symbol("_CHAR=?1180"); 
symbol1272___r4_characters_6_6 = 
string_to_symbol("CHAR<?"); 
symbol1273___r4_characters_6_6 = 
string_to_symbol("_CHAR<?1181"); 
symbol1274___r4_characters_6_6 = 
string_to_symbol("CHAR>?"); 
symbol1275___r4_characters_6_6 = 
string_to_symbol("_CHAR>?1182"); 
symbol1276___r4_characters_6_6 = 
string_to_symbol("CHAR<=?"); 
symbol1277___r4_characters_6_6 = 
string_to_symbol("_CHAR<=?1183"); 
symbol1278___r4_characters_6_6 = 
string_to_symbol("CHAR>=?"); 
symbol1279___r4_characters_6_6 = 
string_to_symbol("_CHAR>=?1184"); 
symbol1280___r4_characters_6_6 = 
string_to_symbol("CHAR-CI=?"); 
symbol1281___r4_characters_6_6 = 
string_to_symbol("_CHAR-CI=?1185"); 
symbol1282___r4_characters_6_6 = 
string_to_symbol("CHAR-CI<?"); 
symbol1283___r4_characters_6_6 = 
string_to_symbol("_CHAR-CI<?1186"); 
symbol1284___r4_characters_6_6 = 
string_to_symbol("CHAR-CI>?"); 
symbol1285___r4_characters_6_6 = 
string_to_symbol("_CHAR-CI>?1187"); 
symbol1286___r4_characters_6_6 = 
string_to_symbol("CHAR-CI<=?"); 
symbol1287___r4_characters_6_6 = 
string_to_symbol("_CHAR-CI<=?1188"); 
symbol1288___r4_characters_6_6 = 
string_to_symbol("CHAR-CI>=?"); 
symbol1289___r4_characters_6_6 = 
string_to_symbol("_CHAR-CI>=?1189"); 
symbol1290___r4_characters_6_6 = 
string_to_symbol("CHAR-ALPHABETIC?"); 
symbol1291___r4_characters_6_6 = 
string_to_symbol("_CHAR-ALPHABETIC?1190"); 
symbol1292___r4_characters_6_6 = 
string_to_symbol("CHAR-NUMERIC?"); 
symbol1293___r4_characters_6_6 = 
string_to_symbol("_CHAR-NUMERIC?1191"); 
symbol1294___r4_characters_6_6 = 
string_to_symbol("CHAR-WHITESPACE?"); 
symbol1295___r4_characters_6_6 = 
string_to_symbol("_CHAR-WHITESPACE?1192"); 
symbol1296___r4_characters_6_6 = 
string_to_symbol("CHAR-UPPER-CASE?"); 
symbol1297___r4_characters_6_6 = 
string_to_symbol("_CHAR-UPPER-CASE?1193"); 
symbol1298___r4_characters_6_6 = 
string_to_symbol("CHAR-LOWER-CASE?"); 
symbol1299___r4_characters_6_6 = 
string_to_symbol("_CHAR-LOWER-CASE?1194"); 
symbol1300___r4_characters_6_6 = 
string_to_symbol("CHAR->INTEGER"); 
symbol1301___r4_characters_6_6 = 
string_to_symbol("_CHAR->INTEGER1195"); 
symbol1302___r4_characters_6_6 = 
string_to_symbol("INTEGER->CHAR"); 
symbol1306___r4_characters_6_6 = 
string_to_symbol("_INTEGER->CHAR1196"); 
symbol1308___r4_characters_6_6 = 
string_to_symbol("INTEGER->CHAR-UR"); 
symbol1309___r4_characters_6_6 = 
string_to_symbol("_INTEGER->CHAR-UR1197"); 
symbol1310___r4_characters_6_6 = 
string_to_symbol("CHAR-UPCASE"); 
symbol1311___r4_characters_6_6 = 
string_to_symbol("_CHAR-UPCASE1198"); 
symbol1312___r4_characters_6_6 = 
string_to_symbol("CHAR-DOWNCASE"); 
symbol1313___r4_characters_6_6 = 
string_to_symbol("_CHAR-DOWNCASE1199"); 
symbol1314___r4_characters_6_6 = 
string_to_symbol("CHAR-OR"); 
symbol1315___r4_characters_6_6 = 
string_to_symbol("_CHAR-OR1200"); 
return ( 
symbol1316___r4_characters_6_6 = 
string_to_symbol("IMPORTED-MODULES-INIT"), BUNSPEC) ;} 
}



/* char? */
bool_t char__59___r4_characters_6_6(obj_t obj_1)
{ AN_OBJECT;
{ /* Ieee/char.scm 103 */
{ /* Ieee/char.scm 104 */
obj_t symbol1135_570;
symbol1135_570 = symbol1267___r4_characters_6_6; 
{ /* Ieee/char.scm 104 */

PUSH_TRACE(symbol1135_570); BUNSPEC; 
{ /* Ieee/char.scm 104 */
bool_t aux1134_571;
aux1134_571 = 
CHARP(obj_1); 
POP_TRACE(); 
return aux1134_571;} } } } 
}



/* _char? */
obj_t _char__134___r4_characters_6_6(obj_t env_449, obj_t obj_450)
{ AN_OBJECT;
{ /* Ieee/char.scm 103 */
{ /* Ieee/char.scm 103 */
bool_t aux_769;
{ /* Ieee/char.scm 103 */
bool_t res1317_575;
{ /* Ieee/char.scm 103 */
obj_t obj_572;
obj_572 = obj_450; 
{ /* Ieee/char.scm 104 */
obj_t symbol1135_573;
symbol1135_573 = symbol1267___r4_characters_6_6; 
{ /* Ieee/char.scm 104 */

PUSH_TRACE(symbol1135_573); BUNSPEC; 
{ /* Ieee/char.scm 104 */
bool_t aux1134_574;
aux1134_574 = 
CHARP(obj_572); 
POP_TRACE(); 
res1317_575 = aux1134_574; } } } } 
aux_769 = res1317_575; } 
return 
BBOOL(aux_769);} } 
}



/* char=? */
bool_t char___215___r4_characters_6_6(unsigned char char1_2, unsigned char char2_3)
{ AN_OBJECT;
{ /* Ieee/char.scm 109 */
{ /* Ieee/char.scm 110 */
obj_t symbol1137_576;
symbol1137_576 = symbol1268___r4_characters_6_6; 
{ /* Ieee/char.scm 110 */

PUSH_TRACE(symbol1137_576); BUNSPEC; 
{ /* Ieee/char.scm 110 */
bool_t aux1136_577;
aux1136_577 = 
(char1_2==char2_3); 
POP_TRACE(); 
return aux1136_577;} } } } 
}



/* _char=?1180 */
obj_t _char__1180_122___r4_characters_6_6(obj_t env_451, obj_t char1_452, obj_t char2_453)
{ AN_OBJECT;
{ /* Ieee/char.scm 109 */
{ /* Ieee/char.scm 109 */
bool_t aux_777;
{ /* Ieee/char.scm 109 */
bool_t res1318_582;
{ /* Ieee/char.scm 109 */
unsigned char char1_578;unsigned char char2_579;
{ /* Ieee/char.scm 109 */
obj_t aux_778;
if(
CHARP(char1_452))
{ /* Ieee/char.scm 109 */
aux_778 = char1_452
; }  else 
{ /* Ieee/char.scm 109 */
bigloo_type_error_location_103___error(symbol1269___r4_characters_6_6, string1270___r4_characters_6_6, char1_452, string1271___r4_characters_6_6, 
BINT(((long)5057))); 
exit( -1 );} 
char1_578 = 
(unsigned char)CCHAR(aux_778); } 
{ /* Ieee/char.scm 109 */
obj_t aux_785;
if(
CHARP(char2_453))
{ /* Ieee/char.scm 109 */
aux_785 = char2_453
; }  else 
{ /* Ieee/char.scm 109 */
bigloo_type_error_location_103___error(symbol1269___r4_characters_6_6, string1270___r4_characters_6_6, char2_453, string1271___r4_characters_6_6, 
BINT(((long)5057))); 
exit( -1 );} 
char2_579 = 
(unsigned char)CCHAR(aux_785); } 
{ /* Ieee/char.scm 110 */
obj_t symbol1137_580;
symbol1137_580 = symbol1268___r4_characters_6_6; 
{ /* Ieee/char.scm 110 */

PUSH_TRACE(symbol1137_580); BUNSPEC; 
{ /* Ieee/char.scm 110 */
bool_t aux1136_581;
aux1136_581 = 
(char1_578==char2_579); 
POP_TRACE(); 
res1318_582 = aux1136_581; } } } } 
aux_777 = res1318_582; } 
return 
BBOOL(aux_777);} } 
}



/* char<? */
bool_t char___13___r4_characters_6_6(unsigned char char1_4, unsigned char char2_5)
{ AN_OBJECT;
{ /* Ieee/char.scm 115 */
{ /* Ieee/char.scm 116 */
obj_t symbol1139_583;
symbol1139_583 = symbol1272___r4_characters_6_6; 
{ /* Ieee/char.scm 116 */

PUSH_TRACE(symbol1139_583); BUNSPEC; 
{ /* Ieee/char.scm 116 */
bool_t aux1138_584;
aux1138_584 = 
(char1_4<char2_5); 
POP_TRACE(); 
return aux1138_584;} } } } 
}



/* _char<?1181 */
obj_t _char__1181_59___r4_characters_6_6(obj_t env_454, obj_t char1_455, obj_t char2_456)
{ AN_OBJECT;
{ /* Ieee/char.scm 115 */
{ /* Ieee/char.scm 115 */
bool_t aux_799;
{ /* Ieee/char.scm 115 */
bool_t res1319_589;
{ /* Ieee/char.scm 115 */
unsigned char char1_585;unsigned char char2_586;
{ /* Ieee/char.scm 115 */
obj_t aux_800;
if(
CHARP(char1_455))
{ /* Ieee/char.scm 115 */
aux_800 = char1_455
; }  else 
{ /* Ieee/char.scm 115 */
bigloo_type_error_location_103___error(symbol1273___r4_characters_6_6, string1270___r4_characters_6_6, char1_455, string1271___r4_characters_6_6, 
BINT(((long)5343))); 
exit( -1 );} 
char1_585 = 
(unsigned char)CCHAR(aux_800); } 
{ /* Ieee/char.scm 115 */
obj_t aux_807;
if(
CHARP(char2_456))
{ /* Ieee/char.scm 115 */
aux_807 = char2_456
; }  else 
{ /* Ieee/char.scm 115 */
bigloo_type_error_location_103___error(symbol1273___r4_characters_6_6, string1270___r4_characters_6_6, char2_456, string1271___r4_characters_6_6, 
BINT(((long)5343))); 
exit( -1 );} 
char2_586 = 
(unsigned char)CCHAR(aux_807); } 
{ /* Ieee/char.scm 116 */
obj_t symbol1139_587;
symbol1139_587 = symbol1272___r4_characters_6_6; 
{ /* Ieee/char.scm 116 */

PUSH_TRACE(symbol1139_587); BUNSPEC; 
{ /* Ieee/char.scm 116 */
bool_t aux1138_588;
aux1138_588 = 
(char1_585<char2_586); 
POP_TRACE(); 
res1319_589 = aux1138_588; } } } } 
aux_799 = res1319_589; } 
return 
BBOOL(aux_799);} } 
}



/* char>? */
bool_t char___195___r4_characters_6_6(unsigned char char1_6, unsigned char char2_7)
{ AN_OBJECT;
{ /* Ieee/char.scm 121 */
{ /* Ieee/char.scm 122 */
obj_t symbol1141_590;
symbol1141_590 = symbol1274___r4_characters_6_6; 
{ /* Ieee/char.scm 122 */

PUSH_TRACE(symbol1141_590); BUNSPEC; 
{ /* Ieee/char.scm 122 */
bool_t aux1140_591;
aux1140_591 = 
(char1_6>char2_7); 
POP_TRACE(); 
return aux1140_591;} } } } 
}



/* _char>?1182 */
obj_t _char__1182_92___r4_characters_6_6(obj_t env_457, obj_t char1_458, obj_t char2_459)
{ AN_OBJECT;
{ /* Ieee/char.scm 121 */
{ /* Ieee/char.scm 121 */
bool_t aux_821;
{ /* Ieee/char.scm 121 */
bool_t res1320_596;
{ /* Ieee/char.scm 121 */
unsigned char char1_592;unsigned char char2_593;
{ /* Ieee/char.scm 121 */
obj_t aux_822;
if(
CHARP(char1_458))
{ /* Ieee/char.scm 121 */
aux_822 = char1_458
; }  else 
{ /* Ieee/char.scm 121 */
bigloo_type_error_location_103___error(symbol1275___r4_characters_6_6, string1270___r4_characters_6_6, char1_458, string1271___r4_characters_6_6, 
BINT(((long)5629))); 
exit( -1 );} 
char1_592 = 
(unsigned char)CCHAR(aux_822); } 
{ /* Ieee/char.scm 121 */
obj_t aux_829;
if(
CHARP(char2_459))
{ /* Ieee/char.scm 121 */
aux_829 = char2_459
; }  else 
{ /* Ieee/char.scm 121 */
bigloo_type_error_location_103___error(symbol1275___r4_characters_6_6, string1270___r4_characters_6_6, char2_459, string1271___r4_characters_6_6, 
BINT(((long)5629))); 
exit( -1 );} 
char2_593 = 
(unsigned char)CCHAR(aux_829); } 
{ /* Ieee/char.scm 122 */
obj_t symbol1141_594;
symbol1141_594 = symbol1274___r4_characters_6_6; 
{ /* Ieee/char.scm 122 */

PUSH_TRACE(symbol1141_594); BUNSPEC; 
{ /* Ieee/char.scm 122 */
bool_t aux1140_595;
aux1140_595 = 
(char1_592>char2_593); 
POP_TRACE(); 
res1320_596 = aux1140_595; } } } } 
aux_821 = res1320_596; } 
return 
BBOOL(aux_821);} } 
}



/* char<=? */
bool_t char____152___r4_characters_6_6(unsigned char char1_8, unsigned char char2_9)
{ AN_OBJECT;
{ /* Ieee/char.scm 127 */
{ /* Ieee/char.scm 128 */
obj_t symbol1143_597;
symbol1143_597 = symbol1276___r4_characters_6_6; 
{ /* Ieee/char.scm 128 */

PUSH_TRACE(symbol1143_597); BUNSPEC; 
{ /* Ieee/char.scm 128 */
bool_t aux1142_598;
aux1142_598 = 
(char1_8<=char2_9); 
POP_TRACE(); 
return aux1142_598;} } } } 
}



/* _char<=?1183 */
obj_t _char___1183_186___r4_characters_6_6(obj_t env_460, obj_t char1_461, obj_t char2_462)
{ AN_OBJECT;
{ /* Ieee/char.scm 127 */
{ /* Ieee/char.scm 127 */
bool_t aux_843;
{ /* Ieee/char.scm 127 */
bool_t res1321_603;
{ /* Ieee/char.scm 127 */
unsigned char char1_599;unsigned char char2_600;
{ /* Ieee/char.scm 127 */
obj_t aux_844;
if(
CHARP(char1_461))
{ /* Ieee/char.scm 127 */
aux_844 = char1_461
; }  else 
{ /* Ieee/char.scm 127 */
bigloo_type_error_location_103___error(symbol1277___r4_characters_6_6, string1270___r4_characters_6_6, char1_461, string1271___r4_characters_6_6, 
BINT(((long)5916))); 
exit( -1 );} 
char1_599 = 
(unsigned char)CCHAR(aux_844); } 
{ /* Ieee/char.scm 127 */
obj_t aux_851;
if(
CHARP(char2_462))
{ /* Ieee/char.scm 127 */
aux_851 = char2_462
; }  else 
{ /* Ieee/char.scm 127 */
bigloo_type_error_location_103___error(symbol1277___r4_characters_6_6, string1270___r4_characters_6_6, char2_462, string1271___r4_characters_6_6, 
BINT(((long)5916))); 
exit( -1 );} 
char2_600 = 
(unsigned char)CCHAR(aux_851); } 
{ /* Ieee/char.scm 128 */
obj_t symbol1143_601;
symbol1143_601 = symbol1276___r4_characters_6_6; 
{ /* Ieee/char.scm 128 */

PUSH_TRACE(symbol1143_601); BUNSPEC; 
{ /* Ieee/char.scm 128 */
bool_t aux1142_602;
aux1142_602 = 
(char1_599<=char2_600); 
POP_TRACE(); 
res1321_603 = aux1142_602; } } } } 
aux_843 = res1321_603; } 
return 
BBOOL(aux_843);} } 
}



/* char>=? */
bool_t char____252___r4_characters_6_6(unsigned char char1_10, unsigned char char2_11)
{ AN_OBJECT;
{ /* Ieee/char.scm 133 */
{ /* Ieee/char.scm 134 */
obj_t symbol1145_604;
symbol1145_604 = symbol1278___r4_characters_6_6; 
{ /* Ieee/char.scm 134 */

PUSH_TRACE(symbol1145_604); BUNSPEC; 
{ /* Ieee/char.scm 134 */
bool_t aux1144_605;
aux1144_605 = 
(char1_10>=char2_11); 
POP_TRACE(); 
return aux1144_605;} } } } 
}



/* _char>=?1184 */
obj_t _char___1184_27___r4_characters_6_6(obj_t env_463, obj_t char1_464, obj_t char2_465)
{ AN_OBJECT;
{ /* Ieee/char.scm 133 */
{ /* Ieee/char.scm 133 */
bool_t aux_865;
{ /* Ieee/char.scm 133 */
bool_t res1322_610;
{ /* Ieee/char.scm 133 */
unsigned char char1_606;unsigned char char2_607;
{ /* Ieee/char.scm 133 */
obj_t aux_866;
if(
CHARP(char1_464))
{ /* Ieee/char.scm 133 */
aux_866 = char1_464
; }  else 
{ /* Ieee/char.scm 133 */
bigloo_type_error_location_103___error(symbol1279___r4_characters_6_6, string1270___r4_characters_6_6, char1_464, string1271___r4_characters_6_6, 
BINT(((long)6204))); 
exit( -1 );} 
char1_606 = 
(unsigned char)CCHAR(aux_866); } 
{ /* Ieee/char.scm 133 */
obj_t aux_873;
if(
CHARP(char2_465))
{ /* Ieee/char.scm 133 */
aux_873 = char2_465
; }  else 
{ /* Ieee/char.scm 133 */
bigloo_type_error_location_103___error(symbol1279___r4_characters_6_6, string1270___r4_characters_6_6, char2_465, string1271___r4_characters_6_6, 
BINT(((long)6204))); 
exit( -1 );} 
char2_607 = 
(unsigned char)CCHAR(aux_873); } 
{ /* Ieee/char.scm 134 */
obj_t symbol1145_608;
symbol1145_608 = symbol1278___r4_characters_6_6; 
{ /* Ieee/char.scm 134 */

PUSH_TRACE(symbol1145_608); BUNSPEC; 
{ /* Ieee/char.scm 134 */
bool_t aux1144_609;
aux1144_609 = 
(char1_606>=char2_607); 
POP_TRACE(); 
res1322_610 = aux1144_609; } } } } 
aux_865 = res1322_610; } 
return 
BBOOL(aux_865);} } 
}



/* char-ci=? */
bool_t char_ci___242___r4_characters_6_6(unsigned char char1_12, unsigned char char2_13)
{ AN_OBJECT;
{ /* Ieee/char.scm 139 */
{ /* Ieee/char.scm 140 */
obj_t symbol1147_611;
symbol1147_611 = symbol1280___r4_characters_6_6; 
{ /* Ieee/char.scm 140 */

PUSH_TRACE(symbol1147_611); BUNSPEC; 
{ /* Ieee/char.scm 140 */
bool_t aux1146_612;
{ /* Ieee/char.scm 110 */
unsigned char aux_887;unsigned char aux_885;
aux_887 = 
toupper(char2_13); 
aux_885 = 
toupper(char1_12); 
aux1146_612 = 
(aux_885==aux_887); } 
POP_TRACE(); 
return aux1146_612;} } } } 
}



/* _char-ci=?1185 */
obj_t _char_ci__1185_39___r4_characters_6_6(obj_t env_466, obj_t char1_467, obj_t char2_468)
{ AN_OBJECT;
{ /* Ieee/char.scm 139 */
{ /* Ieee/char.scm 139 */
bool_t aux_891;
{ /* Ieee/char.scm 139 */
bool_t res1323_617;
{ /* Ieee/char.scm 139 */
unsigned char char1_613;unsigned char char2_614;
{ /* Ieee/char.scm 139 */
obj_t aux_892;
if(
CHARP(char1_467))
{ /* Ieee/char.scm 139 */
aux_892 = char1_467
; }  else 
{ /* Ieee/char.scm 139 */
bigloo_type_error_location_103___error(symbol1281___r4_characters_6_6, string1270___r4_characters_6_6, char1_467, string1271___r4_characters_6_6, 
BINT(((long)6492))); 
exit( -1 );} 
char1_613 = 
(unsigned char)CCHAR(aux_892); } 
{ /* Ieee/char.scm 139 */
obj_t aux_899;
if(
CHARP(char2_468))
{ /* Ieee/char.scm 139 */
aux_899 = char2_468
; }  else 
{ /* Ieee/char.scm 139 */
bigloo_type_error_location_103___error(symbol1281___r4_characters_6_6, string1270___r4_characters_6_6, char2_468, string1271___r4_characters_6_6, 
BINT(((long)6492))); 
exit( -1 );} 
char2_614 = 
(unsigned char)CCHAR(aux_899); } 
{ /* Ieee/char.scm 140 */
obj_t symbol1147_615;
symbol1147_615 = symbol1280___r4_characters_6_6; 
{ /* Ieee/char.scm 140 */

PUSH_TRACE(symbol1147_615); BUNSPEC; 
{ /* Ieee/char.scm 140 */
bool_t aux1146_616;
{ /* Ieee/char.scm 110 */
unsigned char aux_909;unsigned char aux_907;
aux_909 = 
toupper(char2_614); 
aux_907 = 
toupper(char1_613); 
aux1146_616 = 
(aux_907==aux_909); } 
POP_TRACE(); 
res1323_617 = aux1146_616; } } } } 
aux_891 = res1323_617; } 
return 
BBOOL(aux_891);} } 
}



/* char-ci<? */
bool_t char_ci___112___r4_characters_6_6(unsigned char char1_14, unsigned char char2_15)
{ AN_OBJECT;
{ /* Ieee/char.scm 145 */
{ /* Ieee/char.scm 146 */
obj_t symbol1149_618;
symbol1149_618 = symbol1282___r4_characters_6_6; 
{ /* Ieee/char.scm 146 */

PUSH_TRACE(symbol1149_618); BUNSPEC; 
{ /* Ieee/char.scm 146 */
bool_t aux1148_619;
{ /* Ieee/char.scm 146 */
unsigned char aux_917;unsigned char aux_915;
aux_917 = 
toupper(char2_15); 
aux_915 = 
toupper(char1_14); 
aux1148_619 = 
(aux_915<aux_917); } 
POP_TRACE(); 
return aux1148_619;} } } } 
}



/* _char-ci<?1186 */
obj_t _char_ci__1186_234___r4_characters_6_6(obj_t env_469, obj_t char1_470, obj_t char2_471)
{ AN_OBJECT;
{ /* Ieee/char.scm 145 */
{ /* Ieee/char.scm 145 */
bool_t aux_921;
{ /* Ieee/char.scm 145 */
bool_t res1324_624;
{ /* Ieee/char.scm 145 */
unsigned char char1_620;unsigned char char2_621;
{ /* Ieee/char.scm 145 */
obj_t aux_922;
if(
CHARP(char1_470))
{ /* Ieee/char.scm 145 */
aux_922 = char1_470
; }  else 
{ /* Ieee/char.scm 145 */
bigloo_type_error_location_103___error(symbol1283___r4_characters_6_6, string1270___r4_characters_6_6, char1_470, string1271___r4_characters_6_6, 
BINT(((long)6807))); 
exit( -1 );} 
char1_620 = 
(unsigned char)CCHAR(aux_922); } 
{ /* Ieee/char.scm 145 */
obj_t aux_929;
if(
CHARP(char2_471))
{ /* Ieee/char.scm 145 */
aux_929 = char2_471
; }  else 
{ /* Ieee/char.scm 145 */
bigloo_type_error_location_103___error(symbol1283___r4_characters_6_6, string1270___r4_characters_6_6, char2_471, string1271___r4_characters_6_6, 
BINT(((long)6807))); 
exit( -1 );} 
char2_621 = 
(unsigned char)CCHAR(aux_929); } 
{ /* Ieee/char.scm 146 */
obj_t symbol1149_622;
symbol1149_622 = symbol1282___r4_characters_6_6; 
{ /* Ieee/char.scm 146 */

PUSH_TRACE(symbol1149_622); BUNSPEC; 
{ /* Ieee/char.scm 146 */
bool_t aux1148_623;
{ /* Ieee/char.scm 146 */
unsigned char aux_939;unsigned char aux_937;
aux_939 = 
toupper(char2_621); 
aux_937 = 
toupper(char1_620); 
aux1148_623 = 
(aux_937<aux_939); } 
POP_TRACE(); 
res1324_624 = aux1148_623; } } } } 
aux_921 = res1324_624; } 
return 
BBOOL(aux_921);} } 
}



/* char-ci>? */
bool_t char_ci___21___r4_characters_6_6(unsigned char char1_16, unsigned char char2_17)
{ AN_OBJECT;
{ /* Ieee/char.scm 151 */
{ /* Ieee/char.scm 152 */
obj_t symbol1151_625;
symbol1151_625 = symbol1284___r4_characters_6_6; 
{ /* Ieee/char.scm 152 */

PUSH_TRACE(symbol1151_625); BUNSPEC; 
{ /* Ieee/char.scm 152 */
bool_t aux1150_626;
{ /* Ieee/char.scm 152 */
unsigned char aux_947;unsigned char aux_945;
aux_947 = 
toupper(char2_17); 
aux_945 = 
toupper(char1_16); 
aux1150_626 = 
(aux_945>aux_947); } 
POP_TRACE(); 
return aux1150_626;} } } } 
}



/* _char-ci>?1187 */
obj_t _char_ci__1187_201___r4_characters_6_6(obj_t env_472, obj_t char1_473, obj_t char2_474)
{ AN_OBJECT;
{ /* Ieee/char.scm 151 */
{ /* Ieee/char.scm 151 */
bool_t aux_951;
{ /* Ieee/char.scm 151 */
bool_t res1325_631;
{ /* Ieee/char.scm 151 */
unsigned char char1_627;unsigned char char2_628;
{ /* Ieee/char.scm 151 */
obj_t aux_952;
if(
CHARP(char1_473))
{ /* Ieee/char.scm 151 */
aux_952 = char1_473
; }  else 
{ /* Ieee/char.scm 151 */
bigloo_type_error_location_103___error(symbol1285___r4_characters_6_6, string1270___r4_characters_6_6, char1_473, string1271___r4_characters_6_6, 
BINT(((long)7125))); 
exit( -1 );} 
char1_627 = 
(unsigned char)CCHAR(aux_952); } 
{ /* Ieee/char.scm 151 */
obj_t aux_959;
if(
CHARP(char2_474))
{ /* Ieee/char.scm 151 */
aux_959 = char2_474
; }  else 
{ /* Ieee/char.scm 151 */
bigloo_type_error_location_103___error(symbol1285___r4_characters_6_6, string1270___r4_characters_6_6, char2_474, string1271___r4_characters_6_6, 
BINT(((long)7125))); 
exit( -1 );} 
char2_628 = 
(unsigned char)CCHAR(aux_959); } 
{ /* Ieee/char.scm 152 */
obj_t symbol1151_629;
symbol1151_629 = symbol1284___r4_characters_6_6; 
{ /* Ieee/char.scm 152 */

PUSH_TRACE(symbol1151_629); BUNSPEC; 
{ /* Ieee/char.scm 152 */
bool_t aux1150_630;
{ /* Ieee/char.scm 152 */
unsigned char aux_969;unsigned char aux_967;
aux_969 = 
toupper(char2_628); 
aux_967 = 
toupper(char1_627); 
aux1150_630 = 
(aux_967>aux_969); } 
POP_TRACE(); 
res1325_631 = aux1150_630; } } } } 
aux_951 = res1325_631; } 
return 
BBOOL(aux_951);} } 
}



/* char-ci<=? */
bool_t char_ci____192___r4_characters_6_6(unsigned char char1_18, unsigned char char2_19)
{ AN_OBJECT;
{ /* Ieee/char.scm 157 */
{ /* Ieee/char.scm 158 */
obj_t symbol1153_632;
symbol1153_632 = symbol1286___r4_characters_6_6; 
{ /* Ieee/char.scm 158 */

PUSH_TRACE(symbol1153_632); BUNSPEC; 
{ /* Ieee/char.scm 158 */
bool_t aux1152_633;
{ /* Ieee/char.scm 158 */
unsigned char aux_977;unsigned char aux_975;
aux_977 = 
toupper(char2_19); 
aux_975 = 
toupper(char1_18); 
aux1152_633 = 
(aux_975<=aux_977); } 
POP_TRACE(); 
return aux1152_633;} } } } 
}



/* _char-ci<=?1188 */
obj_t _char_ci___1188_94___r4_characters_6_6(obj_t env_475, obj_t char1_476, obj_t char2_477)
{ AN_OBJECT;
{ /* Ieee/char.scm 157 */
{ /* Ieee/char.scm 157 */
bool_t aux_981;
{ /* Ieee/char.scm 157 */
bool_t res1326_638;
{ /* Ieee/char.scm 157 */
unsigned char char1_634;unsigned char char2_635;
{ /* Ieee/char.scm 157 */
obj_t aux_982;
if(
CHARP(char1_476))
{ /* Ieee/char.scm 157 */
aux_982 = char1_476
; }  else 
{ /* Ieee/char.scm 157 */
bigloo_type_error_location_103___error(symbol1287___r4_characters_6_6, string1270___r4_characters_6_6, char1_476, string1271___r4_characters_6_6, 
BINT(((long)7443))); 
exit( -1 );} 
char1_634 = 
(unsigned char)CCHAR(aux_982); } 
{ /* Ieee/char.scm 157 */
obj_t aux_989;
if(
CHARP(char2_477))
{ /* Ieee/char.scm 157 */
aux_989 = char2_477
; }  else 
{ /* Ieee/char.scm 157 */
bigloo_type_error_location_103___error(symbol1287___r4_characters_6_6, string1270___r4_characters_6_6, char2_477, string1271___r4_characters_6_6, 
BINT(((long)7443))); 
exit( -1 );} 
char2_635 = 
(unsigned char)CCHAR(aux_989); } 
{ /* Ieee/char.scm 158 */
obj_t symbol1153_636;
symbol1153_636 = symbol1286___r4_characters_6_6; 
{ /* Ieee/char.scm 158 */

PUSH_TRACE(symbol1153_636); BUNSPEC; 
{ /* Ieee/char.scm 158 */
bool_t aux1152_637;
{ /* Ieee/char.scm 158 */
unsigned char aux_999;unsigned char aux_997;
aux_999 = 
toupper(char2_635); 
aux_997 = 
toupper(char1_634); 
aux1152_637 = 
(aux_997<=aux_999); } 
POP_TRACE(); 
res1326_638 = aux1152_637; } } } } 
aux_981 = res1326_638; } 
return 
BBOOL(aux_981);} } 
}



/* char-ci>=? */
bool_t char_ci____41___r4_characters_6_6(unsigned char char1_20, unsigned char char2_21)
{ AN_OBJECT;
{ /* Ieee/char.scm 163 */
{ /* Ieee/char.scm 164 */
obj_t symbol1155_639;
symbol1155_639 = symbol1288___r4_characters_6_6; 
{ /* Ieee/char.scm 164 */

PUSH_TRACE(symbol1155_639); BUNSPEC; 
{ /* Ieee/char.scm 164 */
bool_t aux1154_640;
{ /* Ieee/char.scm 164 */
unsigned char aux_1007;unsigned char aux_1005;
aux_1007 = 
toupper(char2_21); 
aux_1005 = 
toupper(char1_20); 
aux1154_640 = 
(aux_1005>=aux_1007); } 
POP_TRACE(); 
return aux1154_640;} } } } 
}



/* _char-ci>=?1189 */
obj_t _char_ci___1189_98___r4_characters_6_6(obj_t env_478, obj_t char1_479, obj_t char2_480)
{ AN_OBJECT;
{ /* Ieee/char.scm 163 */
{ /* Ieee/char.scm 163 */
bool_t aux_1011;
{ /* Ieee/char.scm 163 */
bool_t res1327_645;
{ /* Ieee/char.scm 163 */
unsigned char char1_641;unsigned char char2_642;
{ /* Ieee/char.scm 163 */
obj_t aux_1012;
if(
CHARP(char1_479))
{ /* Ieee/char.scm 163 */
aux_1012 = char1_479
; }  else 
{ /* Ieee/char.scm 163 */
bigloo_type_error_location_103___error(symbol1289___r4_characters_6_6, string1270___r4_characters_6_6, char1_479, string1271___r4_characters_6_6, 
BINT(((long)7762))); 
exit( -1 );} 
char1_641 = 
(unsigned char)CCHAR(aux_1012); } 
{ /* Ieee/char.scm 163 */
obj_t aux_1019;
if(
CHARP(char2_480))
{ /* Ieee/char.scm 163 */
aux_1019 = char2_480
; }  else 
{ /* Ieee/char.scm 163 */
bigloo_type_error_location_103___error(symbol1289___r4_characters_6_6, string1270___r4_characters_6_6, char2_480, string1271___r4_characters_6_6, 
BINT(((long)7762))); 
exit( -1 );} 
char2_642 = 
(unsigned char)CCHAR(aux_1019); } 
{ /* Ieee/char.scm 164 */
obj_t symbol1155_643;
symbol1155_643 = symbol1288___r4_characters_6_6; 
{ /* Ieee/char.scm 164 */

PUSH_TRACE(symbol1155_643); BUNSPEC; 
{ /* Ieee/char.scm 164 */
bool_t aux1154_644;
{ /* Ieee/char.scm 164 */
unsigned char aux_1029;unsigned char aux_1027;
aux_1029 = 
toupper(char2_642); 
aux_1027 = 
toupper(char1_641); 
aux1154_644 = 
(aux_1027>=aux_1029); } 
POP_TRACE(); 
res1327_645 = aux1154_644; } } } } 
aux_1011 = res1327_645; } 
return 
BBOOL(aux_1011);} } 
}



/* char-alphabetic? */
bool_t char_alphabetic__208___r4_characters_6_6(unsigned char char_22)
{ AN_OBJECT;
{ /* Ieee/char.scm 169 */
{ /* Ieee/char.scm 170 */
obj_t symbol1157_646;
symbol1157_646 = symbol1290___r4_characters_6_6; 
{ /* Ieee/char.scm 170 */

PUSH_TRACE(symbol1157_646); BUNSPEC; 
{ /* Ieee/char.scm 170 */
bool_t aux1156_647;
{ /* Ieee/char.scm 170 */
unsigned char c_648;
c_648 = 
toupper(char_22); 
if(
(c_648>=((unsigned char)'A')))
{ /* Ieee/char.scm 171 */
aux1156_647 = 
(c_648<=((unsigned char)'Z')); }  else 
{ /* Ieee/char.scm 171 */
aux1156_647 = ((bool_t)0); } } 
POP_TRACE(); 
return aux1156_647;} } } } 
}



/* _char-alphabetic?1190 */
obj_t _char_alphabetic_1190_91___r4_characters_6_6(obj_t env_481, obj_t char_482)
{ AN_OBJECT;
{ /* Ieee/char.scm 169 */
{ /* Ieee/char.scm 169 */
bool_t aux_1040;
{ /* Ieee/char.scm 169 */
bool_t res1328_653;
{ /* Ieee/char.scm 169 */
unsigned char char_166_649;
{ /* Ieee/char.scm 169 */
obj_t aux_1041;
if(
CHARP(char_482))
{ /* Ieee/char.scm 169 */
aux_1041 = char_482
; }  else 
{ /* Ieee/char.scm 169 */
bigloo_type_error_location_103___error(symbol1291___r4_characters_6_6, string1270___r4_characters_6_6, char_482, string1271___r4_characters_6_6, 
BINT(((long)8081))); 
exit( -1 );} 
char_166_649 = 
(unsigned char)CCHAR(aux_1041); } 
{ /* Ieee/char.scm 170 */
obj_t symbol1157_650;
symbol1157_650 = symbol1290___r4_characters_6_6; 
{ /* Ieee/char.scm 170 */

PUSH_TRACE(symbol1157_650); BUNSPEC; 
{ /* Ieee/char.scm 170 */
bool_t aux1156_651;
{ /* Ieee/char.scm 170 */
unsigned char c_652;
c_652 = 
toupper(char_166_649); 
if(
(c_652>=((unsigned char)'A')))
{ /* Ieee/char.scm 171 */
aux1156_651 = 
(c_652<=((unsigned char)'Z')); }  else 
{ /* Ieee/char.scm 171 */
aux1156_651 = ((bool_t)0); } } 
POP_TRACE(); 
res1328_653 = aux1156_651; } } } } 
aux_1040 = res1328_653; } 
return 
BBOOL(aux_1040);} } 
}



/* char-numeric? */
bool_t char_numeric__32___r4_characters_6_6(unsigned char char_23)
{ AN_OBJECT;
{ /* Ieee/char.scm 178 */
{ /* Ieee/char.scm 179 */
obj_t symbol1159_654;
symbol1159_654 = symbol1292___r4_characters_6_6; 
{ /* Ieee/char.scm 179 */

PUSH_TRACE(symbol1159_654); BUNSPEC; 
{ /* Ieee/char.scm 179 */
bool_t aux1158_655;
if(
(char_23>=((unsigned char)'0')))
{ /* Ieee/char.scm 179 */
aux1158_655 = 
(char_23<=((unsigned char)'9')); }  else 
{ /* Ieee/char.scm 179 */
aux1158_655 = ((bool_t)0); } 
POP_TRACE(); 
return aux1158_655;} } } } 
}



/* _char-numeric?1191 */
obj_t _char_numeric_1191_68___r4_characters_6_6(obj_t env_483, obj_t char_484)
{ AN_OBJECT;
{ /* Ieee/char.scm 178 */
{ /* Ieee/char.scm 178 */
bool_t aux_1060;
{ /* Ieee/char.scm 178 */
bool_t res1329_659;
{ /* Ieee/char.scm 178 */
unsigned char char_166_656;
{ /* Ieee/char.scm 178 */
obj_t aux_1061;
if(
CHARP(char_484))
{ /* Ieee/char.scm 178 */
aux_1061 = char_484
; }  else 
{ /* Ieee/char.scm 178 */
bigloo_type_error_location_103___error(symbol1293___r4_characters_6_6, string1270___r4_characters_6_6, char_484, string1271___r4_characters_6_6, 
BINT(((long)8430))); 
exit( -1 );} 
char_166_656 = 
(unsigned char)CCHAR(aux_1061); } 
{ /* Ieee/char.scm 179 */
obj_t symbol1159_657;
symbol1159_657 = symbol1292___r4_characters_6_6; 
{ /* Ieee/char.scm 179 */

PUSH_TRACE(symbol1159_657); BUNSPEC; 
{ /* Ieee/char.scm 179 */
bool_t aux1158_658;
if(
(char_166_656>=((unsigned char)'0')))
{ /* Ieee/char.scm 179 */
aux1158_658 = 
(char_166_656<=((unsigned char)'9')); }  else 
{ /* Ieee/char.scm 179 */
aux1158_658 = ((bool_t)0); } 
POP_TRACE(); 
res1329_659 = aux1158_658; } } } } 
aux_1060 = res1329_659; } 
return 
BBOOL(aux_1060);} } 
}



/* char-whitespace? */
bool_t char_whitespace__92___r4_characters_6_6(unsigned char char_24)
{ AN_OBJECT;
{ /* Ieee/char.scm 186 */
{ /* Ieee/char.scm 187 */
obj_t symbol1161_660;
symbol1161_660 = symbol1294___r4_characters_6_6; 
{ /* Ieee/char.scm 187 */

PUSH_TRACE(symbol1161_660); BUNSPEC; 
{ /* Ieee/char.scm 187 */
bool_t aux1160_661;
{ /* Ieee/char.scm 187 */
bool_t _ortest_1002_662;
_ortest_1002_662 = 
(char_24==((unsigned char)' ')); 
if(_ortest_1002_662)
{ /* Ieee/char.scm 187 */
aux1160_661 = _ortest_1002_662; }  else 
{ /* Ieee/char.scm 188 */
bool_t _ortest_1003_663;
_ortest_1003_663 = 
(char_24==((unsigned char)'\t')); 
if(_ortest_1003_663)
{ /* Ieee/char.scm 188 */
aux1160_661 = _ortest_1003_663; }  else 
{ /* Ieee/char.scm 189 */
bool_t _ortest_1004_664;
_ortest_1004_664 = 
(char_24==((unsigned char)'\r')); 
if(_ortest_1004_664)
{ /* Ieee/char.scm 189 */
aux1160_661 = _ortest_1004_664; }  else 
{ /* Ieee/char.scm 189 */
aux1160_661 = 
(char_24==((unsigned char)'\n')); } } } } 
POP_TRACE(); 
return aux1160_661;} } } } 
}



/* _char-whitespace?1192 */
obj_t _char_whitespace_1192_84___r4_characters_6_6(obj_t env_485, obj_t char_486)
{ AN_OBJECT;
{ /* Ieee/char.scm 186 */
{ /* Ieee/char.scm 186 */
bool_t aux_1083;
{ /* Ieee/char.scm 186 */
bool_t res1330_671;
{ /* Ieee/char.scm 186 */
unsigned char char_166_665;
{ /* Ieee/char.scm 186 */
obj_t aux_1084;
if(
CHARP(char_486))
{ /* Ieee/char.scm 186 */
aux_1084 = char_486
; }  else 
{ /* Ieee/char.scm 186 */
bigloo_type_error_location_103___error(symbol1295___r4_characters_6_6, string1270___r4_characters_6_6, char_486, string1271___r4_characters_6_6, 
BINT(((long)8753))); 
exit( -1 );} 
char_166_665 = 
(unsigned char)CCHAR(aux_1084); } 
{ /* Ieee/char.scm 187 */
obj_t symbol1161_666;
symbol1161_666 = symbol1294___r4_characters_6_6; 
{ /* Ieee/char.scm 187 */

PUSH_TRACE(symbol1161_666); BUNSPEC; 
{ /* Ieee/char.scm 187 */
bool_t aux1160_667;
{ /* Ieee/char.scm 187 */
bool_t _ortest_1002_668;
_ortest_1002_668 = 
(char_166_665==((unsigned char)' ')); 
if(_ortest_1002_668)
{ /* Ieee/char.scm 187 */
aux1160_667 = _ortest_1002_668; }  else 
{ /* Ieee/char.scm 188 */
bool_t _ortest_1003_669;
_ortest_1003_669 = 
(char_166_665==((unsigned char)'\t')); 
if(_ortest_1003_669)
{ /* Ieee/char.scm 188 */
aux1160_667 = _ortest_1003_669; }  else 
{ /* Ieee/char.scm 189 */
bool_t _ortest_1004_670;
_ortest_1004_670 = 
(char_166_665==((unsigned char)'\r')); 
if(_ortest_1004_670)
{ /* Ieee/char.scm 189 */
aux1160_667 = _ortest_1004_670; }  else 
{ /* Ieee/char.scm 189 */
aux1160_667 = 
(char_166_665==((unsigned char)'\n')); } } } } 
POP_TRACE(); 
res1330_671 = aux1160_667; } } } } 
aux_1083 = res1330_671; } 
return 
BBOOL(aux_1083);} } 
}



/* char-upper-case? */
bool_t char_upper_case__12___r4_characters_6_6(unsigned char char_25)
{ AN_OBJECT;
{ /* Ieee/char.scm 195 */
{ /* Ieee/char.scm 196 */
obj_t symbol1163_672;
symbol1163_672 = symbol1296___r4_characters_6_6; 
{ /* Ieee/char.scm 196 */

PUSH_TRACE(symbol1163_672); BUNSPEC; 
{ /* Ieee/char.scm 196 */
bool_t aux1162_673;
if(
(char_25>=((unsigned char)'A')))
{ /* Ieee/char.scm 196 */
aux1162_673 = 
(char_25<=((unsigned char)'Z')); }  else 
{ /* Ieee/char.scm 196 */
aux1162_673 = ((bool_t)0); } 
POP_TRACE(); 
return aux1162_673;} } } } 
}



/* _char-upper-case?1193 */
obj_t _char_upper_case_1193_86___r4_characters_6_6(obj_t env_487, obj_t char_488)
{ AN_OBJECT;
{ /* Ieee/char.scm 195 */
{ /* Ieee/char.scm 195 */
bool_t aux_1106;
{ /* Ieee/char.scm 195 */
bool_t res1331_677;
{ /* Ieee/char.scm 195 */
unsigned char char_166_674;
{ /* Ieee/char.scm 195 */
obj_t aux_1107;
if(
CHARP(char_488))
{ /* Ieee/char.scm 195 */
aux_1107 = char_488
; }  else 
{ /* Ieee/char.scm 195 */
bigloo_type_error_location_103___error(symbol1297___r4_characters_6_6, string1270___r4_characters_6_6, char_488, string1271___r4_characters_6_6, 
BINT(((long)9134))); 
exit( -1 );} 
char_166_674 = 
(unsigned char)CCHAR(aux_1107); } 
{ /* Ieee/char.scm 196 */
obj_t symbol1163_675;
symbol1163_675 = symbol1296___r4_characters_6_6; 
{ /* Ieee/char.scm 196 */

PUSH_TRACE(symbol1163_675); BUNSPEC; 
{ /* Ieee/char.scm 196 */
bool_t aux1162_676;
if(
(char_166_674>=((unsigned char)'A')))
{ /* Ieee/char.scm 196 */
aux1162_676 = 
(char_166_674<=((unsigned char)'Z')); }  else 
{ /* Ieee/char.scm 196 */
aux1162_676 = ((bool_t)0); } 
POP_TRACE(); 
res1331_677 = aux1162_676; } } } } 
aux_1106 = res1331_677; } 
return 
BBOOL(aux_1106);} } 
}



/* char-lower-case? */
bool_t char_lower_case__222___r4_characters_6_6(unsigned char char_26)
{ AN_OBJECT;
{ /* Ieee/char.scm 203 */
{ /* Ieee/char.scm 204 */
obj_t symbol1165_678;
symbol1165_678 = symbol1298___r4_characters_6_6; 
{ /* Ieee/char.scm 204 */

PUSH_TRACE(symbol1165_678); BUNSPEC; 
{ /* Ieee/char.scm 204 */
bool_t aux1164_679;
if(
(char_26>=((unsigned char)'a')))
{ /* Ieee/char.scm 204 */
aux1164_679 = 
(char_26<=((unsigned char)'z')); }  else 
{ /* Ieee/char.scm 204 */
aux1164_679 = ((bool_t)0); } 
POP_TRACE(); 
return aux1164_679;} } } } 
}



/* _char-lower-case?1194 */
obj_t _char_lower_case_1194_211___r4_characters_6_6(obj_t env_489, obj_t char_490)
{ AN_OBJECT;
{ /* Ieee/char.scm 203 */
{ /* Ieee/char.scm 203 */
bool_t aux_1125;
{ /* Ieee/char.scm 203 */
bool_t res1332_683;
{ /* Ieee/char.scm 203 */
unsigned char char_166_680;
{ /* Ieee/char.scm 203 */
obj_t aux_1126;
if(
CHARP(char_490))
{ /* Ieee/char.scm 203 */
aux_1126 = char_490
; }  else 
{ /* Ieee/char.scm 203 */
bigloo_type_error_location_103___error(symbol1299___r4_characters_6_6, string1270___r4_characters_6_6, char_490, string1271___r4_characters_6_6, 
BINT(((long)9460))); 
exit( -1 );} 
char_166_680 = 
(unsigned char)CCHAR(aux_1126); } 
{ /* Ieee/char.scm 204 */
obj_t symbol1165_681;
symbol1165_681 = symbol1298___r4_characters_6_6; 
{ /* Ieee/char.scm 204 */

PUSH_TRACE(symbol1165_681); BUNSPEC; 
{ /* Ieee/char.scm 204 */
bool_t aux1164_682;
if(
(char_166_680>=((unsigned char)'a')))
{ /* Ieee/char.scm 204 */
aux1164_682 = 
(char_166_680<=((unsigned char)'z')); }  else 
{ /* Ieee/char.scm 204 */
aux1164_682 = ((bool_t)0); } 
POP_TRACE(); 
res1332_683 = aux1164_682; } } } } 
aux_1125 = res1332_683; } 
return 
BBOOL(aux_1125);} } 
}



/* char->integer */
long char__integer_184___r4_characters_6_6(unsigned char char_27)
{ AN_OBJECT;
{ /* Ieee/char.scm 211 */
{ /* Ieee/char.scm 212 */
obj_t symbol1167_684;
symbol1167_684 = symbol1300___r4_characters_6_6; 
{ /* Ieee/char.scm 212 */

PUSH_TRACE(symbol1167_684); BUNSPEC; 
{ /* Ieee/char.scm 212 */
long aux1166_685;
aux1166_685 = 
(char_27); 
POP_TRACE(); 
return aux1166_685;} } } } 
}



/* _char->integer1195 */
obj_t _char__integer1195_129___r4_characters_6_6(obj_t env_491, obj_t char_492)
{ AN_OBJECT;
{ /* Ieee/char.scm 211 */
{ /* Ieee/char.scm 211 */
long aux_1142;
{ /* Ieee/char.scm 211 */
long res1333_689;
{ /* Ieee/char.scm 211 */
unsigned char char_166_686;
{ /* Ieee/char.scm 211 */
obj_t aux_1143;
if(
CHARP(char_492))
{ /* Ieee/char.scm 211 */
aux_1143 = char_492
; }  else 
{ /* Ieee/char.scm 211 */
bigloo_type_error_location_103___error(symbol1301___r4_characters_6_6, string1270___r4_characters_6_6, char_492, string1271___r4_characters_6_6, 
BINT(((long)9786))); 
exit( -1 );} 
char_166_686 = 
(unsigned char)CCHAR(aux_1143); } 
{ /* Ieee/char.scm 212 */
obj_t symbol1167_687;
symbol1167_687 = symbol1300___r4_characters_6_6; 
{ /* Ieee/char.scm 212 */

PUSH_TRACE(symbol1167_687); BUNSPEC; 
{ /* Ieee/char.scm 212 */
long aux1166_688;
aux1166_688 = 
(char_166_686); 
POP_TRACE(); 
res1333_689 = aux1166_688; } } } } 
aux_1142 = res1333_689; } 
return 
BINT(aux_1142);} } 
}



/* integer->char */
unsigned char integer__char_140___r4_characters_6_6(long int_28)
{ AN_OBJECT;
{ /* Ieee/char.scm 217 */
{ /* Ieee/char.scm 218 */
obj_t symbol1169_437;
symbol1169_437 = symbol1302___r4_characters_6_6; 
{ /* Ieee/char.scm 218 */

PUSH_TRACE(symbol1169_437); BUNSPEC; 
{ /* Ieee/char.scm 218 */
unsigned char aux1168_438;
{ /* Ieee/char.scm 218 */
bool_t test_1155;
if(
(int_28>=((long)0)))
{ /* Ieee/char.scm 218 */
test_1155 = 
(int_28<=((long)255))
; }  else 
{ /* Ieee/char.scm 218 */
test_1155 = ((bool_t)0)
; } 
if(test_1155)
{ /* Ieee/char.scm 218 */
aux1168_438 = 
(int_28); }  else 
{ /* Ieee/char.scm 218 */
error_c_location_83___error(string1303___r4_characters_6_6, string1304___r4_characters_6_6, 
BINT(int_28), "Ieee/char.scm", ((long)10177)); 
{ /* ./Llib/error.scm 407 */
obj_t aux_1162;
{ /* ./Llib/error.scm 407 */
obj_t aux1253_556;
aux1253_556 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1305___r4_characters_6_6, 
BINT(((long)7583))); 
if(
CHARP(aux1253_556))
{ /* ./Llib/error.scm 407 */
aux_1162 = aux1253_556
; }  else 
{ /* ./Llib/error.scm 407 */
bigloo_type_error_location_103___error(symbol1302___r4_characters_6_6, string1270___r4_characters_6_6, aux1253_556, string1305___r4_characters_6_6, 
BINT(((long)7583))); 
exit( -1 );} } 
aux1168_438 = 
(unsigned char)CCHAR(aux_1162); } } } 
POP_TRACE(); 
return aux1168_438;} } } } 
}



/* _integer->char1196 */
obj_t _integer__char1196_4___r4_characters_6_6(obj_t env_493, obj_t int_494)
{ AN_OBJECT;
{ /* Ieee/char.scm 217 */
{ /* Ieee/char.scm 217 */
unsigned char aux_1172;
{ /* Ieee/char.scm 217 */
long aux_1173;
{ /* Ieee/char.scm 217 */
obj_t aux_1174;
if(
INTEGERP(int_494))
{ /* Ieee/char.scm 217 */
aux_1174 = int_494
; }  else 
{ /* Ieee/char.scm 217 */
bigloo_type_error_location_103___error(symbol1306___r4_characters_6_6, string1307___r4_characters_6_6, int_494, string1271___r4_characters_6_6, 
BINT(((long)10072))); 
exit( -1 );} 
aux_1173 = 
(long)CINT(aux_1174); } 
aux_1172 = 
integer__char_140___r4_characters_6_6(aux_1173); } 
return 
BCHAR(aux_1172);} } 
}



/* integer->char-ur */
unsigned char integer__char_ur_23___r4_characters_6_6(long int_29)
{ AN_OBJECT;
{ /* Ieee/char.scm 225 */
{ /* Ieee/char.scm 226 */
obj_t symbol1171_690;
symbol1171_690 = symbol1308___r4_characters_6_6; 
{ /* Ieee/char.scm 226 */

PUSH_TRACE(symbol1171_690); BUNSPEC; 
{ /* Ieee/char.scm 226 */
unsigned char aux1170_691;
aux1170_691 = 
(int_29); 
POP_TRACE(); 
return aux1170_691;} } } } 
}



/* _integer->char-ur1197 */
obj_t _integer__char_ur1197_33___r4_characters_6_6(obj_t env_495, obj_t int_496)
{ AN_OBJECT;
{ /* Ieee/char.scm 225 */
{ /* Ieee/char.scm 225 */
unsigned char aux_1186;
{ /* Ieee/char.scm 225 */
unsigned char res1334_695;
{ /* Ieee/char.scm 225 */
long int_184_692;
{ /* Ieee/char.scm 225 */
obj_t aux_1187;
if(
INTEGERP(int_496))
{ /* Ieee/char.scm 225 */
aux_1187 = int_496
; }  else 
{ /* Ieee/char.scm 225 */
bigloo_type_error_location_103___error(symbol1309___r4_characters_6_6, string1307___r4_characters_6_6, int_496, string1271___r4_characters_6_6, 
BINT(((long)10453))); 
exit( -1 );} 
int_184_692 = 
(long)CINT(aux_1187); } 
{ /* Ieee/char.scm 226 */
obj_t symbol1171_693;
symbol1171_693 = symbol1308___r4_characters_6_6; 
{ /* Ieee/char.scm 226 */

PUSH_TRACE(symbol1171_693); BUNSPEC; 
{ /* Ieee/char.scm 226 */
unsigned char aux1170_694;
aux1170_694 = 
(int_184_692); 
POP_TRACE(); 
res1334_695 = aux1170_694; } } } } 
aux_1186 = res1334_695; } 
return 
BCHAR(aux_1186);} } 
}



/* char-upcase */
unsigned char char_upcase_134___r4_characters_6_6(unsigned char char_30)
{ AN_OBJECT;
{ /* Ieee/char.scm 231 */
{ /* Ieee/char.scm 232 */
obj_t symbol1173_696;
symbol1173_696 = symbol1310___r4_characters_6_6; 
{ /* Ieee/char.scm 232 */

PUSH_TRACE(symbol1173_696); BUNSPEC; 
{ /* Ieee/char.scm 232 */
unsigned char aux1172_697;
aux1172_697 = 
toupper(char_30); 
POP_TRACE(); 
return aux1172_697;} } } } 
}



/* _char-upcase1198 */
obj_t _char_upcase1198_8___r4_characters_6_6(obj_t env_497, obj_t char_498)
{ AN_OBJECT;
{ /* Ieee/char.scm 231 */
{ /* Ieee/char.scm 231 */
unsigned char aux_1201;
{ /* Ieee/char.scm 231 */
unsigned char res1335_701;
{ /* Ieee/char.scm 231 */
unsigned char char_166_698;
{ /* Ieee/char.scm 231 */
obj_t aux_1202;
if(
CHARP(char_498))
{ /* Ieee/char.scm 231 */
aux_1202 = char_498
; }  else 
{ /* Ieee/char.scm 231 */
bigloo_type_error_location_103___error(symbol1311___r4_characters_6_6, string1270___r4_characters_6_6, char_498, string1271___r4_characters_6_6, 
BINT(((long)10740))); 
exit( -1 );} 
char_166_698 = 
(unsigned char)CCHAR(aux_1202); } 
{ /* Ieee/char.scm 232 */
obj_t symbol1173_699;
symbol1173_699 = symbol1310___r4_characters_6_6; 
{ /* Ieee/char.scm 232 */

PUSH_TRACE(symbol1173_699); BUNSPEC; 
{ /* Ieee/char.scm 232 */
unsigned char aux1172_700;
aux1172_700 = 
toupper(char_166_698); 
POP_TRACE(); 
res1335_701 = aux1172_700; } } } } 
aux_1201 = res1335_701; } 
return 
BCHAR(aux_1201);} } 
}



/* char-downcase */
unsigned char char_downcase_76___r4_characters_6_6(unsigned char char_31)
{ AN_OBJECT;
{ /* Ieee/char.scm 237 */
{ /* Ieee/char.scm 238 */
obj_t symbol1175_702;
symbol1175_702 = symbol1312___r4_characters_6_6; 
{ /* Ieee/char.scm 238 */

PUSH_TRACE(symbol1175_702); BUNSPEC; 
{ /* Ieee/char.scm 238 */
unsigned char aux1174_703;
aux1174_703 = 
tolower(char_31); 
POP_TRACE(); 
return aux1174_703;} } } } 
}



/* _char-downcase1199 */
obj_t _char_downcase1199_225___r4_characters_6_6(obj_t env_499, obj_t char_500)
{ AN_OBJECT;
{ /* Ieee/char.scm 237 */
{ /* Ieee/char.scm 237 */
unsigned char aux_1216;
{ /* Ieee/char.scm 237 */
unsigned char res1336_707;
{ /* Ieee/char.scm 237 */
unsigned char char_166_704;
{ /* Ieee/char.scm 237 */
obj_t aux_1217;
if(
CHARP(char_500))
{ /* Ieee/char.scm 237 */
aux_1217 = char_500
; }  else 
{ /* Ieee/char.scm 237 */
bigloo_type_error_location_103___error(symbol1313___r4_characters_6_6, string1270___r4_characters_6_6, char_500, string1271___r4_characters_6_6, 
BINT(((long)11023))); 
exit( -1 );} 
char_166_704 = 
(unsigned char)CCHAR(aux_1217); } 
{ /* Ieee/char.scm 238 */
obj_t symbol1175_705;
symbol1175_705 = symbol1312___r4_characters_6_6; 
{ /* Ieee/char.scm 238 */

PUSH_TRACE(symbol1175_705); BUNSPEC; 
{ /* Ieee/char.scm 238 */
unsigned char aux1174_706;
aux1174_706 = 
tolower(char_166_704); 
POP_TRACE(); 
res1336_707 = aux1174_706; } } } } 
aux_1216 = res1336_707; } 
return 
BCHAR(aux_1216);} } 
}



/* char-or */
unsigned char char_or_106___r4_characters_6_6(unsigned char char1_32, unsigned char char2_33)
{ AN_OBJECT;
{ /* Ieee/char.scm 243 */
{ /* Ieee/char.scm 244 */
obj_t symbol1177_708;
symbol1177_708 = symbol1314___r4_characters_6_6; 
{ /* Ieee/char.scm 244 */

PUSH_TRACE(symbol1177_708); BUNSPEC; 
{ /* Ieee/char.scm 244 */
unsigned char aux1176_709;
aux1176_709 = 
(char1_32|char2_33); 
POP_TRACE(); 
return aux1176_709;} } } } 
}



/* _char-or1200 */
obj_t _char_or1200_195___r4_characters_6_6(obj_t env_501, obj_t char1_502, obj_t char2_503)
{ AN_OBJECT;
{ /* Ieee/char.scm 243 */
{ /* Ieee/char.scm 243 */
unsigned char aux_1231;
{ /* Ieee/char.scm 243 */
unsigned char res1337_714;
{ /* Ieee/char.scm 243 */
unsigned char char1_710;unsigned char char2_711;
{ /* Ieee/char.scm 243 */
obj_t aux_1232;
if(
CHARP(char1_502))
{ /* Ieee/char.scm 243 */
aux_1232 = char1_502
; }  else 
{ /* Ieee/char.scm 243 */
bigloo_type_error_location_103___error(symbol1315___r4_characters_6_6, string1270___r4_characters_6_6, char1_502, string1271___r4_characters_6_6, 
BINT(((long)11317))); 
exit( -1 );} 
char1_710 = 
(unsigned char)CCHAR(aux_1232); } 
{ /* Ieee/char.scm 243 */
obj_t aux_1239;
if(
CHARP(char2_503))
{ /* Ieee/char.scm 243 */
aux_1239 = char2_503
; }  else 
{ /* Ieee/char.scm 243 */
bigloo_type_error_location_103___error(symbol1315___r4_characters_6_6, string1270___r4_characters_6_6, char2_503, string1271___r4_characters_6_6, 
BINT(((long)11317))); 
exit( -1 );} 
char2_711 = 
(unsigned char)CCHAR(aux_1239); } 
{ /* Ieee/char.scm 244 */
obj_t symbol1177_712;
symbol1177_712 = symbol1314___r4_characters_6_6; 
{ /* Ieee/char.scm 244 */

PUSH_TRACE(symbol1177_712); BUNSPEC; 
{ /* Ieee/char.scm 244 */
unsigned char aux1176_713;
aux1176_713 = 
(char1_710|char2_711); 
POP_TRACE(); 
res1337_714 = aux1176_713; } } } } 
aux_1231 = res1337_714; } 
return 
BCHAR(aux_1231);} } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___r4_characters_6_6()
{ AN_OBJECT;
{ /* Ieee/char.scm 14 */
{ /* Ieee/char.scm 14 */
obj_t symbol1179_447;
symbol1179_447 = symbol1316___r4_characters_6_6; 
{ /* Ieee/char.scm 14 */

PUSH_TRACE(symbol1179_447); BUNSPEC; 
{ /* Ieee/char.scm 14 */
obj_t aux1178_448;
aux1178_448 = 
module_initialization_70___error(((long)0), "__R4_CHARACTERS_6_6"); 
POP_TRACE(); 
return aux1178_448;} } } } 
}

