/*===========================================================================*/
/*   (Llib/bexit.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t unwind_until__178___bexit(obj_t, obj_t);
extern obj_t string_to_symbol(char *);
static obj_t _unwind_until__238___bexit(obj_t, obj_t, obj_t);
extern obj_t unwind_stack_until(obj_t, obj_t, obj_t, obj_t);
static obj_t _protected_val__170___bexit = BUNSPEC;
static obj_t symbol1222___bexit = BUNSPEC;
static obj_t symbol1217___bexit = BUNSPEC;
static obj_t symbol1216___bexit = BUNSPEC;
static obj_t symbol1215___bexit = BUNSPEC;
static obj_t symbol1214___bexit = BUNSPEC;
static obj_t symbol1210___bexit = BUNSPEC;
static obj_t symbol1207___bexit = BUNSPEC;
static obj_t symbol1206___bexit = BUNSPEC;
static obj_t symbol1205___bexit = BUNSPEC;
static obj_t symbol1204___bexit = BUNSPEC;
static obj_t symbol1203___bexit = BUNSPEC;
obj_t exitd_top = BUNSPEC;
static obj_t toplevel_init_63___bexit();
static obj_t list1213___bexit = BUNSPEC;
extern bool_t unwind_stack_value_p(obj_t);
extern obj_t bigloo_type_error_location_103___error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _val_from_exit__167___bexit(obj_t, obj_t);
extern obj_t debug_error_location_199___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___error(long, char *);
static obj_t _unwind_stack_until__173___bexit(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t error_location_112___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t error_c_location_83___error(obj_t, obj_t, obj_t, char *, long);
static obj_t _unwind_stack_value__112___bexit(obj_t, obj_t);
static obj_t imported_modules_init_94___bexit();
extern obj_t val_from_exit__100___bexit(obj_t);
static obj_t require_initialization_114___bexit = BUNSPEC;
static obj_t cnst_init_137___bexit();
obj_t exitd_stamp = BUNSPEC;
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( unwind_until__env_204___bexit, _unwind_until__238___bexit1224, _unwind_until__238___bexit, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( val_from_exit__env_189___bexit, _val_from_exit__167___bexit1225, _val_from_exit__167___bexit, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( unwind_stack_value__env_181___bexit, _unwind_stack_value__112___bexit1226, _unwind_stack_value__112___bexit, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( unwind_stack_until__env_164___bexit, _unwind_stack_until__173___bexit1227, _unwind_stack_until__173___bexit, 0L, 4 );
DEFINE_STRING( string1221___bexit, string1221___bexit1228, "LONG", 4 );
DEFINE_STRING( string1219___bexit, string1219___bexit1229, "exit out of dynamic scope", 25 );
DEFINE_STRING( string1220___bexit, string1220___bexit1230, "/home/tahoe2/serrano/tmp/bigloo/runtime/./Llib/error.scm", 56 );
DEFINE_STRING( string1218___bexit, string1218___bexit1231, "unwind-until!", 13 );
DEFINE_STRING( string1212___bexit, string1212___bexit1232, "UNWIND-STACK-UNTIL!:Wrong number of arguments", 45 );
DEFINE_STRING( string1211___bexit, string1211___bexit1233, "PROCEDURE", 9 );
DEFINE_STRING( string1209___bexit, string1209___bexit1234, "/home/tahoe2/serrano/tmp/bigloo/runtime/Llib/bexit.scm", 54 );
DEFINE_STRING( string1208___bexit, string1208___bexit1235, "PAIR", 4 );



/* module-initialization */
obj_t module_initialization_70___bexit(long checksum_476, char * from_477)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___bexit))
{ 
require_initialization_114___bexit = 
BBOOL(((bool_t)0)); 
cnst_init_137___bexit(); 
imported_modules_init_94___bexit(); 
toplevel_init_63___bexit(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___bexit()
{ AN_OBJECT;
{ /* Llib/bexit.scm 14 */
symbol1203___bexit = 
string_to_symbol("@__BEXIT"); 
symbol1204___bexit = 
string_to_symbol("*PROTECTED-VAL*"); 
symbol1205___bexit = 
string_to_symbol("VAL-FROM-EXIT?"); 
symbol1206___bexit = 
string_to_symbol("UNWIND-STACK-VALUE?"); 
symbol1207___bexit = 
string_to_symbol("UNWIND-UNTIL!"); 
symbol1210___bexit = 
string_to_symbol("UNWIND-STACK-UNTIL!"); 
symbol1214___bexit = 
string_to_symbol("FUNCALL"); 
symbol1215___bexit = 
string_to_symbol("proc"); 
symbol1216___bexit = 
string_to_symbol("val"); 
{ /* Llib/bexit.scm 109 */
obj_t aux_493;
{ /* Llib/bexit.scm 109 */
obj_t aux_494;
{ /* Llib/bexit.scm 109 */
obj_t aux_495;
aux_495 = 
MAKE_PAIR(symbol1216___bexit, BNIL); 
aux_494 = 
MAKE_PAIR(symbol1215___bexit, aux_495); } 
aux_493 = 
MAKE_PAIR(symbol1215___bexit, aux_494); } 
list1213___bexit = 
MAKE_PAIR(symbol1214___bexit, aux_493); } 
symbol1217___bexit = 
string_to_symbol("_"); 
return ( 
symbol1222___bexit = 
string_to_symbol("IMPORTED-MODULES-INIT"), BUNSPEC) ;} 
}



/* toplevel-init */
obj_t toplevel_init_63___bexit()
{ AN_OBJECT;
{ /* Llib/bexit.scm 14 */
{ /* Llib/bexit.scm 14 */
obj_t symbol1182_441;
symbol1182_441 = symbol1203___bexit; 
{ /* Llib/bexit.scm 14 */

PUSH_TRACE(symbol1182_441); BUNSPEC; 
{ /* Llib/bexit.scm 14 */
obj_t aux1181_442;
exitd_top = BFALSE; 
exitd_stamp = 
BINT(((long)0)); 
{ /* Llib/bexit.scm 66 */
obj_t symbol1180_439;
symbol1180_439 = symbol1204___bexit; 
{ /* Llib/bexit.scm 66 */

PUSH_TRACE(symbol1180_439); BUNSPEC; 
{ /* Llib/bexit.scm 66 */
obj_t aux1179_440;
aux1179_440 = 
MAKE_PAIR(BUNSPEC, BUNSPEC); 
POP_TRACE(); 
aux1181_442 = ( 
_protected_val__170___bexit = aux1179_440, BUNSPEC) ; } } } 
POP_TRACE(); 
return aux1181_442;} } } } 
}



/* val-from-exit? */
obj_t val_from_exit__100___bexit(obj_t val_1)
{ AN_OBJECT;
{ /* Llib/bexit.scm 71 */
{ /* Llib/bexit.scm 72 */
obj_t symbol1184_443;
symbol1184_443 = symbol1205___bexit; 
{ /* Llib/bexit.scm 72 */

PUSH_TRACE(symbol1184_443); BUNSPEC; 
{ /* Llib/bexit.scm 72 */
obj_t aux1183_444;
{ /* ./Ieee/equiv.scm 1480 */
bool_t aux_509;
aux_509 = 
(val_1==_protected_val__170___bexit); 
aux1183_444 = 
BBOOL(aux_509); } 
POP_TRACE(); 
return aux1183_444;} } } } 
}



/* _val-from-exit? */
obj_t _val_from_exit__167___bexit(obj_t env_453, obj_t val_454)
{ AN_OBJECT;
{ /* Llib/bexit.scm 71 */
return 
val_from_exit__100___bexit(val_454);} 
}



/* unwind-stack-value? */
bool_t unwind_stack_value_p(obj_t val_2)
{ AN_OBJECT;
{ /* Llib/bexit.scm 82 */
{ /* Llib/bexit.scm 83 */
obj_t symbol1186_445;
symbol1186_445 = symbol1206___bexit; 
{ /* Llib/bexit.scm 83 */

PUSH_TRACE(symbol1186_445); BUNSPEC; 
{ /* Llib/bexit.scm 83 */
bool_t aux1185_446;
aux1185_446 = 
(val_2==_protected_val__170___bexit); 
POP_TRACE(); 
return aux1185_446;} } } } 
}



/* _unwind-stack-value? */
obj_t _unwind_stack_value__112___bexit(obj_t env_455, obj_t val_456)
{ AN_OBJECT;
{ /* Llib/bexit.scm 82 */
{ /* Llib/bexit.scm 82 */
bool_t aux_517;
aux_517 = 
unwind_stack_value_p(val_456); 
return 
BBOOL(aux_517);} } 
}



/* unwind-until! */
obj_t unwind_until__178___bexit(obj_t exitd_3, obj_t val_4)
{ AN_OBJECT;
{ /* Llib/bexit.scm 92 */
{ /* Llib/bexit.scm 93 */
obj_t symbol1188_447;
symbol1188_447 = symbol1207___bexit; 
{ /* Llib/bexit.scm 93 */

PUSH_TRACE(symbol1188_447); BUNSPEC; 
{ /* Llib/bexit.scm 93 */
obj_t aux1187_448;
{ /* Llib/bexit.scm 93 */
bool_t test1005_237;
test1005_237 = 
PAIRP(exitd_3); 
if(test1005_237)
{ /* Llib/bexit.scm 94 */
obj_t arg1006_238;obj_t arg1007_239;
{ /* Llib/bexit.scm 94 */
obj_t pair_417;
if(test1005_237)
{ /* Llib/bexit.scm 94 */
pair_417 = exitd_3; }  else 
{ /* Llib/bexit.scm 94 */
bigloo_type_error_location_103___error(symbol1207___bexit, string1208___bexit, exitd_3, string1209___bexit, 
BINT(((long)4782))); 
exit( -1 );} 
arg1006_238 = 
CAR(pair_417); } 
{ /* Llib/bexit.scm 94 */
obj_t pair_418;
if(test1005_237)
{ /* Llib/bexit.scm 94 */
pair_418 = exitd_3; }  else 
{ /* Llib/bexit.scm 94 */
bigloo_type_error_location_103___error(symbol1207___bexit, string1208___bexit, exitd_3, string1209___bexit, 
BINT(((long)4801))); 
exit( -1 );} 
arg1007_239 = 
CDR(pair_418); } 
aux1187_448 = 
unwind_stack_until(arg1006_238, BFALSE, val_4, arg1007_239); }  else 
{ /* Llib/bexit.scm 93 */
aux1187_448 = 
unwind_stack_until(exitd_3, BFALSE, val_4, BFALSE); } } 
POP_TRACE(); 
return aux1187_448;} } } } 
}



/* _unwind-until! */
obj_t _unwind_until__238___bexit(obj_t env_457, obj_t exitd_458, obj_t val_459)
{ AN_OBJECT;
{ /* Llib/bexit.scm 92 */
return 
unwind_until__178___bexit(exitd_458, val_459);} 
}



/* unwind-stack-until! */
obj_t unwind_stack_until(obj_t exitd_5, obj_t estamp_6, obj_t val_7, obj_t proc_8)
{ AN_OBJECT;
{ /* Llib/bexit.scm 105 */
{ /* Llib/bexit.scm 106 */
obj_t symbol1190_449;
symbol1190_449 = symbol1210___bexit; 
{ /* Llib/bexit.scm 106 */

PUSH_TRACE(symbol1190_449); BUNSPEC; 
{ /* Llib/bexit.scm 106 */
obj_t aux1189_450;
{ 

loop_240:
{ /* Llib/bexit.scm 107 */
bool_t test1008_241;
{ /* Llib/bexit.scm 107 */
obj_t obj1_419;
obj1_419 = exitd_top; 
test1008_241 = 
(obj1_419==BFALSE); } 
if(test1008_241)
{ /* Llib/bexit.scm 108 */
bool_t test1009_242;
test1009_242 = 
PROCEDUREP(proc_8); 
if(test1009_242)
{ /* Llib/bexit.scm 109 */
obj_t fun_471;
if(test1009_242)
{ /* Llib/bexit.scm 109 */
fun_471 = proc_8; }  else 
{ /* Llib/bexit.scm 109 */
bigloo_type_error_location_103___error(symbol1210___bexit, string1211___bexit, proc_8, string1209___bexit, 
BINT(((long)5584))); 
exit( -1 );} 
{ /* Llib/bexit.scm 109 */
bool_t test1200_473;
test1200_473 = 
PROCEDURE_CORRECT_ARITYP(fun_471, ((long)1)); 
if(test1200_473)
{ /* Llib/bexit.scm 109 */
aux1189_450 = 
PROCEDURE_ENTRY(fun_471)(proc_8, val_7, BEOA); }  else 
{ /* Llib/bexit.scm 109 */
error_location_112___error(string1212___bexit, list1213___bexit, fun_471, string1209___bexit, 
BINT(((long)5584))); 
FAILURE(symbol1217___bexit,symbol1217___bexit,symbol1217___bexit);} } }  else 
{ /* Llib/bexit.scm 108 */
error_c_location_83___error(string1218___bexit, string1219___bexit, BUNSPEC, "Llib/bexit.scm", ((long)5602)); 
aux1189_450 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1220___bexit, 
BINT(((long)7583))); } }  else 
{ /* Llib/bexit.scm 113 */
obj_t exit_top_38_243;
exit_top_38_243 = exitd_top; 
POP_EXIT(); 
{ /* Llib/bexit.scm 116 */
bool_t test1010_244;
if(
(exit_top_38_243==exitd_5))
{ /* Llib/bexit.scm 117 */
bool_t _ortest_1002_248;
if(
INTEGERP(estamp_6))
{ /* Llib/bexit.scm 117 */
_ortest_1002_248 = ((bool_t)0); }  else 
{ /* Llib/bexit.scm 117 */
_ortest_1002_248 = ((bool_t)1); } 
if(_ortest_1002_248)
{ /* Llib/bexit.scm 117 */
test1010_244 = _ortest_1002_248; }  else 
{ /* Llib/bexit.scm 118 */
obj_t arg1014_249;
arg1014_249 = 
EXITD_STAMP(exit_top_38_243); 
{ /* Llib/bexit.scm 118 */
long n1_428;long n2_429;
n1_428 = 
(long)CINT(arg1014_249); 
{ /* Llib/bexit.scm 118 */
obj_t aux_564;
if(
INTEGERP(estamp_6))
{ /* Llib/bexit.scm 118 */
aux_564 = estamp_6
; }  else 
{ /* Llib/bexit.scm 118 */
bigloo_type_error_location_103___error(symbol1210___bexit, string1221___bexit, estamp_6, string1209___bexit, 
BINT(((long)5817))); 
exit( -1 );} 
n2_429 = 
(long)CINT(aux_564); } 
test1010_244 = 
(n1_428==n2_429); } } }  else 
{ /* Llib/bexit.scm 116 */
test1010_244 = ((bool_t)0); } 
if(test1010_244)
{ /* Llib/bexit.scm 116 */
JUMP_EXIT( 
EXITD_TO_EXIT(exit_top_38_243),val_7); }  else 
{ /* Llib/bexit.scm 120 */
bool_t test1011_245;
test1011_245 = 
EXITD_USERP(exit_top_38_243); 
if(test1011_245)
{ /* Llib/bexit.scm 120 */
goto loop_240;}  else 
{ /* Llib/bexit.scm 120 */
{ /* Llib/bexit.scm 121 */
obj_t arg1012_246;
arg1012_246 = 
MAKE_PAIR(exitd_5, proc_8); 
SET_CAR(_protected_val__170___bexit, arg1012_246); } 
SET_CDR(_protected_val__170___bexit, val_7); 
JUMP_EXIT( 
EXITD_TO_EXIT(exit_top_38_243),_protected_val__170___bexit); } } } } } } 
POP_TRACE(); 
return aux1189_450;} } } } 
}



/* _unwind-stack-until! */
obj_t _unwind_stack_until__173___bexit(obj_t env_460, obj_t exitd_461, obj_t estamp_462, obj_t val_463, obj_t proc_464)
{ AN_OBJECT;
{ /* Llib/bexit.scm 105 */
return 
unwind_stack_until(exitd_461, estamp_462, val_463, proc_464);} 
}



/* imported-modules-init */
obj_t imported_modules_init_94___bexit()
{ AN_OBJECT;
{ /* Llib/bexit.scm 14 */
{ /* Llib/bexit.scm 14 */
obj_t symbol1192_451;
symbol1192_451 = symbol1222___bexit; 
{ /* Llib/bexit.scm 14 */

PUSH_TRACE(symbol1192_451); BUNSPEC; 
{ /* Llib/bexit.scm 14 */
obj_t aux1191_452;
aux1191_452 = 
module_initialization_70___error(((long)0), "__BEXIT"); 
POP_TRACE(); 
return aux1191_452;} } } } 
}

