/*===========================================================================*/
/*   (Llib/os.scm)                                                           */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t prefix___os(obj_t);
extern obj_t make_static_library_name_134___os(obj_t);
static obj_t _getenv___os(obj_t, obj_t);
static obj_t symbol1438___os = BUNSPEC;
static obj_t symbol1437___os = BUNSPEC;
static obj_t symbol1436___os = BUNSPEC;
static obj_t symbol1435___os = BUNSPEC;
static obj_t symbol1434___os = BUNSPEC;
static obj_t symbol1433___os = BUNSPEC;
static obj_t symbol1431___os = BUNSPEC;
static obj_t symbol1429___os = BUNSPEC;
static obj_t symbol1430___os = BUNSPEC;
static obj_t symbol1428___os = BUNSPEC;
static obj_t symbol1426___os = BUNSPEC;
static obj_t symbol1425___os = BUNSPEC;
static obj_t symbol1422___os = BUNSPEC;
static obj_t symbol1421___os = BUNSPEC;
static obj_t symbol1419___os = BUNSPEC;
static obj_t symbol1420___os = BUNSPEC;
extern obj_t command_line_67___os();
extern obj_t string_to_symbol(char *);
static obj_t symbol1412___os = BUNSPEC;
static obj_t symbol1411___os = BUNSPEC;
static obj_t symbol1409___os = BUNSPEC;
static obj_t symbol1410___os = BUNSPEC;
static obj_t symbol1408___os = BUNSPEC;
static obj_t symbol1397___os = BUNSPEC;
static obj_t symbol1407___os = BUNSPEC;
static obj_t symbol1406___os = BUNSPEC;
static obj_t symbol1404___os = BUNSPEC;
static obj_t symbol1403___os = BUNSPEC;
static obj_t symbol1392___os = BUNSPEC;
static obj_t symbol1402___os = BUNSPEC;
static obj_t symbol1391___os = BUNSPEC;
static obj_t symbol1401___os = BUNSPEC;
static obj_t symbol1389___os = BUNSPEC;
static obj_t symbol1390___os = BUNSPEC;
static obj_t symbol1388___os = BUNSPEC;
static obj_t symbol1387___os = BUNSPEC;
static obj_t symbol1386___os = BUNSPEC;
static obj_t symbol1385___os = BUNSPEC;
static obj_t symbol1384___os = BUNSPEC;
static obj_t symbol1383___os = BUNSPEC;
static obj_t symbol1381___os = BUNSPEC;
static obj_t symbol1379___os = BUNSPEC;
static obj_t symbol1377___os = BUNSPEC;
static obj_t symbol1375___os = BUNSPEC;
static obj_t symbol1373___os = BUNSPEC;
static obj_t symbol1371___os = BUNSPEC;
static obj_t symbol1369___os = BUNSPEC;
static obj_t symbol1368___os = BUNSPEC;
static obj_t _dirname___os(obj_t, obj_t);
extern obj_t c_signal(int, obj_t);
obj_t os_arch_255___os = BUNSPEC;
obj_t os_name_233___os = BUNSPEC;
obj_t path_separator_174___os = BUNSPEC;
extern obj_t string_append(obj_t, obj_t);
static obj_t toplevel_init_63___os();
obj_t os_version_65___os = BUNSPEC;
extern obj_t find_file_path_55___os(obj_t, obj_t);
static obj_t _prefix___os(obj_t, obj_t);
static obj_t _executable_name_113___os(obj_t);
static obj_t _make_shared_library_name_15___os(obj_t, obj_t);
extern obj_t dirname___os(obj_t);
static obj_t _basename___os(obj_t, obj_t);
extern obj_t signal___os(int, obj_t);
extern obj_t string_to_bstring(char *);
static obj_t _anonymous_1012__103___os(obj_t);
static obj_t _anonymous_1011__26___os(obj_t);
static obj_t _anonymous_1010__206___os(obj_t);
static obj_t _anonymous_1009__195___os(obj_t);
static obj_t _anonymous_1008__166___os(obj_t);
static obj_t _anonymous_1007__55___os(obj_t);
static obj_t _anonymous_1006__59___os(obj_t);
extern obj_t bigloo_type_error_location_103___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t pwd___os();
extern obj_t basename___os(obj_t);
static obj_t _date___os(obj_t);
static obj_t _make_file_name_179___os(obj_t, obj_t, obj_t);
extern obj_t debug_error_location_199___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_string(long, unsigned char);
extern obj_t suffix___os(obj_t);
static obj_t _signal___os(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70___os(long, char *);
extern obj_t module_initialization_70___error(long, char *);
obj_t file_separator_81___os = BUNSPEC;
extern obj_t system___os(char *);
extern obj_t c_substring(obj_t, long, long);
static obj_t _chdir___os(obj_t, obj_t);
extern obj_t get_signal_handler(int);
static obj_t _command_line_112___os(obj_t);
static obj_t _pwd___os(obj_t);
extern obj_t make_shared_library_name_78___os(obj_t);
obj_t os_tmp_175___os = BUNSPEC;
static obj_t _find_file_path1291_240___os(obj_t, obj_t, obj_t);
extern bool_t fexists(char *);
extern obj_t chdir___os(char *);
extern obj_t error_c_location_83___error(obj_t, obj_t, obj_t, char *, long);
obj_t os_class_179___os = BUNSPEC;
static obj_t _make_static_library_name_240___os(obj_t, obj_t);
extern obj_t command_line;
extern obj_t get_signal_handler_120___os(int);
static obj_t _suffix___os(obj_t, obj_t);
static obj_t _system___os(obj_t, obj_t);
static obj_t _get_signal_handler_163___os(obj_t, obj_t);
extern char * date___os();
extern obj_t getenv___os(char *);
extern char * executable_name_99___os();
extern char * executable_name;
static obj_t imported_modules_init_94___os();
extern char * c_date();
static obj_t require_initialization_114___os = BUNSPEC;
extern obj_t make_file_name_203___os(obj_t, obj_t);
static obj_t cnst_init_137___os();
extern obj_t blit_string(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( basename_env_222___os, _basename___os1441, _basename___os, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( find_file_path_env_231___os, _find_file_path1291_240___os1442, _find_file_path1291_240___os, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( pwd_env_121___os, _pwd___os1443, _pwd___os, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( get_signal_handler_env_192___os, _get_signal_handler_163___os1444, _get_signal_handler_163___os, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( system_env_221___os, _system___os1445, _system___os, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( date_env_128___os, _date___os1446, _date___os, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( make_static_library_name_env_199___os, _make_static_library_name_240___os1447, _make_static_library_name_240___os, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( dirname_env_218___os, _dirname___os1448, _dirname___os, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( signal_env_180___os, _signal___os1449, _signal___os, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( prefix_env_157___os, _prefix___os1450, _prefix___os, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( make_shared_library_name_env_249___os, _make_shared_library_name_15___os1451, _make_shared_library_name_15___os, 0L, 1 );
DEFINE_STATIC_PROCEDURE( proc1382___os, _anonymous_1012__103___os1452, _anonymous_1012__103___os, 0L, 0 );
DEFINE_STATIC_PROCEDURE( proc1380___os, _anonymous_1011__26___os1453, _anonymous_1011__26___os, 0L, 0 );
DEFINE_STATIC_PROCEDURE( proc1378___os, _anonymous_1010__206___os1454, _anonymous_1010__206___os, 0L, 0 );
DEFINE_STATIC_PROCEDURE( proc1376___os, _anonymous_1009__195___os1455, _anonymous_1009__195___os, 0L, 0 );
DEFINE_STATIC_PROCEDURE( proc1374___os, _anonymous_1008__166___os1456, _anonymous_1008__166___os, 0L, 0 );
DEFINE_STATIC_PROCEDURE( proc1372___os, _anonymous_1007__55___os1457, _anonymous_1007__55___os, 0L, 0 );
DEFINE_STATIC_PROCEDURE( proc1370___os, _anonymous_1006__59___os1458, _anonymous_1006__59___os, 0L, 0 );
DEFINE_STRING( string1432___os, string1432___os1459, "PAIR", 4 );
DEFINE_STRING( string1427___os, string1427___os1460, "", 0 );
DEFINE_STRING( string1424___os, string1424___os1461, ".", 1 );
DEFINE_STRING( string1423___os, string1423___os1462, "/home/tahoe2/serrano/tmp/bigloo/runtime/./Ieee/string.scm", 57 );
DEFINE_STRING( string1418___os, string1418___os1463, "BSTRING", 7 );
DEFINE_STRING( string1417___os, string1417___os1464, "Illegal index", 13 );
DEFINE_STRING( string1416___os, string1416___os1465, "substring", 9 );
DEFINE_STRING( string1415___os, string1415___os1466, "UCHAR", 5 );
DEFINE_STRING( string1414___os, string1414___os1467, "index out of range", 18 );
DEFINE_STRING( string1413___os, string1413___os1468, "string-ref", 10 );
DEFINE_STRING( string1399___os, string1399___os1469, "/home/tahoe2/serrano/tmp/bigloo/runtime/Llib/os.scm", 51 );
DEFINE_STRING( string1398___os, string1398___os1470, "INT", 3 );
DEFINE_STRING( string1396___os, string1396___os1471, "Wrong number of arguments", 25 );
DEFINE_STRING( string1395___os, string1395___os1472, "/home/tahoe2/serrano/tmp/bigloo/runtime/./Llib/error.scm", 56 );
DEFINE_STRING( string1405___os, string1405___os1473, "STRING", 6 );
DEFINE_STRING( string1394___os, string1394___os1474, "Illegal signal", 14 );
DEFINE_STRING( string1393___os, string1393___os1475, "signal", 6 );
DEFINE_STRING( string1400___os, string1400___os1476, "PROCEDURE", 9 );
DEFINE_EXPORT_PROCEDURE( executable_name_env_184___os, _executable_name_113___os1477, _executable_name_113___os, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( chdir_env_87___os, _chdir___os1478, _chdir___os, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( suffix_env_109___os, _suffix___os1479, _suffix___os, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( make_file_name_env_223___os, _make_file_name_179___os1480, _make_file_name_179___os, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( command_line_env_109___os, _command_line_112___os1481, _command_line_112___os, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( getenv_env_98___os, _getenv___os1482, _getenv___os, 0L, 1 );



/* module-initialization */
obj_t module_initialization_70___os(long checksum_1056, char * from_1057)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___os))
{ 
require_initialization_114___os = 
BBOOL(((bool_t)0)); 
cnst_init_137___os(); 
imported_modules_init_94___os(); 
toplevel_init_63___os(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___os()
{ AN_OBJECT;
{ /* Llib/os.scm 18 */
symbol1368___os = 
string_to_symbol("@__OS"); 
symbol1369___os = 
string_to_symbol("OS-CLASS"); 
symbol1371___os = 
string_to_symbol("OS-NAME"); 
symbol1373___os = 
string_to_symbol("OS-ARCH"); 
symbol1375___os = 
string_to_symbol("OS-VERSION"); 
symbol1377___os = 
string_to_symbol("OS-TMP"); 
symbol1379___os = 
string_to_symbol("FILE-SEPARATOR"); 
symbol1381___os = 
string_to_symbol("PATH-SEPARATOR"); 
symbol1383___os = 
string_to_symbol("<ANONYMOUS:1012>"); 
symbol1384___os = 
string_to_symbol("<ANONYMOUS:1011>"); 
symbol1385___os = 
string_to_symbol("<ANONYMOUS:1010>"); 
symbol1386___os = 
string_to_symbol("<ANONYMOUS:1009>"); 
symbol1387___os = 
string_to_symbol("<ANONYMOUS:1008>"); 
symbol1388___os = 
string_to_symbol("<ANONYMOUS:1007>"); 
symbol1389___os = 
string_to_symbol("<ANONYMOUS:1006>"); 
symbol1390___os = 
string_to_symbol("COMMAND-LINE"); 
symbol1391___os = 
string_to_symbol("EXECUTABLE-NAME"); 
symbol1392___os = 
string_to_symbol("SIGNAL"); 
symbol1397___os = 
string_to_symbol("_SIGNAL"); 
symbol1401___os = 
string_to_symbol("GET-SIGNAL-HANDLER"); 
symbol1402___os = 
string_to_symbol("_GET-SIGNAL-HANDLER"); 
symbol1403___os = 
string_to_symbol("GETENV"); 
symbol1404___os = 
string_to_symbol("_GETENV"); 
symbol1406___os = 
string_to_symbol("SYSTEM"); 
symbol1407___os = 
string_to_symbol("_SYSTEM"); 
symbol1408___os = 
string_to_symbol("DATE"); 
symbol1409___os = 
string_to_symbol("CHDIR"); 
symbol1410___os = 
string_to_symbol("_CHDIR"); 
symbol1411___os = 
string_to_symbol("PWD"); 
symbol1412___os = 
string_to_symbol("BASENAME"); 
symbol1419___os = 
string_to_symbol("_BASENAME"); 
symbol1420___os = 
string_to_symbol("PREFIX"); 
symbol1421___os = 
string_to_symbol("_PREFIX"); 
symbol1422___os = 
string_to_symbol("DIRNAME"); 
symbol1425___os = 
string_to_symbol("_DIRNAME"); 
symbol1426___os = 
string_to_symbol("SUFFIX"); 
symbol1428___os = 
string_to_symbol("_SUFFIX"); 
symbol1429___os = 
string_to_symbol("MAKE-FILE-NAME"); 
symbol1430___os = 
string_to_symbol("_MAKE-FILE-NAME"); 
symbol1431___os = 
string_to_symbol("FIND-FILE/PATH"); 
symbol1433___os = 
string_to_symbol("_FIND-FILE/PATH1291"); 
symbol1434___os = 
string_to_symbol("MAKE-STATIC-LIBRARY-NAME"); 
symbol1435___os = 
string_to_symbol("_MAKE-STATIC-LIBRARY-NAME"); 
symbol1436___os = 
string_to_symbol("MAKE-SHARED-LIBRARY-NAME"); 
symbol1437___os = 
string_to_symbol("_MAKE-SHARED-LIBRARY-NAME"); 
return ( 
symbol1438___os = 
string_to_symbol("IMPORTED-MODULES-INIT"), BUNSPEC) ;} 
}



/* toplevel-init */
obj_t toplevel_init_63___os()
{ AN_OBJECT;
{ /* Llib/os.scm 18 */
{ /* Llib/os.scm 18 */
obj_t symbol1254_873;
symbol1254_873 = symbol1368___os; 
{ /* Llib/os.scm 18 */

PUSH_TRACE(symbol1254_873); BUNSPEC; 
{ /* Llib/os.scm 18 */
obj_t aux1253_874;
{ /* Llib/os.scm 90 */
obj_t symbol1226_838;
symbol1226_838 = symbol1369___os; 
{ /* Llib/os.scm 90 */

PUSH_TRACE(symbol1226_838); BUNSPEC; 
{ /* Llib/os.scm 90 */
obj_t _anonymous_1006__59_917;
_anonymous_1006__59_917 = proc1370___os; 
POP_TRACE(); 
os_class_179___os = _anonymous_1006__59_917; } } } 
{ /* Llib/os.scm 91 */
obj_t symbol1228_841;
symbol1228_841 = symbol1371___os; 
{ /* Llib/os.scm 91 */

PUSH_TRACE(symbol1228_841); BUNSPEC; 
{ /* Llib/os.scm 91 */
obj_t _anonymous_1007__55_916;
_anonymous_1007__55_916 = proc1372___os; 
POP_TRACE(); 
os_name_233___os = _anonymous_1007__55_916; } } } 
{ /* Llib/os.scm 92 */
obj_t symbol1230_844;
symbol1230_844 = symbol1373___os; 
{ /* Llib/os.scm 92 */

PUSH_TRACE(symbol1230_844); BUNSPEC; 
{ /* Llib/os.scm 92 */
obj_t _anonymous_1008__166_915;
_anonymous_1008__166_915 = proc1374___os; 
POP_TRACE(); 
os_arch_255___os = _anonymous_1008__166_915; } } } 
{ /* Llib/os.scm 93 */
obj_t symbol1232_847;
symbol1232_847 = symbol1375___os; 
{ /* Llib/os.scm 93 */

PUSH_TRACE(symbol1232_847); BUNSPEC; 
{ /* Llib/os.scm 93 */
obj_t _anonymous_1009__195_914;
_anonymous_1009__195_914 = proc1376___os; 
POP_TRACE(); 
os_version_65___os = _anonymous_1009__195_914; } } } 
{ /* Llib/os.scm 94 */
obj_t symbol1234_850;
symbol1234_850 = symbol1377___os; 
{ /* Llib/os.scm 94 */

PUSH_TRACE(symbol1234_850); BUNSPEC; 
{ /* Llib/os.scm 94 */
obj_t _anonymous_1010__206_913;
_anonymous_1010__206_913 = proc1378___os; 
POP_TRACE(); 
os_tmp_175___os = _anonymous_1010__206_913; } } } 
{ /* Llib/os.scm 95 */
obj_t symbol1236_853;
symbol1236_853 = symbol1379___os; 
{ /* Llib/os.scm 95 */

PUSH_TRACE(symbol1236_853); BUNSPEC; 
{ /* Llib/os.scm 95 */
obj_t _anonymous_1011__26_912;
_anonymous_1011__26_912 = proc1380___os; 
POP_TRACE(); 
file_separator_81___os = _anonymous_1011__26_912; } } } 
{ /* Llib/os.scm 96 */
obj_t symbol1238_856;
symbol1238_856 = symbol1381___os; 
{ /* Llib/os.scm 96 */

PUSH_TRACE(symbol1238_856); BUNSPEC; 
{ /* Llib/os.scm 96 */
obj_t _anonymous_1012__103_911;
_anonymous_1012__103_911 = proc1382___os; 
POP_TRACE(); 
aux1253_874 = ( 
path_separator_174___os = _anonymous_1012__103_911, BUNSPEC) ; } } } 
POP_TRACE(); 
return aux1253_874;} } } } 
}



/* <anonymous:1012> */
obj_t _anonymous_1012__103___os(obj_t env_918)
{ AN_OBJECT;
{ /* Llib/os.scm 96 */
{ 

{ /* Llib/os.scm 96 */
char aux_1126;
{ /* Llib/os.scm 96 */
obj_t symbol1252_871;
symbol1252_871 = symbol1383___os; 
{ /* Llib/os.scm 96 */

PUSH_TRACE(symbol1252_871); BUNSPEC; 
POP_TRACE(); 
aux_1126 = PATH_SEPARATOR; } } 
return 
BCHAR(aux_1126);} } } 
}



/* <anonymous:1011> */
obj_t _anonymous_1011__26___os(obj_t env_919)
{ AN_OBJECT;
{ /* Llib/os.scm 95 */
{ 

{ /* Llib/os.scm 95 */
char aux_1130;
{ /* Llib/os.scm 95 */
obj_t symbol1250_869;
symbol1250_869 = symbol1384___os; 
{ /* Llib/os.scm 95 */

PUSH_TRACE(symbol1250_869); BUNSPEC; 
POP_TRACE(); 
aux_1130 = FILE_SEPARATOR; } } 
return 
BCHAR(aux_1130);} } } 
}



/* <anonymous:1010> */
obj_t _anonymous_1010__206___os(obj_t env_920)
{ AN_OBJECT;
{ /* Llib/os.scm 94 */
{ 

{ /* Llib/os.scm 94 */
char * aux_1134;
{ /* Llib/os.scm 94 */
obj_t symbol1248_867;
symbol1248_867 = symbol1385___os; 
{ /* Llib/os.scm 94 */

PUSH_TRACE(symbol1248_867); BUNSPEC; 
POP_TRACE(); 
aux_1134 = OS_TMP; } } 
return 
string_to_bstring(aux_1134);} } } 
}



/* <anonymous:1009> */
obj_t _anonymous_1009__195___os(obj_t env_921)
{ AN_OBJECT;
{ /* Llib/os.scm 93 */
{ 

{ /* Llib/os.scm 93 */
char * aux_1138;
{ /* Llib/os.scm 93 */
obj_t symbol1246_865;
symbol1246_865 = symbol1386___os; 
{ /* Llib/os.scm 93 */

PUSH_TRACE(symbol1246_865); BUNSPEC; 
POP_TRACE(); 
aux_1138 = OS_VERSION; } } 
return 
string_to_bstring(aux_1138);} } } 
}



/* <anonymous:1008> */
obj_t _anonymous_1008__166___os(obj_t env_922)
{ AN_OBJECT;
{ /* Llib/os.scm 92 */
{ 

{ /* Llib/os.scm 92 */
char * aux_1142;
{ /* Llib/os.scm 92 */
obj_t symbol1244_863;
symbol1244_863 = symbol1387___os; 
{ /* Llib/os.scm 92 */

PUSH_TRACE(symbol1244_863); BUNSPEC; 
POP_TRACE(); 
aux_1142 = OS_ARCH; } } 
return 
string_to_bstring(aux_1142);} } } 
}



/* <anonymous:1007> */
obj_t _anonymous_1007__55___os(obj_t env_923)
{ AN_OBJECT;
{ /* Llib/os.scm 91 */
{ 

{ /* Llib/os.scm 91 */
char * aux_1146;
{ /* Llib/os.scm 91 */
obj_t symbol1242_861;
symbol1242_861 = symbol1388___os; 
{ /* Llib/os.scm 91 */

PUSH_TRACE(symbol1242_861); BUNSPEC; 
POP_TRACE(); 
aux_1146 = OS_NAME; } } 
return 
string_to_bstring(aux_1146);} } } 
}



/* <anonymous:1006> */
obj_t _anonymous_1006__59___os(obj_t env_924)
{ AN_OBJECT;
{ /* Llib/os.scm 90 */
{ 

{ /* Llib/os.scm 90 */
char * aux_1150;
{ /* Llib/os.scm 90 */
obj_t symbol1240_859;
symbol1240_859 = symbol1389___os; 
{ /* Llib/os.scm 90 */

PUSH_TRACE(symbol1240_859); BUNSPEC; 
POP_TRACE(); 
aux_1150 = OS_CLASS; } } 
return 
string_to_bstring(aux_1150);} } } 
}



/* command-line */
obj_t command_line_67___os()
{ AN_OBJECT;
{ /* Llib/os.scm 101 */
{ /* Llib/os.scm 101 */
obj_t symbol1256_875;
symbol1256_875 = symbol1390___os; 
{ /* Llib/os.scm 101 */

PUSH_TRACE(symbol1256_875); BUNSPEC; 
POP_TRACE(); 
return command_line;} } } 
}



/* _command-line */
obj_t _command_line_112___os(obj_t env_925)
{ AN_OBJECT;
{ /* Llib/os.scm 101 */
return 
command_line_67___os();} 
}



/* executable-name */
char * executable_name_99___os()
{ AN_OBJECT;
{ /* Llib/os.scm 107 */
{ /* Llib/os.scm 107 */
obj_t symbol1258_877;
symbol1258_877 = symbol1391___os; 
{ /* Llib/os.scm 107 */

PUSH_TRACE(symbol1258_877); BUNSPEC; 
POP_TRACE(); 
return executable_name;} } } 
}



/* _executable-name */
obj_t _executable_name_113___os(obj_t env_926)
{ AN_OBJECT;
{ /* Llib/os.scm 107 */
{ /* Llib/os.scm 107 */
char * aux_1159;
aux_1159 = 
executable_name_99___os(); 
return 
string_to_bstring(aux_1159);} } 
}



/* signal */
obj_t signal___os(int num_1, obj_t proc_2)
{ AN_OBJECT;
{ /* Llib/os.scm 113 */
{ /* Llib/os.scm 115 */
obj_t symbol1260_879;
symbol1260_879 = symbol1392___os; 
{ /* Llib/os.scm 115 */

PUSH_TRACE(symbol1260_879); BUNSPEC; 
{ /* Llib/os.scm 115 */
obj_t aux1259_880;
{ /* Llib/os.scm 115 */
bool_t test1013_263;
{ /* Llib/os.scm 115 */
long arg1016_266;
arg1016_266 = 
PROCEDURE_ARITY(proc_2); 
test1013_263 = 
(arg1016_266==((long)1)); } 
if(test1013_263)
{ /* Llib/os.scm 117 */
bool_t test_1166;
{ /* Llib/os.scm 117 */
bool_t test_1167;
{ /* ./Ieee/fixnum.scm 1578 */
long aux_1168;
aux_1168 = 
(long)(num_1); 
test_1167 = 
(aux_1168<((long)0)); } 
if(test_1167)
{ /* Llib/os.scm 117 */
test_1166 = ((bool_t)1)
; }  else 
{ /* ./Ieee/fixnum.scm 1584 */
long aux_1171;
aux_1171 = 
(long)(num_1); 
test_1166 = 
(aux_1171>((long)31)); } } 
if(test_1166)
{ /* Llib/os.scm 117 */
error_c_location_83___error(string1393___os, string1394___os, 
BINT(num_1), "Llib/os.scm", ((long)5491)); 
aux1259_880 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); }  else 
{ /* Llib/os.scm 117 */
aux1259_880 = 
c_signal(num_1, proc_2); } }  else 
{ /* Llib/os.scm 115 */
error_c_location_83___error(string1393___os, string1396___os, proc_2, "Llib/os.scm", ((long)5396)); 
aux1259_880 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); } } 
POP_TRACE(); 
return aux1259_880;} } } } 
}



/* _signal */
obj_t _signal___os(obj_t env_927, obj_t num_928, obj_t proc_929)
{ AN_OBJECT;
{ /* Llib/os.scm 113 */
{ /* Llib/os.scm 113 */
obj_t aux_1191;int aux_1183;
if(
PROCEDUREP(proc_929))
{ /* Llib/os.scm 113 */
aux_1191 = proc_929
; }  else 
{ /* Llib/os.scm 113 */
bigloo_type_error_location_103___error(symbol1397___os, string1400___os, proc_929, string1399___os, 
BINT(((long)5310))); 
exit( -1 );} 
{ /* Llib/os.scm 113 */
obj_t aux_1184;
if(
INTEGERP(num_928))
{ /* Llib/os.scm 113 */
aux_1184 = num_928
; }  else 
{ /* Llib/os.scm 113 */
bigloo_type_error_location_103___error(symbol1397___os, string1398___os, num_928, string1399___os, 
BINT(((long)5310))); 
exit( -1 );} 
aux_1183 = 
CINT(aux_1184); } 
return 
signal___os(aux_1183, aux_1191);} } 
}



/* get-signal-handler */
obj_t get_signal_handler_120___os(int num_3)
{ AN_OBJECT;
{ /* Llib/os.scm 125 */
{ /* Llib/os.scm 126 */
obj_t symbol1262_881;
symbol1262_881 = symbol1401___os; 
{ /* Llib/os.scm 126 */

PUSH_TRACE(symbol1262_881); BUNSPEC; 
{ /* Llib/os.scm 126 */
obj_t aux1261_882;
aux1261_882 = 
get_signal_handler(num_3); 
POP_TRACE(); 
return aux1261_882;} } } } 
}



/* _get-signal-handler */
obj_t _get_signal_handler_163___os(obj_t env_930, obj_t num_931)
{ AN_OBJECT;
{ /* Llib/os.scm 125 */
{ /* Llib/os.scm 125 */
int aux_1201;
{ /* Llib/os.scm 125 */
obj_t aux_1202;
if(
INTEGERP(num_931))
{ /* Llib/os.scm 125 */
aux_1202 = num_931
; }  else 
{ /* Llib/os.scm 125 */
bigloo_type_error_location_103___error(symbol1402___os, string1398___os, num_931, string1399___os, 
BINT(((long)5795))); 
exit( -1 );} 
aux_1201 = 
CINT(aux_1202); } 
return 
get_signal_handler_120___os(aux_1201);} } 
}



/* getenv */
obj_t getenv___os(char * string_4)
{ AN_OBJECT;
{ /* Llib/os.scm 131 */
{ /* Llib/os.scm 132 */
obj_t symbol1264_1034;
symbol1264_1034 = symbol1403___os; 
{ /* Llib/os.scm 132 */

PUSH_TRACE(symbol1264_1034); BUNSPEC; 
{ /* Llib/os.scm 132 */
obj_t aux1263_1035;
{ /* Llib/os.scm 132 */
bool_t test1018_1036;
test1018_1036 = 
(long)getenv(string_4); 
if(test1018_1036)
{ /* Llib/os.scm 133 */
char * aux_1213;
aux_1213 = 
(char *)getenv(string_4); 
aux1263_1035 = 
string_to_bstring(aux_1213); }  else 
{ /* Llib/os.scm 132 */
aux1263_1035 = BFALSE; } } 
POP_TRACE(); 
return aux1263_1035;} } } } 
}



/* _getenv */
obj_t _getenv___os(obj_t env_932, obj_t string_933)
{ AN_OBJECT;
{ /* Llib/os.scm 131 */
{ /* Llib/os.scm 131 */
char * string_1037;
{ /* Llib/os.scm 131 */
obj_t aux_1217;
if(
STRINGP(string_933))
{ /* Llib/os.scm 131 */
aux_1217 = string_933
; }  else 
{ /* Llib/os.scm 131 */
bigloo_type_error_location_103___error(symbol1404___os, string1405___os, string_933, string1399___os, 
BINT(((long)6082))); 
exit( -1 );} 
string_1037 = 
BSTRING_TO_STRING(aux_1217); } 
{ /* Llib/os.scm 132 */
obj_t symbol1264_1038;
symbol1264_1038 = symbol1403___os; 
{ /* Llib/os.scm 132 */

PUSH_TRACE(symbol1264_1038); BUNSPEC; 
{ /* Llib/os.scm 132 */
obj_t aux1263_1039;
{ /* Llib/os.scm 132 */
bool_t test1018_1040;
test1018_1040 = 
(long)getenv(string_1037); 
if(test1018_1040)
{ /* Llib/os.scm 133 */
char * aux_1227;
aux_1227 = 
(char *)getenv(string_1037); 
aux1263_1039 = 
string_to_bstring(aux_1227); }  else 
{ /* Llib/os.scm 132 */
aux1263_1039 = BFALSE; } } 
POP_TRACE(); 
return aux1263_1039;} } } } } 
}



/* system */
obj_t system___os(char * string_5)
{ AN_OBJECT;
{ /* Llib/os.scm 139 */
{ /* Llib/os.scm 140 */
obj_t symbol1266_1041;
symbol1266_1041 = symbol1406___os; 
{ /* Llib/os.scm 140 */

PUSH_TRACE(symbol1266_1041); BUNSPEC; 
{ /* Llib/os.scm 140 */
obj_t aux1265_1042;
{ /* Llib/os.scm 140 */
int aux_1232;
aux_1232 = 
system(string_5); 
aux1265_1042 = 
BINT(aux_1232); } 
POP_TRACE(); 
return aux1265_1042;} } } } 
}



/* _system */
obj_t _system___os(obj_t env_934, obj_t string_935)
{ AN_OBJECT;
{ /* Llib/os.scm 139 */
{ /* Llib/os.scm 139 */
char * string_1043;
{ /* Llib/os.scm 139 */
obj_t aux_1236;
if(
STRINGP(string_935))
{ /* Llib/os.scm 139 */
aux_1236 = string_935
; }  else 
{ /* Llib/os.scm 139 */
bigloo_type_error_location_103___error(symbol1407___os, string1405___os, string_935, string1399___os, 
BINT(((long)6399))); 
exit( -1 );} 
string_1043 = 
BSTRING_TO_STRING(aux_1236); } 
{ /* Llib/os.scm 140 */
obj_t symbol1266_1044;
symbol1266_1044 = symbol1406___os; 
{ /* Llib/os.scm 140 */

PUSH_TRACE(symbol1266_1044); BUNSPEC; 
{ /* Llib/os.scm 140 */
obj_t aux1265_1045;
{ /* Llib/os.scm 140 */
int aux_1244;
aux_1244 = 
system(string_1043); 
aux1265_1045 = 
BINT(aux_1244); } 
POP_TRACE(); 
return aux1265_1045;} } } } } 
}



/* date */
char * date___os()
{ AN_OBJECT;
{ /* Llib/os.scm 145 */
{ /* Llib/os.scm 146 */
obj_t symbol1268_1046;
symbol1268_1046 = symbol1408___os; 
{ /* Llib/os.scm 146 */

PUSH_TRACE(symbol1268_1046); BUNSPEC; 
{ /* Llib/os.scm 146 */
char * aux1267_1047;
aux1267_1047 = 
c_date(); 
POP_TRACE(); 
return aux1267_1047;} } } } 
}



/* _date */
obj_t _date___os(obj_t env_936)
{ AN_OBJECT;
{ /* Llib/os.scm 145 */
{ /* Llib/os.scm 145 */
char * aux_1251;
{ /* Llib/os.scm 145 */
char * res1439_1050;
{ /* Llib/os.scm 146 */
obj_t symbol1268_1048;
symbol1268_1048 = symbol1408___os; 
{ /* Llib/os.scm 146 */

PUSH_TRACE(symbol1268_1048); BUNSPEC; 
{ /* Llib/os.scm 146 */
char * aux1267_1049;
aux1267_1049 = 
c_date(); 
POP_TRACE(); 
res1439_1050 = aux1267_1049; } } } 
aux_1251 = res1439_1050; } 
return 
string_to_bstring(aux_1251);} } 
}



/* chdir */
obj_t chdir___os(char * dirname_6)
{ AN_OBJECT;
{ /* Llib/os.scm 151 */
{ /* Llib/os.scm 152 */
obj_t symbol1270_1051;
symbol1270_1051 = symbol1409___os; 
{ /* Llib/os.scm 152 */

PUSH_TRACE(symbol1270_1051); BUNSPEC; 
{ /* Llib/os.scm 152 */
obj_t aux1269_1052;
{ /* Llib/os.scm 152 */
int aux_1257;
aux_1257 = 
chdir(dirname_6); 
aux1269_1052 = 
BINT(aux_1257); } 
POP_TRACE(); 
return aux1269_1052;} } } } 
}



/* _chdir */
obj_t _chdir___os(obj_t env_937, obj_t dirname_938)
{ AN_OBJECT;
{ /* Llib/os.scm 151 */
{ /* Llib/os.scm 151 */
char * dirname_1053;
{ /* Llib/os.scm 151 */
obj_t aux_1261;
if(
STRINGP(dirname_938))
{ /* Llib/os.scm 151 */
aux_1261 = dirname_938
; }  else 
{ /* Llib/os.scm 151 */
bigloo_type_error_location_103___error(symbol1410___os, string1405___os, dirname_938, string1399___os, 
BINT(((long)6936))); 
exit( -1 );} 
dirname_1053 = 
BSTRING_TO_STRING(aux_1261); } 
{ /* Llib/os.scm 152 */
obj_t symbol1270_1054;
symbol1270_1054 = symbol1409___os; 
{ /* Llib/os.scm 152 */

PUSH_TRACE(symbol1270_1054); BUNSPEC; 
{ /* Llib/os.scm 152 */
obj_t aux1269_1055;
{ /* Llib/os.scm 152 */
int aux_1269;
aux_1269 = 
chdir(dirname_1053); 
aux1269_1055 = 
BINT(aux_1269); } 
POP_TRACE(); 
return aux1269_1055;} } } } } 
}



/* pwd */
obj_t pwd___os()
{ AN_OBJECT;
{ /* Llib/os.scm 157 */
{ /* Llib/os.scm 158 */
obj_t symbol1272_891;
symbol1272_891 = symbol1411___os; 
{ /* Llib/os.scm 158 */

PUSH_TRACE(symbol1272_891); BUNSPEC; 
{ /* Llib/os.scm 158 */
obj_t aux1271_892;
{ /* Llib/os.scm 158 */
obj_t string_269;
{ /* Llib/os.scm 158 */
obj_t res1210_495;
{ /* ./Ieee/string.scm 3214 */
long aux_1274;
{ /* ./Ieee/string.scm 3214 */
int aux_1275;
aux_1275 = 
(int)(((long)1024)); 
aux_1274 = 
(long)(aux_1275); } 
res1210_495 = 
make_string(aux_1274, ((unsigned char)' ')); } 
string_269 = res1210_495; } 
{ /* Llib/os.scm 159 */
char * aux_1279;
{ /* Llib/os.scm 159 */
int aux_1282;char * aux_1280;
aux_1282 = 
(int)(((long)1024)); 
aux_1280 = 
BSTRING_TO_STRING(string_269); 
aux_1279 = 
(char *)(long)getcwd(aux_1280, aux_1282); } 
aux1271_892 = 
string_to_bstring(aux_1279); } } 
POP_TRACE(); 
return aux1271_892;} } } } 
}



/* _pwd */
obj_t _pwd___os(obj_t env_939)
{ AN_OBJECT;
{ /* Llib/os.scm 157 */
return 
pwd___os();} 
}



/* basename */
obj_t basename___os(obj_t string_7)
{ AN_OBJECT;
{ /* Llib/os.scm 164 */
{ /* Llib/os.scm 165 */
obj_t symbol1274_893;
symbol1274_893 = symbol1412___os; 
{ /* Llib/os.scm 165 */

PUSH_TRACE(symbol1274_893); BUNSPEC; 
{ /* Llib/os.scm 165 */
obj_t aux1273_894;
{ /* Llib/os.scm 165 */
long len_271;
{ /* ./Ieee/fixnum.scm 1662 */
long aux_1289;
aux_1289 = 
STRING_LENGTH(string_7); 
len_271 = 
(aux_1289-((long)1)); } 
{ /* Llib/os.scm 165 */
long start_272;
{ /* Llib/os.scm 166 */
bool_t test1026_281;
if(
(len_271>((long)0)))
{ /* Llib/os.scm 167 */
unsigned char arg1028_283;
{ /* Llib/os.scm 167 */
unsigned char res1211_509;
{ /* ./Ieee/string.scm 3233 */
bool_t test_1294;
{ /* ./Ieee/string.scm 3233 */
long aux_1295;
aux_1295 = 
STRING_LENGTH(string_7); 
test_1294 = 
BOUND_CHECK(len_271, aux_1295); } 
if(test_1294)
{ /* ./Ieee/string.scm 3233 */
res1211_509 = 
STRING_REF(string_7, len_271); }  else 
{ /* ./Ieee/string.scm 3233 */
error_c_location_83___error(string1413___os, string1414___os, 
BINT(len_271), "./Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 444 */
obj_t aux_1301;
{ /* ./Llib/error.scm 444 */
obj_t aux1308_974;
aux1308_974 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); 
if(
CHARP(aux1308_974))
{ /* ./Llib/error.scm 444 */
aux_1301 = aux1308_974
; }  else 
{ /* ./Llib/error.scm 444 */
bigloo_type_error_location_103___error(symbol1412___os, string1415___os, aux1308_974, string1395___os, 
BINT(((long)7583))); 
exit( -1 );} } 
res1211_509 = 
(unsigned char)CCHAR(aux_1301); } } } 
arg1028_283 = res1211_509; } 
{ /* ./Ieee/char.scm 2863 */
unsigned char aux_1310;
aux_1310 = 
(unsigned char)(FILE_SEPARATOR); 
test1026_281 = 
(arg1028_283==aux_1310); } }  else 
{ /* Llib/os.scm 166 */
test1026_281 = ((bool_t)0); } 
if(test1026_281)
{ /* Llib/os.scm 166 */
start_272 = 
(len_271-((long)1)); }  else 
{ /* Llib/os.scm 166 */
start_272 = len_271; } } 
{ /* Llib/os.scm 166 */

{ 
long index_273;
index_273 = start_272; 
loop_274:
if(
(index_273==((long)-1)))
{ /* Llib/os.scm 172 */
aux1273_894 = string_7; }  else 
{ /* Llib/os.scm 174 */
bool_t test1021_276;
{ /* Llib/os.scm 174 */
unsigned char arg1025_280;
{ /* Llib/os.scm 174 */
unsigned char res1212_524;
{ /* ./Ieee/string.scm 3233 */
bool_t test_1317;
{ /* ./Ieee/string.scm 3233 */
long aux_1318;
aux_1318 = 
STRING_LENGTH(string_7); 
test_1317 = 
BOUND_CHECK(index_273, aux_1318); } 
if(test_1317)
{ /* ./Ieee/string.scm 3233 */
res1212_524 = 
STRING_REF(string_7, index_273); }  else 
{ /* ./Ieee/string.scm 3233 */
error_c_location_83___error(string1413___os, string1414___os, 
BINT(index_273), "./Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 444 */
obj_t aux_1324;
{ /* ./Llib/error.scm 444 */
obj_t aux1310_976;
aux1310_976 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); 
if(
CHARP(aux1310_976))
{ /* ./Llib/error.scm 444 */
aux_1324 = aux1310_976
; }  else 
{ /* ./Llib/error.scm 444 */
bigloo_type_error_location_103___error(symbol1412___os, string1415___os, aux1310_976, string1395___os, 
BINT(((long)7583))); 
exit( -1 );} } 
res1212_524 = 
(unsigned char)CCHAR(aux_1324); } } } 
arg1025_280 = res1212_524; } 
{ /* ./Ieee/char.scm 2863 */
unsigned char aux_1333;
aux_1333 = 
(unsigned char)(FILE_SEPARATOR); 
test1021_276 = 
(arg1025_280==aux_1333); } } 
if(test1021_276)
{ /* Llib/os.scm 174 */
{ /* Llib/os.scm 175 */
long arg1022_277;long arg1023_278;
arg1022_277 = 
(index_273+((long)1)); 
arg1023_278 = 
(start_272+((long)1)); 
{ /* Llib/os.scm 175 */
obj_t res1213_561;
{ /* ./Ieee/string.scm 3340 */
bool_t test_1339;
if(
(arg1023_278>=arg1022_277))
{ /* ./Ieee/string.scm 3341 */
bool_t test_1342;
{ /* ./Ieee/string.scm 3341 */
long aux_1343;
{ /* ./Ieee/fixnum.scm 1656 */
long aux_1344;
aux_1344 = 
STRING_LENGTH(string_7); 
aux_1343 = 
(aux_1344+((long)1)); } 
test_1342 = 
BOUND_CHECK(arg1022_277, aux_1343); } 
if(test_1342)
{ /* ./Ieee/string.scm 3342 */
long aux_1348;
{ /* ./Ieee/fixnum.scm 1656 */
long aux_1349;
aux_1349 = 
STRING_LENGTH(string_7); 
aux_1348 = 
(aux_1349+((long)1)); } 
test_1339 = 
BOUND_CHECK(arg1023_278, aux_1348); }  else 
{ /* ./Ieee/string.scm 3341 */
test_1339 = ((bool_t)0)
; } }  else 
{ /* ./Ieee/string.scm 3340 */
test_1339 = ((bool_t)0)
; } 
if(test_1339)
{ /* ./Ieee/string.scm 3340 */
res1213_561 = 
c_substring(string_7, arg1022_277, arg1023_278); }  else 
{ /* ./Ieee/string.scm 3340 */
{ /* ./Ieee/string.scm 3346 */
obj_t arg1091_545;
{ /* ./Ieee/pair-list.scm 2498 */
obj_t aux_1356;obj_t aux_1354;
aux_1356 = 
BINT(arg1023_278); 
aux_1354 = 
BINT(arg1022_277); 
arg1091_545 = 
MAKE_PAIR(aux_1354, aux_1356); } 
error_c_location_83___error(string1416___os, string1417___os, arg1091_545, "./Ieee/string.scm", ((long)13819)); } 
{ /* ./Llib/error.scm 444 */
obj_t aux1312_978;
aux1312_978 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); 
if(
STRINGP(aux1312_978))
{ /* ./Llib/error.scm 444 */
res1213_561 = aux1312_978; }  else 
{ /* ./Llib/error.scm 444 */
bigloo_type_error_location_103___error(symbol1412___os, string1418___os, aux1312_978, string1395___os, 
BINT(((long)7583))); 
exit( -1 );} } } } 
aux1273_894 = res1213_561; } } }  else 
{ /* Llib/os.scm 174 */
{ 
long index_1367;
index_1367 = 
(index_273-((long)1)); 
index_273 = index_1367; 
goto loop_274;} } } } } } } 
POP_TRACE(); 
return aux1273_894;} } } } 
}



/* _basename */
obj_t _basename___os(obj_t env_940, obj_t string_941)
{ AN_OBJECT;
{ /* Llib/os.scm 164 */
{ /* Llib/os.scm 164 */
obj_t aux_1370;
if(
STRINGP(string_941))
{ /* Llib/os.scm 164 */
aux_1370 = string_941
; }  else 
{ /* Llib/os.scm 164 */
bigloo_type_error_location_103___error(symbol1419___os, string1418___os, string_941, string1399___os, 
BINT(((long)7521))); 
exit( -1 );} 
return 
basename___os(aux_1370);} } 
}



/* prefix */
obj_t prefix___os(obj_t string_8)
{ AN_OBJECT;
{ /* Llib/os.scm 182 */
{ /* Llib/os.scm 183 */
obj_t symbol1276_895;
symbol1276_895 = symbol1420___os; 
{ /* Llib/os.scm 183 */

PUSH_TRACE(symbol1276_895); BUNSPEC; 
{ /* Llib/os.scm 183 */
obj_t aux1275_896;
{ /* Llib/os.scm 183 */
long len_286;
{ /* ./Ieee/fixnum.scm 1662 */
long aux_1378;
aux_1378 = 
STRING_LENGTH(string_8); 
len_286 = 
(aux_1378-((long)1)); } 
{ 
long e_287;long s_288;
e_287 = len_286; 
s_288 = len_286; 
loop_289:
if(
(s_288<=((long)0)))
{ /* Llib/os.scm 187 */
{ /* Llib/os.scm 188 */
long arg1033_292;
arg1033_292 = 
(((long)1)+e_287); 
{ /* Llib/os.scm 188 */
obj_t res1214_601;
{ /* ./Ieee/string.scm 3340 */
bool_t test_1384;
if(
(arg1033_292>=((long)0)))
{ /* ./Ieee/string.scm 3341 */
bool_t test_1387;
{ /* ./Ieee/string.scm 3341 */
long aux_1388;
{ /* ./Ieee/fixnum.scm 1656 */
long aux_1389;
aux_1389 = 
STRING_LENGTH(string_8); 
aux_1388 = 
(aux_1389+((long)1)); } 
test_1387 = 
BOUND_CHECK(((long)0), aux_1388); } 
if(test_1387)
{ /* ./Ieee/string.scm 3342 */
long aux_1393;
{ /* ./Ieee/fixnum.scm 1656 */
long aux_1394;
aux_1394 = 
STRING_LENGTH(string_8); 
aux_1393 = 
(aux_1394+((long)1)); } 
test_1384 = 
BOUND_CHECK(arg1033_292, aux_1393); }  else 
{ /* ./Ieee/string.scm 3341 */
test_1384 = ((bool_t)0)
; } }  else 
{ /* ./Ieee/string.scm 3340 */
test_1384 = ((bool_t)0)
; } 
if(test_1384)
{ /* ./Ieee/string.scm 3340 */
res1214_601 = 
c_substring(string_8, ((long)0), arg1033_292); }  else 
{ /* ./Ieee/string.scm 3340 */
{ /* ./Ieee/string.scm 3346 */
obj_t arg1091_585;
{ /* ./Ieee/pair-list.scm 2498 */
obj_t aux_1401;obj_t aux_1399;
aux_1401 = 
BINT(arg1033_292); 
aux_1399 = 
BINT(((long)0)); 
arg1091_585 = 
MAKE_PAIR(aux_1399, aux_1401); } 
error_c_location_83___error(string1416___os, string1417___os, arg1091_585, "./Ieee/string.scm", ((long)13819)); } 
{ /* ./Llib/error.scm 444 */
obj_t aux1316_982;
aux1316_982 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); 
if(
STRINGP(aux1316_982))
{ /* ./Llib/error.scm 444 */
res1214_601 = aux1316_982; }  else 
{ /* ./Llib/error.scm 444 */
bigloo_type_error_location_103___error(symbol1420___os, string1418___os, aux1316_982, string1395___os, 
BINT(((long)7583))); 
exit( -1 );} } } } 
aux1275_896 = res1214_601; } } }  else 
{ /* Llib/os.scm 187 */
{ /* Llib/os.scm 190 */
bool_t test1034_293;
{ /* Llib/os.scm 190 */
bool_t test1039_297;
{ /* Llib/os.scm 190 */
unsigned char arg1040_298;
{ /* Llib/os.scm 190 */
unsigned char res1215_610;
{ /* ./Ieee/string.scm 3233 */
bool_t test_1412;
{ /* ./Ieee/string.scm 3233 */
long aux_1413;
aux_1413 = 
STRING_LENGTH(string_8); 
test_1412 = 
BOUND_CHECK(s_288, aux_1413); } 
if(test_1412)
{ /* ./Ieee/string.scm 3233 */
res1215_610 = 
STRING_REF(string_8, s_288); }  else 
{ /* ./Ieee/string.scm 3233 */
error_c_location_83___error(string1413___os, string1414___os, 
BINT(s_288), "./Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 444 */
obj_t aux_1419;
{ /* ./Llib/error.scm 444 */
obj_t aux1318_984;
aux1318_984 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); 
if(
CHARP(aux1318_984))
{ /* ./Llib/error.scm 444 */
aux_1419 = aux1318_984
; }  else 
{ /* ./Llib/error.scm 444 */
bigloo_type_error_location_103___error(symbol1420___os, string1415___os, aux1318_984, string1395___os, 
BINT(((long)7583))); 
exit( -1 );} } 
res1215_610 = 
(unsigned char)CCHAR(aux_1419); } } } 
arg1040_298 = res1215_610; } 
{ /* ./Ieee/equiv.scm 3052 */
obj_t aux_1430;obj_t aux_1428;
aux_1430 = 
BCHAR(((unsigned char)'.')); 
aux_1428 = 
BCHAR(arg1040_298); 
test1039_297 = 
(aux_1428==aux_1430); } } 
if(test1039_297)
{ /* Llib/os.scm 190 */
test1034_293 = 
(e_287==len_286); }  else 
{ /* Llib/os.scm 190 */
test1034_293 = ((bool_t)0); } } 
if(test1034_293)
{ 
long s_1438;long e_1436;
e_1436 = 
(s_288-((long)1)); 
s_1438 = 
(s_288-((long)1)); 
s_288 = s_1438; 
e_287 = e_1436; 
goto loop_289;}  else 
{ 
long s_1440;
s_1440 = 
(s_288-((long)1)); 
s_288 = s_1440; 
goto loop_289;} } } } } 
POP_TRACE(); 
return aux1275_896;} } } } 
}



/* _prefix */
obj_t _prefix___os(obj_t env_942, obj_t string_943)
{ AN_OBJECT;
{ /* Llib/os.scm 182 */
{ /* Llib/os.scm 182 */
obj_t aux_1443;
if(
STRINGP(string_943))
{ /* Llib/os.scm 182 */
aux_1443 = string_943
; }  else 
{ /* Llib/os.scm 182 */
bigloo_type_error_location_103___error(symbol1421___os, string1418___os, string_943, string1399___os, 
BINT(((long)8167))); 
exit( -1 );} 
return 
prefix___os(aux_1443);} } 
}



/* dirname */
obj_t dirname___os(obj_t string_9)
{ AN_OBJECT;
{ /* Llib/os.scm 198 */
{ /* Llib/os.scm 199 */
obj_t symbol1278_897;
symbol1278_897 = symbol1422___os; 
{ /* Llib/os.scm 199 */

PUSH_TRACE(symbol1278_897); BUNSPEC; 
{ /* Llib/os.scm 199 */
obj_t aux1277_898;
{ 
long read_302;
{ /* Llib/os.scm 200 */
obj_t aux1332_998;
{ /* ./Ieee/fixnum.scm 1662 */
long aux_1540;
aux_1540 = 
STRING_LENGTH(string_9); 
read_302 = 
(aux_1540-((long)1)); } 
loop_303:
if(
(read_302<=((long)0)))
{ /* Llib/os.scm 202 */
{ /* Llib/os.scm 203 */
bool_t test1045_305;
{ /* Llib/os.scm 203 */
unsigned char arg1047_307;
{ /* Llib/os.scm 203 */
unsigned char res1216_634;
{ /* ./Ieee/string.scm 3233 */
bool_t test_1453;
{ /* ./Ieee/string.scm 3233 */
long aux_1454;
aux_1454 = 
STRING_LENGTH(string_9); 
test_1453 = 
BOUND_CHECK(read_302, aux_1454); } 
if(test_1453)
{ /* ./Ieee/string.scm 3233 */
res1216_634 = 
STRING_REF(string_9, read_302); }  else 
{ /* ./Ieee/string.scm 3233 */
error_c_location_83___error(string1413___os, string1414___os, 
BINT(read_302), "./Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 444 */
obj_t aux_1460;
{ /* ./Llib/error.scm 444 */
obj_t aux1322_988;
aux1322_988 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); 
if(
CHARP(aux1322_988))
{ /* ./Llib/error.scm 444 */
aux_1460 = aux1322_988
; }  else 
{ /* ./Llib/error.scm 444 */
bigloo_type_error_location_103___error(symbol1422___os, string1415___os, aux1322_988, string1395___os, 
BINT(((long)7583))); 
exit( -1 );} } 
res1216_634 = 
(unsigned char)CCHAR(aux_1460); } } } 
arg1047_307 = res1216_634; } 
{ /* ./Ieee/char.scm 2863 */
unsigned char aux_1469;
aux_1469 = 
(unsigned char)(FILE_SEPARATOR); 
test1045_305 = 
(arg1047_307==aux_1469); } } 
if(test1045_305)
{ /* Llib/os.scm 204 */
obj_t list1046_306;
{ /* Llib/os.scm 204 */
obj_t aux_1473;
aux_1473 = 
BCHAR(FILE_SEPARATOR); 
list1046_306 = 
MAKE_PAIR(aux_1473, BNIL); } 
{ /* Llib/os.scm 204 */
obj_t res1217_643;
{ /* ./Ieee/string.scm 3215 */
obj_t arg1109_640;
arg1109_640 = 
CAR(list1046_306); 
{ /* ./Ieee/string.scm 3215 */
unsigned char aux_1481;long aux_1477;
{ /* ./Ieee/string.scm 3215 */
obj_t aux_1482;
if(
CHARP(arg1109_640))
{ /* ./Ieee/string.scm 3215 */
aux_1482 = arg1109_640
; }  else 
{ /* ./Ieee/string.scm 3215 */
bigloo_type_error_location_103___error(symbol1422___os, string1415___os, arg1109_640, string1423___os, 
BINT(((long)7350))); 
exit( -1 );} 
aux_1481 = 
(unsigned char)CCHAR(aux_1482); } 
{ /* ./Ieee/string.scm 3215 */
int aux_1478;
aux_1478 = 
(int)(((long)1)); 
aux_1477 = 
(long)(aux_1478); } 
res1217_643 = 
make_string(aux_1477, aux_1481); } } 
aux1332_998 = res1217_643; } }  else 
{ /* Llib/os.scm 203 */
aux1332_998 = string1424___os; } } }  else 
{ /* Llib/os.scm 206 */
bool_t test1048_308;
{ /* Llib/os.scm 206 */
unsigned char arg1050_310;
{ /* Llib/os.scm 206 */
unsigned char res1218_652;
{ /* ./Ieee/string.scm 3233 */
bool_t test_1490;
{ /* ./Ieee/string.scm 3233 */
long aux_1491;
aux_1491 = 
STRING_LENGTH(string_9); 
test_1490 = 
BOUND_CHECK(read_302, aux_1491); } 
if(test_1490)
{ /* ./Ieee/string.scm 3233 */
res1218_652 = 
STRING_REF(string_9, read_302); }  else 
{ /* ./Ieee/string.scm 3233 */
error_c_location_83___error(string1413___os, string1414___os, 
BINT(read_302), "./Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 444 */
obj_t aux_1497;
{ /* ./Llib/error.scm 444 */
obj_t aux1328_994;
aux1328_994 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); 
if(
CHARP(aux1328_994))
{ /* ./Llib/error.scm 444 */
aux_1497 = aux1328_994
; }  else 
{ /* ./Llib/error.scm 444 */
bigloo_type_error_location_103___error(symbol1422___os, string1415___os, aux1328_994, string1395___os, 
BINT(((long)7583))); 
exit( -1 );} } 
res1218_652 = 
(unsigned char)CCHAR(aux_1497); } } } 
arg1050_310 = res1218_652; } 
{ /* ./Ieee/char.scm 2863 */
unsigned char aux_1506;
aux_1506 = 
(unsigned char)(FILE_SEPARATOR); 
test1048_308 = 
(arg1050_310==aux_1506); } } 
if(test1048_308)
{ /* Llib/os.scm 206 */
{ /* Llib/os.scm 207 */
obj_t res1219_685;
{ /* ./Ieee/string.scm 3340 */
bool_t test_1510;
if(
(read_302>=((long)0)))
{ /* ./Ieee/string.scm 3341 */
bool_t test_1513;
{ /* ./Ieee/string.scm 3341 */
long aux_1514;
{ /* ./Ieee/fixnum.scm 1656 */
long aux_1515;
aux_1515 = 
STRING_LENGTH(string_9); 
aux_1514 = 
(aux_1515+((long)1)); } 
test_1513 = 
BOUND_CHECK(((long)0), aux_1514); } 
if(test_1513)
{ /* ./Ieee/string.scm 3342 */
long aux_1519;
{ /* ./Ieee/fixnum.scm 1656 */
long aux_1520;
aux_1520 = 
STRING_LENGTH(string_9); 
aux_1519 = 
(aux_1520+((long)1)); } 
test_1510 = 
BOUND_CHECK(read_302, aux_1519); }  else 
{ /* ./Ieee/string.scm 3341 */
test_1510 = ((bool_t)0)
; } }  else 
{ /* ./Ieee/string.scm 3340 */
test_1510 = ((bool_t)0)
; } 
if(test_1510)
{ /* ./Ieee/string.scm 3340 */
res1219_685 = 
c_substring(string_9, ((long)0), read_302); }  else 
{ /* ./Ieee/string.scm 3340 */
{ /* ./Ieee/string.scm 3346 */
obj_t arg1091_669;
{ /* ./Ieee/pair-list.scm 2498 */
obj_t aux_1527;obj_t aux_1525;
aux_1527 = 
BINT(read_302); 
aux_1525 = 
BINT(((long)0)); 
arg1091_669 = 
MAKE_PAIR(aux_1525, aux_1527); } 
error_c_location_83___error(string1416___os, string1417___os, arg1091_669, "./Ieee/string.scm", ((long)13819)); } 
{ /* ./Llib/error.scm 444 */
obj_t aux1330_996;
aux1330_996 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); 
if(
STRINGP(aux1330_996))
{ /* ./Llib/error.scm 444 */
res1219_685 = aux1330_996; }  else 
{ /* ./Llib/error.scm 444 */
bigloo_type_error_location_103___error(symbol1422___os, string1418___os, aux1330_996, string1395___os, 
BINT(((long)7583))); 
exit( -1 );} } } } 
aux1332_998 = res1219_685; } }  else 
{ /* Llib/os.scm 206 */
{ 
long read_1538;
read_1538 = 
(read_302-((long)1)); 
read_302 = read_1538; 
goto loop_303;} } } 
if(
STRINGP(aux1332_998))
{ /* Llib/os.scm 200 */
aux1277_898 = aux1332_998; }  else 
{ /* Llib/os.scm 200 */
bigloo_type_error_location_103___error(symbol1422___os, string1418___os, aux1332_998, string1399___os, 
BINT(((long)8867))); 
exit( -1 );} } } 
POP_TRACE(); 
return aux1277_898;} } } } 
}



/* _dirname */
obj_t _dirname___os(obj_t env_944, obj_t string_945)
{ AN_OBJECT;
{ /* Llib/os.scm 198 */
{ /* Llib/os.scm 198 */
obj_t aux_1549;
if(
STRINGP(string_945))
{ /* Llib/os.scm 198 */
aux_1549 = string_945
; }  else 
{ /* Llib/os.scm 198 */
bigloo_type_error_location_103___error(symbol1425___os, string1418___os, string_945, string1399___os, 
BINT(((long)8789))); 
exit( -1 );} 
return 
dirname___os(aux_1549);} } 
}



/* suffix */
obj_t suffix___os(obj_t string_10)
{ AN_OBJECT;
{ /* Llib/os.scm 214 */
{ /* Llib/os.scm 215 */
obj_t symbol1280_899;
symbol1280_899 = symbol1426___os; 
{ /* Llib/os.scm 215 */

PUSH_TRACE(symbol1280_899); BUNSPEC; 
{ /* Llib/os.scm 215 */
obj_t aux1279_900;
{ /* Llib/os.scm 215 */
long len_313;
len_313 = 
STRING_LENGTH(string_10); 
{ /* Llib/os.scm 215 */
long len_1_56_314;
len_1_56_314 = 
(len_313-((long)1)); 
{ /* Llib/os.scm 216 */

{ 
long read_315;
{ /* Llib/os.scm 217 */
obj_t aux1342_1008;
read_315 = len_1_56_314; 
loop_316:
if(
(read_315<((long)0)))
{ /* Llib/os.scm 219 */
aux1342_1008 = string1427___os; }  else 
{ /* Llib/os.scm 221 */
bool_t test1054_318;
{ /* Llib/os.scm 221 */
unsigned char arg1064_324;
{ /* Llib/os.scm 221 */
unsigned char res1220_701;
{ /* ./Ieee/string.scm 3233 */
bool_t test_1561;
{ /* ./Ieee/string.scm 3233 */
long aux_1562;
aux_1562 = 
STRING_LENGTH(string_10); 
test_1561 = 
BOUND_CHECK(read_315, aux_1562); } 
if(test_1561)
{ /* ./Ieee/string.scm 3233 */
res1220_701 = 
STRING_REF(string_10, read_315); }  else 
{ /* ./Ieee/string.scm 3233 */
error_c_location_83___error(string1413___os, string1414___os, 
BINT(read_315), "./Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 444 */
obj_t aux_1568;
{ /* ./Llib/error.scm 444 */
obj_t aux1336_1002;
aux1336_1002 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); 
if(
CHARP(aux1336_1002))
{ /* ./Llib/error.scm 444 */
aux_1568 = aux1336_1002
; }  else 
{ /* ./Llib/error.scm 444 */
bigloo_type_error_location_103___error(symbol1426___os, string1415___os, aux1336_1002, string1395___os, 
BINT(((long)7583))); 
exit( -1 );} } 
res1220_701 = 
(unsigned char)CCHAR(aux_1568); } } } 
arg1064_324 = res1220_701; } 
{ /* ./Ieee/char.scm 2863 */
unsigned char aux_1577;
aux_1577 = 
(unsigned char)(FILE_SEPARATOR); 
test1054_318 = 
(arg1064_324==aux_1577); } } 
if(test1054_318)
{ /* Llib/os.scm 221 */
aux1342_1008 = string1427___os; }  else 
{ /* Llib/os.scm 223 */
bool_t test1055_319;
{ /* Llib/os.scm 223 */
unsigned char arg1063_323;
{ /* Llib/os.scm 223 */
unsigned char res1221_712;
{ /* ./Ieee/string.scm 3233 */
bool_t test_1581;
{ /* ./Ieee/string.scm 3233 */
long aux_1582;
aux_1582 = 
STRING_LENGTH(string_10); 
test_1581 = 
BOUND_CHECK(read_315, aux_1582); } 
if(test_1581)
{ /* ./Ieee/string.scm 3233 */
res1221_712 = 
STRING_REF(string_10, read_315); }  else 
{ /* ./Ieee/string.scm 3233 */
error_c_location_83___error(string1413___os, string1414___os, 
BINT(read_315), "./Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 444 */
obj_t aux_1588;
{ /* ./Llib/error.scm 444 */
obj_t aux1338_1004;
aux1338_1004 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); 
if(
CHARP(aux1338_1004))
{ /* ./Llib/error.scm 444 */
aux_1588 = aux1338_1004
; }  else 
{ /* ./Llib/error.scm 444 */
bigloo_type_error_location_103___error(symbol1426___os, string1415___os, aux1338_1004, string1395___os, 
BINT(((long)7583))); 
exit( -1 );} } 
res1221_712 = 
(unsigned char)CCHAR(aux_1588); } } } 
arg1063_323 = res1221_712; } 
test1055_319 = 
(arg1063_323==((unsigned char)'.')); } 
if(test1055_319)
{ /* Llib/os.scm 223 */
if(
(read_315==len_1_56_314))
{ /* Llib/os.scm 225 */
aux1342_1008 = string1427___os; }  else 
{ /* Llib/os.scm 225 */
{ /* Llib/os.scm 228 */
long arg1061_321;
arg1061_321 = 
(read_315+((long)1)); 
{ /* Llib/os.scm 228 */
obj_t res1222_749;
{ /* ./Ieee/string.scm 3340 */
bool_t test_1602;
if(
(len_313>=arg1061_321))
{ /* ./Ieee/string.scm 3341 */
bool_t test_1605;
{ /* ./Ieee/string.scm 3341 */
long aux_1606;
{ /* ./Ieee/fixnum.scm 1656 */
long aux_1607;
aux_1607 = 
STRING_LENGTH(string_10); 
aux_1606 = 
(aux_1607+((long)1)); } 
test_1605 = 
BOUND_CHECK(arg1061_321, aux_1606); } 
if(test_1605)
{ /* ./Ieee/string.scm 3342 */
long aux_1611;
{ /* ./Ieee/fixnum.scm 1656 */
long aux_1612;
aux_1612 = 
STRING_LENGTH(string_10); 
aux_1611 = 
(aux_1612+((long)1)); } 
test_1602 = 
BOUND_CHECK(len_313, aux_1611); }  else 
{ /* ./Ieee/string.scm 3341 */
test_1602 = ((bool_t)0)
; } }  else 
{ /* ./Ieee/string.scm 3340 */
test_1602 = ((bool_t)0)
; } 
if(test_1602)
{ /* ./Ieee/string.scm 3340 */
res1222_749 = 
c_substring(string_10, arg1061_321, len_313); }  else 
{ /* ./Ieee/string.scm 3340 */
{ /* ./Ieee/string.scm 3346 */
obj_t arg1091_733;
{ /* ./Ieee/pair-list.scm 2498 */
obj_t aux_1619;obj_t aux_1617;
aux_1619 = 
BINT(len_313); 
aux_1617 = 
BINT(arg1061_321); 
arg1091_733 = 
MAKE_PAIR(aux_1617, aux_1619); } 
error_c_location_83___error(string1416___os, string1417___os, arg1091_733, "./Ieee/string.scm", ((long)13819)); } 
{ /* ./Llib/error.scm 444 */
obj_t aux1340_1006;
aux1340_1006 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); 
if(
STRINGP(aux1340_1006))
{ /* ./Llib/error.scm 444 */
res1222_749 = aux1340_1006; }  else 
{ /* ./Llib/error.scm 444 */
bigloo_type_error_location_103___error(symbol1426___os, string1418___os, aux1340_1006, string1395___os, 
BINT(((long)7583))); 
exit( -1 );} } } } 
aux1342_1008 = res1222_749; } } } }  else 
{ /* Llib/os.scm 223 */
{ 
long read_1630;
read_1630 = 
(read_315-((long)1)); 
read_315 = read_1630; 
goto loop_316;} } } } 
if(
STRINGP(aux1342_1008))
{ /* Llib/os.scm 217 */
aux1279_900 = aux1342_1008; }  else 
{ /* Llib/os.scm 217 */
bigloo_type_error_location_103___error(symbol1426___os, string1418___os, aux1342_1008, string1399___os, 
BINT(((long)9476))); 
exit( -1 );} } } } } } 
POP_TRACE(); 
return aux1279_900;} } } } 
}



/* _suffix */
obj_t _suffix___os(obj_t env_946, obj_t string_947)
{ AN_OBJECT;
{ /* Llib/os.scm 214 */
{ /* Llib/os.scm 214 */
obj_t aux_1638;
if(
STRINGP(string_947))
{ /* Llib/os.scm 214 */
aux_1638 = string_947
; }  else 
{ /* Llib/os.scm 214 */
bigloo_type_error_location_103___error(symbol1428___os, string1418___os, string_947, string1399___os, 
BINT(((long)9376))); 
exit( -1 );} 
return 
suffix___os(aux_1638);} } 
}



/* make-file-name */
obj_t make_file_name_203___os(obj_t directory_11, obj_t file_12)
{ AN_OBJECT;
{ /* Llib/os.scm 238 */
{ /* Llib/os.scm 239 */
obj_t symbol1282_901;
symbol1282_901 = symbol1429___os; 
{ /* Llib/os.scm 239 */

PUSH_TRACE(symbol1282_901); BUNSPEC; 
{ /* Llib/os.scm 239 */
obj_t aux1281_902;
{ /* Llib/os.scm 239 */
long ldir_325;
ldir_325 = 
STRING_LENGTH(directory_11); 
{ /* Llib/os.scm 239 */
long lfile_326;
lfile_326 = 
STRING_LENGTH(file_12); 
{ /* Llib/os.scm 240 */
long len_327;
{ /* ./Ieee/fixnum.scm 1656 */
long aux_1648;
aux_1648 = 
(lfile_326+((long)1)); 
len_327 = 
(ldir_325+aux_1648); } 
{ /* Llib/os.scm 241 */
obj_t str_328;
{ /* Llib/os.scm 242 */
obj_t list1067_331;
{ /* Llib/os.scm 242 */
obj_t aux_1651;
aux_1651 = 
BCHAR(FILE_SEPARATOR); 
list1067_331 = 
MAKE_PAIR(aux_1651, BNIL); } 
{ /* Llib/os.scm 242 */
obj_t res1223_764;
{ /* ./Ieee/string.scm 3215 */
obj_t arg1109_761;
arg1109_761 = 
CAR(list1067_331); 
{ /* ./Ieee/string.scm 3215 */
unsigned char aux_1659;long aux_1655;
{ /* ./Ieee/string.scm 3215 */
obj_t aux_1660;
if(
CHARP(arg1109_761))
{ /* ./Ieee/string.scm 3215 */
aux_1660 = arg1109_761
; }  else 
{ /* ./Ieee/string.scm 3215 */
bigloo_type_error_location_103___error(symbol1429___os, string1415___os, arg1109_761, string1423___os, 
BINT(((long)7350))); 
exit( -1 );} 
aux_1659 = 
(unsigned char)CCHAR(aux_1660); } 
{ /* ./Ieee/string.scm 3215 */
int aux_1656;
aux_1656 = 
(int)(len_327); 
aux_1655 = 
(long)(aux_1656); } 
res1223_764 = 
make_string(aux_1655, aux_1659); } } 
str_328 = res1223_764; } } 
{ /* Llib/os.scm 242 */

{ /* ./Ieee/string.scm 3496 */
obj_t aux_1672;obj_t aux_1670;obj_t aux_1668;
aux_1672 = 
BINT(ldir_325); 
aux_1670 = 
BINT(((long)0)); 
aux_1668 = 
BINT(((long)0)); 
blit_string(directory_11, aux_1668, str_328, aux_1670, aux_1672); } 
{ /* ./Ieee/string.scm 3496 */
obj_t aux_1681;obj_t aux_1677;obj_t aux_1675;
aux_1681 = 
BINT(lfile_326); 
{ /* Llib/os.scm 244 */
long aux_1678;
aux_1678 = 
(((long)1)+ldir_325); 
aux_1677 = 
BINT(aux_1678); } 
aux_1675 = 
BINT(((long)0)); 
blit_string(file_12, aux_1675, str_328, aux_1677, aux_1681); } 
aux1281_902 = str_328; } } } } } 
POP_TRACE(); 
return aux1281_902;} } } } 
}



/* _make-file-name */
obj_t _make_file_name_179___os(obj_t env_948, obj_t directory_949, obj_t file_950)
{ AN_OBJECT;
{ /* Llib/os.scm 238 */
{ /* Llib/os.scm 238 */
obj_t aux_1691;obj_t aux_1685;
if(
STRINGP(file_950))
{ /* Llib/os.scm 238 */
aux_1691 = file_950
; }  else 
{ /* Llib/os.scm 238 */
bigloo_type_error_location_103___error(symbol1430___os, string1418___os, file_950, string1399___os, 
BINT(((long)10336))); 
exit( -1 );} 
if(
STRINGP(directory_949))
{ /* Llib/os.scm 238 */
aux_1685 = directory_949
; }  else 
{ /* Llib/os.scm 238 */
bigloo_type_error_location_103___error(symbol1430___os, string1418___os, directory_949, string1399___os, 
BINT(((long)10336))); 
exit( -1 );} 
return 
make_file_name_203___os(aux_1685, aux_1691);} } 
}



/* find-file/path */
obj_t find_file_path_55___os(obj_t file_name_128_13, obj_t path_14)
{ AN_OBJECT;
{ /* Llib/os.scm 250 */
{ /* Llib/os.scm 252 */
obj_t symbol1284_903;
symbol1284_903 = symbol1431___os; 
{ /* Llib/os.scm 252 */

PUSH_TRACE(symbol1284_903); BUNSPEC; 
{ /* Llib/os.scm 252 */
obj_t aux1283_904;
{ /* Llib/os.scm 252 */
bool_t test_1699;
{ /* ./Ieee/fixnum.scm 1572 */
long aux_1700;
aux_1700 = 
STRING_LENGTH(file_name_128_13); 
test_1699 = 
(aux_1700==((long)0)); } 
if(test_1699)
{ /* Llib/os.scm 252 */
aux1283_904 = BFALSE; }  else 
{ /* Llib/os.scm 254 */
bool_t test1070_334;
{ /* Llib/os.scm 254 */
unsigned char arg1076_343;
{ /* Llib/os.scm 254 */
unsigned char res1224_788;
{ /* ./Ieee/string.scm 3233 */
bool_t test_1703;
{ /* ./Ieee/string.scm 3233 */
long aux_1704;
aux_1704 = 
STRING_LENGTH(file_name_128_13); 
test_1703 = 
BOUND_CHECK(((long)0), aux_1704); } 
if(test_1703)
{ /* ./Ieee/string.scm 3233 */
res1224_788 = 
STRING_REF(file_name_128_13, ((long)0)); }  else 
{ /* ./Ieee/string.scm 3233 */
error_c_location_83___error(string1413___os, string1414___os, 
BINT(((long)0)), "./Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 444 */
obj_t aux_1710;
{ /* ./Llib/error.scm 444 */
obj_t aux1354_1020;
aux1354_1020 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1395___os, 
BINT(((long)7583))); 
if(
CHARP(aux1354_1020))
{ /* ./Llib/error.scm 444 */
aux_1710 = aux1354_1020
; }  else 
{ /* ./Llib/error.scm 444 */
bigloo_type_error_location_103___error(symbol1431___os, string1415___os, aux1354_1020, string1395___os, 
BINT(((long)7583))); 
exit( -1 );} } 
res1224_788 = 
(unsigned char)CCHAR(aux_1710); } } } 
arg1076_343 = res1224_788; } 
{ /* ./Ieee/char.scm 2863 */
unsigned char aux_1719;
aux_1719 = 
(unsigned char)(FILE_SEPARATOR); 
test1070_334 = 
(arg1076_343==aux_1719); } } 
if(test1070_334)
{ /* Llib/os.scm 254 */
{ /* Llib/os.scm 255 */
bool_t test1071_335;
{ /* ./Ieee/port.scm 3831 */
char * aux_1723;
aux_1723 = 
BSTRING_TO_STRING(file_name_128_13); 
test1071_335 = 
fexists(aux_1723); } 
if(test1071_335)
{ /* Llib/os.scm 255 */
aux1283_904 = file_name_128_13; }  else 
{ /* Llib/os.scm 255 */
aux1283_904 = BFALSE; } } }  else 
{ /* Llib/os.scm 254 */
{ 
obj_t path_336;
path_336 = path_14; 
loop_337:
if(
NULLP(path_336))
{ /* Llib/os.scm 260 */
aux1283_904 = BFALSE; }  else 
{ /* Llib/os.scm 262 */
obj_t fname_339;
{ /* Llib/os.scm 262 */
obj_t arg1075_342;
{ /* Llib/os.scm 262 */
obj_t pair_793;
if(
PAIRP(path_336))
{ /* Llib/os.scm 262 */
pair_793 = path_336; }  else 
{ /* Llib/os.scm 262 */
bigloo_type_error_location_103___error(symbol1431___os, string1432___os, path_336, string1399___os, 
BINT(((long)11229))); 
exit( -1 );} 
arg1075_342 = 
CAR(pair_793); } 
{ /* Llib/os.scm 262 */
obj_t aux_1735;
if(
STRINGP(arg1075_342))
{ /* Llib/os.scm 262 */
aux_1735 = arg1075_342
; }  else 
{ /* Llib/os.scm 262 */
bigloo_type_error_location_103___error(symbol1431___os, string1418___os, arg1075_342, string1399___os, 
BINT(((long)11212))); 
exit( -1 );} 
fname_339 = 
make_file_name_203___os(aux_1735, file_name_128_13); } } 
{ /* Llib/os.scm 263 */
bool_t test1073_340;
{ /* ./Ieee/port.scm 3831 */
char * aux_1742;
aux_1742 = 
BSTRING_TO_STRING(fname_339); 
test1073_340 = 
fexists(aux_1742); } 
if(test1073_340)
{ /* Llib/os.scm 263 */
aux1283_904 = fname_339; }  else 
{ /* Llib/os.scm 265 */
obj_t arg1074_341;
{ /* Llib/os.scm 265 */
obj_t pair_795;
if(
PAIRP(path_336))
{ /* Llib/os.scm 265 */
pair_795 = path_336; }  else 
{ /* Llib/os.scm 265 */
bigloo_type_error_location_103___error(symbol1431___os, string1432___os, path_336, string1399___os, 
BINT(((long)11307))); 
exit( -1 );} 
arg1074_341 = 
CDR(pair_795); } 
{ 
obj_t path_1752;
path_1752 = arg1074_341; 
path_336 = path_1752; 
goto loop_337;} } } } } } } } 
POP_TRACE(); 
return aux1283_904;} } } } 
}



/* _find-file/path1291 */
obj_t _find_file_path1291_240___os(obj_t env_951, obj_t file_name_128_952, obj_t path_953)
{ AN_OBJECT;
{ /* Llib/os.scm 250 */
{ /* Llib/os.scm 250 */
obj_t aux_1754;
if(
STRINGP(file_name_128_952))
{ /* Llib/os.scm 250 */
aux_1754 = file_name_128_952
; }  else 
{ /* Llib/os.scm 250 */
bigloo_type_error_location_103___error(symbol1433___os, string1418___os, file_name_128_952, string1399___os, 
BINT(((long)10888))); 
exit( -1 );} 
return 
find_file_path_55___os(aux_1754, path_953);} } 
}



/* make-static-library-name */
obj_t make_static_library_name_134___os(obj_t libname_15)
{ AN_OBJECT;
{ /* Llib/os.scm 272 */
{ /* Llib/os.scm 273 */
obj_t symbol1286_905;
symbol1286_905 = symbol1434___os; 
{ /* Llib/os.scm 273 */

PUSH_TRACE(symbol1286_905); BUNSPEC; 
{ /* Llib/os.scm 273 */
obj_t aux1285_906;
{ /* Llib/os.scm 273 */
obj_t arg1079_796;
{ /* Llib/os.scm 273 */
obj_t aux_1762;
aux_1762 = 
string_to_bstring(STATIC_LIB_SUFFIX); 
arg1079_796 = 
string_append(string1424___os, aux_1762); } 
aux1285_906 = 
string_append(libname_15, arg1079_796); } 
POP_TRACE(); 
return aux1285_906;} } } } 
}



/* _make-static-library-name */
obj_t _make_static_library_name_240___os(obj_t env_954, obj_t libname_955)
{ AN_OBJECT;
{ /* Llib/os.scm 272 */
{ /* Llib/os.scm 272 */
obj_t aux_1767;
if(
STRINGP(libname_955))
{ /* Llib/os.scm 272 */
aux_1767 = libname_955
; }  else 
{ /* Llib/os.scm 272 */
bigloo_type_error_location_103___error(symbol1435___os, string1418___os, libname_955, string1399___os, 
BINT(((long)11696))); 
exit( -1 );} 
return 
make_static_library_name_134___os(aux_1767);} } 
}



/* make-shared-library-name */
obj_t make_shared_library_name_78___os(obj_t libname_16)
{ AN_OBJECT;
{ /* Llib/os.scm 280 */
{ /* Llib/os.scm 281 */
obj_t symbol1288_907;
symbol1288_907 = symbol1436___os; 
{ /* Llib/os.scm 281 */

PUSH_TRACE(symbol1288_907); BUNSPEC; 
{ /* Llib/os.scm 281 */
obj_t aux1287_908;
{ /* Llib/os.scm 281 */
obj_t arg1080_797;
{ /* Llib/os.scm 281 */
obj_t aux_1775;
aux_1775 = 
string_to_bstring(SHARED_LIB_SUFFIX); 
arg1080_797 = 
string_append(string1424___os, aux_1775); } 
aux1287_908 = 
string_append(libname_16, arg1080_797); } 
POP_TRACE(); 
return aux1287_908;} } } } 
}



/* _make-shared-library-name */
obj_t _make_shared_library_name_15___os(obj_t env_956, obj_t libname_957)
{ AN_OBJECT;
{ /* Llib/os.scm 280 */
{ /* Llib/os.scm 280 */
obj_t aux_1780;
if(
STRINGP(libname_957))
{ /* Llib/os.scm 280 */
aux_1780 = libname_957
; }  else 
{ /* Llib/os.scm 280 */
bigloo_type_error_location_103___error(symbol1437___os, string1418___os, libname_957, string1399___os, 
BINT(((long)12174))); 
exit( -1 );} 
return 
make_shared_library_name_78___os(aux_1780);} } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___os()
{ AN_OBJECT;
{ /* Llib/os.scm 18 */
{ /* Llib/os.scm 18 */
obj_t symbol1290_909;
symbol1290_909 = symbol1438___os; 
{ /* Llib/os.scm 18 */

PUSH_TRACE(symbol1290_909); BUNSPEC; 
{ /* Llib/os.scm 18 */
obj_t aux1289_910;
aux1289_910 = 
module_initialization_70___error(((long)0), "__OS"); 
POP_TRACE(); 
return aux1289_910;} } } } 
}

