/*===========================================================================*/
/*   (Eval/evmeaning.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t unwind_until__178___bexit(obj_t, obj_t);
extern obj_t string_to_symbol(char *);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t evmeaning_notify_error_24___evmeaning(obj_t, obj_t, obj_t);
static obj_t _anonymous_1377__234___evmeaning(obj_t, obj_t);
static obj_t _evmeaning_notify_error_221___evmeaning(obj_t, obj_t, obj_t, obj_t);
static obj_t _anonymous_1368__42___evmeaning(obj_t, obj_t);
static obj_t _loop___27___evmeaning(obj_t, obj_t, obj_t, obj_t);
static obj_t _anonymous_1360__234___evmeaning(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _anonymous_1355__80___evmeaning(obj_t, obj_t, obj_t, obj_t);
extern obj_t exitd_top;
static obj_t toplevel_init_63___evmeaning();
static obj_t _anonymous_1347__225___evmeaning(obj_t, obj_t, obj_t);
static obj_t _evmeaning___evmeaning(obj_t, obj_t, obj_t);
static obj_t _anonymous_1343__133___evmeaning(obj_t, obj_t);
extern obj_t create_vector(long);
static obj_t _anonymous_1337__6___evmeaning(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _anonymous_1333__236___evmeaning(obj_t, obj_t, obj_t, obj_t);
static obj_t _anonymous_1330__135___evmeaning(obj_t, obj_t, obj_t);
extern obj_t init_the_global_environment__144___evenv();
static obj_t _anonymous_1328__33___evmeaning(obj_t, obj_t);
extern obj_t warning_location_135___error(obj_t, obj_t, obj_t);
static obj_t __dummy_____evmeaning(obj_t, obj_t);
static obj_t _anonymous_1321__117___evmeaning(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t warning___error(obj_t);
static obj_t _anonymous_1316__103___evmeaning(obj_t, obj_t, obj_t, obj_t);
static obj_t _anonymous_1309__69___evmeaning(obj_t, obj_t, obj_t);
static obj_t _anonymous_1298__87___evmeaning(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _anonymous_1305__208___evmeaning(obj_t, obj_t);
static obj_t _anonymous_1294__155___evmeaning(obj_t, obj_t, obj_t, obj_t);
extern obj_t evmeaning_reset_error__111___evmeaning();
static obj_t _anonymous_1303__124___evmeaning(obj_t);
static obj_t _evmeaning_reset_error__115___evmeaning(obj_t);
static obj_t _anonymous_1291__214___evmeaning(obj_t, obj_t, obj_t);
static obj_t _anonymous_1289__5___evmeaning(obj_t, obj_t);
static obj_t _anonymous_1288__199___evmeaning(obj_t);
extern obj_t evmeaning___evmeaning(obj_t, obj_t);
extern obj_t eval_lookup_172___evenv(obj_t);
static obj_t handling_function1134___evmeaning(obj_t, obj_t);
static obj_t handling_function1127___evmeaning(obj_t, obj_t);
extern obj_t eval_apply(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70___evmeaning(long, char *);
extern obj_t module_initialization_70___evcompile(long, char *);
extern obj_t module_initialization_70___type(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___bigloo(long, char *);
extern obj_t module_initialization_70___tvector(long, char *);
extern obj_t module_initialization_70___structure(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___os(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_flonum(long, char *);
extern obj_t module_initialization_70___r4_characters_6_6(long, char *);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___r4_booleans_6_1(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_input_6_10_2(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
extern obj_t module_initialization_70___r4_ports_6_10_1(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t module_initialization_70___progn(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t error_location_file_107___error(obj_t, obj_t);
extern obj_t notify_error_43___error(obj_t, obj_t, obj_t);
extern obj_t bind_eval_global__246___evenv(obj_t, obj_t);
extern obj_t error_location_112___error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t evmeaning_error_137___evmeaning(obj_t, obj_t, obj_t, obj_t);
static obj_t _loop____evmeaning(obj_t, obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94___evmeaning();
extern obj_t val_from_exit__100___bexit(obj_t);
static obj_t require_initialization_114___evmeaning = BUNSPEC;
extern obj_t eval_funcall_4(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t eval_funcall_3(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t eval_funcall_2(obj_t, obj_t, obj_t, obj_t);
extern obj_t eval_funcall_1(obj_t, obj_t, obj_t);
extern obj_t eval_funcall_0(obj_t, obj_t);
static obj_t evmeaning_warning_75___evmeaning(obj_t, obj_t);
static obj_t _current_bcode__25___evmeaning = BUNSPEC;
static obj_t symbol1607___evmeaning = BUNSPEC;
static obj_t cnst_init_137___evmeaning();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( evmeaning_env_72___evmeaning, _evmeaning___evmeaning1609, _evmeaning___evmeaning, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( evmeaning_reset_error__env_190___evmeaning, _evmeaning_reset_error__115___evmeaning1610, _evmeaning_reset_error__115___evmeaning, 0L, 0 );
DEFINE_STRING( string1606___evmeaning, string1606___evmeaning1611, "Too few arguments provided", 26 );
DEFINE_STRING( string1605___evmeaning, string1605___evmeaning1612, "Too many arguments provided", 27 );
DEFINE_STRING( string1604___evmeaning, string1604___evmeaning1613, "unknown byte-code", 17 );
DEFINE_STRING( string1603___evmeaning, string1603___evmeaning1614, "evmeaning (internal error)", 26 );
DEFINE_STRING( string1602___evmeaning, string1602___evmeaning1615, "redefinition of variable -- ", 28 );
DEFINE_STRING( string1601___evmeaning, string1601___evmeaning1616, "Unbound variable", 16 );
DEFINE_STRING( string1600___evmeaning, string1600___evmeaning1617, "eval", 4 );
DEFINE_EXPORT_PROCEDURE( evmeaning_notify_error_env_6___evmeaning, _evmeaning_notify_error_221___evmeaning1618, _evmeaning_notify_error_221___evmeaning, 0L, 3 );



/* module-initialization */
obj_t module_initialization_70___evmeaning(long checksum_2485, char * from_2486)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___evmeaning))
{ 
require_initialization_114___evmeaning = 
BBOOL(((bool_t)0)); 
cnst_init_137___evmeaning(); 
imported_modules_init_94___evmeaning(); 
toplevel_init_63___evmeaning(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___evmeaning()
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 14 */
return ( 
symbol1607___evmeaning = 
string_to_symbol("AT"), BUNSPEC) ;} 
}



/* toplevel-init */
obj_t toplevel_init_63___evmeaning()
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 14 */
_current_bcode__25___evmeaning = BFALSE; 
return 
init_the_global_environment__144___evenv();} 
}



/* evmeaning */
obj_t evmeaning___evmeaning(obj_t exp_1, obj_t stack_2)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 62 */
evmeaning___evmeaning:
if(
VECTORP(exp_1))
{ /* Eval/evmeaning.scm 63 */
_current_bcode__25___evmeaning = exp_1; 
{ /* Eval/evmeaning.scm 66 */
obj_t aux1010_340;
aux1010_340 = 
VECTOR_REF(exp_1, ((long)0)); 
if(
INTEGERP(aux1010_340))
{ /* Eval/evmeaning.scm 66 */
switch( 
(long)CINT(aux1010_340)) { case ((long)-2) : 

{ /* Eval/evmeaning.scm 69 */
obj_t aux_2510;obj_t aux_2504;obj_t aux_2500;
{ /* ./Ieee/pair-list.scm 4981 */
obj_t aux_2511;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2512;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2513;
aux_2513 = 
VECTOR_REF(exp_1, ((long)2)); 
aux_2512 = 
CDR(aux_2513); } 
aux_2511 = 
CDR(aux_2512); } 
aux_2510 = 
CAR(aux_2511); } 
{ /* ./Ieee/pair-list.scm 4981 */
obj_t aux_2505;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2506;
aux_2506 = 
VECTOR_REF(exp_1, ((long)2)); 
aux_2505 = 
CDR(aux_2506); } 
aux_2504 = 
CAR(aux_2505); } 
{ /* ./Ieee/pair-list.scm 4981 */
obj_t aux_2501;
aux_2501 = 
VECTOR_REF(exp_1, ((long)2)); 
aux_2500 = 
CAR(aux_2501); } 
return 
evmeaning_error_137___evmeaning(exp_1, aux_2500, aux_2504, aux_2510);} break;case ((long)-1) : 

return 
VECTOR_REF(exp_1, ((long)2));break;case ((long)0) : 

return 
CAR(stack_2);break;case ((long)1) : 

{ /* ./Ieee/pair-list.scm 4981 */
obj_t aux_2521;
aux_2521 = 
CDR(stack_2); 
return 
CAR(aux_2521);} break;case ((long)2) : 

{ /* ./Ieee/pair-list.scm 4981 */
obj_t aux_2524;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2525;
aux_2525 = 
CDR(stack_2); 
aux_2524 = 
CDR(aux_2525); } 
return 
CAR(aux_2524);} break;case ((long)3) : 

{ /* ./Ieee/pair-list.scm 4981 */
obj_t aux_2529;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2530;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2531;
aux_2531 = 
CDR(stack_2); 
aux_2530 = 
CDR(aux_2531); } 
aux_2529 = 
CDR(aux_2530); } 
return 
CAR(aux_2529);} break;case ((long)4) : 

{ /* Eval/evmeaning.scm 90 */
obj_t offset_348;
offset_348 = 
VECTOR_REF(exp_1, ((long)2)); 
{ 
long i_1148;obj_t env_1149;
i_1148 = ((long)4); 
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2546;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2547;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2548;
aux_2548 = 
CDR(stack_2); 
aux_2547 = 
CDR(aux_2548); } 
aux_2546 = 
CDR(aux_2547); } 
env_1149 = 
CDR(aux_2546); } 
do_loop__1011_191_1147:
{ /* Eval/evmeaning.scm 91 */
bool_t test_2537;
{ /* ./Ieee/fixnum.scm 3247 */
long aux_2538;
aux_2538 = 
(long)CINT(offset_348); 
test_2537 = 
(i_1148==aux_2538); } 
if(test_2537)
{ /* Eval/evmeaning.scm 91 */
return 
CAR(env_1149);}  else 
{ /* Eval/evmeaning.scm 91 */
{ 
obj_t env_2544;long i_2542;
i_2542 = 
(i_1148+((long)1)); 
env_2544 = 
CDR(env_1149); 
env_1149 = env_2544; 
i_1148 = i_2542; 
goto do_loop__1011_191_1147;} } } } } break;case ((long)5) : 

{ /* Eval/evmeaning.scm 96 */
obj_t aux_2553;
{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2554;
aux_2554 = 
VECTOR_REF(exp_1, ((long)2)); 
aux_2553 = 
VECTOR_REF(aux_2554, ((long)2)); } 
return 
__EVMEANING_ADDRESS_REF(aux_2553);} break;case ((long)6) : 

{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2558;
aux_2558 = 
VECTOR_REF(exp_1, ((long)2)); 
return 
VECTOR_REF(aux_2558, ((long)2));} break;case ((long)7) : 

{ /* Eval/evmeaning.scm 103 */
obj_t name_362;
name_362 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 103 */
obj_t global_363;
global_363 = 
eval_lookup_172___evenv(name_362); 
{ /* Eval/evmeaning.scm 104 */

{ /* Eval/evmeaning.scm 105 */
bool_t test_2563;
if(
VECTORP(global_363))
{ /* ./Ieee/fixnum.scm 3247 */
long aux_2566;
aux_2566 = 
VECTOR_LENGTH(global_363); 
test_2563 = 
(aux_2566==((long)3)); }  else 
{ /* ./Eval/evenv.scm 6480 */
test_2563 = ((bool_t)0)
; } 
if(test_2563)
{ /* Eval/evmeaning.scm 105 */
{ /* ./Ieee/vector.scm 5624 */
obj_t aux_2569;
aux_2569 = 
BINT(((long)6)); 
VECTOR_SET(exp_1, ((long)0), aux_2569); } 
VECTOR_SET(exp_1, ((long)2), global_363); 
return 
VECTOR_REF(global_363, ((long)2));}  else 
{ /* Eval/evmeaning.scm 105 */
return 
evmeaning_error_137___evmeaning(exp_1, string1600___evmeaning, string1601___evmeaning, name_362);} } } } } break;case ((long)8) : 

{ /* Eval/evmeaning.scm 118 */
obj_t var_365;obj_t val_366;
{ /* ./Ieee/pair-list.scm 4981 */
obj_t aux_2575;
aux_2575 = 
VECTOR_REF(exp_1, ((long)2)); 
var_365 = 
CAR(aux_2575); } 
{ /* Eval/evmeaning.scm 119 */
obj_t aux_2578;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2579;
aux_2579 = 
VECTOR_REF(exp_1, ((long)2)); 
aux_2578 = 
CDR(aux_2579); } 
val_366 = 
evmeaning___evmeaning(aux_2578, stack_2); } 
{ /* Eval/evmeaning.scm 734 */
bool_t test_2583;
{ /* ./Ieee/equiv.scm 4102 */
obj_t aux_2586;obj_t aux_2584;
aux_2586 = 
BINT(((long)1)); 
aux_2584 = 
VECTOR_REF(var_365, ((long)0)); 
test_2583 = 
(aux_2584==aux_2586); } 
if(test_2583)
{ /* Eval/evmeaning.scm 735 */
obj_t aux_2589;
aux_2589 = 
VECTOR_REF(var_365, ((long)2)); 
__EVMEANING_ADDRESS_SET(aux_2589, val_366); }  else 
{ /* Eval/evmeaning.scm 734 */
VECTOR_SET(var_365, ((long)2), val_366); } } 
VECTOR_REF(var_365, ((long)1)); 
return BUNSPEC;} break;case ((long)9) : 

{ /* Eval/evmeaning.scm 123 */
obj_t name_370;
{ /* ./Ieee/pair-list.scm 4981 */
obj_t aux_2594;
aux_2594 = 
VECTOR_REF(exp_1, ((long)2)); 
name_370 = 
CAR(aux_2594); } 
{ /* Eval/evmeaning.scm 123 */
obj_t value_371;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2597;
aux_2597 = 
VECTOR_REF(exp_1, ((long)2)); 
value_371 = 
CDR(aux_2597); } 
{ /* Eval/evmeaning.scm 124 */
obj_t global_372;
global_372 = 
eval_lookup_172___evenv(name_370); 
{ /* Eval/evmeaning.scm 125 */

{ /* Eval/evmeaning.scm 126 */
bool_t test_2601;
if(
VECTORP(global_372))
{ /* ./Ieee/fixnum.scm 3247 */
long aux_2604;
aux_2604 = 
VECTOR_LENGTH(global_372); 
test_2601 = 
(aux_2604==((long)3)); }  else 
{ /* ./Eval/evenv.scm 6480 */
test_2601 = ((bool_t)0)
; } 
if(test_2601)
{ /* Eval/evmeaning.scm 126 */
{ /* ./Ieee/vector.scm 5624 */
obj_t aux_2607;
aux_2607 = 
BINT(((long)8)); 
VECTOR_SET(exp_1, ((long)0), aux_2607); } 
{ /* Eval/evmeaning.scm 129 */
obj_t arg1066_375;
arg1066_375 = 
MAKE_PAIR(global_372, value_371); 
VECTOR_SET(exp_1, ((long)2), arg1066_375); } 
{ 

goto evmeaning___evmeaning;} }  else 
{ /* Eval/evmeaning.scm 126 */
return 
evmeaning_error_137___evmeaning(exp_1, string1600___evmeaning, string1601___evmeaning, name_370);} } } } } } break;case ((long)10) : 

{ /* Eval/evmeaning.scm 137 */
obj_t arg1069_378;
arg1069_378 = 
evmeaning___evmeaning(
VECTOR_REF(exp_1, ((long)2)), stack_2); 
SET_CAR(stack_2, arg1069_378); } 
return BUNSPEC;break;case ((long)11) : 

{ /* Eval/evmeaning.scm 141 */
obj_t arg1071_380;obj_t arg1072_381;
arg1071_380 = 
CDR(stack_2); 
arg1072_381 = 
evmeaning___evmeaning(
VECTOR_REF(exp_1, ((long)2)), stack_2); 
SET_CAR(arg1071_380, arg1072_381); } 
return BUNSPEC;break;case ((long)12) : 

{ /* Eval/evmeaning.scm 145 */
obj_t arg1074_383;obj_t arg1075_384;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2620;
aux_2620 = 
CDR(stack_2); 
arg1074_383 = 
CDR(aux_2620); } 
arg1075_384 = 
evmeaning___evmeaning(
VECTOR_REF(exp_1, ((long)2)), stack_2); 
SET_CAR(arg1074_383, arg1075_384); } 
return BUNSPEC;break;case ((long)13) : 

{ /* Eval/evmeaning.scm 150 */
obj_t arg1077_386;obj_t arg1078_387;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2626;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2627;
aux_2627 = 
CDR(stack_2); 
aux_2626 = 
CDR(aux_2627); } 
arg1077_386 = 
CDR(aux_2626); } 
arg1078_387 = 
evmeaning___evmeaning(
VECTOR_REF(exp_1, ((long)2)), stack_2); 
SET_CAR(arg1077_386, arg1078_387); } 
return BUNSPEC;break;case ((long)14) : 

{ /* Eval/evmeaning.scm 155 */
obj_t offset_389;obj_t value_390;
{ /* ./Ieee/pair-list.scm 4981 */
obj_t aux_2634;
aux_2634 = 
VECTOR_REF(exp_1, ((long)2)); 
offset_389 = 
CAR(aux_2634); } 
{ /* Eval/evmeaning.scm 156 */
obj_t aux_2637;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2638;
aux_2638 = 
VECTOR_REF(exp_1, ((long)2)); 
aux_2637 = 
CDR(aux_2638); } 
value_390 = 
evmeaning___evmeaning(aux_2637, stack_2); } 
{ 
long i_1308;obj_t env_1309;
i_1308 = ((long)4); 
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2651;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2652;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2653;
aux_2653 = 
CDR(stack_2); 
aux_2652 = 
CDR(aux_2653); } 
aux_2651 = 
CDR(aux_2652); } 
env_1309 = 
CDR(aux_2651); } 
do_loop__1012_232_1307:
{ /* Eval/evmeaning.scm 157 */
bool_t test_2642;
{ /* ./Ieee/fixnum.scm 3247 */
long aux_2643;
aux_2643 = 
(long)CINT(offset_389); 
test_2642 = 
(i_1308==aux_2643); } 
if(test_2642)
{ /* Eval/evmeaning.scm 157 */
SET_CAR(env_1309, value_390); }  else 
{ /* Eval/evmeaning.scm 157 */
{ 
obj_t env_2649;long i_2647;
i_2647 = 
(i_1308+((long)1)); 
env_2649 = 
CDR(env_1309); 
env_1309 = env_2649; 
i_1308 = i_2647; 
goto do_loop__1012_232_1307;} } } } 
return BUNSPEC;} break;case ((long)15) : 

{ /* Eval/evmeaning.scm 163 */
obj_t value_404;
value_404 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 164 */
bool_t test1089_405;
{ /* Eval/evmeaning.scm 164 */
obj_t aux_2659;
aux_2659 = 
evmeaning___evmeaning(
VECTOR_REF(value_404, ((long)0)), stack_2); 
test1089_405 = 
CBOOL(aux_2659); } 
if(test1089_405)
{ 
obj_t exp_2664;
exp_2664 = 
VECTOR_REF(value_404, ((long)1)); 
exp_1 = exp_2664; 
goto evmeaning___evmeaning;}  else 
{ 
obj_t exp_2666;
exp_2666 = 
VECTOR_REF(value_404, ((long)2)); 
exp_1 = exp_2666; 
goto evmeaning___evmeaning;} } } break;case ((long)16) : 

{ /* Eval/evmeaning.scm 169 */
obj_t exps_409;
exps_409 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 169 */
long len_410;
{ /* ./Ieee/fixnum.scm 3337 */
long aux_2669;
aux_2669 = 
VECTOR_LENGTH(exps_409); 
len_410 = 
(aux_2669-((long)1)); } 
{ /* Eval/evmeaning.scm 170 */

if(
(len_410==((long)0)))
{ /* Eval/evmeaning.scm 171 */
return BUNSPEC;}  else 
{ 
long i_412;
i_412 = ((long)0); 
loop_413:
if(
(i_412==len_410))
{ 
obj_t exp_2676;
exp_2676 = 
VECTOR_REF(exps_409, i_412); 
exp_1 = exp_2676; 
goto evmeaning___evmeaning;}  else 
{ /* Eval/evmeaning.scm 174 */
evmeaning___evmeaning(
VECTOR_REF(exps_409, i_412), stack_2); 
{ 
long i_2680;
i_2680 = 
(i_412+((long)1)); 
i_412 = i_2680; 
goto loop_413;} } } } } } break;case ((long)17) : 

{ /* Eval/evmeaning.scm 181 */
obj_t var_420;obj_t val_421;
{ /* ./Ieee/pair-list.scm 4981 */
obj_t aux_2682;
aux_2682 = 
VECTOR_REF(exp_1, ((long)2)); 
var_420 = 
CAR(aux_2682); } 
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2685;
aux_2685 = 
VECTOR_REF(exp_1, ((long)2)); 
val_421 = 
CDR(aux_2685); } 
{ /* Eval/evmeaning.scm 183 */
obj_t cell_422;
cell_422 = 
eval_lookup_172___evenv(var_420); 
{ /* Eval/evmeaning.scm 184 */
bool_t test_2689;
if(
VECTORP(cell_422))
{ /* ./Ieee/fixnum.scm 3247 */
long aux_2692;
aux_2692 = 
VECTOR_LENGTH(cell_422); 
test_2689 = 
(aux_2692==((long)3)); }  else 
{ /* ./Eval/evenv.scm 6480 */
test_2689 = ((bool_t)0)
; } 
if(test_2689)
{ /* Eval/evmeaning.scm 184 */
{ /* Eval/evmeaning.scm 186 */
obj_t list1101_424;
{ /* Eval/evmeaning.scm 186 */
obj_t arg1103_426;
{ /* Eval/evmeaning.scm 186 */
obj_t arg1104_427;
{ /* Eval/evmeaning.scm 186 */
obj_t arg1106_429;
arg1106_429 = 
MAKE_PAIR(var_420, BNIL); 
arg1104_427 = 
MAKE_PAIR(string1602___evmeaning, arg1106_429); } 
{ /* Eval/evmeaning.scm 186 */
obj_t aux_2697;
aux_2697 = 
BCHAR(((unsigned char)'\n')); 
arg1103_426 = 
MAKE_PAIR(aux_2697, arg1104_427); } } 
list1101_424 = 
MAKE_PAIR(string1600___evmeaning, arg1103_426); } 
evmeaning_warning_75___evmeaning(exp_1, list1101_424); } 
{ /* Eval/evmeaning.scm 192 */
obj_t arg1107_430;
{ /* Eval/evmeaning.scm 192 */
obj_t arg1108_431;
arg1108_431 = 
PROCEDURE_ENTRY(val_421)(val_421, BEOA); 
arg1107_430 = 
evmeaning___evmeaning(arg1108_431, BNIL); } 
{ /* Eval/evmeaning.scm 734 */
bool_t test_2705;
{ /* ./Ieee/equiv.scm 4102 */
obj_t aux_2708;obj_t aux_2706;
aux_2708 = 
BINT(((long)1)); 
aux_2706 = 
VECTOR_REF(cell_422, ((long)0)); 
test_2705 = 
(aux_2706==aux_2708); } 
if(test_2705)
{ /* Eval/evmeaning.scm 735 */
obj_t aux_2711;
aux_2711 = 
VECTOR_REF(cell_422, ((long)2)); 
__EVMEANING_ADDRESS_SET(aux_2711, arg1107_430); }  else 
{ /* Eval/evmeaning.scm 734 */
VECTOR_SET(cell_422, ((long)2), arg1107_430); } } 
VECTOR_REF(cell_422, ((long)1)); } }  else 
{ /* Eval/evmeaning.scm 193 */
obj_t cell_433;
{ /* Eval/evmeaning.scm 193 */
obj_t v1013_437;
v1013_437 = 
create_vector(((long)3)); 
VECTOR_SET(v1013_437, ((long)2), BUNSPEC); 
VECTOR_SET(v1013_437, ((long)1), var_420); 
{ /* ./Ieee/vector.scm 5624 */
obj_t aux_2719;
aux_2719 = 
BINT(((long)0)); 
VECTOR_SET(v1013_437, ((long)0), aux_2719); } 
cell_433 = v1013_437; } 
bind_eval_global__246___evenv(var_420, cell_433); 
{ /* Eval/evmeaning.scm 197 */
obj_t value_434;
{ /* Eval/evmeaning.scm 197 */
obj_t arg1110_435;
arg1110_435 = 
PROCEDURE_ENTRY(val_421)(val_421, BEOA); 
value_434 = 
evmeaning___evmeaning(arg1110_435, BNIL); } 
VECTOR_SET(cell_433, ((long)2), value_434); } } } 
return var_420;} } break;case ((long)63) : 

{ /* Eval/evmeaning.scm 202 */
obj_t var_442;
{ /* ./Ieee/pair-list.scm 4981 */
obj_t aux_2727;
aux_2727 = 
VECTOR_REF(exp_1, ((long)2)); 
var_442 = 
CAR(aux_2727); } 
{ /* Eval/evmeaning.scm 203 */
obj_t value_444;
{ /* Eval/evmeaning.scm 204 */
obj_t aux_2730;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2731;
aux_2731 = 
VECTOR_REF(exp_1, ((long)2)); 
aux_2730 = 
CDR(aux_2731); } 
value_444 = 
evmeaning___evmeaning(aux_2730, BNIL); } 
{ /* Eval/evmeaning.scm 204 */

{ /* Eval/evmeaning.scm 205 */
obj_t cell_445;
cell_445 = 
eval_lookup_172___evenv(var_442); 
{ /* Eval/evmeaning.scm 206 */
bool_t test_2736;
if(
VECTORP(cell_445))
{ /* ./Ieee/fixnum.scm 3247 */
long aux_2739;
aux_2739 = 
VECTOR_LENGTH(cell_445); 
test_2736 = 
(aux_2739==((long)3)); }  else 
{ /* ./Eval/evenv.scm 6480 */
test_2736 = ((bool_t)0)
; } 
if(test_2736)
{ /* Eval/evmeaning.scm 206 */
{ /* Eval/evmeaning.scm 208 */
obj_t list1117_447;
{ /* Eval/evmeaning.scm 208 */
obj_t arg1119_449;
{ /* Eval/evmeaning.scm 208 */
obj_t arg1120_450;
{ /* Eval/evmeaning.scm 208 */
obj_t arg1122_452;
arg1122_452 = 
MAKE_PAIR(var_442, BNIL); 
arg1120_450 = 
MAKE_PAIR(string1602___evmeaning, arg1122_452); } 
{ /* Eval/evmeaning.scm 208 */
obj_t aux_2744;
aux_2744 = 
BCHAR(((unsigned char)'\n')); 
arg1119_449 = 
MAKE_PAIR(aux_2744, arg1120_450); } } 
list1117_447 = 
MAKE_PAIR(string1600___evmeaning, arg1119_449); } 
evmeaning_warning_75___evmeaning(exp_1, list1117_447); } 
{ /* Eval/evmeaning.scm 734 */
bool_t test_2749;
{ /* ./Ieee/equiv.scm 4102 */
obj_t aux_2752;obj_t aux_2750;
aux_2752 = 
BINT(((long)1)); 
aux_2750 = 
VECTOR_REF(cell_445, ((long)0)); 
test_2749 = 
(aux_2750==aux_2752); } 
if(test_2749)
{ /* Eval/evmeaning.scm 735 */
obj_t aux_2755;
aux_2755 = 
VECTOR_REF(cell_445, ((long)2)); 
__EVMEANING_ADDRESS_SET(aux_2755, value_444); }  else 
{ /* Eval/evmeaning.scm 734 */
VECTOR_SET(cell_445, ((long)2), value_444); } } 
VECTOR_REF(cell_445, ((long)1)); }  else 
{ /* Eval/evmeaning.scm 214 */
obj_t cell_453;
{ /* Eval/evmeaning.scm 214 */
obj_t v1014_454;
v1014_454 = 
create_vector(((long)3)); 
VECTOR_SET(v1014_454, ((long)2), BUNSPEC); 
VECTOR_SET(v1014_454, ((long)1), var_442); 
{ /* ./Ieee/vector.scm 5624 */
obj_t aux_2763;
aux_2763 = 
BINT(((long)0)); 
VECTOR_SET(v1014_454, ((long)0), aux_2763); } 
cell_453 = v1014_454; } 
bind_eval_global__246___evenv(var_442, cell_453); 
VECTOR_SET(cell_453, ((long)2), value_444); } } 
return var_442;} } } } break;case ((long)18) : 

return 
handling_function1127___evmeaning(stack_2, exp_1);break;case ((long)64) : 

{ /* Eval/evmeaning.scm 227 */
obj_t protect_469;
{ /* ./Ieee/pair-list.scm 4987 */
obj_t aux_2769;
aux_2769 = 
VECTOR_REF(exp_1, ((long)2)); 
protect_469 = 
CDR(aux_2769); } 
{ /* Eval/evmeaning.scm 229 */
obj_t val1019_470;
{ /* Eval/evmeaning.scm 230 */
obj_t aux_2772;
{ /* ./Ieee/pair-list.scm 4981 */
obj_t aux_2773;
aux_2773 = 
VECTOR_REF(exp_1, ((long)2)); 
aux_2772 = 
CAR(aux_2773); } 
val1019_470 = 
handling_function1134___evmeaning(stack_2, aux_2772); } 
evmeaning___evmeaning(protect_469, stack_2); 
{ /* Eval/evmeaning.scm 230 */
bool_t test1131_471;
{ /* Eval/evmeaning.scm 230 */
obj_t aux_2778;
aux_2778 = 
val_from_exit__100___bexit(val1019_470); 
test1131_471 = 
CBOOL(aux_2778); } 
if(test1131_471)
{ /* Eval/evmeaning.scm 230 */
return 
unwind_until__178___bexit(
CAR(val1019_470), 
CDR(val1019_470));}  else 
{ /* Eval/evmeaning.scm 230 */
return val1019_470;} } } } break;case ((long)19) : 

{ /* Eval/evmeaning.scm 233 */
obj_t value_479;
value_479 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 233 */
obj_t name_480;
name_480 = 
VECTOR_REF(value_479, ((long)0)); 
{ /* Eval/evmeaning.scm 234 */
obj_t fun_481;
{ /* Eval/evmeaning.scm 235 */
obj_t aux_2787;
{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2788;
aux_2788 = 
VECTOR_REF(value_479, ((long)1)); 
aux_2787 = 
VECTOR_REF(aux_2788, ((long)2)); } 
fun_481 = 
__EVMEANING_ADDRESS_REF(aux_2787); } 
{ /* Eval/evmeaning.scm 235 */

return 
eval_funcall_0(name_480, fun_481);} } } } break;case ((long)57) : 

{ /* Eval/evmeaning.scm 239 */
obj_t value_484;
value_484 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 241 */

{ /* Eval/evmeaning.scm 242 */
obj_t aux_2796;obj_t aux_2794;
{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2797;
aux_2797 = 
VECTOR_REF(value_484, ((long)1)); 
aux_2796 = 
VECTOR_REF(aux_2797, ((long)2)); } 
aux_2794 = 
VECTOR_REF(value_484, ((long)0)); 
return 
eval_funcall_0(aux_2794, aux_2796);} } } break;case ((long)20) : 

{ /* Eval/evmeaning.scm 245 */
obj_t value_488;
value_488 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 245 */
obj_t name_489;
name_489 = 
VECTOR_REF(value_488, ((long)0)); 
{ /* Eval/evmeaning.scm 246 */
obj_t fun_490;
{ /* Eval/evmeaning.scm 247 */
obj_t aux_2803;
{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2804;
aux_2804 = 
VECTOR_REF(value_488, ((long)1)); 
aux_2803 = 
VECTOR_REF(aux_2804, ((long)2)); } 
fun_490 = 
__EVMEANING_ADDRESS_REF(aux_2803); } 
{ /* Eval/evmeaning.scm 247 */

{ /* Eval/evmeaning.scm 250 */
obj_t arg1141_491;
arg1141_491 = 
evmeaning___evmeaning(
VECTOR_REF(value_488, ((long)2)), stack_2); 
return 
eval_funcall_1(name_489, fun_490, arg1141_491);} } } } } break;case ((long)58) : 

{ /* Eval/evmeaning.scm 252 */
obj_t value_495;
value_495 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 252 */
obj_t name_496;
name_496 = 
VECTOR_REF(value_495, ((long)0)); 
{ /* Eval/evmeaning.scm 253 */
obj_t fun_497;
{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2813;
aux_2813 = 
VECTOR_REF(value_495, ((long)1)); 
fun_497 = 
VECTOR_REF(aux_2813, ((long)2)); } 
{ /* Eval/evmeaning.scm 254 */

{ /* Eval/evmeaning.scm 256 */
obj_t arg1145_498;
arg1145_498 = 
evmeaning___evmeaning(
VECTOR_REF(value_495, ((long)2)), stack_2); 
return 
eval_funcall_1(name_496, fun_497, arg1145_498);} } } } } break;case ((long)21) : 

{ /* Eval/evmeaning.scm 259 */
obj_t value_501;
value_501 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 259 */
obj_t name_502;
name_502 = 
VECTOR_REF(value_501, ((long)0)); 
{ /* Eval/evmeaning.scm 260 */
obj_t fun_503;
{ /* Eval/evmeaning.scm 261 */
obj_t aux_2821;
{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2822;
aux_2822 = 
VECTOR_REF(value_501, ((long)1)); 
aux_2821 = 
VECTOR_REF(aux_2822, ((long)2)); } 
fun_503 = 
__EVMEANING_ADDRESS_REF(aux_2821); } 
{ /* Eval/evmeaning.scm 261 */

{ /* Eval/evmeaning.scm 264 */
obj_t arg1148_504;obj_t arg1150_505;
arg1148_504 = 
evmeaning___evmeaning(
VECTOR_REF(value_501, ((long)2)), stack_2); 
arg1150_505 = 
evmeaning___evmeaning(
VECTOR_REF(value_501, ((long)3)), stack_2); 
return 
eval_funcall_2(name_502, fun_503, arg1148_504, arg1150_505);} } } } } break;case ((long)59) : 

{ /* Eval/evmeaning.scm 267 */
obj_t value_510;
value_510 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 267 */
obj_t name_511;
name_511 = 
VECTOR_REF(value_510, ((long)0)); 
{ /* Eval/evmeaning.scm 268 */
obj_t fun_512;
{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2833;
aux_2833 = 
VECTOR_REF(value_510, ((long)1)); 
fun_512 = 
VECTOR_REF(aux_2833, ((long)2)); } 
{ /* Eval/evmeaning.scm 269 */

{ /* Eval/evmeaning.scm 271 */
obj_t arg1155_513;obj_t arg1156_514;
arg1155_513 = 
evmeaning___evmeaning(
VECTOR_REF(value_510, ((long)2)), stack_2); 
arg1156_514 = 
evmeaning___evmeaning(
VECTOR_REF(value_510, ((long)3)), stack_2); 
return 
eval_funcall_2(name_511, fun_512, arg1155_513, arg1156_514);} } } } } break;case ((long)22) : 

{ /* Eval/evmeaning.scm 275 */
obj_t value_518;
value_518 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 275 */
obj_t name_519;
name_519 = 
VECTOR_REF(value_518, ((long)0)); 
{ /* Eval/evmeaning.scm 276 */
obj_t fun_520;
{ /* Eval/evmeaning.scm 277 */
obj_t aux_2843;
{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2844;
aux_2844 = 
VECTOR_REF(value_518, ((long)1)); 
aux_2843 = 
VECTOR_REF(aux_2844, ((long)2)); } 
fun_520 = 
__EVMEANING_ADDRESS_REF(aux_2843); } 
{ /* Eval/evmeaning.scm 277 */

{ /* Eval/evmeaning.scm 280 */
obj_t arg1160_521;obj_t arg1161_522;obj_t arg1162_523;
arg1160_521 = 
evmeaning___evmeaning(
VECTOR_REF(value_518, ((long)2)), stack_2); 
arg1161_522 = 
evmeaning___evmeaning(
VECTOR_REF(value_518, ((long)3)), stack_2); 
arg1162_523 = 
evmeaning___evmeaning(
VECTOR_REF(value_518, ((long)4)), stack_2); 
return 
eval_funcall_3(name_519, fun_520, arg1160_521, arg1161_522, arg1162_523);} } } } } break;case ((long)60) : 

{ /* Eval/evmeaning.scm 284 */
obj_t value_529;
value_529 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 284 */
obj_t name_530;
name_530 = 
VECTOR_REF(value_529, ((long)0)); 
{ /* Eval/evmeaning.scm 285 */
obj_t fun_531;
{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2857;
aux_2857 = 
VECTOR_REF(value_529, ((long)1)); 
fun_531 = 
VECTOR_REF(aux_2857, ((long)2)); } 
{ /* Eval/evmeaning.scm 286 */

{ /* Eval/evmeaning.scm 288 */
obj_t arg1168_532;obj_t arg1169_533;obj_t arg1170_534;
arg1168_532 = 
evmeaning___evmeaning(
VECTOR_REF(value_529, ((long)2)), stack_2); 
arg1169_533 = 
evmeaning___evmeaning(
VECTOR_REF(value_529, ((long)3)), stack_2); 
arg1170_534 = 
evmeaning___evmeaning(
VECTOR_REF(value_529, ((long)4)), stack_2); 
return 
eval_funcall_3(name_530, fun_531, arg1168_532, arg1169_533, arg1170_534);} } } } } break;case ((long)23) : 

{ /* Eval/evmeaning.scm 293 */
obj_t value_539;
value_539 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 293 */
obj_t name_540;
name_540 = 
VECTOR_REF(value_539, ((long)0)); 
{ /* Eval/evmeaning.scm 294 */
obj_t fun_541;
{ /* Eval/evmeaning.scm 295 */
obj_t aux_2869;
{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2870;
aux_2870 = 
VECTOR_REF(value_539, ((long)1)); 
aux_2869 = 
VECTOR_REF(aux_2870, ((long)2)); } 
fun_541 = 
__EVMEANING_ADDRESS_REF(aux_2869); } 
{ /* Eval/evmeaning.scm 295 */

{ /* Eval/evmeaning.scm 298 */
obj_t arg1175_542;obj_t arg1176_543;obj_t arg1177_544;obj_t arg1178_545;
arg1175_542 = 
evmeaning___evmeaning(
VECTOR_REF(value_539, ((long)2)), stack_2); 
arg1176_543 = 
evmeaning___evmeaning(
VECTOR_REF(value_539, ((long)3)), stack_2); 
arg1177_544 = 
evmeaning___evmeaning(
VECTOR_REF(value_539, ((long)4)), stack_2); 
arg1178_545 = 
evmeaning___evmeaning(
VECTOR_REF(value_539, ((long)5)), stack_2); 
return 
eval_funcall_4(name_540, fun_541, arg1175_542, arg1176_543, arg1177_544, arg1178_545);} } } } } break;case ((long)61) : 

{ /* Eval/evmeaning.scm 303 */
obj_t value_552;
value_552 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 303 */
obj_t name_553;
name_553 = 
VECTOR_REF(value_552, ((long)0)); 
{ /* Eval/evmeaning.scm 304 */
obj_t fun_554;
{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2885;
aux_2885 = 
VECTOR_REF(value_552, ((long)1)); 
fun_554 = 
VECTOR_REF(aux_2885, ((long)2)); } 
{ /* Eval/evmeaning.scm 305 */

{ /* Eval/evmeaning.scm 307 */
obj_t arg1185_555;obj_t arg1186_556;obj_t arg1187_557;obj_t arg1188_558;
arg1185_555 = 
evmeaning___evmeaning(
VECTOR_REF(value_552, ((long)2)), stack_2); 
arg1186_556 = 
evmeaning___evmeaning(
VECTOR_REF(value_552, ((long)3)), stack_2); 
arg1187_557 = 
evmeaning___evmeaning(
VECTOR_REF(value_552, ((long)4)), stack_2); 
arg1188_558 = 
evmeaning___evmeaning(
VECTOR_REF(value_552, ((long)5)), stack_2); 
return 
eval_funcall_4(name_553, fun_554, arg1185_555, arg1186_556, arg1187_557, arg1188_558);} } } } } break;case ((long)24) : 

{ /* Eval/evmeaning.scm 313 */
obj_t value_564;
value_564 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 313 */
obj_t name_565;
name_565 = 
VECTOR_REF(value_564, ((long)0)); 
{ /* Eval/evmeaning.scm 314 */
obj_t fun_566;
{ /* Eval/evmeaning.scm 315 */
obj_t aux_2899;
{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2900;
aux_2900 = 
VECTOR_REF(value_564, ((long)1)); 
aux_2899 = 
VECTOR_REF(aux_2900, ((long)2)); } 
fun_566 = 
__EVMEANING_ADDRESS_REF(aux_2899); } 
{ /* Eval/evmeaning.scm 317 */

{ /* Eval/evmeaning.scm 320 */
obj_t arg1195_568;
{ 
obj_t args_1625;obj_t res_1626;
args_1625 = 
VECTOR_REF(value_564, ((long)2)); 
res_1626 = BNIL; 
loop_1624:
if(
NULLP(args_1625))
{ /* Eval/evmeaning.scm 322 */
arg1195_568 = 
reverse__39___r4_pairs_and_lists_6_3(res_1626); }  else 
{ /* Eval/evmeaning.scm 324 */
obj_t arg1198_1633;obj_t arg1201_1634;
arg1198_1633 = 
CDR(args_1625); 
{ /* Eval/evmeaning.scm 325 */
obj_t arg1202_1635;
arg1202_1635 = 
evmeaning___evmeaning(
CAR(args_1625), stack_2); 
arg1201_1634 = 
MAKE_PAIR(arg1202_1635, res_1626); } 
{ 
obj_t res_2912;obj_t args_2911;
args_2911 = arg1198_1633; 
res_2912 = arg1201_1634; 
res_1626 = res_2912; 
args_1625 = args_2911; 
goto loop_1624;} } } 
return 
eval_apply(name_565, fun_566, arg1195_568);} } } } } break;case ((long)62) : 

{ /* Eval/evmeaning.scm 328 */
obj_t value_579;
value_579 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 328 */
obj_t name_580;
name_580 = 
VECTOR_REF(value_579, ((long)0)); 
{ /* Eval/evmeaning.scm 329 */
obj_t fun_581;
{ /* ./Ieee/vector.scm 5618 */
obj_t aux_2917;
aux_2917 = 
VECTOR_REF(value_579, ((long)1)); 
fun_581 = 
VECTOR_REF(aux_2917, ((long)2)); } 
{ /* Eval/evmeaning.scm 331 */

{ /* Eval/evmeaning.scm 334 */
obj_t arg1209_583;
{ 
obj_t args_1676;obj_t res_1677;
args_1676 = 
VECTOR_REF(value_579, ((long)2)); 
res_1677 = BNIL; 
loop_1675:
if(
NULLP(args_1676))
{ /* Eval/evmeaning.scm 336 */
arg1209_583 = 
reverse__39___r4_pairs_and_lists_6_3(res_1677); }  else 
{ /* Eval/evmeaning.scm 338 */
obj_t arg1212_1684;obj_t arg1213_1685;
arg1212_1684 = 
CDR(args_1676); 
{ /* Eval/evmeaning.scm 339 */
obj_t arg1214_1686;
arg1214_1686 = 
evmeaning___evmeaning(
CAR(args_1676), stack_2); 
arg1213_1685 = 
MAKE_PAIR(arg1214_1686, res_1677); } 
{ 
obj_t res_2928;obj_t args_2927;
args_2927 = arg1212_1684; 
res_2928 = arg1213_1685; 
res_1677 = res_2928; 
args_1676 = args_2927; 
goto loop_1675;} } } 
return 
eval_apply(name_580, fun_581, arg1209_583);} } } } } break;case ((long)25) : 

{ /* Eval/evmeaning.scm 343 */
obj_t fun1218_593;
fun1218_593 = 
VECTOR_REF(exp_1, ((long)2)); 
return 
PROCEDURE_ENTRY(fun1218_593)(fun1218_593, BEOA);} break;case ((long)26) : 

{ /* Eval/evmeaning.scm 346 */
obj_t value_594;
value_594 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 346 */
obj_t fun_595;
fun_595 = 
VECTOR_REF(value_594, ((long)0)); 
{ /* Eval/evmeaning.scm 347 */

{ /* Eval/evmeaning.scm 348 */
obj_t arg1220_596;
arg1220_596 = 
evmeaning___evmeaning(
VECTOR_REF(value_594, ((long)1)), stack_2); 
return 
PROCEDURE_ENTRY(fun_595)(fun_595, arg1220_596, BEOA);} } } } break;case ((long)27) : 

{ /* Eval/evmeaning.scm 351 */
obj_t value_598;
value_598 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 351 */
obj_t fun_599;
fun_599 = 
VECTOR_REF(value_598, ((long)0)); 
{ /* Eval/evmeaning.scm 352 */

{ /* Eval/evmeaning.scm 353 */
obj_t arg1223_600;obj_t arg1224_601;
arg1223_600 = 
evmeaning___evmeaning(
VECTOR_REF(value_598, ((long)1)), stack_2); 
arg1224_601 = 
evmeaning___evmeaning(
VECTOR_REF(value_598, ((long)2)), stack_2); 
return 
PROCEDURE_ENTRY(fun_599)(fun_599, arg1223_600, arg1224_601, BEOA);} } } } break;case ((long)28) : 

{ /* Eval/evmeaning.scm 357 */
obj_t value_604;
value_604 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 357 */
obj_t fun_605;
fun_605 = 
VECTOR_REF(value_604, ((long)0)); 
{ /* Eval/evmeaning.scm 358 */

{ /* Eval/evmeaning.scm 359 */
obj_t arg1228_606;obj_t arg1229_607;obj_t arg1230_608;
arg1228_606 = 
evmeaning___evmeaning(
VECTOR_REF(value_604, ((long)1)), stack_2); 
arg1229_607 = 
evmeaning___evmeaning(
VECTOR_REF(value_604, ((long)2)), stack_2); 
arg1230_608 = 
evmeaning___evmeaning(
VECTOR_REF(value_604, ((long)3)), stack_2); 
return 
PROCEDURE_ENTRY(fun_605)(fun_605, arg1228_606, arg1229_607, arg1230_608, BEOA);} } } } break;case ((long)29) : 

{ /* Eval/evmeaning.scm 364 */
obj_t value_612;
value_612 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 364 */
obj_t fun_613;
fun_613 = 
VECTOR_REF(value_612, ((long)0)); 
{ /* Eval/evmeaning.scm 365 */

{ /* Eval/evmeaning.scm 366 */
obj_t arg1234_614;obj_t arg1235_615;obj_t arg1236_616;obj_t arg1237_617;
arg1234_614 = 
evmeaning___evmeaning(
VECTOR_REF(value_612, ((long)1)), stack_2); 
arg1235_615 = 
evmeaning___evmeaning(
VECTOR_REF(value_612, ((long)2)), stack_2); 
arg1236_616 = 
evmeaning___evmeaning(
VECTOR_REF(value_612, ((long)3)), stack_2); 
arg1237_617 = 
evmeaning___evmeaning(
VECTOR_REF(value_612, ((long)4)), stack_2); 
return 
PROCEDURE_ENTRY(fun_613)(fun_613, arg1234_614, arg1235_615, arg1236_616, arg1237_617, BEOA);} } } } break;case ((long)30) : 

{ /* Eval/evmeaning.scm 372 */
obj_t value_622;
value_622 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 373 */
obj_t aux_2971;
{ /* Eval/evmeaning.scm 373 */
obj_t l1022_623;
l1022_623 = 
CDR(value_622); 
if(
NULLP(l1022_623))
{ /* Eval/evmeaning.scm 373 */
aux_2971 = BNIL
; }  else 
{ /* Eval/evmeaning.scm 373 */
obj_t head1024_625;
head1024_625 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t l1022_1761;obj_t tail1025_1762;
l1022_1761 = l1022_623; 
tail1025_1762 = head1024_625; 
lname1023_1760:
if(
NULLP(l1022_1761))
{ /* Eval/evmeaning.scm 373 */
aux_2971 = 
CDR(head1024_625)
; }  else 
{ /* Eval/evmeaning.scm 374 */
obj_t newtail1026_1770;
{ /* Eval/evmeaning.scm 374 */
obj_t arg1248_1771;
arg1248_1771 = 
evmeaning___evmeaning(
CAR(l1022_1761), stack_2); 
newtail1026_1770 = 
MAKE_PAIR(arg1248_1771, BNIL); } 
SET_CDR(tail1025_1762, newtail1026_1770); 
{ 
obj_t tail1025_2985;obj_t l1022_2983;
l1022_2983 = 
CDR(l1022_1761); 
tail1025_2985 = newtail1026_1770; 
tail1025_1762 = tail1025_2985; 
l1022_1761 = l1022_2983; 
goto lname1023_1760;} } } } } 
return 
apply(
CAR(value_622), aux_2971);} } break;case ((long)31) : 

{ /* Eval/evmeaning.scm 378 */
obj_t value_635;
value_635 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 378 */
obj_t name_636;
name_636 = 
CAR(value_635); 
{ /* Eval/evmeaning.scm 379 */
obj_t fun_637;
fun_637 = 
evmeaning___evmeaning(
CDR(value_635), stack_2); 
{ /* Eval/evmeaning.scm 380 */

return 
eval_funcall_0(name_636, fun_637);} } } } break;case ((long)32) : 

{ /* Eval/evmeaning.scm 384 */
obj_t value_639;
value_639 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 384 */
obj_t name_640;
name_640 = 
VECTOR_REF(value_639, ((long)0)); 
{ /* Eval/evmeaning.scm 385 */
obj_t fun_641;
fun_641 = 
evmeaning___evmeaning(
VECTOR_REF(value_639, ((long)1)), stack_2); 
{ /* Eval/evmeaning.scm 386 */

{ /* Eval/evmeaning.scm 388 */
obj_t arg1251_642;
arg1251_642 = 
evmeaning___evmeaning(
VECTOR_REF(value_639, ((long)2)), stack_2); 
return 
eval_funcall_1(name_640, fun_641, arg1251_642);} } } } } break;case ((long)33) : 

{ /* Eval/evmeaning.scm 391 */
obj_t value_645;
value_645 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 391 */
obj_t name_646;
name_646 = 
VECTOR_REF(value_645, ((long)0)); 
{ /* Eval/evmeaning.scm 392 */
obj_t fun_647;
fun_647 = 
evmeaning___evmeaning(
VECTOR_REF(value_645, ((long)1)), stack_2); 
{ /* Eval/evmeaning.scm 393 */

{ /* Eval/evmeaning.scm 395 */
obj_t arg1254_648;obj_t arg1255_649;
arg1254_648 = 
evmeaning___evmeaning(
VECTOR_REF(value_645, ((long)2)), stack_2); 
arg1255_649 = 
evmeaning___evmeaning(
VECTOR_REF(value_645, ((long)3)), stack_2); 
return 
eval_funcall_2(name_646, fun_647, arg1254_648, arg1255_649);} } } } } break;case ((long)34) : 

{ /* Eval/evmeaning.scm 399 */
obj_t value_653;
value_653 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 399 */
obj_t name_654;
name_654 = 
VECTOR_REF(value_653, ((long)0)); 
{ /* Eval/evmeaning.scm 400 */
obj_t fun_655;
fun_655 = 
evmeaning___evmeaning(
VECTOR_REF(value_653, ((long)1)), stack_2); 
{ /* Eval/evmeaning.scm 401 */

{ /* Eval/evmeaning.scm 403 */
obj_t arg1259_656;obj_t arg1260_657;obj_t arg1261_658;
arg1259_656 = 
evmeaning___evmeaning(
VECTOR_REF(value_653, ((long)2)), stack_2); 
arg1260_657 = 
evmeaning___evmeaning(
VECTOR_REF(value_653, ((long)3)), stack_2); 
arg1261_658 = 
evmeaning___evmeaning(
VECTOR_REF(value_653, ((long)4)), stack_2); 
return 
eval_funcall_3(name_654, fun_655, arg1259_656, arg1260_657, arg1261_658);} } } } } break;case ((long)35) : 

{ /* Eval/evmeaning.scm 408 */
obj_t value_663;
value_663 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 408 */
obj_t name_664;
name_664 = 
VECTOR_REF(value_663, ((long)0)); 
{ /* Eval/evmeaning.scm 409 */
obj_t fun_665;
fun_665 = 
evmeaning___evmeaning(
VECTOR_REF(value_663, ((long)1)), stack_2); 
{ /* Eval/evmeaning.scm 410 */

{ /* Eval/evmeaning.scm 412 */
obj_t arg1268_666;obj_t arg1269_667;obj_t arg1270_668;obj_t arg1271_669;
arg1268_666 = 
evmeaning___evmeaning(
VECTOR_REF(value_663, ((long)2)), stack_2); 
arg1269_667 = 
evmeaning___evmeaning(
VECTOR_REF(value_663, ((long)3)), stack_2); 
arg1270_668 = 
evmeaning___evmeaning(
VECTOR_REF(value_663, ((long)4)), stack_2); 
arg1271_669 = 
evmeaning___evmeaning(
VECTOR_REF(value_663, ((long)5)), stack_2); 
return 
eval_funcall_4(name_664, fun_665, arg1268_666, arg1269_667, arg1270_668, arg1271_669);} } } } } break;case ((long)36) : 

{ /* Eval/evmeaning.scm 418 */
obj_t value_675;
value_675 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 418 */
obj_t name_676;
name_676 = 
VECTOR_REF(value_675, ((long)0)); 
{ /* Eval/evmeaning.scm 419 */
obj_t fun_677;
fun_677 = 
evmeaning___evmeaning(
VECTOR_REF(value_675, ((long)1)), stack_2); 
{ /* Eval/evmeaning.scm 420 */

{ /* Eval/evmeaning.scm 422 */
obj_t arg1278_678;
{ /* Eval/evmeaning.scm 422 */
obj_t l1027_679;
l1027_679 = 
VECTOR_REF(value_675, ((long)2)); 
if(
NULLP(l1027_679))
{ /* Eval/evmeaning.scm 422 */
arg1278_678 = BNIL; }  else 
{ /* Eval/evmeaning.scm 422 */
obj_t head1029_681;
head1029_681 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t l1027_1873;obj_t tail1030_1874;
l1027_1873 = l1027_679; 
tail1030_1874 = head1029_681; 
lname1028_1872:
if(
NULLP(l1027_1873))
{ /* Eval/evmeaning.scm 422 */
arg1278_678 = 
CDR(head1029_681); }  else 
{ /* Eval/evmeaning.scm 423 */
obj_t newtail1031_1882;
{ /* Eval/evmeaning.scm 423 */
obj_t arg1282_1883;
arg1282_1883 = 
evmeaning___evmeaning(
CAR(l1027_1873), stack_2); 
newtail1031_1882 = 
MAKE_PAIR(arg1282_1883, BNIL); } 
SET_CDR(tail1030_1874, newtail1031_1882); 
{ 
obj_t tail1030_3050;obj_t l1027_3048;
l1027_3048 = 
CDR(l1027_1873); 
tail1030_3050 = newtail1031_1882; 
tail1030_1874 = tail1030_3050; 
l1027_1873 = l1027_3048; 
goto lname1028_1872;} } } } } 
return 
eval_apply(name_676, fun_677, arg1278_678);} } } } } break;case ((long)37) : 

{ /* Eval/evmeaning.scm 427 */
obj_t value_692;
value_692 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 427 */
obj_t where_693;
where_693 = 
CAR(value_692); 
{ /* Eval/evmeaning.scm 428 */
obj_t body_694;
body_694 = 
CDR(value_692); 
{ /* Eval/evmeaning.scm 429 */

{ /* Eval/evmeaning.scm 430 */
obj_t _anonymous_1288__199_2339;
_anonymous_1288__199_2339 = 
make_fx_procedure(_anonymous_1288__199___evmeaning, ((long)0), ((long)3)); 
PROCEDURE_SET(_anonymous_1288__199_2339, ((long)0), where_693); 
PROCEDURE_SET(_anonymous_1288__199_2339, ((long)1), body_694); 
PROCEDURE_SET(_anonymous_1288__199_2339, ((long)2), stack_2); 
return _anonymous_1288__199_2339;} } } } } break;case ((long)38) : 

{ /* Eval/evmeaning.scm 447 */
obj_t value_698;
value_698 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 447 */
obj_t where_699;
where_699 = 
CAR(value_698); 
{ /* Eval/evmeaning.scm 448 */
obj_t body_700;
body_700 = 
CDR(value_698); 
{ /* Eval/evmeaning.scm 449 */

{ /* Eval/evmeaning.scm 450 */
obj_t _anonymous_1289__5_2338;
_anonymous_1289__5_2338 = 
make_fx_procedure(_anonymous_1289__5___evmeaning, ((long)1), ((long)3)); 
PROCEDURE_SET(_anonymous_1289__5_2338, ((long)0), where_699); 
PROCEDURE_SET(_anonymous_1289__5_2338, ((long)1), stack_2); 
PROCEDURE_SET(_anonymous_1289__5_2338, ((long)2), body_700); 
return _anonymous_1289__5_2338;} } } } } break;case ((long)39) : 

{ /* Eval/evmeaning.scm 460 */
obj_t value_706;
value_706 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 460 */
obj_t where_707;
where_707 = 
CAR(value_706); 
{ /* Eval/evmeaning.scm 461 */
obj_t body_708;
body_708 = 
CDR(value_706); 
{ /* Eval/evmeaning.scm 462 */

{ /* Eval/evmeaning.scm 463 */
obj_t _anonymous_1291__214_2337;
_anonymous_1291__214_2337 = 
make_fx_procedure(_anonymous_1291__214___evmeaning, ((long)2), ((long)3)); 
PROCEDURE_SET(_anonymous_1291__214_2337, ((long)0), where_707); 
PROCEDURE_SET(_anonymous_1291__214_2337, ((long)1), stack_2); 
PROCEDURE_SET(_anonymous_1291__214_2337, ((long)2), body_708); 
return _anonymous_1291__214_2337;} } } } } break;case ((long)40) : 

{ /* Eval/evmeaning.scm 473 */
obj_t value_716;
value_716 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 473 */
obj_t where_717;
where_717 = 
CAR(value_716); 
{ /* Eval/evmeaning.scm 474 */
obj_t body_718;
body_718 = 
CDR(value_716); 
{ /* Eval/evmeaning.scm 475 */

{ /* Eval/evmeaning.scm 476 */
obj_t _anonymous_1294__155_2336;
_anonymous_1294__155_2336 = 
make_fx_procedure(_anonymous_1294__155___evmeaning, ((long)3), ((long)3)); 
PROCEDURE_SET(_anonymous_1294__155_2336, ((long)0), where_717); 
PROCEDURE_SET(_anonymous_1294__155_2336, ((long)1), stack_2); 
PROCEDURE_SET(_anonymous_1294__155_2336, ((long)2), body_718); 
return _anonymous_1294__155_2336;} } } } } break;case ((long)41) : 

{ /* Eval/evmeaning.scm 489 */
obj_t value_728;
value_728 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 489 */
obj_t where_729;
where_729 = 
CAR(value_728); 
{ /* Eval/evmeaning.scm 490 */
obj_t body_730;
body_730 = 
CDR(value_728); 
{ /* Eval/evmeaning.scm 491 */

{ /* Eval/evmeaning.scm 492 */
obj_t _anonymous_1298__87_2335;
_anonymous_1298__87_2335 = 
make_fx_procedure(_anonymous_1298__87___evmeaning, ((long)4), ((long)3)); 
PROCEDURE_SET(_anonymous_1298__87_2335, ((long)0), where_729); 
PROCEDURE_SET(_anonymous_1298__87_2335, ((long)1), stack_2); 
PROCEDURE_SET(_anonymous_1298__87_2335, ((long)2), body_730); 
return _anonymous_1298__87_2335;} } } } } break;case ((long)42) : 

{ /* Eval/evmeaning.scm 508 */
obj_t _anonymous_1303__124_2334;
_anonymous_1303__124_2334 = 
make_fx_procedure(_anonymous_1303__124___evmeaning, ((long)0), ((long)2)); 
PROCEDURE_SET(_anonymous_1303__124_2334, ((long)0), exp_1); 
PROCEDURE_SET(_anonymous_1303__124_2334, ((long)1), stack_2); 
return _anonymous_1303__124_2334;} break;case ((long)43) : 

{ /* Eval/evmeaning.scm 513 */
obj_t _anonymous_1305__208_2333;
_anonymous_1305__208_2333 = 
make_fx_procedure(_anonymous_1305__208___evmeaning, ((long)1), ((long)2)); 
PROCEDURE_SET(_anonymous_1305__208_2333, ((long)0), exp_1); 
PROCEDURE_SET(_anonymous_1305__208_2333, ((long)1), stack_2); 
return _anonymous_1305__208_2333;} break;case ((long)44) : 

{ /* Eval/evmeaning.scm 518 */
obj_t _anonymous_1309__69_2332;
_anonymous_1309__69_2332 = 
make_fx_procedure(_anonymous_1309__69___evmeaning, ((long)2), ((long)2)); 
PROCEDURE_SET(_anonymous_1309__69_2332, ((long)0), exp_1); 
PROCEDURE_SET(_anonymous_1309__69_2332, ((long)1), stack_2); 
return _anonymous_1309__69_2332;} break;case ((long)45) : 

{ /* Eval/evmeaning.scm 523 */
obj_t _anonymous_1316__103_2331;
_anonymous_1316__103_2331 = 
make_fx_procedure(_anonymous_1316__103___evmeaning, ((long)3), ((long)2)); 
PROCEDURE_SET(_anonymous_1316__103_2331, ((long)0), exp_1); 
PROCEDURE_SET(_anonymous_1316__103_2331, ((long)1), stack_2); 
return _anonymous_1316__103_2331;} break;case ((long)46) : 

{ /* Eval/evmeaning.scm 528 */
obj_t _anonymous_1321__117_2330;
_anonymous_1321__117_2330 = 
make_fx_procedure(_anonymous_1321__117___evmeaning, ((long)4), ((long)2)); 
PROCEDURE_SET(_anonymous_1321__117_2330, ((long)0), exp_1); 
PROCEDURE_SET(_anonymous_1321__117_2330, ((long)1), stack_2); 
return _anonymous_1321__117_2330;} break;case ((long)47) : 

{ /* Eval/evmeaning.scm 533 */
obj_t value_772;
value_772 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 533 */
obj_t where_773;
where_773 = 
CAR(value_772); 
{ /* Eval/evmeaning.scm 534 */
obj_t body_774;
body_774 = 
CDR(value_772); 
{ /* Eval/evmeaning.scm 535 */

{ /* Eval/evmeaning.scm 536 */
obj_t _anonymous_1328__33_2329;
_anonymous_1328__33_2329 = 
make_va_procedure(_anonymous_1328__33___evmeaning, ((long)-1), ((long)3)); 
PROCEDURE_SET(_anonymous_1328__33_2329, ((long)0), where_773); 
PROCEDURE_SET(_anonymous_1328__33_2329, ((long)1), stack_2); 
PROCEDURE_SET(_anonymous_1328__33_2329, ((long)2), body_774); 
return _anonymous_1328__33_2329;} } } } } break;case ((long)48) : 

{ /* Eval/evmeaning.scm 546 */
obj_t value_780;
value_780 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 546 */
obj_t where_781;
where_781 = 
CAR(value_780); 
{ /* Eval/evmeaning.scm 547 */
obj_t body_782;
body_782 = 
CDR(value_780); 
{ /* Eval/evmeaning.scm 548 */

{ /* Eval/evmeaning.scm 549 */
obj_t _anonymous_1330__135_2328;
_anonymous_1330__135_2328 = 
make_va_procedure(_anonymous_1330__135___evmeaning, ((long)-2), ((long)3)); 
PROCEDURE_SET(_anonymous_1330__135_2328, ((long)0), where_781); 
PROCEDURE_SET(_anonymous_1330__135_2328, ((long)1), stack_2); 
PROCEDURE_SET(_anonymous_1330__135_2328, ((long)2), body_782); 
return _anonymous_1330__135_2328;} } } } } break;case ((long)49) : 

{ /* Eval/evmeaning.scm 559 */
obj_t value_790;
value_790 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 559 */
obj_t where_791;
where_791 = 
CAR(value_790); 
{ /* Eval/evmeaning.scm 560 */
obj_t body_792;
body_792 = 
CDR(value_790); 
{ /* Eval/evmeaning.scm 561 */

{ /* Eval/evmeaning.scm 562 */
obj_t _anonymous_1333__236_2327;
_anonymous_1333__236_2327 = 
make_va_procedure(_anonymous_1333__236___evmeaning, ((long)-3), ((long)3)); 
PROCEDURE_SET(_anonymous_1333__236_2327, ((long)0), where_791); 
PROCEDURE_SET(_anonymous_1333__236_2327, ((long)1), stack_2); 
PROCEDURE_SET(_anonymous_1333__236_2327, ((long)2), body_792); 
return _anonymous_1333__236_2327;} } } } } break;case ((long)50) : 

{ /* Eval/evmeaning.scm 575 */
obj_t value_802;
value_802 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 575 */
obj_t where_803;
where_803 = 
CAR(value_802); 
{ /* Eval/evmeaning.scm 576 */
obj_t body_804;
body_804 = 
CDR(value_802); 
{ /* Eval/evmeaning.scm 577 */

{ /* Eval/evmeaning.scm 578 */
obj_t _anonymous_1337__6_2326;
_anonymous_1337__6_2326 = 
make_va_procedure(_anonymous_1337__6___evmeaning, ((long)-4), ((long)3)); 
PROCEDURE_SET(_anonymous_1337__6_2326, ((long)0), where_803); 
PROCEDURE_SET(_anonymous_1337__6_2326, ((long)1), stack_2); 
PROCEDURE_SET(_anonymous_1337__6_2326, ((long)2), body_804); 
return _anonymous_1337__6_2326;} } } } } break;case ((long)51) : 

{ /* Eval/evmeaning.scm 594 */
obj_t _anonymous_1343__133_2325;
_anonymous_1343__133_2325 = 
make_va_procedure(_anonymous_1343__133___evmeaning, ((long)-1), ((long)2)); 
PROCEDURE_SET(_anonymous_1343__133_2325, ((long)0), exp_1); 
PROCEDURE_SET(_anonymous_1343__133_2325, ((long)1), stack_2); 
return _anonymous_1343__133_2325;} break;case ((long)52) : 

{ /* Eval/evmeaning.scm 599 */
obj_t _anonymous_1347__225_2324;
_anonymous_1347__225_2324 = 
make_va_procedure(_anonymous_1347__225___evmeaning, ((long)-2), ((long)2)); 
PROCEDURE_SET(_anonymous_1347__225_2324, ((long)0), exp_1); 
PROCEDURE_SET(_anonymous_1347__225_2324, ((long)1), stack_2); 
return _anonymous_1347__225_2324;} break;case ((long)53) : 

{ /* Eval/evmeaning.scm 604 */
obj_t _anonymous_1355__80_2323;
_anonymous_1355__80_2323 = 
make_va_procedure(_anonymous_1355__80___evmeaning, ((long)-3), ((long)2)); 
PROCEDURE_SET(_anonymous_1355__80_2323, ((long)0), exp_1); 
PROCEDURE_SET(_anonymous_1355__80_2323, ((long)1), stack_2); 
return _anonymous_1355__80_2323;} break;case ((long)54) : 

{ /* Eval/evmeaning.scm 609 */
obj_t _anonymous_1360__234_2322;
_anonymous_1360__234_2322 = 
make_va_procedure(_anonymous_1360__234___evmeaning, ((long)-4), ((long)2)); 
PROCEDURE_SET(_anonymous_1360__234_2322, ((long)0), exp_1); 
PROCEDURE_SET(_anonymous_1360__234_2322, ((long)1), stack_2); 
return _anonymous_1360__234_2322;} break;case ((long)55) : 

{ /* Eval/evmeaning.scm 614 */
obj_t value_844;
value_844 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 614 */
obj_t where_845;
where_845 = 
VECTOR_REF(value_844, ((long)0)); 
{ /* Eval/evmeaning.scm 615 */
obj_t body_846;
body_846 = 
VECTOR_REF(value_844, ((long)1)); 
{ /* Eval/evmeaning.scm 616 */
obj_t formals_847;
formals_847 = 
VECTOR_REF(value_844, ((long)2)); 
{ /* Eval/evmeaning.scm 617 */

{ /* Eval/evmeaning.scm 618 */
obj_t _anonymous_1368__42_2321;
_anonymous_1368__42_2321 = 
make_va_procedure(_anonymous_1368__42___evmeaning, ((long)-1), ((long)5)); 
PROCEDURE_SET(_anonymous_1368__42_2321, ((long)0), where_845); 
PROCEDURE_SET(_anonymous_1368__42_2321, ((long)1), stack_2); 
PROCEDURE_SET(_anonymous_1368__42_2321, ((long)2), exp_1); 
PROCEDURE_SET(_anonymous_1368__42_2321, ((long)3), formals_847); 
PROCEDURE_SET(_anonymous_1368__42_2321, ((long)4), body_846); 
return _anonymous_1368__42_2321;} } } } } } break;case ((long)56) : 

{ /* Eval/evmeaning.scm 651 */
obj_t value_864;
value_864 = 
VECTOR_REF(exp_1, ((long)2)); 
{ /* Eval/evmeaning.scm 651 */
obj_t body_865;
body_865 = 
CAR(value_864); 
{ /* Eval/evmeaning.scm 652 */
obj_t formals_866;
formals_866 = 
CDR(value_864); 
{ /* Eval/evmeaning.scm 653 */

{ /* Eval/evmeaning.scm 654 */
obj_t _anonymous_1377__234_2320;
_anonymous_1377__234_2320 = 
make_va_procedure(_anonymous_1377__234___evmeaning, ((long)-1), ((long)4)); 
PROCEDURE_SET(_anonymous_1377__234_2320, ((long)0), stack_2); 
PROCEDURE_SET(_anonymous_1377__234_2320, ((long)1), exp_1); 
PROCEDURE_SET(_anonymous_1377__234_2320, ((long)2), formals_866); 
PROCEDURE_SET(_anonymous_1377__234_2320, ((long)3), body_865); 
return _anonymous_1377__234_2320;} } } } } break;
default: 
return 
evmeaning_error_137___evmeaning(exp_1, string1603___evmeaning, string1604___evmeaning, exp_1);} }  else 
{ /* Eval/evmeaning.scm 66 */
return 
evmeaning_error_137___evmeaning(exp_1, string1603___evmeaning, string1604___evmeaning, exp_1);} } }  else 
{ /* Eval/evmeaning.scm 63 */
return exp_1;} } 
}



/* handling_function1127 */
obj_t handling_function1127___evmeaning(obj_t stack_2473, obj_t exp_2472)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 222 */
jmp_buf jmpbuf; 
obj_t an_exit1015_460;
if( SET_EXIT(an_exit1015_460) ) { RESTORE_TRACE(); 
return 
_exit_value_;
} else {
an_exit1015_460 = 
(obj_t)jmpbuf; 
{ /* Eval/evmeaning.scm 222 */

PUSH_EXIT(an_exit1015_460, ((bool_t)1)); 
{ /* Eval/evmeaning.scm 222 */
obj_t an_exitd1016_461;
an_exitd1016_461 = exitd_top; 
{ /* Eval/evmeaning.scm 222 */
obj_t __dummy___2340;
__dummy___2340 = 
make_fx_procedure(__dummy_____evmeaning, ((long)1), ((long)1)); 
PROCEDURE_SET(__dummy___2340, ((long)0), an_exitd1016_461); 
{ /* Eval/evmeaning.scm 223 */
obj_t res1018_464;
{ /* Eval/evmeaning.scm 223 */
obj_t fun1129_466;
fun1129_466 = 
evmeaning___evmeaning(
VECTOR_REF(exp_2472, ((long)2)), stack_2473); 
res1018_464 = 
PROCEDURE_ENTRY(fun1129_466)(fun1129_466, __dummy___2340, BEOA); } 
POP_EXIT(); 
return res1018_464;} } } } 
} } 
}



/* handling_function1134 */
obj_t handling_function1134___evmeaning(obj_t stack_2475, obj_t body_2474)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 230 */
jmp_buf jmpbuf; 
obj_t an_exit1020_475;
if( SET_EXIT(an_exit1020_475) ) { RESTORE_TRACE(); 
return 
_exit_value_;
} else {
an_exit1020_475 = 
(obj_t)jmpbuf; 
{ /* Eval/evmeaning.scm 230 */

PUSH_EXIT(an_exit1020_475, ((bool_t)0)); 
{ /* Eval/evmeaning.scm 229 */
obj_t val1021_476;
val1021_476 = 
evmeaning___evmeaning(body_2474, stack_2475); 
POP_EXIT(); 
return val1021_476;} } 
} } 
}



/* _evmeaning */
obj_t _evmeaning___evmeaning(obj_t env_2341, obj_t exp_2342, obj_t stack_2343)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 62 */
return 
evmeaning___evmeaning(exp_2342, stack_2343);} 
}



/* <anonymous:1377> */
obj_t _anonymous_1377__234___evmeaning(obj_t env_2344, obj_t x_2349)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 654 */
{ /* Eval/evmeaning.scm 655 */
obj_t stack_2345;obj_t exp_2346;obj_t formals_2347;obj_t body_2348;
stack_2345 = 
PROCEDURE_REF(env_2344, ((long)0)); 
exp_2346 = 
PROCEDURE_REF(env_2344, ((long)1)); 
formals_2347 = 
PROCEDURE_REF(env_2344, ((long)2)); 
body_2348 = 
PROCEDURE_REF(env_2344, ((long)3)); 
{ 
obj_t x_867;
x_867 = x_2349; 
{ /* Eval/evmeaning.scm 655 */
obj_t new_env_64_869;
new_env_64_869 = 
_loop___27___evmeaning(exp_2346, stack_2345, x_867, formals_2347); 
return 
evmeaning___evmeaning(body_2348, new_env_64_869);} } } } 
}



/* _loop_' */
obj_t _loop___27___evmeaning(obj_t exp_2471, obj_t stack_2470, obj_t actuals_870, obj_t formals_871)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 655 */
if(
NULLP(formals_871))
{ /* Eval/evmeaning.scm 658 */
if(
NULLP(actuals_870))
{ /* Eval/evmeaning.scm 659 */
return stack_2470;}  else 
{ /* Eval/evmeaning.scm 659 */
return 
evmeaning_error_137___evmeaning(exp_2471, string1600___evmeaning, string1605___evmeaning, actuals_870);} }  else 
{ /* Eval/evmeaning.scm 658 */
if(
PAIRP(formals_871))
{ /* Eval/evmeaning.scm 666 */
if(
NULLP(actuals_870))
{ /* Eval/evmeaning.scm 668 */
return 
evmeaning_error_137___evmeaning(exp_2471, string1600___evmeaning, string1606___evmeaning, formals_871);}  else 
{ /* Eval/evmeaning.scm 668 */
{ /* Eval/evmeaning.scm 675 */
obj_t arg1383_877;obj_t arg1384_878;
arg1383_877 = 
CAR(actuals_870); 
arg1384_878 = 
_loop___27___evmeaning(exp_2471, stack_2470, 
CDR(actuals_870), 
CDR(formals_871)); 
return 
MAKE_PAIR(arg1383_877, arg1384_878);} } }  else 
{ /* Eval/evmeaning.scm 666 */
return 
MAKE_PAIR(actuals_870, stack_2470);} } } 
}



/* <anonymous:1368> */
obj_t _anonymous_1368__42___evmeaning(obj_t env_2350, obj_t x_2356)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 618 */
{ /* Eval/evmeaning.scm 619 */
obj_t where_2351;obj_t stack_2352;obj_t exp_2353;obj_t formals_2354;obj_t body_2355;
where_2351 = 
PROCEDURE_REF(env_2350, ((long)0)); 
stack_2352 = 
PROCEDURE_REF(env_2350, ((long)1)); 
exp_2353 = 
PROCEDURE_REF(env_2350, ((long)2)); 
formals_2354 = 
PROCEDURE_REF(env_2350, ((long)3)); 
body_2355 = 
PROCEDURE_REF(env_2350, ((long)4)); 
{ 
obj_t x_848;
x_848 = x_2356; 
{ /* Eval/evmeaning.scm 619 */
obj_t where_850;
where_850 = where_2351; 
{ /* Eval/evmeaning.scm 620 */

PUSH_TRACE(where_850); BUNSPEC; 
{ /* Eval/evmeaning.scm 623 */
obj_t new_env_64_851;
new_env_64_851 = 
_loop____evmeaning(exp_2353, stack_2352, x_848, formals_2354); 
{ /* Eval/evmeaning.scm 646 */
obj_t res_852;
res_852 = 
evmeaning___evmeaning(body_2355, new_env_64_851); 
POP_TRACE(); 
return res_852;} } } } } } } 
}



/* _loop_ */
obj_t _loop____evmeaning(obj_t exp_2469, obj_t stack_2468, obj_t actuals_853, obj_t formals_854)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 623 */
if(
NULLP(formals_854))
{ /* Eval/evmeaning.scm 626 */
if(
NULLP(actuals_853))
{ /* Eval/evmeaning.scm 627 */
return stack_2468;}  else 
{ /* Eval/evmeaning.scm 627 */
return 
evmeaning_error_137___evmeaning(exp_2469, string1600___evmeaning, string1605___evmeaning, actuals_853);} }  else 
{ /* Eval/evmeaning.scm 626 */
if(
PAIRP(formals_854))
{ /* Eval/evmeaning.scm 634 */
if(
NULLP(actuals_853))
{ /* Eval/evmeaning.scm 636 */
return 
evmeaning_error_137___evmeaning(exp_2469, string1600___evmeaning, string1606___evmeaning, formals_854);}  else 
{ /* Eval/evmeaning.scm 636 */
{ /* Eval/evmeaning.scm 643 */
obj_t arg1373_860;obj_t arg1374_861;
arg1373_860 = 
CAR(actuals_853); 
arg1374_861 = 
_loop____evmeaning(exp_2469, stack_2468, 
CDR(actuals_853), 
CDR(formals_854)); 
return 
MAKE_PAIR(arg1373_860, arg1374_861);} } }  else 
{ /* Eval/evmeaning.scm 634 */
return 
MAKE_PAIR(actuals_853, stack_2468);} } } 
}



/* <anonymous:1360> */
obj_t _anonymous_1360__234___evmeaning(obj_t env_2357, obj_t x_2360, obj_t y_2361, obj_t z_2362, obj_t t_2363)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 609 */
{ /* Eval/evmeaning.scm 610 */
obj_t exp_2358;obj_t stack_2359;
exp_2358 = 
PROCEDURE_REF(env_2357, ((long)0)); 
stack_2359 = 
PROCEDURE_REF(env_2357, ((long)1)); 
{ 
obj_t x_834;obj_t y_835;obj_t z_836;obj_t t_837;
x_834 = x_2360; 
y_835 = y_2361; 
z_836 = z_2362; 
t_837 = t_2363; 
{ /* Eval/evmeaning.scm 610 */
obj_t arg1361_2109;obj_t arg1363_2110;
arg1361_2109 = 
VECTOR_REF(exp_2358, ((long)2)); 
{ /* Eval/evmeaning.scm 611 */
obj_t arg1365_2111;
{ /* Eval/evmeaning.scm 611 */
obj_t arg1366_2112;
{ /* Eval/evmeaning.scm 611 */
obj_t arg1367_2113;
arg1367_2113 = 
MAKE_PAIR(t_837, stack_2359); 
arg1366_2112 = 
MAKE_PAIR(z_836, arg1367_2113); } 
arg1365_2111 = 
MAKE_PAIR(y_835, arg1366_2112); } 
arg1363_2110 = 
MAKE_PAIR(x_834, arg1365_2111); } 
return 
evmeaning___evmeaning(arg1361_2109, arg1363_2110);} } } } 
}



/* <anonymous:1355> */
obj_t _anonymous_1355__80___evmeaning(obj_t env_2364, obj_t x_2367, obj_t y_2368, obj_t z_2369)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 604 */
{ /* Eval/evmeaning.scm 605 */
obj_t exp_2365;obj_t stack_2366;
exp_2365 = 
PROCEDURE_REF(env_2364, ((long)0)); 
stack_2366 = 
PROCEDURE_REF(env_2364, ((long)1)); 
{ 
obj_t x_826;obj_t y_827;obj_t z_828;
x_826 = x_2367; 
y_827 = y_2368; 
z_828 = z_2369; 
{ /* Eval/evmeaning.scm 605 */
obj_t arg1356_2097;obj_t arg1357_2098;
arg1356_2097 = 
VECTOR_REF(exp_2365, ((long)2)); 
{ /* Eval/evmeaning.scm 606 */
obj_t arg1358_2099;
{ /* Eval/evmeaning.scm 606 */
obj_t arg1359_2100;
arg1359_2100 = 
MAKE_PAIR(z_828, stack_2366); 
arg1358_2099 = 
MAKE_PAIR(y_827, arg1359_2100); } 
arg1357_2098 = 
MAKE_PAIR(x_826, arg1358_2099); } 
return 
evmeaning___evmeaning(arg1356_2097, arg1357_2098);} } } } 
}



/* <anonymous:1347> */
obj_t _anonymous_1347__225___evmeaning(obj_t env_2370, obj_t x_2373, obj_t y_2374)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 599 */
{ /* Eval/evmeaning.scm 600 */
obj_t exp_2371;obj_t stack_2372;
exp_2371 = 
PROCEDURE_REF(env_2370, ((long)0)); 
stack_2372 = 
PROCEDURE_REF(env_2370, ((long)1)); 
{ 
obj_t x_820;obj_t y_821;
x_820 = x_2373; 
y_821 = y_2374; 
{ /* Eval/evmeaning.scm 600 */
obj_t arg1348_2088;obj_t arg1350_2089;
arg1348_2088 = 
VECTOR_REF(exp_2371, ((long)2)); 
{ /* Eval/evmeaning.scm 601 */
obj_t arg1354_2090;
arg1354_2090 = 
MAKE_PAIR(y_821, stack_2372); 
arg1350_2089 = 
MAKE_PAIR(x_820, arg1354_2090); } 
return 
evmeaning___evmeaning(arg1348_2088, arg1350_2089);} } } } 
}



/* <anonymous:1343> */
obj_t _anonymous_1343__133___evmeaning(obj_t env_2375, obj_t x_2378)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 594 */
{ /* Eval/evmeaning.scm 595 */
obj_t exp_2376;obj_t stack_2377;
exp_2376 = 
PROCEDURE_REF(env_2375, ((long)0)); 
stack_2377 = 
PROCEDURE_REF(env_2375, ((long)1)); 
{ 
obj_t x_816;
x_816 = x_2378; 
{ /* Eval/evmeaning.scm 595 */
obj_t arg1344_2082;obj_t arg1346_2083;
arg1344_2082 = 
VECTOR_REF(exp_2376, ((long)2)); 
arg1346_2083 = 
MAKE_PAIR(x_816, stack_2377); 
return 
evmeaning___evmeaning(arg1344_2082, arg1346_2083);} } } } 
}



/* <anonymous:1337> */
obj_t _anonymous_1337__6___evmeaning(obj_t env_2379, obj_t x_2383, obj_t y_2384, obj_t z_2385, obj_t t_2386)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 578 */
{ /* Eval/evmeaning.scm 579 */
obj_t where_2380;obj_t stack_2381;obj_t body_2382;
where_2380 = 
PROCEDURE_REF(env_2379, ((long)0)); 
stack_2381 = 
PROCEDURE_REF(env_2379, ((long)1)); 
body_2382 = 
PROCEDURE_REF(env_2379, ((long)2)); 
{ 
obj_t x_805;obj_t y_806;obj_t z_807;obj_t t_808;
x_805 = x_2383; 
y_806 = y_2384; 
z_807 = z_2385; 
t_808 = t_2386; 
{ /* Eval/evmeaning.scm 579 */
obj_t where_2068;
where_2068 = where_2380; 
{ /* Eval/evmeaning.scm 580 */

PUSH_TRACE(where_2068); BUNSPEC; 
{ /* Eval/evmeaning.scm 583 */
obj_t res_2069;
{ /* Eval/evmeaning.scm 588 */
obj_t arg1338_2070;
{ /* Eval/evmeaning.scm 588 */
obj_t arg1339_2071;
{ /* Eval/evmeaning.scm 588 */
obj_t arg1340_2072;
{ /* Eval/evmeaning.scm 588 */
obj_t arg1342_2073;
arg1342_2073 = 
MAKE_PAIR(t_808, stack_2381); 
arg1340_2072 = 
MAKE_PAIR(z_807, arg1342_2073); } 
arg1339_2071 = 
MAKE_PAIR(y_806, arg1340_2072); } 
arg1338_2070 = 
MAKE_PAIR(x_805, arg1339_2071); } 
res_2069 = 
evmeaning___evmeaning(body_2382, arg1338_2070); } 
POP_TRACE(); 
return res_2069;} } } } } } 
}



/* <anonymous:1333> */
obj_t _anonymous_1333__236___evmeaning(obj_t env_2387, obj_t x_2391, obj_t y_2392, obj_t z_2393)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 562 */
{ /* Eval/evmeaning.scm 563 */
obj_t where_2388;obj_t stack_2389;obj_t body_2390;
where_2388 = 
PROCEDURE_REF(env_2387, ((long)0)); 
stack_2389 = 
PROCEDURE_REF(env_2387, ((long)1)); 
body_2390 = 
PROCEDURE_REF(env_2387, ((long)2)); 
{ 
obj_t x_793;obj_t y_794;obj_t z_795;
x_793 = x_2391; 
y_794 = y_2392; 
z_795 = z_2393; 
{ /* Eval/evmeaning.scm 563 */
obj_t where_2053;
where_2053 = where_2388; 
{ /* Eval/evmeaning.scm 564 */

PUSH_TRACE(where_2053); BUNSPEC; 
{ /* Eval/evmeaning.scm 567 */
obj_t res_2054;
{ /* Eval/evmeaning.scm 570 */
obj_t arg1334_2055;
{ /* Eval/evmeaning.scm 570 */
obj_t arg1335_2056;
{ /* Eval/evmeaning.scm 570 */
obj_t arg1336_2057;
arg1336_2057 = 
MAKE_PAIR(z_795, stack_2389); 
arg1335_2056 = 
MAKE_PAIR(y_794, arg1336_2057); } 
arg1334_2055 = 
MAKE_PAIR(x_793, arg1335_2056); } 
res_2054 = 
evmeaning___evmeaning(body_2390, arg1334_2055); } 
POP_TRACE(); 
return res_2054;} } } } } } 
}



/* <anonymous:1330> */
obj_t _anonymous_1330__135___evmeaning(obj_t env_2394, obj_t x_2398, obj_t y_2399)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 549 */
{ /* Eval/evmeaning.scm 550 */
obj_t where_2395;obj_t stack_2396;obj_t body_2397;
where_2395 = 
PROCEDURE_REF(env_2394, ((long)0)); 
stack_2396 = 
PROCEDURE_REF(env_2394, ((long)1)); 
body_2397 = 
PROCEDURE_REF(env_2394, ((long)2)); 
{ 
obj_t x_783;obj_t y_784;
x_783 = x_2398; 
y_784 = y_2399; 
{ /* Eval/evmeaning.scm 550 */
obj_t where_2041;
where_2041 = where_2395; 
{ /* Eval/evmeaning.scm 551 */

PUSH_TRACE(where_2041); BUNSPEC; 
{ /* Eval/evmeaning.scm 554 */
obj_t res_2042;
{ /* Eval/evmeaning.scm 554 */
obj_t arg1331_2043;
{ /* Eval/evmeaning.scm 554 */
obj_t arg1332_2044;
arg1332_2044 = 
MAKE_PAIR(y_784, stack_2396); 
arg1331_2043 = 
MAKE_PAIR(x_783, arg1332_2044); } 
res_2042 = 
evmeaning___evmeaning(body_2397, arg1331_2043); } 
POP_TRACE(); 
return res_2042;} } } } } } 
}



/* <anonymous:1328> */
obj_t _anonymous_1328__33___evmeaning(obj_t env_2400, obj_t x_2404)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 536 */
{ /* Eval/evmeaning.scm 537 */
obj_t where_2401;obj_t stack_2402;obj_t body_2403;
where_2401 = 
PROCEDURE_REF(env_2400, ((long)0)); 
stack_2402 = 
PROCEDURE_REF(env_2400, ((long)1)); 
body_2403 = 
PROCEDURE_REF(env_2400, ((long)2)); 
{ 
obj_t x_775;
x_775 = x_2404; 
{ /* Eval/evmeaning.scm 537 */
obj_t where_2032;
where_2032 = where_2401; 
{ /* Eval/evmeaning.scm 538 */

PUSH_TRACE(where_2032); BUNSPEC; 
{ /* Eval/evmeaning.scm 541 */
obj_t res_2033;
{ /* Eval/evmeaning.scm 541 */
obj_t arg1329_2034;
arg1329_2034 = 
MAKE_PAIR(x_775, stack_2402); 
res_2033 = 
evmeaning___evmeaning(body_2403, arg1329_2034); } 
POP_TRACE(); 
return res_2033;} } } } } } 
}



/* <anonymous:1321> */
obj_t _anonymous_1321__117___evmeaning(obj_t env_2405, obj_t x_2408, obj_t y_2409, obj_t z_2410, obj_t t_2411)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 528 */
{ /* Eval/evmeaning.scm 529 */
obj_t exp_2406;obj_t stack_2407;
exp_2406 = 
PROCEDURE_REF(env_2405, ((long)0)); 
stack_2407 = 
PROCEDURE_REF(env_2405, ((long)1)); 
{ 
obj_t x_762;obj_t y_763;obj_t z_764;obj_t t_765;
x_762 = x_2408; 
y_763 = y_2409; 
z_764 = z_2410; 
t_765 = t_2411; 
{ /* Eval/evmeaning.scm 529 */
obj_t arg1322_2013;obj_t arg1323_2014;
arg1322_2013 = 
VECTOR_REF(exp_2406, ((long)2)); 
{ /* Eval/evmeaning.scm 530 */
obj_t arg1325_2015;
{ /* Eval/evmeaning.scm 530 */
obj_t arg1326_2016;
{ /* Eval/evmeaning.scm 530 */
obj_t arg1327_2017;
arg1327_2017 = 
MAKE_PAIR(t_765, stack_2407); 
arg1326_2016 = 
MAKE_PAIR(z_764, arg1327_2017); } 
arg1325_2015 = 
MAKE_PAIR(y_763, arg1326_2016); } 
arg1323_2014 = 
MAKE_PAIR(x_762, arg1325_2015); } 
return 
evmeaning___evmeaning(arg1322_2013, arg1323_2014);} } } } 
}



/* <anonymous:1316> */
obj_t _anonymous_1316__103___evmeaning(obj_t env_2412, obj_t x_2415, obj_t y_2416, obj_t z_2417)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 523 */
{ /* Eval/evmeaning.scm 524 */
obj_t exp_2413;obj_t stack_2414;
exp_2413 = 
PROCEDURE_REF(env_2412, ((long)0)); 
stack_2414 = 
PROCEDURE_REF(env_2412, ((long)1)); 
{ 
obj_t x_754;obj_t y_755;obj_t z_756;
x_754 = x_2415; 
y_755 = y_2416; 
z_756 = z_2417; 
{ /* Eval/evmeaning.scm 524 */
obj_t arg1317_2001;obj_t arg1318_2002;
arg1317_2001 = 
VECTOR_REF(exp_2413, ((long)2)); 
{ /* Eval/evmeaning.scm 525 */
obj_t arg1319_2003;
{ /* Eval/evmeaning.scm 525 */
obj_t arg1320_2004;
arg1320_2004 = 
MAKE_PAIR(z_756, stack_2414); 
arg1319_2003 = 
MAKE_PAIR(y_755, arg1320_2004); } 
arg1318_2002 = 
MAKE_PAIR(x_754, arg1319_2003); } 
return 
evmeaning___evmeaning(arg1317_2001, arg1318_2002);} } } } 
}



/* <anonymous:1309> */
obj_t _anonymous_1309__69___evmeaning(obj_t env_2418, obj_t x_2421, obj_t y_2422)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 518 */
{ /* Eval/evmeaning.scm 519 */
obj_t exp_2419;obj_t stack_2420;
exp_2419 = 
PROCEDURE_REF(env_2418, ((long)0)); 
stack_2420 = 
PROCEDURE_REF(env_2418, ((long)1)); 
{ 
obj_t x_748;obj_t y_749;
x_748 = x_2421; 
y_749 = y_2422; 
{ /* Eval/evmeaning.scm 519 */
obj_t arg1313_1992;obj_t arg1314_1993;
arg1313_1992 = 
VECTOR_REF(exp_2419, ((long)2)); 
{ /* Eval/evmeaning.scm 520 */
obj_t arg1315_1994;
arg1315_1994 = 
MAKE_PAIR(y_749, stack_2420); 
arg1314_1993 = 
MAKE_PAIR(x_748, arg1315_1994); } 
return 
evmeaning___evmeaning(arg1313_1992, arg1314_1993);} } } } 
}



/* <anonymous:1305> */
obj_t _anonymous_1305__208___evmeaning(obj_t env_2423, obj_t x_2426)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 513 */
{ /* Eval/evmeaning.scm 514 */
obj_t exp_2424;obj_t stack_2425;
exp_2424 = 
PROCEDURE_REF(env_2423, ((long)0)); 
stack_2425 = 
PROCEDURE_REF(env_2423, ((long)1)); 
{ 
obj_t x_744;
x_744 = x_2426; 
{ /* Eval/evmeaning.scm 514 */
obj_t arg1307_1986;obj_t arg1308_1987;
arg1307_1986 = 
VECTOR_REF(exp_2424, ((long)2)); 
arg1308_1987 = 
MAKE_PAIR(x_744, stack_2425); 
return 
evmeaning___evmeaning(arg1307_1986, arg1308_1987);} } } } 
}



/* <anonymous:1303> */
obj_t _anonymous_1303__124___evmeaning(obj_t env_2427)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 508 */
{ /* Eval/evmeaning.scm 509 */
obj_t exp_2428;obj_t stack_2429;
exp_2428 = 
PROCEDURE_REF(env_2427, ((long)0)); 
stack_2429 = 
PROCEDURE_REF(env_2427, ((long)1)); 
{ 

return 
evmeaning___evmeaning(
VECTOR_REF(exp_2428, ((long)2)), stack_2429);} } } 
}



/* <anonymous:1298> */
obj_t _anonymous_1298__87___evmeaning(obj_t env_2430, obj_t x_2434, obj_t y_2435, obj_t z_2436, obj_t t_2437)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 492 */
{ /* Eval/evmeaning.scm 493 */
obj_t where_2431;obj_t stack_2432;obj_t body_2433;
where_2431 = 
PROCEDURE_REF(env_2430, ((long)0)); 
stack_2432 = 
PROCEDURE_REF(env_2430, ((long)1)); 
body_2433 = 
PROCEDURE_REF(env_2430, ((long)2)); 
{ 
obj_t x_731;obj_t y_732;obj_t z_733;obj_t t_734;
x_731 = x_2434; 
y_732 = y_2435; 
z_733 = z_2436; 
t_734 = t_2437; 
{ /* Eval/evmeaning.scm 493 */
obj_t where_1969;
where_1969 = where_2431; 
{ /* Eval/evmeaning.scm 494 */

PUSH_TRACE(where_1969); BUNSPEC; 
{ /* Eval/evmeaning.scm 497 */
obj_t res_1970;
{ /* Eval/evmeaning.scm 502 */
obj_t arg1299_1971;
{ /* Eval/evmeaning.scm 502 */
obj_t arg1300_1972;
{ /* Eval/evmeaning.scm 502 */
obj_t arg1301_1973;
{ /* Eval/evmeaning.scm 502 */
obj_t arg1302_1974;
arg1302_1974 = 
MAKE_PAIR(t_734, stack_2432); 
arg1301_1973 = 
MAKE_PAIR(z_733, arg1302_1974); } 
arg1300_1972 = 
MAKE_PAIR(y_732, arg1301_1973); } 
arg1299_1971 = 
MAKE_PAIR(x_731, arg1300_1972); } 
res_1970 = 
evmeaning___evmeaning(body_2433, arg1299_1971); } 
POP_TRACE(); 
return res_1970;} } } } } } 
}



/* <anonymous:1294> */
obj_t _anonymous_1294__155___evmeaning(obj_t env_2438, obj_t x_2442, obj_t y_2443, obj_t z_2444)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 476 */
{ /* Eval/evmeaning.scm 477 */
obj_t where_2439;obj_t stack_2440;obj_t body_2441;
where_2439 = 
PROCEDURE_REF(env_2438, ((long)0)); 
stack_2440 = 
PROCEDURE_REF(env_2438, ((long)1)); 
body_2441 = 
PROCEDURE_REF(env_2438, ((long)2)); 
{ 
obj_t x_719;obj_t y_720;obj_t z_721;
x_719 = x_2442; 
y_720 = y_2443; 
z_721 = z_2444; 
{ /* Eval/evmeaning.scm 477 */
obj_t where_1954;
where_1954 = where_2439; 
{ /* Eval/evmeaning.scm 478 */

PUSH_TRACE(where_1954); BUNSPEC; 
{ /* Eval/evmeaning.scm 481 */
obj_t res_1955;
{ /* Eval/evmeaning.scm 484 */
obj_t arg1295_1956;
{ /* Eval/evmeaning.scm 484 */
obj_t arg1296_1957;
{ /* Eval/evmeaning.scm 484 */
obj_t arg1297_1958;
arg1297_1958 = 
MAKE_PAIR(z_721, stack_2440); 
arg1296_1957 = 
MAKE_PAIR(y_720, arg1297_1958); } 
arg1295_1956 = 
MAKE_PAIR(x_719, arg1296_1957); } 
res_1955 = 
evmeaning___evmeaning(body_2441, arg1295_1956); } 
POP_TRACE(); 
return res_1955;} } } } } } 
}



/* <anonymous:1291> */
obj_t _anonymous_1291__214___evmeaning(obj_t env_2445, obj_t x_2449, obj_t y_2450)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 463 */
{ /* Eval/evmeaning.scm 464 */
obj_t where_2446;obj_t stack_2447;obj_t body_2448;
where_2446 = 
PROCEDURE_REF(env_2445, ((long)0)); 
stack_2447 = 
PROCEDURE_REF(env_2445, ((long)1)); 
body_2448 = 
PROCEDURE_REF(env_2445, ((long)2)); 
{ 
obj_t x_709;obj_t y_710;
x_709 = x_2449; 
y_710 = y_2450; 
{ /* Eval/evmeaning.scm 464 */
obj_t where_1942;
where_1942 = where_2446; 
{ /* Eval/evmeaning.scm 465 */

PUSH_TRACE(where_1942); BUNSPEC; 
{ /* Eval/evmeaning.scm 468 */
obj_t res_1943;
{ /* Eval/evmeaning.scm 468 */
obj_t arg1292_1944;
{ /* Eval/evmeaning.scm 468 */
obj_t arg1293_1945;
arg1293_1945 = 
MAKE_PAIR(y_710, stack_2447); 
arg1292_1944 = 
MAKE_PAIR(x_709, arg1293_1945); } 
res_1943 = 
evmeaning___evmeaning(body_2448, arg1292_1944); } 
POP_TRACE(); 
return res_1943;} } } } } } 
}



/* <anonymous:1289> */
obj_t _anonymous_1289__5___evmeaning(obj_t env_2451, obj_t x_2455)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 450 */
{ /* Eval/evmeaning.scm 451 */
obj_t where_2452;obj_t stack_2453;obj_t body_2454;
where_2452 = 
PROCEDURE_REF(env_2451, ((long)0)); 
stack_2453 = 
PROCEDURE_REF(env_2451, ((long)1)); 
body_2454 = 
PROCEDURE_REF(env_2451, ((long)2)); 
{ 
obj_t x_701;
x_701 = x_2455; 
{ /* Eval/evmeaning.scm 451 */
obj_t where_1933;
where_1933 = where_2452; 
{ /* Eval/evmeaning.scm 452 */

PUSH_TRACE(where_1933); BUNSPEC; 
{ /* Eval/evmeaning.scm 455 */
obj_t res_1934;
{ /* Eval/evmeaning.scm 455 */
obj_t arg1290_1935;
arg1290_1935 = 
MAKE_PAIR(x_701, stack_2453); 
res_1934 = 
evmeaning___evmeaning(body_2454, arg1290_1935); } 
POP_TRACE(); 
return res_1934;} } } } } } 
}



/* <anonymous:1288> */
obj_t _anonymous_1288__199___evmeaning(obj_t env_2456)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 430 */
{ /* Eval/evmeaning.scm 431 */
obj_t where_2457;obj_t body_2458;obj_t stack_2459;
where_2457 = 
PROCEDURE_REF(env_2456, ((long)0)); 
body_2458 = 
PROCEDURE_REF(env_2456, ((long)1)); 
stack_2459 = 
PROCEDURE_REF(env_2456, ((long)2)); 
{ 

{ /* Eval/evmeaning.scm 431 */
obj_t where_696;
where_696 = where_2457; 
{ /* Eval/evmeaning.scm 432 */

PUSH_TRACE(where_696); BUNSPEC; 
{ /* Eval/evmeaning.scm 442 */
obj_t res_697;
res_697 = 
evmeaning___evmeaning(body_2458, stack_2459); 
POP_TRACE(); 
return res_697;} } } } } } 
}



/* __dummy__ */
obj_t __dummy_____evmeaning(obj_t env_2460, obj_t val1017_2462)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 222 */
{ /* Eval/evmeaning.scm 222 */
obj_t an_exitd1016_2461;
an_exitd1016_2461 = 
PROCEDURE_REF(env_2460, ((long)0)); 
{ 
obj_t val1017_462;
val1017_462 = val1017_2462; 
return 
unwind_until__178___bexit(an_exitd1016_2461, val1017_462);} } } 
}



/* evmeaning-error */
obj_t evmeaning_error_137___evmeaning(obj_t bcode_3, obj_t proc_4, obj_t mes_5, obj_t obj_6)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 690 */
if(
VECTORP(bcode_3))
{ /* Eval/evmeaning.scm 692 */
obj_t e_103_175_886;
e_103_175_886 = 
VECTOR_REF(bcode_3, ((long)1)); 
if(
PAIRP(e_103_175_886))
{ /* Eval/evmeaning.scm 692 */
obj_t cdr_109_69_888;
cdr_109_69_888 = 
CDR(e_103_175_886); 
{ /* Eval/evmeaning.scm 692 */
bool_t test_3365;
{ /* ./Ieee/equiv.scm 4102 */
obj_t aux_3366;
aux_3366 = 
CAR(e_103_175_886); 
test_3365 = 
(aux_3366==symbol1607___evmeaning); } 
if(test_3365)
{ /* Eval/evmeaning.scm 692 */
if(
PAIRP(cdr_109_69_888))
{ /* Eval/evmeaning.scm 692 */
obj_t cdr_113_28_891;
cdr_113_28_891 = 
CDR(cdr_109_69_888); 
if(
PAIRP(cdr_113_28_891))
{ /* Eval/evmeaning.scm 692 */
bool_t test_3374;
{ /* ./Ieee/equiv.scm 4102 */
obj_t aux_3375;
aux_3375 = 
CDR(cdr_113_28_891); 
test_3374 = 
(aux_3375==BNIL); } 
if(test_3374)
{ /* Eval/evmeaning.scm 692 */
return 
error_location_112___error(proc_4, mes_5, obj_6, 
CAR(cdr_109_69_888), 
CAR(cdr_113_28_891));}  else 
{ /* Eval/evmeaning.scm 692 */
FAILURE(proc_4,mes_5,obj_6);} }  else 
{ /* Eval/evmeaning.scm 692 */
FAILURE(proc_4,mes_5,obj_6);} }  else 
{ /* Eval/evmeaning.scm 692 */
FAILURE(proc_4,mes_5,obj_6);} }  else 
{ /* Eval/evmeaning.scm 692 */
FAILURE(proc_4,mes_5,obj_6);} } }  else 
{ /* Eval/evmeaning.scm 692 */
FAILURE(proc_4,mes_5,obj_6);} }  else 
{ /* Eval/evmeaning.scm 691 */
FAILURE(proc_4,mes_5,obj_6);} } 
}



/* evmeaning-warning */
obj_t evmeaning_warning_75___evmeaning(obj_t bcode_7, obj_t args_8)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 702 */
if(
VECTORP(bcode_7))
{ 
obj_t fname_901;obj_t loc_902;
{ /* Eval/evmeaning.scm 704 */
obj_t e_121_5_905;
e_121_5_905 = 
VECTOR_REF(bcode_7, ((long)1)); 
if(
PAIRP(e_121_5_905))
{ /* Eval/evmeaning.scm 704 */
obj_t cdr_127_175_907;
cdr_127_175_907 = 
CDR(e_121_5_905); 
{ /* Eval/evmeaning.scm 704 */
bool_t test_3393;
{ /* ./Ieee/equiv.scm 4102 */
obj_t aux_3394;
aux_3394 = 
CAR(e_121_5_905); 
test_3393 = 
(aux_3394==symbol1607___evmeaning); } 
if(test_3393)
{ /* Eval/evmeaning.scm 704 */
if(
PAIRP(cdr_127_175_907))
{ /* Eval/evmeaning.scm 704 */
obj_t cdr_131_134_910;
cdr_131_134_910 = 
CDR(cdr_127_175_907); 
if(
PAIRP(cdr_131_134_910))
{ /* Eval/evmeaning.scm 704 */
bool_t test_3402;
{ /* ./Ieee/equiv.scm 4102 */
obj_t aux_3403;
aux_3403 = 
CDR(cdr_131_134_910); 
test_3402 = 
(aux_3403==BNIL); } 
if(test_3402)
{ /* Eval/evmeaning.scm 704 */
fname_901 = 
CAR(cdr_127_175_907); 
loc_902 = 
CAR(cdr_131_134_910); 
{ /* Eval/evmeaning.scm 706 */
obj_t runner1422_923;
{ /* Eval/evmeaning.scm 706 */
obj_t arg1417_919;
{ /* ./Ieee/pair-list.scm 4969 */
obj_t aux_3406;
aux_3406 = 
append_2_18___r4_pairs_and_lists_6_3(args_8, BNIL); 
arg1417_919 = 
MAKE_PAIR(loc_902, aux_3406); } 
runner1422_923 = 
MAKE_PAIR(fname_901, arg1417_919); } 
{ /* Eval/evmeaning.scm 706 */
obj_t aux1420_921;
{ /* Eval/evmeaning.scm 706 */
obj_t pair_2222;
pair_2222 = runner1422_923; 
aux1420_921 = 
CAR(pair_2222); } 
{ /* Eval/evmeaning.scm 706 */
obj_t pair_2223;
pair_2223 = runner1422_923; 
runner1422_923 = 
CDR(pair_2223); } 
{ /* Eval/evmeaning.scm 706 */
obj_t aux1421_922;
{ /* Eval/evmeaning.scm 706 */
obj_t pair_2224;
pair_2224 = runner1422_923; 
aux1421_922 = 
CAR(pair_2224); } 
{ /* Eval/evmeaning.scm 706 */
obj_t pair_2225;
pair_2225 = runner1422_923; 
runner1422_923 = 
CDR(pair_2225); } 
return 
warning_location_135___error(aux1420_921, aux1421_922, runner1422_923);} } } }  else 
{ /* Eval/evmeaning.scm 704 */
return 
warning___error(args_8);} }  else 
{ /* Eval/evmeaning.scm 704 */
return 
warning___error(args_8);} }  else 
{ /* Eval/evmeaning.scm 704 */
return 
warning___error(args_8);} }  else 
{ /* Eval/evmeaning.scm 704 */
return 
warning___error(args_8);} } }  else 
{ /* Eval/evmeaning.scm 704 */
return 
warning___error(args_8);} } }  else 
{ /* Eval/evmeaning.scm 703 */
return 
warning___error(args_8);} } 
}



/* evmeaning-notify-error */
obj_t evmeaning_notify_error_24___evmeaning(obj_t proc_9, obj_t mes_10, obj_t obj_11)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 714 */
{ /* Eval/evmeaning.scm 715 */
bool_t test1425_926;
{ /* Eval/evmeaning.scm 715 */
obj_t obj_2227;
obj_2227 = _current_bcode__25___evmeaning; 
test1425_926 = 
VECTORP(obj_2227); } 
if(test1425_926)
{ /* Eval/evmeaning.scm 716 */
obj_t e_139_15_931;
{ /* Eval/evmeaning.scm 716 */
obj_t vector_2228;
vector_2228 = _current_bcode__25___evmeaning; 
e_139_15_931 = 
VECTOR_REF(vector_2228, ((long)1)); } 
if(
PAIRP(e_139_15_931))
{ /* Eval/evmeaning.scm 716 */
obj_t cdr_145_238_933;
cdr_145_238_933 = 
CDR(e_139_15_931); 
{ /* Eval/evmeaning.scm 716 */
bool_t test_3429;
{ /* ./Ieee/equiv.scm 4102 */
obj_t aux_3430;
aux_3430 = 
CAR(e_139_15_931); 
test_3429 = 
(aux_3430==symbol1607___evmeaning); } 
if(test_3429)
{ /* Eval/evmeaning.scm 716 */
if(
PAIRP(cdr_145_238_933))
{ /* Eval/evmeaning.scm 716 */
obj_t cdr_149_75_936;
cdr_149_75_936 = 
CDR(cdr_145_238_933); 
if(
PAIRP(cdr_149_75_936))
{ /* Eval/evmeaning.scm 716 */
bool_t test_3438;
{ /* ./Ieee/equiv.scm 4102 */
obj_t aux_3439;
aux_3439 = 
CDR(cdr_149_75_936); 
test_3438 = 
(aux_3439==BNIL); } 
if(test_3438)
{ /* Eval/evmeaning.scm 716 */
_current_bcode__25___evmeaning = BFALSE; 
{ /* Eval/evmeaning.scm 719 */
obj_t fun1437_2245;
fun1437_2245 = 
error_location_file_107___error(
CAR(cdr_145_238_933), 
CAR(cdr_149_75_936)); 
return 
PROCEDURE_ENTRY(fun1437_2245)(fun1437_2245, proc_9, mes_10, obj_11, BEOA);} }  else 
{ /* Eval/evmeaning.scm 716 */
return 
notify_error_43___error(proc_9, mes_10, obj_11);} }  else 
{ /* Eval/evmeaning.scm 716 */
return 
notify_error_43___error(proc_9, mes_10, obj_11);} }  else 
{ /* Eval/evmeaning.scm 716 */
return 
notify_error_43___error(proc_9, mes_10, obj_11);} }  else 
{ /* Eval/evmeaning.scm 716 */
return 
notify_error_43___error(proc_9, mes_10, obj_11);} } }  else 
{ /* Eval/evmeaning.scm 716 */
return 
notify_error_43___error(proc_9, mes_10, obj_11);} }  else 
{ /* Eval/evmeaning.scm 715 */
return 
notify_error_43___error(proc_9, mes_10, obj_11);} } } 
}



/* _evmeaning-notify-error */
obj_t _evmeaning_notify_error_221___evmeaning(obj_t env_2463, obj_t proc_2464, obj_t mes_2465, obj_t obj_2466)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 714 */
return 
evmeaning_notify_error_24___evmeaning(proc_2464, mes_2465, obj_2466);} 
}



/* evmeaning-reset-error! */
obj_t evmeaning_reset_error__111___evmeaning()
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 727 */
return ( 
_current_bcode__25___evmeaning = BFALSE, BUNSPEC) ;} 
}



/* _evmeaning-reset-error! */
obj_t _evmeaning_reset_error__115___evmeaning(obj_t env_2467)
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 727 */
return 
evmeaning_reset_error__111___evmeaning();} 
}



/* imported-modules-init */
obj_t imported_modules_init_94___evmeaning()
{ AN_OBJECT;
{ /* Eval/evmeaning.scm 14 */
module_initialization_70___type(((long)0), "__EVMEANING"); 
module_initialization_70___error(((long)0), "__EVMEANING"); 
module_initialization_70___bigloo(((long)0), "__EVMEANING"); 
module_initialization_70___tvector(((long)0), "__EVMEANING"); 
module_initialization_70___structure(((long)0), "__EVMEANING"); 
module_initialization_70___bexit(((long)0), "__EVMEANING"); 
module_initialization_70___os(((long)0), "__EVMEANING"); 
module_initialization_70___r4_numbers_6_5(((long)0), "__EVMEANING"); 
module_initialization_70___r4_numbers_6_5_fixnum(((long)0), "__EVMEANING"); 
module_initialization_70___r4_numbers_6_5_flonum(((long)0), "__EVMEANING"); 
module_initialization_70___r4_characters_6_6(((long)0), "__EVMEANING"); 
module_initialization_70___r4_equivalence_6_2(((long)0), "__EVMEANING"); 
module_initialization_70___r4_booleans_6_1(((long)0), "__EVMEANING"); 
module_initialization_70___r4_symbols_6_4(((long)0), "__EVMEANING"); 
module_initialization_70___r4_strings_6_7(((long)0), "__EVMEANING"); 
module_initialization_70___r4_pairs_and_lists_6_3(((long)0), "__EVMEANING"); 
module_initialization_70___r4_input_6_10_2(((long)0), "__EVMEANING"); 
module_initialization_70___r4_control_features_6_9(((long)0), "__EVMEANING"); 
module_initialization_70___r4_vectors_6_8(((long)0), "__EVMEANING"); 
module_initialization_70___r4_ports_6_10_1(((long)0), "__EVMEANING"); 
module_initialization_70___r4_output_6_10_3(((long)0), "__EVMEANING"); 
module_initialization_70___progn(((long)0), "__EVMEANING"); 
module_initialization_70___evenv(((long)0), "__EVMEANING"); 
return 
module_initialization_70___evcompile(((long)0), "__EVMEANING");} 
}

