/*===========================================================================*/
/*   (Eval/expd-case.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t string_to_symbol(char *);
static obj_t symbol1239___expander_case = BUNSPEC;
static obj_t symbol1238___expander_case = BUNSPEC;
static obj_t symbol1237___expander_case = BUNSPEC;
static obj_t symbol1236___expander_case = BUNSPEC;
static obj_t symbol1235___expander_case = BUNSPEC;
static obj_t symbol1233___expander_case = BUNSPEC;
static obj_t symbol1232___expander_case = BUNSPEC;
static obj_t loop___expander_case(obj_t, obj_t);
static obj_t _expand_eval_case_201___expander_case(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70___expander_case(long, char *);
extern obj_t module_initialization_70___progn(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___bigloo(long, char *);
extern obj_t module_initialization_70___tvector(long, char *);
extern obj_t module_initialization_70___structure(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_flonum(long, char *);
extern obj_t module_initialization_70___r4_characters_6_6(long, char *);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___r4_booleans_6_1(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_input_6_10_2(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
extern obj_t module_initialization_70___r4_ports_6_10_1(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t expand_eval_case_113___expander_case(obj_t, obj_t);
static obj_t imported_modules_init_94___expander_case();
static obj_t require_initialization_114___expander_case = BUNSPEC;
static obj_t generic_case_158___expander_case(obj_t, obj_t, obj_t, obj_t);
extern obj_t normalize_progn_143___progn(obj_t);
static obj_t cnst_init_137___expander_case();
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( expand_eval_case_env_39___expander_case, _expand_eval_case_201___expander_case1241, _expand_eval_case_201___expander_case, 0L, 2 );
DEFINE_STRING( string1234___expander_case, string1234___expander_case1242, "Illegal `case' form", 19 );
DEFINE_STRING( string1231___expander_case, string1231___expander_case1243, "Illegal form", 12 );
DEFINE_STRING( string1230___expander_case, string1230___expander_case1244, "case", 4 );



/* module-initialization */
obj_t module_initialization_70___expander_case(long checksum_688, char * from_689)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___expander_case))
{ 
require_initialization_114___expander_case = 
BBOOL(((bool_t)0)); 
cnst_init_137___expander_case(); 
imported_modules_init_94___expander_case(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___expander_case()
{ AN_OBJECT;
{ /* Eval/expd-case.scm 14 */
symbol1232___expander_case = 
string_to_symbol("LET"); 
symbol1233___expander_case = 
string_to_symbol("CASE-VALUE"); 
symbol1235___expander_case = 
string_to_symbol("IF"); 
symbol1236___expander_case = 
string_to_symbol("EQ?"); 
symbol1237___expander_case = 
string_to_symbol("QUOTE"); 
symbol1238___expander_case = 
string_to_symbol("MEMQ"); 
return ( 
symbol1239___expander_case = 
string_to_symbol("ELSE"), BUNSPEC) ;} 
}



/* expand-eval-case */
obj_t expand_eval_case_113___expander_case(obj_t x_1, obj_t e_2)
{ AN_OBJECT;
{ /* Eval/expd-case.scm 48 */
if(
PAIRP(x_1))
{ /* Eval/expd-case.scm 49 */
obj_t cdr_109_69_334;
cdr_109_69_334 = 
CDR(x_1); 
if(
PAIRP(cdr_109_69_334))
{ /* Eval/expd-case.scm 49 */
return 
generic_case_158___expander_case(x_1, 
CAR(cdr_109_69_334), 
CDR(cdr_109_69_334), e_2);}  else 
{ /* Eval/expd-case.scm 49 */
FAILURE(string1230___expander_case,string1231___expander_case,x_1);} }  else 
{ /* Eval/expd-case.scm 49 */
FAILURE(string1230___expander_case,string1231___expander_case,x_1);} } 
}



/* _expand-eval-case */
obj_t _expand_eval_case_201___expander_case(obj_t env_684, obj_t x_685, obj_t e_686)
{ AN_OBJECT;
{ /* Eval/expd-case.scm 48 */
return 
expand_eval_case_113___expander_case(x_685, e_686);} 
}



/* generic-case */
obj_t generic_case_158___expander_case(obj_t x_3, obj_t value_4, obj_t clauses_5, obj_t e_6)
{ AN_OBJECT;
{ /* Eval/expd-case.scm 59 */
{ /* Eval/expd-case.scm 60 */
obj_t arg1010_338;
{ /* Eval/expd-case.scm 60 */
obj_t arg1011_339;obj_t arg1012_340;
arg1011_339 = symbol1232___expander_case; 
{ /* Eval/expd-case.scm 60 */
obj_t arg1013_341;obj_t arg1014_342;
{ /* Eval/expd-case.scm 60 */
obj_t arg1015_343;
{ /* Eval/expd-case.scm 60 */
obj_t arg1017_345;obj_t arg1018_346;
arg1017_345 = symbol1233___expander_case; 
arg1018_346 = 
MAKE_PAIR(value_4, BNIL); 
arg1015_343 = 
MAKE_PAIR(arg1017_345, arg1018_346); } 
arg1013_341 = 
MAKE_PAIR(arg1015_343, BNIL); } 
{ /* Eval/expd-case.scm 61 */
obj_t arg1019_347;
arg1019_347 = 
loop___expander_case(x_3, clauses_5); 
arg1014_342 = 
MAKE_PAIR(arg1019_347, BNIL); } 
arg1012_340 = 
MAKE_PAIR(arg1013_341, arg1014_342); } 
arg1010_338 = 
MAKE_PAIR(arg1011_339, arg1012_340); } 
return 
PROCEDURE_ENTRY(e_6)(e_6, arg1010_338, e_6, BEOA);} } 
}



/* loop */
obj_t loop___expander_case(obj_t x_687, obj_t clauses_349)
{ AN_OBJECT;
{ /* Eval/expd-case.scm 61 */
if(
NULLP(clauses_349))
{ /* Eval/expd-case.scm 62 */
return BFALSE;}  else 
{ 
obj_t body_353;obj_t datums_355;obj_t body_356;obj_t datums_358;obj_t body_359;
{ /* Eval/expd-case.scm 64 */
obj_t e_120_171_361;
e_120_171_361 = 
CAR(clauses_349); 
if(
(e_120_171_361==BNIL))
{ /* Eval/expd-case.scm 64 */
return BFALSE;}  else 
{ /* Eval/expd-case.scm 64 */
if(
PAIRP(e_120_171_361))
{ /* Eval/expd-case.scm 64 */
bool_t test_729;
{ /* ./Ieee/equiv.scm 2544 */
obj_t aux_730;
aux_730 = 
CAR(e_120_171_361); 
test_729 = 
(aux_730==symbol1239___expander_case); } 
if(test_729)
{ /* Eval/expd-case.scm 64 */
body_353 = 
CDR(e_120_171_361); 
{ /* Eval/expd-case.scm 68 */
bool_t test_733;
{ /* Eval/expd-case.scm 68 */
bool_t test_734;
{ /* ./Ieee/pair-list.scm 3634 */
obj_t aux_735;
aux_735 = 
CDR(clauses_349); 
test_734 = 
NULLP(aux_735); } 
if(test_734)
{ /* Eval/expd-case.scm 68 */
test_733 = 
NULLP(body_353)
; }  else 
{ /* Eval/expd-case.scm 68 */
test_733 = ((bool_t)1)
; } } 
if(test_733)
{ /* Eval/expd-case.scm 68 */
FAILURE(string1230___expander_case,string1234___expander_case,x_687);}  else 
{ /* Eval/expd-case.scm 68 */
return 
normalize_progn_143___progn(body_353);} } }  else 
{ /* Eval/expd-case.scm 64 */
obj_t car_133_3_366;
car_133_3_366 = 
CAR(e_120_171_361); 
if(
PAIRP(car_133_3_366))
{ /* Eval/expd-case.scm 64 */
bool_t test_745;
{ /* ./Ieee/pair-list.scm 3391 */
obj_t aux_746;
aux_746 = 
CDR(car_133_3_366); 
test_745 = 
PAIRP(aux_746); } 
if(test_745)
{ /* Eval/expd-case.scm 64 */
datums_355 = car_133_3_366; 
body_356 = 
CDR(e_120_171_361); 
if(
NULLP(body_356))
{ /* Eval/expd-case.scm 73 */
FAILURE(string1230___expander_case,string1234___expander_case,x_687);}  else 
{ /* Eval/expd-case.scm 75 */
obj_t arg1049_390;obj_t arg1050_391;
arg1049_390 = symbol1235___expander_case; 
{ /* Eval/expd-case.scm 75 */
obj_t arg1051_392;obj_t arg1052_393;
{ /* Eval/expd-case.scm 75 */
obj_t arg1054_394;obj_t arg1055_395;
arg1054_394 = symbol1238___expander_case; 
{ /* Eval/expd-case.scm 75 */
obj_t arg1061_396;obj_t arg1062_397;
arg1061_396 = symbol1233___expander_case; 
{ /* Eval/expd-case.scm 75 */
obj_t arg1063_398;
{ /* Eval/expd-case.scm 75 */
obj_t arg1065_400;obj_t arg1066_401;
arg1065_400 = symbol1237___expander_case; 
arg1066_401 = 
MAKE_PAIR(datums_355, BNIL); 
arg1063_398 = 
MAKE_PAIR(arg1065_400, arg1066_401); } 
arg1062_397 = 
MAKE_PAIR(arg1063_398, BNIL); } 
arg1055_395 = 
MAKE_PAIR(arg1061_396, arg1062_397); } 
arg1051_392 = 
MAKE_PAIR(arg1054_394, arg1055_395); } 
{ /* Eval/expd-case.scm 76 */
obj_t arg1067_402;obj_t arg1068_403;
arg1067_402 = 
normalize_progn_143___progn(body_356); 
{ /* Eval/expd-case.scm 77 */
obj_t arg1069_404;
arg1069_404 = 
loop___expander_case(x_687, 
CDR(clauses_349)); 
arg1068_403 = 
MAKE_PAIR(arg1069_404, BNIL); } 
arg1052_393 = 
MAKE_PAIR(arg1067_402, arg1068_403); } 
arg1050_391 = 
MAKE_PAIR(arg1051_392, arg1052_393); } 
return 
MAKE_PAIR(arg1049_390, arg1050_391);} }  else 
{ /* Eval/expd-case.scm 64 */
bool_t test_765;
{ /* ./Ieee/equiv.scm 2544 */
obj_t aux_766;
aux_766 = 
CDR(car_133_3_366); 
test_765 = 
(aux_766==BNIL); } 
if(test_765)
{ /* Eval/expd-case.scm 64 */
datums_358 = 
CAR(car_133_3_366); 
body_359 = 
CDR(e_120_171_361); 
tag_119_205_360:
if(
NULLP(body_359))
{ /* Eval/expd-case.scm 79 */
FAILURE(string1230___expander_case,string1234___expander_case,x_687);}  else 
{ /* Eval/expd-case.scm 81 */
obj_t arg1073_408;obj_t arg1074_409;
arg1073_408 = symbol1235___expander_case; 
{ /* Eval/expd-case.scm 81 */
obj_t arg1075_410;obj_t arg1076_411;
{ /* Eval/expd-case.scm 81 */
obj_t arg1077_412;obj_t arg1078_413;
arg1077_412 = symbol1236___expander_case; 
{ /* Eval/expd-case.scm 81 */
obj_t arg1079_414;obj_t arg1080_415;
arg1079_414 = symbol1233___expander_case; 
{ /* Eval/expd-case.scm 81 */
obj_t arg1081_416;
{ /* Eval/expd-case.scm 81 */
obj_t arg1083_418;obj_t arg1084_419;
arg1083_418 = symbol1237___expander_case; 
arg1084_419 = 
MAKE_PAIR(datums_358, BNIL); 
arg1081_416 = 
MAKE_PAIR(arg1083_418, arg1084_419); } 
arg1080_415 = 
MAKE_PAIR(arg1081_416, BNIL); } 
arg1078_413 = 
MAKE_PAIR(arg1079_414, arg1080_415); } 
arg1075_410 = 
MAKE_PAIR(arg1077_412, arg1078_413); } 
{ /* Eval/expd-case.scm 82 */
obj_t arg1085_420;obj_t arg1086_421;
arg1085_420 = 
normalize_progn_143___progn(body_359); 
{ /* Eval/expd-case.scm 83 */
obj_t arg1087_422;
arg1087_422 = 
loop___expander_case(x_687, 
CDR(clauses_349)); 
arg1086_421 = 
MAKE_PAIR(arg1087_422, BNIL); } 
arg1076_411 = 
MAKE_PAIR(arg1085_420, arg1086_421); } 
arg1074_409 = 
MAKE_PAIR(arg1075_410, arg1076_411); } 
return 
MAKE_PAIR(arg1073_408, arg1074_409);} }  else 
{ /* Eval/expd-case.scm 64 */
return BFALSE;} } }  else 
{ /* Eval/expd-case.scm 64 */
if(
PAIRP(car_133_3_366))
{ /* Eval/expd-case.scm 64 */
bool_t test_788;
{ /* ./Ieee/equiv.scm 2544 */
obj_t aux_789;
aux_789 = 
CDR(car_133_3_366); 
test_788 = 
(aux_789==BNIL); } 
if(test_788)
{ 
obj_t body_794;obj_t datums_792;
datums_792 = 
CAR(car_133_3_366); 
body_794 = 
CDR(e_120_171_361); 
body_359 = body_794; 
datums_358 = datums_792; 
goto tag_119_205_360;}  else 
{ /* Eval/expd-case.scm 64 */
return BFALSE;} }  else 
{ /* Eval/expd-case.scm 64 */
return BFALSE;} } } }  else 
{ /* Eval/expd-case.scm 64 */
return BFALSE;} } } } } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___expander_case()
{ AN_OBJECT;
{ /* Eval/expd-case.scm 14 */
module_initialization_70___error(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___bigloo(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___tvector(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___structure(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___bexit(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_numbers_6_5(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_numbers_6_5_fixnum(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_numbers_6_5_flonum(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_characters_6_6(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_equivalence_6_2(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_booleans_6_1(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_symbols_6_4(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_strings_6_7(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_pairs_and_lists_6_3(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_input_6_10_2(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_control_features_6_9(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_vectors_6_8(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_ports_6_10_1(((long)0), "__EXPANDER_CASE"); 
module_initialization_70___r4_output_6_10_3(((long)0), "__EXPANDER_CASE"); 
return 
module_initialization_70___progn(((long)0), "__EXPANDER_CASE");} 
}

