/*===========================================================================*/
/*   (Eval/macro.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t string_to_symbol(char *);
extern long get_hash_number(char *);
static obj_t symbol1196___macro = BUNSPEC;
static obj_t _install_expander_130___macro(obj_t, obj_t, obj_t);
static obj_t toplevel_init_63___macro();
extern obj_t install_eval_expander_92___macro(obj_t, obj_t);
extern obj_t warning___error(obj_t);
extern obj_t put_hash__129___hash(obj_t, obj_t);
extern obj_t install_compiler_expander_48___macro(obj_t, obj_t);
extern obj_t create_struct(obj_t, long);
extern obj_t get_compiler_expander_150___macro(obj_t);
extern obj_t install_expander_245___macro(obj_t, obj_t);
static obj_t _get_eval_expander_30___macro(obj_t, obj_t);
static obj_t _install_compiler_expander_234___macro(obj_t, obj_t, obj_t);
static obj_t _anonymous_1009__195___macro(obj_t, obj_t);
extern obj_t get_eval_expander_232___macro(obj_t);
static obj_t _install_eval_expander_35___macro(obj_t, obj_t, obj_t);
extern obj_t get_hash_29___hash(obj_t, obj_t);
extern obj_t module_initialization_70___macro(long, char *);
extern obj_t module_initialization_70___hash(long, char *);
extern obj_t module_initialization_70___error(long, char *);
static obj_t _get_compiler_expander_46___macro(obj_t, obj_t);
extern obj_t make_hash_table_174___hash(long, obj_t, obj_t, obj_t, obj_t);
static obj_t _macros_key_51___macro(obj_t, obj_t);
static obj_t imported_modules_init_94___macro();
static obj_t _macro_table__91___macro = BUNSPEC;
static obj_t require_initialization_114___macro = BUNSPEC;
static obj_t cnst_init_137___macro();
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( install_eval_expander_env_29___macro, _install_eval_expander_35___macro1203, _install_eval_expander_35___macro, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( get_eval_expander_env_96___macro, _get_eval_expander_30___macro1204, _get_eval_expander_30___macro, 0L, 1 );
DEFINE_STATIC_PROCEDURE( macros_key_env_196___macro, _macros_key_51___macro1205, _macros_key_51___macro, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( install_compiler_expander_env_164___macro, _install_compiler_expander_234___macro1206, _install_compiler_expander_234___macro, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( install_expander_env_113___macro, _install_expander_130___macro1207, _install_expander_130___macro, 0L, 2 );
extern obj_t eq__env_189___r4_equivalence_6_2;
DEFINE_EXPORT_PROCEDURE( get_compiler_expander_env_9___macro, _get_compiler_expander_46___macro1208, _get_compiler_expander_46___macro, 0L, 1 );
DEFINE_STRING( string1199___macro, string1199___macro1209, "Illegal expander expander", 25 );
DEFINE_STRING( string1198___macro, string1198___macro1210, "install-eval-expander", 21 );
DEFINE_STRING( string1197___macro, string1197___macro1211, "Redefinition of expander -- ", 28 );
DEFINE_STRING( string1201___macro, string1201___macro1212, "install-compiler-expander", 25 );
DEFINE_STRING( string1200___macro, string1200___macro1213, "Illegal expander keyword", 24 );



/* module-initialization */
obj_t module_initialization_70___macro(long checksum_794, char * from_795)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___macro))
{ 
require_initialization_114___macro = 
BBOOL(((bool_t)0)); 
cnst_init_137___macro(); 
imported_modules_init_94___macro(); 
toplevel_init_63___macro(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___macro()
{ AN_OBJECT;
{ /* Eval/macro.scm 14 */
return ( 
symbol1196___macro = 
string_to_symbol("MACROS"), BUNSPEC) ;} 
}



/* toplevel-init */
obj_t toplevel_init_63___macro()
{ AN_OBJECT;
{ /* Eval/macro.scm 14 */
{ /* Eval/macro.scm 58 */
obj_t arg1007_351;
{ /* Eval/macro.scm 60 */
obj_t old_key_215_353;obj_t old_num_119_354;
old_key_215_353 = 
MAKE_CELL(BFALSE); 
old_num_119_354 = 
MAKE_CELL(BFALSE); 
{ /* Eval/macro.scm 62 */
obj_t _anonymous_1009__195_767;
_anonymous_1009__195_767 = 
make_fx_procedure(_anonymous_1009__195___macro, ((long)1), ((long)2)); 
PROCEDURE_SET(_anonymous_1009__195_767, ((long)0), old_key_215_353); 
PROCEDURE_SET(_anonymous_1009__195_767, ((long)1), old_num_119_354); 
arg1007_351 = _anonymous_1009__195_767; } } 
return ( 
_macro_table__91___macro = 
make_hash_table_174___hash(((long)256), arg1007_351, macros_key_env_196___macro, eq__env_189___r4_equivalence_6_2, BNIL), BUNSPEC) ;} } 
}



/* <anonymous:1009> */
obj_t _anonymous_1009__195___macro(obj_t env_768, obj_t x_771)
{ AN_OBJECT;
{ /* Eval/macro.scm 62 */
{ /* Eval/macro.scm 63 */
obj_t old_key_215_769;obj_t old_num_119_770;
old_key_215_769 = 
PROCEDURE_REF(env_768, ((long)0)); 
old_num_119_770 = 
PROCEDURE_REF(env_768, ((long)1)); 
{ 
obj_t x_355;
x_355 = x_771; 
{ /* Eval/macro.scm 63 */
bool_t test1010_357;
{ /* Eval/macro.scm 63 */
obj_t obj2_556;
obj2_556 = 
CELL_REF(old_key_215_769); 
test1010_357 = 
(x_355==obj2_556); } 
if(test1010_357)
{ /* Eval/macro.scm 63 */
return 
CELL_REF(old_num_119_770);}  else 
{ /* Eval/macro.scm 63 */
CELL_SET(old_key_215_769, x_355); 
{ /* Eval/macro.scm 67 */
obj_t aux_773;
{ /* Eval/macro.scm 68 */
obj_t arg1011_358;
arg1011_358 = 
SYMBOL_TO_STRING(x_355); 
{ /* ./Llib/hash.scm 663 */
long aux_812;
{ /* ./Llib/hash.scm 663 */
char * aux_813;
aux_813 = 
BSTRING_TO_STRING(arg1011_358); 
aux_812 = 
get_hash_number(aux_813); } 
aux_773 = 
BINT(aux_812); } } 
CELL_SET(old_num_119_770, aux_773); } 
return 
CELL_REF(old_num_119_770);} } } } } 
}



/* _macros-key */
obj_t _macros_key_51___macro(obj_t env_774, obj_t s_775)
{ AN_OBJECT;
{ /* Eval/macro.scm 52 */
{ /* Eval/macro.scm 52 */
obj_t s_793;
s_793 = s_775; 
return 
STRUCT_REF(s_793, ((long)0));} } 
}



/* install-eval-expander */
obj_t install_eval_expander_92___macro(obj_t keyword_15, obj_t expander_16)
{ AN_OBJECT;
{ /* Eval/macro.scm 78 */
if(
SYMBOLP(keyword_15))
{ /* Eval/macro.scm 80 */
if(
PROCEDUREP(expander_16))
{ /* Eval/macro.scm 82 */
{ /* Eval/macro.scm 85 */
obj_t macro_371;
macro_371 = 
get_hash_29___hash(keyword_15, _macro_table__91___macro); 
{ /* Eval/macro.scm 86 */
bool_t test1023_372;
{ /* Eval/macro.scm 86 */
obj_t o_599;
o_599 = macro_371; 
if(
STRUCTP(o_599))
{ /* ./Ieee/equiv.scm 3658 */
obj_t aux_825;
aux_825 = 
STRUCT_KEY(o_599); 
test1023_372 = 
(aux_825==symbol1196___macro); }  else 
{ /* Eval/macro.scm 52 */
test1023_372 = ((bool_t)0); } } 
if(test1023_372)
{ /* Eval/macro.scm 86 */BUNSPEC; }  else 
{ /* Eval/macro.scm 86 */
{ /* Eval/macro.scm 52 */
obj_t new_610;
new_610 = 
create_struct(symbol1196___macro, ((long)3)); 
STRUCT_SET(new_610, ((long)2), BFALSE); 
STRUCT_SET(new_610, ((long)1), BFALSE); 
STRUCT_SET(new_610, ((long)0), keyword_15); 
macro_371 = new_610; } 
put_hash__129___hash(macro_371, _macro_table__91___macro); } } 
{ /* Eval/macro.scm 91 */
bool_t test1024_373;
{ /* Eval/macro.scm 91 */
obj_t s_626;
s_626 = macro_371; 
{ /* ./Llib/struct.scm 1765 */
obj_t aux_834;
aux_834 = 
STRUCT_REF(s_626, ((long)1)); 
test1024_373 = 
CBOOL(aux_834); } } 
if(test1024_373)
{ /* Eval/macro.scm 92 */
obj_t list1025_374;
{ /* Eval/macro.scm 92 */
obj_t arg1027_376;
{ /* Eval/macro.scm 92 */
obj_t arg1029_378;
arg1029_378 = 
MAKE_PAIR(keyword_15, BNIL); 
arg1027_376 = 
MAKE_PAIR(string1197___macro, arg1029_378); } 
list1025_374 = 
MAKE_PAIR(string1198___macro, arg1027_376); } 
warning___error(list1025_374); }  else 
{ /* Eval/macro.scm 91 */BUNSPEC; } } 
{ /* Eval/macro.scm 95 */
obj_t s_629;
s_629 = macro_371; 
return 
STRUCT_SET(s_629, ((long)1), expander_16);} } }  else 
{ /* Eval/macro.scm 82 */
FAILURE(string1198___macro,string1199___macro,expander_16);} }  else 
{ /* Eval/macro.scm 80 */
FAILURE(string1198___macro,string1200___macro,keyword_15);} } 
}



/* _install-eval-expander */
obj_t _install_eval_expander_35___macro(obj_t env_779, obj_t keyword_780, obj_t expander_781)
{ AN_OBJECT;
{ /* Eval/macro.scm 78 */
return 
install_eval_expander_92___macro(keyword_780, expander_781);} 
}



/* install-compiler-expander */
obj_t install_compiler_expander_48___macro(obj_t keyword_17, obj_t expander_18)
{ AN_OBJECT;
{ /* Eval/macro.scm 102 */
if(
SYMBOLP(keyword_17))
{ /* Eval/macro.scm 104 */
if(
PROCEDUREP(expander_18))
{ /* Eval/macro.scm 106 */
{ /* Eval/macro.scm 109 */
obj_t macro_381;
macro_381 = 
get_hash_29___hash(keyword_17, _macro_table__91___macro); 
{ /* Eval/macro.scm 110 */
bool_t test1032_382;
{ /* Eval/macro.scm 110 */
obj_t o_642;
o_642 = macro_381; 
if(
STRUCTP(o_642))
{ /* ./Ieee/equiv.scm 3658 */
obj_t aux_853;
aux_853 = 
STRUCT_KEY(o_642); 
test1032_382 = 
(aux_853==symbol1196___macro); }  else 
{ /* Eval/macro.scm 52 */
test1032_382 = ((bool_t)0); } } 
if(test1032_382)
{ /* Eval/macro.scm 110 */BUNSPEC; }  else 
{ /* Eval/macro.scm 110 */
{ /* Eval/macro.scm 52 */
obj_t new_653;
new_653 = 
create_struct(symbol1196___macro, ((long)3)); 
STRUCT_SET(new_653, ((long)2), BFALSE); 
STRUCT_SET(new_653, ((long)1), BFALSE); 
STRUCT_SET(new_653, ((long)0), keyword_17); 
macro_381 = new_653; } 
put_hash__129___hash(macro_381, _macro_table__91___macro); } } 
{ /* Eval/macro.scm 115 */
bool_t test1033_383;
{ /* Eval/macro.scm 115 */
obj_t s_669;
s_669 = macro_381; 
{ /* ./Llib/struct.scm 1765 */
obj_t aux_862;
aux_862 = 
STRUCT_REF(s_669, ((long)2)); 
test1033_383 = 
CBOOL(aux_862); } } 
if(test1033_383)
{ /* Eval/macro.scm 116 */
obj_t list1034_384;
{ /* Eval/macro.scm 116 */
obj_t arg1036_386;
{ /* Eval/macro.scm 116 */
obj_t arg1039_388;
arg1039_388 = 
MAKE_PAIR(keyword_17, BNIL); 
arg1036_386 = 
MAKE_PAIR(string1197___macro, arg1039_388); } 
list1034_384 = 
MAKE_PAIR(string1201___macro, arg1036_386); } 
warning___error(list1034_384); }  else 
{ /* Eval/macro.scm 115 */BUNSPEC; } } 
{ /* Eval/macro.scm 119 */
obj_t s_672;
s_672 = macro_381; 
return 
STRUCT_SET(s_672, ((long)2), expander_18);} } }  else 
{ /* Eval/macro.scm 106 */
FAILURE(string1198___macro,string1199___macro,expander_18);} }  else 
{ /* Eval/macro.scm 104 */
FAILURE(string1198___macro,string1200___macro,keyword_17);} } 
}



/* _install-compiler-expander */
obj_t _install_compiler_expander_234___macro(obj_t env_782, obj_t keyword_783, obj_t expander_784)
{ AN_OBJECT;
{ /* Eval/macro.scm 102 */
return 
install_compiler_expander_48___macro(keyword_783, expander_784);} 
}



/* install-expander */
obj_t install_expander_245___macro(obj_t keyword_19, obj_t expander_20)
{ AN_OBJECT;
{ /* Eval/macro.scm 126 */
if(
SYMBOLP(keyword_19))
{ /* Eval/macro.scm 128 */
if(
PROCEDUREP(expander_20))
{ /* Eval/macro.scm 130 */
{ /* Eval/macro.scm 133 */
obj_t macro_391;
macro_391 = 
get_hash_29___hash(keyword_19, _macro_table__91___macro); 
{ /* Eval/macro.scm 134 */
bool_t test1042_392;
{ /* Eval/macro.scm 134 */
obj_t o_685;
o_685 = macro_391; 
if(
STRUCTP(o_685))
{ /* ./Ieee/equiv.scm 3658 */
obj_t aux_881;
aux_881 = 
STRUCT_KEY(o_685); 
test1042_392 = 
(aux_881==symbol1196___macro); }  else 
{ /* Eval/macro.scm 52 */
test1042_392 = ((bool_t)0); } } 
if(test1042_392)
{ /* Eval/macro.scm 134 */BUNSPEC; }  else 
{ /* Eval/macro.scm 134 */
{ /* Eval/macro.scm 52 */
obj_t new_696;
new_696 = 
create_struct(symbol1196___macro, ((long)3)); 
STRUCT_SET(new_696, ((long)2), BFALSE); 
STRUCT_SET(new_696, ((long)1), BFALSE); 
STRUCT_SET(new_696, ((long)0), keyword_19); 
macro_391 = new_696; } 
put_hash__129___hash(macro_391, _macro_table__91___macro); } } 
{ /* Eval/macro.scm 139 */
bool_t test1043_393;
{ /* Eval/macro.scm 139 */
obj_t s_712;
s_712 = macro_391; 
{ /* ./Llib/struct.scm 1765 */
obj_t aux_890;
aux_890 = 
STRUCT_REF(s_712, ((long)1)); 
test1043_393 = 
CBOOL(aux_890); } } 
if(test1043_393)
{ /* Eval/macro.scm 140 */
obj_t list1044_394;
{ /* Eval/macro.scm 140 */
obj_t arg1046_396;
{ /* Eval/macro.scm 140 */
obj_t arg1048_398;
arg1048_398 = 
MAKE_PAIR(keyword_19, BNIL); 
arg1046_396 = 
MAKE_PAIR(string1197___macro, arg1048_398); } 
list1044_394 = 
MAKE_PAIR(string1198___macro, arg1046_396); } 
warning___error(list1044_394); }  else 
{ /* Eval/macro.scm 139 */BUNSPEC; } } 
{ /* Eval/macro.scm 144 */
bool_t test1049_399;
{ /* Eval/macro.scm 144 */
obj_t s_715;
s_715 = macro_391; 
{ /* ./Llib/struct.scm 1765 */
obj_t aux_898;
aux_898 = 
STRUCT_REF(s_715, ((long)2)); 
test1049_399 = 
CBOOL(aux_898); } } 
if(test1049_399)
{ /* Eval/macro.scm 145 */
obj_t list1050_400;
{ /* Eval/macro.scm 145 */
obj_t arg1052_402;
{ /* Eval/macro.scm 145 */
obj_t arg1055_404;
arg1055_404 = 
MAKE_PAIR(keyword_19, BNIL); 
arg1052_402 = 
MAKE_PAIR(string1197___macro, arg1055_404); } 
list1050_400 = 
MAKE_PAIR(string1201___macro, arg1052_402); } 
warning___error(list1050_400); }  else 
{ /* Eval/macro.scm 144 */BUNSPEC; } } 
{ /* Eval/macro.scm 149 */
obj_t s_718;
s_718 = macro_391; 
STRUCT_SET(s_718, ((long)1), expander_20); } 
{ /* Eval/macro.scm 150 */
obj_t s_723;
s_723 = macro_391; 
return 
STRUCT_SET(s_723, ((long)2), expander_20);} } }  else 
{ /* Eval/macro.scm 130 */
FAILURE(string1198___macro,string1199___macro,expander_20);} }  else 
{ /* Eval/macro.scm 128 */
FAILURE(string1198___macro,string1200___macro,keyword_19);} } 
}



/* _install-expander */
obj_t _install_expander_130___macro(obj_t env_785, obj_t keyword_786, obj_t expander_787)
{ AN_OBJECT;
{ /* Eval/macro.scm 126 */
return 
install_expander_245___macro(keyword_786, expander_787);} 
}



/* get-eval-expander */
obj_t get_eval_expander_232___macro(obj_t keyword_21)
{ AN_OBJECT;
{ /* Eval/macro.scm 157 */
{ /* Eval/macro.scm 158 */
obj_t macro_734;
macro_734 = 
get_hash_29___hash(keyword_21, _macro_table__91___macro); 
{ /* Eval/macro.scm 159 */
bool_t test_912;
if(
STRUCTP(macro_734))
{ /* ./Ieee/equiv.scm 3658 */
obj_t aux_915;
aux_915 = 
STRUCT_KEY(macro_734); 
test_912 = 
(aux_915==symbol1196___macro); }  else 
{ /* Eval/macro.scm 52 */
test_912 = ((bool_t)0)
; } 
if(test_912)
{ /* Eval/macro.scm 159 */
return 
STRUCT_REF(macro_734, ((long)1));}  else 
{ /* Eval/macro.scm 159 */
return BFALSE;} } } } 
}



/* _get-eval-expander */
obj_t _get_eval_expander_30___macro(obj_t env_788, obj_t keyword_789)
{ AN_OBJECT;
{ /* Eval/macro.scm 157 */
return 
get_eval_expander_232___macro(keyword_789);} 
}



/* get-compiler-expander */
obj_t get_compiler_expander_150___macro(obj_t keyword_22)
{ AN_OBJECT;
{ /* Eval/macro.scm 168 */
{ /* Eval/macro.scm 169 */
obj_t macro_747;
macro_747 = 
get_hash_29___hash(keyword_22, _macro_table__91___macro); 
{ /* Eval/macro.scm 170 */
bool_t test_921;
if(
STRUCTP(macro_747))
{ /* ./Ieee/equiv.scm 3658 */
obj_t aux_924;
aux_924 = 
STRUCT_KEY(macro_747); 
test_921 = 
(aux_924==symbol1196___macro); }  else 
{ /* Eval/macro.scm 52 */
test_921 = ((bool_t)0)
; } 
if(test_921)
{ /* Eval/macro.scm 170 */
return 
STRUCT_REF(macro_747, ((long)2));}  else 
{ /* Eval/macro.scm 170 */
return BFALSE;} } } } 
}



/* _get-compiler-expander */
obj_t _get_compiler_expander_46___macro(obj_t env_790, obj_t keyword_791)
{ AN_OBJECT;
{ /* Eval/macro.scm 168 */
return 
get_compiler_expander_150___macro(keyword_791);} 
}



/* imported-modules-init */
obj_t imported_modules_init_94___macro()
{ AN_OBJECT;
{ /* Eval/macro.scm 14 */
module_initialization_70___error(((long)0), "__MACRO"); 
return 
module_initialization_70___hash(((long)0), "__MACRO");} 
}

