/*===========================================================================*/
/*   (Ieee/output.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>


/* Object type definitions */

extern obj_t unwind_until__178___bexit(obj_t, obj_t);
extern obj_t display___r4_output_6_10_3(obj_t, obj_t);
extern obj_t object_write_132___object(object_bglt, obj_t);
static obj_t method_init_76___r4_output_6_10_3();
static obj_t rhandler1006___r4_output_6_10_3(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t write_display_tvector_50___r4_output_6_10_3(obj_t, obj_t, bool_t);
extern obj_t current_output_port;
extern obj_t display__75___r4_output_6_10_3(obj_t);
extern obj_t newline___r4_output_6_10_3(obj_t);
static obj_t body1007___r4_output_6_10_3(obj_t);
extern obj_t set_printer__238___r4_output_6_10_3(obj_t);
extern obj_t display_fixnum(obj_t, obj_t);
extern obj_t write_2_13___r4_output_6_10_3(obj_t, obj_t);
extern obj_t exitd_top;
static obj_t _print___r4_output_6_10_3(obj_t, obj_t);
static obj_t _fprint___r4_output_6_10_3(obj_t, obj_t, obj_t);
static obj_t toplevel_init_63___r4_output_6_10_3();
extern obj_t display_ucs2(obj_t, obj_t);
extern obj_t tvector_id_255___tvector(obj_t);
extern obj_t write__14___r4_output_6_10_3(obj_t);
extern obj_t ill_char_rep(unsigned char);
extern obj_t print___r4_output_6_10_3(obj_t);
static obj_t native_display_62___r4_output_6_10_3(obj_t, obj_t);
extern obj_t native_printer_249___r4_output_6_10_3();
static obj_t _illegal_char_rep_248___r4_output_6_10_3(obj_t, obj_t);
static obj_t _anonymous_1034__155___r4_output_6_10_3(obj_t);
static obj_t _anonymous_1033__185___r4_output_6_10_3(obj_t);
extern obj_t write_char_2_204___r4_output_6_10_3(unsigned char, obj_t);
static obj_t write_display_pair_103___r4_output_6_10_3(obj_t, obj_t, bool_t);
static obj_t _get_write_length_196___r4_output_6_10_3(obj_t);
static obj_t _write__154___r4_output_6_10_3(obj_t, obj_t);
static obj_t write_display_159___r4_output_6_10_3(obj_t, obj_t, bool_t);
extern obj_t display_string(obj_t, obj_t);
extern obj_t display_char(obj_t, obj_t);
extern obj_t dynamic_wind_31___r4_control_features_6_9(obj_t, obj_t, obj_t);
static obj_t _newline_11339_86___r4_output_6_10_3(obj_t, obj_t);
static long _displayed__5___r4_output_6_10_3;
extern obj_t ucs2_string_to_utf8_string(obj_t);
static obj_t _display_21340_184___r4_output_6_10_3(obj_t, obj_t, obj_t);
extern obj_t object_display_243___object(object_bglt, obj_t);
extern obj_t display_ucs2string(obj_t, obj_t);
extern obj_t illegal_char_rep_197___r4_output_6_10_3(unsigned char);
static obj_t handling_function1030___r4_output_6_10_3(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t module_initialization_70___r4_ports_6_10_1(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
static obj_t _current_printer__39___r4_output_6_10_3 = BUNSPEC;
extern obj_t newline_1_115___r4_output_6_10_3(obj_t);
static obj_t _write_char_42___r4_output_6_10_3(obj_t, obj_t, obj_t);
extern long get_write_length_193___r4_output_6_10_3();
extern obj_t write_ucs2(obj_t, obj_t);
extern obj_t tvector_ref_208___tvector(obj_t);
extern obj_t remove_error_handler__102___error();
extern obj_t write_utf8string(obj_t, obj_t);
static obj_t _set_printer__226___r4_output_6_10_3(obj_t, obj_t);
extern obj_t write_string(obj_t, obj_t);
static obj_t _write___r4_output_6_10_3(obj_t, obj_t, obj_t);
static obj_t write_display_structure_107___r4_output_6_10_3(obj_t, obj_t, bool_t);
extern obj_t display_flonum(obj_t, obj_t);
extern obj_t write_object(obj_t, obj_t);
static obj_t _display___r4_output_6_10_3(obj_t, obj_t, obj_t);
static obj_t _set_write_length__230___r4_output_6_10_3(obj_t, obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
extern obj_t write___r4_output_6_10_3(obj_t, obj_t);
static obj_t escape___r4_output_6_10_3(obj_t, obj_t);
static obj_t _newline___r4_output_6_10_3(obj_t, obj_t);
static obj_t imported_modules_init_94___r4_output_6_10_3();
static obj_t _write_char_21342_123___r4_output_6_10_3(obj_t, obj_t, obj_t);
static obj_t _native_display_199___r4_output_6_10_3(obj_t, obj_t, obj_t);
extern obj_t add_error_handler__155___error(obj_t, obj_t);
static obj_t _write_21341_73___r4_output_6_10_3(obj_t, obj_t, obj_t);
static obj_t _native_printer_193___r4_output_6_10_3(obj_t);
extern obj_t set_write_length__244___r4_output_6_10_3(long);
static obj_t require_initialization_114___r4_output_6_10_3 = BUNSPEC;
static long _max_length_write__149___r4_output_6_10_3;
extern obj_t write_char(obj_t, obj_t);
extern obj_t string_for_read(obj_t);
static obj_t _display__37___r4_output_6_10_3(obj_t, obj_t);
extern obj_t write_char_165___r4_output_6_10_3(unsigned char, obj_t);
extern obj_t fprint___r4_output_6_10_3(obj_t, obj_t);
static obj_t write_display_vector_76___r4_output_6_10_3(obj_t, obj_t, bool_t);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( display_2_env_238___r4_output_6_10_3, _display_21340_184___r4_output_6_10_31355, _display_21340_184___r4_output_6_10_3, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( set_write_length__env_212___r4_output_6_10_3, _set_write_length__230___r4_output_6_10_31356, _set_write_length__230___r4_output_6_10_3, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( display_env_131___r4_output_6_10_3, _display___r4_output_6_10_31357, va_generic_entry, _display___r4_output_6_10_3, -2 );
DEFINE_EXPORT_PROCEDURE( newline_env_143___r4_output_6_10_3, _newline___r4_output_6_10_31358, va_generic_entry, _newline___r4_output_6_10_3, -1 );
DEFINE_STATIC_PROCEDURE( native_display_env_3___r4_output_6_10_3, _native_display_199___r4_output_6_10_31359, va_generic_entry, _native_display_199___r4_output_6_10_3, -2 );
DEFINE_EXPORT_PROCEDURE( write_char_env_35___r4_output_6_10_3, _write_char_42___r4_output_6_10_31360, va_generic_entry, _write_char_42___r4_output_6_10_3, -2 );
DEFINE_EXPORT_PROCEDURE( get_write_length_env_149___r4_output_6_10_3, _get_write_length_196___r4_output_6_10_31361, _get_write_length_196___r4_output_6_10_3, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( write_env_37___r4_output_6_10_3, _write___r4_output_6_10_31362, va_generic_entry, _write___r4_output_6_10_3, -2 );
DEFINE_EXPORT_PROCEDURE( write__env_225___r4_output_6_10_3, _write__154___r4_output_6_10_31363, va_generic_entry, _write__154___r4_output_6_10_3, -1 );
DEFINE_EXPORT_PROCEDURE( fprint_env_249___r4_output_6_10_3, _fprint___r4_output_6_10_31364, va_generic_entry, _fprint___r4_output_6_10_3, -2 );
DEFINE_EXPORT_PROCEDURE( native_printer_env_215___r4_output_6_10_3, _native_printer_193___r4_output_6_10_31365, _native_printer_193___r4_output_6_10_3, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( write_2_env_34___r4_output_6_10_3, _write_21341_73___r4_output_6_10_31366, _write_21341_73___r4_output_6_10_3, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( write_char_2_env_236___r4_output_6_10_3, _write_char_21342_123___r4_output_6_10_31367, _write_char_21342_123___r4_output_6_10_3, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( print_env_243___r4_output_6_10_3, _print___r4_output_6_10_31368, va_generic_entry, _print___r4_output_6_10_3, -1 );
DEFINE_EXPORT_PROCEDURE( illegal_char_rep_env_244___r4_output_6_10_3, _illegal_char_rep_248___r4_output_6_10_31369, _illegal_char_rep_248___r4_output_6_10_3, 0L, 1 );
DEFINE_STRING( string1353___r4_output_6_10_3, string1353___r4_output_6_10_31370, " . ... )", 8 );
DEFINE_STRING( string1352___r4_output_6_10_3, string1352___r4_output_6_10_31371, "...)", 4 );
DEFINE_STRING( string1351___r4_output_6_10_3, string1351___r4_output_6_10_31372, "... )", 5 );
DEFINE_STRING( string1349___r4_output_6_10_3, string1349___r4_output_6_10_31373, ">", 1 );
DEFINE_STRING( string1350___r4_output_6_10_3, string1350___r4_output_6_10_31374, "... }", 5 );
DEFINE_STRING( string1348___r4_output_6_10_3, string1348___r4_output_6_10_31375, "#<cell:", 7 );
DEFINE_STRING( string1347___r4_output_6_10_3, string1347___r4_output_6_10_31376, "...", 3 );
DEFINE_STRING( string1346___r4_output_6_10_3, string1346___r4_output_6_10_31377, "write", 5 );
DEFINE_STRING( string1345___r4_output_6_10_3, string1345___r4_output_6_10_31378, "display", 7 );
DEFINE_STRING( string1344___r4_output_6_10_3, string1344___r4_output_6_10_31379, "wrong number of optional arguments", 34 );
DEFINE_STRING( string1343___r4_output_6_10_3, string1343___r4_output_6_10_31380, "newline", 7 );
DEFINE_EXPORT_PROCEDURE( set_printer__env_75___r4_output_6_10_3, _set_printer__226___r4_output_6_10_31381, _set_printer__226___r4_output_6_10_3, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( display__env_163___r4_output_6_10_3, _display__37___r4_output_6_10_31382, va_generic_entry, _display__37___r4_output_6_10_3, -1 );
DEFINE_EXPORT_PROCEDURE( newline_1_env_172___r4_output_6_10_3, _newline_11339_86___r4_output_6_10_31383, _newline_11339_86___r4_output_6_10_3, 0L, 1 );



/* module-initialization */
obj_t module_initialization_70___r4_output_6_10_3(long checksum_1202, char * from_1203)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___r4_output_6_10_3))
{ 
require_initialization_114___r4_output_6_10_3 = 
BBOOL(((bool_t)0)); 
imported_modules_init_94___r4_output_6_10_3(); 
method_init_76___r4_output_6_10_3(); 
toplevel_init_63___r4_output_6_10_3(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* toplevel-init */
obj_t toplevel_init_63___r4_output_6_10_3()
{ AN_OBJECT;
{ /* Ieee/output.scm 24 */
_max_length_write__149___r4_output_6_10_3 = ((long)-1); 
_displayed__5___r4_output_6_10_3 = ((long)0); 
_current_printer__39___r4_output_6_10_3 = BUNSPEC; 
return ( 
_current_printer__39___r4_output_6_10_3 = native_display_env_3___r4_output_6_10_3, BUNSPEC) ;} 
}



/* set-write-length! */
obj_t set_write_length__244___r4_output_6_10_3(long length_1)
{ AN_OBJECT;
{ /* Ieee/output.scm 116 */
return ( 
_max_length_write__149___r4_output_6_10_3 = length_1, BUNSPEC) ;} 
}



/* _set-write-length! */
obj_t _set_write_length__230___r4_output_6_10_3(obj_t env_1129, obj_t length_1130)
{ AN_OBJECT;
{ /* Ieee/output.scm 116 */
return 
set_write_length__244___r4_output_6_10_3(
(long)CINT(length_1130));} 
}



/* get-write-length */
long get_write_length_193___r4_output_6_10_3()
{ AN_OBJECT;
{ /* Ieee/output.scm 122 */
{ /* Ieee/output.scm 123 */
bool_t test1018_831;
{ /* Ieee/output.scm 123 */
obj_t obj_832;
obj_832 = 
BINT(_max_length_write__149___r4_output_6_10_3); 
test1018_831 = 
INTEGERP(obj_832); } 
if(test1018_831)
{ /* Ieee/output.scm 123 */
return _max_length_write__149___r4_output_6_10_3;}  else 
{ /* Ieee/output.scm 123 */
return ((long)-1);} } } 
}



/* _get-write-length */
obj_t _get_write_length_196___r4_output_6_10_3(obj_t env_1131)
{ AN_OBJECT;
{ /* Ieee/output.scm 122 */
{ /* Ieee/output.scm 122 */
long aux_1215;
aux_1215 = 
get_write_length_193___r4_output_6_10_3(); 
return 
BINT(aux_1215);} } 
}



/* newline */
obj_t newline___r4_output_6_10_3(obj_t port_2)
{ AN_OBJECT;
{ /* Ieee/output.scm 130 */
{ /* Ieee/output.scm 131 */
obj_t port_451;
if(
(port_2==BNIL))
{ /* Ieee/output.scm 131 */
port_451 = current_output_port; }  else 
{ /* Ieee/output.scm 131 */
if(
PAIRP(port_2))
{ /* Ieee/output.scm 131 */
bool_t test_1222;
{ /* ./Ieee/equiv.scm 5275 */
obj_t aux_1223;
aux_1223 = 
CDR(port_2); 
test_1222 = 
(aux_1223==BNIL); } 
if(test_1222)
{ /* Ieee/output.scm 131 */
port_451 = 
CAR(port_2); }  else 
{ /* Ieee/output.scm 131 */
FAILURE(string1343___r4_output_6_10_3,string1344___r4_output_6_10_3,port_2);} }  else 
{ /* Ieee/output.scm 131 */
FAILURE(string1343___r4_output_6_10_3,string1344___r4_output_6_10_3,port_2);} } 
{ /* Ieee/output.scm 146 */
unsigned char aux_1229;
aux_1229 = 
WRITE_CHAR(((unsigned char)'\n'), port_451); 
return 
BCHAR(aux_1229);} } } 
}



/* _newline */
obj_t _newline___r4_output_6_10_3(obj_t env_1132, obj_t port_1133)
{ AN_OBJECT;
{ /* Ieee/output.scm 130 */
return 
newline___r4_output_6_10_3(port_1133);} 
}



/* newline-1 */
obj_t newline_1_115___r4_output_6_10_3(obj_t port_3)
{ AN_OBJECT;
{ /* Ieee/output.scm 145 */
{ /* Ieee/output.scm 146 */
unsigned char aux_1233;
aux_1233 = 
WRITE_CHAR(((unsigned char)'\n'), port_3); 
return 
BCHAR(aux_1233);} } 
}



/* _newline-11339 */
obj_t _newline_11339_86___r4_output_6_10_3(obj_t env_1134, obj_t port_1135)
{ AN_OBJECT;
{ /* Ieee/output.scm 145 */
{ /* Ieee/output.scm 145 */
obj_t port_1198;
port_1198 = port_1135; 
{ /* Ieee/output.scm 146 */
unsigned char aux_1236;
aux_1236 = 
WRITE_CHAR(((unsigned char)'\n'), port_1198); 
return 
BCHAR(aux_1236);} } } 
}



/* display */
obj_t display___r4_output_6_10_3(obj_t obj_4, obj_t port_5)
{ AN_OBJECT;
{ /* Ieee/output.scm 151 */
{ /* Ieee/output.scm 152 */
obj_t port_461;
if(
(port_5==BNIL))
{ /* Ieee/output.scm 152 */
port_461 = current_output_port; }  else 
{ /* Ieee/output.scm 152 */
if(
PAIRP(port_5))
{ /* Ieee/output.scm 152 */
bool_t test_1243;
{ /* ./Ieee/equiv.scm 5275 */
obj_t aux_1244;
aux_1244 = 
CDR(port_5); 
test_1243 = 
(aux_1244==BNIL); } 
if(test_1243)
{ /* Ieee/output.scm 152 */
port_461 = 
CAR(port_5); }  else 
{ /* Ieee/output.scm 152 */
FAILURE(string1345___r4_output_6_10_3,string1344___r4_output_6_10_3,port_5);} }  else 
{ /* Ieee/output.scm 152 */
FAILURE(string1345___r4_output_6_10_3,string1344___r4_output_6_10_3,port_5);} } 
return 
display_2_122___r4_output_6_10_3(obj_4, port_461);} } 
}



/* _display */
obj_t _display___r4_output_6_10_3(obj_t env_1136, obj_t obj_1137, obj_t port_1138)
{ AN_OBJECT;
{ /* Ieee/output.scm 151 */
return 
display___r4_output_6_10_3(obj_1137, port_1138);} 
}



/* display-2 */
obj_t display_2_122___r4_output_6_10_3(obj_t obj_6, obj_t port_7)
{ AN_OBJECT;
{ /* Ieee/output.scm 166 */
_displayed__5___r4_output_6_10_3 = ((long)0); 
{ /* Ieee/output.scm 168 */
bool_t test1029_471;
{ /* Ieee/output.scm 168 */
bool_t test1039_503;
{ /* Ieee/output.scm 168 */
obj_t obj1_868;
obj1_868 = _current_printer__39___r4_output_6_10_3; 
test1039_503 = 
(obj1_868==native_display_env_3___r4_output_6_10_3); } 
if(test1039_503)
{ /* Ieee/output.scm 168 */
test1029_471 = ((bool_t)1); }  else 
{ /* Ieee/output.scm 169 */
bool_t test1040_504;
{ /* Ieee/output.scm 169 */
obj_t obj_869;
obj_869 = _current_printer__39___r4_output_6_10_3; 
test1040_504 = 
PROCEDUREP(obj_869); } 
if(test1040_504)
{ /* Ieee/output.scm 169 */
test1029_471 = ((bool_t)0); }  else 
{ /* Ieee/output.scm 169 */
test1029_471 = ((bool_t)1); } } } 
if(test1029_471)
{ /* Ieee/output.scm 168 */
return 
write_display_159___r4_output_6_10_3(obj_6, port_7, ((bool_t)1));}  else 
{ /* Ieee/output.scm 171 */
obj_t armed1008_472;
armed1008_472 = 
MAKE_CELL(BUNSPEC); 
{ /* Ieee/output.scm 172 */
obj_t body1007_1140;obj_t rhandler1006_1142;
body1007_1140 = 
make_fx_procedure(body1007___r4_output_6_10_3, ((long)0), ((long)2)); 
rhandler1006_1142 = 
make_fx_procedure(rhandler1006___r4_output_6_10_3, ((long)4), ((long)1)); 
PROCEDURE_SET(body1007_1140, ((long)0), obj_6); 
PROCEDURE_SET(body1007_1140, ((long)1), port_7); 
PROCEDURE_SET(rhandler1006_1142, ((long)0), armed1008_472); 
CELL_SET(armed1008_472, BTRUE); 
return 
handling_function1030___r4_output_6_10_3(body1007_1140, rhandler1006_1142, armed1008_472);} } } } 
}



/* handling_function1030 */
obj_t handling_function1030___r4_output_6_10_3(obj_t body1007_1197, obj_t rhandler1006_1196, obj_t armed1008_1195)
{ AN_OBJECT;
{ /* Ieee/output.scm 171 */
jmp_buf jmpbuf; 
obj_t an_exit1009_477;
if( SET_EXIT(an_exit1009_477) ) { RESTORE_TRACE(); 
return 
_exit_value_;
} else {
an_exit1009_477 = 
(obj_t)jmpbuf; 
{ /* Ieee/output.scm 171 */

PUSH_EXIT(an_exit1009_477, ((bool_t)1)); 
{ /* Ieee/output.scm 171 */
obj_t an_exitd1010_478;
an_exitd1010_478 = exitd_top; 
{ /* Ieee/output.scm 171 */
obj_t escape_1141;
escape_1141 = 
make_fx_procedure(escape___r4_output_6_10_3, ((long)1), ((long)1)); 
PROCEDURE_SET(escape_1141, ((long)0), an_exitd1010_478); 
{ /* Ieee/output.scm 171 */
obj_t res1012_481;
{ /* Ieee/output.scm 171 */
obj_t _anonymous_1034__155_1139;obj_t _anonymous_1033__185_1143;
_anonymous_1034__155_1139 = 
make_fx_procedure(_anonymous_1034__155___r4_output_6_10_3, ((long)0), ((long)1)); 
_anonymous_1033__185_1143 = 
make_fx_procedure(_anonymous_1033__185___r4_output_6_10_3, ((long)0), ((long)4)); 
PROCEDURE_SET(_anonymous_1034__155_1139, ((long)0), armed1008_1195); 
PROCEDURE_SET(_anonymous_1033__185_1143, ((long)0), an_exitd1010_478); 
PROCEDURE_SET(_anonymous_1033__185_1143, ((long)1), armed1008_1195); 
PROCEDURE_SET(_anonymous_1033__185_1143, ((long)2), rhandler1006_1196); 
PROCEDURE_SET(_anonymous_1033__185_1143, ((long)3), escape_1141); 
res1012_481 = 
dynamic_wind_31___r4_control_features_6_9(_anonymous_1033__185_1143, body1007_1197, _anonymous_1034__155_1139); } 
POP_EXIT(); 
return res1012_481;} } } } 
} } 
}



/* _display-21340 */
obj_t _display_21340_184___r4_output_6_10_3(obj_t env_1144, obj_t obj_1145, obj_t port_1146)
{ AN_OBJECT;
{ /* Ieee/output.scm 166 */
return 
display_2_122___r4_output_6_10_3(obj_1145, port_1146);} 
}



/* <anonymous:1034> */
obj_t _anonymous_1034__155___r4_output_6_10_3(obj_t env_1147)
{ AN_OBJECT;
{ /* Ieee/output.scm 171 */
{ /* Ieee/output.scm 171 */
obj_t armed1008_1148;
armed1008_1148 = 
PROCEDURE_REF(env_1147, ((long)0)); 
{ 

{ /* Ieee/output.scm 171 */
bool_t test_1280;
{ /* Ieee/output.scm 171 */
obj_t aux_1281;
aux_1281 = 
CELL_REF(armed1008_1148); 
test_1280 = 
CBOOL(aux_1281); } 
if(test_1280)
{ /* Ieee/output.scm 171 */
CELL_SET(armed1008_1148, BFALSE); 
return 
remove_error_handler__102___error();}  else 
{ /* Ieee/output.scm 171 */
return BUNSPEC;} } } } } 
}



/* body1007 */
obj_t body1007___r4_output_6_10_3(obj_t env_1150)
{ AN_OBJECT;
{ /* Ieee/output.scm 171 */
{ /* Ieee/output.scm 171 */
obj_t obj_1151;obj_t port_1152;
obj_1151 = 
PROCEDURE_REF(env_1150, ((long)0)); 
port_1152 = 
PROCEDURE_REF(env_1150, ((long)1)); 
{ 

return 
PROCEDURE_ENTRY(_current_printer__39___r4_output_6_10_3)(_current_printer__39___r4_output_6_10_3, obj_1151, port_1152, BEOA);} } } 
}



/* <anonymous:1033> */
obj_t _anonymous_1033__185___r4_output_6_10_3(obj_t env_1153)
{ AN_OBJECT;
{ /* Ieee/output.scm 171 */
{ /* Ieee/output.scm 171 */
obj_t rhandler1006_1156;obj_t escape_1157;
rhandler1006_1156 = 
PROCEDURE_REF(env_1153, ((long)2)); 
escape_1157 = 
PROCEDURE_REF(env_1153, ((long)3)); 
{ 

return 
add_error_handler__155___error(rhandler1006_1156, escape_1157);} } } 
}



/* escape */
obj_t escape___r4_output_6_10_3(obj_t env_1158, obj_t val1011_1160)
{ AN_OBJECT;
{ /* Ieee/output.scm 171 */
{ /* Ieee/output.scm 171 */
obj_t an_exitd1010_1159;
an_exitd1010_1159 = 
PROCEDURE_REF(env_1158, ((long)0)); 
{ 
obj_t val1011_479;
val1011_479 = val1011_1160; 
return 
unwind_until__178___bexit(an_exitd1010_1159, val1011_479);} } } 
}



/* rhandler1006 */
obj_t rhandler1006___r4_output_6_10_3(obj_t env_1161, obj_t esc_1163, obj_t obj_1164, obj_t proc_1165, obj_t msg_1166)
{ AN_OBJECT;
{ /* Ieee/output.scm 171 */
{ /* Ieee/output.scm 171 */
obj_t armed1008_1162;
armed1008_1162 = 
PROCEDURE_REF(env_1161, ((long)0)); 
{ 
obj_t esc_494;obj_t obj_495;obj_t proc_496;obj_t msg_497;
esc_494 = esc_1163; 
obj_495 = obj_1164; 
proc_496 = proc_1165; 
msg_497 = msg_1166; 
CELL_SET(armed1008_1162, BFALSE); 
remove_error_handler__102___error(); 
_current_printer__39___r4_output_6_10_3 = native_display_env_3___r4_output_6_10_3; 
FAILURE(obj_495,proc_496,msg_497);} } } 
}



/* native-display */
obj_t native_display_62___r4_output_6_10_3(obj_t obj_8, obj_t port_9)
{ AN_OBJECT;
{ /* Ieee/output.scm 179 */
_displayed__5___r4_output_6_10_3 = ((long)0); 
{ /* Ieee/output.scm 181 */
obj_t aux_1296;
{ /* Ieee/output.scm 182 */
bool_t test_1297;
if(
PAIRP(port_9))
{ /* Ieee/output.scm 182 */
bool_t test_1300;
{ /* ./Ieee/port.scm 883 */
obj_t aux_1301;
aux_1301 = 
CAR(port_9); 
test_1300 = 
OUTPUT_PORTP(aux_1301); } 
if(test_1300)
{ /* Ieee/output.scm 182 */
test_1297 = ((bool_t)0)
; }  else 
{ /* Ieee/output.scm 182 */
test_1297 = ((bool_t)1)
; } }  else 
{ /* Ieee/output.scm 182 */
test_1297 = ((bool_t)1)
; } 
if(test_1297)
{ /* Ieee/output.scm 182 */
aux_1296 = current_output_port
; }  else 
{ /* Ieee/output.scm 182 */
aux_1296 = 
CAR(port_9)
; } } 
return 
write_display_159___r4_output_6_10_3(obj_8, aux_1296, ((bool_t)1));} } 
}



/* _native-display */
obj_t _native_display_199___r4_output_6_10_3(obj_t env_1126, obj_t obj_1127, obj_t port_1128)
{ AN_OBJECT;
{ /* Ieee/output.scm 179 */
return 
native_display_62___r4_output_6_10_3(obj_1127, port_1128);} 
}



/* write */
obj_t write___r4_output_6_10_3(obj_t obj_10, obj_t port_11)
{ AN_OBJECT;
{ /* Ieee/output.scm 190 */
{ /* Ieee/output.scm 191 */
obj_t port_510;
if(
(port_11==BNIL))
{ /* Ieee/output.scm 191 */
port_510 = current_output_port; }  else 
{ /* Ieee/output.scm 191 */
if(
PAIRP(port_11))
{ /* Ieee/output.scm 191 */
bool_t test_1311;
{ /* ./Ieee/equiv.scm 5275 */
obj_t aux_1312;
aux_1312 = 
CDR(port_11); 
test_1311 = 
(aux_1312==BNIL); } 
if(test_1311)
{ /* Ieee/output.scm 191 */
port_510 = 
CAR(port_11); }  else 
{ /* Ieee/output.scm 191 */
FAILURE(string1346___r4_output_6_10_3,string1344___r4_output_6_10_3,port_11);} }  else 
{ /* Ieee/output.scm 191 */
FAILURE(string1346___r4_output_6_10_3,string1344___r4_output_6_10_3,port_11);} } 
_displayed__5___r4_output_6_10_3 = ((long)0); 
return 
write_display_159___r4_output_6_10_3(obj_10, port_510, ((bool_t)0));} } 
}



/* _write */
obj_t _write___r4_output_6_10_3(obj_t env_1169, obj_t obj_1170, obj_t port_1171)
{ AN_OBJECT;
{ /* Ieee/output.scm 190 */
return 
write___r4_output_6_10_3(obj_1170, port_1171);} 
}



/* write-2 */
obj_t write_2_13___r4_output_6_10_3(obj_t obj_12, obj_t port_13)
{ AN_OBJECT;
{ /* Ieee/output.scm 205 */
_displayed__5___r4_output_6_10_3 = ((long)0); 
return 
write_display_159___r4_output_6_10_3(obj_12, port_13, ((bool_t)0));} 
}



/* _write-21341 */
obj_t _write_21341_73___r4_output_6_10_3(obj_t env_1172, obj_t obj_1173, obj_t port_1174)
{ AN_OBJECT;
{ /* Ieee/output.scm 205 */
return 
write_2_13___r4_output_6_10_3(obj_1173, port_1174);} 
}



/* write-char */
obj_t write_char_165___r4_output_6_10_3(unsigned char char_14, obj_t port_15)
{ AN_OBJECT;
{ /* Ieee/output.scm 212 */
{ /* Ieee/output.scm 213 */
obj_t port_520;
if(
(port_15==BNIL))
{ /* Ieee/output.scm 213 */
port_520 = current_output_port; }  else 
{ /* Ieee/output.scm 213 */
if(
PAIRP(port_15))
{ /* Ieee/output.scm 213 */
bool_t test_1326;
{ /* ./Ieee/equiv.scm 5275 */
obj_t aux_1327;
aux_1327 = 
CDR(port_15); 
test_1326 = 
(aux_1327==BNIL); } 
if(test_1326)
{ /* Ieee/output.scm 213 */
port_520 = 
CAR(port_15); }  else 
{ /* Ieee/output.scm 213 */
FAILURE(string1346___r4_output_6_10_3,string1344___r4_output_6_10_3,port_15);} }  else 
{ /* Ieee/output.scm 213 */
FAILURE(string1346___r4_output_6_10_3,string1344___r4_output_6_10_3,port_15);} } 
{ /* Ieee/output.scm 228 */
unsigned char aux_1333;
aux_1333 = 
WRITE_CHAR(char_14, port_520); 
return 
BCHAR(aux_1333);} } } 
}



/* _write-char */
obj_t _write_char_42___r4_output_6_10_3(obj_t env_1175, obj_t char_1176, obj_t port_1177)
{ AN_OBJECT;
{ /* Ieee/output.scm 212 */
return 
write_char_165___r4_output_6_10_3(
(unsigned char)CCHAR(char_1176), port_1177);} 
}



/* write-char-2 */
obj_t write_char_2_204___r4_output_6_10_3(unsigned char char_16, obj_t port_17)
{ AN_OBJECT;
{ /* Ieee/output.scm 227 */
{ /* Ieee/output.scm 228 */
unsigned char aux_1338;
aux_1338 = 
WRITE_CHAR(char_16, port_17); 
return 
BCHAR(aux_1338);} } 
}



/* _write-char-21342 */
obj_t _write_char_21342_123___r4_output_6_10_3(obj_t env_1178, obj_t char_1179, obj_t port_1180)
{ AN_OBJECT;
{ /* Ieee/output.scm 227 */
{ /* Ieee/output.scm 227 */
unsigned char char_166_1199;obj_t port_1200;
char_166_1199 = 
(unsigned char)CCHAR(char_1179); 
port_1200 = port_1180; 
{ /* Ieee/output.scm 228 */
unsigned char aux_1342;
aux_1342 = 
WRITE_CHAR(char_166_1199, port_1200); 
return 
BCHAR(aux_1342);} } } 
}



/* illegal-char-rep */
obj_t illegal_char_rep_197___r4_output_6_10_3(unsigned char char_18)
{ AN_OBJECT;
{ /* Ieee/output.scm 233 */
return 
ill_char_rep(char_18);} 
}



/* _illegal-char-rep */
obj_t _illegal_char_rep_248___r4_output_6_10_3(obj_t env_1181, obj_t char_1182)
{ AN_OBJECT;
{ /* Ieee/output.scm 233 */
{ /* Ieee/output.scm 233 */
unsigned char char_166_1201;
char_166_1201 = 
(unsigned char)CCHAR(char_1182); 
return 
ill_char_rep(char_166_1201);} } 
}



/* write/display */
obj_t write_display_159___r4_output_6_10_3(obj_t obj_19, obj_t port_20, bool_t flag_21)
{ AN_OBJECT;
{ /* Ieee/output.scm 246 */
{ /* Ieee/output.scm 247 */
long z2_929;
z2_929 = _displayed__5___r4_output_6_10_3; 
_displayed__5___r4_output_6_10_3 = 
(((long)1)+z2_929); } 
{ /* Ieee/output.scm 249 */
bool_t test1056_530;
{ /* Ieee/output.scm 249 */
bool_t test1072_546;
{ /* Ieee/output.scm 249 */
obj_t obj_930;
obj_930 = 
BINT(_max_length_write__149___r4_output_6_10_3); 
test1072_546 = 
INTEGERP(obj_930); } 
if(test1072_546)
{ /* Ieee/output.scm 250 */
bool_t test1073_547;
{ /* Ieee/output.scm 250 */
long n1_931;
n1_931 = _max_length_write__149___r4_output_6_10_3; 
test1073_547 = 
(n1_931>((long)0)); } 
if(test1073_547)
{ /* Ieee/output.scm 251 */
long n1_933;long n2_934;
n1_933 = _displayed__5___r4_output_6_10_3; 
n2_934 = _max_length_write__149___r4_output_6_10_3; 
test1056_530 = 
(n1_933>=n2_934); }  else 
{ /* Ieee/output.scm 250 */
test1056_530 = ((bool_t)0); } }  else 
{ /* Ieee/output.scm 249 */
test1056_530 = ((bool_t)0); } } 
if(test1056_530)
{ /* Ieee/output.scm 249 */
display_string(string1347___r4_output_6_10_3, port_20); }  else 
{ /* Ieee/output.scm 249 */
if(
INTEGERP(obj_19))
{ /* Ieee/output.scm 253 */
display_fixnum(obj_19, port_20); }  else 
{ /* Ieee/output.scm 253 */
if(
CHARP(obj_19))
{ /* Ieee/output.scm 255 */
if(flag_21)
{ /* Ieee/output.scm 256 */
display_char(obj_19, port_20); }  else 
{ /* Ieee/output.scm 256 */
write_char(obj_19, port_20); } }  else 
{ /* Ieee/output.scm 255 */
if(
UCS2P(obj_19))
{ /* Ieee/output.scm 259 */
if(flag_21)
{ /* Ieee/output.scm 260 */
display_ucs2(obj_19, port_20); }  else 
{ /* Ieee/output.scm 260 */
write_ucs2(obj_19, port_20); } }  else 
{ /* Ieee/output.scm 259 */
if(
STRINGP(obj_19))
{ /* Ieee/output.scm 263 */
if(flag_21)
{ /* Ieee/output.scm 264 */
display_string(obj_19, port_20); }  else 
{ /* Ieee/output.scm 266 */
obj_t arg1061_535;
arg1061_535 = 
string_for_read(obj_19); 
write_string(arg1061_535, port_20); } }  else 
{ /* Ieee/output.scm 263 */
if(
VECTORP(obj_19))
{ /* Ieee/output.scm 267 */
write_display_vector_76___r4_output_6_10_3(obj_19, port_20, flag_21); }  else 
{ /* Ieee/output.scm 267 */
if(
PAIRP(obj_19))
{ /* Ieee/output.scm 269 */
write_display_pair_103___r4_output_6_10_3(obj_19, port_20, flag_21); }  else 
{ /* Ieee/output.scm 269 */
if(
REALP(obj_19))
{ /* Ieee/output.scm 271 */
display_flonum(obj_19, port_20); }  else 
{ /* Ieee/output.scm 271 */
if(
CELLP(obj_19))
{ /* Ieee/output.scm 273 */
display_string(string1348___r4_output_6_10_3, port_20); 
{ /* Ieee/output.scm 295 */
obj_t arg1074_946;
arg1074_946 = 
CELL_REF(obj_19); 
write_display_159___r4_output_6_10_3(arg1074_946, port_20, flag_21); } 
display_string(string1349___r4_output_6_10_3, port_20); }  else 
{ /* Ieee/output.scm 273 */
if(
STRUCTP(obj_19))
{ /* Ieee/output.scm 275 */
write_display_structure_107___r4_output_6_10_3(obj_19, port_20, flag_21); }  else 
{ /* Ieee/output.scm 275 */
if(
TVECTORP(obj_19))
{ /* Ieee/output.scm 277 */
write_display_tvector_50___r4_output_6_10_3(obj_19, port_20, flag_21); }  else 
{ /* Ieee/output.scm 279 */
bool_t test1068_542;
test1068_542 = 
(POINTERP( obj_19 ) && (TYPE( obj_19 ) >= OBJECT_TYPE)); 
if(test1068_542)
{ /* Ieee/output.scm 279 */
if(flag_21)
{ /* Ieee/output.scm 398 */
obj_t list1115_953;
list1115_953 = 
MAKE_PAIR(port_20, BNIL); 
object_display_243___object(
(object_bglt)(obj_19), list1115_953); }  else 
{ /* Ieee/output.scm 399 */
obj_t list1116_954;
list1116_954 = 
MAKE_PAIR(port_20, BNIL); 
object_write_132___object(
(object_bglt)(obj_19), list1116_954); } }  else 
{ /* Ieee/output.scm 279 */
if(
UCS2_STRINGP(obj_19))
{ /* Ieee/output.scm 281 */
if(flag_21)
{ /* Ieee/output.scm 282 */
display_ucs2string(obj_19, port_20); }  else 
{ /* Ieee/output.scm 284 */
obj_t arg1070_544;
{ /* Ieee/output.scm 284 */
obj_t arg1071_545;
arg1071_545 = 
ucs2_string_to_utf8_string(obj_19); 
arg1070_544 = 
string_for_read(arg1071_545); } 
write_utf8string(arg1070_544, port_20); } }  else 
{ /* Ieee/output.scm 281 */
write_object(obj_19, port_20); } } } } } } } } } } } } } } 
return BUNSPEC;} 
}



/* write/display-structure */
obj_t write_display_structure_107___r4_output_6_10_3(obj_t obj_25, obj_t port_26, bool_t flag_27)
{ AN_OBJECT;
{ /* Ieee/output.scm 301 */
WRITE_CHAR(((unsigned char)'#'), port_26); 
WRITE_CHAR(((unsigned char)'{'), port_26); 
{ /* Ieee/output.scm 304 */
obj_t aux_1416;
aux_1416 = 
STRUCT_KEY(obj_25); 
write_object(aux_1416, port_26); } 
{ /* Ieee/output.scm 305 */
bool_t test_1419;
{ /* ./Ieee/fixnum.scm 3790 */
long aux_1420;
aux_1420 = 
STRUCT_LENGTH(obj_25); 
test_1419 = 
(((long)0)==aux_1420); } 
if(test_1419)
{ /* Ieee/output.scm 306 */
unsigned char aux_1423;
aux_1423 = 
WRITE_CHAR(((unsigned char)'}'), port_26); 
return 
BCHAR(aux_1423);}  else 
{ /* Ieee/output.scm 307 */
long len_551;
{ /* ./Ieee/fixnum.scm 3880 */
long aux_1426;
aux_1426 = 
STRUCT_LENGTH(obj_25); 
len_551 = 
(aux_1426-((long)1)); } 
WRITE_CHAR(((unsigned char)' '), port_26); 
{ 
long i_552;
i_552 = ((long)0); 
loop_553:
{ /* Ieee/output.scm 311 */
bool_t test1077_554;
{ /* Ieee/output.scm 311 */
bool_t test1082_559;
{ /* Ieee/output.scm 311 */
obj_t obj_966;
obj_966 = 
BINT(_max_length_write__149___r4_output_6_10_3); 
test1082_559 = 
INTEGERP(obj_966); } 
if(test1082_559)
{ /* Ieee/output.scm 312 */
bool_t test1083_560;
{ /* Ieee/output.scm 312 */
long n1_967;
n1_967 = _max_length_write__149___r4_output_6_10_3; 
test1083_560 = 
(n1_967>((long)0)); } 
if(test1083_560)
{ /* Ieee/output.scm 313 */
long n1_969;long n2_970;
n1_969 = _displayed__5___r4_output_6_10_3; 
n2_970 = _max_length_write__149___r4_output_6_10_3; 
test1077_554 = 
(n1_969>n2_970); }  else 
{ /* Ieee/output.scm 312 */
test1077_554 = ((bool_t)0); } }  else 
{ /* Ieee/output.scm 311 */
test1077_554 = ((bool_t)0); } } 
if(test1077_554)
{ /* Ieee/output.scm 311 */
return 
write_object(string1350___r4_output_6_10_3, port_26);}  else 
{ /* Ieee/output.scm 311 */
if(
(i_552==len_551))
{ /* Ieee/output.scm 315 */
write_display_159___r4_output_6_10_3(
STRUCT_REF(obj_25, i_552), port_26, flag_27); 
{ /* Ieee/output.scm 317 */
unsigned char aux_1442;
aux_1442 = 
WRITE_CHAR(((unsigned char)'}'), port_26); 
return 
BCHAR(aux_1442);} }  else 
{ /* Ieee/output.scm 315 */
write_display_159___r4_output_6_10_3(
STRUCT_REF(obj_25, i_552), port_26, flag_27); 
WRITE_CHAR(((unsigned char)' '), port_26); 
{ 
long i_1448;
i_1448 = 
(((long)1)+i_552); 
i_552 = i_1448; 
goto loop_553;} } } } } } } } 
}



/* write/display-vector */
obj_t write_display_vector_76___r4_output_6_10_3(obj_t obj_28, obj_t port_29, bool_t flag_30)
{ AN_OBJECT;
{ /* Ieee/output.scm 326 */
WRITE_CHAR(((unsigned char)'#'), port_29); 
{ /* Ieee/output.scm 328 */
long tag_565;
tag_565 = 
VECTOR_TAG(obj_28); 
if(
(tag_565>((long)0)))
{ /* Ieee/output.scm 329 */
if(
(tag_565>=((long)100)))
{ /* Ieee/output.scm 332 */
obj_t aux_1456;
aux_1456 = 
BINT(tag_565); 
write_object(aux_1456, port_29); }  else 
{ /* Ieee/output.scm 331 */
WRITE_CHAR(((unsigned char)'0'), port_29); 
if(
(tag_565>=((long)10)))
{ /* Ieee/output.scm 336 */
obj_t aux_1462;
aux_1462 = 
BINT(tag_565); 
write_object(aux_1462, port_29); }  else 
{ /* Ieee/output.scm 335 */
WRITE_CHAR(((unsigned char)'0'), port_29); 
{ /* Ieee/output.scm 339 */
obj_t aux_1466;
aux_1466 = 
BINT(tag_565); 
write_object(aux_1466, port_29); } } } }  else 
{ /* Ieee/output.scm 329 */BUNSPEC; } } 
WRITE_CHAR(((unsigned char)'('), port_29); 
{ /* Ieee/output.scm 341 */
bool_t test_1470;
{ /* ./Ieee/fixnum.scm 3790 */
long aux_1471;
aux_1471 = 
VECTOR_LENGTH(obj_28); 
test_1470 = 
(((long)0)==aux_1471); } 
if(test_1470)
{ /* Ieee/output.scm 342 */
unsigned char aux_1474;
aux_1474 = 
WRITE_CHAR(((unsigned char)')'), port_29); 
return 
BCHAR(aux_1474);}  else 
{ /* Ieee/output.scm 343 */
long len_570;
{ /* ./Ieee/fixnum.scm 3880 */
long aux_1477;
aux_1477 = 
VECTOR_LENGTH(obj_28); 
len_570 = 
(aux_1477-((long)1)); } 
{ 
long i_571;
i_571 = ((long)0); 
loop_572:
{ /* Ieee/output.scm 346 */
bool_t test1092_573;
{ /* Ieee/output.scm 346 */
bool_t test1097_578;
{ /* Ieee/output.scm 346 */
obj_t obj_992;
obj_992 = 
BINT(_max_length_write__149___r4_output_6_10_3); 
test1097_578 = 
INTEGERP(obj_992); } 
if(test1097_578)
{ /* Ieee/output.scm 347 */
bool_t test1098_579;
{ /* Ieee/output.scm 347 */
long n1_993;
n1_993 = _max_length_write__149___r4_output_6_10_3; 
test1098_579 = 
(n1_993>((long)0)); } 
if(test1098_579)
{ /* Ieee/output.scm 348 */
long n1_995;long n2_996;
n1_995 = _displayed__5___r4_output_6_10_3; 
n2_996 = _max_length_write__149___r4_output_6_10_3; 
test1092_573 = 
(n1_995>=n2_996); }  else 
{ /* Ieee/output.scm 347 */
test1092_573 = ((bool_t)0); } }  else 
{ /* Ieee/output.scm 346 */
test1092_573 = ((bool_t)0); } } 
if(test1092_573)
{ /* Ieee/output.scm 346 */
return 
write_object(string1351___r4_output_6_10_3, port_29);}  else 
{ /* Ieee/output.scm 346 */
if(
(i_571==len_570))
{ /* Ieee/output.scm 350 */
write_display_159___r4_output_6_10_3(
VECTOR_REF(obj_28, i_571), port_29, flag_30); 
{ /* Ieee/output.scm 352 */
unsigned char aux_1492;
aux_1492 = 
WRITE_CHAR(((unsigned char)')'), port_29); 
return 
BCHAR(aux_1492);} }  else 
{ /* Ieee/output.scm 350 */
write_display_159___r4_output_6_10_3(
VECTOR_REF(obj_28, i_571), port_29, flag_30); 
WRITE_CHAR(((unsigned char)' '), port_29); 
{ 
long i_1498;
i_1498 = 
(((long)1)+i_571); 
i_571 = i_1498; 
goto loop_572;} } } } } } } } 
}



/* write/display-tvector */
obj_t write_display_tvector_50___r4_output_6_10_3(obj_t tvec_31, obj_t port_32, bool_t flag_33)
{ AN_OBJECT;
{ /* Ieee/output.scm 361 */
{ /* Ieee/output.scm 362 */
obj_t tvector_ref_208_584;obj_t id_585;
tvector_ref_208_584 = 
tvector_ref_208___tvector(tvec_31); 
id_585 = 
tvector_id_255___tvector(tvec_31); 
WRITE_CHAR(((unsigned char)'#'), port_32); 
write_object(id_585, port_32); 
WRITE_CHAR(((unsigned char)'('), port_32); 
if(
CBOOL(tvector_ref_208_584))
{ /* Ieee/output.scm 367 */
{ /* Ieee/output.scm 372 */
bool_t test_1507;
{ /* ./Ieee/fixnum.scm 3790 */
long aux_1508;
aux_1508 = 
TVECTOR_LENGTH(tvec_31); 
test_1507 = 
(((long)0)==aux_1508); } 
if(test_1507)
{ /* Ieee/output.scm 373 */
unsigned char aux_1511;
aux_1511 = 
WRITE_CHAR(((unsigned char)')'), port_32); 
return 
BCHAR(aux_1511);}  else 
{ /* Ieee/output.scm 374 */
long len_587;
{ /* ./Ieee/fixnum.scm 3880 */
long aux_1514;
aux_1514 = 
TVECTOR_LENGTH(tvec_31); 
len_587 = 
(aux_1514-((long)1)); } 
{ 
long i_588;
i_588 = ((long)0); 
loop_589:
{ /* Ieee/output.scm 377 */
bool_t test1104_590;
{ /* Ieee/output.scm 377 */
bool_t test1109_595;
{ /* Ieee/output.scm 377 */
obj_t obj_1011;
obj_1011 = 
BINT(_max_length_write__149___r4_output_6_10_3); 
test1109_595 = 
INTEGERP(obj_1011); } 
if(test1109_595)
{ /* Ieee/output.scm 378 */
bool_t test1110_596;
{ /* Ieee/output.scm 378 */
long n1_1012;
n1_1012 = _max_length_write__149___r4_output_6_10_3; 
test1110_596 = 
(n1_1012>((long)0)); } 
if(test1110_596)
{ /* Ieee/output.scm 379 */
long n1_1014;long n2_1015;
n1_1014 = _displayed__5___r4_output_6_10_3; 
n2_1015 = _max_length_write__149___r4_output_6_10_3; 
test1104_590 = 
(n1_1014>=n2_1015); }  else 
{ /* Ieee/output.scm 378 */
test1104_590 = ((bool_t)0); } }  else 
{ /* Ieee/output.scm 377 */
test1104_590 = ((bool_t)0); } } 
if(test1104_590)
{ /* Ieee/output.scm 377 */
return 
write_object(string1351___r4_output_6_10_3, port_32);}  else 
{ /* Ieee/output.scm 377 */
if(
(i_588==len_587))
{ /* Ieee/output.scm 381 */
{ /* Ieee/output.scm 382 */
obj_t arg1106_592;
arg1106_592 = 
PROCEDURE_ENTRY(tvector_ref_208_584)(tvector_ref_208_584, tvec_31, 
BINT(i_588), BEOA); 
write_display_159___r4_output_6_10_3(arg1106_592, port_32, flag_33); } 
{ /* Ieee/output.scm 385 */
unsigned char aux_1531;
aux_1531 = 
WRITE_CHAR(((unsigned char)')'), port_32); 
return 
BCHAR(aux_1531);} }  else 
{ /* Ieee/output.scm 381 */
{ /* Ieee/output.scm 387 */
obj_t arg1107_593;
arg1107_593 = 
PROCEDURE_ENTRY(tvector_ref_208_584)(tvector_ref_208_584, tvec_31, 
BINT(i_588), BEOA); 
write_display_159___r4_output_6_10_3(arg1107_593, port_32, flag_33); } 
WRITE_CHAR(((unsigned char)' '), port_32); 
{ 
long i_1539;
i_1539 = 
(((long)1)+i_588); 
i_588 = i_1539; 
goto loop_589;} } } } } } } }  else 
{ /* Ieee/output.scm 367 */
write_object(string1352___r4_output_6_10_3, port_32); 
return tvec_31;} } } 
}



/* write/display-pair */
obj_t write_display_pair_103___r4_output_6_10_3(obj_t obj_37, obj_t port_38, bool_t flag_39)
{ AN_OBJECT;
{ /* Ieee/output.scm 404 */
WRITE_CHAR(((unsigned char)'('), port_38); 
{ 
obj_t l_603;
l_603 = obj_37; 
loop_604:
{ /* Ieee/output.scm 408 */
bool_t test_1543;
{ /* ./Ieee/pair-list.scm 5929 */
obj_t aux_1544;
aux_1544 = 
CDR(l_603); 
test_1543 = 
NULLP(aux_1544); } 
if(test_1543)
{ /* Ieee/output.scm 408 */
write_display_159___r4_output_6_10_3(
CAR(l_603), port_38, flag_39); 
{ /* Ieee/output.scm 410 */
unsigned char aux_1549;
aux_1549 = 
WRITE_CHAR(((unsigned char)')'), port_38); 
return 
BCHAR(aux_1549);} }  else 
{ /* Ieee/output.scm 411 */
bool_t test1119_607;
{ /* Ieee/output.scm 411 */
bool_t test1126_614;
{ /* Ieee/output.scm 411 */
obj_t obj_1025;
obj_1025 = 
BINT(_max_length_write__149___r4_output_6_10_3); 
test1126_614 = 
INTEGERP(obj_1025); } 
if(test1126_614)
{ /* Ieee/output.scm 412 */
bool_t test1127_615;
{ /* Ieee/output.scm 412 */
long n1_1026;
n1_1026 = _max_length_write__149___r4_output_6_10_3; 
test1127_615 = 
(n1_1026>((long)0)); } 
if(test1127_615)
{ /* Ieee/output.scm 413 */
long n1_1028;long n2_1029;
n1_1028 = _displayed__5___r4_output_6_10_3; 
n2_1029 = _max_length_write__149___r4_output_6_10_3; 
test1119_607 = 
(n1_1028>=n2_1029); }  else 
{ /* Ieee/output.scm 412 */
test1119_607 = ((bool_t)0); } }  else 
{ /* Ieee/output.scm 411 */
test1119_607 = ((bool_t)0); } } 
if(test1119_607)
{ /* Ieee/output.scm 411 */
return 
write_object(string1353___r4_output_6_10_3, port_38);}  else 
{ /* Ieee/output.scm 415 */
bool_t test_1560;
{ /* ./Ieee/pair-list.scm 5686 */
obj_t aux_1561;
aux_1561 = 
CDR(l_603); 
test_1560 = 
PAIRP(aux_1561); } 
if(test_1560)
{ /* Ieee/output.scm 415 */
write_display_159___r4_output_6_10_3(
CAR(l_603), port_38, flag_39); 
WRITE_CHAR(((unsigned char)' '), port_38); 
{ 
obj_t l_1567;
l_1567 = 
CDR(l_603); 
l_603 = l_1567; 
goto loop_604;} }  else 
{ /* Ieee/output.scm 415 */
write_display_159___r4_output_6_10_3(
CAR(l_603), port_38, flag_39); 
WRITE_CHAR(((unsigned char)' '), port_38); 
WRITE_CHAR(((unsigned char)'.'), port_38); 
WRITE_CHAR(((unsigned char)' '), port_38); 
write_display_159___r4_output_6_10_3(
CDR(l_603), port_38, flag_39); 
{ /* Ieee/output.scm 421 */
unsigned char aux_1576;
aux_1576 = 
WRITE_CHAR(((unsigned char)')'), port_38); 
return 
BCHAR(aux_1576);} } } } } } } 
}



/* print */
obj_t print___r4_output_6_10_3(obj_t obj_40)
{ AN_OBJECT;
{ /* Ieee/output.scm 430 */
_displayed__5___r4_output_6_10_3 = ((long)0); 
{ 
obj_t l_1037;obj_t res_1038;
l_1037 = obj_40; 
res_1038 = BNIL; 
loop_1036:
if(
NULLP(l_1037))
{ /* Ieee/output.scm 435 */
WRITE_CHAR(((unsigned char)'\n'), current_output_port); 
return res_1038;}  else 
{ /* Ieee/output.scm 439 */
obj_t v_1043;
v_1043 = 
CAR(l_1037); 
write_display_159___r4_output_6_10_3(v_1043, current_output_port, ((bool_t)1)); 
{ 
obj_t res_1586;obj_t l_1584;
l_1584 = 
CDR(l_1037); 
res_1586 = v_1043; 
res_1038 = res_1586; 
l_1037 = l_1584; 
goto loop_1036;} } } } 
}



/* _print */
obj_t _print___r4_output_6_10_3(obj_t env_1183, obj_t obj_1184)
{ AN_OBJECT;
{ /* Ieee/output.scm 430 */
return 
print___r4_output_6_10_3(obj_1184);} 
}



/* display* */
obj_t display__75___r4_output_6_10_3(obj_t obj_41)
{ AN_OBJECT;
{ /* Ieee/output.scm 446 */
_displayed__5___r4_output_6_10_3 = ((long)0); 
{ 
obj_t l_625;
l_625 = obj_41; 
loop_626:
if(
NULLP(l_625))
{ /* Ieee/output.scm 450 */
return BUNSPEC;}  else 
{ /* Ieee/output.scm 450 */
display_2_122___r4_output_6_10_3(
CAR(l_625), current_output_port); 
{ 
obj_t l_1592;
l_1592 = 
CDR(l_625); 
l_625 = l_1592; 
goto loop_626;} } } } 
}



/* _display* */
obj_t _display__37___r4_output_6_10_3(obj_t env_1185, obj_t obj_1186)
{ AN_OBJECT;
{ /* Ieee/output.scm 446 */
return 
display__75___r4_output_6_10_3(obj_1186);} 
}



/* write* */
obj_t write__14___r4_output_6_10_3(obj_t obj_42)
{ AN_OBJECT;
{ /* Ieee/output.scm 459 */
_displayed__5___r4_output_6_10_3 = ((long)0); 
{ 
obj_t l_632;
l_632 = obj_42; 
loop_633:
if(
NULLP(l_632))
{ /* Ieee/output.scm 463 */
return BUNSPEC;}  else 
{ /* Ieee/output.scm 463 */
write_display_159___r4_output_6_10_3(
CAR(l_632), current_output_port, ((bool_t)0)); 
{ 
obj_t l_1599;
l_1599 = 
CDR(l_632); 
l_632 = l_1599; 
goto loop_633;} } } } 
}



/* _write* */
obj_t _write__154___r4_output_6_10_3(obj_t env_1187, obj_t obj_1188)
{ AN_OBJECT;
{ /* Ieee/output.scm 459 */
return 
write__14___r4_output_6_10_3(obj_1188);} 
}



/* fprint */
obj_t fprint___r4_output_6_10_3(obj_t port_43, obj_t obj_44)
{ AN_OBJECT;
{ /* Ieee/output.scm 472 */
_displayed__5___r4_output_6_10_3 = ((long)0); 
{ 
obj_t l_1071;obj_t res_1072;
l_1071 = obj_44; 
res_1072 = BNIL; 
loop_1070:
if(
NULLP(l_1071))
{ /* Ieee/output.scm 476 */
WRITE_CHAR(((unsigned char)'\n'), port_43); 
return res_1072;}  else 
{ /* Ieee/output.scm 480 */
obj_t v_1078;
v_1078 = 
CAR(l_1071); 
write_display_159___r4_output_6_10_3(v_1078, port_43, ((bool_t)1)); 
{ 
obj_t res_1609;obj_t l_1607;
l_1607 = 
CDR(l_1071); 
res_1609 = v_1078; 
res_1072 = res_1609; 
l_1071 = l_1607; 
goto loop_1070;} } } } 
}



/* _fprint */
obj_t _fprint___r4_output_6_10_3(obj_t env_1189, obj_t port_1190, obj_t obj_1191)
{ AN_OBJECT;
{ /* Ieee/output.scm 472 */
return 
fprint___r4_output_6_10_3(port_1190, obj_1191);} 
}



/* set-printer! */
obj_t set_printer__238___r4_output_6_10_3(obj_t f_45)
{ AN_OBJECT;
{ /* Ieee/output.scm 497 */
return ( 
_current_printer__39___r4_output_6_10_3 = f_45, BUNSPEC) ;} 
}



/* _set-printer! */
obj_t _set_printer__226___r4_output_6_10_3(obj_t env_1192, obj_t f_1193)
{ AN_OBJECT;
{ /* Ieee/output.scm 497 */
return 
set_printer__238___r4_output_6_10_3(f_1193);} 
}



/* native-printer */
obj_t native_printer_249___r4_output_6_10_3()
{ AN_OBJECT;
{ /* Ieee/output.scm 503 */
return native_display_env_3___r4_output_6_10_3;} 
}



/* _native-printer */
obj_t _native_printer_193___r4_output_6_10_3(obj_t env_1194)
{ AN_OBJECT;
{ /* Ieee/output.scm 503 */
return native_display_env_3___r4_output_6_10_3;} 
}



/* method-init */
obj_t method_init_76___r4_output_6_10_3()
{ AN_OBJECT;
{ /* Ieee/output.scm 24 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t imported_modules_init_94___r4_output_6_10_3()
{ AN_OBJECT;
{ /* Ieee/output.scm 24 */
module_initialization_70___error(((long)0), "__R4_OUTPUT_6_10_3"); 
module_initialization_70___bexit(((long)0), "__R4_OUTPUT_6_10_3"); 
return 
module_initialization_70___r4_ports_6_10_1(((long)0), "__R4_OUTPUT_6_10_3");} 
}

