/*===========================================================================*/
/*   (Llib/bigloo.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

extern bool_t bigloo_strcmp(obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
static obj_t toplevel_init_63___bigloo();
static obj_t _release__212___bigloo = BUNSPEC;
static obj_t _level__58___bigloo = BUNSPEC;
extern long closure_arity_107___bigloo(obj_t);
extern obj_t check_version__107___bigloo(obj_t, char *, obj_t);
extern obj_t string_to_bstring(char *);
static obj_t _closure_arity_246___bigloo(obj_t, obj_t);
extern obj_t string_to_bstring(char *);
static obj_t _modules__206___bigloo = BUNSPEC;
extern obj_t module_initialization_70___bigloo(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t c_substring(obj_t, long, long);
static obj_t _unspecified___bigloo(obj_t);
extern obj_t unspecified___bigloo();
static obj_t _cnst__123___bigloo(obj_t, obj_t);
static obj_t imported_modules_init_94___bigloo();
extern long minfx___r4_numbers_6_5_fixnum(long, obj_t);
static obj_t require_initialization_114___bigloo = BUNSPEC;
extern bool_t cnst__120___bigloo(obj_t);
static obj_t _check_version__245___bigloo(obj_t, obj_t, obj_t, obj_t);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( check_version__env_23___bigloo, _check_version__245___bigloo1154, _check_version__245___bigloo, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( closure_arity_env_23___bigloo, _closure_arity_246___bigloo1155, _closure_arity_246___bigloo, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( cnst__env_192___bigloo, _cnst__123___bigloo1156, _cnst__123___bigloo, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( unspecified_env_163___bigloo, _unspecified___bigloo1157, _unspecified___bigloo, 0L, 0 );
DEFINE_STRING( string1152___bigloo, string1152___bigloo1158, "and other by: ", 14 );
DEFINE_STRING( string1151___bigloo, string1151___bigloo1159, "Some modules have been compiled by: ", 36 );
DEFINE_STRING( string1150___bigloo, string1150___bigloo1160, " (level 0)", 10 );



/* module-initialization */
obj_t module_initialization_70___bigloo(long checksum_434, char * from_435)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___bigloo))
{ 
require_initialization_114___bigloo = 
BBOOL(((bool_t)0)); 
imported_modules_init_94___bigloo(); 
toplevel_init_63___bigloo(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* toplevel-init */
obj_t toplevel_init_63___bigloo()
{ AN_OBJECT;
{ /* Llib/bigloo.scm 14 */
_release__212___bigloo = BFALSE; 
_level__58___bigloo = BFALSE; 
return ( 
_modules__206___bigloo = BNIL, BUNSPEC) ;} 
}



/* check-version! */
obj_t check_version__107___bigloo(obj_t module_1, char * release_2, obj_t level_3)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 136 */
{ /* Llib/bigloo.scm 138 */
bool_t test1007_218;
{ /* Llib/bigloo.scm 138 */
obj_t obj_369;
obj_369 = _release__212___bigloo; 
test1007_218 = 
STRINGP(obj_369); } 
if(test1007_218)
{ /* Llib/bigloo.scm 142 */
bool_t test1008_219;
{ /* Llib/bigloo.scm 142 */
bool_t test1018_234;
{ /* Llib/bigloo.scm 142 */
long min_238;
{ /* Llib/bigloo.scm 142 */
long arg1023_242;
{ /* Llib/bigloo.scm 142 */
long arg1025_244;long arg1026_245;
{ /* ./Ieee/string.scm 2946 */
obj_t aux_443;
aux_443 = 
string_to_bstring(release_2); 
arg1025_244 = 
STRING_LENGTH(aux_443); } 
{ /* Llib/bigloo.scm 143 */
obj_t string_371;
string_371 = _release__212___bigloo; 
arg1026_245 = 
STRING_LENGTH(string_371); } 
{ /* Llib/bigloo.scm 142 */
obj_t list1027_246;
{ /* Llib/bigloo.scm 142 */
obj_t aux_447;
aux_447 = 
BINT(arg1026_245); 
list1027_246 = 
MAKE_PAIR(aux_447, BNIL); } 
arg1023_242 = 
minfx___r4_numbers_6_5_fixnum(arg1025_244, list1027_246); } } 
min_238 = 
(arg1023_242-((long)1)); } 
{ /* Llib/bigloo.scm 145 */
bool_t test1020_239;
{ /* Llib/bigloo.scm 145 */
obj_t arg1021_240;obj_t arg1022_241;
{ /* ./Ieee/string.scm 3071 */
obj_t aux_452;
aux_452 = 
string_to_bstring(release_2); 
arg1021_240 = 
c_substring(aux_452, ((long)0), min_238); } 
{ /* Llib/bigloo.scm 146 */
obj_t string_377;
string_377 = _release__212___bigloo; 
arg1022_241 = 
c_substring(string_377, ((long)0), min_238); } 
test1020_239 = 
bigloo_strcmp(arg1021_240, arg1022_241); } 
if(test1020_239)
{ /* Llib/bigloo.scm 145 */
test1018_234 = ((bool_t)0); }  else 
{ /* Llib/bigloo.scm 145 */
test1018_234 = ((bool_t)1); } } } 
if(test1018_234)
{ /* Llib/bigloo.scm 142 */
test1008_219 = ((bool_t)1); }  else 
{ /* Llib/bigloo.scm 142 */
if(
CHARP(level_3))
{ /* Llib/bigloo.scm 147 */
bool_t _andtest_1003_236;
{ /* Llib/bigloo.scm 147 */
obj_t obj_383;
obj_383 = _level__58___bigloo; 
_andtest_1003_236 = 
CHARP(obj_383); } 
if(_andtest_1003_236)
{ /* Llib/bigloo.scm 147 */
bool_t test1019_237;
{ /* Llib/bigloo.scm 147 */
unsigned char char1_384;unsigned char char2_385;
char1_384 = 
(unsigned char)CCHAR(_level__58___bigloo); 
char2_385 = 
(unsigned char)CCHAR(level_3); 
test1019_237 = 
(char1_384==char2_385); } 
if(test1019_237)
{ /* Llib/bigloo.scm 147 */
test1008_219 = ((bool_t)0); }  else 
{ /* Llib/bigloo.scm 147 */
test1008_219 = ((bool_t)1); } }  else 
{ /* Llib/bigloo.scm 147 */
test1008_219 = ((bool_t)0); } }  else 
{ /* Llib/bigloo.scm 147 */
test1008_219 = ((bool_t)0); } } } 
if(test1008_219)
{ /* Llib/bigloo.scm 142 */
{ /* Llib/bigloo.scm 154 */
obj_t arg1009_221;obj_t arg1010_222;obj_t arg1011_223;
{ /* Llib/bigloo.scm 154 */
obj_t arg1013_225;
{ /* Llib/bigloo.scm 155 */
obj_t release_386;obj_t level_387;
release_386 = _release__212___bigloo; 
level_387 = _level__58___bigloo; 
if(
CHARP(level_387))
{ /* Llib/bigloo.scm 150 */
obj_t s_389;
{ /* ./Ieee/string.scm 3114 */
char * aux_470;
aux_470 = 
BSTRING_TO_STRING(string1150___bigloo); 
s_389 = 
string_to_bstring(aux_470); } 
{ /* ./Ieee/string.scm 2974 */
unsigned char aux_473;
aux_473 = 
(unsigned char)CCHAR(level_387); 
STRING_SET(s_389, ((long)8), aux_473); } 
arg1013_225 = 
string_append(release_386, s_389); }  else 
{ /* Llib/bigloo.scm 149 */
arg1013_225 = release_386; } } 
arg1009_221 = 
string_append(string1151___bigloo, arg1013_225); } 
{ /* Llib/bigloo.scm 156 */
obj_t arg1015_227;
if(
CHARP(level_3))
{ /* Llib/bigloo.scm 150 */
obj_t s_398;
{ /* ./Ieee/string.scm 3114 */
char * aux_480;
aux_480 = 
BSTRING_TO_STRING(string1150___bigloo); 
s_398 = 
string_to_bstring(aux_480); } 
{ /* ./Ieee/string.scm 2974 */
unsigned char aux_483;
aux_483 = 
(unsigned char)CCHAR(level_3); 
STRING_SET(s_398, ((long)8), aux_483); } 
{ /* Llib/bigloo.scm 152 */
obj_t aux_486;
aux_486 = 
string_to_bstring(release_2); 
arg1015_227 = 
string_append(aux_486, s_398); } }  else 
{ /* Llib/bigloo.scm 149 */
arg1015_227 = 
string_to_bstring(release_2); } 
arg1010_222 = 
string_append(string1152___bigloo, arg1015_227); } 
{ /* Llib/bigloo.scm 158 */
obj_t obj2_405;
obj2_405 = _modules__206___bigloo; 
arg1011_223 = 
MAKE_PAIR(module_1, obj2_405); } 
FAILURE(arg1009_221,arg1010_222,arg1011_223);} }  else 
{ /* Llib/bigloo.scm 142 */
{ /* Llib/bigloo.scm 160 */
obj_t obj2_417;
obj2_417 = _modules__206___bigloo; 
return ( 
_modules__206___bigloo = 
MAKE_PAIR(module_1, obj2_417), BUNSPEC) ;} } }  else 
{ /* Llib/bigloo.scm 138 */
{ /* Llib/bigloo.scm 139 */
obj_t list1028_247;
list1028_247 = 
MAKE_PAIR(module_1, BNIL); 
_modules__206___bigloo = list1028_247; } 
_release__212___bigloo = 
string_to_bstring(release_2); 
return ( 
_level__58___bigloo = level_3, BUNSPEC) ;} } } 
}



/* _check-version! */
obj_t _check_version__245___bigloo(obj_t env_422, obj_t module_423, obj_t release_424, obj_t level_425)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 136 */
return 
check_version__107___bigloo(module_423, 
BSTRING_TO_STRING(release_424), level_425);} 
}



/* closure-arity */
long closure_arity_107___bigloo(obj_t proc_4)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 172 */
return 
PROCEDURE_ARITY(proc_4);} 
}



/* _closure-arity */
obj_t _closure_arity_246___bigloo(obj_t env_426, obj_t proc_427)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 172 */
{ /* Llib/bigloo.scm 172 */
long aux_499;
{ /* Llib/bigloo.scm 172 */
obj_t proc_432;
proc_432 = proc_427; 
aux_499 = 
PROCEDURE_ARITY(proc_432); } 
return 
BINT(aux_499);} } 
}



/* unspecified */
obj_t unspecified___bigloo()
{ AN_OBJECT;
{ /* Llib/bigloo.scm 178 */
return BUNSPEC;} 
}



/* _unspecified */
obj_t _unspecified___bigloo(obj_t env_428)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 178 */
return BUNSPEC;} 
}



/* cnst? */
bool_t cnst__120___bigloo(obj_t obj_5)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 184 */
return 
CNSTP(obj_5);} 
}



/* _cnst? */
obj_t _cnst__123___bigloo(obj_t env_429, obj_t obj_430)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 184 */
{ /* Llib/bigloo.scm 184 */
bool_t aux_503;
{ /* Llib/bigloo.scm 184 */
obj_t obj_433;
obj_433 = obj_430; 
aux_503 = 
CNSTP(obj_433); } 
return 
BBOOL(aux_503);} } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___bigloo()
{ AN_OBJECT;
{ /* Llib/bigloo.scm 14 */
return 
module_initialization_70___error(((long)0), "__BIGLOO");} 
}

