/*===========================================================================*/
/*   (Llib/bit.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

static obj_t _bit_not1133_43___bit(obj_t, obj_t);
extern long bit_not_211___bit(long);
extern long bit_or_153___bit(long, long);
static obj_t _bit_or1130_51___bit(obj_t, obj_t, obj_t);
static obj_t _bit_lsh1136_4___bit(obj_t, obj_t, obj_t);
extern long bit_lsh_5___bit(long, long);
static obj_t _bit_rsh1134_191___bit(obj_t, obj_t, obj_t);
static obj_t _bit_ursh1135_120___bit(obj_t, obj_t, obj_t);
extern unsigned long bit_ursh_31___bit(unsigned long, unsigned long);
static obj_t _bit_xor1132_140___bit(obj_t, obj_t, obj_t);
static obj_t _bit_and1131_249___bit(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70___bit(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern long bit_and_249___bit(long, long);
extern long bit_xor_189___bit(long, long);
static obj_t imported_modules_init_94___bit();
static obj_t require_initialization_114___bit = BUNSPEC;
extern long bit_rsh_14___bit(long, long);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( bit_ursh_env_99___bit, _bit_ursh1135_120___bit1138, _bit_ursh1135_120___bit, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( bit_xor_env_214___bit, _bit_xor1132_140___bit1139, _bit_xor1132_140___bit, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( bit_and_env_215___bit, _bit_and1131_249___bit1140, _bit_and1131_249___bit, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( bit_not_env_219___bit, _bit_not1133_43___bit1141, _bit_not1133_43___bit, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( bit_lsh_env_185___bit, _bit_lsh1136_4___bit1142, _bit_lsh1136_4___bit, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( bit_rsh_env_225___bit, _bit_rsh1134_191___bit1143, _bit_rsh1134_191___bit, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( bit_or_env_216___bit, _bit_or1130_51___bit1144, _bit_or1130_51___bit, 0L, 2 );



/* module-initialization */
obj_t module_initialization_70___bit(long checksum_382, char * from_383)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___bit))
{ 
require_initialization_114___bit = 
BBOOL(((bool_t)0)); 
imported_modules_init_94___bit(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* bit-or */
long bit_or_153___bit(long x_1, long y_2)
{ AN_OBJECT;
{ /* Llib/bit.scm 65 */
return 
(x_1 | y_2);} 
}



/* _bit-or1130 */
obj_t _bit_or1130_51___bit(obj_t env_349, obj_t x_350, obj_t y_351)
{ AN_OBJECT;
{ /* Llib/bit.scm 65 */
{ /* Llib/bit.scm 65 */
long aux_389;
{ /* Llib/bit.scm 65 */
long x_369;long y_370;
x_369 = 
(long)CINT(x_350); 
y_370 = 
(long)CINT(y_351); 
aux_389 = 
(x_369 | y_370); } 
return 
BINT(aux_389);} } 
}



/* bit-and */
long bit_and_249___bit(long x_3, long y_4)
{ AN_OBJECT;
{ /* Llib/bit.scm 71 */
return 
(x_3 & y_4);} 
}



/* _bit-and1131 */
obj_t _bit_and1131_249___bit(obj_t env_352, obj_t x_353, obj_t y_354)
{ AN_OBJECT;
{ /* Llib/bit.scm 71 */
{ /* Llib/bit.scm 71 */
long aux_395;
{ /* Llib/bit.scm 71 */
long x_371;long y_372;
x_371 = 
(long)CINT(x_353); 
y_372 = 
(long)CINT(y_354); 
aux_395 = 
(x_371 & y_372); } 
return 
BINT(aux_395);} } 
}



/* bit-xor */
long bit_xor_189___bit(long x_5, long y_6)
{ AN_OBJECT;
{ /* Llib/bit.scm 77 */
return 
(x_5 ^ y_6);} 
}



/* _bit-xor1132 */
obj_t _bit_xor1132_140___bit(obj_t env_355, obj_t x_356, obj_t y_357)
{ AN_OBJECT;
{ /* Llib/bit.scm 77 */
{ /* Llib/bit.scm 77 */
long aux_401;
{ /* Llib/bit.scm 77 */
long x_373;long y_374;
x_373 = 
(long)CINT(x_356); 
y_374 = 
(long)CINT(y_357); 
aux_401 = 
(x_373 ^ y_374); } 
return 
BINT(aux_401);} } 
}



/* bit-not */
long bit_not_211___bit(long x_7)
{ AN_OBJECT;
{ /* Llib/bit.scm 83 */
return 
~(x_7);} 
}



/* _bit-not1133 */
obj_t _bit_not1133_43___bit(obj_t env_358, obj_t x_359)
{ AN_OBJECT;
{ /* Llib/bit.scm 83 */
{ /* Llib/bit.scm 83 */
long aux_407;
{ /* Llib/bit.scm 83 */
long x_375;
x_375 = 
(long)CINT(x_359); 
aux_407 = 
~(x_375); } 
return 
BINT(aux_407);} } 
}



/* bit-rsh */
long bit_rsh_14___bit(long x_8, long y_9)
{ AN_OBJECT;
{ /* Llib/bit.scm 89 */
return 
(x_8 >> y_9);} 
}



/* _bit-rsh1134 */
obj_t _bit_rsh1134_191___bit(obj_t env_360, obj_t x_361, obj_t y_362)
{ AN_OBJECT;
{ /* Llib/bit.scm 89 */
{ /* Llib/bit.scm 89 */
long aux_412;
{ /* Llib/bit.scm 89 */
long x_376;long y_377;
x_376 = 
(long)CINT(x_361); 
y_377 = 
(long)CINT(y_362); 
aux_412 = 
(x_376 >> y_377); } 
return 
BINT(aux_412);} } 
}



/* bit-ursh */
unsigned long bit_ursh_31___bit(unsigned long x_10, unsigned long y_11)
{ AN_OBJECT;
{ /* Llib/bit.scm 95 */
return 
(x_10 >> y_11);} 
}



/* _bit-ursh1135 */
obj_t _bit_ursh1135_120___bit(obj_t env_363, obj_t x_364, obj_t y_365)
{ AN_OBJECT;
{ /* Llib/bit.scm 95 */
{ /* Llib/bit.scm 95 */
unsigned long aux_418;
{ /* Llib/bit.scm 95 */
unsigned long x_378;unsigned long y_379;
x_378 = 
(unsigned long)CINT(x_364); 
y_379 = 
(unsigned long)CINT(y_365); 
aux_418 = 
(x_378 >> y_379); } 
return 
BINT(aux_418);} } 
}



/* bit-lsh */
long bit_lsh_5___bit(long x_12, long y_13)
{ AN_OBJECT;
{ /* Llib/bit.scm 101 */
return 
(x_12 << y_13);} 
}



/* _bit-lsh1136 */
obj_t _bit_lsh1136_4___bit(obj_t env_366, obj_t x_367, obj_t y_368)
{ AN_OBJECT;
{ /* Llib/bit.scm 101 */
{ /* Llib/bit.scm 101 */
long aux_424;
{ /* Llib/bit.scm 101 */
long x_380;long y_381;
x_380 = 
(long)CINT(x_367); 
y_381 = 
(long)CINT(y_368); 
aux_424 = 
(x_380 << y_381); } 
return 
BINT(aux_424);} } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___bit()
{ AN_OBJECT;
{ /* Llib/bit.scm 14 */
return 
module_initialization_70___error(((long)0), "__BIT");} 
}

