/*===========================================================================*/
/*   (Rgc/rgc-config.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t string_to_symbol(char *);
extern bool_t rgc_alphabetic__209___rgc_config(obj_t);
static obj_t symbol1231___rgc_config = BUNSPEC;
static obj_t symbol1226___rgc_config = BUNSPEC;
static obj_t symbol1222___rgc_config = BUNSPEC;
static obj_t symbol1218___rgc_config = BUNSPEC;
extern bool_t rgc_char__84___rgc_config(obj_t);
static obj_t symbol1212___rgc_config = BUNSPEC;
static obj_t symbol1198___rgc_config = BUNSPEC;
static obj_t symbol1207___rgc_config = BUNSPEC;
static obj_t symbol1196___rgc_config = BUNSPEC;
static obj_t symbol1205___rgc_config = BUNSPEC;
static obj_t symbol1191___rgc_config = BUNSPEC;
static obj_t symbol1200___rgc_config = BUNSPEC;
static obj_t symbol1187___rgc_config = BUNSPEC;
static obj_t symbol1185___rgc_config = BUNSPEC;
static obj_t symbol1183___rgc_config = BUNSPEC;
static obj_t symbol1181___rgc_config = BUNSPEC;
static obj_t list1225___rgc_config = BUNSPEC;
static obj_t toplevel_init_63___rgc_config();
static obj_t list1223___rgc_config = BUNSPEC;
static obj_t list1221___rgc_config = BUNSPEC;
static obj_t list1219___rgc_config = BUNSPEC;
static obj_t list1217___rgc_config = BUNSPEC;
static obj_t list1215___rgc_config = BUNSPEC;
static obj_t list1214___rgc_config = BUNSPEC;
static obj_t list1213___rgc_config = BUNSPEC;
static obj_t list1211___rgc_config = BUNSPEC;
static obj_t list1199___rgc_config = BUNSPEC;
static obj_t list1209___rgc_config = BUNSPEC;
static obj_t list1208___rgc_config = BUNSPEC;
static obj_t list1197___rgc_config = BUNSPEC;
static obj_t list1206___rgc_config = BUNSPEC;
static obj_t list1195___rgc_config = BUNSPEC;
static obj_t list1204___rgc_config = BUNSPEC;
static obj_t list1193___rgc_config = BUNSPEC;
static obj_t list1192___rgc_config = BUNSPEC;
static obj_t list1202___rgc_config = BUNSPEC;
static obj_t list1201___rgc_config = BUNSPEC;
static obj_t list1190___rgc_config = BUNSPEC;
static obj_t list1188___rgc_config = BUNSPEC;
static obj_t list1186___rgc_config = BUNSPEC;
static obj_t list1184___rgc_config = BUNSPEC;
static obj_t list1182___rgc_config = BUNSPEC;
static obj_t list1179___rgc_config = BUNSPEC;
static obj_t list1180___rgc_config = BUNSPEC;
static obj_t _ascii_config__87___rgc_config = BUNSPEC;
extern obj_t rgc_downcase_36___rgc_config(obj_t);
obj_t _rgc_optim__189___rgc_config = BUNSPEC;
extern obj_t rgc_upcase_160___rgc_config(obj_t);
extern obj_t create_struct(obj_t, long);
static obj_t _anonymous_1023__223___rgc_config(obj_t, obj_t);
static obj_t _anonymous_1020__144___rgc_config(obj_t, obj_t);
static obj_t _anonymous_1018__230___rgc_config(obj_t, obj_t);
static obj_t _anonymous_1017__97___rgc_config(obj_t, obj_t);
static obj_t _rgc_config__122___rgc_config = BUNSPEC;
static obj_t _rgc_max_char_138___rgc_config(obj_t);
static obj_t _rgc_env_126___rgc_config(obj_t);
static obj_t _rgc_alphabetic__243___rgc_config(obj_t, obj_t);
extern obj_t module_initialization_70___rgc_config(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t rgc_env_91___rgc_config();
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern bool_t _2__116___r4_numbers_6_5(obj_t, obj_t);
static obj_t _rgc_downcase_71___rgc_config(obj_t, obj_t);
static obj_t _rgc_char__224___rgc_config(obj_t, obj_t);
static obj_t imported_modules_init_94___rgc_config();
extern obj_t rgc_max_char_237___rgc_config();
static obj_t require_initialization_114___rgc_config = BUNSPEC;
static obj_t _rgc_upcase_243___rgc_config(obj_t, obj_t);
static obj_t cnst_init_137___rgc_config();
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( rgc_env_env_87___rgc_config, _rgc_env_126___rgc_config1234, _rgc_env_126___rgc_config, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( rgc_max_char_env_30___rgc_config, _rgc_max_char_138___rgc_config1235, _rgc_max_char_138___rgc_config, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( rgc_downcase_env_174___rgc_config, _rgc_downcase_71___rgc_config1236, _rgc_downcase_71___rgc_config, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( rgc_alphabetic__env_78___rgc_config, _rgc_alphabetic__243___rgc_config1237, _rgc_alphabetic__243___rgc_config, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( rgc_upcase_env_157___rgc_config, _rgc_upcase_243___rgc_config1238, _rgc_upcase_243___rgc_config, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( rgc_char__env_72___rgc_config, _rgc_char__224___rgc_config1239, _rgc_char__224___rgc_config, 0L, 1 );
DEFINE_STATIC_PROCEDURE( proc1229___rgc_config, _anonymous_1018__230___rgc_config1240, _anonymous_1018__230___rgc_config, 0L, 1 );
DEFINE_STATIC_PROCEDURE( proc1230___rgc_config, _anonymous_1017__97___rgc_config1241, _anonymous_1017__97___rgc_config, 0L, 1 );
DEFINE_STATIC_PROCEDURE( proc1228___rgc_config, _anonymous_1020__144___rgc_config1242, _anonymous_1020__144___rgc_config, 0L, 1 );
DEFINE_STATIC_PROCEDURE( proc1227___rgc_config, _anonymous_1023__223___rgc_config1243, _anonymous_1023__223___rgc_config, 0L, 1 );
DEFINE_STRING( string1232___rgc_config, string1232___rgc_config1244, "ascii", 5 );
DEFINE_STRING( string1224___rgc_config, string1224___rgc_config1245, " \t\n", 3 );
DEFINE_STRING( string1220___rgc_config, string1220___rgc_config1246, ".,;!?", 5 );
DEFINE_STRING( string1216___rgc_config, string1216___rgc_config1247, "az09", 4 );
DEFINE_STRING( string1210___rgc_config, string1210___rgc_config1248, "af09", 4 );
DEFINE_STRING( string1194___rgc_config, string1194___rgc_config1249, "AZ", 2 );
DEFINE_STRING( string1203___rgc_config, string1203___rgc_config1250, "09", 2 );
DEFINE_STRING( string1189___rgc_config, string1189___rgc_config1251, "az", 2 );



/* module-initialization */
obj_t module_initialization_70___rgc_config(long checksum_717, char * from_718)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___rgc_config))
{ 
require_initialization_114___rgc_config = 
BBOOL(((bool_t)0)); 
cnst_init_137___rgc_config(); 
imported_modules_init_94___rgc_config(); 
toplevel_init_63___rgc_config(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___rgc_config()
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 14 */
symbol1181___rgc_config = 
string_to_symbol("ALL"); 
symbol1183___rgc_config = 
string_to_symbol("OUT"); 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_727;
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_728;
aux_728 = 
BCHAR(((unsigned char)'\n')); 
aux_727 = 
MAKE_PAIR(aux_728, BNIL); } 
list1182___rgc_config = 
MAKE_PAIR(symbol1183___rgc_config, aux_727); } 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_732;
aux_732 = 
MAKE_PAIR(list1182___rgc_config, BNIL); 
list1180___rgc_config = 
MAKE_PAIR(symbol1181___rgc_config, aux_732); } 
symbol1185___rgc_config = 
string_to_symbol("LOWER"); 
symbol1187___rgc_config = 
string_to_symbol("IN"); 
list1188___rgc_config = 
MAKE_PAIR(string1189___rgc_config, BNIL); 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_738;
aux_738 = 
MAKE_PAIR(list1188___rgc_config, BNIL); 
list1186___rgc_config = 
MAKE_PAIR(symbol1187___rgc_config, aux_738); } 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_741;
aux_741 = 
MAKE_PAIR(list1186___rgc_config, BNIL); 
list1184___rgc_config = 
MAKE_PAIR(symbol1185___rgc_config, aux_741); } 
symbol1191___rgc_config = 
string_to_symbol("UPPER"); 
list1193___rgc_config = 
MAKE_PAIR(string1194___rgc_config, BNIL); 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_746;
aux_746 = 
MAKE_PAIR(list1193___rgc_config, BNIL); 
list1192___rgc_config = 
MAKE_PAIR(symbol1187___rgc_config, aux_746); } 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_749;
aux_749 = 
MAKE_PAIR(list1192___rgc_config, BNIL); 
list1190___rgc_config = 
MAKE_PAIR(symbol1191___rgc_config, aux_749); } 
symbol1196___rgc_config = 
string_to_symbol("ALPHA"); 
symbol1198___rgc_config = 
string_to_symbol("OR"); 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_754;
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_755;
aux_755 = 
MAKE_PAIR(symbol1191___rgc_config, BNIL); 
aux_754 = 
MAKE_PAIR(symbol1185___rgc_config, aux_755); } 
list1197___rgc_config = 
MAKE_PAIR(symbol1198___rgc_config, aux_754); } 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_759;
aux_759 = 
MAKE_PAIR(list1197___rgc_config, BNIL); 
list1195___rgc_config = 
MAKE_PAIR(symbol1196___rgc_config, aux_759); } 
symbol1200___rgc_config = 
string_to_symbol("DIGIT"); 
list1202___rgc_config = 
MAKE_PAIR(string1203___rgc_config, BNIL); 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_764;
aux_764 = 
MAKE_PAIR(list1202___rgc_config, BNIL); 
list1201___rgc_config = 
MAKE_PAIR(symbol1187___rgc_config, aux_764); } 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_767;
aux_767 = 
MAKE_PAIR(list1201___rgc_config, BNIL); 
list1199___rgc_config = 
MAKE_PAIR(symbol1200___rgc_config, aux_767); } 
symbol1205___rgc_config = 
string_to_symbol("XDIGIT"); 
symbol1207___rgc_config = 
string_to_symbol("UNCASE"); 
list1209___rgc_config = 
MAKE_PAIR(string1210___rgc_config, BNIL); 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_773;
aux_773 = 
MAKE_PAIR(list1209___rgc_config, BNIL); 
list1208___rgc_config = 
MAKE_PAIR(symbol1187___rgc_config, aux_773); } 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_776;
aux_776 = 
MAKE_PAIR(list1208___rgc_config, BNIL); 
list1206___rgc_config = 
MAKE_PAIR(symbol1207___rgc_config, aux_776); } 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_779;
aux_779 = 
MAKE_PAIR(list1206___rgc_config, BNIL); 
list1204___rgc_config = 
MAKE_PAIR(symbol1205___rgc_config, aux_779); } 
symbol1212___rgc_config = 
string_to_symbol("ALNUM"); 
list1215___rgc_config = 
MAKE_PAIR(string1216___rgc_config, BNIL); 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_784;
aux_784 = 
MAKE_PAIR(list1215___rgc_config, BNIL); 
list1214___rgc_config = 
MAKE_PAIR(symbol1187___rgc_config, aux_784); } 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_787;
aux_787 = 
MAKE_PAIR(list1214___rgc_config, BNIL); 
list1213___rgc_config = 
MAKE_PAIR(symbol1207___rgc_config, aux_787); } 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_790;
aux_790 = 
MAKE_PAIR(list1213___rgc_config, BNIL); 
list1211___rgc_config = 
MAKE_PAIR(symbol1212___rgc_config, aux_790); } 
symbol1218___rgc_config = 
string_to_symbol("PUNCT"); 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_794;
aux_794 = 
MAKE_PAIR(string1220___rgc_config, BNIL); 
list1219___rgc_config = 
MAKE_PAIR(symbol1187___rgc_config, aux_794); } 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_797;
aux_797 = 
MAKE_PAIR(list1219___rgc_config, BNIL); 
list1217___rgc_config = 
MAKE_PAIR(symbol1218___rgc_config, aux_797); } 
symbol1222___rgc_config = 
string_to_symbol("BLANK"); 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_801;
aux_801 = 
MAKE_PAIR(string1224___rgc_config, BNIL); 
list1223___rgc_config = 
MAKE_PAIR(symbol1187___rgc_config, aux_801); } 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_804;
aux_804 = 
MAKE_PAIR(list1223___rgc_config, BNIL); 
list1221___rgc_config = 
MAKE_PAIR(symbol1222___rgc_config, aux_804); } 
symbol1226___rgc_config = 
string_to_symbol("SPACE"); 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_808;
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_809;
aux_809 = 
BCHAR(((unsigned char)' ')); 
aux_808 = 
MAKE_PAIR(aux_809, BNIL); } 
list1225___rgc_config = 
MAKE_PAIR(symbol1226___rgc_config, aux_808); } 
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_813;
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_814;
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_815;
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_816;
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_817;
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_818;
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_819;
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_820;
{ /* Rgc/rgc-config.scm 127 */
obj_t aux_821;
aux_821 = 
MAKE_PAIR(list1225___rgc_config, BNIL); 
aux_820 = 
MAKE_PAIR(list1221___rgc_config, aux_821); } 
aux_819 = 
MAKE_PAIR(list1217___rgc_config, aux_820); } 
aux_818 = 
MAKE_PAIR(list1211___rgc_config, aux_819); } 
aux_817 = 
MAKE_PAIR(list1204___rgc_config, aux_818); } 
aux_816 = 
MAKE_PAIR(list1199___rgc_config, aux_817); } 
aux_815 = 
MAKE_PAIR(list1195___rgc_config, aux_816); } 
aux_814 = 
MAKE_PAIR(list1190___rgc_config, aux_815); } 
aux_813 = 
MAKE_PAIR(list1184___rgc_config, aux_814); } 
list1179___rgc_config = 
MAKE_PAIR(list1180___rgc_config, aux_813); } 
return ( 
symbol1231___rgc_config = 
string_to_symbol("RGC-CONFIG"), BUNSPEC) ;} 
}



/* toplevel-init */
obj_t toplevel_init_63___rgc_config()
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 14 */
_rgc_optim__189___rgc_config = BFALSE; 
{ /* Rgc/rgc-config.scm 108 */
obj_t arg1016_356;
arg1016_356 = list1179___rgc_config; 
{ /* Rgc/rgc-config.scm 111 */
obj_t _anonymous_1023__223_697;obj_t _anonymous_1020__144_696;obj_t _anonymous_1018__230_695;obj_t _anonymous_1017__97_694;
_anonymous_1023__223_697 = proc1227___rgc_config; 
_anonymous_1020__144_696 = proc1228___rgc_config; 
_anonymous_1018__230_695 = proc1229___rgc_config; 
_anonymous_1017__97_694 = proc1230___rgc_config; 
{ /* Rgc/rgc-config.scm 55 */
obj_t new_538;
new_538 = 
create_struct(symbol1231___rgc_config, ((long)7)); 
STRUCT_SET(new_538, ((long)6), arg1016_356); 
STRUCT_SET(new_538, ((long)5), _anonymous_1023__223_697); 
STRUCT_SET(new_538, ((long)4), _anonymous_1020__144_696); 
STRUCT_SET(new_538, ((long)3), _anonymous_1018__230_695); 
STRUCT_SET(new_538, ((long)2), _anonymous_1017__97_694); 
{ /* ./Llib/struct.scm 1389 */
obj_t aux_839;
aux_839 = 
BINT(((long)256)); 
STRUCT_SET(new_538, ((long)1), aux_839); } 
STRUCT_SET(new_538, ((long)0), string1232___rgc_config); 
_ascii_config__87___rgc_config = new_538; } } } 
return ( 
_rgc_config__122___rgc_config = _ascii_config__87___rgc_config, BUNSPEC) ;} 
}



/* <anonymous:1017> */
obj_t _anonymous_1017__97___rgc_config(obj_t env_698, obj_t x_699)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 110 */
{ 
obj_t x_357;
{ /* Rgc/rgc-config.scm 111 */
bool_t aux_843;
x_357 = x_699; 
if(
_2__206___r4_numbers_6_5(x_357, 
BINT(((long)0))))
{ /* Rgc/rgc-config.scm 111 */
if(
_2__116___r4_numbers_6_5(x_357, 
BINT(((long)256))))
{ /* Rgc/rgc-config.scm 111 */
aux_843 = 
CHARP(x_357)
; }  else 
{ /* Rgc/rgc-config.scm 111 */
aux_843 = ((bool_t)0)
; } }  else 
{ /* Rgc/rgc-config.scm 111 */
aux_843 = ((bool_t)0)
; } 
return 
BBOOL(aux_843);} } } 
}



/* <anonymous:1018> */
obj_t _anonymous_1018__230___rgc_config(obj_t env_700, obj_t x_701)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 112 */
{ 
obj_t x_361;
{ /* Rgc/rgc-config.scm 113 */
bool_t aux_852;
x_361 = x_701; 
if(
_2__206___r4_numbers_6_5(x_361, 
BINT(((long)0))))
{ /* Rgc/rgc-config.scm 113 */
if(
_2__116___r4_numbers_6_5(x_361, 
BINT(((long)256))))
{ /* ./Ieee/char.scm 3092 */
unsigned char c_571;
{ /* ./Ieee/char.scm 3154 */
unsigned char aux_859;
{ /* ./Ieee/char.scm 3148 */
long aux_860;
aux_860 = 
(long)CINT(x_361); 
aux_859 = 
(aux_860); } 
c_571 = 
toupper(aux_859); } 
if(
(c_571>=((unsigned char)'A')))
{ /* ./Ieee/char.scm 3093 */
aux_852 = 
(c_571<=((unsigned char)'Z'))
; }  else 
{ /* ./Ieee/char.scm 3093 */
aux_852 = ((bool_t)0)
; } }  else 
{ /* Rgc/rgc-config.scm 113 */
aux_852 = ((bool_t)0)
; } }  else 
{ /* Rgc/rgc-config.scm 113 */
aux_852 = ((bool_t)0)
; } 
return 
BBOOL(aux_852);} } } 
}



/* <anonymous:1020> */
obj_t _anonymous_1020__144___rgc_config(obj_t env_702, obj_t x_703)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 114 */
{ 
obj_t x_366;
{ /* Rgc/rgc-config.scm 115 */
long aux_868;
x_366 = x_703; 
{ /* ./Ieee/char.scm 3134 */
unsigned char aux_869;
{ /* ./Ieee/char.scm 3154 */
unsigned char aux_870;
{ /* ./Ieee/char.scm 3148 */
long aux_871;
aux_871 = 
(long)CINT(x_366); 
aux_870 = 
(aux_871); } 
aux_869 = 
toupper(aux_870); } 
aux_868 = 
(aux_869); } 
return 
BINT(aux_868);} } } 
}



/* <anonymous:1023> */
obj_t _anonymous_1023__223___rgc_config(obj_t env_704, obj_t x_705)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 116 */
{ 
obj_t x_370;
{ /* Rgc/rgc-config.scm 117 */
long aux_877;
x_370 = x_705; 
{ /* ./Ieee/char.scm 3134 */
unsigned char aux_878;
{ /* ./Ieee/char.scm 3160 */
unsigned char aux_879;
{ /* ./Ieee/char.scm 3148 */
long aux_880;
aux_880 = 
(long)CINT(x_370); 
aux_879 = 
(aux_880); } 
aux_878 = 
tolower(aux_879); } 
aux_877 = 
(aux_878); } 
return 
BINT(aux_877);} } } 
}



/* rgc-max-char */
obj_t rgc_max_char_237___rgc_config()
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 69 */
return 
STRUCT_REF(_rgc_config__122___rgc_config, ((long)1));} 
}



/* _rgc-max-char */
obj_t _rgc_max_char_138___rgc_config(obj_t env_706)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 69 */
return 
rgc_max_char_237___rgc_config();} 
}



/* rgc-char? */
bool_t rgc_char__84___rgc_config(obj_t char_31)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 75 */
{ /* Rgc/rgc-config.scm 76 */
obj_t fun1035_661;
fun1035_661 = 
STRUCT_REF(_rgc_config__122___rgc_config, ((long)2)); 
{ /* Rgc/rgc-config.scm 76 */
obj_t aux_889;
aux_889 = 
PROCEDURE_ENTRY(fun1035_661)(fun1035_661, char_31, BEOA); 
return 
CBOOL(aux_889);} } } 
}



/* _rgc-char? */
obj_t _rgc_char__224___rgc_config(obj_t env_707, obj_t char_708)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 75 */
{ /* Rgc/rgc-config.scm 75 */
bool_t aux_893;
aux_893 = 
rgc_char__84___rgc_config(char_708); 
return 
BBOOL(aux_893);} } 
}



/* rgc-alphabetic? */
bool_t rgc_alphabetic__209___rgc_config(obj_t char_32)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 81 */
{ /* Rgc/rgc-config.scm 82 */
obj_t fun1036_665;
fun1036_665 = 
STRUCT_REF(_rgc_config__122___rgc_config, ((long)3)); 
{ /* Rgc/rgc-config.scm 82 */
obj_t aux_897;
aux_897 = 
PROCEDURE_ENTRY(fun1036_665)(fun1036_665, char_32, BEOA); 
return 
CBOOL(aux_897);} } } 
}



/* _rgc-alphabetic? */
obj_t _rgc_alphabetic__243___rgc_config(obj_t env_709, obj_t char_710)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 81 */
{ /* Rgc/rgc-config.scm 81 */
bool_t aux_901;
aux_901 = 
rgc_alphabetic__209___rgc_config(char_710); 
return 
BBOOL(aux_901);} } 
}



/* rgc-upcase */
obj_t rgc_upcase_160___rgc_config(obj_t char_33)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 87 */
{ /* Rgc/rgc-config.scm 88 */
obj_t fun1037_669;
fun1037_669 = 
STRUCT_REF(_rgc_config__122___rgc_config, ((long)4)); 
return 
PROCEDURE_ENTRY(fun1037_669)(fun1037_669, char_33, BEOA);} } 
}



/* _rgc-upcase */
obj_t _rgc_upcase_243___rgc_config(obj_t env_711, obj_t char_712)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 87 */
return 
rgc_upcase_160___rgc_config(char_712);} 
}



/* rgc-downcase */
obj_t rgc_downcase_36___rgc_config(obj_t char_34)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 93 */
{ /* Rgc/rgc-config.scm 94 */
obj_t fun1039_673;
fun1039_673 = 
STRUCT_REF(_rgc_config__122___rgc_config, ((long)5)); 
return 
PROCEDURE_ENTRY(fun1039_673)(fun1039_673, char_34, BEOA);} } 
}



/* _rgc-downcase */
obj_t _rgc_downcase_71___rgc_config(obj_t env_713, obj_t char_714)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 93 */
return 
rgc_downcase_36___rgc_config(char_714);} 
}



/* rgc-env */
obj_t rgc_env_91___rgc_config()
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 99 */
return 
STRUCT_REF(_rgc_config__122___rgc_config, ((long)6));} 
}



/* _rgc-env */
obj_t _rgc_env_126___rgc_config(obj_t env_715)
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 99 */
return 
rgc_env_91___rgc_config();} 
}



/* imported-modules-init */
obj_t imported_modules_init_94___rgc_config()
{ AN_OBJECT;
{ /* Rgc/rgc-config.scm 14 */
return 
module_initialization_70___error(((long)0), "__RGC_CONFIG");} 
}

