;*=====================================================================*/
;*    serrano/prgm/project/bigloo/work/lib/point.scm                   */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Sat Dec 19 13:03:45 1998                          */
;*    Last change :  Sat Dec 19 13:15:20 1998 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The Scheme implementation of the point library                   */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module point
   (include "point.sch")
   (export  (make-point::point_2d ::double ::double)
	    (inline print-point   ::point_2s)
	    (inline point?        ::object)))

;*---------------------------------------------------------------------*/
;*    make-point ...                                                   */
;*---------------------------------------------------------------------*/
(define (make-point::point_2d x::double y::double)
   (make-point_2s x y))

;*---------------------------------------------------------------------*/
;*    print-point ...                                                  */
;*---------------------------------------------------------------------*/
(define-inline (print-point p::point_2s)
   (print_point_2d (current-output-port p)))

;*---------------------------------------------------------------------*/
;*    point? ...                                                       */
;*---------------------------------------------------------------------*/
(define-inline (point? obj::object)
   (point_2d? obj))
