/*===========================================================================*/
/*   (Ast/ident.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;


static obj_t method_init_76_ast_ident();
extern obj_t string_to_symbol(char *);
static obj_t _id_of_id_229_ast_ident(obj_t, obj_t, obj_t);
extern long get_hash_number(char *);
extern obj_t string_append(obj_t, obj_t);
static obj_t _user_symbol_1320_78_ast_ident(obj_t, obj_t);
extern obj_t id_of_id_112_ast_ident(obj_t, obj_t);
extern obj_t mark_symbol_non_user__17_ast_ident(obj_t);
extern bool_t user_symbol__147_ast_ident(obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _obj__252_type_cache;
extern obj_t dsssl_defaulted_formal__174_tools_dsssl(obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
static obj_t remove___ast_ident(obj_t);
static obj_t _c_keyword_list__101_ast_ident = BUNSPEC;
extern obj_t fast_id_of_id_130_ast_ident(obj_t, obj_t);
extern type_bglt type_of_id_183_ast_ident(obj_t, obj_t);
extern type_bglt get_default_type_181_type_cache();
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_dsssl(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
static obj_t _local_id__name1317_147_ast_ident(obj_t, obj_t);
static obj_t _parse_dsssl_92_ast_ident(obj_t, obj_t);
static obj_t imported_modules_init_94_ast_ident();
static bool_t legal_c_starting_identifier_char__221_ast_ident(unsigned char);
static obj_t _id__name_37_ast_ident(obj_t, obj_t);
static obj_t _mark_symbol_non_user_1319_57_ast_ident(obj_t, obj_t);
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
extern obj_t parse_dsssl_9_ast_ident(obj_t);
extern obj_t id__name_228_ast_ident(obj_t);
extern obj_t dsssl_named_constant__188_tools_dsssl(obj_t);
static obj_t library_modules_init_112_ast_ident();
static obj_t _type_of_id_93_ast_ident(obj_t, obj_t, obj_t);
extern type_bglt use_type__231_type_env(obj_t, obj_t);
static obj_t toplevel_init_63_ast_ident();
extern obj_t open_input_string(obj_t);
static obj_t _parse_id_64_ast_ident(obj_t, obj_t, obj_t);
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t getprop___r4_symbols_6_4(obj_t, obj_t);
extern obj_t local_id__name_204_ast_ident(obj_t);
extern obj_t parse_id_241_ast_ident(obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t putprop__88___r4_symbols_6_4(obj_t, obj_t, obj_t);
static obj_t _fast_id_of_id_85_ast_ident(obj_t, obj_t, obj_t);
extern obj_t check_id_6_ast_ident(obj_t, obj_t);
extern obj_t make_string(long, unsigned char);
extern obj_t c_substring(obj_t, long, long);
extern obj_t read___reader(obj_t);
static obj_t _check_id1318_148_ast_ident(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_ast_ident = BUNSPEC;
static obj_t scheme_id__c_id_79_ast_ident(obj_t, obj_t);
static obj_t cnst_init_137_ast_ident();
static obj_t __cnst[4];

DEFINE_EXPORT_PROCEDURE(local_id__name_env_236_ast_ident, _local_id__name1317_147_ast_ident1335, _local_id__name1317_147_ast_ident, 0L, 1);
DEFINE_EXPORT_PROCEDURE(mark_symbol_non_user__env_195_ast_ident, _mark_symbol_non_user_1319_57_ast_ident1336, _mark_symbol_non_user_1319_57_ast_ident, 0L, 1);
DEFINE_EXPORT_PROCEDURE(parse_dsssl_env_107_ast_ident, _parse_dsssl_92_ast_ident1337, _parse_dsssl_92_ast_ident, 0L, 1);
DEFINE_EXPORT_PROCEDURE(parse_id_env_180_ast_ident, _parse_id_64_ast_ident1338, _parse_id_64_ast_ident, 0L, 2);
DEFINE_EXPORT_PROCEDURE(user_symbol__env_177_ast_ident, _user_symbol_1320_78_ast_ident1339, _user_symbol_1320_78_ast_ident, 0L, 1);
DEFINE_EXPORT_PROCEDURE(id__name_env_140_ast_ident, _id__name_37_ast_ident1340, _id__name_37_ast_ident, 0L, 1);
DEFINE_EXPORT_PROCEDURE(fast_id_of_id_env_120_ast_ident, _fast_id_of_id_85_ast_ident1341, _fast_id_of_id_85_ast_ident, 0L, 2);
DEFINE_EXPORT_PROCEDURE(type_of_id_env_122_ast_ident, _type_of_id_93_ast_ident1342, _type_of_id_93_ast_ident, 0L, 2);
DEFINE_EXPORT_PROCEDURE(id_of_id_env_202_ast_ident, _id_of_id_229_ast_ident1343, _id_of_id_229_ast_ident, 0L, 2);
DEFINE_EXPORT_PROCEDURE(check_id_env_15_ast_ident, _check_id1318_148_ast_ident1344, _check_id1318_148_ast_ident, 0L, 2);
DEFINE_STRING(string1329_ast_ident, string1329_ast_ident1345, "Illegal formal parameter", 24);
DEFINE_STRING(string1330_ast_ident, string1330_ast_ident1346, "NON-USER ERROR-IDENT DSSSL (\"asm\" \"auto\" \"break\" \"case\" \"char\" \"const\" \"continue\" \"default\" \"do\" \"double\" \"else\" \"entry\" \"enum\" \"extern\" \"float\" \"for\" \"fortran\" \"goto\" \"if\" \"int\" \"long\" \"register\" \"return\" \"short\" \"signed\" \"sizeof\" \"static\" \"struct\" \"switch\" \"typedef\" \"union\" \"unsigned\" \"void\" \"volatile\" \"while\" \"main\") ", 322);
DEFINE_STRING(string1328_ast_ident, string1328_ast_ident1347, "_n_o_f_u_c_k_i_n_g___init_or_fini", 33);
DEFINE_STRING(string1327_ast_ident, string1327_ast_ident1348, "_", 1);
DEFINE_STRING(string1326_ast_ident, string1326_ast_ident1349, "Illegal formal identifier", 25);
DEFINE_STRING(string1325_ast_ident, string1325_ast_ident1350, "type-of-id", 10);
DEFINE_STRING(string1324_ast_ident, string1324_ast_ident1351, "", 0);
DEFINE_STRING(string1323_ast_ident, string1323_ast_ident1352, "parse", 5);
DEFINE_STRING(string1322_ast_ident, string1322_ast_ident1353, "`'", 2);
DEFINE_STRING(string1321_ast_ident, string1321_ast_ident1354, "Illegal identifier", 18);



/* module-initialization */
obj_t 
module_initialization_70_ast_ident(long checksum_565, char *from_566)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_ast_ident))
	{
	   require_initialization_114_ast_ident =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_ast_ident();
	   cnst_init_137_ast_ident();
	   imported_modules_init_94_ast_ident();
	   method_init_76_ast_ident();
	   toplevel_init_63_ast_ident();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_ast_ident()
{
   AN_OBJECT;
   {	/* Ast/ident.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "AST_IDENT");
      module_initialization_70___r4_strings_6_7(((long) 0), "AST_IDENT");
      module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "AST_IDENT");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "AST_IDENT");
      module_initialization_70___reader(((long) 0), "AST_IDENT");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_ast_ident()
{
   AN_OBJECT;
   {	/* Ast/ident.scm 14 */
      {		/* Ast/ident.scm 14 */
	 obj_t cnst_port_138_558;
	 cnst_port_138_558 =
	    open_input_string(string1330_ast_ident);
	 {
	    long i_559;
	    i_559 = ((long) 3);
	  loop_560:
	    {	/* Ast/ident.scm 14 */
	       bool_t test1331_561;
	       test1331_561 =
		  (i_559 == ((long) -1));
	       if (test1331_561)
		 {	/* Ast/ident.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Ast/ident.scm 14 */
		    {	/* Ast/ident.scm 14 */
		       obj_t arg1332_562;
		       {	/* Ast/ident.scm 14 */
			  obj_t list1333_563;
			  list1333_563 =
			     MAKE_PAIR(cnst_port_138_558, BNIL);
			  arg1332_562 =
			     read___reader(list1333_563);
		       }
		       CNST_TABLE_SET(i_559, arg1332_562);
		    }
		    {	/* Ast/ident.scm 14 */
		       int aux_564;
		       {	/* Ast/ident.scm 14 */
			  long aux_586;
			  aux_586 =
			     (i_559 - ((long) 1));
			  aux_564 =
			     (int) (aux_586);
		       }
		       {
			  long i_589;
			  i_589 =
			     (long) (aux_564);
			  i_559 = i_589;
			  goto loop_560;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_ast_ident()
{
   AN_OBJECT;
   {	/* Ast/ident.scm 14 */
      {		/* Ast/ident.scm 134 */
	 obj_t l1030_70;
	 l1030_70 =
	    CNST_TABLE_REF(((long) 0));
	 {	/* Ast/ident.scm 134 */
	    obj_t head1033_72;
	    {	/* Ast/ident.scm 134 */
	       obj_t arg1065_83;
	       {	/* ./Ieee/symbol.scm 6027 */
		  char *aux_592;
		  {	/* ./Ieee/symbol.scm 6027 */
		     obj_t aux_593;
		     aux_593 =
			CAR(l1030_70);
		     aux_592 =
			BSTRING_TO_STRING(aux_593);
		  }
		  arg1065_83 =
		     string_to_symbol(aux_592);
	       }
	       head1033_72 =
		  MAKE_PAIR(arg1065_83, BNIL);
	    }
	    {
	       obj_t l1030_73;
	       obj_t tail1034_74;
	       l1030_73 =
		  CDR(l1030_70);
	       tail1034_74 = head1033_72;
	     lname1032_75:
	       if (
		  NULLP(l1030_73))
		 {	/* Ast/ident.scm 134 */
		    return (
		       _c_keyword_list__101_ast_ident = head1033_72, BUNSPEC);
		 }
	       else
		 {	/* Ast/ident.scm 134 */
		    obj_t newtail1035_78;
		    {	/* Ast/ident.scm 134 */
		       obj_t arg1062_80;
		       {	/* ./Ieee/symbol.scm 6027 */
			  char *aux_600;
			  {	/* ./Ieee/symbol.scm 6027 */
			     obj_t aux_601;
			     aux_601 =
				CAR(l1030_73);
			     aux_600 =
				BSTRING_TO_STRING(aux_601);
			  }
			  arg1062_80 =
			     string_to_symbol(aux_600);
		       }
		       newtail1035_78 =
			  MAKE_PAIR(arg1062_80, BNIL);
		    }
		    SET_CDR(tail1034_74, newtail1035_78);
		    {
		       obj_t tail1034_609;
		       obj_t l1030_607;
		       l1030_607 =
			  CDR(l1030_73);
		       tail1034_609 = newtail1035_78;
		       tail1034_74 = tail1034_609;
		       l1030_73 = l1030_607;
		       goto lname1032_75;
		    }
		 }
	    }
	 }
      }
   }
}



/* type-of-id */
type_bglt 
type_of_id_183_ast_ident(obj_t id_1, obj_t loc_2)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 34 */
      if (
	 SYMBOLP(id_1))
	{	/* Ast/ident.scm 37 */
	   obj_t arg1137_87;
	   arg1137_87 =
	      parse_id_241_ast_ident(id_1, loc_2);
	   {	/* ./Ieee/pair-list.scm 5707 */
	      obj_t aux_614;
	      aux_614 =
		 CDR(arg1137_87);
	      return
		 (type_bglt) (aux_614);
	   }
	}
      else
	{	/* Ast/ident.scm 36 */
	   obj_t aux_617;
	   aux_617 =
	      user_error_151_tools_error(string1321_ast_ident, string1322_ast_ident, id_1, BNIL);
	   return
	      (type_bglt) (aux_617);
	}
   }
}



/* _type-of-id */
obj_t 
_type_of_id_93_ast_ident(obj_t env_533, obj_t id_534, obj_t loc_535)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 34 */
      {		/* Ast/ident.scm 34 */
	 type_bglt aux_620;
	 aux_620 =
	    type_of_id_183_ast_ident(id_534, loc_535);
	 return
	    (obj_t) (aux_620);
      }
   }
}



/* id-of-id */
obj_t 
id_of_id_112_ast_ident(obj_t id_3, obj_t loc_4)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 42 */
      if (
	 SYMBOLP(id_3))
	{	/* Ast/ident.scm 45 */
	   obj_t arg1142_90;
	   arg1142_90 =
	      parse_id_241_ast_ident(id_3, loc_4);
	   return
	      CAR(arg1142_90);
	}
      else
	{	/* Ast/ident.scm 43 */
	   return
	      user_error_151_tools_error(string1323_ast_ident, string1321_ast_ident, id_3, BNIL);
	}
   }
}



/* _id-of-id */
obj_t 
_id_of_id_229_ast_ident(obj_t env_536, obj_t id_537, obj_t loc_538)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 42 */
      return
	 id_of_id_112_ast_ident(id_537, loc_538);
   }
}



/* fast-id-of-id */
obj_t 
fast_id_of_id_130_ast_ident(obj_t id_5, obj_t loc_6)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 50 */
      {		/* Ast/ident.scm 52 */
	 bool_t test1146_92;
	 {	/* Ast/ident.scm 52 */
	    obj_t aux_629;
	    aux_629 =
	       dsssl_named_constant__188_tools_dsssl(id_5);
	    test1146_92 =
	       CBOOL(aux_629);
	 }
	 if (test1146_92)
	   {	/* Ast/ident.scm 52 */
	      return
		 PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		 CNST_TABLE_REF(((long) 1)), BEOA);
	   }
	 else
	   {	/* Ast/ident.scm 54 */
	      bool_t test_636;
	      if (
		 PAIRP(id_5))
		{	/* ./Ieee/symbol.scm 6015 */
		   obj_t aux_639;
		   aux_639 =
		      CAR(id_5);
		   test_636 =
		      SYMBOLP(aux_639);
		}
	      else
		{	/* Ast/ident.scm 54 */
		   test_636 = ((bool_t) 0)
		      ;
		}
	      if (test_636)
		{	/* Ast/ident.scm 54 */
		   return
		      CAR(id_5);
		}
	      else
		{	/* Ast/ident.scm 54 */
		   if (
		      SYMBOLP(id_5))
		     {	/* Ast/ident.scm 56 */
			{	/* Ast/ident.scm 59 */
			   obj_t string_95;
			   string_95 =
			      SYMBOL_TO_STRING(id_5);
			   {	/* Ast/ident.scm 59 */
			      long len_96;
			      len_96 =
				 STRING_LENGTH(string_95);
			      {		/* Ast/ident.scm 60 */

				 {
				    long walker_97;
				    walker_97 = ((long) 0);
				  loop_98:
				    if (
				       (walker_97 == len_96))
				      {		/* Ast/ident.scm 63 */
					 return id_5;
				      }
				    else
				      {		/* Ast/ident.scm 65 */
					 bool_t test_649;
					 {	/* Ast/ident.scm 65 */
					    bool_t test_650;
					    {	/* ./Ieee/char.scm 7775 */
					       unsigned char aux_651;
					       aux_651 =
						  STRING_REF(string_95, walker_97);
					       test_650 =
						  (aux_651 == ((unsigned char) ':'));
					    }
					    if (test_650)
					      {		/* Ast/ident.scm 66 */
						 bool_t test_654;
						 {	/* ./Ieee/fixnum.scm 7115 */
						    long aux_655;
						    aux_655 =
						       (len_96 - ((long) 1));
						    test_654 =
						       (walker_97 < aux_655);
						 }
						 if (test_654)
						   {	/* ./Ieee/char.scm 7775 */
						      unsigned char aux_658;
						      {		/* ./Ieee/string.scm 8089 */
							 long aux_659;
							 aux_659 =
							    (walker_97 + ((long) 1));
							 aux_658 =
							    STRING_REF(string_95, aux_659);
						      }
						      test_649 =
							 (aux_658 == ((unsigned char) ':'));
						   }
						 else
						   {	/* Ast/ident.scm 66 */
						      test_649 = ((bool_t) 0)
							 ;
						   }
					      }
					    else
					      {		/* Ast/ident.scm 65 */
						 test_649 = ((bool_t) 0)
						    ;
					      }
					 }
					 if (test_649)
					   {	/* Ast/ident.scm 65 */
					      {		/* Ast/ident.scm 68 */
						 obj_t arg1157_101;
						 arg1157_101 =
						    c_substring(string_95, ((long) 0), walker_97);
						 {	/* ./Ieee/symbol.scm 6027 */
						    char *aux_664;
						    aux_664 =
						       BSTRING_TO_STRING(arg1157_101);
						    return
						       string_to_symbol(aux_664);
						 }
					      }
					   }
					 else
					   {	/* Ast/ident.scm 65 */
					      {
						 long walker_667;
						 walker_667 =
						    (walker_97 + ((long) 1));
						 walker_97 = walker_667;
						 goto loop_98;
					      }
					   }
				      }
				 }
			      }
			   }
			}
		     }
		   else
		     {	/* Ast/ident.scm 56 */
			return
			   user_error_151_tools_error(string1323_ast_ident, string1321_ast_ident, id_5, BNIL);
		     }
		}
	   }
      }
   }
}



/* _fast-id-of-id */
obj_t 
_fast_id_of_id_85_ast_ident(obj_t env_539, obj_t id_540, obj_t loc_541)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 50 */
      return
	 fast_id_of_id_130_ast_ident(id_540, loc_541);
   }
}



/* parse-id */
obj_t 
parse_id_241_ast_ident(obj_t id_7, obj_t loc_8)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 75 */
      if (
	 SYMBOLP(id_7))
	{	/* Ast/ident.scm 78 */
	   obj_t string_113;
	   string_113 =
	      SYMBOL_TO_STRING(id_7);
	   {	/* Ast/ident.scm 78 */
	      long len_114;
	      len_114 =
		 STRING_LENGTH(string_113);
	      {		/* Ast/ident.scm 79 */

		 {
		    long walker_115;
		    long id_stop_141_116;
		    long type_start_90_117;
		    walker_115 = ((long) 0);
		    id_stop_141_116 = ((long) 0);
		    type_start_90_117 = ((long) 0);
		  loop_118:
		    if (
		       (walker_115 == len_114))
		      {		/* Ast/ident.scm 84 */
			 {	/* Ast/ident.scm 86 */
			    bool_t test_677;
			    if (
			       (id_stop_141_116 == ((long) 0)))
			      {		/* Ast/ident.scm 86 */
				 test_677 =
				    (type_start_90_117 > ((long) 0))
				    ;
			      }
			    else
			      {		/* Ast/ident.scm 86 */
				 test_677 = ((bool_t) 0)
				    ;
			      }
			    if (test_677)
			      {		/* Ast/ident.scm 86 */
				 {	/* Ast/ident.scm 89 */
				    obj_t id_121;
				    obj_t tid_122;
				    {	/* ./Ieee/symbol.scm 6027 */
				       char *aux_681;
				       aux_681 =
					  BSTRING_TO_STRING(string1324_ast_ident);
				       id_121 =
					  string_to_symbol(aux_681);
				    }
				    {	/* Ast/ident.scm 90 */
				       obj_t arg1194_124;
				       arg1194_124 =
					  c_substring(string_113, type_start_90_117, len_114);
				       {	/* ./Ieee/symbol.scm 6027 */
					  char *aux_685;
					  aux_685 =
					     BSTRING_TO_STRING(arg1194_124);
					  tid_122 =
					     string_to_symbol(aux_685);
				       }
				    }
				    {	/* Ast/ident.scm 93 */
				       type_bglt arg1193_123;
				       arg1193_123 =
					  use_type__231_type_env(tid_122, loc_8);
				       {	/* ./Ieee/pair-list.scm 5689 */
					  obj_t aux_689;
					  aux_689 =
					     (obj_t) (arg1193_123);
					  return
					     MAKE_PAIR(id_121, aux_689);
				       }
				    }
				 }
			      }
			    else
			      {		/* Ast/ident.scm 86 */
				 if (
				    (id_stop_141_116 == ((long) 0)))
				   {	/* Ast/ident.scm 94 */
				      {		/* Ast/ident.scm 95 */
					 type_bglt arg1196_126;
					 arg1196_126 =
					    get_default_type_181_type_cache();
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_695;
					    aux_695 =
					       (obj_t) (arg1196_126);
					    return
					       MAKE_PAIR(id_7, aux_695);
					 }
				      }
				   }
				 else
				   {	/* Ast/ident.scm 94 */
				      if (
					 (type_start_90_117 == len_114))
					{	/* Ast/ident.scm 96 */
					   {	/* Ast/ident.scm 98 */
					      obj_t arg1202_130;
					      {		/* Ast/ident.scm 101 */
						 obj_t arg1204_132;
						 type_bglt arg1206_133;
						 arg1204_132 =
						    CNST_TABLE_REF(((long) 2));
						 arg1206_133 =
						    get_default_type_181_type_cache();
						 {	/* ./Ieee/pair-list.scm 5689 */
						    obj_t aux_702;
						    aux_702 =
						       (obj_t) (arg1206_133);
						    arg1202_130 =
						       MAKE_PAIR(arg1204_132, aux_702);
						 }
					      }
					      {		/* Ast/ident.scm 98 */
						 obj_t list1203_131;
						 list1203_131 =
						    MAKE_PAIR(arg1202_130, BNIL);
						 return
						    user_error_151_tools_error(string1325_ast_ident, string1326_ast_ident, id_7, list1203_131);
					      }
					   }
					}
				      else
					{	/* Ast/ident.scm 96 */
					   {	/* Ast/ident.scm 103 */
					      obj_t id_134;
					      obj_t tid_135;
					      {		/* Ast/ident.scm 103 */
						 obj_t arg1209_137;
						 arg1209_137 =
						    c_substring(string_113, ((long) 0), id_stop_141_116);
						 {	/* ./Ieee/symbol.scm 6027 */
						    char *aux_708;
						    aux_708 =
						       BSTRING_TO_STRING(arg1209_137);
						    id_134 =
						       string_to_symbol(aux_708);
						 }
					      }
					      {		/* Ast/ident.scm 104 */
						 obj_t arg1212_138;
						 arg1212_138 =
						    c_substring(string_113, type_start_90_117, len_114);
						 {	/* ./Ieee/symbol.scm 6027 */
						    char *aux_712;
						    aux_712 =
						       BSTRING_TO_STRING(arg1212_138);
						    tid_135 =
						       string_to_symbol(aux_712);
						 }
					      }
					      {		/* Ast/ident.scm 107 */
						 type_bglt arg1207_136;
						 arg1207_136 =
						    use_type__231_type_env(tid_135, loc_8);
						 {	/* ./Ieee/pair-list.scm 5689 */
						    obj_t aux_716;
						    aux_716 =
						       (obj_t) (arg1207_136);
						    return
						       MAKE_PAIR(id_134, aux_716);
						 }
					      }
					   }
					}
				   }
			      }
			 }
		      }
		    else
		      {		/* Ast/ident.scm 108 */
			 bool_t test_719;
			 {	/* Ast/ident.scm 108 */
			    bool_t test_720;
			    {	/* ./Ieee/char.scm 7775 */
			       unsigned char aux_721;
			       aux_721 =
				  STRING_REF(string_113, walker_115);
			       test_720 =
				  (aux_721 == ((unsigned char) ':'));
			    }
			    if (test_720)
			      {		/* Ast/ident.scm 109 */
				 bool_t test_724;
				 {	/* ./Ieee/fixnum.scm 7115 */
				    long aux_725;
				    aux_725 =
				       (len_114 - ((long) 1));
				    test_724 =
				       (walker_115 < aux_725);
				 }
				 if (test_724)
				   {	/* ./Ieee/char.scm 7775 */
				      unsigned char aux_728;
				      {		/* ./Ieee/string.scm 8089 */
					 long aux_729;
					 aux_729 =
					    (walker_115 + ((long) 1));
					 aux_728 =
					    STRING_REF(string_113, aux_729);
				      }
				      test_719 =
					 (aux_728 == ((unsigned char) ':'));
				   }
				 else
				   {	/* Ast/ident.scm 109 */
				      test_719 = ((bool_t) 0)
					 ;
				   }
			      }
			    else
			      {		/* Ast/ident.scm 108 */
				 test_719 = ((bool_t) 0)
				    ;
			      }
			 }
			 if (test_719)
			   {	/* Ast/ident.scm 108 */
			      if (
				 (type_start_90_117 > ((long) 0)))
				{	/* Ast/ident.scm 112 */
				   obj_t arg1220_144;
				   {	/* Ast/ident.scm 115 */
				      obj_t arg1222_146;
				      type_bglt arg1223_147;
				      arg1222_146 =
					 CNST_TABLE_REF(((long) 2));
				      arg1223_147 =
					 get_default_type_181_type_cache();
				      {		/* ./Ieee/pair-list.scm 5689 */
					 obj_t aux_737;
					 aux_737 =
					    (obj_t) (arg1223_147);
					 arg1220_144 =
					    MAKE_PAIR(arg1222_146, aux_737);
				      }
				   }
				   {	/* Ast/ident.scm 112 */
				      obj_t list1221_145;
				      list1221_145 =
					 MAKE_PAIR(arg1220_144, BNIL);
				      return
					 user_error_151_tools_error(string1325_ast_ident, string1326_ast_ident, id_7, list1221_145);
				   }
				}
			      else
				{
				   long type_start_90_745;
				   long id_stop_141_744;
				   long walker_742;
				   walker_742 =
				      (walker_115 + ((long) 2));
				   id_stop_141_744 = walker_115;
				   type_start_90_745 =
				      (walker_115 + ((long) 2));
				   type_start_90_117 = type_start_90_745;
				   id_stop_141_116 = id_stop_141_744;
				   walker_115 = walker_742;
				   goto loop_118;
				}
			   }
			 else
			   {	/* Ast/ident.scm 108 */
			      {
				 long walker_747;
				 walker_747 =
				    (walker_115 + ((long) 1));
				 walker_115 = walker_747;
				 goto loop_118;
			      }
			   }
		      }
		 }
	      }
	   }
	}
      else
	{	/* Ast/ident.scm 76 */
	   return
	      user_error_151_tools_error(string1323_ast_ident, string1321_ast_ident, id_7, BNIL);
	}
   }
}



/* _parse-id */
obj_t 
_parse_id_64_ast_ident(obj_t env_542, obj_t id_543, obj_t loc_544)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 75 */
      return
	 parse_id_241_ast_ident(id_543, loc_544);
   }
}



/* id->name */
obj_t 
id__name_228_ast_ident(obj_t id_9)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 123 */
      if (
	 SYMBOLP(id_9))
	{	/* Ast/ident.scm 126 */
	   obj_t name_159;
	   {	/* Ast/ident.scm 126 */
	      obj_t arg1238_162;
	      arg1238_162 =
		 SYMBOL_TO_STRING(id_9);
	      name_159 =
		 string_downcase_77___r4_strings_6_7(arg1238_162);
	   }
	   {	/* Ast/ident.scm 128 */
	      obj_t arg1236_160;
	      {		/* Ast/ident.scm 128 */
		 obj_t arg1237_161;
		 {	/* ./Ieee/symbol.scm 6027 */
		    char *aux_755;
		    aux_755 =
		       BSTRING_TO_STRING(name_159);
		    arg1237_161 =
		       string_to_symbol(aux_755);
		 }
		 arg1236_160 =
		    memq___r4_pairs_and_lists_6_3(arg1237_161, _c_keyword_list__101_ast_ident);
	      }
	      return
		 scheme_id__c_id_79_ast_ident(name_159, arg1236_160);
	   }
	}
      else
	{	/* Ast/ident.scm 124 */
	   return
	      user_error_151_tools_error(string1323_ast_ident, string1321_ast_ident, id_9, BNIL);
	}
   }
}



/* _id->name */
obj_t 
_id__name_37_ast_ident(obj_t env_545, obj_t id_546)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 123 */
      return
	 id__name_228_ast_ident(id_546);
   }
}



/* local-id->name */
obj_t 
local_id__name_204_ast_ident(obj_t id_10)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 144 */
      {		/* Ast/ident.scm 145 */
	 obj_t name_377;
	 {	/* Ast/ident.scm 145 */
	    obj_t arg1240_378;
	    arg1240_378 =
	       SYMBOL_TO_STRING(id_10);
	    name_377 =
	       string_downcase_77___r4_strings_6_7(arg1240_378);
	 }
	 return
	    scheme_id__c_id_79_ast_ident(name_377, BFALSE);
      }
   }
}



/* _local-id->name1317 */
obj_t 
_local_id__name1317_147_ast_ident(obj_t env_547, obj_t id_548)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 144 */
      return
	 local_id__name_204_ast_ident(id_548);
   }
}



/* scheme-id->c-id */
obj_t 
scheme_id__c_id_79_ast_ident(obj_t string_11, obj_t rg_12)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 151 */
      {
	 obj_t string_195;
	 {	/* Ast/ident.scm 170 */
	    long len_168;
	    len_168 =
	       STRING_LENGTH(string_11);
	    if (
	       (len_168 == ((long) 0)))
	      {		/* Ast/ident.scm 172 */
		 return string1327_ast_ident;
	      }
	    else
	      {		/* Ast/ident.scm 174 */
		 bool_t test_769;
		 {	/* Ast/ident.scm 174 */
		    obj_t aux_770;
		    string_195 = string_11;
		    if (
		       CBOOL(rg_12))
		      {		/* Ast/ident.scm 157 */
			 aux_770 = rg_12
			    ;
		      }
		    else
		      {		/* Ast/ident.scm 158 */
			 bool_t _ortest_1038_198;
			 if (
			    legal_c_starting_identifier_char__221_ast_ident(
			       STRING_REF(string_195, ((long) 0))))
			   {	/* Ast/ident.scm 158 */
			      _ortest_1038_198 = ((bool_t) 0);
			   }
			 else
			   {	/* Ast/ident.scm 158 */
			      _ortest_1038_198 = ((bool_t) 1);
			   }
			 if (_ortest_1038_198)
			   {	/* Ast/ident.scm 158 */
			      aux_770 =
				 BBOOL(_ortest_1038_198)
				 ;
			   }
			 else
			   {	/* Ast/ident.scm 159 */
			      long len_199;
			      len_199 =
				 STRING_LENGTH(string_195);
			      {
				 long i_200;
				 {	/* Ast/ident.scm 160 */
				    bool_t aux_779;
				    i_200 = ((long) 0);
				  loop_201:
				    if (
				       (i_200 == len_199))
				      {		/* Ast/ident.scm 161 */
					 aux_779 = ((bool_t) 0)
					    ;
				      }
				    else
				      {		/* Ast/ident.scm 163 */
					 unsigned char c_203;
					 c_203 =
					    STRING_REF(string_195, i_200);
					 {	/* Ast/ident.scm 164 */
					    bool_t test_783;
					    {	/* Ast/ident.scm 164 */
					       bool_t test_784;
					       {	/* ./Ieee/char.scm 7835 */
						  unsigned char c_442;
						  c_442 =
						     toupper(c_203);
						  if (
						     (c_442 >= ((unsigned char) 'A')))
						    {	/* ./Ieee/char.scm 7836 */
						       test_784 =
							  (c_442 <= ((unsigned char) 'Z'))
							  ;
						    }
						  else
						    {	/* ./Ieee/char.scm 7836 */
						       test_784 = ((bool_t) 0)
							  ;
						    }
					       }
					       if (test_784)
						 {	/* Ast/ident.scm 164 */
						    test_783 = ((bool_t) 1)
						       ;
						 }
					       else
						 {	/* Ast/ident.scm 165 */
						    bool_t test_789;
						    if (
						       (c_203 >= ((unsigned char) '0')))
						      {		/* ./Ieee/char.scm 7844 */
							 test_789 =
							    (c_203 <= ((unsigned char) '9'))
							    ;
						      }
						    else
						      {		/* ./Ieee/char.scm 7844 */
							 test_789 = ((bool_t) 0)
							    ;
						      }
						    if (test_789)
						      {		/* Ast/ident.scm 165 */
							 test_783 = ((bool_t) 1)
							    ;
						      }
						    else
						      {		/* Ast/ident.scm 165 */
							 test_783 =
							    (c_203 == ((unsigned char) '_'))
							    ;
						      }
						 }
					    }
					    if (test_783)
					      {
						 long i_794;
						 i_794 =
						    (i_200 + ((long) 1));
						 i_200 = i_794;
						 goto loop_201;
					      }
					    else
					      {		/* Ast/ident.scm 164 */
						 aux_779 = ((bool_t) 1)
						    ;
					      }
					 }
				      }
				    aux_770 =
				       BBOOL(aux_779);
				 }
			      }
			   }
		      }
		    test_769 =
		       CBOOL(aux_770);
		 }
		 if (test_769)
		   {	/* Ast/ident.scm 174 */
		      {		/* Ast/ident.scm 179 */
			 obj_t res_172;
			 {	/* Ast/ident.scm 180 */
			    obj_t res1310_390;
			    {	/* ./Ieee/string.scm 8054 */
			       long aux_798;
			       {	/* ./Ieee/string.scm 8054 */
				  int aux_799;
				  aux_799 =
				     (int) (len_168);
				  aux_798 =
				     (long) (aux_799);
			       }
			       res1310_390 =
				  make_string(aux_798, ((unsigned char) ' '));
			    }
			    res_172 = res1310_390;
			 }
			 {	/* Ast/ident.scm 180 */

			    {
			       long i_173;
			       i_173 = ((long) 0);
			     loop_174:
			       if (
				  (i_173 == len_168))
				 {	/* Ast/ident.scm 183 */
				    obj_t str_176;
				    {	/* Ast/ident.scm 183 */
				       obj_t arg1246_180;
				       {	/* Ast/ident.scm 183 */
					  char *arg1249_182;
					  {	/* Ast/ident.scm 186 */
					     long arg1250_183;
					     {	/* ./Llib/hash.scm 1783 */
						char *aux_805;
						aux_805 =
						   BSTRING_TO_STRING(string_11);
						arg1250_183 =
						   get_hash_number(aux_805);
					     }
					     arg1249_182 =
						integer__string_135___r4_numbers_6_5_fixnum(arg1250_183, BNIL);
					  }
					  {	/* Ast/ident.scm 183 */
					     obj_t aux_809;
					     aux_809 =
						string_to_bstring(arg1249_182);
					     arg1246_180 =
						string_append(string1327_ast_ident, aux_809);
					  }
				       }
				       str_176 =
					  string_append(res_172, arg1246_180);
				    }
				    {	/* Ast/ident.scm 183 */
				       unsigned char cs_177;
				       cs_177 =
					  STRING_REF(str_176, ((long) 0));
				       {	/* Ast/ident.scm 187 */

					  if (
					     (cs_177 == ((unsigned char) '_')))
					    {	/* Ast/ident.scm 189 */
					       return
						  remove___ast_ident(str_176);
					    }
					  else
					    {	/* Ast/ident.scm 189 */
					       if (
						  legal_c_starting_identifier_char__221_ast_ident(cs_177))
						 {	/* Ast/ident.scm 191 */
						    return str_176;
						 }
					       else
						 {	/* Ast/ident.scm 191 */
						    return
						       string_append(string1327_ast_ident, str_176);
						 }
					    }
				       }
				    }
				 }
			       else
				 {	/* Ast/ident.scm 195 */
				    unsigned char c_185;
				    c_185 =
				       STRING_REF(string_11, i_173);
				    {	/* Ast/ident.scm 196 */
				       bool_t test_821;
				       {	/* Ast/ident.scm 196 */
					  bool_t test_822;
					  {	/* ./Ieee/char.scm 7835 */
					     unsigned char c_401;
					     c_401 =
						toupper(c_185);
					     if (
						(c_401 >= ((unsigned char) 'A')))
					       {	/* ./Ieee/char.scm 7836 */
						  test_822 =
						     (c_401 <= ((unsigned char) 'Z'))
						     ;
					       }
					     else
					       {	/* ./Ieee/char.scm 7836 */
						  test_822 = ((bool_t) 0)
						     ;
					       }
					  }
					  if (test_822)
					    {	/* Ast/ident.scm 196 */
					       test_821 = ((bool_t) 1)
						  ;
					    }
					  else
					    {	/* Ast/ident.scm 197 */
					       bool_t test_827;
					       if (
						  (c_185 >= ((unsigned char) '0')))
						 {	/* ./Ieee/char.scm 7844 */
						    test_827 =
						       (c_185 <= ((unsigned char) '9'))
						       ;
						 }
					       else
						 {	/* ./Ieee/char.scm 7844 */
						    test_827 = ((bool_t) 0)
						       ;
						 }
					       if (test_827)
						 {	/* Ast/ident.scm 197 */
						    test_821 = ((bool_t) 1)
						       ;
						 }
					       else
						 {	/* Ast/ident.scm 197 */
						    test_821 =
						       (c_185 == ((unsigned char) '_'))
						       ;
						 }
					    }
				       }
				       if (test_821)
					 {	/* Ast/ident.scm 196 */
					    STRING_SET(res_172, i_173, c_185);
					    {
					       long i_833;
					       i_833 =
						  (i_173 + ((long) 1));
					       i_173 = i_833;
					       goto loop_174;
					    }
					 }
				       else
					 {	/* Ast/ident.scm 196 */
					    STRING_SET(res_172, i_173, ((unsigned char) '_'));
					    {
					       long i_836;
					       i_836 =
						  (i_173 + ((long) 1));
					       i_173 = i_836;
					       goto loop_174;
					    }
					 }
				    }
				 }
			    }
			 }
		      }
		   }
		 else
		   {	/* Ast/ident.scm 174 */
		      {		/* Ast/ident.scm 175 */
			 bool_t test_838;
			 {	/* ./Ieee/char.scm 7775 */
			    unsigned char aux_839;
			    aux_839 =
			       STRING_REF(string_11, ((long) 0));
			    test_838 =
			       (aux_839 == ((unsigned char) '_'));
			 }
			 if (test_838)
			   {	/* Ast/ident.scm 175 */
			      return
				 remove___ast_ident(string_11);
			   }
			 else
			   {	/* Ast/ident.scm 175 */
			      return string_11;
			   }
		      }
		   }
	      }
	 }
      }
   }
}



/* legal-c-starting-identifier-char? */
bool_t 
legal_c_starting_identifier_char__221_ast_ident(unsigned char c_210)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 153 */
      {		/* Ast/ident.scm 154 */
	 bool_t _ortest_1036_212;
	 {	/* ./Ieee/char.scm 7835 */
	    unsigned char c_462;
	    c_462 =
	       toupper(c_210);
	    if (
	       (c_462 >= ((unsigned char) 'A')))
	      {		/* ./Ieee/char.scm 7836 */
		 _ortest_1036_212 =
		    (c_462 <= ((unsigned char) 'Z'));
	      }
	    else
	      {		/* ./Ieee/char.scm 7836 */
		 _ortest_1036_212 = ((bool_t) 0);
	      }
	 }
	 if (_ortest_1036_212)
	   {	/* Ast/ident.scm 154 */
	      return _ortest_1036_212;
	   }
	 else
	   {	/* Ast/ident.scm 154 */
	      return
		 (c_210 == ((unsigned char) '_'));
	   }
      }
   }
}



/* remove__ */
obj_t 
remove___ast_ident(obj_t string_13)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 213 */
      {		/* Ast/ident.scm 215 */
	 bool_t test_849;
	 {	/* ./Ieee/fixnum.scm 7133 */
	    long aux_850;
	    aux_850 =
	       STRING_LENGTH(string_13);
	    test_849 =
	       (aux_850 >= ((long) 6));
	 }
	 if (test_849)
	   {	/* Ast/ident.scm 217 */
	      bool_t test_853;
	      {		/* ./Ieee/char.scm 7775 */
		 unsigned char aux_854;
		 aux_854 =
		    STRING_REF(string_13, ((long) 0));
		 test_853 =
		    (aux_854 == ((unsigned char) '_'));
	      }
	      if (test_853)
		{	/* Ast/ident.scm 219 */
		   bool_t test_857;
		   {	/* ./Ieee/char.scm 7775 */
		      unsigned char aux_858;
		      aux_858 =
			 STRING_REF(string_13, ((long) 1));
		      test_857 =
			 (aux_858 == ((unsigned char) '_'));
		   }
		   if (test_857)
		     {	/* Ast/ident.scm 221 */
			bool_t test_861;
			{	/* Ast/ident.scm 221 */
			   bool_t test_862;
			   {	/* ./Ieee/char.scm 7775 */
			      unsigned char aux_863;
			      aux_863 =
				 STRING_REF(string_13, ((long) 2));
			      test_862 =
				 (aux_863 == ((unsigned char) 'i'));
			   }
			   if (test_862)
			     {	/* Ast/ident.scm 221 */
				test_861 = ((bool_t) 0)
				   ;
			     }
			   else
			     {	/* Ast/ident.scm 222 */
				bool_t test_866;
				{	/* ./Ieee/char.scm 7775 */
				   unsigned char aux_867;
				   aux_867 =
				      STRING_REF(string_13, ((long) 2));
				   test_866 =
				      (aux_867 == ((unsigned char) 'f'));
				}
				if (test_866)
				  {	/* Ast/ident.scm 222 */
				     test_861 = ((bool_t) 0)
					;
				  }
				else
				  {	/* Ast/ident.scm 222 */
				     test_861 = ((bool_t) 1)
					;
				  }
			     }
			}
			if (test_861)
			  {	/* Ast/ident.scm 221 */
			     return string_13;
			  }
			else
			  {	/* Ast/ident.scm 224 */
			     bool_t test_870;
			     {	/* Ast/ident.scm 224 */
				bool_t test_871;
				{	/* ./Ieee/char.scm 7775 */
				   unsigned char aux_872;
				   aux_872 =
				      STRING_REF(string_13, ((long) 3));
				   test_871 =
				      (aux_872 == ((unsigned char) 'n'));
				}
				if (test_871)
				  {	/* Ast/ident.scm 224 */
				     test_870 = ((bool_t) 0)
					;
				  }
				else
				  {	/* Ast/ident.scm 225 */
				     bool_t test_875;
				     {	/* ./Ieee/char.scm 7775 */
					unsigned char aux_876;
					aux_876 =
					   STRING_REF(string_13, ((long) 3));
					test_875 =
					   (aux_876 == ((unsigned char) 'i'));
				     }
				     if (test_875)
				       {	/* Ast/ident.scm 225 */
					  test_870 = ((bool_t) 0)
					     ;
				       }
				     else
				       {	/* Ast/ident.scm 225 */
					  test_870 = ((bool_t) 1)
					     ;
				       }
				  }
			     }
			     if (test_870)
			       {	/* Ast/ident.scm 224 */
				  return string_13;
			       }
			     else
			       {	/* Ast/ident.scm 227 */
				  bool_t test_879;
				  {	/* Ast/ident.scm 227 */
				     bool_t test_880;
				     {	/* ./Ieee/char.scm 7775 */
					unsigned char aux_881;
					aux_881 =
					   STRING_REF(string_13, ((long) 4));
					test_880 =
					   (aux_881 == ((unsigned char) 'i'));
				     }
				     if (test_880)
				       {	/* Ast/ident.scm 227 */
					  test_879 = ((bool_t) 0)
					     ;
				       }
				     else
				       {	/* Ast/ident.scm 228 */
					  bool_t test_884;
					  {	/* ./Ieee/char.scm 7775 */
					     unsigned char aux_885;
					     aux_885 =
						STRING_REF(string_13, ((long) 4));
					     test_884 =
						(aux_885 == ((unsigned char) 'n'));
					  }
					  if (test_884)
					    {	/* Ast/ident.scm 228 */
					       test_879 = ((bool_t) 0)
						  ;
					    }
					  else
					    {	/* Ast/ident.scm 228 */
					       test_879 = ((bool_t) 1)
						  ;
					    }
				       }
				  }
				  if (test_879)
				    {	/* Ast/ident.scm 227 */
				       return string_13;
				    }
				  else
				    {	/* Ast/ident.scm 230 */
				       bool_t test_888;
				       {	/* Ast/ident.scm 230 */
					  bool_t test_889;
					  {	/* ./Ieee/char.scm 7775 */
					     unsigned char aux_890;
					     aux_890 =
						STRING_REF(string_13, ((long) 5));
					     test_889 =
						(aux_890 == ((unsigned char) 't'));
					  }
					  if (test_889)
					    {	/* Ast/ident.scm 230 */
					       test_888 = ((bool_t) 0)
						  ;
					    }
					  else
					    {	/* Ast/ident.scm 231 */
					       bool_t test_893;
					       {	/* ./Ieee/char.scm 7775 */
						  unsigned char aux_894;
						  aux_894 =
						     STRING_REF(string_13, ((long) 5));
						  test_893 =
						     (aux_894 == ((unsigned char) 'i'));
					       }
					       if (test_893)
						 {	/* Ast/ident.scm 231 */
						    test_888 = ((bool_t) 0)
						       ;
						 }
					       else
						 {	/* Ast/ident.scm 231 */
						    test_888 = ((bool_t) 1)
						       ;
						 }
					    }
				       }
				       if (test_888)
					 {	/* Ast/ident.scm 230 */
					    return string_13;
					 }
				       else
					 {	/* Ast/ident.scm 233 */
					    bool_t test_897;
					    {	/* ./Ieee/char.scm 7775 */
					       unsigned char aux_898;
					       aux_898 =
						  STRING_REF(string_13, ((long) 6));
					       test_897 =
						  (aux_898 == ((unsigned char) '_'));
					    }
					    if (test_897)
					      {		/* Ast/ident.scm 233 */
						 return
						    string_append(string1328_ast_ident, string_13);
					      }
					    else
					      {		/* Ast/ident.scm 233 */
						 return string_13;
					      }
					 }
				    }
			       }
			  }
		     }
		   else
		     {	/* Ast/ident.scm 219 */
			return string_13;
		     }
		}
	      else
		{	/* Ast/ident.scm 217 */
		   return string_13;
		}
	   }
	 else
	   {	/* Ast/ident.scm 215 */
	      return string_13;
	   }
      }
   }
}



/* check-id */
obj_t 
check_id_6_ast_ident(obj_t id_14, obj_t src_15)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 241 */
      {		/* Ast/ident.scm 242 */
	 bool_t test1300_244;
	 {	/* Ast/ident.scm 242 */
	    obj_t arg1302_246;
	    {	/* ./Ieee/symbol.scm 6021 */
	       obj_t aux_902;
	       aux_902 =
		  CAR(id_14);
	       arg1302_246 =
		  SYMBOL_TO_STRING(aux_902);
	    }
	    {	/* ./Ieee/fixnum.scm 7109 */
	       long aux_905;
	       aux_905 =
		  STRING_LENGTH(arg1302_246);
	       test1300_244 =
		  (aux_905 == ((long) 0));
	    }
	 }
	 if (test1300_244)
	   {	/* Ast/ident.scm 242 */
	      return
		 user_error_151_tools_error(string1321_ast_ident, string1322_ast_ident, src_15, BNIL);
	   }
	 else
	   {	/* Ast/ident.scm 242 */
	      return id_14;
	   }
      }
   }
}



/* _check-id1318 */
obj_t 
_check_id1318_148_ast_ident(obj_t env_549, obj_t id_550, obj_t src_551)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 241 */
      return
	 check_id_6_ast_ident(id_550, src_551);
   }
}



/* parse-dsssl */
obj_t 
parse_dsssl_9_ast_ident(obj_t obj_16)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 249 */
      {		/* Ast/ident.scm 251 */
	 bool_t test1304_248;
	 {	/* Ast/ident.scm 251 */
	    obj_t aux_911;
	    aux_911 =
	       dsssl_named_constant__188_tools_dsssl(obj_16);
	    test1304_248 =
	       CBOOL(aux_911);
	 }
	 if (test1304_248)
	   {	/* Ast/ident.scm 251 */
	      {		/* Ast/ident.scm 252 */
		 obj_t obj2_529;
		 obj2_529 = _obj__252_type_cache;
		 return
		    MAKE_PAIR(obj_16, obj2_529);
	      }
	   }
	 else
	   {	/* Ast/ident.scm 253 */
	      bool_t test1305_249;
	      {		/* Ast/ident.scm 253 */
		 obj_t aux_916;
		 aux_916 =
		    dsssl_defaulted_formal__174_tools_dsssl(obj_16);
		 test1305_249 =
		    CBOOL(aux_916);
	      }
	      if (test1305_249)
		{	/* Ast/ident.scm 253 */
		   {	/* Ast/ident.scm 254 */
		      obj_t obj2_531;
		      obj2_531 = _obj__252_type_cache;
		      return
			 MAKE_PAIR(obj_16, obj2_531);
		   }
		}
	      else
		{	/* Ast/ident.scm 253 */
		   return
		      user_error_151_tools_error(string1329_ast_ident, string1324_ast_ident, obj_16, BNIL);
		}
	   }
      }
   }
}



/* _parse-dsssl */
obj_t 
_parse_dsssl_92_ast_ident(obj_t env_552, obj_t obj_553)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 249 */
      return
	 parse_dsssl_9_ast_ident(obj_553);
   }
}



/* mark-symbol-non-user! */
obj_t 
mark_symbol_non_user__17_ast_ident(obj_t sym_17)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 268 */
      putprop__88___r4_symbols_6_4(sym_17,
	 CNST_TABLE_REF(((long) 3)), BTRUE);
      return sym_17;
   }
}



/* _mark-symbol-non-user!1319 */
obj_t 
_mark_symbol_non_user_1319_57_ast_ident(obj_t env_554, obj_t sym_555)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 268 */
      return
	 mark_symbol_non_user__17_ast_ident(sym_555);
   }
}



/* user-symbol? */
bool_t 
user_symbol__147_ast_ident(obj_t symbol_18)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 277 */
      {		/* Ast/ident.scm 278 */
	 bool_t test_926;
	 {	/* Ast/ident.scm 278 */
	    obj_t aux_927;
	    aux_927 =
	       getprop___r4_symbols_6_4(symbol_18,
	       CNST_TABLE_REF(((long) 3)));
	    test_926 =
	       CBOOL(aux_927);
	 }
	 if (test_926)
	   {	/* Ast/ident.scm 278 */
	      return ((bool_t) 0);
	   }
	 else
	   {	/* Ast/ident.scm 278 */
	      return ((bool_t) 1);
	   }
      }
   }
}



/* _user-symbol?1320 */
obj_t 
_user_symbol_1320_78_ast_ident(obj_t env_556, obj_t symbol_557)
{
   AN_OBJECT;
   {	/* Ast/ident.scm 277 */
      {		/* Ast/ident.scm 277 */
	 bool_t aux_931;
	 aux_931 =
	    user_symbol__147_ast_ident(symbol_557);
	 return
	    BBOOL(aux_931);
      }
   }
}



/* method-init */
obj_t 
method_init_76_ast_ident()
{
   AN_OBJECT;
   {	/* Ast/ident.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_ast_ident()
{
   AN_OBJECT;
   {	/* Ast/ident.scm 14 */
      module_initialization_70_tools_error(((long) 0), "AST_IDENT");
      module_initialization_70_tools_dsssl(((long) 0), "AST_IDENT");
      module_initialization_70_type_type(((long) 0), "AST_IDENT");
      module_initialization_70_type_env(((long) 0), "AST_IDENT");
      return
	 module_initialization_70_type_cache(((long) 0), "AST_IDENT");
   }
}
