/*===========================================================================*/
/*   (Coerce/pproto.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;


static obj_t method_init_76_coerce_pproto();
static obj_t old_marge_string_21_coerce_pproto = BUNSPEC;
static long _pp_marge__113_coerce_pproto;
extern obj_t _verbose__1_engine_param;
extern obj_t verbose_tools_speek(obj_t, obj_t);
extern obj_t module_initialization_70_coerce_pproto(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_tools_speek(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_pptype(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t pfunction_proto_197_coerce_pproto(long, variable_bglt);
static obj_t imported_modules_init_94_coerce_pproto();
extern obj_t inc_ppmarge__59_coerce_pproto();
static long old_marge_60_coerce_pproto;
extern obj_t variable_type__string_186_type_pptype(variable_bglt);
static obj_t _pvariable_proto1249_97_coerce_pproto(obj_t, obj_t, obj_t);
extern obj_t dec_ppmarge__31_coerce_pproto();
static obj_t library_modules_init_112_coerce_pproto();
static obj_t _reset_ppmarge__204_coerce_pproto(obj_t);
static obj_t toplevel_init_63_coerce_pproto();
extern obj_t reset_ppmarge__67_coerce_pproto();
extern obj_t shape_tools_shape(obj_t);
static obj_t _inc_ppmarge__104_coerce_pproto(obj_t);
extern obj_t make_string(long, unsigned char);
extern obj_t function_type__string_79_type_pptype(variable_bglt);
static obj_t _dec_ppmarge__17_coerce_pproto(obj_t);
extern obj_t pvariable_proto_90_coerce_pproto(long, variable_bglt);
extern bool_t ___161___r4_numbers_6_5(obj_t, obj_t, obj_t);
static obj_t require_initialization_114_coerce_pproto = BUNSPEC;
static obj_t _pfunction_proto1248_155_coerce_pproto(obj_t, obj_t, obj_t);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE(pvariable_proto_env_237_coerce_pproto, _pvariable_proto1249_97_coerce_pproto1253, _pvariable_proto1249_97_coerce_pproto, 0L, 2);
DEFINE_EXPORT_PROCEDURE(reset_ppmarge__env_109_coerce_pproto, _reset_ppmarge__204_coerce_pproto1254, _reset_ppmarge__204_coerce_pproto, 0L, 0);
DEFINE_EXPORT_PROCEDURE(pfunction_proto_env_244_coerce_pproto, _pfunction_proto1248_155_coerce_pproto1255, _pfunction_proto1248_155_coerce_pproto, 0L, 2);
DEFINE_EXPORT_PROCEDURE(inc_ppmarge__env_119_coerce_pproto, _inc_ppmarge__104_coerce_pproto1256, _inc_ppmarge__104_coerce_pproto, 0L, 0);
DEFINE_EXPORT_PROCEDURE(dec_ppmarge__env_99_coerce_pproto, _dec_ppmarge__17_coerce_pproto1257, _dec_ppmarge__17_coerce_pproto, 0L, 0);
DEFINE_STRING(string1251_coerce_pproto, string1251_coerce_pproto1258, " : ", 3);
DEFINE_STRING(string1250_coerce_pproto, string1250_coerce_pproto1259, "", 0);



/* module-initialization */
obj_t 
module_initialization_70_coerce_pproto(long checksum_494, char *from_495)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_coerce_pproto))
	{
	   require_initialization_114_coerce_pproto =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_coerce_pproto();
	   imported_modules_init_94_coerce_pproto();
	   method_init_76_coerce_pproto();
	   toplevel_init_63_coerce_pproto();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_coerce_pproto()
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 14 */
      module_initialization_70___r4_numbers_6_5(((long) 0), "COERCE_PPROTO");
      return BUNSPEC;
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_coerce_pproto()
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 14 */
      _pp_marge__113_coerce_pproto = ((long) 8);
      old_marge_60_coerce_pproto = ((long) -1);
      return (
	 old_marge_string_21_coerce_pproto = string1250_coerce_pproto, BUNSPEC);
   }
}



/* reset-ppmarge! */
obj_t 
reset_ppmarge__67_coerce_pproto()
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 30 */
      return (
	 _pp_marge__113_coerce_pproto = ((long) 8), BUNSPEC);
   }
}



/* _reset-ppmarge! */
obj_t 
_reset_ppmarge__204_coerce_pproto(obj_t env_485)
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 30 */
      return
	 reset_ppmarge__67_coerce_pproto();
   }
}



/* inc-ppmarge! */
obj_t 
inc_ppmarge__59_coerce_pproto()
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 36 */
      {		/* Coerce/pproto.scm 37 */
	 long z2_466;
	 z2_466 = _pp_marge__113_coerce_pproto;
	 return (
	    _pp_marge__113_coerce_pproto =
	    (((long) 1) + z2_466), BUNSPEC);
      }
   }
}



/* _inc-ppmarge! */
obj_t 
_inc_ppmarge__104_coerce_pproto(obj_t env_486)
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 36 */
      return
	 inc_ppmarge__59_coerce_pproto();
   }
}



/* dec-ppmarge! */
obj_t 
dec_ppmarge__31_coerce_pproto()
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 42 */
      {		/* Coerce/pproto.scm 43 */
	 long z1_467;
	 z1_467 = _pp_marge__113_coerce_pproto;
	 return (
	    _pp_marge__113_coerce_pproto =
	    (z1_467 - ((long) 1)), BUNSPEC);
      }
   }
}



/* _dec-ppmarge! */
obj_t 
_dec_ppmarge__17_coerce_pproto(obj_t env_487)
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 42 */
      return
	 dec_ppmarge__31_coerce_pproto();
   }
}



/* pfunction-proto */
obj_t 
pfunction_proto_197_coerce_pproto(long level_1, variable_bglt variable_2)
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 55 */
      {		/* Coerce/pproto.scm 56 */
	 obj_t marge_309;
	 {	/* Coerce/pproto.scm 56 */
	    bool_t test1197_321;
	    {	/* Coerce/pproto.scm 56 */
	       long n1_469;
	       long n2_470;
	       n1_469 = old_marge_60_coerce_pproto;
	       n2_470 = _pp_marge__113_coerce_pproto;
	       test1197_321 =
		  (n1_469 == n2_470);
	    }
	    if (test1197_321)
	      {		/* Coerce/pproto.scm 56 */
		 marge_309 = old_marge_string_21_coerce_pproto;
	      }
	    else
	      {		/* Coerce/pproto.scm 58 */
		 obj_t marge_322;
		 {	/* Coerce/pproto.scm 58 */
		    obj_t list1198_323;
		    {	/* Coerce/pproto.scm 58 */
		       obj_t aux_511;
		       aux_511 =
			  BCHAR(((unsigned char) ' '));
		       list1198_323 =
			  MAKE_PAIR(aux_511, BNIL);
		    }
		    {	/* Coerce/pproto.scm 58 */
		       obj_t res1246_477;
		       {	/* Coerce/pproto.scm 58 */
			  int k_471;
			  k_471 =
			     (int) (_pp_marge__113_coerce_pproto);
			  {	/* ./Ieee/string.scm 8055 */
			     unsigned char aux_517;
			     long aux_515;
			     {	/* ./Ieee/string.scm 8055 */
				obj_t aux_518;
				aux_518 =
				   CAR(list1198_323);
				aux_517 =
				   (unsigned char) CCHAR(aux_518);
			     }
			     aux_515 =
				(long) (k_471);
			     res1246_477 =
				make_string(aux_515, aux_517);
			  }
		       }
		       marge_322 = res1246_477;
		    }
		 }
		 old_marge_60_coerce_pproto = _pp_marge__113_coerce_pproto;
		 old_marge_string_21_coerce_pproto = marge_322;
		 marge_309 = marge_322;
	      }
	 }
	 {	/* Coerce/pproto.scm 62 */
	    bool_t test1186_311;
	    test1186_311 =
	       ___161___r4_numbers_6_5(
	       BINT(level_1), _verbose__1_engine_param, BNIL);
	    if (test1186_311)
	      {		/* Coerce/pproto.scm 64 */
		 obj_t arg1187_312;
		 obj_t arg1189_314;
		 arg1187_312 =
		    shape_tools_shape(
		    (obj_t) (variable_2));
		 arg1189_314 =
		    function_type__string_79_type_pptype(variable_2);
		 {	/* Coerce/pproto.scm 62 */
		    obj_t list1190_315;
		    {	/* Coerce/pproto.scm 62 */
		       obj_t arg1192_316;
		       {	/* Coerce/pproto.scm 62 */
			  obj_t arg1193_317;
			  {	/* Coerce/pproto.scm 62 */
			     obj_t arg1194_318;
			     {	/* Coerce/pproto.scm 62 */
				obj_t arg1195_319;
				{	/* Coerce/pproto.scm 62 */
				   obj_t aux_528;
				   aux_528 =
				      BCHAR(((unsigned char) '\n'));
				   arg1195_319 =
				      MAKE_PAIR(aux_528, BNIL);
				}
				arg1194_318 =
				   MAKE_PAIR(arg1189_314, arg1195_319);
			     }
			     arg1193_317 =
				MAKE_PAIR(string1251_coerce_pproto, arg1194_318);
			  }
			  arg1192_316 =
			     MAKE_PAIR(arg1187_312, arg1193_317);
		       }
		       list1190_315 =
			  MAKE_PAIR(marge_309, arg1192_316);
		    }
		    return
		       verbose_tools_speek(
		       BINT(level_1), list1190_315);
		 }
	      }
	    else
	      {		/* Coerce/pproto.scm 62 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* _pfunction-proto1248 */
obj_t 
_pfunction_proto1248_155_coerce_pproto(obj_t env_488, obj_t level_489, obj_t variable_490)
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 55 */
      return
	 pfunction_proto_197_coerce_pproto(
	 (long) CINT(level_489),
	 (variable_bglt) (variable_490));
   }
}



/* pvariable-proto */
obj_t 
pvariable_proto_90_coerce_pproto(long level_3, variable_bglt variable_4)
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 71 */
      {		/* Coerce/pproto.scm 72 */
	 obj_t marge_324;
	 {	/* Coerce/pproto.scm 72 */
	    obj_t list1214_336;
	    {	/* Coerce/pproto.scm 72 */
	       obj_t aux_540;
	       aux_540 =
		  BCHAR(((unsigned char) ' '));
	       list1214_336 =
		  MAKE_PAIR(aux_540, BNIL);
	    }
	    {	/* Coerce/pproto.scm 72 */
	       obj_t res1247_484;
	       {	/* Coerce/pproto.scm 72 */
		  int k_478;
		  k_478 =
		     (int) (_pp_marge__113_coerce_pproto);
		  {	/* ./Ieee/string.scm 8055 */
		     unsigned char aux_546;
		     long aux_544;
		     {	/* ./Ieee/string.scm 8055 */
			obj_t aux_547;
			aux_547 =
			   CAR(list1214_336);
			aux_546 =
			   (unsigned char) CCHAR(aux_547);
		     }
		     aux_544 =
			(long) (k_478);
		     res1247_484 =
			make_string(aux_544, aux_546);
		  }
	       }
	       marge_324 = res1247_484;
	    }
	 }
	 {	/* Coerce/pproto.scm 73 */
	    bool_t test1199_326;
	    test1199_326 =
	       ___161___r4_numbers_6_5(
	       BINT(level_3), _verbose__1_engine_param, BNIL);
	    if (test1199_326)
	      {		/* Coerce/pproto.scm 75 */
		 obj_t arg1201_327;
		 obj_t arg1204_329;
		 arg1201_327 =
		    shape_tools_shape(
		    (obj_t) (variable_4));
		 arg1204_329 =
		    variable_type__string_186_type_pptype(variable_4);
		 {	/* Coerce/pproto.scm 73 */
		    obj_t list1205_330;
		    {	/* Coerce/pproto.scm 73 */
		       obj_t arg1206_331;
		       {	/* Coerce/pproto.scm 73 */
			  obj_t arg1207_332;
			  {	/* Coerce/pproto.scm 73 */
			     obj_t arg1209_333;
			     {	/* Coerce/pproto.scm 73 */
				obj_t arg1212_334;
				{	/* Coerce/pproto.scm 73 */
				   obj_t aux_557;
				   aux_557 =
				      BCHAR(((unsigned char) '\n'));
				   arg1212_334 =
				      MAKE_PAIR(aux_557, BNIL);
				}
				arg1209_333 =
				   MAKE_PAIR(arg1204_329, arg1212_334);
			     }
			     arg1207_332 =
				MAKE_PAIR(string1251_coerce_pproto, arg1209_333);
			  }
			  arg1206_331 =
			     MAKE_PAIR(arg1201_327, arg1207_332);
		       }
		       list1205_330 =
			  MAKE_PAIR(marge_324, arg1206_331);
		    }
		    return
		       verbose_tools_speek(
		       BINT(level_3), list1205_330);
		 }
	      }
	    else
	      {		/* Coerce/pproto.scm 73 */
		 return BUNSPEC;
	      }
	 }
      }
   }
}



/* _pvariable-proto1249 */
obj_t 
_pvariable_proto1249_97_coerce_pproto(obj_t env_491, obj_t level_492, obj_t variable_493)
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 71 */
      return
	 pvariable_proto_90_coerce_pproto(
	 (long) CINT(level_492),
	 (variable_bglt) (variable_493));
   }
}



/* method-init */
obj_t 
method_init_76_coerce_pproto()
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_coerce_pproto()
{
   AN_OBJECT;
   {	/* Coerce/pproto.scm 14 */
      module_initialization_70_engine_param(((long) 0), "COERCE_PPROTO");
      module_initialization_70_tools_speek(((long) 0), "COERCE_PPROTO");
      module_initialization_70_tools_shape(((long) 0), "COERCE_PPROTO");
      module_initialization_70_type_type(((long) 0), "COERCE_PPROTO");
      module_initialization_70_type_pptype(((long) 0), "COERCE_PPROTO");
      return
	 module_initialization_70_ast_var(((long) 0), "COERCE_PPROTO");
   }
}
