/*===========================================================================*/
/*   (Foreign/cfun.scm)                                                      */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct calias
  {
     bool_t array__248;
  }
      *calias_bglt;

typedef struct cenum
  {
     struct type *btype;
     obj_t literals;
  }
     *cenum_bglt;

typedef struct copaque
  {
     struct type *btype;
  }
       *copaque_bglt;

typedef struct cfunction
  {
     struct type *btype;
     long arity;
     struct type *type_res_48;
     obj_t type_args_244;
  }
         *cfunction_bglt;

typedef struct cptr
  {
     struct type *btype;
     struct type *point_to_164;
     bool_t array__248;
  }
    *cptr_bglt;

typedef struct cstruct
  {
     bool_t struct__46;
     obj_t fields;
     obj_t cstruct__170;
  }
       *cstruct_bglt;

typedef struct cstruct__170
  {
     struct type *btype;
     struct cstruct *cstruct;
  }
            *cstruct__170_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


static obj_t method_init_76_foreign_cfunction();
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t _max_c_foreign_arity__143_engine_param;
extern obj_t string_sans___40_type_tools(obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_foreign_cfunction(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_foreign_ctype(long, char *);
extern obj_t module_initialization_70_foreign_access(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
static obj_t imported_modules_init_94_foreign_cfunction();
extern obj_t produce_module_clause__172_module_module(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_foreign_cfunction();
static obj_t toplevel_init_63_foreign_cfunction();
static obj_t make_ctype_accesses__cfunction1198_100_foreign_cfunction(obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t cfunction_foreign_ctype;
extern char *integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t _4dots_199_tools_misc;
extern obj_t read___reader(obj_t);
static obj_t require_initialization_114_foreign_cfunction = BUNSPEC;
static obj_t cnst_init_137_foreign_cfunction();
static obj_t __cnst[26];

DEFINE_STATIC_PROCEDURE(proc1489_foreign_cfunction, make_ctype_accesses__cfunction1198_100_foreign_cfunction1505, make_ctype_accesses__cfunction1198_100_foreign_cfunction, 0L, 3);
extern obj_t make_ctype_accesses__env_11_foreign_access;
DEFINE_STRING(string1499_foreign_cfunction, string1499_foreign_cfunction1506, "cobj_to_foreign", 15);
DEFINE_STRING(string1498_foreign_cfunction, string1498_foreign_cfunction1507, "(", 1);
DEFINE_STRING(string1497_foreign_cfunction, string1497_foreign_cfunction1508, ")FOREIGN_TO_COBJ", 16);
DEFINE_STRING(string1496_foreign_cfunction, string1496_foreign_cfunction1509, "($1 == $2)", 10);
DEFINE_STRING(string1495_foreign_cfunction, string1495_foreign_cfunction1510, "C_FUNCTION_CALL_", 16);
DEFINE_STRING(string1494_foreign_cfunction, string1494_foreign_cfunction1511, "Can't manage pointers on C multiple arity function", 50);
DEFINE_STRING(string1493_foreign_cfunction, string1493_foreign_cfunction1512, "bigloo", 6);
DEFINE_STRING(string1492_foreign_cfunction, string1492_foreign_cfunction1513, " args provided", 14);
DEFINE_STRING(string1491_foreign_cfunction, string1491_foreign_cfunction1514, "Too large arity for a foreign function (max", 43);
DEFINE_STRING(string1490_foreign_cfunction, string1490_foreign_cfunction1515, ")", 1);
DEFINE_STRING(string1500_foreign_cfunction, string1500_foreign_cfunction1516, "PREDICATE-OF PRAGMA ::OBJ INLINE STATIC FOREIGN SYMBOL QUOTE FOREIGN-ID EQ? O FOREIGN? IF O::OBJ PRAGMA::BOOL O2 O1 = MACRO F DEFINE-INLINE C- ::BOOL ? -> -CALL ", 161);



/* module-initialization */
obj_t 
module_initialization_70_foreign_cfunction(long checksum_1111, char *from_1112)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_foreign_cfunction))
	{
	   require_initialization_114_foreign_cfunction =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_foreign_cfunction();
	   cnst_init_137_foreign_cfunction();
	   imported_modules_init_94_foreign_cfunction();
	   method_init_76_foreign_cfunction();
	   toplevel_init_63_foreign_cfunction();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_foreign_cfunction()
{
   AN_OBJECT;
   {	/* Foreign/cfun.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "FOREIGN_CFUNCTION");
      module_initialization_70___object(((long) 0), "FOREIGN_CFUNCTION");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "FOREIGN_CFUNCTION");
      module_initialization_70___r4_numbers_6_5_fixnum(((long) 0), "FOREIGN_CFUNCTION");
      module_initialization_70___reader(((long) 0), "FOREIGN_CFUNCTION");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_foreign_cfunction()
{
   AN_OBJECT;
   {	/* Foreign/cfun.scm 14 */
      {		/* Foreign/cfun.scm 14 */
	 obj_t cnst_port_138_1104;
	 cnst_port_138_1104 =
	    open_input_string(string1500_foreign_cfunction);
	 {
	    long i_1105;
	    i_1105 = ((long) 25);
	  loop_1106:
	    {	/* Foreign/cfun.scm 14 */
	       bool_t test1501_1107;
	       test1501_1107 =
		  (i_1105 == ((long) -1));
	       if (test1501_1107)
		 {	/* Foreign/cfun.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Foreign/cfun.scm 14 */
		    {	/* Foreign/cfun.scm 14 */
		       obj_t arg1502_1108;
		       {	/* Foreign/cfun.scm 14 */
			  obj_t list1503_1109;
			  list1503_1109 =
			     MAKE_PAIR(cnst_port_138_1104, BNIL);
			  arg1502_1108 =
			     read___reader(list1503_1109);
		       }
		       CNST_TABLE_SET(i_1105, arg1502_1108);
		    }
		    {	/* Foreign/cfun.scm 14 */
		       int aux_1110;
		       {	/* Foreign/cfun.scm 14 */
			  long aux_1132;
			  aux_1132 =
			     (i_1105 - ((long) 1));
			  aux_1110 =
			     (int) (aux_1132);
		       }
		       {
			  long i_1135;
			  i_1135 =
			     (long) (aux_1110);
			  i_1105 = i_1135;
			  goto loop_1106;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_foreign_cfunction()
{
   AN_OBJECT;
   {	/* Foreign/cfun.scm 14 */
      return BUNSPEC;
   }
}



/* method-init */
obj_t 
method_init_76_foreign_cfunction()
{
   AN_OBJECT;
   {	/* Foreign/cfun.scm 14 */
      {		/* Foreign/cfun.scm 14 */
	 obj_t make_ctype_accesses__cfunction1198_100_1095;
	 make_ctype_accesses__cfunction1198_100_1095 = proc1489_foreign_cfunction;
	 return
	    add_method__1___object(make_ctype_accesses__env_11_foreign_access, cfunction_foreign_ctype, make_ctype_accesses__cfunction1198_100_1095);
      }
   }
}



/* make-ctype-accesses!-cfunction1198 */
obj_t 
make_ctype_accesses__cfunction1198_100_foreign_cfunction(obj_t env_1096, obj_t what_1097, obj_t who_1098, obj_t loc_1099)
{
   AN_OBJECT;
   {	/* Foreign/cfun.scm 27 */
      {
	 cfunction_bglt what_566;
	 type_bglt who_567;
	 obj_t loc_568;
	 what_566 =
	    (cfunction_bglt) (what_1097);
	 who_567 =
	    (type_bglt) (who_1098);
	 loc_568 = loc_1099;
	 {	/* Foreign/cfun.scm 28 */
	    type_bglt btype_571;
	    {
	       obj_t aux_1138;
	       {	/* ./Foreign/ctype.scm 568 */
		  object_bglt aux_1139;
		  aux_1139 =
		     (object_bglt) (what_566);
		  aux_1138 =
		     OBJECT_WIDENING(aux_1139);
	       }
	       btype_571 =
		  (((cfunction_bglt) CREF(aux_1138))->btype);
	    }
	    {	/* Foreign/cfun.scm 28 */
	       obj_t id_572;
	       id_572 =
		  (((type_bglt) CREF(who_567))->id);
	       {	/* Foreign/cfun.scm 29 */
		  obj_t wid_573;
		  {	/* Foreign/cfun.scm 30 */
		     type_bglt obj_891;
		     obj_891 =
			(type_bglt) (what_566);
		     wid_573 =
			(((type_bglt) CREF(obj_891))->id);
		  }
		  {	/* Foreign/cfun.scm 30 */
		     obj_t bid_574;
		     bid_574 =
			(((type_bglt) CREF(btype_571))->id);
		     {	/* Foreign/cfun.scm 31 */
			obj_t call_id_67_575;
			{	/* Foreign/cfun.scm 32 */
			   obj_t list1483_845;
			   {	/* Foreign/cfun.scm 32 */
			      obj_t arg1484_846;
			      {		/* Foreign/cfun.scm 32 */
				 obj_t aux_1147;
				 aux_1147 =
				    CNST_TABLE_REF(((long) 0));
				 arg1484_846 =
				    MAKE_PAIR(aux_1147, BNIL);
			      }
			      list1483_845 =
				 MAKE_PAIR(id_572, arg1484_846);
			   }
			   call_id_67_575 =
			      symbol_append_197___r4_symbols_6_4(list1483_845);
			}
			{	/* Foreign/cfun.scm 32 */
			   obj_t id__bid_132_576;
			   {	/* Foreign/cfun.scm 33 */
			      obj_t list1479_841;
			      {		/* Foreign/cfun.scm 33 */
				 obj_t arg1480_842;
				 {	/* Foreign/cfun.scm 33 */
				    obj_t arg1481_843;
				    obj_t arg1482_844;
				    arg1481_843 =
				       CNST_TABLE_REF(((long) 1));
				    arg1482_844 =
				       MAKE_PAIR(bid_574, BNIL);
				    arg1480_842 =
				       MAKE_PAIR(arg1481_843, arg1482_844);
				 }
				 list1479_841 =
				    MAKE_PAIR(id_572, arg1480_842);
			      }
			      id__bid_132_576 =
				 symbol_append_197___r4_symbols_6_4(list1479_841);
			   }
			   {	/* Foreign/cfun.scm 33 */
			      obj_t bid__id_105_577;
			      {		/* Foreign/cfun.scm 34 */
				 obj_t list1475_837;
				 {	/* Foreign/cfun.scm 34 */
				    obj_t arg1476_838;
				    {	/* Foreign/cfun.scm 34 */
				       obj_t arg1477_839;
				       obj_t arg1478_840;
				       arg1477_839 =
					  CNST_TABLE_REF(((long) 1));
				       arg1478_840 =
					  MAKE_PAIR(id_572, BNIL);
				       arg1476_838 =
					  MAKE_PAIR(arg1477_839, arg1478_840);
				    }
				    list1475_837 =
				       MAKE_PAIR(bid_574, arg1476_838);
				 }
				 bid__id_105_577 =
				    symbol_append_197___r4_symbols_6_4(list1475_837);
			      }
			      {		/* Foreign/cfun.scm 34 */
				 obj_t bid__101_578;
				 {	/* Foreign/cfun.scm 35 */
				    obj_t list1473_835;
				    {	/* Foreign/cfun.scm 35 */
				       obj_t arg1474_836;
				       {	/* Foreign/cfun.scm 35 */
					  obj_t aux_1162;
					  aux_1162 =
					     CNST_TABLE_REF(((long) 2));
					  arg1474_836 =
					     MAKE_PAIR(aux_1162, BNIL);
				       }
				       list1473_835 =
					  MAKE_PAIR(id_572, arg1474_836);
				    }
				    bid__101_578 =
				       symbol_append_197___r4_symbols_6_4(list1473_835);
				 }
				 {	/* Foreign/cfun.scm 35 */
				    obj_t bid__bool_159_579;
				    {	/* Foreign/cfun.scm 36 */
				       obj_t list1471_833;
				       {	/* Foreign/cfun.scm 36 */
					  obj_t arg1472_834;
					  {	/* Foreign/cfun.scm 36 */
					     obj_t aux_1167;
					     aux_1167 =
						CNST_TABLE_REF(((long) 3));
					     arg1472_834 =
						MAKE_PAIR(aux_1167, BNIL);
					  }
					  list1471_833 =
					     MAKE_PAIR(bid__101_578, arg1472_834);
				       }
				       bid__bool_159_579 =
					  symbol_append_197___r4_symbols_6_4(list1471_833);
				    }
				    {	/* Foreign/cfun.scm 37 */
				       obj_t name_sans___18_581;
				       name_sans___18_581 =
					  string_sans___40_type_tools(
					  (((type_bglt) CREF(who_567))->name));
				       {	/* Foreign/cfun.scm 38 */
					  type_bglt type_res_48_582;
					  {
					     obj_t aux_1174;
					     {	/* ./Foreign/ctype.scm 572 */
						object_bglt aux_1175;
						aux_1175 =
						   (object_bglt) (what_566);
						aux_1174 =
						   OBJECT_WIDENING(aux_1175);
					     }
					     type_res_48_582 =
						(((cfunction_bglt) CREF(aux_1174))->type_res_48);
					  }
					  {	/* Foreign/cfun.scm 39 */
					     obj_t type_args_244_583;
					     {
						obj_t aux_1179;
						{	/* ./Foreign/ctype.scm 574 */
						   object_bglt aux_1180;
						   aux_1180 =
						      (object_bglt) (what_566);
						   aux_1179 =
						      OBJECT_WIDENING(aux_1180);
						}
						type_args_244_583 =
						   (((cfunction_bglt) CREF(aux_1179))->type_args_244);
					     }
					     {	/* Foreign/cfun.scm 40 */
						long arity_584;
						{
						   obj_t aux_1184;
						   {	/* ./Foreign/ctype.scm 570 */
						      object_bglt aux_1185;
						      aux_1185 =
							 (object_bglt) (what_566);
						      aux_1184 =
							 OBJECT_WIDENING(aux_1185);
						   }
						   arity_584 =
						      (((cfunction_bglt) CREF(aux_1184))->arity);
						}
						{	/* Foreign/cfun.scm 41 */
						   char *nb_args_51_585;
						   nb_args_51_585 =
						      integer__string_135___r4_numbers_6_5_fixnum(arity_584, BNIL);
						   {	/* Foreign/cfun.scm 42 */

						      {

							 {	/* Foreign/cfun.scm 105 */
							    obj_t arg1235_593;
							    {	/* Foreign/cfun.scm 105 */
							       obj_t arg1236_594;
							       obj_t arg1237_595;
							       arg1236_594 =
								  CNST_TABLE_REF(((long) 20));
							       {	/* Foreign/cfun.scm 105 */
								  obj_t arg1238_596;
								  obj_t arg1240_597;
								  {	/* Foreign/cfun.scm 48 */
								     obj_t arg1459_817;
								     obj_t arg1461_818;
								     arg1459_817 =
									CNST_TABLE_REF(((long) 7));
								     {	/* Foreign/cfun.scm 48 */
									obj_t arg1462_819;
									{	/* Foreign/cfun.scm 48 */
									   obj_t arg1463_820;
									   {	/* Foreign/cfun.scm 48 */
									      obj_t arg1464_821;
									      obj_t arg1466_822;
									      {		/* Foreign/cfun.scm 48 */
										 obj_t arg1467_823;
										 obj_t arg1469_824;
										 arg1467_823 =
										    CNST_TABLE_REF(((long) 19));
										 arg1469_824 =
										    MAKE_PAIR(id_572, BNIL);
										 arg1464_821 =
										    MAKE_PAIR(arg1467_823, arg1469_824);
									      }
									      arg1466_822 =
										 MAKE_PAIR(string1499_foreign_cfunction, BNIL);
									      arg1463_820 =
										 MAKE_PAIR(arg1464_821, arg1466_822);
									   }
									   arg1462_819 =
									      MAKE_PAIR(id__bid_132_576, arg1463_820);
									}
									arg1461_818 =
									   MAKE_PAIR(bid_574, arg1462_819);
								     }
								     arg1238_596 =
									MAKE_PAIR(arg1459_817, arg1461_818);
								  }
								  {	/* Foreign/cfun.scm 106 */
								     obj_t arg1241_598;
								     obj_t arg1243_599;
								     {	/* Foreign/cfun.scm 51 */
									obj_t mname_807;
									{	/* Foreign/cfun.scm 51 */
									   obj_t arg1457_815;
									   arg1457_815 =
									      string_append(name_sans___18_581, string1497_foreign_cfunction);
									   mname_807 =
									      string_append(string1498_foreign_cfunction, arg1457_815);
									}
									{	/* Foreign/cfun.scm 52 */
									   obj_t arg1449_808;
									   obj_t arg1450_809;
									   arg1449_808 =
									      CNST_TABLE_REF(((long) 7));
									   {	/* Foreign/cfun.scm 52 */
									      obj_t arg1451_810;
									      {		/* Foreign/cfun.scm 52 */
										 obj_t arg1452_811;
										 {	/* Foreign/cfun.scm 52 */
										    obj_t arg1454_812;
										    obj_t arg1455_813;
										    arg1454_812 =
										       MAKE_PAIR(bid_574, BNIL);
										    arg1455_813 =
										       MAKE_PAIR(mname_807, BNIL);
										    arg1452_811 =
										       MAKE_PAIR(arg1454_812, arg1455_813);
										 }
										 arg1451_810 =
										    MAKE_PAIR(bid__id_105_577, arg1452_811);
									      }
									      arg1450_809 =
										 MAKE_PAIR(id_572, arg1451_810);
									   }
									   arg1241_598 =
									      MAKE_PAIR(arg1449_808, arg1450_809);
									}
								     }
								     {	/* Foreign/cfun.scm 107 */
									obj_t arg1245_600;
									{	/* Foreign/cfun.scm 69 */
									   obj_t tres_id_18_720;
									   tres_id_18_720 =
									      (((type_bglt) CREF(type_res_48_582))->id);
									   {	/* Foreign/cfun.scm 69 */
									      obj_t targs_id_78_721;
									      if (
										 NULLP(type_args_244_583))
										{	/* Foreign/cfun.scm 70 */
										   targs_id_78_721 = BNIL;
										}
									      else
										{	/* Foreign/cfun.scm 70 */
										   obj_t head1177_735;
										   {	/* ./Ieee/pair-list.scm 5689 */
										      obj_t aux_1212;
										      {		/* Foreign/cfun.scm 70 */
											 type_bglt obj_989;
											 {	/* Foreign/cfun.scm 70 */
											    obj_t aux_1213;
											    aux_1213 =
											       CAR(type_args_244_583);
											    obj_989 =
											       (type_bglt) (aux_1213);
											 }
											 aux_1212 =
											    (((type_bglt) CREF(obj_989))->id);
										      }
										      head1177_735 =
											 MAKE_PAIR(aux_1212, BNIL);
										   }
										   {
										      obj_t l1175_736;
										      obj_t tail1178_737;
										      l1175_736 =
											 CDR(type_args_244_583);
										      tail1178_737 = head1177_735;
										    lname1176_738:
										      if (
											 NULLP(l1175_736))
											{	/* Foreign/cfun.scm 70 */
											   targs_id_78_721 = head1177_735;
											}
										      else
											{	/* Foreign/cfun.scm 70 */
											   obj_t newtail1179_741;
											   {	/* ./Ieee/pair-list.scm 5689 */
											      obj_t aux_1220;
											      {		/* Foreign/cfun.scm 70 */
												 type_bglt obj_995;
												 {	/* Foreign/cfun.scm 70 */
												    obj_t aux_1221;
												    aux_1221 =
												       CAR(l1175_736);
												    obj_995 =
												       (type_bglt) (aux_1221);
												 }
												 aux_1220 =
												    (((type_bglt) CREF(obj_995))->id);
											      }
											      newtail1179_741 =
												 MAKE_PAIR(aux_1220, BNIL);
											   }
											   SET_CDR(tail1178_737, newtail1179_741);
											   {
											      obj_t tail1178_1229;
											      obj_t l1175_1227;
											      l1175_1227 =
												 CDR(l1175_736);
											      tail1178_1229 = newtail1179_741;
											      tail1178_737 = tail1178_1229;
											      l1175_736 = l1175_1227;
											      goto lname1176_738;
											   }
											}
										   }
										}
									      {		/* Foreign/cfun.scm 70 */
										 obj_t caller_name_114_722;
										 {	/* Foreign/cfun.scm 71 */
										    obj_t aux_1231;
										    aux_1231 =
										       string_to_bstring(nb_args_51_585);
										    caller_name_114_722 =
										       string_append(string1495_foreign_cfunction, aux_1231);
										 }
										 {	/* Foreign/cfun.scm 71 */
										    obj_t c_call_id_131_723;
										    {	/* Foreign/cfun.scm 72 */
										       obj_t list1362_730;
										       {	/* Foreign/cfun.scm 72 */
											  obj_t arg1363_731;
											  obj_t arg1365_732;
											  arg1363_731 =
											     CNST_TABLE_REF(((long) 4));
											  arg1365_732 =
											     MAKE_PAIR(call_id_67_575, BNIL);
											  list1362_730 =
											     MAKE_PAIR(arg1363_731, arg1365_732);
										       }
										       c_call_id_131_723 =
											  symbol_append_197___r4_symbols_6_4(list1362_730);
										    }
										    {	/* Foreign/cfun.scm 72 */

										       {	/* Foreign/cfun.scm 73 */
											  obj_t arg1355_724;
											  obj_t arg1356_725;
											  arg1355_724 =
											     CNST_TABLE_REF(((long) 7));
											  {	/* Foreign/cfun.scm 73 */
											     obj_t arg1357_726;
											     {	/* Foreign/cfun.scm 73 */
												obj_t arg1358_727;
												{	/* Foreign/cfun.scm 73 */
												   obj_t arg1359_728;
												   obj_t arg1361_729;
												   arg1359_728 =
												      MAKE_PAIR(id_572, targs_id_78_721);
												   arg1361_729 =
												      MAKE_PAIR(caller_name_114_722, BNIL);
												   arg1358_727 =
												      MAKE_PAIR(arg1359_728, arg1361_729);
												}
												arg1357_726 =
												   MAKE_PAIR(c_call_id_131_723, arg1358_727);
											     }
											     arg1356_725 =
												MAKE_PAIR(tres_id_18_720, arg1357_726);
											  }
											  arg1245_600 =
											     MAKE_PAIR(arg1355_724, arg1356_725);
										       }
										    }
										 }
									      }
									   }
									}
									arg1243_599 =
									   MAKE_PAIR(arg1245_600, BNIL);
								     }
								     arg1240_597 =
									MAKE_PAIR(arg1241_598, arg1243_599);
								  }
								  arg1237_595 =
								     MAKE_PAIR(arg1238_596, arg1240_597);
							       }
							       arg1235_593 =
								  MAKE_PAIR(arg1236_594, arg1237_595);
							    }
							    produce_module_clause__172_module_module(arg1235_593);
							 }
							 {	/* Foreign/cfun.scm 109 */
							    obj_t arg1248_602;
							    {	/* Foreign/cfun.scm 109 */
							       obj_t arg1249_603;
							       obj_t arg1250_604;
							       arg1249_603 =
								  CNST_TABLE_REF(((long) 21));
							       {	/* Foreign/cfun.scm 109 */
								  obj_t arg1251_605;
								  {	/* Foreign/cfun.scm 109 */
								     obj_t arg1253_607;
								     obj_t arg1254_608;
								     arg1253_607 =
									CNST_TABLE_REF(((long) 22));
								     {	/* Foreign/cfun.scm 109 */
									obj_t arg1255_609;
									{	/* ./Ieee/pair-list.scm 5689 */
									   obj_t aux_1252;
									   aux_1252 =
									      CNST_TABLE_REF(((long) 23));
									   arg1255_609 =
									      MAKE_PAIR(aux_1252, BNIL);
									}
									arg1254_608 =
									   MAKE_PAIR(bid__bool_159_579, arg1255_609);
								     }
								     arg1251_605 =
									MAKE_PAIR(arg1253_607, arg1254_608);
								  }
								  arg1250_604 =
								     MAKE_PAIR(arg1251_605, BNIL);
							       }
							       arg1248_602 =
								  MAKE_PAIR(arg1249_603, arg1250_604);
							    }
							    produce_module_clause__172_module_module(arg1248_602);
							 }
							 {	/* Foreign/cfun.scm 110 */
							    obj_t arg1256_610;
							    {	/* Foreign/cfun.scm 110 */
							       obj_t arg1257_611;
							       obj_t arg1258_612;
							       arg1257_611 =
								  CNST_TABLE_REF(((long) 24));
							       {	/* Foreign/cfun.scm 110 */
								  obj_t arg1259_613;
								  {	/* Foreign/cfun.scm 110 */
								     obj_t arg1261_615;
								     {	/* Foreign/cfun.scm 110 */
									obj_t arg1263_616;
									{	/* Foreign/cfun.scm 110 */
									   obj_t arg1265_618;
									   obj_t arg1267_619;
									   arg1265_618 =
									      CNST_TABLE_REF(((long) 25));
									   arg1267_619 =
									      MAKE_PAIR(wid_573, BNIL);
									   arg1263_616 =
									      MAKE_PAIR(arg1265_618, arg1267_619);
									}
									arg1261_615 =
									   MAKE_PAIR(arg1263_616, BNIL);
								     }
								     arg1259_613 =
									MAKE_PAIR(bid__101_578, arg1261_615);
								  }
								  arg1258_612 =
								     MAKE_PAIR(arg1259_613, BNIL);
							       }
							       arg1256_610 =
								  MAKE_PAIR(arg1257_611, arg1258_612);
							    }
							    produce_module_clause__172_module_module(arg1256_610);
							 }
							 {	/* Foreign/cfun.scm 113 */
							    obj_t arg1268_620;
							    obj_t arg1269_621;
							    obj_t arg1270_622;
							    {	/* Foreign/cfun.scm 56 */
							       obj_t arg1419_781;
							       obj_t arg1420_782;
							       arg1419_781 =
								  CNST_TABLE_REF(((long) 5));
							       {	/* Foreign/cfun.scm 56 */
								  obj_t arg1422_783;
								  obj_t arg1424_784;
								  {	/* Foreign/cfun.scm 56 */
								     obj_t arg1425_785;
								     {	/* ./Ieee/pair-list.scm 5689 */
									obj_t aux_1270;
									aux_1270 =
									   CNST_TABLE_REF(((long) 12));
									arg1425_785 =
									   MAKE_PAIR(aux_1270, BNIL);
								     }
								     arg1422_783 =
									MAKE_PAIR(bid__bool_159_579, arg1425_785);
								  }
								  {	/* Foreign/cfun.scm 57 */
								     obj_t arg1426_786;
								     {	/* Foreign/cfun.scm 57 */
									obj_t arg1428_788;
									obj_t arg1430_789;
									arg1428_788 =
									   CNST_TABLE_REF(((long) 13));
									{	/* Foreign/cfun.scm 57 */
									   obj_t arg1431_790;
									   obj_t arg1432_791;
									   {	/* Foreign/cfun.scm 57 */
									      obj_t arg1433_792;
									      obj_t arg1434_793;
									      arg1433_792 =
										 CNST_TABLE_REF(((long) 14));
									      {		/* ./Ieee/pair-list.scm 5689 */
										 obj_t aux_1276;
										 aux_1276 =
										    CNST_TABLE_REF(((long) 15));
										 arg1434_793 =
										    MAKE_PAIR(aux_1276, BNIL);
									      }
									      arg1431_790 =
										 MAKE_PAIR(arg1433_792, arg1434_793);
									   }
									   {	/* Foreign/cfun.scm 58 */
									      obj_t arg1435_794;
									      obj_t arg1436_795;
									      {		/* Foreign/cfun.scm 58 */
										 obj_t arg1437_796;
										 obj_t arg1438_797;
										 arg1437_796 =
										    CNST_TABLE_REF(((long) 16));
										 {	/* Foreign/cfun.scm 58 */
										    obj_t arg1439_798;
										    obj_t arg1440_799;
										    {	/* Foreign/cfun.scm 58 */
										       obj_t arg1441_800;
										       obj_t arg1442_801;
										       arg1441_800 =
											  CNST_TABLE_REF(((long) 17));
										       {	/* ./Ieee/pair-list.scm 5689 */
											  obj_t aux_1282;
											  aux_1282 =
											     CNST_TABLE_REF(((long) 15));
											  arg1442_801 =
											     MAKE_PAIR(aux_1282, BNIL);
										       }
										       arg1439_798 =
											  MAKE_PAIR(arg1441_800, arg1442_801);
										    }
										    {	/* Foreign/cfun.scm 58 */
										       obj_t arg1443_802;
										       {	/* Foreign/cfun.scm 58 */
											  obj_t arg1445_804;
											  obj_t arg1446_805;
											  arg1445_804 =
											     CNST_TABLE_REF(((long) 18));
											  arg1446_805 =
											     MAKE_PAIR(bid_574, BNIL);
											  arg1443_802 =
											     MAKE_PAIR(arg1445_804, arg1446_805);
										       }
										       arg1440_799 =
											  MAKE_PAIR(arg1443_802, BNIL);
										    }
										    arg1438_797 =
										       MAKE_PAIR(arg1439_798, arg1440_799);
										 }
										 arg1435_794 =
										    MAKE_PAIR(arg1437_796, arg1438_797);
									      }
									      arg1436_795 =
										 MAKE_PAIR(BFALSE, BNIL);
									      arg1432_791 =
										 MAKE_PAIR(arg1435_794, arg1436_795);
									   }
									   arg1430_789 =
									      MAKE_PAIR(arg1431_790, arg1432_791);
									}
									arg1426_786 =
									   MAKE_PAIR(arg1428_788, arg1430_789);
								     }
								     arg1424_784 =
									MAKE_PAIR(arg1426_786, BNIL);
								  }
								  arg1420_782 =
								     MAKE_PAIR(arg1422_783, arg1424_784);
							       }
							       arg1268_620 =
								  MAKE_PAIR(arg1419_781, arg1420_782);
							    }
							    {	/* Foreign/cfun.scm 63 */
							       obj_t arg1378_750;
							       obj_t arg1379_751;
							       arg1378_750 =
								  CNST_TABLE_REF(((long) 5));
							       {	/* Foreign/cfun.scm 63 */
								  obj_t arg1380_752;
								  obj_t arg1381_753;
								  {	/* Foreign/cfun.scm 63 */
								     obj_t arg1383_754;
								     obj_t arg1384_755;
								     {	/* Foreign/cfun.scm 63 */
									obj_t list1385_756;
									{	/* Foreign/cfun.scm 63 */
									   obj_t arg1387_757;
									   obj_t arg1389_758;
									   arg1387_757 =
									      CNST_TABLE_REF(((long) 8));
									   {	/* Foreign/cfun.scm 63 */
									      obj_t arg1390_759;
									      {		/* Foreign/cfun.scm 63 */
										 obj_t aux_1301;
										 aux_1301 =
										    CNST_TABLE_REF(((long) 3));
										 arg1390_759 =
										    MAKE_PAIR(aux_1301, BNIL);
									      }
									      arg1389_758 =
										 MAKE_PAIR(id_572, arg1390_759);
									   }
									   list1385_756 =
									      MAKE_PAIR(arg1387_757, arg1389_758);
									}
									arg1383_754 =
									   symbol_append_197___r4_symbols_6_4(list1385_756);
								     }
								     {	/* Foreign/cfun.scm 64 */
									obj_t arg1391_760;
									obj_t arg1393_761;
									{	/* Foreign/cfun.scm 64 */
									   obj_t list1394_762;
									   {	/* Foreign/cfun.scm 64 */
									      obj_t arg1395_763;
									      obj_t arg1397_764;
									      arg1395_763 =
										 CNST_TABLE_REF(((long) 9));
									      {		/* Foreign/cfun.scm 64 */
										 obj_t arg1398_765;
										 arg1398_765 =
										    MAKE_PAIR(id_572, BNIL);
										 arg1397_764 =
										    MAKE_PAIR(_4dots_199_tools_misc, arg1398_765);
									      }
									      list1394_762 =
										 MAKE_PAIR(arg1395_763, arg1397_764);
									   }
									   arg1391_760 =
									      symbol_append_197___r4_symbols_6_4(list1394_762);
									}
									{	/* Foreign/cfun.scm 65 */
									   obj_t arg1399_766;
									   {	/* Foreign/cfun.scm 65 */
									      obj_t list1401_768;
									      {		/* Foreign/cfun.scm 65 */
										 obj_t arg1402_769;
										 obj_t arg1403_770;
										 arg1402_769 =
										    CNST_TABLE_REF(((long) 10));
										 {	/* Foreign/cfun.scm 65 */
										    obj_t arg1404_771;
										    arg1404_771 =
										       MAKE_PAIR(id_572, BNIL);
										    arg1403_770 =
										       MAKE_PAIR(_4dots_199_tools_misc, arg1404_771);
										 }
										 list1401_768 =
										    MAKE_PAIR(arg1402_769, arg1403_770);
									      }
									      arg1399_766 =
										 symbol_append_197___r4_symbols_6_4(list1401_768);
									   }
									   arg1393_761 =
									      MAKE_PAIR(arg1399_766, BNIL);
									}
									arg1384_755 =
									   MAKE_PAIR(arg1391_760, arg1393_761);
								     }
								     arg1380_752 =
									MAKE_PAIR(arg1383_754, arg1384_755);
								  }
								  {	/* Foreign/cfun.scm 66 */
								     obj_t arg1405_772;
								     {	/* Foreign/cfun.scm 66 */
									obj_t arg1409_774;
									obj_t arg1410_775;
									arg1409_774 =
									   CNST_TABLE_REF(((long) 11));
									{	/* Foreign/cfun.scm 66 */
									   obj_t arg1412_777;
									   {	/* Foreign/cfun.scm 66 */
									      obj_t arg1415_778;
									      obj_t arg1416_779;
									      arg1415_778 =
										 CNST_TABLE_REF(((long) 9));
									      {		/* ./Ieee/pair-list.scm 5689 */
										 obj_t aux_1322;
										 aux_1322 =
										    CNST_TABLE_REF(((long) 10));
										 arg1416_779 =
										    MAKE_PAIR(aux_1322, BNIL);
									      }
									      arg1412_777 =
										 MAKE_PAIR(arg1415_778, arg1416_779);
									   }
									   arg1410_775 =
									      MAKE_PAIR(string1496_foreign_cfunction, arg1412_777);
									}
									arg1405_772 =
									   MAKE_PAIR(arg1409_774, arg1410_775);
								     }
								     arg1381_753 =
									MAKE_PAIR(arg1405_772, BNIL);
								  }
								  arg1379_751 =
								     MAKE_PAIR(arg1380_752, arg1381_753);
							       }
							       arg1269_621 =
								  MAKE_PAIR(arg1378_750, arg1379_751);
							    }
							    {	/* Foreign/cfun.scm 78 */
							       bool_t test1342_708;
							       {	/* Foreign/cfun.scm 78 */
								  long n2_983;
								  n2_983 =
								     (long) CINT(_max_c_foreign_arity__143_engine_param);
								  test1342_708 =
								     (arity_584 >= n2_983);
							       }
							       if (test1342_708)
								 {	/* Foreign/cfun.scm 78 */
								    {	/* Foreign/cfun.scm 80 */
								       obj_t arg1343_709;
								       obj_t arg1344_710;
								       {	/* Foreign/cfun.scm 80 */
									  obj_t arg1347_713;
									  {	/* Foreign/cfun.scm 82 */
									     char *arg1348_714;
									     arg1348_714 =
										integer__string_135___r4_numbers_6_5_fixnum(
										(long) CINT(_max_c_foreign_arity__143_engine_param), BNIL);
									     {	/* Foreign/cfun.scm 80 */
										obj_t aux_1336;
										aux_1336 =
										   string_to_bstring(arg1348_714);
										arg1347_713 =
										   string_append(aux_1336, string1490_foreign_cfunction);
									     }
									  }
									  arg1343_709 =
									     string_append(string1491_foreign_cfunction, arg1347_713);
								       }
								       {	/* Foreign/cfun.scm 84 */
									  obj_t aux_1340;
									  aux_1340 =
									     string_to_bstring(nb_args_51_585);
									  arg1344_710 =
									     string_append(aux_1340, string1492_foreign_cfunction);
								       }
								       arg1270_622 =
									  user_error_151_tools_error(id_572, arg1343_709, arg1344_710, BNIL);
								    }
								 }
							       else
								 {	/* Foreign/cfun.scm 78 */
								    if (
								       (arity_584 >= ((long) 0)))
								      {		/* Foreign/cfun.scm 85 */
									 {	/* Foreign/cfun.scm 93 */
									    obj_t tres_id_18_627;
									    tres_id_18_627 =
									       (((type_bglt) CREF(type_res_48_582))->id);
									    {	/* Foreign/cfun.scm 93 */
									       obj_t targs_id_78_628;
									       if (
										  NULLP(type_args_244_583))
										 {	/* Foreign/cfun.scm 94 */
										    targs_id_78_628 = BNIL;
										 }
									       else
										 {	/* Foreign/cfun.scm 94 */
										    obj_t head1182_693;
										    {	/* ./Ieee/pair-list.scm 5689 */
										       obj_t aux_1349;
										       {	/* Foreign/cfun.scm 94 */
											  type_bglt obj_931;
											  {	/* Foreign/cfun.scm 94 */
											     obj_t aux_1350;
											     aux_1350 =
												CAR(type_args_244_583);
											     obj_931 =
												(type_bglt) (aux_1350);
											  }
											  aux_1349 =
											     (((type_bglt) CREF(obj_931))->id);
										       }
										       head1182_693 =
											  MAKE_PAIR(aux_1349, BNIL);
										    }
										    {
										       obj_t l1180_694;
										       obj_t tail1183_695;
										       l1180_694 =
											  CDR(type_args_244_583);
										       tail1183_695 = head1182_693;
										     lname1181_696:
										       if (
											  NULLP(l1180_694))
											 {	/* Foreign/cfun.scm 94 */
											    targs_id_78_628 = head1182_693;
											 }
										       else
											 {	/* Foreign/cfun.scm 94 */
											    obj_t newtail1184_699;
											    {	/* ./Ieee/pair-list.scm 5689 */
											       obj_t aux_1357;
											       {	/* Foreign/cfun.scm 94 */
												  type_bglt obj_937;
												  {	/* Foreign/cfun.scm 94 */
												     obj_t aux_1358;
												     aux_1358 =
													CAR(l1180_694);
												     obj_937 =
													(type_bglt) (aux_1358);
												  }
												  aux_1357 =
												     (((type_bglt) CREF(obj_937))->id);
											       }
											       newtail1184_699 =
												  MAKE_PAIR(aux_1357, BNIL);
											    }
											    SET_CDR(tail1183_695, newtail1184_699);
											    {
											       obj_t tail1183_1366;
											       obj_t l1180_1364;
											       l1180_1364 =
												  CDR(l1180_694);
											       tail1183_1366 = newtail1184_699;
											       tail1183_695 = tail1183_1366;
											       l1180_694 = l1180_1364;
											       goto lname1181_696;
											    }
											 }
										    }
										 }
									       {	/* Foreign/cfun.scm 94 */
										  obj_t args_629;
										  if (
										     NULLP(targs_id_78_628))
										    {	/* Foreign/cfun.scm 95 */
										       args_629 = BNIL;
										    }
										  else
										    {	/* Foreign/cfun.scm 95 */
										       obj_t head1187_677;
										       {	/* Foreign/cfun.scm 95 */
											  obj_t arg1327_688;
											  arg1327_688 =
											     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
											     CAR(targs_id_78_628), BEOA);
											  head1187_677 =
											     MAKE_PAIR(arg1327_688, BNIL);
										       }
										       {
											  obj_t l1185_678;
											  obj_t tail1188_679;
											  l1185_678 =
											     CDR(targs_id_78_628);
											  tail1188_679 = head1187_677;
											lname1186_680:
											  if (
											     NULLP(l1185_678))
											    {	/* Foreign/cfun.scm 95 */
											       args_629 = head1187_677;
											    }
											  else
											    {	/* Foreign/cfun.scm 95 */
											       obj_t newtail1189_683;
											       {	/* Foreign/cfun.scm 95 */
												  obj_t arg1323_685;
												  arg1323_685 =
												     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
												     CAR(l1185_678), BEOA);
												  newtail1189_683 =
												     MAKE_PAIR(arg1323_685, BNIL);
											       }
											       SET_CDR(tail1188_679, newtail1189_683);
											       {
												  obj_t tail1188_1383;
												  obj_t l1185_1381;
												  l1185_1381 =
												     CDR(l1185_678);
												  tail1188_1383 = newtail1189_683;
												  tail1188_679 = tail1188_1383;
												  l1185_678 = l1185_1381;
												  goto lname1186_680;
											       }
											    }
										       }
										    }
										  {	/* Foreign/cfun.scm 95 */
										     obj_t c_call_id_131_630;
										     {	/* Foreign/cfun.scm 96 */
											obj_t list1315_672;
											{	/* Foreign/cfun.scm 96 */
											   obj_t arg1317_673;
											   obj_t arg1318_674;
											   arg1317_673 =
											      CNST_TABLE_REF(((long) 4));
											   arg1318_674 =
											      MAKE_PAIR(call_id_67_575, BNIL);
											   list1315_672 =
											      MAKE_PAIR(arg1317_673, arg1318_674);
											}
											c_call_id_131_630 =
											   symbol_append_197___r4_symbols_6_4(list1315_672);
										     }
										     {	/* Foreign/cfun.scm 96 */

											{	/* Foreign/cfun.scm 97 */
											   obj_t arg1276_631;
											   obj_t arg1277_632;
											   arg1276_631 =
											      CNST_TABLE_REF(((long) 5));
											   {	/* Foreign/cfun.scm 97 */
											      obj_t arg1278_633;
											      obj_t arg1280_634;
											      {		/* Foreign/cfun.scm 97 */
												 obj_t arg1281_635;
												 obj_t arg1282_636;
												 {	/* Foreign/cfun.scm 97 */
												    obj_t list1283_637;
												    {	/* Foreign/cfun.scm 97 */
												       obj_t arg1286_638;
												       {	/* Foreign/cfun.scm 97 */
													  obj_t arg1287_639;
													  arg1287_639 =
													     MAKE_PAIR(tres_id_18_627, BNIL);
													  arg1286_638 =
													     MAKE_PAIR(_4dots_199_tools_misc, arg1287_639);
												       }
												       list1283_637 =
													  MAKE_PAIR(call_id_67_575, arg1286_638);
												    }
												    arg1281_635 =
												       symbol_append_197___r4_symbols_6_4(list1283_637);
												 }
												 {	/* Foreign/cfun.scm 98 */
												    obj_t arg1289_640;
												    obj_t arg1290_641;
												    {	/* Foreign/cfun.scm 98 */
												       obj_t list1291_642;
												       {	/* Foreign/cfun.scm 98 */
													  obj_t arg1292_643;
													  obj_t arg1293_644;
													  arg1292_643 =
													     CNST_TABLE_REF(((long) 6));
													  {	/* Foreign/cfun.scm 98 */
													     obj_t arg1294_645;
													     arg1294_645 =
														MAKE_PAIR(id_572, BNIL);
													     arg1293_644 =
														MAKE_PAIR(_4dots_199_tools_misc, arg1294_645);
													  }
													  list1291_642 =
													     MAKE_PAIR(arg1292_643, arg1293_644);
												       }
												       arg1289_640 =
													  symbol_append_197___r4_symbols_6_4(list1291_642);
												    }
												    {	/* Foreign/cfun.scm 99 */
												       obj_t arg1295_646;
												       if (
													  NULLP(args_629))
													 {	/* Foreign/cfun.scm 99 */
													    arg1295_646 = BNIL;
													 }
												       else
													 {	/* Foreign/cfun.scm 99 */
													    obj_t head1192_651;
													    head1192_651 =
													       MAKE_PAIR(BNIL, BNIL);
													    {
													       obj_t ll1190_652;
													       obj_t ll1191_653;
													       obj_t tail1193_654;
													       ll1190_652 = args_629;
													       ll1191_653 = targs_id_78_628;
													       tail1193_654 = head1192_651;
													     lname1195_655:
													       if (
														  NULLP(ll1190_652))
														 {	/* Foreign/cfun.scm 99 */
														    arg1295_646 =
														       CDR(head1192_651);
														 }
													       else
														 {	/* Foreign/cfun.scm 100 */
														    obj_t newtail1194_657;
														    {	/* Foreign/cfun.scm 100 */
														       obj_t arg1301_660;
														       {	/* Foreign/cfun.scm 100 */
															  obj_t arg_662;
															  arg_662 =
															     CAR(ll1190_652);
															  {	/* Foreign/cfun.scm 100 */
															     obj_t list1303_664;
															     {	/* Foreign/cfun.scm 100 */
																obj_t arg1304_665;
																{	/* Foreign/cfun.scm 100 */
																   obj_t arg1305_666;
																   {	/* Foreign/cfun.scm 100 */
																      obj_t aux_1406;
																      aux_1406 =
																	 CAR(ll1191_653);
																      arg1305_666 =
																	 MAKE_PAIR(aux_1406, BNIL);
																   }
																   arg1304_665 =
																      MAKE_PAIR(_4dots_199_tools_misc, arg1305_666);
																}
																list1303_664 =
																   MAKE_PAIR(arg_662, arg1304_665);
															     }
															     arg1301_660 =
																symbol_append_197___r4_symbols_6_4(list1303_664);
															  }
														       }
														       newtail1194_657 =
															  MAKE_PAIR(arg1301_660, BNIL);
														    }
														    SET_CDR(tail1193_654, newtail1194_657);
														    {
														       obj_t tail1193_1418;
														       obj_t ll1191_1416;
														       obj_t ll1190_1414;
														       ll1190_1414 =
															  CDR(ll1190_652);
														       ll1191_1416 =
															  CDR(ll1191_653);
														       tail1193_1418 = newtail1194_657;
														       tail1193_654 = tail1193_1418;
														       ll1191_653 = ll1191_1416;
														       ll1190_652 = ll1190_1414;
														       goto lname1195_655;
														    }
														 }
													    }
													 }
												       arg1290_641 =
													  append_2_18___r4_pairs_and_lists_6_3(arg1295_646, BNIL);
												    }
												    arg1282_636 =
												       MAKE_PAIR(arg1289_640, arg1290_641);
												 }
												 arg1278_633 =
												    MAKE_PAIR(arg1281_635, arg1282_636);
											      }
											      {		/* Foreign/cfun.scm 102 */
												 obj_t arg1307_667;
												 {	/* Foreign/cfun.scm 102 */
												    obj_t arg1309_669;
												    {	/* ./Ieee/pair-list.scm 5689 */
												       obj_t aux_1424;
												       obj_t aux_1422;
												       aux_1424 =
													  append_2_18___r4_pairs_and_lists_6_3(args_629, BNIL);
												       aux_1422 =
													  CNST_TABLE_REF(((long) 6));
												       arg1309_669 =
													  MAKE_PAIR(aux_1422, aux_1424);
												    }
												    arg1307_667 =
												       MAKE_PAIR(c_call_id_131_630, arg1309_669);
												 }
												 arg1280_634 =
												    MAKE_PAIR(arg1307_667, BNIL);
											      }
											      arg1277_632 =
												 MAKE_PAIR(arg1278_633, arg1280_634);
											   }
											   arg1270_622 =
											      MAKE_PAIR(arg1276_631, arg1277_632);
											}
										     }
										  }
									       }
									    }
									 }
								      }
								    else
								      {		/* Foreign/cfun.scm 85 */
									 arg1270_622 =
									    user_error_151_tools_error(string1493_foreign_cfunction, string1494_foreign_cfunction, id_572, BNIL);
								      }
								 }
							    }
							    {	/* Foreign/cfun.scm 113 */
							       obj_t list1271_623;
							       {	/* Foreign/cfun.scm 113 */
								  obj_t arg1272_624;
								  {	/* Foreign/cfun.scm 113 */
								     obj_t arg1273_625;
								     arg1273_625 =
									MAKE_PAIR(arg1270_622, BNIL);
								     arg1272_624 =
									MAKE_PAIR(arg1269_621, arg1273_625);
								  }
								  list1271_623 =
								     MAKE_PAIR(arg1268_620, arg1272_624);
							       }
							       return list1271_623;
							    }
							 }
						      }
						   }
						}
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_foreign_cfunction()
{
   AN_OBJECT;
   {	/* Foreign/cfun.scm 14 */
      module_initialization_70_tools_error(((long) 0), "FOREIGN_CFUNCTION");
      module_initialization_70_tools_misc(((long) 0), "FOREIGN_CFUNCTION");
      module_initialization_70_type_tools(((long) 0), "FOREIGN_CFUNCTION");
      module_initialization_70_type_type(((long) 0), "FOREIGN_CFUNCTION");
      module_initialization_70_foreign_ctype(((long) 0), "FOREIGN_CFUNCTION");
      module_initialization_70_foreign_access(((long) 0), "FOREIGN_CFUNCTION");
      module_initialization_70_module_module(((long) 0), "FOREIGN_CFUNCTION");
      return
	 module_initialization_70_engine_param(((long) 0), "FOREIGN_CFUNCTION");
   }
}
