/*===========================================================================*/
/*   (Module/alibrary.scm)                                                   */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


extern obj_t ccomp_module_module;
static obj_t method_init_76_module_alibrary();
extern obj_t string_to_symbol(char *);
extern obj_t string_append(obj_t, obj_t);
static obj_t _anonymous_1067__239_module_alibrary(obj_t, obj_t, obj_t);
static obj_t _anonymous_1066__76_module_alibrary(obj_t);
static obj_t _anonymous_1065__95_module_alibrary(obj_t, obj_t, obj_t);
static obj_t _use_library__128_module_alibrary(obj_t, obj_t, obj_t);
extern obj_t user_error_151_tools_error(obj_t, obj_t, obj_t, obj_t);
extern obj_t _additional_bigloo_libraries__50_engine_param;
extern obj_t member___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t module_initialization_70_module_alibrary(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_expand_srfi_0_32(long, char *);
extern obj_t module_initialization_70_init_setrc(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t add_supported_srfi__69_expand_srfi_0_32(obj_t);
extern long class_num_218___object(obj_t);
extern obj_t make_alibrary_compiler_139_module_alibrary();
static obj_t _alibrary_producer_189_module_alibrary(obj_t, obj_t);
static obj_t imported_modules_init_94_module_alibrary();
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
static obj_t alibrary_producer_39_module_alibrary(obj_t);
extern obj_t string_upcase_71___r4_strings_6_7(obj_t);
extern bool_t bigloo_strcmp(obj_t, obj_t);
static obj_t library_modules_init_112_module_alibrary();
static obj_t toplevel_init_63_module_alibrary();
extern obj_t open_input_string(obj_t);
extern obj_t setup_library_values_14_init_setrc(obj_t);
extern obj_t use_library__86_module_alibrary(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t _make_alibrary_compiler_52_module_alibrary(obj_t);
static obj_t _make_library_name_5_module_alibrary(obj_t, obj_t);
static obj_t require_initialization_114_module_alibrary = BUNSPEC;
extern obj_t _additional_heap_names__104_engine_param;
extern obj_t make_library_name_119_module_alibrary(obj_t);
static obj_t cnst_init_137_module_alibrary();
static obj_t __cnst[3];

DEFINE_EXPORT_PROCEDURE(use_library__env_138_module_alibrary, _use_library__128_module_alibrary1177, _use_library__128_module_alibrary, 0L, 2);
DEFINE_STATIC_PROCEDURE(alibrary_producer_env_230_module_alibrary, _alibrary_producer_189_module_alibrary1178, _alibrary_producer_189_module_alibrary, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1165_module_alibrary, _anonymous_1065__95_module_alibrary1179, _anonymous_1065__95_module_alibrary, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1164_module_alibrary, _anonymous_1066__76_module_alibrary1180, _anonymous_1066__76_module_alibrary, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc1163_module_alibrary, _anonymous_1067__239_module_alibrary1181, _anonymous_1067__239_module_alibrary, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_library_name_env_51_module_alibrary, _make_library_name_5_module_alibrary1182, _make_library_name_5_module_alibrary, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_alibrary_compiler_env_116_module_alibrary, _make_alibrary_compiler_52_module_alibrary1183, _make_alibrary_compiler_52_module_alibrary, 0L, 0);
DEFINE_STRING(string1169_module_alibrary, string1169_module_alibrary1184, "Illegal library", 15);
DEFINE_STRING(string1170_module_alibrary, string1170_module_alibrary1185, "VOID LIBRARY NOW ", 17);
DEFINE_STRING(string1168_module_alibrary, string1168_module_alibrary1186, "Library name must be downcase", 29);
DEFINE_STRING(string1167_module_alibrary, string1167_module_alibrary1187, "Illegal `library' clause", 24);
DEFINE_STRING(string1166_module_alibrary, string1166_module_alibrary1188, "Parse error", 11);
DEFINE_STRING(string1162_module_alibrary, string1162_module_alibrary1189, ".heap", 5);



/* module-initialization */
obj_t 
module_initialization_70_module_alibrary(long checksum_170, char *from_171)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_module_alibrary))
	{
	   require_initialization_114_module_alibrary =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_module_alibrary();
	   cnst_init_137_module_alibrary();
	   imported_modules_init_94_module_alibrary();
	   method_init_76_module_alibrary();
	   toplevel_init_63_module_alibrary();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_module_alibrary()
{
   AN_OBJECT;
   {	/* Module/alibrary.scm 14 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "MODULE_ALIBRARY");
      module_initialization_70___object(((long) 0), "MODULE_ALIBRARY");
      module_initialization_70___r4_strings_6_7(((long) 0), "MODULE_ALIBRARY");
      module_initialization_70___reader(((long) 0), "MODULE_ALIBRARY");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_module_alibrary()
{
   AN_OBJECT;
   {	/* Module/alibrary.scm 14 */
      {		/* Module/alibrary.scm 14 */
	 obj_t cnst_port_138_163;
	 cnst_port_138_163 =
	    open_input_string(string1170_module_alibrary);
	 {
	    long i_164;
	    i_164 = ((long) 2);
	  loop_165:
	    {	/* Module/alibrary.scm 14 */
	       bool_t test1171_166;
	       test1171_166 =
		  (i_164 == ((long) -1));
	       if (test1171_166)
		 {	/* Module/alibrary.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Module/alibrary.scm 14 */
		    {	/* Module/alibrary.scm 14 */
		       obj_t arg1174_167;
		       {	/* Module/alibrary.scm 14 */
			  obj_t list1175_168;
			  list1175_168 =
			     MAKE_PAIR(cnst_port_138_163, BNIL);
			  arg1174_167 =
			     read___reader(list1175_168);
		       }
		       CNST_TABLE_SET(i_164, arg1174_167);
		    }
		    {	/* Module/alibrary.scm 14 */
		       int aux_169;
		       {	/* Module/alibrary.scm 14 */
			  long aux_190;
			  aux_190 =
			     (i_164 - ((long) 1));
			  aux_169 =
			     (int) (aux_190);
		       }
		       {
			  long i_193;
			  i_193 =
			     (long) (aux_169);
			  i_164 = i_193;
			  goto loop_165;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_module_alibrary()
{
   AN_OBJECT;
   {	/* Module/alibrary.scm 14 */
      return BUNSPEC;
   }
}



/* use-library! */
obj_t 
use_library__86_module_alibrary(obj_t library_19, obj_t mode_20)
{
   AN_OBJECT;
   {	/* Module/alibrary.scm 28 */
      {		/* Module/alibrary.scm 29 */
	 obj_t lib_name_97_44;
	 lib_name_97_44 =
	    make_library_name_119_module_alibrary(library_19);
	 {	/* Module/alibrary.scm 30 */
	    bool_t test1036_45;
	    {	/* Module/alibrary.scm 30 */
	       obj_t aux_196;
	       aux_196 =
		  member___r4_pairs_and_lists_6_3(lib_name_97_44, _additional_bigloo_libraries__50_engine_param);
	       test1036_45 =
		  CBOOL(aux_196);
	    }
	    if (test1036_45)
	      {		/* Module/alibrary.scm 30 */
		 return BUNSPEC;
	      }
	    else
	      {		/* Module/alibrary.scm 30 */
		 {	/* Module/alibrary.scm 33 */
		    obj_t obj2_107;
		    obj2_107 = _additional_bigloo_libraries__50_engine_param;
		    _additional_bigloo_libraries__50_engine_param =
		       MAKE_PAIR(lib_name_97_44, obj2_107);
		 }
		 {	/* Module/alibrary.scm 34 */
		    obj_t heap_name_210_46;
		    heap_name_210_46 =
		       string_append(lib_name_97_44, string1162_module_alibrary);
		    {	/* Module/alibrary.scm 35 */
		       obj_t arg1039_47;
		       {	/* Module/alibrary.scm 35 */
			  obj_t arg1040_48;
			  arg1040_48 =
			     string_upcase_71___r4_strings_6_7(lib_name_97_44);
			  {	/* ./Ieee/symbol.scm 6027 */
			     char *aux_203;
			     aux_203 =
				BSTRING_TO_STRING(arg1040_48);
			     arg1039_47 =
				string_to_symbol(aux_203);
			  }
		       }
		       add_supported_srfi__69_expand_srfi_0_32(arg1039_47);
		    }
		    {	/* Module/alibrary.scm 41 */
		       bool_t test_207;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_208;
			  aux_208 =
			     CNST_TABLE_REF(((long) 0));
			  test_207 =
			     (mode_20 == aux_208);
		       }
		       if (test_207)
			 {	/* Module/alibrary.scm 41 */
			    setup_library_values_14_init_setrc(lib_name_97_44);
			 }
		       else
			 {	/* Module/alibrary.scm 41 */
			    BUNSPEC;
			 }
		    }
		    {	/* Module/alibrary.scm 43 */
		       obj_t obj2_112;
		       obj2_112 = _additional_heap_names__104_engine_param;
		       _additional_heap_names__104_engine_param =
			  MAKE_PAIR(heap_name_210_46, obj2_112);
		    }
		    return lib_name_97_44;
		 }
	      }
	 }
      }
   }
}



/* _use-library! */
obj_t 
_use_library__128_module_alibrary(obj_t env_144, obj_t library_145, obj_t mode_146)
{
   AN_OBJECT;
   {	/* Module/alibrary.scm 28 */
      return
	 use_library__86_module_alibrary(library_145, mode_146);
   }
}



/* make-alibrary-compiler */
obj_t 
make_alibrary_compiler_139_module_alibrary()
{
   AN_OBJECT;
   {	/* Module/alibrary.scm 49 */
      {		/* Module/alibrary.scm 51 */
	 obj_t arg1054_50;
	 arg1054_50 =
	    CNST_TABLE_REF(((long) 1));
	 {	/* ./Module/module.scm 372 */
	    obj_t _anonymous_1067__239_147;
	    obj_t _anonymous_1066__76_148;
	    obj_t _anonymous_1065__95_149;
	    _anonymous_1067__239_147 = proc1163_module_alibrary;
	    _anonymous_1066__76_148 = proc1164_module_alibrary;
	    _anonymous_1065__95_149 = proc1165_module_alibrary;
	    {	/* Module/alibrary.scm 50 */
	       ccomp_bglt res1161_124;
	       {	/* ./Module/module.scm 364 */
		  ccomp_bglt new1002_115;
		  new1002_115 =
		     ((ccomp_bglt) BREF(GC_MALLOC(sizeof(struct ccomp))));
		  {	/* ./Module/module.scm 364 */
		     long arg1159_116;
		     arg1159_116 =
			class_num_218___object(ccomp_module_module);
		     {	/* ./Module/module.scm 364 */
			obj_t obj_122;
			obj_122 =
			   (obj_t) (new1002_115);
			(((obj_t) CREF(obj_122))->header = MAKE_HEADER(arg1159_116, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Module/module.scm 364 */
		     object_bglt aux_219;
		     aux_219 =
			(object_bglt) (new1002_115);
		     OBJECT_WIDENING_SET(aux_219, BFALSE);
		  }
		  ((((ccomp_bglt) CREF(new1002_115))->id) = ((obj_t) arg1054_50), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_115))->producer) = ((obj_t) alibrary_producer_env_230_module_alibrary), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_115))->consumer) = ((obj_t) _anonymous_1065__95_149), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_115))->finalizer) = ((obj_t) _anonymous_1066__76_148), BUNSPEC);
		  ((((ccomp_bglt) CREF(new1002_115))->checksummer) = ((obj_t) _anonymous_1067__239_147), BUNSPEC);
		  res1161_124 = new1002_115;
	       }
	       return
		  (obj_t) (res1161_124);
	    }
	 }
      }
   }
}



/* _make-alibrary-compiler */
obj_t 
_make_alibrary_compiler_52_module_alibrary(obj_t env_150)
{
   AN_OBJECT;
   {	/* Module/alibrary.scm 49 */
      return
	 make_alibrary_compiler_139_module_alibrary();
   }
}



/* <anonymous:1067> */
obj_t 
_anonymous_1067__239_module_alibrary(obj_t env_151, obj_t m_152, obj_t c_153)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 377 */
      {
	 obj_t m_59;
	 obj_t c_60;
	 m_59 = m_152;
	 c_60 = c_153;
	 return c_60;
      }
   }
}



/* <anonymous:1066> */
obj_t 
_anonymous_1066__76_module_alibrary(obj_t env_154)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 374 */
      {

	 return
	    CNST_TABLE_REF(((long) 2));
      }
   }
}



/* <anonymous:1065> */
obj_t 
_anonymous_1065__95_module_alibrary(obj_t env_155, obj_t m_156, obj_t c_157)
{
   AN_OBJECT;
   {	/* ./Module/module.scm 372 */
      {
	 obj_t m_55;
	 obj_t c_56;
	 m_55 = m_156;
	 c_56 = c_157;
	 return BNIL;
      }
   }
}



/* alibrary-producer */
obj_t 
alibrary_producer_39_module_alibrary(obj_t clause_21)
{
   AN_OBJECT;
   {	/* Module/alibrary.scm 57 */
      {
	 obj_t protos_65;
	 if (
	    PAIRP(clause_21))
	   {	/* Module/alibrary.scm 58 */
	      protos_65 =
		 CDR(clause_21);
	      {
		 obj_t l1011_71;
		 l1011_71 = protos_65;
	       lname1012_72:
		 if (
		    PAIRP(l1011_71))
		   {	/* Module/alibrary.scm 60 */
		      use_library__86_module_alibrary(
			 CAR(l1011_71),
			 CNST_TABLE_REF(((long) 0)));
		      {
			 obj_t l1011_237;
			 l1011_237 =
			    CDR(l1011_71);
			 l1011_71 = l1011_237;
			 goto lname1012_72;
		      }
		   }
		 else
		   {	/* Module/alibrary.scm 60 */
		      ((bool_t) 1);
		   }
	      }
	      return BNIL;
	   }
	 else
	   {	/* Module/alibrary.scm 58 */
	      {		/* Module/alibrary.scm 63 */
		 obj_t list1143_76;
		 list1143_76 =
		    MAKE_PAIR(BNIL, BNIL);
		 return
		    user_error_151_tools_error(string1166_module_alibrary, string1167_module_alibrary, clause_21, list1143_76);
	      }
	   }
      }
   }
}



/* _alibrary-producer */
obj_t 
_alibrary_producer_189_module_alibrary(obj_t env_158, obj_t clause_159)
{
   AN_OBJECT;
   {	/* Module/alibrary.scm 57 */
      return
	 alibrary_producer_39_module_alibrary(clause_159);
   }
}



/* make-library-name */
obj_t 
make_library_name_119_module_alibrary(obj_t libname_22)
{
   AN_OBJECT;
   {	/* Module/alibrary.scm 68 */
      if (
	 SYMBOLP(libname_22))
	{	/* Module/alibrary.scm 70 */
	   {	/* Module/alibrary.scm 71 */
	      obj_t arg1150_78;
	      arg1150_78 =
		 SYMBOL_TO_STRING(libname_22);
	      return
		 string_downcase_77___r4_strings_6_7(arg1150_78);
	   }
	}
      else
	{	/* Module/alibrary.scm 70 */
	   if (
	      STRINGP(libname_22))
	     {	/* Module/alibrary.scm 72 */
		{	/* Module/alibrary.scm 73 */
		   obj_t new_name_162_80;
		   new_name_162_80 =
		      string_downcase_77___r4_strings_6_7(libname_22);
		   {	/* Module/alibrary.scm 74 */
		      bool_t test1152_81;
		      test1152_81 =
			 bigloo_strcmp(new_name_162_80, libname_22);
		      if (test1152_81)
			{	/* Module/alibrary.scm 74 */
			   return new_name_162_80;
			}
		      else
			{	/* Module/alibrary.scm 75 */
			   obj_t list1153_82;
			   list1153_82 =
			      MAKE_PAIR(BNIL, BNIL);
			   return
			      user_error_151_tools_error(string1166_module_alibrary, string1168_module_alibrary, libname_22, list1153_82);
			}
		   }
		}
	     }
	   else
	     {	/* Module/alibrary.scm 72 */
		{	/* Module/alibrary.scm 80 */
		   obj_t list1154_83;
		   list1154_83 =
		      MAKE_PAIR(BNIL, BNIL);
		   return
		      user_error_151_tools_error(string1166_module_alibrary, string1169_module_alibrary, libname_22, list1154_83);
		}
	     }
	}
   }
}



/* _make-library-name */
obj_t 
_make_library_name_5_module_alibrary(obj_t env_160, obj_t libname_161)
{
   AN_OBJECT;
   {	/* Module/alibrary.scm 68 */
      return
	 make_library_name_119_module_alibrary(libname_161);
   }
}



/* method-init */
obj_t 
method_init_76_module_alibrary()
{
   AN_OBJECT;
   {	/* Module/alibrary.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_module_alibrary()
{
   AN_OBJECT;
   {	/* Module/alibrary.scm 14 */
      module_initialization_70_module_module(((long) 0), "MODULE_ALIBRARY");
      module_initialization_70_tools_error(((long) 0), "MODULE_ALIBRARY");
      module_initialization_70_engine_param(((long) 0), "MODULE_ALIBRARY");
      module_initialization_70_expand_srfi_0_32(((long) 0), "MODULE_ALIBRARY");
      return
	 module_initialization_70_init_setrc(((long) 0), "MODULE_ALIBRARY");
   }
}
