/*===========================================================================*/
/*   (Tools/misc.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>

extern obj_t string_to_symbol(char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
static obj_t _epairify1016_tools_misc(obj_t, obj_t, obj_t);
static obj_t _replace__98_tools_misc(obj_t, obj_t, obj_t);
static obj_t toplevel_init_63_tools_misc();
extern obj_t replace__160_tools_misc(obj_t, obj_t);
extern obj_t epairify_tools_misc(obj_t, obj_t);
obj_t _4dots_199_tools_misc = BUNSPEC;
static obj_t require_initialization_114_tools_misc = BUNSPEC;
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE(epairify_env_148_tools_misc, _epairify1016_tools_misc1021, _epairify1016_tools_misc, 0L, 2);
DEFINE_EXPORT_PROCEDURE(replace__env_157_tools_misc, _replace__98_tools_misc1022, _replace__98_tools_misc, 0L, 2);
DEFINE_STRING(string1019_tools_misc, string1019_tools_misc1023, "Type `extended pair' expected for expression", 44);
DEFINE_STRING(string1018_tools_misc, string1018_tools_misc1024, "cer", 3);
DEFINE_STRING(string1017_tools_misc, string1017_tools_misc1025, "::", 2);



/* module-initialization */
obj_t 
module_initialization_70_tools_misc(long checksum_43, char *from_44)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_tools_misc))
	{
	   require_initialization_114_tools_misc =
	      BBOOL(((bool_t) 0));
	   toplevel_init_63_tools_misc();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_tools_misc()
{
   AN_OBJECT;
   {	/* Tools/misc.scm 14 */
      {		/* ./Ieee/symbol.scm 6027 */
	 char *aux_49;
	 aux_49 =
	    BSTRING_TO_STRING(string1017_tools_misc);
	 return (
	    _4dots_199_tools_misc =
	    string_to_symbol(aux_49), BUNSPEC);
      }
   }
}



/* replace! */
obj_t 
replace__160_tools_misc(obj_t p1_1, obj_t p2_2)
{
   AN_OBJECT;
   {	/* Tools/misc.scm 22 */
      {		/* Tools/misc.scm 23 */
	 bool_t test1002_5;
	 if (
	    PAIRP(p1_1))
	   {	/* Tools/misc.scm 23 */
	      if (
		 PAIRP(p2_2))
		{	/* Tools/misc.scm 23 */
		   bool_t test1007_10;
		   test1007_10 =
		      EXTENDED_PAIRP(p2_2);
		   if (test1007_10)
		     {	/* Tools/misc.scm 23 */
			test1002_5 = ((bool_t) 0);
		     }
		   else
		     {	/* Tools/misc.scm 23 */
			test1002_5 = ((bool_t) 1);
		     }
		}
	      else
		{	/* Tools/misc.scm 23 */
		   test1002_5 = ((bool_t) 0);
		}
	   }
	 else
	   {	/* Tools/misc.scm 23 */
	      test1002_5 = ((bool_t) 0);
	   }
	 if (test1002_5)
	   {	/* Tools/misc.scm 23 */
	      {		/* ./Ieee/pair-list.scm 5890 */
		 obj_t aux_59;
		 aux_59 =
		    CAR(p2_2);
		 SET_CAR(p1_1, aux_59);
	      }
	      {		/* ./Ieee/pair-list.scm 5896 */
		 obj_t aux_62;
		 aux_62 =
		    CDR(p2_2);
		 SET_CDR(p1_1, aux_62);
	      }
	      return p1_1;
	   }
	 else
	   {	/* Tools/misc.scm 23 */
	      return p2_2;
	   }
      }
   }
}



/* _replace! */
obj_t 
_replace__98_tools_misc(obj_t env_37, obj_t p1_38, obj_t p2_39)
{
   AN_OBJECT;
   {	/* Tools/misc.scm 22 */
      return
	 replace__160_tools_misc(p1_38, p2_39);
   }
}



/* epairify */
obj_t 
epairify_tools_misc(obj_t pair_3, obj_t epair_4)
{
   AN_OBJECT;
   {	/* Tools/misc.scm 43 */
      {		/* Tools/misc.scm 44 */
	 bool_t test1009_11;
	 test1009_11 =
	    EXTENDED_PAIRP(epair_4);
	 if (test1009_11)
	   {	/* Tools/misc.scm 45 */
	      obj_t arg1010_12;
	      obj_t arg1013_13;
	      obj_t arg1015_14;
	      arg1010_12 =
		 CAR(pair_3);
	      arg1013_13 =
		 CDR(pair_3);
	      {		/* ./Ieee/pair-list.scm 5713 */
		 bool_t test1136_29;
		 test1136_29 =
		    EXTENDED_PAIRP(epair_4);
		 if (test1136_29)
		   {	/* ./Ieee/pair-list.scm 5713 */
		      arg1015_14 =
			 CER(epair_4);
		   }
		 else
		   {	/* ./Ieee/pair-list.scm 5713 */
		      FAILURE(string1018_tools_misc, string1019_tools_misc, epair_4);
		   }
	      }
	      return
		 MAKE_EXTENDED_PAIR(arg1010_12, arg1013_13, arg1015_14);
	   }
	 else
	   {	/* Tools/misc.scm 44 */
	      return pair_3;
	   }
      }
   }
}



/* _epairify1016 */
obj_t 
_epairify1016_tools_misc(obj_t env_40, obj_t pair_41, obj_t epair_42)
{
   AN_OBJECT;
   {	/* Tools/misc.scm 43 */
      return
	 epairify_tools_misc(pair_41, epair_42);
   }
}
