/*===========================================================================*/
/*   (Type/cache.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;


obj_t _long__149_type_cache = BUNSPEC;
static obj_t method_init_76_type_cache();
obj_t _symbol__163_type_cache = BUNSPEC;
obj_t _bint__73_type_cache = BUNSPEC;
extern obj_t type_type_type;
obj_t _void__134_type_cache = BUNSPEC;
static obj_t _object__253_type_cache = BUNSPEC;
static obj_t _get_default_type_60_type_cache(obj_t);
static obj_t _default_type__236_type_cache = BUNSPEC;
obj_t _pair__244_type_cache = BUNSPEC;
obj_t _obj__252_type_cache = BUNSPEC;
extern obj_t get_object_type_154_type_cache();
obj_t _cell__121_type_cache = BUNSPEC;
obj_t _magic__144_type_cache = BUNSPEC;
extern bool_t is_a__118___object(obj_t, obj_t);
obj_t _unspec__87_type_cache = BUNSPEC;
extern type_bglt get_default_type_181_type_cache();
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
obj_t _bnil__15_type_cache = BUNSPEC;
static obj_t _install_type_cache__49_type_cache(obj_t);
extern type_bglt get_default_c_type_186_type_cache();
static obj_t _get_object_type_254_type_cache(obj_t);
extern type_bglt find_type_26_type_env(obj_t);
obj_t _real__144_type_cache = BUNSPEC;
static obj_t imported_modules_init_94_type_cache();
obj_t _keyword__63_type_cache = BUNSPEC;
extern bool_t type_exists__12_type_env(obj_t);
static obj_t _set_default_type__33_type_cache(obj_t, obj_t);
static obj_t library_modules_init_112_type_cache();
obj_t _pair_nil__157_type_cache = BUNSPEC;
extern obj_t install_type_cache__77_type_cache();
extern obj_t set_default_type__106_type_cache(type_bglt);
extern type_bglt use_type__231_type_env(obj_t, obj_t);
static obj_t toplevel_init_63_type_cache();
extern obj_t open_input_string(obj_t);
obj_t _cobj__54_type_cache = BUNSPEC;
obj_t _bbool__55_type_cache = BUNSPEC;
obj_t _bstring__127_type_cache = BUNSPEC;
obj_t _exit__255_type_cache = BUNSPEC;
obj_t _procedure__226_type_cache = BUNSPEC;
extern obj_t read___reader(obj_t);
obj_t _char__84_type_cache = BUNSPEC;
static obj_t _get_default_c_type_215_type_cache(obj_t);
obj_t _string__3_type_cache = BUNSPEC;
obj_t ____74_type_cache = BUNSPEC;
static obj_t require_initialization_114_type_cache = BUNSPEC;
obj_t _vector__240_type_cache = BUNSPEC;
obj_t _struct__183_type_cache = BUNSPEC;
static obj_t cnst_init_137_type_cache();
obj_t _int__35_type_cache = BUNSPEC;
obj_t _bool__149_type_cache = BUNSPEC;
static obj_t __cnst[27];

DEFINE_EXPORT_PROCEDURE(set_default_type__env_17_type_cache, _set_default_type__33_type_cache1042, _set_default_type__33_type_cache, 0L, 1);
DEFINE_EXPORT_PROCEDURE(get_default_c_type_env_196_type_cache, _get_default_c_type_215_type_cache1043, _get_default_c_type_215_type_cache, 0L, 0);
DEFINE_EXPORT_PROCEDURE(get_default_type_env_60_type_cache, _get_default_type_60_type_cache1044, _get_default_type_60_type_cache, 0L, 0);
DEFINE_EXPORT_PROCEDURE(get_object_type_env_58_type_cache, _get_object_type_254_type_cache1045, _get_object_type_254_type_cache, 0L, 0);
DEFINE_EXPORT_PROCEDURE(install_type_cache__env_169_type_cache, _install_type_cache__49_type_cache1046, _install_type_cache__49_type_cache, 0L, 0);
DEFINE_STRING(string1036_type_cache, string1036_type_cache1047, "_ OBJECT EXIT UNSPECIFIED PROCEDURE STRUCT VECTOR KEYWORD SYMBOL BSTRING STRING NIL PAIR-NIL PAIR UCHAR DOUBLE BBOOL BOOL LONG INT BINT VOID MAGIC CELL COBJ OBJ NO-TYPE-YET ", 173);



/* module-initialization */
obj_t 
module_initialization_70_type_cache(long checksum_86, char *from_87)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_type_cache))
	{
	   require_initialization_114_type_cache =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_type_cache();
	   cnst_init_137_type_cache();
	   imported_modules_init_94_type_cache();
	   method_init_76_type_cache();
	   toplevel_init_63_type_cache();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_type_cache()
{
   AN_OBJECT;
   {	/* Type/cache.scm 14 */
      module_initialization_70___object(((long) 0), "TYPE_CACHE");
      module_initialization_70___reader(((long) 0), "TYPE_CACHE");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_type_cache()
{
   AN_OBJECT;
   {	/* Type/cache.scm 14 */
      {		/* Type/cache.scm 14 */
	 obj_t cnst_port_138_79;
	 cnst_port_138_79 =
	    open_input_string(string1036_type_cache);
	 {
	    long i_80;
	    i_80 = ((long) 26);
	  loop_81:
	    {	/* Type/cache.scm 14 */
	       bool_t test1038_82;
	       test1038_82 =
		  (i_80 == ((long) -1));
	       if (test1038_82)
		 {	/* Type/cache.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Type/cache.scm 14 */
		    {	/* Type/cache.scm 14 */
		       obj_t arg1039_83;
		       {	/* Type/cache.scm 14 */
			  obj_t list1040_84;
			  list1040_84 =
			     MAKE_PAIR(cnst_port_138_79, BNIL);
			  arg1039_83 =
			     read___reader(list1040_84);
		       }
		       CNST_TABLE_SET(i_80, arg1039_83);
		    }
		    {	/* Type/cache.scm 14 */
		       int aux_85;
		       {	/* Type/cache.scm 14 */
			  long aux_104;
			  aux_104 =
			     (i_80 - ((long) 1));
			  aux_85 =
			     (int) (aux_104);
		       }
		       {
			  long i_107;
			  i_107 =
			     (long) (aux_85);
			  i_80 = i_107;
			  goto loop_81;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_type_cache()
{
   AN_OBJECT;
   {	/* Type/cache.scm 14 */
      _obj__252_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _cobj__54_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _cell__121_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _magic__144_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _void__134_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _bint__73_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _int__35_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _long__149_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _bool__149_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _bbool__55_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _real__144_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _char__84_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _string__3_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _bstring__127_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _symbol__163_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _keyword__63_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _pair__244_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _pair_nil__157_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _bnil__15_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _vector__240_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _struct__183_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _procedure__226_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _unspec__87_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _exit__255_type_cache =
	 CNST_TABLE_REF(((long) 0));
      _object__253_type_cache =
	 CNST_TABLE_REF(((long) 0));
      ____74_type_cache =
	 CNST_TABLE_REF(((long) 0));
      return (
	 _default_type__236_type_cache =
	 CNST_TABLE_REF(((long) 0)), BUNSPEC);
   }
}



/* install-type-cache! */
obj_t 
install_type_cache__77_type_cache()
{
   AN_OBJECT;
   {	/* Type/cache.scm 51 */
      {		/* Type/cache.scm 52 */
	 type_bglt aux_136;
	 aux_136 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 1)), BFALSE);
	 _obj__252_type_cache =
	    (obj_t) (aux_136);
      }
      {		/* Type/cache.scm 53 */
	 type_bglt aux_140;
	 aux_140 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 2)), BFALSE);
	 _cobj__54_type_cache =
	    (obj_t) (aux_140);
      }
      {		/* Type/cache.scm 54 */
	 type_bglt aux_144;
	 aux_144 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 3)), BFALSE);
	 _cell__121_type_cache =
	    (obj_t) (aux_144);
      }
      {		/* Type/cache.scm 55 */
	 type_bglt aux_148;
	 aux_148 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 4)), BFALSE);
	 _magic__144_type_cache =
	    (obj_t) (aux_148);
      }
      {		/* Type/cache.scm 56 */
	 type_bglt aux_152;
	 aux_152 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 5)), BFALSE);
	 _void__134_type_cache =
	    (obj_t) (aux_152);
      }
      {		/* Type/cache.scm 57 */
	 type_bglt aux_156;
	 aux_156 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 6)), BFALSE);
	 _bint__73_type_cache =
	    (obj_t) (aux_156);
      }
      {		/* Type/cache.scm 58 */
	 type_bglt aux_160;
	 aux_160 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 7)), BFALSE);
	 _int__35_type_cache =
	    (obj_t) (aux_160);
      }
      {		/* Type/cache.scm 59 */
	 type_bglt aux_164;
	 aux_164 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 8)), BFALSE);
	 _long__149_type_cache =
	    (obj_t) (aux_164);
      }
      {		/* Type/cache.scm 60 */
	 type_bglt aux_168;
	 aux_168 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 9)), BFALSE);
	 _bool__149_type_cache =
	    (obj_t) (aux_168);
      }
      {		/* Type/cache.scm 61 */
	 type_bglt aux_172;
	 aux_172 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 10)), BFALSE);
	 _bbool__55_type_cache =
	    (obj_t) (aux_172);
      }
      {		/* Type/cache.scm 62 */
	 type_bglt aux_176;
	 aux_176 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 11)), BFALSE);
	 _real__144_type_cache =
	    (obj_t) (aux_176);
      }
      {		/* Type/cache.scm 63 */
	 type_bglt aux_180;
	 aux_180 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 12)), BFALSE);
	 _char__84_type_cache =
	    (obj_t) (aux_180);
      }
      {		/* Type/cache.scm 64 */
	 type_bglt aux_184;
	 aux_184 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 13)), BFALSE);
	 _pair__244_type_cache =
	    (obj_t) (aux_184);
      }
      {		/* Type/cache.scm 65 */
	 type_bglt aux_188;
	 aux_188 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 14)), BFALSE);
	 _pair_nil__157_type_cache =
	    (obj_t) (aux_188);
      }
      {		/* Type/cache.scm 66 */
	 type_bglt aux_192;
	 aux_192 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 15)), BFALSE);
	 _bnil__15_type_cache =
	    (obj_t) (aux_192);
      }
      {		/* Type/cache.scm 67 */
	 type_bglt aux_196;
	 aux_196 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 16)), BFALSE);
	 _string__3_type_cache =
	    (obj_t) (aux_196);
      }
      {		/* Type/cache.scm 68 */
	 type_bglt aux_200;
	 aux_200 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 17)), BFALSE);
	 _bstring__127_type_cache =
	    (obj_t) (aux_200);
      }
      {		/* Type/cache.scm 69 */
	 type_bglt aux_204;
	 aux_204 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 18)), BFALSE);
	 _symbol__163_type_cache =
	    (obj_t) (aux_204);
      }
      {		/* Type/cache.scm 70 */
	 type_bglt aux_208;
	 aux_208 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 19)), BFALSE);
	 _keyword__63_type_cache =
	    (obj_t) (aux_208);
      }
      {		/* Type/cache.scm 71 */
	 type_bglt aux_212;
	 aux_212 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 20)), BFALSE);
	 _vector__240_type_cache =
	    (obj_t) (aux_212);
      }
      {		/* Type/cache.scm 72 */
	 type_bglt aux_216;
	 aux_216 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 21)), BFALSE);
	 _struct__183_type_cache =
	    (obj_t) (aux_216);
      }
      {		/* Type/cache.scm 73 */
	 type_bglt aux_220;
	 aux_220 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 22)), BFALSE);
	 _procedure__226_type_cache =
	    (obj_t) (aux_220);
      }
      {		/* Type/cache.scm 74 */
	 type_bglt aux_224;
	 aux_224 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 23)), BFALSE);
	 _unspec__87_type_cache =
	    (obj_t) (aux_224);
      }
      {		/* Type/cache.scm 75 */
	 type_bglt aux_228;
	 aux_228 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 24)), BFALSE);
	 _exit__255_type_cache =
	    (obj_t) (aux_228);
      }
      {		/* Type/cache.scm 76 */
	 bool_t test1030_53;
	 test1030_53 =
	    type_exists__12_type_env(
	    CNST_TABLE_REF(((long) 25)));
	 if (test1030_53)
	   {	/* Type/cache.scm 77 */
	      type_bglt aux_235;
	      aux_235 =
		 find_type_26_type_env(
		 CNST_TABLE_REF(((long) 25)));
	      _object__253_type_cache =
		 (obj_t) (aux_235);
	   }
	 else
	   {	/* Type/cache.scm 76 */
	      _object__253_type_cache = BFALSE;
	   }
      }
      {		/* Type/cache.scm 79 */
	 type_bglt aux_239;
	 aux_239 =
	    use_type__231_type_env(
	    CNST_TABLE_REF(((long) 26)), BFALSE);
	 ____74_type_cache =
	    (obj_t) (aux_239);
      }
      return (
	 _default_type__236_type_cache = ____74_type_cache, BUNSPEC);
   }
}



/* _install-type-cache! */
obj_t 
_install_type_cache__49_type_cache(obj_t env_73)
{
   AN_OBJECT;
   {	/* Type/cache.scm 51 */
      return
	 install_type_cache__77_type_cache();
   }
}



/* get-default-type */
type_bglt 
get_default_type_181_type_cache()
{
   AN_OBJECT;
   {	/* Type/cache.scm 120 */
      return
	 (type_bglt) (_default_type__236_type_cache);
   }
}



/* _get-default-type */
obj_t 
_get_default_type_60_type_cache(obj_t env_74)
{
   AN_OBJECT;
   {	/* Type/cache.scm 120 */
      {		/* Type/cache.scm 120 */
	 type_bglt aux_245;
	 aux_245 =
	    get_default_type_181_type_cache();
	 return
	    (obj_t) (aux_245);
      }
   }
}



/* set-default-type! */
obj_t 
set_default_type__106_type_cache(type_bglt type_1)
{
   AN_OBJECT;
   {	/* Type/cache.scm 126 */
      return (
	 _default_type__236_type_cache =
	 (obj_t) (type_1), BUNSPEC);
   }
}



/* _set-default-type! */
obj_t 
_set_default_type__33_type_cache(obj_t env_75, obj_t type_76)
{
   AN_OBJECT;
   {	/* Type/cache.scm 126 */
      return
	 set_default_type__106_type_cache(
	 (type_bglt) (type_76));
   }
}



/* get-object-type */
obj_t 
get_object_type_154_type_cache()
{
   AN_OBJECT;
   {	/* Type/cache.scm 132 */
      {		/* Type/cache.scm 134 */
	 bool_t test1031_54;
	 {	/* Type/cache.scm 134 */
	    obj_t obj_72;
	    obj_72 = _object__253_type_cache;
	    test1031_54 =
	       is_a__118___object(obj_72, type_type_type);
	 }
	 if (test1031_54)
	   {	/* Type/cache.scm 134 */
	      return _object__253_type_cache;
	   }
	 else
	   {	/* Type/cache.scm 134 */
	      {		/* Type/cache.scm 137 */
		 type_bglt aux_253;
		 aux_253 =
		    find_type_26_type_env(
		    CNST_TABLE_REF(((long) 25)));
		 _object__253_type_cache =
		    (obj_t) (aux_253);
	      }
	      return _object__253_type_cache;
	   }
      }
   }
}



/* _get-object-type */
obj_t 
_get_object_type_254_type_cache(obj_t env_77)
{
   AN_OBJECT;
   {	/* Type/cache.scm 132 */
      return
	 get_object_type_154_type_cache();
   }
}



/* get-default-c-type */
type_bglt 
get_default_c_type_186_type_cache()
{
   AN_OBJECT;
   {	/* Type/cache.scm 145 */
      return
	 (type_bglt) (_int__35_type_cache);
   }
}



/* _get-default-c-type */
obj_t 
_get_default_c_type_215_type_cache(obj_t env_78)
{
   AN_OBJECT;
   {	/* Type/cache.scm 145 */
      {		/* Type/cache.scm 145 */
	 type_bglt aux_259;
	 aux_259 =
	    get_default_c_type_186_type_cache();
	 return
	    (obj_t) (aux_259);
      }
   }
}



/* method-init */
obj_t 
method_init_76_type_cache()
{
   AN_OBJECT;
   {	/* Type/cache.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_type_cache()
{
   AN_OBJECT;
   {	/* Type/cache.scm 14 */
      module_initialization_70_type_type(((long) 0), "TYPE_CACHE");
      return
	 module_initialization_70_type_env(((long) 0), "TYPE_CACHE");
   }
}
