/*===========================================================================*/
/*   (Ieee/boolean.scm)                                                      */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo2.1a.h>
#include <signal.h>

extern bool_t not___r4_booleans_6_1(obj_t);
static obj_t _boolean__157___r4_booleans_6_1(obj_t, obj_t);
extern obj_t string_to_symbol(char *);
extern obj_t module_initialization_70___r4_booleans_6_1(long, char *);
static obj_t symbol1098___r4_booleans_6_1 = BUNSPEC;
static obj_t symbol1097___r4_booleans_6_1 = BUNSPEC;
extern bool_t boolean__35___r4_booleans_6_1(obj_t);
static obj_t _not___r4_booleans_6_1(obj_t, obj_t);
static obj_t require_initialization_114___r4_booleans_6_1 = BUNSPEC;
static obj_t cnst_init_137___r4_booleans_6_1();
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( boolean__env_44___r4_booleans_6_1, _boolean__157___r4_booleans_6_11102, _boolean__157___r4_booleans_6_1, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( not_env_16___r4_booleans_6_1, _not___r4_booleans_6_11103, _not___r4_booleans_6_1, 0L, 1 );



/* module-initialization */
obj_t module_initialization_70___r4_booleans_6_1(long checksum_229, char * from_230)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___r4_booleans_6_1))
{ 
require_initialization_114___r4_booleans_6_1 = 
BBOOL(((bool_t)0)); 
cnst_init_137___r4_booleans_6_1(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___r4_booleans_6_1()
{ AN_OBJECT;
{ /* Ieee/boolean.scm 14 */
symbol1097___r4_booleans_6_1 = 
string_to_symbol("NOT"); 
return ( 
symbol1098___r4_booleans_6_1 = 
string_to_symbol("BOOLEAN?"), BUNSPEC) ;} 
}



/* not */
bool_t not___r4_booleans_6_1(obj_t obj_1)
{ AN_OBJECT;
{ /* Ieee/boolean.scm 41 */
{ /* Ieee/boolean.scm 42 */
obj_t symbol1094_217;
symbol1094_217 = symbol1097___r4_booleans_6_1; 
{ /* Ieee/boolean.scm 42 */

PUSH_TRACE(symbol1094_217); BUNSPEC; 
{ /* Ieee/boolean.scm 42 */
bool_t aux1093_218;
if(
CBOOL(obj_1))
{ /* Ieee/boolean.scm 42 */
aux1093_218 = ((bool_t)0); }  else 
{ /* Ieee/boolean.scm 42 */
aux1093_218 = ((bool_t)1); } 
POP_TRACE(); 
return aux1093_218;} } } } 
}



/* _not */
obj_t _not___r4_booleans_6_1(obj_t env_213, obj_t obj_214)
{ AN_OBJECT;
{ /* Ieee/boolean.scm 41 */
{ /* Ieee/boolean.scm 41 */
bool_t aux_241;
{ /* Ieee/boolean.scm 41 */
bool_t res1099_222;
{ /* Ieee/boolean.scm 41 */
obj_t obj_219;
obj_219 = obj_214; 
{ /* Ieee/boolean.scm 42 */
obj_t symbol1094_220;
symbol1094_220 = symbol1097___r4_booleans_6_1; 
{ /* Ieee/boolean.scm 42 */

PUSH_TRACE(symbol1094_220); BUNSPEC; 
{ /* Ieee/boolean.scm 42 */
bool_t aux1093_221;
if(
CBOOL(obj_219))
{ /* Ieee/boolean.scm 42 */
aux1093_221 = ((bool_t)0); }  else 
{ /* Ieee/boolean.scm 42 */
aux1093_221 = ((bool_t)1); } 
POP_TRACE(); 
res1099_222 = aux1093_221; } } } } 
aux_241 = res1099_222; } 
return 
BBOOL(aux_241);} } 
}



/* boolean? */
bool_t boolean__35___r4_booleans_6_1(obj_t obj_2)
{ AN_OBJECT;
{ /* Ieee/boolean.scm 47 */
{ /* Ieee/boolean.scm 48 */
obj_t symbol1096_223;
symbol1096_223 = symbol1098___r4_booleans_6_1; 
{ /* Ieee/boolean.scm 48 */

PUSH_TRACE(symbol1096_223); BUNSPEC; 
{ /* Ieee/boolean.scm 48 */
bool_t aux1095_224;
aux1095_224 = 
BOOLEANP(obj_2); 
POP_TRACE(); 
return aux1095_224;} } } } 
}



/* _boolean? */
obj_t _boolean__157___r4_booleans_6_1(obj_t env_215, obj_t obj_216)
{ AN_OBJECT;
{ /* Ieee/boolean.scm 47 */
{ /* Ieee/boolean.scm 47 */
bool_t aux_250;
{ /* Ieee/boolean.scm 47 */
bool_t res1100_228;
{ /* Ieee/boolean.scm 47 */
obj_t obj_225;
obj_225 = obj_216; 
{ /* Ieee/boolean.scm 48 */
obj_t symbol1096_226;
symbol1096_226 = symbol1098___r4_booleans_6_1; 
{ /* Ieee/boolean.scm 48 */

PUSH_TRACE(symbol1096_226); BUNSPEC; 
{ /* Ieee/boolean.scm 48 */
bool_t aux1095_227;
aux1095_227 = 
BOOLEANP(obj_225); 
POP_TRACE(); 
res1100_228 = aux1095_227; } } } } 
aux_250 = res1100_228; } 
return 
BBOOL(aux_250);} } 
}

