/*===========================================================================*/
/*   (Ieee/control5.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t string_to_symbol(char *);
static obj_t symbol1199___r5_control_features_6_4 = BUNSPEC;
static obj_t symbol1197___r5_control_features_6_4 = BUNSPEC;
static obj_t symbol1204___r5_control_features_6_4 = BUNSPEC;
static obj_t symbol1193___r5_control_features_6_4 = BUNSPEC;
static obj_t symbol1192___r5_control_features_6_4 = BUNSPEC;
static obj_t symbol1202___r5_control_features_6_4 = BUNSPEC;
static obj_t symbol1191___r5_control_features_6_4 = BUNSPEC;
static obj_t symbol1201___r5_control_features_6_4 = BUNSPEC;
static obj_t symbol1187___r5_control_features_6_4 = BUNSPEC;
static obj_t symbol1186___r5_control_features_6_4 = BUNSPEC;
static obj_t symbol1185___r5_control_features_6_4 = BUNSPEC;
static obj_t symbol1182___r5_control_features_6_4 = BUNSPEC;
static obj_t symbol1179___r5_control_features_6_4 = BUNSPEC;
static obj_t symbol1178___r5_control_features_6_4 = BUNSPEC;
static obj_t toplevel_init_63___r5_control_features_6_4();
static obj_t list1198___r5_control_features_6_4 = BUNSPEC;
static obj_t list1196___r5_control_features_6_4 = BUNSPEC;
static obj_t list1195___r5_control_features_6_4 = BUNSPEC;
static obj_t list1194___r5_control_features_6_4 = BUNSPEC;
static obj_t list1190___r5_control_features_6_4 = BUNSPEC;
static obj_t list1200___r5_control_features_6_4 = BUNSPEC;
static obj_t list1184___r5_control_features_6_4 = BUNSPEC;
static obj_t _call_with_values1133_119___r5_control_features_6_4(obj_t, obj_t, obj_t);
obj_t _res3__194___r5_control_features_6_4 = BUNSPEC;
obj_t _res2__167___r5_control_features_6_4 = BUNSPEC;
obj_t _res1__155___r5_control_features_6_4 = BUNSPEC;
extern obj_t values___r5_control_features_6_4(obj_t);
extern obj_t bigloo_type_error_location_103___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t module_initialization_70___r5_control_features_6_4(long, char *);
extern obj_t module_initialization_70___error(long, char *);
obj_t _res_number__75___r5_control_features_6_4 = BUNSPEC;
static obj_t _values___r5_control_features_6_4(obj_t, obj_t);
extern obj_t error_location_112___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern long list_length(obj_t);
extern obj_t call_with_values_2___r5_control_features_6_4(obj_t, obj_t);
static obj_t imported_modules_init_94___r5_control_features_6_4();
static obj_t require_initialization_114___r5_control_features_6_4 = BUNSPEC;
static obj_t cnst_init_137___r5_control_features_6_4();
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( call_with_values_env_146___r5_control_features_6_4, _call_with_values1133_119___r5_control_features_6_41206, _call_with_values1133_119___r5_control_features_6_4, 0L, 2 );
DEFINE_STRING( string1203___r5_control_features_6_4, string1203___r5_control_features_6_41207, "PROCEDURE", 9 );
DEFINE_STRING( string1189___r5_control_features_6_4, string1189___r5_control_features_6_41208, "Wrong number of arguments", 25 );
DEFINE_STRING( string1188___r5_control_features_6_4, string1188___r5_control_features_6_41209, "LONG", 4 );
DEFINE_STRING( string1183___r5_control_features_6_4, string1183___r5_control_features_6_41210, "CALL-WITH-VALUES:Wrong number of arguments", 42 );
DEFINE_STRING( string1181___r5_control_features_6_4, string1181___r5_control_features_6_41211, "/home/tahoe2/serrano/tmp/bigloo/runtime/Ieee/control5.scm", 57 );
DEFINE_STRING( string1180___r5_control_features_6_4, string1180___r5_control_features_6_41212, "PAIR", 4 );
DEFINE_EXPORT_PROCEDURE( values_env_201___r5_control_features_6_4, _values___r5_control_features_6_41213, va_generic_entry, _values___r5_control_features_6_4, -1 );



/* module-initialization */
obj_t module_initialization_70___r5_control_features_6_4(long checksum_391, char * from_392)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___r5_control_features_6_4))
{ 
require_initialization_114___r5_control_features_6_4 = 
BBOOL(((bool_t)0)); 
cnst_init_137___r5_control_features_6_4(); 
imported_modules_init_94___r5_control_features_6_4(); 
toplevel_init_63___r5_control_features_6_4(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___r5_control_features_6_4()
{ AN_OBJECT;
{ /* Ieee/control5.scm 14 */
symbol1178___r5_control_features_6_4 = 
string_to_symbol("@__R5_CONTROL_FEATURES_6_4"); 
symbol1179___r5_control_features_6_4 = 
string_to_symbol("VALUES"); 
symbol1182___r5_control_features_6_4 = 
string_to_symbol("CALL-WITH-VALUES"); 
symbol1185___r5_control_features_6_4 = 
string_to_symbol("FUNCALL"); 
symbol1186___r5_control_features_6_4 = 
string_to_symbol("producer"); 
{ /* Ieee/control5.scm 89 */
obj_t aux_404;
{ /* Ieee/control5.scm 89 */
obj_t aux_405;
aux_405 = 
MAKE_PAIR(symbol1186___r5_control_features_6_4, BNIL); 
aux_404 = 
MAKE_PAIR(symbol1186___r5_control_features_6_4, aux_405); } 
list1184___r5_control_features_6_4 = 
MAKE_PAIR(symbol1185___r5_control_features_6_4, aux_404); } 
symbol1187___r5_control_features_6_4 = 
string_to_symbol("_"); 
symbol1191___r5_control_features_6_4 = 
string_to_symbol("APPLY"); 
symbol1192___r5_control_features_6_4 = 
string_to_symbol("consumer"); 
symbol1193___r5_control_features_6_4 = 
string_to_symbol("res0"); 
{ /* Ieee/control5.scm 92 */
obj_t aux_413;
{ /* Ieee/control5.scm 92 */
obj_t aux_414;
aux_414 = 
MAKE_PAIR(symbol1193___r5_control_features_6_4, BNIL); 
aux_413 = 
MAKE_PAIR(symbol1192___r5_control_features_6_4, aux_414); } 
list1190___r5_control_features_6_4 = 
MAKE_PAIR(symbol1191___r5_control_features_6_4, aux_413); } 
{ /* Ieee/control5.scm 94 */
obj_t aux_418;
{ /* Ieee/control5.scm 94 */
obj_t aux_419;
aux_419 = 
MAKE_PAIR(symbol1192___r5_control_features_6_4, BNIL); 
aux_418 = 
MAKE_PAIR(symbol1192___r5_control_features_6_4, aux_419); } 
list1194___r5_control_features_6_4 = 
MAKE_PAIR(symbol1185___r5_control_features_6_4, aux_418); } 
{ /* Ieee/control5.scm 96 */
obj_t aux_423;
{ /* Ieee/control5.scm 96 */
obj_t aux_424;
{ /* Ieee/control5.scm 96 */
obj_t aux_425;
aux_425 = 
MAKE_PAIR(symbol1193___r5_control_features_6_4, BNIL); 
aux_424 = 
MAKE_PAIR(symbol1192___r5_control_features_6_4, aux_425); } 
aux_423 = 
MAKE_PAIR(symbol1192___r5_control_features_6_4, aux_424); } 
list1195___r5_control_features_6_4 = 
MAKE_PAIR(symbol1185___r5_control_features_6_4, aux_423); } 
symbol1197___r5_control_features_6_4 = 
string_to_symbol("*res1*"); 
{ /* Ieee/control5.scm 98 */
obj_t aux_431;
{ /* Ieee/control5.scm 98 */
obj_t aux_432;
{ /* Ieee/control5.scm 98 */
obj_t aux_433;
{ /* Ieee/control5.scm 98 */
obj_t aux_434;
aux_434 = 
MAKE_PAIR(symbol1197___r5_control_features_6_4, BNIL); 
aux_433 = 
MAKE_PAIR(symbol1193___r5_control_features_6_4, aux_434); } 
aux_432 = 
MAKE_PAIR(symbol1192___r5_control_features_6_4, aux_433); } 
aux_431 = 
MAKE_PAIR(symbol1192___r5_control_features_6_4, aux_432); } 
list1196___r5_control_features_6_4 = 
MAKE_PAIR(symbol1185___r5_control_features_6_4, aux_431); } 
symbol1199___r5_control_features_6_4 = 
string_to_symbol("*res2*"); 
{ /* Ieee/control5.scm 100 */
obj_t aux_441;
{ /* Ieee/control5.scm 100 */
obj_t aux_442;
{ /* Ieee/control5.scm 100 */
obj_t aux_443;
{ /* Ieee/control5.scm 100 */
obj_t aux_444;
{ /* Ieee/control5.scm 100 */
obj_t aux_445;
aux_445 = 
MAKE_PAIR(symbol1199___r5_control_features_6_4, BNIL); 
aux_444 = 
MAKE_PAIR(symbol1197___r5_control_features_6_4, aux_445); } 
aux_443 = 
MAKE_PAIR(symbol1193___r5_control_features_6_4, aux_444); } 
aux_442 = 
MAKE_PAIR(symbol1192___r5_control_features_6_4, aux_443); } 
aux_441 = 
MAKE_PAIR(symbol1192___r5_control_features_6_4, aux_442); } 
list1198___r5_control_features_6_4 = 
MAKE_PAIR(symbol1185___r5_control_features_6_4, aux_441); } 
symbol1201___r5_control_features_6_4 = 
string_to_symbol("*res3*"); 
{ /* Ieee/control5.scm 102 */
obj_t aux_453;
{ /* Ieee/control5.scm 102 */
obj_t aux_454;
{ /* Ieee/control5.scm 102 */
obj_t aux_455;
{ /* Ieee/control5.scm 102 */
obj_t aux_456;
{ /* Ieee/control5.scm 102 */
obj_t aux_457;
{ /* Ieee/control5.scm 102 */
obj_t aux_458;
aux_458 = 
MAKE_PAIR(symbol1201___r5_control_features_6_4, BNIL); 
aux_457 = 
MAKE_PAIR(symbol1199___r5_control_features_6_4, aux_458); } 
aux_456 = 
MAKE_PAIR(symbol1197___r5_control_features_6_4, aux_457); } 
aux_455 = 
MAKE_PAIR(symbol1193___r5_control_features_6_4, aux_456); } 
aux_454 = 
MAKE_PAIR(symbol1192___r5_control_features_6_4, aux_455); } 
aux_453 = 
MAKE_PAIR(symbol1192___r5_control_features_6_4, aux_454); } 
list1200___r5_control_features_6_4 = 
MAKE_PAIR(symbol1185___r5_control_features_6_4, aux_453); } 
symbol1202___r5_control_features_6_4 = 
string_to_symbol("_CALL-WITH-VALUES1133"); 
return ( 
symbol1204___r5_control_features_6_4 = 
string_to_symbol("IMPORTED-MODULES-INIT"), BUNSPEC) ;} 
}



/* toplevel-init */
obj_t toplevel_init_63___r5_control_features_6_4()
{ AN_OBJECT;
{ /* Ieee/control5.scm 14 */
{ /* Ieee/control5.scm 14 */
obj_t symbol1126_322;
symbol1126_322 = symbol1178___r5_control_features_6_4; 
{ /* Ieee/control5.scm 14 */

PUSH_TRACE(symbol1126_322); BUNSPEC; 
{ /* Ieee/control5.scm 14 */
obj_t aux1125_323;
_res_number__75___r5_control_features_6_4 = 
BINT(((long)1)); 
_res1__155___r5_control_features_6_4 = BUNSPEC; 
_res2__167___r5_control_features_6_4 = BUNSPEC; 
aux1125_323 = ( 
_res3__194___r5_control_features_6_4 = BUNSPEC, BUNSPEC) ; 
POP_TRACE(); 
return aux1125_323;} } } } 
}



/* values */
obj_t values___r5_control_features_6_4(obj_t args_1)
{ AN_OBJECT;
{ /* Ieee/control5.scm 52 */
{ /* Ieee/control5.scm 53 */
obj_t symbol1128_324;
symbol1128_324 = symbol1179___r5_control_features_6_4; 
{ /* Ieee/control5.scm 53 */

PUSH_TRACE(symbol1128_324); BUNSPEC; 
{ /* Ieee/control5.scm 53 */
obj_t aux1127_325;
{ /* Ieee/control5.scm 53 */
obj_t all_args_251_186;
all_args_251_186 = args_1; 
{ /* Ieee/control5.scm 54 */
bool_t test1004_187;
{ /* Ieee/control5.scm 54 */
obj_t obj_304;
obj_304 = args_1; 
test1004_187 = 
NULLP(obj_304); } 
if(test1004_187)
{ /* Ieee/control5.scm 54 */
aux1127_325 = ( 
_res_number__75___r5_control_features_6_4 = 
BINT(((long)0)), BUNSPEC) ; }  else 
{ /* Ieee/control5.scm 56 */
bool_t test1005_188;
{ /* Ieee/control5.scm 56 */
obj_t arg1010_194;
{ /* Ieee/control5.scm 56 */
obj_t pair_305;
{ /* Ieee/control5.scm 56 */
obj_t aux1134_335;
aux1134_335 = args_1; 
if(
PAIRP(aux1134_335))
{ /* Ieee/control5.scm 56 */
pair_305 = aux1134_335; }  else 
{ /* Ieee/control5.scm 56 */
bigloo_type_error_location_103___error(symbol1179___r5_control_features_6_4, string1180___r5_control_features_6_4, aux1134_335, string1181___r5_control_features_6_4, 
BINT(((long)2575))); 
exit( -1 );} } 
arg1010_194 = 
CDR(pair_305); } 
test1005_188 = 
NULLP(arg1010_194); } 
if(test1005_188)
{ /* Ieee/control5.scm 56 */
_res_number__75___r5_control_features_6_4 = 
BINT(((long)1)); 
{ /* Ieee/control5.scm 59 */
obj_t pair_307;
{ /* Ieee/control5.scm 59 */
obj_t aux1136_337;
aux1136_337 = args_1; 
if(
PAIRP(aux1136_337))
{ /* Ieee/control5.scm 59 */
pair_307 = aux1136_337; }  else 
{ /* Ieee/control5.scm 59 */
bigloo_type_error_location_103___error(symbol1179___r5_control_features_6_4, string1180___r5_control_features_6_4, aux1136_337, string1181___r5_control_features_6_4, 
BINT(((long)2634))); 
exit( -1 );} } 
aux1127_325 = 
CAR(pair_307); } }  else 
{ /* Ieee/control5.scm 60 */
obj_t res0_189;
{ /* Ieee/control5.scm 60 */
obj_t pair_308;
{ /* Ieee/control5.scm 60 */
obj_t aux1138_339;
aux1138_339 = args_1; 
if(
PAIRP(aux1138_339))
{ /* Ieee/control5.scm 60 */
pair_308 = aux1138_339; }  else 
{ /* Ieee/control5.scm 60 */
bigloo_type_error_location_103___error(symbol1179___r5_control_features_6_4, string1180___r5_control_features_6_4, aux1138_339, string1181___r5_control_features_6_4, 
BINT(((long)2662))); 
exit( -1 );} } 
res0_189 = 
CAR(pair_308); } 
{ /* Ieee/control5.scm 61 */
obj_t pair_309;
{ /* Ieee/control5.scm 61 */
obj_t aux1140_341;
aux1140_341 = args_1; 
if(
PAIRP(aux1140_341))
{ /* Ieee/control5.scm 61 */
pair_309 = aux1140_341; }  else 
{ /* Ieee/control5.scm 61 */
bigloo_type_error_location_103___error(symbol1179___r5_control_features_6_4, string1180___r5_control_features_6_4, aux1140_341, string1181___r5_control_features_6_4, 
BINT(((long)2693))); 
exit( -1 );} } 
args_1 = 
CDR(pair_309); } 
{ /* Ieee/control5.scm 62 */
obj_t pair_310;
{ /* Ieee/control5.scm 62 */
obj_t aux1142_343;
aux1142_343 = args_1; 
if(
PAIRP(aux1142_343))
{ /* Ieee/control5.scm 62 */
pair_310 = aux1142_343; }  else 
{ /* Ieee/control5.scm 62 */
bigloo_type_error_location_103___error(symbol1179___r5_control_features_6_4, string1180___r5_control_features_6_4, aux1142_343, string1181___r5_control_features_6_4, 
BINT(((long)2725))); 
exit( -1 );} } 
_res1__155___r5_control_features_6_4 = 
CAR(pair_310); } 
{ /* Ieee/control5.scm 63 */
obj_t pair_311;
{ /* Ieee/control5.scm 63 */
obj_t aux1144_345;
aux1144_345 = args_1; 
if(
PAIRP(aux1144_345))
{ /* Ieee/control5.scm 63 */
pair_311 = aux1144_345; }  else 
{ /* Ieee/control5.scm 63 */
bigloo_type_error_location_103___error(symbol1179___r5_control_features_6_4, string1180___r5_control_features_6_4, aux1144_345, string1181___r5_control_features_6_4, 
BINT(((long)2755))); 
exit( -1 );} } 
args_1 = 
CDR(pair_311); } 
{ /* Ieee/control5.scm 64 */
bool_t test1006_190;
{ /* Ieee/control5.scm 64 */
obj_t obj_312;
obj_312 = args_1; 
test1006_190 = 
PAIRP(obj_312); } 
if(test1006_190)
{ /* Ieee/control5.scm 64 */
{ /* Ieee/control5.scm 66 */
obj_t pair_313;
{ /* Ieee/control5.scm 66 */
obj_t aux1146_347;
aux1146_347 = args_1; 
if(
PAIRP(aux1146_347))
{ /* Ieee/control5.scm 66 */
pair_313 = aux1146_347; }  else 
{ /* Ieee/control5.scm 66 */
bigloo_type_error_location_103___error(symbol1179___r5_control_features_6_4, string1180___r5_control_features_6_4, aux1146_347, string1181___r5_control_features_6_4, 
BINT(((long)2822))); 
exit( -1 );} } 
_res2__167___r5_control_features_6_4 = 
CAR(pair_313); } 
{ /* Ieee/control5.scm 67 */
obj_t pair_314;
{ /* Ieee/control5.scm 67 */
obj_t aux1148_349;
aux1148_349 = args_1; 
if(
PAIRP(aux1148_349))
{ /* Ieee/control5.scm 67 */
pair_314 = aux1148_349; }  else 
{ /* Ieee/control5.scm 67 */
bigloo_type_error_location_103___error(symbol1179___r5_control_features_6_4, string1180___r5_control_features_6_4, aux1148_349, string1181___r5_control_features_6_4, 
BINT(((long)2852))); 
exit( -1 );} } 
args_1 = 
CDR(pair_314); } 
{ /* Ieee/control5.scm 68 */
bool_t test1007_191;
{ /* Ieee/control5.scm 68 */
obj_t obj_315;
obj_315 = args_1; 
test1007_191 = 
PAIRP(obj_315); } 
if(test1007_191)
{ /* Ieee/control5.scm 69 */
bool_t test1008_192;
{ /* Ieee/control5.scm 69 */
obj_t arg1009_193;
{ /* Ieee/control5.scm 69 */
obj_t pair_316;
{ /* Ieee/control5.scm 69 */
obj_t aux1150_351;
aux1150_351 = args_1; 
if(
PAIRP(aux1150_351))
{ /* Ieee/control5.scm 69 */
pair_316 = aux1150_351; }  else 
{ /* Ieee/control5.scm 69 */
bigloo_type_error_location_103___error(symbol1179___r5_control_features_6_4, string1180___r5_control_features_6_4, aux1150_351, string1181___r5_control_features_6_4, 
BINT(((long)2903))); 
exit( -1 );} } 
arg1009_193 = 
CDR(pair_316); } 
test1008_192 = 
PAIRP(arg1009_193); } 
if(test1008_192)
{ /* Ieee/control5.scm 69 */
_res_number__75___r5_control_features_6_4 = 
BINT(((long)-1)); 
aux1127_325 = all_args_251_186; }  else 
{ /* Ieee/control5.scm 69 */
{ /* Ieee/control5.scm 74 */
obj_t pair_318;
{ /* Ieee/control5.scm 74 */
obj_t aux1152_353;
aux1152_353 = args_1; 
if(
PAIRP(aux1152_353))
{ /* Ieee/control5.scm 74 */
pair_318 = aux1152_353; }  else 
{ /* Ieee/control5.scm 74 */
bigloo_type_error_location_103___error(symbol1179___r5_control_features_6_4, string1180___r5_control_features_6_4, aux1152_353, string1181___r5_control_features_6_4, 
BINT(((long)3024))); 
exit( -1 );} } 
_res3__194___r5_control_features_6_4 = 
CAR(pair_318); } 
_res_number__75___r5_control_features_6_4 = 
BINT(((long)4)); 
aux1127_325 = res0_189; } }  else 
{ /* Ieee/control5.scm 68 */
_res_number__75___r5_control_features_6_4 = 
BINT(((long)3)); 
aux1127_325 = res0_189; } } }  else 
{ /* Ieee/control5.scm 64 */
_res_number__75___r5_control_features_6_4 = 
BINT(((long)2)); 
aux1127_325 = res0_189; } } } } } } 
POP_TRACE(); 
return aux1127_325;} } } } 
}



/* _values */
obj_t _values___r5_control_features_6_4(obj_t env_330, obj_t args_331)
{ AN_OBJECT;
{ /* Ieee/control5.scm 52 */
return 
values___r5_control_features_6_4(args_331);} 
}



/* call-with-values */
obj_t call_with_values_2___r5_control_features_6_4(obj_t producer_2, obj_t consumer_3)
{ AN_OBJECT;
{ /* Ieee/control5.scm 87 */
{ /* Ieee/control5.scm 87 */
obj_t symbol1130_326;
symbol1130_326 = symbol1182___r5_control_features_6_4; 
{ /* Ieee/control5.scm 87 */

PUSH_TRACE(symbol1130_326); BUNSPEC; 
{ /* Ieee/control5.scm 87 */
obj_t aux1129_327;
_res_number__75___r5_control_features_6_4 = 
BINT(((long)1)); 
{ /* Ieee/control5.scm 89 */
obj_t res0_195;
{ /* Ieee/control5.scm 89 */
bool_t test1155_357;
test1155_357 = 
PROCEDURE_CORRECT_ARITYP(producer_2, ((long)0)); 
if(test1155_357)
{ /* Ieee/control5.scm 89 */
res0_195 = 
PROCEDURE_ENTRY(producer_2)(producer_2, BEOA); }  else 
{ /* Ieee/control5.scm 89 */
error_location_112___error(string1183___r5_control_features_6_4, list1184___r5_control_features_6_4, producer_2, string1181___r5_control_features_6_4, 
BINT(((long)3515))); 
FAILURE(symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4);} } 
{ /* Ieee/control5.scm 90 */
obj_t aux1003_197;
aux1003_197 = _res_number__75___r5_control_features_6_4; 
{ /* Ieee/control5.scm 90 */
bool_t test1011_198;
test1011_198 = 
INTEGERP(aux1003_197); 
if(test1011_198)
{ /* Ieee/control5.scm 90 */
long aux_614;
{ /* Ieee/control5.scm 90 */
obj_t aux_615;
if(test1011_198)
{ /* Ieee/control5.scm 90 */
aux_615 = aux1003_197
; }  else 
{ /* Ieee/control5.scm 90 */
bigloo_type_error_location_103___error(symbol1182___r5_control_features_6_4, string1188___r5_control_features_6_4, aux1003_197, string1181___r5_control_features_6_4, 
BINT(((long)3534))); 
exit( -1 );} 
aux_614 = 
(long)CINT(aux_615); } 
switch( aux_614) { case ((long)-1) : 

{ /* Ieee/control5.scm 92 */
bool_t test1159_363;
{ /* Ieee/control5.scm 92 */
long aux_561;
aux_561 = 
list_length(res0_195); 
test1159_363 = 
PROCEDURE_CORRECT_ARITYP(consumer_3, aux_561); } 
if(test1159_363)
{ /* Ieee/control5.scm 92 */
aux1129_327 = 
apply(consumer_3, res0_195); }  else 
{ /* Ieee/control5.scm 92 */
error_location_112___error(symbol1182___r5_control_features_6_4, string1189___r5_control_features_6_4, list1190___r5_control_features_6_4, string1181___r5_control_features_6_4, 
BINT(((long)3564))); 
FAILURE(symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4);} } break;case ((long)0) : 

{ /* Ieee/control5.scm 94 */
bool_t test1161_366;
test1161_366 = 
PROCEDURE_CORRECT_ARITYP(consumer_3, ((long)0)); 
if(test1161_366)
{ /* Ieee/control5.scm 94 */
aux1129_327 = 
PROCEDURE_ENTRY(consumer_3)(consumer_3, BEOA); }  else 
{ /* Ieee/control5.scm 94 */
error_location_112___error(string1183___r5_control_features_6_4, list1194___r5_control_features_6_4, consumer_3, string1181___r5_control_features_6_4, 
BINT(((long)3597))); 
FAILURE(symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4);} } break;case ((long)1) : 

{ /* Ieee/control5.scm 96 */
bool_t test1163_369;
test1163_369 = 
PROCEDURE_CORRECT_ARITYP(consumer_3, ((long)1)); 
if(test1163_369)
{ /* Ieee/control5.scm 96 */
aux1129_327 = 
PROCEDURE_ENTRY(consumer_3)(consumer_3, res0_195, BEOA); }  else 
{ /* Ieee/control5.scm 96 */
error_location_112___error(string1183___r5_control_features_6_4, list1195___r5_control_features_6_4, consumer_3, string1181___r5_control_features_6_4, 
BINT(((long)3619))); 
FAILURE(symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4);} } break;case ((long)2) : 

{ /* Ieee/control5.scm 98 */
bool_t test1165_372;
test1165_372 = 
PROCEDURE_CORRECT_ARITYP(consumer_3, ((long)2)); 
if(test1165_372)
{ /* Ieee/control5.scm 98 */
aux1129_327 = 
PROCEDURE_ENTRY(consumer_3)(consumer_3, res0_195, _res1__155___r5_control_features_6_4, BEOA); }  else 
{ /* Ieee/control5.scm 98 */
error_location_112___error(string1183___r5_control_features_6_4, list1196___r5_control_features_6_4, consumer_3, string1181___r5_control_features_6_4, 
BINT(((long)3646))); 
FAILURE(symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4);} } break;case ((long)3) : 

{ /* Ieee/control5.scm 100 */
bool_t test1167_375;
test1167_375 = 
PROCEDURE_CORRECT_ARITYP(consumer_3, ((long)3)); 
if(test1167_375)
{ /* Ieee/control5.scm 100 */
aux1129_327 = 
PROCEDURE_ENTRY(consumer_3)(consumer_3, res0_195, _res1__155___r5_control_features_6_4, _res2__167___r5_control_features_6_4, BEOA); }  else 
{ /* Ieee/control5.scm 100 */
error_location_112___error(string1183___r5_control_features_6_4, list1198___r5_control_features_6_4, consumer_3, string1181___r5_control_features_6_4, 
BINT(((long)3680))); 
FAILURE(symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4);} } break;case ((long)4) : 

{ /* Ieee/control5.scm 102 */
bool_t test1169_378;
test1169_378 = 
PROCEDURE_CORRECT_ARITYP(consumer_3, ((long)4)); 
if(test1169_378)
{ /* Ieee/control5.scm 102 */
aux1129_327 = 
PROCEDURE_ENTRY(consumer_3)(consumer_3, res0_195, _res1__155___r5_control_features_6_4, _res2__167___r5_control_features_6_4, _res3__194___r5_control_features_6_4, BEOA); }  else 
{ /* Ieee/control5.scm 102 */
error_location_112___error(string1183___r5_control_features_6_4, list1200___r5_control_features_6_4, consumer_3, string1181___r5_control_features_6_4, 
BINT(((long)3721))); 
FAILURE(symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4);} } break;
default: 
{ /* Ieee/control5.scm 104 */
bool_t test1171_382;
{ /* Ieee/control5.scm 104 */
long aux_605;
aux_605 = 
list_length(res0_195); 
test1171_382 = 
PROCEDURE_CORRECT_ARITYP(consumer_3, aux_605); } 
if(test1171_382)
{ /* Ieee/control5.scm 104 */
aux1129_327 = 
apply(consumer_3, res0_195); }  else 
{ /* Ieee/control5.scm 104 */
error_location_112___error(symbol1182___r5_control_features_6_4, string1189___r5_control_features_6_4, list1190___r5_control_features_6_4, string1181___r5_control_features_6_4, 
BINT(((long)3770))); 
FAILURE(symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4);} } } }  else 
{ /* Ieee/control5.scm 104 */
bool_t test1173_386;
{ /* Ieee/control5.scm 104 */
long aux_621;
aux_621 = 
list_length(res0_195); 
test1173_386 = 
PROCEDURE_CORRECT_ARITYP(consumer_3, aux_621); } 
if(test1173_386)
{ /* Ieee/control5.scm 104 */
aux1129_327 = 
apply(consumer_3, res0_195); }  else 
{ /* Ieee/control5.scm 104 */
error_location_112___error(symbol1182___r5_control_features_6_4, string1189___r5_control_features_6_4, list1190___r5_control_features_6_4, string1181___r5_control_features_6_4, 
BINT(((long)3770))); 
FAILURE(symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4,symbol1187___r5_control_features_6_4);} } } } } 
POP_TRACE(); 
return aux1129_327;} } } } 
}



/* _call-with-values1133 */
obj_t _call_with_values1133_119___r5_control_features_6_4(obj_t env_332, obj_t producer_333, obj_t consumer_334)
{ AN_OBJECT;
{ /* Ieee/control5.scm 87 */
{ /* Ieee/control5.scm 87 */
obj_t aux_637;obj_t aux_631;
if(
PROCEDUREP(consumer_334))
{ /* Ieee/control5.scm 87 */
aux_637 = consumer_334
; }  else 
{ /* Ieee/control5.scm 87 */
bigloo_type_error_location_103___error(symbol1202___r5_control_features_6_4, string1203___r5_control_features_6_4, consumer_334, string1181___r5_control_features_6_4, 
BINT(((long)3430))); 
exit( -1 );} 
if(
PROCEDUREP(producer_333))
{ /* Ieee/control5.scm 87 */
aux_631 = producer_333
; }  else 
{ /* Ieee/control5.scm 87 */
bigloo_type_error_location_103___error(symbol1202___r5_control_features_6_4, string1203___r5_control_features_6_4, producer_333, string1181___r5_control_features_6_4, 
BINT(((long)3430))); 
exit( -1 );} 
return 
call_with_values_2___r5_control_features_6_4(aux_631, aux_637);} } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___r5_control_features_6_4()
{ AN_OBJECT;
{ /* Ieee/control5.scm 14 */
{ /* Ieee/control5.scm 14 */
obj_t symbol1132_328;
symbol1132_328 = symbol1204___r5_control_features_6_4; 
{ /* Ieee/control5.scm 14 */

PUSH_TRACE(symbol1132_328); BUNSPEC; 
{ /* Ieee/control5.scm 14 */
obj_t aux1131_329;
aux1131_329 = 
module_initialization_70___error(((long)0), "__R5_CONTROL_FEATURES_6_4"); 
POP_TRACE(); 
return aux1131_329;} } } } 
}

