/*===========================================================================*/
/*   (Ieee/equiv.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo2.1a.h>
#include <signal.h>


/* Object type definitions */

extern bool_t bigloo_strcmp(obj_t, obj_t);
static obj_t method_init_76___r4_equivalence_6_2();
extern obj_t string_to_symbol(char *);
static obj_t _equal__165___r4_equivalence_6_2(obj_t, obj_t, obj_t);
static obj_t _eq__190___r4_equivalence_6_2(obj_t, obj_t, obj_t);
static obj_t symbol1337___r4_equivalence_6_2 = BUNSPEC;
static obj_t symbol1336___r4_equivalence_6_2 = BUNSPEC;
static obj_t symbol1327___r4_equivalence_6_2 = BUNSPEC;
static obj_t symbol1324___r4_equivalence_6_2 = BUNSPEC;
static obj_t symbol1323___r4_equivalence_6_2 = BUNSPEC;
extern obj_t bigloo_type_error_location_103___error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _eqv__158___r4_equivalence_6_2(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern bool_t _2__95___r4_numbers_6_5(obj_t, obj_t);
extern bool_t eqv__112___r4_equivalence_6_2(obj_t, obj_t);
static obj_t imported_modules_init_94___r4_equivalence_6_2();
extern bool_t ucs2_strcmp(obj_t, obj_t);
extern bool_t equal__25___r4_equivalence_6_2(obj_t, obj_t);
extern bool_t eq__100___r4_equivalence_6_2(obj_t, obj_t);
static obj_t require_initialization_114___r4_equivalence_6_2 = BUNSPEC;
extern bool_t object_equal__12___object(object_bglt, object_bglt);
static obj_t cnst_init_137___r4_equivalence_6_2();
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( equal__env_47___r4_equivalence_6_2, _equal__165___r4_equivalence_6_21340, _equal__165___r4_equivalence_6_2, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( eqv__env_202___r4_equivalence_6_2, _eqv__158___r4_equivalence_6_21341, _eqv__158___r4_equivalence_6_2, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( eq__env_189___r4_equivalence_6_2, _eq__190___r4_equivalence_6_21342, _eq__190___r4_equivalence_6_2, 0L, 2 );
DEFINE_STRING( string1335___r4_equivalence_6_2, string1335___r4_equivalence_6_21343, "CUSTOM", 6 );
DEFINE_STRING( string1334___r4_equivalence_6_2, string1334___r4_equivalence_6_21344, "UCS2STRING", 10 );
DEFINE_STRING( string1333___r4_equivalence_6_2, string1333___r4_equivalence_6_21345, "OBJECT", 6 );
DEFINE_STRING( string1332___r4_equivalence_6_2, string1332___r4_equivalence_6_21346, "STRUCT", 6 );
DEFINE_STRING( string1331___r4_equivalence_6_2, string1331___r4_equivalence_6_21347, "DOUBLE", 6 );
DEFINE_STRING( string1329___r4_equivalence_6_2, string1329___r4_equivalence_6_21348, "VECTOR", 6 );
DEFINE_STRING( string1330___r4_equivalence_6_2, string1330___r4_equivalence_6_21349, "BSTRING", 7 );
DEFINE_STRING( string1328___r4_equivalence_6_2, string1328___r4_equivalence_6_21350, "PAIR", 4 );
DEFINE_STRING( string1326___r4_equivalence_6_2, string1326___r4_equivalence_6_21351, "/home/tahoe2/serrano/tmp/bigloo/runtime/Ieee/equiv.scm", 54 );
DEFINE_STRING( string1325___r4_equivalence_6_2, string1325___r4_equivalence_6_21352, "SYMBOL", 6 );



/* module-initialization */
obj_t module_initialization_70___r4_equivalence_6_2(long checksum_854, char * from_855)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___r4_equivalence_6_2))
{ 
require_initialization_114___r4_equivalence_6_2 = 
BBOOL(((bool_t)0)); 
cnst_init_137___r4_equivalence_6_2(); 
imported_modules_init_94___r4_equivalence_6_2(); 
method_init_76___r4_equivalence_6_2(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___r4_equivalence_6_2()
{ AN_OBJECT;
{ /* Ieee/equiv.scm 14 */
symbol1323___r4_equivalence_6_2 = 
string_to_symbol("EQ?"); 
symbol1324___r4_equivalence_6_2 = 
string_to_symbol("EQV?"); 
symbol1327___r4_equivalence_6_2 = 
string_to_symbol("EQUAL?"); 
symbol1336___r4_equivalence_6_2 = 
string_to_symbol("METHOD-INIT"); 
return ( 
symbol1337___r4_equivalence_6_2 = 
string_to_symbol("IMPORTED-MODULES-INIT"), BUNSPEC) ;} 
}



/* eq? */
bool_t eq__100___r4_equivalence_6_2(obj_t obj1_1, obj_t obj2_2)
{ AN_OBJECT;
{ /* Ieee/equiv.scm 54 */
{ /* Ieee/equiv.scm 55 */
obj_t symbol1262_845;
symbol1262_845 = symbol1323___r4_equivalence_6_2; 
{ /* Ieee/equiv.scm 55 */

PUSH_TRACE(symbol1262_845); BUNSPEC; 
{ /* Ieee/equiv.scm 55 */
bool_t aux1261_846;
aux1261_846 = 
(obj1_1==obj2_2); 
POP_TRACE(); 
return aux1261_846;} } } } 
}



/* _eq? */
obj_t _eq__190___r4_equivalence_6_2(obj_t env_784, obj_t obj1_785, obj_t obj2_786)
{ AN_OBJECT;
{ /* Ieee/equiv.scm 54 */
{ /* Ieee/equiv.scm 54 */
bool_t aux_870;
{ /* Ieee/equiv.scm 54 */
bool_t res1338_851;
{ /* Ieee/equiv.scm 54 */
obj_t obj1_847;obj_t obj2_848;
obj1_847 = obj1_785; 
obj2_848 = obj2_786; 
{ /* Ieee/equiv.scm 55 */
obj_t symbol1262_849;
symbol1262_849 = symbol1323___r4_equivalence_6_2; 
{ /* Ieee/equiv.scm 55 */

PUSH_TRACE(symbol1262_849); BUNSPEC; 
{ /* Ieee/equiv.scm 55 */
bool_t aux1261_850;
aux1261_850 = 
(obj1_847==obj2_848); 
POP_TRACE(); 
res1338_851 = aux1261_850; } } } } 
aux_870 = res1338_851; } 
return 
BBOOL(aux_870);} } 
}



/* eqv? */
bool_t eqv__112___r4_equivalence_6_2(obj_t obj1_3, obj_t obj2_4)
{ AN_OBJECT;
{ /* Ieee/equiv.scm 60 */
{ /* Ieee/equiv.scm 62 */
obj_t symbol1264_776;
symbol1264_776 = symbol1324___r4_equivalence_6_2; 
{ /* Ieee/equiv.scm 62 */

PUSH_TRACE(symbol1264_776); BUNSPEC; 
{ /* Ieee/equiv.scm 62 */
bool_t aux1263_777;
if(
INTEGERP(obj1_3))
{ /* Ieee/equiv.scm 62 */
if(
INTEGERP(obj2_4))
{ /* Ieee/equiv.scm 63 */
aux1263_777 = 
_2__95___r4_numbers_6_5(obj1_3, obj2_4); }  else 
{ /* Ieee/equiv.scm 63 */
aux1263_777 = ((bool_t)0); } }  else 
{ /* Ieee/equiv.scm 62 */
if(
REALP(obj1_3))
{ /* Ieee/equiv.scm 65 */
if(
REALP(obj2_4))
{ /* Ieee/equiv.scm 66 */
aux1263_777 = 
_2__95___r4_numbers_6_5(obj1_3, obj2_4); }  else 
{ /* Ieee/equiv.scm 66 */
aux1263_777 = ((bool_t)0); } }  else 
{ /* Ieee/equiv.scm 68 */
bool_t test1032_405;
test1032_405 = 
SYMBOLP(obj1_3); 
if(test1032_405)
{ /* Ieee/equiv.scm 68 */
{ /* Ieee/equiv.scm 69 */
bool_t _andtest_1007_406;
_andtest_1007_406 = 
SYMBOLP(obj2_4); 
if(_andtest_1007_406)
{ /* Ieee/equiv.scm 70 */
obj_t arg1033_407;obj_t arg1034_408;
{ /* Ieee/equiv.scm 70 */
obj_t symbol_664;
if(test1032_405)
{ /* Ieee/equiv.scm 70 */
symbol_664 = obj1_3; }  else 
{ /* Ieee/equiv.scm 70 */
bigloo_type_error_location_103___error(symbol1324___r4_equivalence_6_2, string1325___r4_equivalence_6_2, obj1_3, string1326___r4_equivalence_6_2, 
BINT(((long)3036))); 
exit( -1 );} 
arg1033_407 = 
SYMBOL_TO_STRING(symbol_664); } 
{ /* Ieee/equiv.scm 71 */
obj_t symbol_665;
if(_andtest_1007_406)
{ /* Ieee/equiv.scm 71 */
symbol_665 = obj2_4; }  else 
{ /* Ieee/equiv.scm 71 */
bigloo_type_error_location_103___error(symbol1324___r4_equivalence_6_2, string1325___r4_equivalence_6_2, obj2_4, string1326___r4_equivalence_6_2, 
BINT(((long)3066))); 
exit( -1 );} 
arg1034_408 = 
SYMBOL_TO_STRING(symbol_665); } 
aux1263_777 = 
bigloo_strcmp(arg1033_407, arg1034_408); }  else 
{ /* Ieee/equiv.scm 69 */
aux1263_777 = ((bool_t)0); } } }  else 
{ /* Ieee/equiv.scm 68 */
aux1263_777 = 
(obj1_3==obj2_4); } } } 
POP_TRACE(); 
return aux1263_777;} } } } 
}



/* _eqv? */
obj_t _eqv__158___r4_equivalence_6_2(obj_t env_787, obj_t obj1_788, obj_t obj2_789)
{ AN_OBJECT;
{ /* Ieee/equiv.scm 60 */
{ /* Ieee/equiv.scm 60 */
bool_t aux_903;
aux_903 = 
eqv__112___r4_equivalence_6_2(obj1_788, obj2_789); 
return 
BBOOL(aux_903);} } 
}



/* equal? */
bool_t equal__25___r4_equivalence_6_2(obj_t obj1_5, obj_t obj2_6)
{ AN_OBJECT;
{ /* Ieee/equiv.scm 78 */
{ /* Ieee/equiv.scm 80 */
obj_t symbol1266_778;
symbol1266_778 = symbol1327___r4_equivalence_6_2; 
{ /* Ieee/equiv.scm 80 */

PUSH_TRACE(symbol1266_778); BUNSPEC; 
{ /* Ieee/equiv.scm 80 */
bool_t aux1265_779;
if(
(obj1_5==obj2_6))
{ /* Ieee/equiv.scm 80 */
aux1265_779 = ((bool_t)1); }  else 
{ /* Ieee/equiv.scm 82 */
bool_t test1036_410;
test1036_410 = 
INTEGERP(obj1_5); 
if(test1036_410)
{ /* Ieee/equiv.scm 82 */
aux1265_779 = ((bool_t)0); }  else 
{ /* Ieee/equiv.scm 82 */
if(
SYMBOLP(obj1_5))
{ /* Ieee/equiv.scm 84 */
aux1265_779 = ((bool_t)0); }  else 
{ /* Ieee/equiv.scm 84 */
if(
UCS2P(obj1_5))
{ /* Ieee/equiv.scm 86 */
aux1265_779 = ((bool_t)0); }  else 
{ /* Ieee/equiv.scm 88 */
bool_t test1039_413;
test1039_413 = 
PAIRP(obj1_5); 
if(test1039_413)
{ /* Ieee/equiv.scm 88 */
{ /* Ieee/equiv.scm 89 */
bool_t _andtest_1008_414;
_andtest_1008_414 = 
PAIRP(obj2_6); 
if(_andtest_1008_414)
{ /* Ieee/equiv.scm 89 */
bool_t _andtest_1009_415;
{ /* Ieee/equiv.scm 89 */
obj_t arg1043_418;obj_t arg1044_419;
{ /* Ieee/equiv.scm 89 */
obj_t pair_675;
if(test1039_413)
{ /* Ieee/equiv.scm 89 */
pair_675 = obj1_5; }  else 
{ /* Ieee/equiv.scm 89 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1328___r4_equivalence_6_2, obj1_5, string1326___r4_equivalence_6_2, 
BINT(((long)3574))); 
exit( -1 );} 
arg1043_418 = 
CAR(pair_675); } 
{ /* Ieee/equiv.scm 89 */
obj_t pair_676;
if(_andtest_1008_414)
{ /* Ieee/equiv.scm 89 */
pair_676 = obj2_6; }  else 
{ /* Ieee/equiv.scm 89 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1328___r4_equivalence_6_2, obj2_6, string1326___r4_equivalence_6_2, 
BINT(((long)3585))); 
exit( -1 );} 
arg1044_419 = 
CAR(pair_676); } 
_andtest_1009_415 = 
equal__25___r4_equivalence_6_2(arg1043_418, arg1044_419); } 
if(_andtest_1009_415)
{ /* Ieee/equiv.scm 90 */
obj_t arg1040_416;obj_t arg1041_417;
{ /* Ieee/equiv.scm 90 */
obj_t pair_677;
if(test1039_413)
{ /* Ieee/equiv.scm 90 */
pair_677 = obj1_5; }  else 
{ /* Ieee/equiv.scm 90 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1328___r4_equivalence_6_2, obj1_5, string1326___r4_equivalence_6_2, 
BINT(((long)3610))); 
exit( -1 );} 
arg1040_416 = 
CDR(pair_677); } 
{ /* Ieee/equiv.scm 90 */
obj_t pair_678;
if(_andtest_1008_414)
{ /* Ieee/equiv.scm 90 */
pair_678 = obj2_6; }  else 
{ /* Ieee/equiv.scm 90 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1328___r4_equivalence_6_2, obj2_6, string1326___r4_equivalence_6_2, 
BINT(((long)3621))); 
exit( -1 );} 
arg1041_417 = 
CDR(pair_678); } 
aux1265_779 = 
equal__25___r4_equivalence_6_2(arg1040_416, arg1041_417); }  else 
{ /* Ieee/equiv.scm 89 */
aux1265_779 = ((bool_t)0); } }  else 
{ /* Ieee/equiv.scm 89 */
aux1265_779 = ((bool_t)0); } } }  else 
{ /* Ieee/equiv.scm 91 */
bool_t test1045_420;
test1045_420 = 
VECTORP(obj1_5); 
if(test1045_420)
{ /* Ieee/equiv.scm 91 */
{ /* Ieee/equiv.scm 92 */
long lobj1_421;
{ /* Ieee/equiv.scm 92 */
obj_t vector_680;
if(test1045_420)
{ /* Ieee/equiv.scm 92 */
vector_680 = obj1_5; }  else 
{ /* Ieee/equiv.scm 92 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1329___r4_equivalence_6_2, obj1_5, string1326___r4_equivalence_6_2, 
BINT(((long)3677))); 
exit( -1 );} 
lobj1_421 = 
VECTOR_LENGTH(vector_680); } 
{ /* Ieee/equiv.scm 93 */
bool_t _andtest_1010_422;
_andtest_1010_422 = 
VECTORP(obj2_6); 
if(_andtest_1010_422)
{ /* Ieee/equiv.scm 94 */
bool_t _andtest_1011_423;
{ /* Ieee/equiv.scm 94 */
long arg1052_435;
{ /* Ieee/equiv.scm 94 */
obj_t vector_682;
if(_andtest_1010_422)
{ /* Ieee/equiv.scm 94 */
vector_682 = obj2_6; }  else 
{ /* Ieee/equiv.scm 94 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1329___r4_equivalence_6_2, obj2_6, string1326___r4_equivalence_6_2, 
BINT(((long)3736))); 
exit( -1 );} 
arg1052_435 = 
VECTOR_LENGTH(vector_682); } 
_andtest_1011_423 = 
(arg1052_435==lobj1_421); } 
if(_andtest_1011_423)
{ /* Ieee/equiv.scm 95 */
bool_t _andtest_1012_424;
{ /* Ieee/equiv.scm 95 */
long arg1050_433;long arg1051_434;
{ /* Ieee/equiv.scm 95 */
obj_t vector_685;
if(test1045_420)
{ /* Ieee/equiv.scm 95 */
vector_685 = obj1_5; }  else 
{ /* Ieee/equiv.scm 95 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1329___r4_equivalence_6_2, obj1_5, string1326___r4_equivalence_6_2, 
BINT(((long)3777))); 
exit( -1 );} 
arg1050_433 = 
VECTOR_TAG(vector_685); } 
{ /* Ieee/equiv.scm 95 */
obj_t vector_686;
if(_andtest_1010_422)
{ /* Ieee/equiv.scm 95 */
vector_686 = obj2_6; }  else 
{ /* Ieee/equiv.scm 95 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1329___r4_equivalence_6_2, obj2_6, string1326___r4_equivalence_6_2, 
BINT(((long)3795))); 
exit( -1 );} 
arg1051_434 = 
VECTOR_TAG(vector_686); } 
_andtest_1012_424 = 
(arg1050_433==arg1051_434); } 
if(_andtest_1012_424)
{ 
long i_425;
i_425 = 
(lobj1_421-((long)1)); 
test_426:
{ /* Ieee/equiv.scm 97 */
bool_t _ortest_1013_428;
_ortest_1013_428 = 
(i_425==((long)-1)); 
if(_ortest_1013_428)
{ /* Ieee/equiv.scm 97 */
aux1265_779 = _ortest_1013_428; }  else 
{ /* Ieee/equiv.scm 98 */
bool_t _andtest_1014_429;
{ /* Ieee/equiv.scm 98 */
obj_t arg1048_431;obj_t arg1049_432;
{ /* Ieee/equiv.scm 98 */
obj_t vector_693;
if(
VECTORP(obj1_5))
{ /* Ieee/equiv.scm 98 */
vector_693 = obj1_5; }  else 
{ /* Ieee/equiv.scm 98 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1329___r4_equivalence_6_2, obj1_5, string1326___r4_equivalence_6_2, 
BINT(((long)3892))); 
exit( -1 );} 
arg1048_431 = 
VECTOR_REF(vector_693, i_425); } 
{ /* Ieee/equiv.scm 99 */
obj_t vector_695;
if(
VECTORP(obj2_6))
{ /* Ieee/equiv.scm 99 */
vector_695 = obj2_6; }  else 
{ /* Ieee/equiv.scm 99 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1329___r4_equivalence_6_2, obj2_6, string1326___r4_equivalence_6_2, 
BINT(((long)3922))); 
exit( -1 );} 
arg1049_432 = 
VECTOR_REF(vector_695, i_425); } 
_andtest_1014_429 = 
equal__25___r4_equivalence_6_2(arg1048_431, arg1049_432); } 
if(_andtest_1014_429)
{ 
long i_986;
i_986 = 
(i_425-((long)1)); 
i_425 = i_986; 
goto test_426;}  else 
{ /* Ieee/equiv.scm 98 */
aux1265_779 = ((bool_t)0); } } } }  else 
{ /* Ieee/equiv.scm 95 */
aux1265_779 = ((bool_t)0); } }  else 
{ /* Ieee/equiv.scm 94 */
aux1265_779 = ((bool_t)0); } }  else 
{ /* Ieee/equiv.scm 93 */
aux1265_779 = ((bool_t)0); } } } }  else 
{ /* Ieee/equiv.scm 101 */
bool_t test1053_436;
test1053_436 = 
STRINGP(obj1_5); 
if(test1053_436)
{ /* Ieee/equiv.scm 101 */
{ /* Ieee/equiv.scm 102 */
bool_t _andtest_1015_437;
_andtest_1015_437 = 
STRINGP(obj2_6); 
if(_andtest_1015_437)
{ /* Ieee/equiv.scm 102 */
obj_t string1_701;obj_t string2_702;
if(test1053_436)
{ /* Ieee/equiv.scm 102 */
string1_701 = obj1_5; }  else 
{ /* Ieee/equiv.scm 102 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1330___r4_equivalence_6_2, obj1_5, string1326___r4_equivalence_6_2, 
BINT(((long)4024))); 
exit( -1 );} 
if(_andtest_1015_437)
{ /* Ieee/equiv.scm 102 */
string2_702 = obj2_6; }  else 
{ /* Ieee/equiv.scm 102 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1330___r4_equivalence_6_2, obj2_6, string1326___r4_equivalence_6_2, 
BINT(((long)4033))); 
exit( -1 );} 
aux1265_779 = 
bigloo_strcmp(string1_701, string2_702); }  else 
{ /* Ieee/equiv.scm 102 */
aux1265_779 = ((bool_t)0); } } }  else 
{ /* Ieee/equiv.scm 103 */
bool_t test1054_438;
test1054_438 = 
REALP(obj1_5); 
if(test1054_438)
{ /* Ieee/equiv.scm 103 */
{ /* Ieee/equiv.scm 104 */
bool_t _andtest_1016_439;
_andtest_1016_439 = 
REALP(obj2_6); 
if(_andtest_1016_439)
{ /* Ieee/equiv.scm 105 */
double r1_703;double r2_704;
{ /* Ieee/equiv.scm 105 */
obj_t aux_1006;
if(test1054_438)
{ /* Ieee/equiv.scm 105 */
aux_1006 = obj1_5
; }  else 
{ /* Ieee/equiv.scm 105 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1331___r4_equivalence_6_2, obj1_5, string1326___r4_equivalence_6_2, 
BINT(((long)4105))); 
exit( -1 );} 
r1_703 = 
REAL_TO_DOUBLE(aux_1006); } 
{ /* Ieee/equiv.scm 105 */
obj_t aux_1012;
if(_andtest_1016_439)
{ /* Ieee/equiv.scm 105 */
aux_1012 = obj2_6
; }  else 
{ /* Ieee/equiv.scm 105 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1331___r4_equivalence_6_2, obj2_6, string1326___r4_equivalence_6_2, 
BINT(((long)4109))); 
exit( -1 );} 
r2_704 = 
REAL_TO_DOUBLE(aux_1012); } 
aux1265_779 = 
(r1_703==r2_704); }  else 
{ /* Ieee/equiv.scm 104 */
aux1265_779 = ((bool_t)0); } } }  else 
{ /* Ieee/equiv.scm 106 */
bool_t test1055_440;
test1055_440 = 
STRUCTP(obj1_5); 
if(test1055_440)
{ /* Ieee/equiv.scm 106 */
{ /* Ieee/equiv.scm 107 */
long lobj1_441;
{ /* Ieee/equiv.scm 107 */
obj_t s_705;
if(test1055_440)
{ /* Ieee/equiv.scm 107 */
s_705 = obj1_5; }  else 
{ /* Ieee/equiv.scm 107 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1332___r4_equivalence_6_2, obj1_5, string1326___r4_equivalence_6_2, 
BINT(((long)4167))); 
exit( -1 );} 
lobj1_441 = 
STRUCT_LENGTH(s_705); } 
{ /* Ieee/equiv.scm 108 */
bool_t _andtest_1017_442;
_andtest_1017_442 = 
STRUCTP(obj2_6); 
if(_andtest_1017_442)
{ /* Ieee/equiv.scm 109 */
bool_t _andtest_1018_443;
{ /* Ieee/equiv.scm 109 */
long arg1065_452;
{ /* Ieee/equiv.scm 109 */
obj_t s_707;
if(_andtest_1017_442)
{ /* Ieee/equiv.scm 109 */
s_707 = obj2_6; }  else 
{ /* Ieee/equiv.scm 109 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1332___r4_equivalence_6_2, obj2_6, string1326___r4_equivalence_6_2, 
BINT(((long)4226))); 
exit( -1 );} 
arg1065_452 = 
STRUCT_LENGTH(s_707); } 
_andtest_1018_443 = 
(arg1065_452==lobj1_441); } 
if(_andtest_1018_443)
{ 
long i_444;
i_444 = 
(lobj1_441-((long)1)); 
test_445:
{ /* Ieee/equiv.scm 111 */
bool_t _ortest_1019_447;
_ortest_1019_447 = 
(i_444==((long)-1)); 
if(_ortest_1019_447)
{ /* Ieee/equiv.scm 111 */
aux1265_779 = _ortest_1019_447; }  else 
{ /* Ieee/equiv.scm 112 */
bool_t _andtest_1020_448;
{ /* Ieee/equiv.scm 112 */
obj_t arg1063_450;obj_t arg1064_451;
{ /* Ieee/equiv.scm 112 */
obj_t s_714;
if(
STRUCTP(obj1_5))
{ /* Ieee/equiv.scm 112 */
s_714 = obj1_5; }  else 
{ /* Ieee/equiv.scm 112 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1332___r4_equivalence_6_2, obj1_5, string1326___r4_equivalence_6_2, 
BINT(((long)4332))); 
exit( -1 );} 
arg1063_450 = 
STRUCT_REF(s_714, i_444); } 
{ /* Ieee/equiv.scm 112 */
obj_t s_716;
if(
STRUCTP(obj2_6))
{ /* Ieee/equiv.scm 112 */
s_716 = obj2_6; }  else 
{ /* Ieee/equiv.scm 112 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1332___r4_equivalence_6_2, obj2_6, string1326___r4_equivalence_6_2, 
BINT(((long)4352))); 
exit( -1 );} 
arg1064_451 = 
STRUCT_REF(s_716, i_444); } 
_andtest_1020_448 = 
equal__25___r4_equivalence_6_2(arg1063_450, arg1064_451); } 
if(_andtest_1020_448)
{ 
long i_1051;
i_1051 = 
(i_444-((long)1)); 
i_444 = i_1051; 
goto test_445;}  else 
{ /* Ieee/equiv.scm 112 */
aux1265_779 = ((bool_t)0); } } } }  else 
{ /* Ieee/equiv.scm 109 */
aux1265_779 = ((bool_t)0); } }  else 
{ /* Ieee/equiv.scm 108 */
aux1265_779 = ((bool_t)0); } } } }  else 
{ /* Ieee/equiv.scm 106 */
if(
CELLP(obj1_5))
{ /* Ieee/equiv.scm 114 */
if(
CELLP(obj2_6))
{ /* Ieee/equiv.scm 116 */
obj_t arg1067_455;obj_t arg1068_456;
arg1067_455 = 
CELL_REF(obj1_5); 
arg1068_456 = 
CELL_REF(obj2_6); 
aux1265_779 = 
equal__25___r4_equivalence_6_2(arg1067_455, arg1068_456); }  else 
{ /* Ieee/equiv.scm 115 */
aux1265_779 = ((bool_t)0); } }  else 
{ /* Ieee/equiv.scm 117 */
bool_t test_1061;
if(test1036_410)
{ /* ./Ieee/number.scm 3049 */
test_1061 = ((bool_t)1)
; }  else 
{ /* ./Ieee/number.scm 3049 */
test_1061 = test1054_438
; } 
if(test_1061)
{ /* Ieee/equiv.scm 117 */
{ /* Ieee/equiv.scm 118 */
bool_t test_1063;
if(
INTEGERP(obj2_6))
{ /* ./Ieee/number.scm 3049 */
test_1063 = ((bool_t)1)
; }  else 
{ /* ./Ieee/number.scm 3049 */
test_1063 = 
REALP(obj2_6)
; } 
if(test_1063)
{ /* Ieee/equiv.scm 118 */
aux1265_779 = 
_2__95___r4_numbers_6_5(obj1_5, obj2_6); }  else 
{ /* Ieee/equiv.scm 118 */
aux1265_779 = ((bool_t)0); } } }  else 
{ /* Ieee/equiv.scm 120 */
bool_t test1070_459;
test1070_459 = 
(POINTERP( obj1_5 ) && (TYPE( obj1_5 ) >= OBJECT_TYPE)); 
if(test1070_459)
{ /* Ieee/equiv.scm 120 */
{ /* Ieee/equiv.scm 121 */
bool_t _andtest_1023_460;
_andtest_1023_460 = 
(POINTERP( obj2_6 ) && (TYPE( obj2_6 ) >= OBJECT_TYPE)); 
if(_andtest_1023_460)
{ /* Ieee/equiv.scm 122 */
object_bglt aux_1079;object_bglt aux_1072;
{ /* Ieee/equiv.scm 122 */
bool_t test1314_836;
{ /* Ieee/equiv.scm 122 */
obj_t obj_853;
obj_853 = obj2_6; 
test1314_836 = 
(POINTERP( obj_853 ) && (TYPE( obj_853 ) >= OBJECT_TYPE)); } 
if(test1314_836)
{ /* Ieee/equiv.scm 122 */
aux_1079 = 
(object_bglt)(obj2_6)
; }  else 
{ /* Ieee/equiv.scm 122 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1333___r4_equivalence_6_2, obj2_6, string1326___r4_equivalence_6_2, 
BINT(((long)4633))); 
exit( -1 );} } 
{ /* Ieee/equiv.scm 122 */
bool_t test1312_834;
{ /* Ieee/equiv.scm 122 */
obj_t obj_852;
obj_852 = obj1_5; 
test1312_834 = 
(POINTERP( obj_852 ) && (TYPE( obj_852 ) >= OBJECT_TYPE)); } 
if(test1312_834)
{ /* Ieee/equiv.scm 122 */
aux_1072 = 
(object_bglt)(obj1_5)
; }  else 
{ /* Ieee/equiv.scm 122 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1333___r4_equivalence_6_2, obj1_5, string1326___r4_equivalence_6_2, 
BINT(((long)4619))); 
exit( -1 );} } 
aux1265_779 = 
object_equal__12___object(aux_1072, aux_1079); }  else 
{ /* Ieee/equiv.scm 121 */
aux1265_779 = ((bool_t)0); } } }  else 
{ /* Ieee/equiv.scm 123 */
bool_t test1071_461;
test1071_461 = 
UCS2_STRINGP(obj1_5); 
if(test1071_461)
{ /* Ieee/equiv.scm 123 */
{ /* Ieee/equiv.scm 124 */
bool_t _andtest_1024_462;
_andtest_1024_462 = 
UCS2_STRINGP(obj2_6); 
if(_andtest_1024_462)
{ /* Ieee/equiv.scm 124 */
obj_t ucs2_string1_235_734;obj_t ucs2_string2_163_735;
if(test1071_461)
{ /* Ieee/equiv.scm 124 */
ucs2_string1_235_734 = obj1_5; }  else 
{ /* Ieee/equiv.scm 124 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1334___r4_equivalence_6_2, obj1_5, string1326___r4_equivalence_6_2, 
BINT(((long)4706))); 
exit( -1 );} 
if(_andtest_1024_462)
{ /* Ieee/equiv.scm 124 */
ucs2_string2_163_735 = obj2_6; }  else 
{ /* Ieee/equiv.scm 124 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1334___r4_equivalence_6_2, obj2_6, string1326___r4_equivalence_6_2, 
BINT(((long)4720))); 
exit( -1 );} 
aux1265_779 = 
ucs2_strcmp(ucs2_string1_235_734, ucs2_string2_163_735); }  else 
{ /* Ieee/equiv.scm 124 */
aux1265_779 = ((bool_t)0); } } }  else 
{ /* Ieee/equiv.scm 125 */
bool_t test1072_463;
test1072_463 = 
CUSTOMP(obj1_5); 
if(test1072_463)
{ /* Ieee/equiv.scm 125 */
{ /* Ieee/equiv.scm 126 */
bool_t _andtest_1025_464;
_andtest_1025_464 = 
CUSTOMP(obj2_6); 
if(_andtest_1025_464)
{ /* Ieee/equiv.scm 126 */
obj_t obj1_738;obj_t obj2_739;
{ /* Ieee/equiv.scm 126 */
bool_t test1320_842;
test1320_842 = 
CUSTOMP(obj1_5); 
if(test1320_842)
{ /* Ieee/equiv.scm 126 */
obj1_738 = obj1_5; }  else 
{ /* Ieee/equiv.scm 126 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1335___r4_equivalence_6_2, obj1_5, string1326___r4_equivalence_6_2, 
BINT(((long)4783))); 
exit( -1 );} } 
{ /* Ieee/equiv.scm 126 */
bool_t test1322_844;
test1322_844 = 
CUSTOMP(obj2_6); 
if(test1322_844)
{ /* Ieee/equiv.scm 126 */
obj2_739 = obj2_6; }  else 
{ /* Ieee/equiv.scm 126 */
bigloo_type_error_location_103___error(symbol1327___r4_equivalence_6_2, string1335___r4_equivalence_6_2, obj2_6, string1326___r4_equivalence_6_2, 
BINT(((long)4797))); 
exit( -1 );} } 
aux1265_779 = 
CUSTOM_CMP(obj1_738, obj2_739); }  else 
{ /* Ieee/equiv.scm 126 */
aux1265_779 = ((bool_t)0); } } }  else 
{ /* Ieee/equiv.scm 125 */
aux1265_779 = ((bool_t)0); } } } } } } } } } } } } } } 
POP_TRACE(); 
return aux1265_779;} } } } 
}



/* _equal? */
obj_t _equal__165___r4_equivalence_6_2(obj_t env_790, obj_t obj1_791, obj_t obj2_792)
{ AN_OBJECT;
{ /* Ieee/equiv.scm 78 */
{ /* Ieee/equiv.scm 78 */
bool_t aux_1116;
aux_1116 = 
equal__25___r4_equivalence_6_2(obj1_791, obj2_792); 
return 
BBOOL(aux_1116);} } 
}



/* method-init */
obj_t method_init_76___r4_equivalence_6_2()
{ AN_OBJECT;
{ /* Ieee/equiv.scm 14 */
{ /* Ieee/equiv.scm 14 */
obj_t symbol1268_780;
symbol1268_780 = symbol1336___r4_equivalence_6_2; 
{ /* Ieee/equiv.scm 14 */

PUSH_TRACE(symbol1268_780); BUNSPEC; 
POP_TRACE(); 
return BUNSPEC;} } } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___r4_equivalence_6_2()
{ AN_OBJECT;
{ /* Ieee/equiv.scm 14 */
{ /* Ieee/equiv.scm 14 */
obj_t symbol1270_782;
symbol1270_782 = symbol1337___r4_equivalence_6_2; 
{ /* Ieee/equiv.scm 14 */

PUSH_TRACE(symbol1270_782); BUNSPEC; 
{ /* Ieee/equiv.scm 14 */
obj_t aux1269_783;
aux1269_783 = 
module_initialization_70___error(((long)0), "__R4_EQUIVALENCE_6_2"); 
POP_TRACE(); 
return aux1269_783;} } } } 
}

