/*===========================================================================*/
/*   (Ieee/string.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo2.1a.h>
#include <signal.h>

static obj_t symbol1520___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1518___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1514___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1512___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1511___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1510___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1508___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1504___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1503___r4_strings_6_7 = BUNSPEC;
extern bool_t bigloo_strncmp_ci(obj_t, obj_t, long);
extern bool_t bigloo_strcmp(obj_t, obj_t);
static obj_t _blit_string_1318_217___r4_strings_6_7(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t string_to_symbol(char *);
extern bool_t string__76___r4_strings_6_7(obj_t);
extern bool_t substring___218___r4_strings_6_7(obj_t, obj_t, long);
extern obj_t string_set__176___r4_strings_6_7(obj_t, long, unsigned char);
extern obj_t string_append(obj_t, obj_t);
extern bool_t empty_string__16___r4_strings_6_7(obj_t);
extern bool_t bigloo_strncmp(obj_t, obj_t, long);
extern bool_t string____135___r4_strings_6_7(obj_t, obj_t);
extern obj_t blit_string_ur__74___r4_strings_6_7(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _string___1299_227___r4_strings_6_7(obj_t, obj_t, obj_t);
static obj_t _string_capitalize_1314_64___r4_strings_6_7(obj_t, obj_t);
static obj_t _string___1300_67___r4_strings_6_7(obj_t, obj_t, obj_t);
static obj_t _string_downcase_1313_48___r4_strings_6_7(obj_t, obj_t);
extern obj_t substring_ur_202___r4_strings_6_7(obj_t, long, long);
extern bool_t string____33___r4_strings_6_7(obj_t, obj_t);
extern obj_t string_fill__51___r4_strings_6_7(obj_t, unsigned char);
static obj_t _string_upcase1310_66___r4_strings_6_7(obj_t, obj_t);
extern obj_t list__string_78___r4_strings_6_7(obj_t);
static obj_t _substring_ur1306_38___r4_strings_6_7(obj_t, obj_t, obj_t, obj_t);
static obj_t _string_for_read1316_162___r4_strings_6_7(obj_t, obj_t);
static obj_t _substring1305___r4_strings_6_7(obj_t, obj_t, obj_t, obj_t);
extern obj_t string___r4_strings_6_7(obj_t);
static obj_t _string_ci__1301_149___r4_strings_6_7(obj_t, obj_t, obj_t);
extern obj_t string_copy_207___r4_strings_6_7(obj_t);
extern obj_t bigloo_type_error_location_103___error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _string__1297_239___r4_strings_6_7(obj_t, obj_t, obj_t);
extern unsigned char string_ref_ur_85___r4_strings_6_7(obj_t, long);
static obj_t loop___r4_strings_6_7(obj_t);
static obj_t _string_copy1308_66___r4_strings_6_7(obj_t, obj_t);
extern obj_t make_string_124___r4_strings_6_7(int, obj_t);
extern bool_t string_cilt(obj_t, obj_t);
extern obj_t string_for_read_25___r4_strings_6_7(obj_t);
extern bool_t string_cile(obj_t, obj_t);
static obj_t _string_capitalize1315_144___r4_strings_6_7(obj_t, obj_t);
extern obj_t string_to_bstring(char *);
extern bool_t string_cigt(obj_t, obj_t);
static obj_t _string_upcase_1312_143___r4_strings_6_7(obj_t, obj_t);
extern bool_t string_ci____43___r4_strings_6_7(obj_t, obj_t);
extern bool_t string_cige(obj_t, obj_t);
static obj_t _string_set_1289_73___r4_strings_6_7(obj_t, obj_t, obj_t, obj_t);
static obj_t _string_ci__1296_45___r4_strings_6_7(obj_t, obj_t, obj_t);
extern bool_t substring_ci___99___r4_strings_6_7(obj_t, obj_t, long);
static obj_t _string_ci___1303_129___r4_strings_6_7(obj_t, obj_t, obj_t);
extern obj_t string_set_ur__94___r4_strings_6_7(obj_t, long, unsigned char);
extern obj_t debug_error_location_199___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t string_capitalize__136___r4_strings_6_7(obj_t);
static obj_t _string_ref1288_56___r4_strings_6_7(obj_t, obj_t, obj_t);
static obj_t _string_ci___1304_187___r4_strings_6_7(obj_t, obj_t, obj_t);
static obj_t _string_fill_1309_109___r4_strings_6_7(obj_t, obj_t, obj_t);
extern obj_t make_string(long, unsigned char);
static obj_t _string___r4_strings_6_7(obj_t, obj_t);
static obj_t _substring__1293_154___r4_strings_6_7(obj_t, obj_t, obj_t, obj_t);
static obj_t _string_length1287_185___r4_strings_6_7(obj_t, obj_t);
extern long string_length_125___r4_strings_6_7(obj_t);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t c_substring(obj_t, long, long);
extern bool_t string_ci____210___r4_strings_6_7(obj_t, obj_t);
extern bool_t string___248___r4_strings_6_7(obj_t, obj_t);
extern bool_t string___146___r4_strings_6_7(obj_t, obj_t);
extern bool_t string___83___r4_strings_6_7(obj_t, obj_t);
static obj_t _string__1292_29___r4_strings_6_7(obj_t, obj_t, obj_t);
extern obj_t string_capitalize_230___r4_strings_6_7(obj_t);
static obj_t _string_set_ur_1291_206___r4_strings_6_7(obj_t, obj_t, obj_t, obj_t);
static obj_t _make_string1286_31___r4_strings_6_7(obj_t, obj_t, obj_t);
extern bool_t strcicmp(obj_t, obj_t);
extern obj_t substring___r4_strings_6_7(obj_t, long, long);
extern obj_t error_c_location_83___error(obj_t, obj_t, obj_t, char *, long);
static obj_t _string_ci__1302_205___r4_strings_6_7(obj_t, obj_t, obj_t);
extern long list_length(obj_t);
extern bool_t string_ci___60___r4_strings_6_7(obj_t, obj_t);
extern bool_t string_ci___247___r4_strings_6_7(obj_t, obj_t);
extern bool_t string_ci___92___r4_strings_6_7(obj_t, obj_t);
static obj_t _string__list1307_156___r4_strings_6_7(obj_t, obj_t);
static obj_t _string__1298_85___r4_strings_6_7(obj_t, obj_t, obj_t);
static obj_t _substring_ci__1294_82___r4_strings_6_7(obj_t, obj_t, obj_t, obj_t);
extern bool_t string_lt(obj_t, obj_t);
extern bool_t string_le(obj_t, obj_t);
static obj_t _string__159___r4_strings_6_7(obj_t, obj_t);
extern bool_t string_gt(obj_t, obj_t);
extern bool_t string_ge(obj_t, obj_t);
extern obj_t string_upcase__158___r4_strings_6_7(obj_t);
static obj_t _list__string_5___r4_strings_6_7(obj_t, obj_t);
static obj_t imported_modules_init_94___r4_strings_6_7();
extern obj_t string_append_106___r4_strings_6_7(obj_t);
extern obj_t string_downcase_77___r4_strings_6_7(obj_t);
static obj_t require_initialization_114___r4_strings_6_7 = BUNSPEC;
extern obj_t string__list_125___r4_strings_6_7(obj_t);
extern obj_t string_downcase__42___r4_strings_6_7(obj_t);
static obj_t _string_downcase1311_132___r4_strings_6_7(obj_t, obj_t);
static obj_t _string_append_156___r4_strings_6_7(obj_t, obj_t);
static obj_t _blit_string_ur_1317_25___r4_strings_6_7(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t string_for_read(obj_t);
static obj_t _empty_string_1295_96___r4_strings_6_7(obj_t, obj_t);
extern unsigned char string_ref_239___r4_strings_6_7(obj_t, long);
extern obj_t blit_string__141___r4_strings_6_7(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t symbol1589___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1590___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1586___r4_strings_6_7 = BUNSPEC;
static obj_t cnst_init_137___r4_strings_6_7();
static obj_t symbol1584___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1583___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1582___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1581___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1579___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1580___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1578___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1577___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1576___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1575___r4_strings_6_7 = BUNSPEC;
extern obj_t blit_string(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t symbol1574___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1573___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1572___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1571___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1569___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1570___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1568___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1567___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1566___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1565___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1564___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1563___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1562___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1561___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1559___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1558___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1557___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1556___r4_strings_6_7 = BUNSPEC;
extern obj_t string_upcase_71___r4_strings_6_7(obj_t);
static obj_t symbol1553___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1552___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1551___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1549___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1550___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1548___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1547___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1546___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1545___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1544___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1543___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1542___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1541___r4_strings_6_7 = BUNSPEC;
static obj_t _string_ref_ur1290_25___r4_strings_6_7(obj_t, obj_t, obj_t);
static obj_t symbol1539___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1540___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1538___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1537___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1536___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1535___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1534___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1533___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1532___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1531___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1529___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1530___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1528___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1527___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1526___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1525___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1524___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1523___r4_strings_6_7 = BUNSPEC;
static obj_t symbol1522___r4_strings_6_7 = BUNSPEC;
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( string_downcase_env_169___r4_strings_6_7, _string_downcase1311_132___r4_strings_6_71609, _string_downcase1311_132___r4_strings_6_7, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( string_upcase__env_48___r4_strings_6_7, _string_upcase_1312_143___r4_strings_6_71610, _string_upcase_1312_143___r4_strings_6_7, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( blit_string_ur__env_52___r4_strings_6_7, _blit_string_ur_1317_25___r4_strings_6_71611, _blit_string_ur_1317_25___r4_strings_6_7, 0L, 5 );
DEFINE_EXPORT_PROCEDURE( substring_ur_env_69___r4_strings_6_7, _substring_ur1306_38___r4_strings_6_71612, _substring_ur1306_38___r4_strings_6_7, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( string_set_ur__env_0___r4_strings_6_7, _string_set_ur_1291_206___r4_strings_6_71613, _string_set_ur_1291_206___r4_strings_6_7, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( string_length_env_217___r4_strings_6_7, _string_length1287_185___r4_strings_6_71614, _string_length1287_185___r4_strings_6_7, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( substring_ci___env_184___r4_strings_6_7, _substring_ci__1294_82___r4_strings_6_71615, _substring_ci__1294_82___r4_strings_6_7, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( string_ci____env_38___r4_strings_6_7, _string_ci___1303_129___r4_strings_6_71616, _string_ci___1303_129___r4_strings_6_7, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( string_ci____env_37___r4_strings_6_7, _string_ci___1304_187___r4_strings_6_71617, _string_ci___1304_187___r4_strings_6_7, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( string_fill__env_181___r4_strings_6_7, _string_fill_1309_109___r4_strings_6_71618, _string_fill_1309_109___r4_strings_6_7, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( string_downcase__env_73___r4_strings_6_7, _string_downcase_1313_48___r4_strings_6_71619, _string_downcase_1313_48___r4_strings_6_7, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( string_for_read_env_47___r4_strings_6_7, _string_for_read1316_162___r4_strings_6_71620, _string_for_read1316_162___r4_strings_6_7, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( string_env_246___r4_strings_6_7, _string___r4_strings_6_71621, va_generic_entry, _string___r4_strings_6_7, -1 );
DEFINE_EXPORT_PROCEDURE( string___env_245___r4_strings_6_7, _string__1297_239___r4_strings_6_71622, _string__1297_239___r4_strings_6_7, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( list__string_env_249___r4_strings_6_7, _list__string_5___r4_strings_6_71623, _list__string_5___r4_strings_6_7, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( string_ref_env_251___r4_strings_6_7, _string_ref1288_56___r4_strings_6_71624, _string_ref1288_56___r4_strings_6_7, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( string_ci___env_29___r4_strings_6_7, _string_ci__1301_149___r4_strings_6_71625, _string_ci__1301_149___r4_strings_6_7, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( string__list_env_217___r4_strings_6_7, _string__list1307_156___r4_strings_6_71626, _string__list1307_156___r4_strings_6_7, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( string_copy_env_8___r4_strings_6_7, _string_copy1308_66___r4_strings_6_71627, _string_copy1308_66___r4_strings_6_7, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( string___env_211___r4_strings_6_7, _string__1292_29___r4_strings_6_71628, _string__1292_29___r4_strings_6_7, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( empty_string__env_165___r4_strings_6_7, _empty_string_1295_96___r4_strings_6_71629, _empty_string_1295_96___r4_strings_6_7, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( string_set__env_239___r4_strings_6_7, _string_set_1289_73___r4_strings_6_71630, _string_set_1289_73___r4_strings_6_7, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( string_ref_ur_env_171___r4_strings_6_7, _string_ref_ur1290_25___r4_strings_6_71631, _string_ref_ur1290_25___r4_strings_6_7, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( string_ci___env_62___r4_strings_6_7, _string_ci__1296_45___r4_strings_6_71632, _string_ci__1296_45___r4_strings_6_7, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( substring___env_12___r4_strings_6_7, _substring__1293_154___r4_strings_6_71633, _substring__1293_154___r4_strings_6_7, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( string____env_63___r4_strings_6_7, _string___1299_227___r4_strings_6_71634, _string___1299_227___r4_strings_6_7, 0L, 2 );
DEFINE_STRING( string1588___r4_strings_6_7, string1588___r4_strings_6_71635, "Index and length out of range", 29 );
DEFINE_STRING( string1587___r4_strings_6_7, string1587___r4_strings_6_71636, "blit-string!", 12 );
DEFINE_STRING( string1585___r4_strings_6_7, string1585___r4_strings_6_71637, "BINT", 4 );
DEFINE_EXPORT_PROCEDURE( string____env_18___r4_strings_6_7, _string___1300_67___r4_strings_6_71638, _string___1300_67___r4_strings_6_7, 0L, 2 );
DEFINE_STRING( string1560___r4_strings_6_7, string1560___r4_strings_6_71639, "", 0 );
DEFINE_STRING( string1555___r4_strings_6_7, string1555___r4_strings_6_71640, "Illegal index", 13 );
DEFINE_STRING( string1554___r4_strings_6_7, string1554___r4_strings_6_71641, "substring", 9 );
DEFINE_EXPORT_PROCEDURE( string___env_124___r4_strings_6_7, _string__1298_85___r4_strings_6_71642, _string__1298_85___r4_strings_6_7, 0L, 2 );
DEFINE_STRING( string1521___r4_strings_6_7, string1521___r4_strings_6_71643, "string-set!", 11 );
DEFINE_STRING( string1519___r4_strings_6_7, string1519___r4_strings_6_71644, "LONG", 4 );
DEFINE_STRING( string1517___r4_strings_6_7, string1517___r4_strings_6_71645, "/home/tahoe2/serrano/tmp/bigloo/runtime/./Llib/error.scm", 56 );
DEFINE_STRING( string1516___r4_strings_6_7, string1516___r4_strings_6_71646, "index out of range", 18 );
DEFINE_STRING( string1515___r4_strings_6_7, string1515___r4_strings_6_71647, "string-ref", 10 );
DEFINE_STRING( string1513___r4_strings_6_7, string1513___r4_strings_6_71648, "BSTRING", 7 );
DEFINE_STRING( string1509___r4_strings_6_7, string1509___r4_strings_6_71649, "INT", 3 );
DEFINE_STRING( string1507___r4_strings_6_7, string1507___r4_strings_6_71650, "UCHAR", 5 );
DEFINE_STRING( string1506___r4_strings_6_7, string1506___r4_strings_6_71651, "/home/tahoe2/serrano/tmp/bigloo/runtime/Ieee/string.scm", 55 );
DEFINE_STRING( string1505___r4_strings_6_7, string1505___r4_strings_6_71652, "PAIR", 4 );
DEFINE_EXPORT_PROCEDURE( make_string_env_55___r4_strings_6_7, _make_string1286_31___r4_strings_6_71653, va_generic_entry, _make_string1286_31___r4_strings_6_7, -2 );
DEFINE_EXPORT_PROCEDURE( string_capitalize__env_137___r4_strings_6_7, _string_capitalize_1314_64___r4_strings_6_71654, _string_capitalize_1314_64___r4_strings_6_7, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( string_ci___env_46___r4_strings_6_7, _string_ci__1302_205___r4_strings_6_71655, _string_ci__1302_205___r4_strings_6_7, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( string_capitalize_env_253___r4_strings_6_7, _string_capitalize1315_144___r4_strings_6_71656, _string_capitalize1315_144___r4_strings_6_7, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( substring_env_248___r4_strings_6_7, _substring1305___r4_strings_6_71657, _substring1305___r4_strings_6_7, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( blit_string__env_232___r4_strings_6_7, _blit_string_1318_217___r4_strings_6_71658, _blit_string_1318_217___r4_strings_6_7, 0L, 5 );
DEFINE_EXPORT_PROCEDURE( string_append_env_17___r4_strings_6_7, _string_append_156___r4_strings_6_71659, va_generic_entry, _string_append_156___r4_strings_6_7, -1 );
DEFINE_EXPORT_PROCEDURE( string_upcase_env_136___r4_strings_6_7, _string_upcase1310_66___r4_strings_6_71660, _string_upcase1310_66___r4_strings_6_7, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( string__env_22___r4_strings_6_7, _string__159___r4_strings_6_71661, _string__159___r4_strings_6_7, 0L, 1 );



/* module-initialization */
obj_t module_initialization_70___r4_strings_6_7(long checksum_1294, char * from_1295)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___r4_strings_6_7))
{ 
require_initialization_114___r4_strings_6_7 = 
BBOOL(((bool_t)0)); 
cnst_init_137___r4_strings_6_7(); 
imported_modules_init_94___r4_strings_6_7(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___r4_strings_6_7()
{ AN_OBJECT;
{ /* Ieee/string.scm 18 */
symbol1503___r4_strings_6_7 = 
string_to_symbol("STRING?"); 
symbol1504___r4_strings_6_7 = 
string_to_symbol("MAKE-STRING"); 
symbol1508___r4_strings_6_7 = 
string_to_symbol("_MAKE-STRING1286"); 
symbol1510___r4_strings_6_7 = 
string_to_symbol("STRING"); 
symbol1511___r4_strings_6_7 = 
string_to_symbol("STRING-LENGTH"); 
symbol1512___r4_strings_6_7 = 
string_to_symbol("_STRING-LENGTH1287"); 
symbol1514___r4_strings_6_7 = 
string_to_symbol("STRING-REF"); 
symbol1518___r4_strings_6_7 = 
string_to_symbol("_STRING-REF1288"); 
symbol1520___r4_strings_6_7 = 
string_to_symbol("STRING-SET!"); 
symbol1522___r4_strings_6_7 = 
string_to_symbol("_STRING-SET!1289"); 
symbol1523___r4_strings_6_7 = 
string_to_symbol("STRING-REF-UR"); 
symbol1524___r4_strings_6_7 = 
string_to_symbol("_STRING-REF-UR1290"); 
symbol1525___r4_strings_6_7 = 
string_to_symbol("STRING-SET-UR!"); 
symbol1526___r4_strings_6_7 = 
string_to_symbol("_STRING-SET-UR!1291"); 
symbol1527___r4_strings_6_7 = 
string_to_symbol("STRING=?"); 
symbol1528___r4_strings_6_7 = 
string_to_symbol("_STRING=?1292"); 
symbol1529___r4_strings_6_7 = 
string_to_symbol("SUBSTRING=?"); 
symbol1530___r4_strings_6_7 = 
string_to_symbol("_SUBSTRING=?1293"); 
symbol1531___r4_strings_6_7 = 
string_to_symbol("SUBSTRING-CI=?"); 
symbol1532___r4_strings_6_7 = 
string_to_symbol("_SUBSTRING-CI=?1294"); 
symbol1533___r4_strings_6_7 = 
string_to_symbol("EMPTY-STRING?"); 
symbol1534___r4_strings_6_7 = 
string_to_symbol("_EMPTY-STRING?1295"); 
symbol1535___r4_strings_6_7 = 
string_to_symbol("STRING-CI=?"); 
symbol1536___r4_strings_6_7 = 
string_to_symbol("_STRING-CI=?1296"); 
symbol1537___r4_strings_6_7 = 
string_to_symbol("STRING<?"); 
symbol1538___r4_strings_6_7 = 
string_to_symbol("_STRING<?1297"); 
symbol1539___r4_strings_6_7 = 
string_to_symbol("STRING>?"); 
symbol1540___r4_strings_6_7 = 
string_to_symbol("_STRING>?1298"); 
symbol1541___r4_strings_6_7 = 
string_to_symbol("STRING<=?"); 
symbol1542___r4_strings_6_7 = 
string_to_symbol("_STRING<=?1299"); 
symbol1543___r4_strings_6_7 = 
string_to_symbol("STRING>=?"); 
symbol1544___r4_strings_6_7 = 
string_to_symbol("_STRING>=?1300"); 
symbol1545___r4_strings_6_7 = 
string_to_symbol("STRING-CI<?"); 
symbol1546___r4_strings_6_7 = 
string_to_symbol("_STRING-CI<?1301"); 
symbol1547___r4_strings_6_7 = 
string_to_symbol("STRING-CI>?"); 
symbol1548___r4_strings_6_7 = 
string_to_symbol("_STRING-CI>?1302"); 
symbol1549___r4_strings_6_7 = 
string_to_symbol("STRING-CI<=?"); 
symbol1550___r4_strings_6_7 = 
string_to_symbol("_STRING-CI<=?1303"); 
symbol1551___r4_strings_6_7 = 
string_to_symbol("STRING-CI>=?"); 
symbol1552___r4_strings_6_7 = 
string_to_symbol("_STRING-CI>=?1304"); 
symbol1553___r4_strings_6_7 = 
string_to_symbol("SUBSTRING"); 
symbol1556___r4_strings_6_7 = 
string_to_symbol("_SUBSTRING1305"); 
symbol1557___r4_strings_6_7 = 
string_to_symbol("SUBSTRING-UR"); 
symbol1558___r4_strings_6_7 = 
string_to_symbol("_SUBSTRING-UR1306"); 
symbol1559___r4_strings_6_7 = 
string_to_symbol("STRING-APPEND"); 
symbol1561___r4_strings_6_7 = 
string_to_symbol("LOOP"); 
symbol1562___r4_strings_6_7 = 
string_to_symbol("LIST->STRING"); 
symbol1563___r4_strings_6_7 = 
string_to_symbol("STRING->LIST"); 
symbol1564___r4_strings_6_7 = 
string_to_symbol("_STRING->LIST1307"); 
symbol1565___r4_strings_6_7 = 
string_to_symbol("STRING-COPY"); 
symbol1566___r4_strings_6_7 = 
string_to_symbol("_STRING-COPY1308"); 
symbol1567___r4_strings_6_7 = 
string_to_symbol("STRING-FILL!"); 
symbol1568___r4_strings_6_7 = 
string_to_symbol("_STRING-FILL!1309"); 
symbol1569___r4_strings_6_7 = 
string_to_symbol("STRING-UPCASE"); 
symbol1570___r4_strings_6_7 = 
string_to_symbol("_STRING-UPCASE1310"); 
symbol1571___r4_strings_6_7 = 
string_to_symbol("STRING-DOWNCASE"); 
symbol1572___r4_strings_6_7 = 
string_to_symbol("_STRING-DOWNCASE1311"); 
symbol1573___r4_strings_6_7 = 
string_to_symbol("STRING-UPCASE!"); 
symbol1574___r4_strings_6_7 = 
string_to_symbol("_STRING-UPCASE!1312"); 
symbol1575___r4_strings_6_7 = 
string_to_symbol("STRING-DOWNCASE!"); 
symbol1576___r4_strings_6_7 = 
string_to_symbol("_STRING-DOWNCASE!1313"); 
symbol1577___r4_strings_6_7 = 
string_to_symbol("STRING-CAPITALIZE!"); 
symbol1578___r4_strings_6_7 = 
string_to_symbol("_STRING-CAPITALIZE!1314"); 
symbol1579___r4_strings_6_7 = 
string_to_symbol("STRING-CAPITALIZE"); 
symbol1580___r4_strings_6_7 = 
string_to_symbol("_STRING-CAPITALIZE1315"); 
symbol1581___r4_strings_6_7 = 
string_to_symbol("STRING-FOR-READ"); 
symbol1582___r4_strings_6_7 = 
string_to_symbol("_STRING-FOR-READ1316"); 
symbol1583___r4_strings_6_7 = 
string_to_symbol("BLIT-STRING-UR!"); 
symbol1584___r4_strings_6_7 = 
string_to_symbol("_BLIT-STRING-UR!1317"); 
symbol1586___r4_strings_6_7 = 
string_to_symbol("BLIT-STRING!"); 
symbol1589___r4_strings_6_7 = 
string_to_symbol("_BLIT-STRING!1318"); 
return ( 
symbol1590___r4_strings_6_7 = 
string_to_symbol("IMPORTED-MODULES-INIT"), BUNSPEC) ;} 
}



/* string? */
bool_t string__76___r4_strings_6_7(obj_t obj_1)
{ AN_OBJECT;
{ /* Ieee/string.scm 137 */
{ /* Ieee/string.scm 138 */
obj_t symbol1211_1108;
symbol1211_1108 = symbol1503___r4_strings_6_7; 
{ /* Ieee/string.scm 138 */

PUSH_TRACE(symbol1211_1108); BUNSPEC; 
{ /* Ieee/string.scm 138 */
bool_t aux1210_1109;
aux1210_1109 = 
STRINGP(obj_1); 
POP_TRACE(); 
return aux1210_1109;} } } } 
}



/* _string? */
obj_t _string__159___r4_strings_6_7(obj_t env_816, obj_t obj_817)
{ AN_OBJECT;
{ /* Ieee/string.scm 137 */
{ /* Ieee/string.scm 137 */
bool_t aux_1376;
{ /* Ieee/string.scm 137 */
bool_t res1591_1113;
{ /* Ieee/string.scm 137 */
obj_t obj_1110;
obj_1110 = obj_817; 
{ /* Ieee/string.scm 138 */
obj_t symbol1211_1111;
symbol1211_1111 = symbol1503___r4_strings_6_7; 
{ /* Ieee/string.scm 138 */

PUSH_TRACE(symbol1211_1111); BUNSPEC; 
{ /* Ieee/string.scm 138 */
bool_t aux1210_1112;
aux1210_1112 = 
STRINGP(obj_1110); 
POP_TRACE(); 
res1591_1113 = aux1210_1112; } } } } 
aux_1376 = res1591_1113; } 
return 
BBOOL(aux_1376);} } 
}



/* make-string */
obj_t make_string_124___r4_strings_6_7(int k_2, obj_t char_3)
{ AN_OBJECT;
{ /* Ieee/string.scm 143 */
{ /* Ieee/string.scm 144 */
obj_t symbol1213_1114;
symbol1213_1114 = symbol1504___r4_strings_6_7; 
{ /* Ieee/string.scm 144 */

PUSH_TRACE(symbol1213_1114); BUNSPEC; 
{ /* Ieee/string.scm 144 */
obj_t aux1212_1115;
if(
NULLP(char_3))
{ /* Ieee/string.scm 145 */
long aux_1384;
aux_1384 = 
(long)(k_2); 
aux1212_1115 = 
make_string(aux_1384, ((unsigned char)' ')); }  else 
{ /* Ieee/string.scm 146 */
obj_t arg1007_1116;
{ /* Ieee/string.scm 146 */
obj_t pair_1117;
if(
PAIRP(char_3))
{ /* Ieee/string.scm 146 */
pair_1117 = char_3; }  else 
{ /* Ieee/string.scm 146 */
bigloo_type_error_location_103___error(symbol1504___r4_strings_6_7, string1505___r4_strings_6_7, char_3, string1506___r4_strings_6_7, 
BINT(((long)7368))); 
exit( -1 );} 
arg1007_1116 = 
CAR(pair_1117); } 
{ /* Ieee/string.scm 146 */
unsigned char aux_1395;long aux_1393;
{ /* Ieee/string.scm 146 */
obj_t aux_1396;
if(
CHARP(arg1007_1116))
{ /* Ieee/string.scm 146 */
aux_1396 = arg1007_1116
; }  else 
{ /* Ieee/string.scm 146 */
bigloo_type_error_location_103___error(symbol1504___r4_strings_6_7, string1507___r4_strings_6_7, arg1007_1116, string1506___r4_strings_6_7, 
BINT(((long)7350))); 
exit( -1 );} 
aux_1395 = 
(unsigned char)CCHAR(aux_1396); } 
aux_1393 = 
(long)(k_2); 
aux1212_1115 = 
make_string(aux_1393, aux_1395); } } 
POP_TRACE(); 
return aux1212_1115;} } } } 
}



/* _make-string1286 */
obj_t _make_string1286_31___r4_strings_6_7(obj_t env_818, obj_t k_819, obj_t char_820)
{ AN_OBJECT;
{ /* Ieee/string.scm 143 */
{ /* Ieee/string.scm 143 */
int k_1118;obj_t char_166_1119;
{ /* Ieee/string.scm 143 */
obj_t aux_1405;
if(
INTEGERP(k_819))
{ /* Ieee/string.scm 143 */
aux_1405 = k_819
; }  else 
{ /* Ieee/string.scm 143 */
bigloo_type_error_location_103___error(symbol1508___r4_strings_6_7, string1509___r4_strings_6_7, k_819, string1506___r4_strings_6_7, 
BINT(((long)7251))); 
exit( -1 );} 
k_1118 = 
CINT(aux_1405); } 
char_166_1119 = char_820; 
{ /* Ieee/string.scm 144 */
obj_t symbol1213_1120;
symbol1213_1120 = symbol1504___r4_strings_6_7; 
{ /* Ieee/string.scm 144 */

PUSH_TRACE(symbol1213_1120); BUNSPEC; 
{ /* Ieee/string.scm 144 */
obj_t aux1212_1121;
if(
NULLP(char_166_1119))
{ /* Ieee/string.scm 145 */
long aux_1415;
aux_1415 = 
(long)(k_1118); 
aux1212_1121 = 
make_string(aux_1415, ((unsigned char)' ')); }  else 
{ /* Ieee/string.scm 146 */
obj_t arg1007_1122;
{ /* Ieee/string.scm 146 */
obj_t pair_1123;
if(
PAIRP(char_166_1119))
{ /* Ieee/string.scm 146 */
pair_1123 = char_166_1119; }  else 
{ /* Ieee/string.scm 146 */
bigloo_type_error_location_103___error(symbol1504___r4_strings_6_7, string1505___r4_strings_6_7, char_166_1119, string1506___r4_strings_6_7, 
BINT(((long)7368))); 
exit( -1 );} 
arg1007_1122 = 
CAR(pair_1123); } 
{ /* Ieee/string.scm 146 */
unsigned char aux_1426;long aux_1424;
{ /* Ieee/string.scm 146 */
obj_t aux_1427;
if(
CHARP(arg1007_1122))
{ /* Ieee/string.scm 146 */
aux_1427 = arg1007_1122
; }  else 
{ /* Ieee/string.scm 146 */
bigloo_type_error_location_103___error(symbol1504___r4_strings_6_7, string1507___r4_strings_6_7, arg1007_1122, string1506___r4_strings_6_7, 
BINT(((long)7350))); 
exit( -1 );} 
aux_1426 = 
(unsigned char)CCHAR(aux_1427); } 
aux_1424 = 
(long)(k_1118); 
aux1212_1121 = 
make_string(aux_1424, aux_1426); } } 
POP_TRACE(); 
return aux1212_1121;} } } } } 
}



/* string */
obj_t string___r4_strings_6_7(obj_t chars_4)
{ AN_OBJECT;
{ /* Ieee/string.scm 151 */
{ /* Ieee/string.scm 152 */
obj_t symbol1215_1124;
symbol1215_1124 = symbol1510___r4_strings_6_7; 
{ /* Ieee/string.scm 152 */

PUSH_TRACE(symbol1215_1124); BUNSPEC; 
{ /* Ieee/string.scm 152 */
obj_t aux1214_1125;
aux1214_1125 = 
list__string_78___r4_strings_6_7(chars_4); 
POP_TRACE(); 
return aux1214_1125;} } } } 
}



/* _string */
obj_t _string___r4_strings_6_7(obj_t env_821, obj_t chars_822)
{ AN_OBJECT;
{ /* Ieee/string.scm 151 */
{ /* Ieee/string.scm 151 */
obj_t chars_1126;
chars_1126 = chars_822; 
{ /* Ieee/string.scm 152 */
obj_t symbol1215_1127;
symbol1215_1127 = symbol1510___r4_strings_6_7; 
{ /* Ieee/string.scm 152 */

PUSH_TRACE(symbol1215_1127); BUNSPEC; 
{ /* Ieee/string.scm 152 */
obj_t aux1214_1128;
aux1214_1128 = 
list__string_78___r4_strings_6_7(chars_1126); 
POP_TRACE(); 
return aux1214_1128;} } } } } 
}



/* string-length */
long string_length_125___r4_strings_6_7(obj_t string_5)
{ AN_OBJECT;
{ /* Ieee/string.scm 157 */
{ /* Ieee/string.scm 158 */
obj_t symbol1217_1129;
symbol1217_1129 = symbol1511___r4_strings_6_7; 
{ /* Ieee/string.scm 158 */

PUSH_TRACE(symbol1217_1129); BUNSPEC; 
{ /* Ieee/string.scm 158 */
long aux1216_1130;
aux1216_1130 = 
STRING_LENGTH(string_5); 
POP_TRACE(); 
return aux1216_1130;} } } } 
}



/* _string-length1287 */
obj_t _string_length1287_185___r4_strings_6_7(obj_t env_823, obj_t string_824)
{ AN_OBJECT;
{ /* Ieee/string.scm 157 */
{ /* Ieee/string.scm 157 */
long aux_1445;
{ /* Ieee/string.scm 157 */
long res1592_1134;
{ /* Ieee/string.scm 157 */
obj_t string_1131;
if(
STRINGP(string_824))
{ /* Ieee/string.scm 157 */
string_1131 = string_824; }  else 
{ /* Ieee/string.scm 157 */
bigloo_type_error_location_103___error(symbol1512___r4_strings_6_7, string1513___r4_strings_6_7, string_824, string1506___r4_strings_6_7, 
BINT(((long)7885))); 
exit( -1 );} 
{ /* Ieee/string.scm 158 */
obj_t symbol1217_1132;
symbol1217_1132 = symbol1511___r4_strings_6_7; 
{ /* Ieee/string.scm 158 */

PUSH_TRACE(symbol1217_1132); BUNSPEC; 
{ /* Ieee/string.scm 158 */
long aux1216_1133;
aux1216_1133 = 
STRING_LENGTH(string_1131); 
POP_TRACE(); 
res1592_1134 = aux1216_1133; } } } } 
aux_1445 = res1592_1134; } 
return 
BINT(aux_1445);} } 
}



/* string-ref */
unsigned char string_ref_239___r4_strings_6_7(obj_t string_6, long k_7)
{ AN_OBJECT;
{ /* Ieee/string.scm 163 */
{ /* Ieee/string.scm 164 */
obj_t symbol1219_1135;
symbol1219_1135 = symbol1514___r4_strings_6_7; 
{ /* Ieee/string.scm 164 */

PUSH_TRACE(symbol1219_1135); BUNSPEC; 
{ /* Ieee/string.scm 164 */
unsigned char aux1218_1136;
{ /* Ieee/string.scm 164 */
bool_t test_1456;
{ /* Ieee/string.scm 164 */
long aux_1457;
aux_1457 = 
STRING_LENGTH(string_6); 
test_1456 = 
BOUND_CHECK(k_7, aux_1457); } 
if(test_1456)
{ /* Ieee/string.scm 164 */
aux1218_1136 = 
STRING_REF(string_6, k_7); }  else 
{ /* Ieee/string.scm 164 */
error_c_location_83___error(string1515___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(k_7), "Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 601 */
obj_t aux_1463;
{ /* ./Llib/error.scm 601 */
obj_t aux1327_1137;
aux1327_1137 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
if(
CHARP(aux1327_1137))
{ /* ./Llib/error.scm 601 */
aux_1463 = aux1327_1137
; }  else 
{ /* ./Llib/error.scm 601 */
bigloo_type_error_location_103___error(symbol1514___r4_strings_6_7, string1507___r4_strings_6_7, aux1327_1137, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
exit( -1 );} } 
aux1218_1136 = 
(unsigned char)CCHAR(aux_1463); } } } 
POP_TRACE(); 
return aux1218_1136;} } } } 
}



/* _string-ref1288 */
obj_t _string_ref1288_56___r4_strings_6_7(obj_t env_825, obj_t string_826, obj_t k_827)
{ AN_OBJECT;
{ /* Ieee/string.scm 163 */
{ /* Ieee/string.scm 163 */
unsigned char aux_1473;
{ /* Ieee/string.scm 163 */
unsigned char res1593_1143;
{ /* Ieee/string.scm 163 */
obj_t string_1138;long k_1139;
if(
STRINGP(string_826))
{ /* Ieee/string.scm 163 */
string_1138 = string_826; }  else 
{ /* Ieee/string.scm 163 */
bigloo_type_error_location_103___error(symbol1518___r4_strings_6_7, string1513___r4_strings_6_7, string_826, string1506___r4_strings_6_7, 
BINT(((long)8175))); 
exit( -1 );} 
{ /* Ieee/string.scm 163 */
obj_t aux_1479;
if(
INTEGERP(k_827))
{ /* Ieee/string.scm 163 */
aux_1479 = k_827
; }  else 
{ /* Ieee/string.scm 163 */
bigloo_type_error_location_103___error(symbol1518___r4_strings_6_7, string1519___r4_strings_6_7, k_827, string1506___r4_strings_6_7, 
BINT(((long)8175))); 
exit( -1 );} 
k_1139 = 
(long)CINT(aux_1479); } 
{ /* Ieee/string.scm 164 */
obj_t symbol1219_1140;
symbol1219_1140 = symbol1514___r4_strings_6_7; 
{ /* Ieee/string.scm 164 */

PUSH_TRACE(symbol1219_1140); BUNSPEC; 
{ /* Ieee/string.scm 164 */
unsigned char aux1218_1141;
{ /* Ieee/string.scm 164 */
bool_t test_1487;
{ /* Ieee/string.scm 164 */
long aux_1488;
aux_1488 = 
STRING_LENGTH(string_1138); 
test_1487 = 
BOUND_CHECK(k_1139, aux_1488); } 
if(test_1487)
{ /* Ieee/string.scm 164 */
aux1218_1141 = 
STRING_REF(string_1138, k_1139); }  else 
{ /* Ieee/string.scm 164 */
error_c_location_83___error(string1515___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(k_1139), "Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 601 */
obj_t aux_1494;
{ /* ./Llib/error.scm 601 */
obj_t aux1327_1142;
aux1327_1142 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
if(
CHARP(aux1327_1142))
{ /* ./Llib/error.scm 601 */
aux_1494 = aux1327_1142
; }  else 
{ /* ./Llib/error.scm 601 */
bigloo_type_error_location_103___error(symbol1514___r4_strings_6_7, string1507___r4_strings_6_7, aux1327_1142, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
exit( -1 );} } 
aux1218_1141 = 
(unsigned char)CCHAR(aux_1494); } } } 
POP_TRACE(); 
res1593_1143 = aux1218_1141; } } } } 
aux_1473 = res1593_1143; } 
return 
BCHAR(aux_1473);} } 
}



/* string-set! */
obj_t string_set__176___r4_strings_6_7(obj_t string_8, long k_9, unsigned char char_10)
{ AN_OBJECT;
{ /* Ieee/string.scm 171 */
{ /* Ieee/string.scm 172 */
obj_t symbol1221_1144;
symbol1221_1144 = symbol1520___r4_strings_6_7; 
{ /* Ieee/string.scm 172 */

PUSH_TRACE(symbol1221_1144); BUNSPEC; 
{ /* Ieee/string.scm 172 */
obj_t aux1220_1145;
{ /* Ieee/string.scm 172 */
bool_t test_1506;
{ /* Ieee/string.scm 172 */
long aux_1507;
aux_1507 = 
STRING_LENGTH(string_8); 
test_1506 = 
BOUND_CHECK(k_9, aux_1507); } 
if(test_1506)
{ /* Ieee/string.scm 172 */
aux1220_1145 = 
STRING_SET(string_8, k_9, char_10); }  else 
{ /* Ieee/string.scm 172 */
error_c_location_83___error(string1521___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(k_9), "Ieee/string.scm", ((long)8715)); 
aux1220_1145 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); } } 
POP_TRACE(); 
return aux1220_1145;} } } } 
}



/* _string-set!1289 */
obj_t _string_set_1289_73___r4_strings_6_7(obj_t env_828, obj_t string_829, obj_t k_830, obj_t char_831)
{ AN_OBJECT;
{ /* Ieee/string.scm 171 */
{ /* Ieee/string.scm 171 */
obj_t string_1146;long k_1147;unsigned char char_166_1148;
if(
STRINGP(string_829))
{ /* Ieee/string.scm 171 */
string_1146 = string_829; }  else 
{ /* Ieee/string.scm 171 */
bigloo_type_error_location_103___error(symbol1522___r4_strings_6_7, string1513___r4_strings_6_7, string_829, string1506___r4_strings_6_7, 
BINT(((long)8574))); 
exit( -1 );} 
{ /* Ieee/string.scm 171 */
obj_t aux_1521;
if(
INTEGERP(k_830))
{ /* Ieee/string.scm 171 */
aux_1521 = k_830
; }  else 
{ /* Ieee/string.scm 171 */
bigloo_type_error_location_103___error(symbol1522___r4_strings_6_7, string1519___r4_strings_6_7, k_830, string1506___r4_strings_6_7, 
BINT(((long)8574))); 
exit( -1 );} 
k_1147 = 
(long)CINT(aux_1521); } 
{ /* Ieee/string.scm 171 */
obj_t aux_1528;
if(
CHARP(char_831))
{ /* Ieee/string.scm 171 */
aux_1528 = char_831
; }  else 
{ /* Ieee/string.scm 171 */
bigloo_type_error_location_103___error(symbol1522___r4_strings_6_7, string1507___r4_strings_6_7, char_831, string1506___r4_strings_6_7, 
BINT(((long)8574))); 
exit( -1 );} 
char_166_1148 = 
(unsigned char)CCHAR(aux_1528); } 
{ /* Ieee/string.scm 172 */
obj_t symbol1221_1149;
symbol1221_1149 = symbol1520___r4_strings_6_7; 
{ /* Ieee/string.scm 172 */

PUSH_TRACE(symbol1221_1149); BUNSPEC; 
{ /* Ieee/string.scm 172 */
obj_t aux1220_1150;
{ /* Ieee/string.scm 172 */
bool_t test_1536;
{ /* Ieee/string.scm 172 */
long aux_1537;
aux_1537 = 
STRING_LENGTH(string_1146); 
test_1536 = 
BOUND_CHECK(k_1147, aux_1537); } 
if(test_1536)
{ /* Ieee/string.scm 172 */
aux1220_1150 = 
STRING_SET(string_1146, k_1147, char_166_1148); }  else 
{ /* Ieee/string.scm 172 */
error_c_location_83___error(string1521___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(k_1147), "Ieee/string.scm", ((long)8715)); 
aux1220_1150 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); } } 
POP_TRACE(); 
return aux1220_1150;} } } } } 
}



/* string-ref-ur */
unsigned char string_ref_ur_85___r4_strings_6_7(obj_t string_11, long k_12)
{ AN_OBJECT;
{ /* Ieee/string.scm 179 */
{ /* Ieee/string.scm 180 */
obj_t symbol1223_1151;
symbol1223_1151 = symbol1523___r4_strings_6_7; 
{ /* Ieee/string.scm 180 */

PUSH_TRACE(symbol1223_1151); BUNSPEC; 
{ /* Ieee/string.scm 180 */
unsigned char aux1222_1152;
aux1222_1152 = 
STRING_REF(string_11, k_12); 
POP_TRACE(); 
return aux1222_1152;} } } } 
}



/* _string-ref-ur1290 */
obj_t _string_ref_ur1290_25___r4_strings_6_7(obj_t env_832, obj_t string_833, obj_t k_834)
{ AN_OBJECT;
{ /* Ieee/string.scm 179 */
{ /* Ieee/string.scm 179 */
unsigned char aux_1549;
{ /* Ieee/string.scm 179 */
unsigned char res1594_1157;
{ /* Ieee/string.scm 179 */
obj_t string_1153;long k_1154;
if(
STRINGP(string_833))
{ /* Ieee/string.scm 179 */
string_1153 = string_833; }  else 
{ /* Ieee/string.scm 179 */
bigloo_type_error_location_103___error(symbol1524___r4_strings_6_7, string1513___r4_strings_6_7, string_833, string1506___r4_strings_6_7, 
BINT(((long)8985))); 
exit( -1 );} 
{ /* Ieee/string.scm 179 */
obj_t aux_1555;
if(
INTEGERP(k_834))
{ /* Ieee/string.scm 179 */
aux_1555 = k_834
; }  else 
{ /* Ieee/string.scm 179 */
bigloo_type_error_location_103___error(symbol1524___r4_strings_6_7, string1519___r4_strings_6_7, k_834, string1506___r4_strings_6_7, 
BINT(((long)8985))); 
exit( -1 );} 
k_1154 = 
(long)CINT(aux_1555); } 
{ /* Ieee/string.scm 180 */
obj_t symbol1223_1155;
symbol1223_1155 = symbol1523___r4_strings_6_7; 
{ /* Ieee/string.scm 180 */

PUSH_TRACE(symbol1223_1155); BUNSPEC; 
{ /* Ieee/string.scm 180 */
unsigned char aux1222_1156;
aux1222_1156 = 
STRING_REF(string_1153, k_1154); 
POP_TRACE(); 
res1594_1157 = aux1222_1156; } } } } 
aux_1549 = res1594_1157; } 
return 
BCHAR(aux_1549);} } 
}



/* string-set-ur! */
obj_t string_set_ur__94___r4_strings_6_7(obj_t string_13, long k_14, unsigned char char_15)
{ AN_OBJECT;
{ /* Ieee/string.scm 185 */
{ /* Ieee/string.scm 186 */
obj_t symbol1225_1158;
symbol1225_1158 = symbol1525___r4_strings_6_7; 
{ /* Ieee/string.scm 186 */

PUSH_TRACE(symbol1225_1158); BUNSPEC; 
{ /* Ieee/string.scm 186 */
obj_t aux1224_1159;
aux1224_1159 = 
STRING_SET(string_13, k_14, char_15); 
POP_TRACE(); 
return aux1224_1159;} } } } 
}



/* _string-set-ur!1291 */
obj_t _string_set_ur_1291_206___r4_strings_6_7(obj_t env_835, obj_t string_836, obj_t k_837, obj_t char_838)
{ AN_OBJECT;
{ /* Ieee/string.scm 185 */
{ /* Ieee/string.scm 185 */
obj_t string_1160;long k_1161;unsigned char char_166_1162;
if(
STRINGP(string_836))
{ /* Ieee/string.scm 185 */
string_1160 = string_836; }  else 
{ /* Ieee/string.scm 185 */
bigloo_type_error_location_103___error(symbol1526___r4_strings_6_7, string1513___r4_strings_6_7, string_836, string1506___r4_strings_6_7, 
BINT(((long)9277))); 
exit( -1 );} 
{ /* Ieee/string.scm 185 */
obj_t aux_1574;
if(
INTEGERP(k_837))
{ /* Ieee/string.scm 185 */
aux_1574 = k_837
; }  else 
{ /* Ieee/string.scm 185 */
bigloo_type_error_location_103___error(symbol1526___r4_strings_6_7, string1519___r4_strings_6_7, k_837, string1506___r4_strings_6_7, 
BINT(((long)9277))); 
exit( -1 );} 
k_1161 = 
(long)CINT(aux_1574); } 
{ /* Ieee/string.scm 185 */
obj_t aux_1581;
if(
CHARP(char_838))
{ /* Ieee/string.scm 185 */
aux_1581 = char_838
; }  else 
{ /* Ieee/string.scm 185 */
bigloo_type_error_location_103___error(symbol1526___r4_strings_6_7, string1507___r4_strings_6_7, char_838, string1506___r4_strings_6_7, 
BINT(((long)9277))); 
exit( -1 );} 
char_166_1162 = 
(unsigned char)CCHAR(aux_1581); } 
{ /* Ieee/string.scm 186 */
obj_t symbol1225_1163;
symbol1225_1163 = symbol1525___r4_strings_6_7; 
{ /* Ieee/string.scm 186 */

PUSH_TRACE(symbol1225_1163); BUNSPEC; 
{ /* Ieee/string.scm 186 */
obj_t aux1224_1164;
aux1224_1164 = 
STRING_SET(string_1160, k_1161, char_166_1162); 
POP_TRACE(); 
return aux1224_1164;} } } } } 
}



/* string=? */
bool_t string___146___r4_strings_6_7(obj_t string1_16, obj_t string2_17)
{ AN_OBJECT;
{ /* Ieee/string.scm 191 */
{ /* Ieee/string.scm 192 */
obj_t symbol1227_1165;
symbol1227_1165 = symbol1527___r4_strings_6_7; 
{ /* Ieee/string.scm 192 */

PUSH_TRACE(symbol1227_1165); BUNSPEC; 
{ /* Ieee/string.scm 192 */
bool_t aux1226_1166;
aux1226_1166 = 
bigloo_strcmp(string1_16, string2_17); 
POP_TRACE(); 
return aux1226_1166;} } } } 
}



/* _string=?1292 */
obj_t _string__1292_29___r4_strings_6_7(obj_t env_839, obj_t string1_840, obj_t string2_841)
{ AN_OBJECT;
{ /* Ieee/string.scm 191 */
{ /* Ieee/string.scm 191 */
bool_t aux_1594;
{ /* Ieee/string.scm 191 */
bool_t res1595_1171;
{ /* Ieee/string.scm 191 */
obj_t string1_1167;obj_t string2_1168;
if(
STRINGP(string1_840))
{ /* Ieee/string.scm 191 */
string1_1167 = string1_840; }  else 
{ /* Ieee/string.scm 191 */
bigloo_type_error_location_103___error(symbol1528___r4_strings_6_7, string1513___r4_strings_6_7, string1_840, string1506___r4_strings_6_7, 
BINT(((long)9580))); 
exit( -1 );} 
if(
STRINGP(string2_841))
{ /* Ieee/string.scm 191 */
string2_1168 = string2_841; }  else 
{ /* Ieee/string.scm 191 */
bigloo_type_error_location_103___error(symbol1528___r4_strings_6_7, string1513___r4_strings_6_7, string2_841, string1506___r4_strings_6_7, 
BINT(((long)9580))); 
exit( -1 );} 
{ /* Ieee/string.scm 192 */
obj_t symbol1227_1169;
symbol1227_1169 = symbol1527___r4_strings_6_7; 
{ /* Ieee/string.scm 192 */

PUSH_TRACE(symbol1227_1169); BUNSPEC; 
{ /* Ieee/string.scm 192 */
bool_t aux1226_1170;
aux1226_1170 = 
bigloo_strcmp(string1_1167, string2_1168); 
POP_TRACE(); 
res1595_1171 = aux1226_1170; } } } } 
aux_1594 = res1595_1171; } 
return 
BBOOL(aux_1594);} } 
}



/* substring=? */
bool_t substring___218___r4_strings_6_7(obj_t string1_18, obj_t string2_19, long len_20)
{ AN_OBJECT;
{ /* Ieee/string.scm 197 */
{ /* Ieee/string.scm 198 */
obj_t symbol1229_1172;
symbol1229_1172 = symbol1529___r4_strings_6_7; 
{ /* Ieee/string.scm 198 */

PUSH_TRACE(symbol1229_1172); BUNSPEC; 
{ /* Ieee/string.scm 198 */
bool_t aux1228_1173;
aux1228_1173 = 
bigloo_strncmp(string1_18, string2_19, len_20); 
POP_TRACE(); 
return aux1228_1173;} } } } 
}



/* _substring=?1293 */
obj_t _substring__1293_154___r4_strings_6_7(obj_t env_842, obj_t string1_843, obj_t string2_844, obj_t len_845)
{ AN_OBJECT;
{ /* Ieee/string.scm 197 */
{ /* Ieee/string.scm 197 */
bool_t aux_1612;
{ /* Ieee/string.scm 197 */
bool_t res1596_1179;
{ /* Ieee/string.scm 197 */
obj_t string1_1174;obj_t string2_1175;long len_1176;
if(
STRINGP(string1_843))
{ /* Ieee/string.scm 197 */
string1_1174 = string1_843; }  else 
{ /* Ieee/string.scm 197 */
bigloo_type_error_location_103___error(symbol1530___r4_strings_6_7, string1513___r4_strings_6_7, string1_843, string1506___r4_strings_6_7, 
BINT(((long)9878))); 
exit( -1 );} 
if(
STRINGP(string2_844))
{ /* Ieee/string.scm 197 */
string2_1175 = string2_844; }  else 
{ /* Ieee/string.scm 197 */
bigloo_type_error_location_103___error(symbol1530___r4_strings_6_7, string1513___r4_strings_6_7, string2_844, string1506___r4_strings_6_7, 
BINT(((long)9878))); 
exit( -1 );} 
{ /* Ieee/string.scm 197 */
obj_t aux_1623;
if(
INTEGERP(len_845))
{ /* Ieee/string.scm 197 */
aux_1623 = len_845
; }  else 
{ /* Ieee/string.scm 197 */
bigloo_type_error_location_103___error(symbol1530___r4_strings_6_7, string1519___r4_strings_6_7, len_845, string1506___r4_strings_6_7, 
BINT(((long)9878))); 
exit( -1 );} 
len_1176 = 
(long)CINT(aux_1623); } 
{ /* Ieee/string.scm 198 */
obj_t symbol1229_1177;
symbol1229_1177 = symbol1529___r4_strings_6_7; 
{ /* Ieee/string.scm 198 */

PUSH_TRACE(symbol1229_1177); BUNSPEC; 
{ /* Ieee/string.scm 198 */
bool_t aux1228_1178;
aux1228_1178 = 
bigloo_strncmp(string1_1174, string2_1175, len_1176); 
POP_TRACE(); 
res1596_1179 = aux1228_1178; } } } } 
aux_1612 = res1596_1179; } 
return 
BBOOL(aux_1612);} } 
}



/* substring-ci=? */
bool_t substring_ci___99___r4_strings_6_7(obj_t string1_21, obj_t string2_22, long len_23)
{ AN_OBJECT;
{ /* Ieee/string.scm 203 */
{ /* Ieee/string.scm 204 */
obj_t symbol1231_1180;
symbol1231_1180 = symbol1531___r4_strings_6_7; 
{ /* Ieee/string.scm 204 */

PUSH_TRACE(symbol1231_1180); BUNSPEC; 
{ /* Ieee/string.scm 204 */
bool_t aux1230_1181;
aux1230_1181 = 
bigloo_strncmp_ci(string1_21, string2_22, len_23); 
POP_TRACE(); 
return aux1230_1181;} } } } 
}



/* _substring-ci=?1294 */
obj_t _substring_ci__1294_82___r4_strings_6_7(obj_t env_846, obj_t string1_847, obj_t string2_848, obj_t len_849)
{ AN_OBJECT;
{ /* Ieee/string.scm 203 */
{ /* Ieee/string.scm 203 */
bool_t aux_1637;
{ /* Ieee/string.scm 203 */
bool_t res1597_1187;
{ /* Ieee/string.scm 203 */
obj_t string1_1182;obj_t string2_1183;long len_1184;
if(
STRINGP(string1_847))
{ /* Ieee/string.scm 203 */
string1_1182 = string1_847; }  else 
{ /* Ieee/string.scm 203 */
bigloo_type_error_location_103___error(symbol1532___r4_strings_6_7, string1513___r4_strings_6_7, string1_847, string1506___r4_strings_6_7, 
BINT(((long)10190))); 
exit( -1 );} 
if(
STRINGP(string2_848))
{ /* Ieee/string.scm 203 */
string2_1183 = string2_848; }  else 
{ /* Ieee/string.scm 203 */
bigloo_type_error_location_103___error(symbol1532___r4_strings_6_7, string1513___r4_strings_6_7, string2_848, string1506___r4_strings_6_7, 
BINT(((long)10190))); 
exit( -1 );} 
{ /* Ieee/string.scm 203 */
obj_t aux_1648;
if(
INTEGERP(len_849))
{ /* Ieee/string.scm 203 */
aux_1648 = len_849
; }  else 
{ /* Ieee/string.scm 203 */
bigloo_type_error_location_103___error(symbol1532___r4_strings_6_7, string1519___r4_strings_6_7, len_849, string1506___r4_strings_6_7, 
BINT(((long)10190))); 
exit( -1 );} 
len_1184 = 
(long)CINT(aux_1648); } 
{ /* Ieee/string.scm 204 */
obj_t symbol1231_1185;
symbol1231_1185 = symbol1531___r4_strings_6_7; 
{ /* Ieee/string.scm 204 */

PUSH_TRACE(symbol1231_1185); BUNSPEC; 
{ /* Ieee/string.scm 204 */
bool_t aux1230_1186;
aux1230_1186 = 
bigloo_strncmp_ci(string1_1182, string2_1183, len_1184); 
POP_TRACE(); 
res1597_1187 = aux1230_1186; } } } } 
aux_1637 = res1597_1187; } 
return 
BBOOL(aux_1637);} } 
}



/* empty-string? */
bool_t empty_string__16___r4_strings_6_7(obj_t string_24)
{ AN_OBJECT;
{ /* Ieee/string.scm 209 */
{ /* Ieee/string.scm 210 */
obj_t symbol1233_1188;
symbol1233_1188 = symbol1533___r4_strings_6_7; 
{ /* Ieee/string.scm 210 */

PUSH_TRACE(symbol1233_1188); BUNSPEC; 
{ /* Ieee/string.scm 210 */
bool_t aux1232_1189;
{ /* ./Ieee/fixnum.scm 1729 */
long aux_1660;
aux_1660 = 
STRING_LENGTH(string_24); 
aux1232_1189 = 
(aux_1660==((long)0)); } 
POP_TRACE(); 
return aux1232_1189;} } } } 
}



/* _empty-string?1295 */
obj_t _empty_string_1295_96___r4_strings_6_7(obj_t env_850, obj_t string_851)
{ AN_OBJECT;
{ /* Ieee/string.scm 209 */
{ /* Ieee/string.scm 209 */
bool_t aux_1664;
{ /* Ieee/string.scm 209 */
bool_t res1598_1193;
{ /* Ieee/string.scm 209 */
obj_t string_1190;
if(
STRINGP(string_851))
{ /* Ieee/string.scm 209 */
string_1190 = string_851; }  else 
{ /* Ieee/string.scm 209 */
bigloo_type_error_location_103___error(symbol1534___r4_strings_6_7, string1513___r4_strings_6_7, string_851, string1506___r4_strings_6_7, 
BINT(((long)10508))); 
exit( -1 );} 
{ /* Ieee/string.scm 210 */
obj_t symbol1233_1191;
symbol1233_1191 = symbol1533___r4_strings_6_7; 
{ /* Ieee/string.scm 210 */

PUSH_TRACE(symbol1233_1191); BUNSPEC; 
{ /* Ieee/string.scm 210 */
bool_t aux1232_1192;
{ /* ./Ieee/fixnum.scm 1729 */
long aux_1671;
aux_1671 = 
STRING_LENGTH(string_1190); 
aux1232_1192 = 
(aux_1671==((long)0)); } 
POP_TRACE(); 
res1598_1193 = aux1232_1192; } } } } 
aux_1664 = res1598_1193; } 
return 
BBOOL(aux_1664);} } 
}



/* string-ci=? */
bool_t string_ci___247___r4_strings_6_7(obj_t string1_25, obj_t string2_26)
{ AN_OBJECT;
{ /* Ieee/string.scm 215 */
{ /* Ieee/string.scm 216 */
obj_t symbol1235_1194;
symbol1235_1194 = symbol1535___r4_strings_6_7; 
{ /* Ieee/string.scm 216 */

PUSH_TRACE(symbol1235_1194); BUNSPEC; 
{ /* Ieee/string.scm 216 */
bool_t aux1234_1195;
aux1234_1195 = 
strcicmp(string1_25, string2_26); 
POP_TRACE(); 
return aux1234_1195;} } } } 
}



/* _string-ci=?1296 */
obj_t _string_ci__1296_45___r4_strings_6_7(obj_t env_852, obj_t string1_853, obj_t string2_854)
{ AN_OBJECT;
{ /* Ieee/string.scm 215 */
{ /* Ieee/string.scm 215 */
bool_t aux_1679;
{ /* Ieee/string.scm 215 */
bool_t res1599_1200;
{ /* Ieee/string.scm 215 */
obj_t string1_1196;obj_t string2_1197;
if(
STRINGP(string1_853))
{ /* Ieee/string.scm 215 */
string1_1196 = string1_853; }  else 
{ /* Ieee/string.scm 215 */
bigloo_type_error_location_103___error(symbol1536___r4_strings_6_7, string1513___r4_strings_6_7, string1_853, string1506___r4_strings_6_7, 
BINT(((long)10804))); 
exit( -1 );} 
if(
STRINGP(string2_854))
{ /* Ieee/string.scm 215 */
string2_1197 = string2_854; }  else 
{ /* Ieee/string.scm 215 */
bigloo_type_error_location_103___error(symbol1536___r4_strings_6_7, string1513___r4_strings_6_7, string2_854, string1506___r4_strings_6_7, 
BINT(((long)10804))); 
exit( -1 );} 
{ /* Ieee/string.scm 216 */
obj_t symbol1235_1198;
symbol1235_1198 = symbol1535___r4_strings_6_7; 
{ /* Ieee/string.scm 216 */

PUSH_TRACE(symbol1235_1198); BUNSPEC; 
{ /* Ieee/string.scm 216 */
bool_t aux1234_1199;
aux1234_1199 = 
strcicmp(string1_1196, string2_1197); 
POP_TRACE(); 
res1599_1200 = aux1234_1199; } } } } 
aux_1679 = res1599_1200; } 
return 
BBOOL(aux_1679);} } 
}



/* string<? */
bool_t string___83___r4_strings_6_7(obj_t string1_27, obj_t string2_28)
{ AN_OBJECT;
{ /* Ieee/string.scm 221 */
{ /* Ieee/string.scm 222 */
obj_t symbol1237_1201;
symbol1237_1201 = symbol1537___r4_strings_6_7; 
{ /* Ieee/string.scm 222 */

PUSH_TRACE(symbol1237_1201); BUNSPEC; 
{ /* Ieee/string.scm 222 */
bool_t aux1236_1202;
aux1236_1202 = 
string_lt(string1_27, string2_28); 
POP_TRACE(); 
return aux1236_1202;} } } } 
}



/* _string<?1297 */
obj_t _string__1297_239___r4_strings_6_7(obj_t env_855, obj_t string1_856, obj_t string2_857)
{ AN_OBJECT;
{ /* Ieee/string.scm 221 */
{ /* Ieee/string.scm 221 */
bool_t aux_1697;
{ /* Ieee/string.scm 221 */
bool_t res1600_1207;
{ /* Ieee/string.scm 221 */
obj_t string1_1203;obj_t string2_1204;
if(
STRINGP(string1_856))
{ /* Ieee/string.scm 221 */
string1_1203 = string1_856; }  else 
{ /* Ieee/string.scm 221 */
bigloo_type_error_location_103___error(symbol1538___r4_strings_6_7, string1513___r4_strings_6_7, string1_856, string1506___r4_strings_6_7, 
BINT(((long)11103))); 
exit( -1 );} 
if(
STRINGP(string2_857))
{ /* Ieee/string.scm 221 */
string2_1204 = string2_857; }  else 
{ /* Ieee/string.scm 221 */
bigloo_type_error_location_103___error(symbol1538___r4_strings_6_7, string1513___r4_strings_6_7, string2_857, string1506___r4_strings_6_7, 
BINT(((long)11103))); 
exit( -1 );} 
{ /* Ieee/string.scm 222 */
obj_t symbol1237_1205;
symbol1237_1205 = symbol1537___r4_strings_6_7; 
{ /* Ieee/string.scm 222 */

PUSH_TRACE(symbol1237_1205); BUNSPEC; 
{ /* Ieee/string.scm 222 */
bool_t aux1236_1206;
aux1236_1206 = 
string_lt(string1_1203, string2_1204); 
POP_TRACE(); 
res1600_1207 = aux1236_1206; } } } } 
aux_1697 = res1600_1207; } 
return 
BBOOL(aux_1697);} } 
}



/* string>? */
bool_t string___248___r4_strings_6_7(obj_t string1_29, obj_t string2_30)
{ AN_OBJECT;
{ /* Ieee/string.scm 227 */
{ /* Ieee/string.scm 228 */
obj_t symbol1239_1208;
symbol1239_1208 = symbol1539___r4_strings_6_7; 
{ /* Ieee/string.scm 228 */

PUSH_TRACE(symbol1239_1208); BUNSPEC; 
{ /* Ieee/string.scm 228 */
bool_t aux1238_1209;
aux1238_1209 = 
string_gt(string1_29, string2_30); 
POP_TRACE(); 
return aux1238_1209;} } } } 
}



/* _string>?1298 */
obj_t _string__1298_85___r4_strings_6_7(obj_t env_858, obj_t string1_859, obj_t string2_860)
{ AN_OBJECT;
{ /* Ieee/string.scm 227 */
{ /* Ieee/string.scm 227 */
bool_t aux_1715;
{ /* Ieee/string.scm 227 */
bool_t res1601_1214;
{ /* Ieee/string.scm 227 */
obj_t string1_1210;obj_t string2_1211;
if(
STRINGP(string1_859))
{ /* Ieee/string.scm 227 */
string1_1210 = string1_859; }  else 
{ /* Ieee/string.scm 227 */
bigloo_type_error_location_103___error(symbol1540___r4_strings_6_7, string1513___r4_strings_6_7, string1_859, string1506___r4_strings_6_7, 
BINT(((long)11400))); 
exit( -1 );} 
if(
STRINGP(string2_860))
{ /* Ieee/string.scm 227 */
string2_1211 = string2_860; }  else 
{ /* Ieee/string.scm 227 */
bigloo_type_error_location_103___error(symbol1540___r4_strings_6_7, string1513___r4_strings_6_7, string2_860, string1506___r4_strings_6_7, 
BINT(((long)11400))); 
exit( -1 );} 
{ /* Ieee/string.scm 228 */
obj_t symbol1239_1212;
symbol1239_1212 = symbol1539___r4_strings_6_7; 
{ /* Ieee/string.scm 228 */

PUSH_TRACE(symbol1239_1212); BUNSPEC; 
{ /* Ieee/string.scm 228 */
bool_t aux1238_1213;
aux1238_1213 = 
string_gt(string1_1210, string2_1211); 
POP_TRACE(); 
res1601_1214 = aux1238_1213; } } } } 
aux_1715 = res1601_1214; } 
return 
BBOOL(aux_1715);} } 
}



/* string<=? */
bool_t string____33___r4_strings_6_7(obj_t string1_31, obj_t string2_32)
{ AN_OBJECT;
{ /* Ieee/string.scm 233 */
{ /* Ieee/string.scm 234 */
obj_t symbol1241_1215;
symbol1241_1215 = symbol1541___r4_strings_6_7; 
{ /* Ieee/string.scm 234 */

PUSH_TRACE(symbol1241_1215); BUNSPEC; 
{ /* Ieee/string.scm 234 */
bool_t aux1240_1216;
aux1240_1216 = 
string_le(string1_31, string2_32); 
POP_TRACE(); 
return aux1240_1216;} } } } 
}



/* _string<=?1299 */
obj_t _string___1299_227___r4_strings_6_7(obj_t env_861, obj_t string1_862, obj_t string2_863)
{ AN_OBJECT;
{ /* Ieee/string.scm 233 */
{ /* Ieee/string.scm 233 */
bool_t aux_1733;
{ /* Ieee/string.scm 233 */
bool_t res1602_1221;
{ /* Ieee/string.scm 233 */
obj_t string1_1217;obj_t string2_1218;
if(
STRINGP(string1_862))
{ /* Ieee/string.scm 233 */
string1_1217 = string1_862; }  else 
{ /* Ieee/string.scm 233 */
bigloo_type_error_location_103___error(symbol1542___r4_strings_6_7, string1513___r4_strings_6_7, string1_862, string1506___r4_strings_6_7, 
BINT(((long)11697))); 
exit( -1 );} 
if(
STRINGP(string2_863))
{ /* Ieee/string.scm 233 */
string2_1218 = string2_863; }  else 
{ /* Ieee/string.scm 233 */
bigloo_type_error_location_103___error(symbol1542___r4_strings_6_7, string1513___r4_strings_6_7, string2_863, string1506___r4_strings_6_7, 
BINT(((long)11697))); 
exit( -1 );} 
{ /* Ieee/string.scm 234 */
obj_t symbol1241_1219;
symbol1241_1219 = symbol1541___r4_strings_6_7; 
{ /* Ieee/string.scm 234 */

PUSH_TRACE(symbol1241_1219); BUNSPEC; 
{ /* Ieee/string.scm 234 */
bool_t aux1240_1220;
aux1240_1220 = 
string_le(string1_1217, string2_1218); 
POP_TRACE(); 
res1602_1221 = aux1240_1220; } } } } 
aux_1733 = res1602_1221; } 
return 
BBOOL(aux_1733);} } 
}



/* string>=? */
bool_t string____135___r4_strings_6_7(obj_t string1_33, obj_t string2_34)
{ AN_OBJECT;
{ /* Ieee/string.scm 239 */
{ /* Ieee/string.scm 240 */
obj_t symbol1243_1222;
symbol1243_1222 = symbol1543___r4_strings_6_7; 
{ /* Ieee/string.scm 240 */

PUSH_TRACE(symbol1243_1222); BUNSPEC; 
{ /* Ieee/string.scm 240 */
bool_t aux1242_1223;
aux1242_1223 = 
string_ge(string1_33, string2_34); 
POP_TRACE(); 
return aux1242_1223;} } } } 
}



/* _string>=?1300 */
obj_t _string___1300_67___r4_strings_6_7(obj_t env_864, obj_t string1_865, obj_t string2_866)
{ AN_OBJECT;
{ /* Ieee/string.scm 239 */
{ /* Ieee/string.scm 239 */
bool_t aux_1751;
{ /* Ieee/string.scm 239 */
bool_t res1603_1228;
{ /* Ieee/string.scm 239 */
obj_t string1_1224;obj_t string2_1225;
if(
STRINGP(string1_865))
{ /* Ieee/string.scm 239 */
string1_1224 = string1_865; }  else 
{ /* Ieee/string.scm 239 */
bigloo_type_error_location_103___error(symbol1544___r4_strings_6_7, string1513___r4_strings_6_7, string1_865, string1506___r4_strings_6_7, 
BINT(((long)11995))); 
exit( -1 );} 
if(
STRINGP(string2_866))
{ /* Ieee/string.scm 239 */
string2_1225 = string2_866; }  else 
{ /* Ieee/string.scm 239 */
bigloo_type_error_location_103___error(symbol1544___r4_strings_6_7, string1513___r4_strings_6_7, string2_866, string1506___r4_strings_6_7, 
BINT(((long)11995))); 
exit( -1 );} 
{ /* Ieee/string.scm 240 */
obj_t symbol1243_1226;
symbol1243_1226 = symbol1543___r4_strings_6_7; 
{ /* Ieee/string.scm 240 */

PUSH_TRACE(symbol1243_1226); BUNSPEC; 
{ /* Ieee/string.scm 240 */
bool_t aux1242_1227;
aux1242_1227 = 
string_ge(string1_1224, string2_1225); 
POP_TRACE(); 
res1603_1228 = aux1242_1227; } } } } 
aux_1751 = res1603_1228; } 
return 
BBOOL(aux_1751);} } 
}



/* string-ci<? */
bool_t string_ci___92___r4_strings_6_7(obj_t string1_35, obj_t string2_36)
{ AN_OBJECT;
{ /* Ieee/string.scm 245 */
{ /* Ieee/string.scm 246 */
obj_t symbol1245_1229;
symbol1245_1229 = symbol1545___r4_strings_6_7; 
{ /* Ieee/string.scm 246 */

PUSH_TRACE(symbol1245_1229); BUNSPEC; 
{ /* Ieee/string.scm 246 */
bool_t aux1244_1230;
aux1244_1230 = 
string_cilt(string1_35, string2_36); 
POP_TRACE(); 
return aux1244_1230;} } } } 
}



/* _string-ci<?1301 */
obj_t _string_ci__1301_149___r4_strings_6_7(obj_t env_867, obj_t string1_868, obj_t string2_869)
{ AN_OBJECT;
{ /* Ieee/string.scm 245 */
{ /* Ieee/string.scm 245 */
bool_t aux_1769;
{ /* Ieee/string.scm 245 */
bool_t res1604_1235;
{ /* Ieee/string.scm 245 */
obj_t string1_1231;obj_t string2_1232;
if(
STRINGP(string1_868))
{ /* Ieee/string.scm 245 */
string1_1231 = string1_868; }  else 
{ /* Ieee/string.scm 245 */
bigloo_type_error_location_103___error(symbol1546___r4_strings_6_7, string1513___r4_strings_6_7, string1_868, string1506___r4_strings_6_7, 
BINT(((long)12293))); 
exit( -1 );} 
if(
STRINGP(string2_869))
{ /* Ieee/string.scm 245 */
string2_1232 = string2_869; }  else 
{ /* Ieee/string.scm 245 */
bigloo_type_error_location_103___error(symbol1546___r4_strings_6_7, string1513___r4_strings_6_7, string2_869, string1506___r4_strings_6_7, 
BINT(((long)12293))); 
exit( -1 );} 
{ /* Ieee/string.scm 246 */
obj_t symbol1245_1233;
symbol1245_1233 = symbol1545___r4_strings_6_7; 
{ /* Ieee/string.scm 246 */

PUSH_TRACE(symbol1245_1233); BUNSPEC; 
{ /* Ieee/string.scm 246 */
bool_t aux1244_1234;
aux1244_1234 = 
string_cilt(string1_1231, string2_1232); 
POP_TRACE(); 
res1604_1235 = aux1244_1234; } } } } 
aux_1769 = res1604_1235; } 
return 
BBOOL(aux_1769);} } 
}



/* string-ci>? */
bool_t string_ci___60___r4_strings_6_7(obj_t string1_37, obj_t string2_38)
{ AN_OBJECT;
{ /* Ieee/string.scm 251 */
{ /* Ieee/string.scm 252 */
obj_t symbol1247_1236;
symbol1247_1236 = symbol1547___r4_strings_6_7; 
{ /* Ieee/string.scm 252 */

PUSH_TRACE(symbol1247_1236); BUNSPEC; 
{ /* Ieee/string.scm 252 */
bool_t aux1246_1237;
aux1246_1237 = 
string_cigt(string1_37, string2_38); 
POP_TRACE(); 
return aux1246_1237;} } } } 
}



/* _string-ci>?1302 */
obj_t _string_ci__1302_205___r4_strings_6_7(obj_t env_870, obj_t string1_871, obj_t string2_872)
{ AN_OBJECT;
{ /* Ieee/string.scm 251 */
{ /* Ieee/string.scm 251 */
bool_t aux_1787;
{ /* Ieee/string.scm 251 */
bool_t res1605_1242;
{ /* Ieee/string.scm 251 */
obj_t string1_1238;obj_t string2_1239;
if(
STRINGP(string1_871))
{ /* Ieee/string.scm 251 */
string1_1238 = string1_871; }  else 
{ /* Ieee/string.scm 251 */
bigloo_type_error_location_103___error(symbol1548___r4_strings_6_7, string1513___r4_strings_6_7, string1_871, string1506___r4_strings_6_7, 
BINT(((long)12595))); 
exit( -1 );} 
if(
STRINGP(string2_872))
{ /* Ieee/string.scm 251 */
string2_1239 = string2_872; }  else 
{ /* Ieee/string.scm 251 */
bigloo_type_error_location_103___error(symbol1548___r4_strings_6_7, string1513___r4_strings_6_7, string2_872, string1506___r4_strings_6_7, 
BINT(((long)12595))); 
exit( -1 );} 
{ /* Ieee/string.scm 252 */
obj_t symbol1247_1240;
symbol1247_1240 = symbol1547___r4_strings_6_7; 
{ /* Ieee/string.scm 252 */

PUSH_TRACE(symbol1247_1240); BUNSPEC; 
{ /* Ieee/string.scm 252 */
bool_t aux1246_1241;
aux1246_1241 = 
string_cigt(string1_1238, string2_1239); 
POP_TRACE(); 
res1605_1242 = aux1246_1241; } } } } 
aux_1787 = res1605_1242; } 
return 
BBOOL(aux_1787);} } 
}



/* string-ci<=? */
bool_t string_ci____210___r4_strings_6_7(obj_t string1_39, obj_t string2_40)
{ AN_OBJECT;
{ /* Ieee/string.scm 257 */
{ /* Ieee/string.scm 258 */
obj_t symbol1249_1243;
symbol1249_1243 = symbol1549___r4_strings_6_7; 
{ /* Ieee/string.scm 258 */

PUSH_TRACE(symbol1249_1243); BUNSPEC; 
{ /* Ieee/string.scm 258 */
bool_t aux1248_1244;
aux1248_1244 = 
string_cile(string1_39, string2_40); 
POP_TRACE(); 
return aux1248_1244;} } } } 
}



/* _string-ci<=?1303 */
obj_t _string_ci___1303_129___r4_strings_6_7(obj_t env_873, obj_t string1_874, obj_t string2_875)
{ AN_OBJECT;
{ /* Ieee/string.scm 257 */
{ /* Ieee/string.scm 257 */
bool_t aux_1805;
{ /* Ieee/string.scm 257 */
bool_t res1606_1249;
{ /* Ieee/string.scm 257 */
obj_t string1_1245;obj_t string2_1246;
if(
STRINGP(string1_874))
{ /* Ieee/string.scm 257 */
string1_1245 = string1_874; }  else 
{ /* Ieee/string.scm 257 */
bigloo_type_error_location_103___error(symbol1550___r4_strings_6_7, string1513___r4_strings_6_7, string1_874, string1506___r4_strings_6_7, 
BINT(((long)12897))); 
exit( -1 );} 
if(
STRINGP(string2_875))
{ /* Ieee/string.scm 257 */
string2_1246 = string2_875; }  else 
{ /* Ieee/string.scm 257 */
bigloo_type_error_location_103___error(symbol1550___r4_strings_6_7, string1513___r4_strings_6_7, string2_875, string1506___r4_strings_6_7, 
BINT(((long)12897))); 
exit( -1 );} 
{ /* Ieee/string.scm 258 */
obj_t symbol1249_1247;
symbol1249_1247 = symbol1549___r4_strings_6_7; 
{ /* Ieee/string.scm 258 */

PUSH_TRACE(symbol1249_1247); BUNSPEC; 
{ /* Ieee/string.scm 258 */
bool_t aux1248_1248;
aux1248_1248 = 
string_cile(string1_1245, string2_1246); 
POP_TRACE(); 
res1606_1249 = aux1248_1248; } } } } 
aux_1805 = res1606_1249; } 
return 
BBOOL(aux_1805);} } 
}



/* string-ci>=? */
bool_t string_ci____43___r4_strings_6_7(obj_t string1_41, obj_t string2_42)
{ AN_OBJECT;
{ /* Ieee/string.scm 263 */
{ /* Ieee/string.scm 264 */
obj_t symbol1251_1250;
symbol1251_1250 = symbol1551___r4_strings_6_7; 
{ /* Ieee/string.scm 264 */

PUSH_TRACE(symbol1251_1250); BUNSPEC; 
{ /* Ieee/string.scm 264 */
bool_t aux1250_1251;
aux1250_1251 = 
string_cige(string1_41, string2_42); 
POP_TRACE(); 
return aux1250_1251;} } } } 
}



/* _string-ci>=?1304 */
obj_t _string_ci___1304_187___r4_strings_6_7(obj_t env_876, obj_t string1_877, obj_t string2_878)
{ AN_OBJECT;
{ /* Ieee/string.scm 263 */
{ /* Ieee/string.scm 263 */
bool_t aux_1823;
{ /* Ieee/string.scm 263 */
bool_t res1607_1256;
{ /* Ieee/string.scm 263 */
obj_t string1_1252;obj_t string2_1253;
if(
STRINGP(string1_877))
{ /* Ieee/string.scm 263 */
string1_1252 = string1_877; }  else 
{ /* Ieee/string.scm 263 */
bigloo_type_error_location_103___error(symbol1552___r4_strings_6_7, string1513___r4_strings_6_7, string1_877, string1506___r4_strings_6_7, 
BINT(((long)13200))); 
exit( -1 );} 
if(
STRINGP(string2_878))
{ /* Ieee/string.scm 263 */
string2_1253 = string2_878; }  else 
{ /* Ieee/string.scm 263 */
bigloo_type_error_location_103___error(symbol1552___r4_strings_6_7, string1513___r4_strings_6_7, string2_878, string1506___r4_strings_6_7, 
BINT(((long)13200))); 
exit( -1 );} 
{ /* Ieee/string.scm 264 */
obj_t symbol1251_1254;
symbol1251_1254 = symbol1551___r4_strings_6_7; 
{ /* Ieee/string.scm 264 */

PUSH_TRACE(symbol1251_1254); BUNSPEC; 
{ /* Ieee/string.scm 264 */
bool_t aux1250_1255;
aux1250_1255 = 
string_cige(string1_1252, string2_1253); 
POP_TRACE(); 
res1607_1256 = aux1250_1255; } } } } 
aux_1823 = res1607_1256; } 
return 
BBOOL(aux_1823);} } 
}



/* substring */
obj_t substring___r4_strings_6_7(obj_t string_43, long start_44, long end_45)
{ AN_OBJECT;
{ /* Ieee/string.scm 269 */
{ /* Ieee/string.scm 271 */
obj_t symbol1253_1257;
symbol1253_1257 = symbol1553___r4_strings_6_7; 
{ /* Ieee/string.scm 271 */

PUSH_TRACE(symbol1253_1257); BUNSPEC; 
{ /* Ieee/string.scm 271 */
obj_t aux1252_1258;
{ /* Ieee/string.scm 271 */
bool_t test_1839;
if(
(end_45>=start_44))
{ /* Ieee/string.scm 272 */
bool_t test_1842;
{ /* Ieee/string.scm 272 */
long aux_1843;
{ /* ./Ieee/fixnum.scm 1813 */
long aux_1844;
aux_1844 = 
STRING_LENGTH(string_43); 
aux_1843 = 
(aux_1844+((long)1)); } 
test_1842 = 
BOUND_CHECK(start_44, aux_1843); } 
if(test_1842)
{ /* Ieee/string.scm 273 */
long aux_1848;
{ /* ./Ieee/fixnum.scm 1813 */
long aux_1849;
aux_1849 = 
STRING_LENGTH(string_43); 
aux_1848 = 
(aux_1849+((long)1)); } 
test_1839 = 
BOUND_CHECK(end_45, aux_1848); }  else 
{ /* Ieee/string.scm 272 */
test_1839 = ((bool_t)0)
; } }  else 
{ /* Ieee/string.scm 271 */
test_1839 = ((bool_t)0)
; } 
if(test_1839)
{ /* Ieee/string.scm 271 */
aux1252_1258 = 
c_substring(string_43, start_44, end_45); }  else 
{ /* Ieee/string.scm 271 */
{ /* Ieee/string.scm 277 */
obj_t arg1017_1259;
{ /* ./Ieee/pair-list.scm 2791 */
obj_t aux_1856;obj_t aux_1854;
aux_1856 = 
BINT(end_45); 
aux_1854 = 
BINT(start_44); 
arg1017_1259 = 
MAKE_PAIR(aux_1854, aux_1856); } 
error_c_location_83___error(string1554___r4_strings_6_7, string1555___r4_strings_6_7, arg1017_1259, "Ieee/string.scm", ((long)13819)); } 
{ /* ./Llib/error.scm 601 */
obj_t aux1403_1260;
aux1403_1260 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
if(
STRINGP(aux1403_1260))
{ /* ./Llib/error.scm 601 */
aux1252_1258 = aux1403_1260; }  else 
{ /* ./Llib/error.scm 601 */
bigloo_type_error_location_103___error(symbol1553___r4_strings_6_7, string1513___r4_strings_6_7, aux1403_1260, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
exit( -1 );} } } } 
POP_TRACE(); 
return aux1252_1258;} } } } 
}



/* _substring1305 */
obj_t _substring1305___r4_strings_6_7(obj_t env_879, obj_t string_880, obj_t start_881, obj_t end_882)
{ AN_OBJECT;
{ /* Ieee/string.scm 269 */
{ /* Ieee/string.scm 269 */
obj_t string_1261;long start_1262;long end_1263;
if(
STRINGP(string_880))
{ /* Ieee/string.scm 269 */
string_1261 = string_880; }  else 
{ /* Ieee/string.scm 269 */
bigloo_type_error_location_103___error(symbol1556___r4_strings_6_7, string1513___r4_strings_6_7, string_880, string1506___r4_strings_6_7, 
BINT(((long)13503))); 
exit( -1 );} 
{ /* Ieee/string.scm 269 */
obj_t aux_1873;
if(
INTEGERP(start_881))
{ /* Ieee/string.scm 269 */
aux_1873 = start_881
; }  else 
{ /* Ieee/string.scm 269 */
bigloo_type_error_location_103___error(symbol1556___r4_strings_6_7, string1519___r4_strings_6_7, start_881, string1506___r4_strings_6_7, 
BINT(((long)13503))); 
exit( -1 );} 
start_1262 = 
(long)CINT(aux_1873); } 
{ /* Ieee/string.scm 269 */
obj_t aux_1880;
if(
INTEGERP(end_882))
{ /* Ieee/string.scm 269 */
aux_1880 = end_882
; }  else 
{ /* Ieee/string.scm 269 */
bigloo_type_error_location_103___error(symbol1556___r4_strings_6_7, string1519___r4_strings_6_7, end_882, string1506___r4_strings_6_7, 
BINT(((long)13503))); 
exit( -1 );} 
end_1263 = 
(long)CINT(aux_1880); } 
{ /* Ieee/string.scm 271 */
obj_t symbol1253_1264;
symbol1253_1264 = symbol1553___r4_strings_6_7; 
{ /* Ieee/string.scm 271 */

PUSH_TRACE(symbol1253_1264); BUNSPEC; 
{ /* Ieee/string.scm 271 */
obj_t aux1252_1265;
{ /* Ieee/string.scm 271 */
bool_t test_1888;
if(
(end_1263>=start_1262))
{ /* Ieee/string.scm 272 */
bool_t test_1891;
{ /* Ieee/string.scm 272 */
long aux_1892;
{ /* ./Ieee/fixnum.scm 1813 */
long aux_1893;
aux_1893 = 
STRING_LENGTH(string_1261); 
aux_1892 = 
(aux_1893+((long)1)); } 
test_1891 = 
BOUND_CHECK(start_1262, aux_1892); } 
if(test_1891)
{ /* Ieee/string.scm 273 */
long aux_1897;
{ /* ./Ieee/fixnum.scm 1813 */
long aux_1898;
aux_1898 = 
STRING_LENGTH(string_1261); 
aux_1897 = 
(aux_1898+((long)1)); } 
test_1888 = 
BOUND_CHECK(end_1263, aux_1897); }  else 
{ /* Ieee/string.scm 272 */
test_1888 = ((bool_t)0)
; } }  else 
{ /* Ieee/string.scm 271 */
test_1888 = ((bool_t)0)
; } 
if(test_1888)
{ /* Ieee/string.scm 271 */
aux1252_1265 = 
c_substring(string_1261, start_1262, end_1263); }  else 
{ /* Ieee/string.scm 271 */
{ /* Ieee/string.scm 277 */
obj_t arg1017_1266;
{ /* ./Ieee/pair-list.scm 2791 */
obj_t aux_1905;obj_t aux_1903;
aux_1905 = 
BINT(end_1263); 
aux_1903 = 
BINT(start_1262); 
arg1017_1266 = 
MAKE_PAIR(aux_1903, aux_1905); } 
error_c_location_83___error(string1554___r4_strings_6_7, string1555___r4_strings_6_7, arg1017_1266, "Ieee/string.scm", ((long)13819)); } 
{ /* ./Llib/error.scm 601 */
obj_t aux1403_1267;
aux1403_1267 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
if(
STRINGP(aux1403_1267))
{ /* ./Llib/error.scm 601 */
aux1252_1265 = aux1403_1267; }  else 
{ /* ./Llib/error.scm 601 */
bigloo_type_error_location_103___error(symbol1553___r4_strings_6_7, string1513___r4_strings_6_7, aux1403_1267, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
exit( -1 );} } } } 
POP_TRACE(); 
return aux1252_1265;} } } } } 
}



/* substring-ur */
obj_t substring_ur_202___r4_strings_6_7(obj_t string_46, long start_47, long end_48)
{ AN_OBJECT;
{ /* Ieee/string.scm 282 */
{ /* Ieee/string.scm 283 */
obj_t symbol1255_1268;
symbol1255_1268 = symbol1557___r4_strings_6_7; 
{ /* Ieee/string.scm 283 */

PUSH_TRACE(symbol1255_1268); BUNSPEC; 
{ /* Ieee/string.scm 283 */
obj_t aux1254_1269;
aux1254_1269 = 
c_substring(string_46, start_47, end_48); 
POP_TRACE(); 
return aux1254_1269;} } } } 
}



/* _substring-ur1306 */
obj_t _substring_ur1306_38___r4_strings_6_7(obj_t env_883, obj_t string_884, obj_t start_885, obj_t end_886)
{ AN_OBJECT;
{ /* Ieee/string.scm 282 */
{ /* Ieee/string.scm 282 */
obj_t string_1270;long start_1271;long end_1272;
if(
STRINGP(string_884))
{ /* Ieee/string.scm 282 */
string_1270 = string_884; }  else 
{ /* Ieee/string.scm 282 */
bigloo_type_error_location_103___error(symbol1558___r4_strings_6_7, string1513___r4_strings_6_7, string_884, string1506___r4_strings_6_7, 
BINT(((long)14097))); 
exit( -1 );} 
{ /* Ieee/string.scm 282 */
obj_t aux_1925;
if(
INTEGERP(start_885))
{ /* Ieee/string.scm 282 */
aux_1925 = start_885
; }  else 
{ /* Ieee/string.scm 282 */
bigloo_type_error_location_103___error(symbol1558___r4_strings_6_7, string1519___r4_strings_6_7, start_885, string1506___r4_strings_6_7, 
BINT(((long)14097))); 
exit( -1 );} 
start_1271 = 
(long)CINT(aux_1925); } 
{ /* Ieee/string.scm 282 */
obj_t aux_1932;
if(
INTEGERP(end_886))
{ /* Ieee/string.scm 282 */
aux_1932 = end_886
; }  else 
{ /* Ieee/string.scm 282 */
bigloo_type_error_location_103___error(symbol1558___r4_strings_6_7, string1519___r4_strings_6_7, end_886, string1506___r4_strings_6_7, 
BINT(((long)14097))); 
exit( -1 );} 
end_1272 = 
(long)CINT(aux_1932); } 
{ /* Ieee/string.scm 283 */
obj_t symbol1255_1273;
symbol1255_1273 = symbol1557___r4_strings_6_7; 
{ /* Ieee/string.scm 283 */

PUSH_TRACE(symbol1255_1273); BUNSPEC; 
{ /* Ieee/string.scm 283 */
obj_t aux1254_1274;
aux1254_1274 = 
c_substring(string_1270, start_1271, end_1272); 
POP_TRACE(); 
return aux1254_1274;} } } } } 
}



/* string-append */
obj_t string_append_106___r4_strings_6_7(obj_t list_49)
{ AN_OBJECT;
{ /* Ieee/string.scm 288 */
{ /* Ieee/string.scm 289 */
obj_t symbol1257_786;
symbol1257_786 = symbol1559___r4_strings_6_7; 
{ /* Ieee/string.scm 289 */

PUSH_TRACE(symbol1257_786); BUNSPEC; 
{ /* Ieee/string.scm 289 */
obj_t aux1256_787;
if(
NULLP(list_49))
{ /* Ieee/string.scm 289 */
aux1256_787 = string1560___r4_strings_6_7; }  else 
{ /* Ieee/string.scm 291 */
obj_t aux1417_1022;
aux1417_1022 = 
loop___r4_strings_6_7(list_49); 
if(
STRINGP(aux1417_1022))
{ /* Ieee/string.scm 291 */
aux1256_787 = aux1417_1022; }  else 
{ /* Ieee/string.scm 291 */
bigloo_type_error_location_103___error(symbol1559___r4_strings_6_7, string1513___r4_strings_6_7, aux1417_1022, string1506___r4_strings_6_7, 
BINT(((long)14471))); 
exit( -1 );} } 
POP_TRACE(); 
return aux1256_787;} } } } 
}



/* loop */
obj_t loop___r4_strings_6_7(obj_t list_251)
{ AN_OBJECT;
{ /* Ieee/string.scm 291 */
{ /* Ieee/string.scm 292 */
bool_t test1029_253;
{ /* Ieee/string.scm 292 */
obj_t arg1033_257;
{ /* Ieee/string.scm 292 */
obj_t pair_500;
if(
PAIRP(list_251))
{ /* Ieee/string.scm 292 */
pair_500 = list_251; }  else 
{ /* Ieee/string.scm 292 */
bigloo_type_error_location_103___error(symbol1561___r4_strings_6_7, string1505___r4_strings_6_7, list_251, string1506___r4_strings_6_7, 
BINT(((long)14510))); 
exit( -1 );} 
arg1033_257 = 
CDR(pair_500); } 
test1029_253 = 
NULLP(arg1033_257); } 
if(test1029_253)
{ /* Ieee/string.scm 293 */
obj_t pair_502;
if(
PAIRP(list_251))
{ /* Ieee/string.scm 293 */
pair_502 = list_251; }  else 
{ /* Ieee/string.scm 293 */
bigloo_type_error_location_103___error(symbol1561___r4_strings_6_7, string1505___r4_strings_6_7, list_251, string1506___r4_strings_6_7, 
BINT(((long)14529))); 
exit( -1 );} 
return 
CAR(pair_502);}  else 
{ /* Ieee/string.scm 294 */
obj_t arg1030_254;obj_t arg1031_255;
{ /* Ieee/string.scm 294 */
obj_t pair_503;
if(
PAIRP(list_251))
{ /* Ieee/string.scm 294 */
pair_503 = list_251; }  else 
{ /* Ieee/string.scm 294 */
bigloo_type_error_location_103___error(symbol1561___r4_strings_6_7, string1505___r4_strings_6_7, list_251, string1506___r4_strings_6_7, 
BINT(((long)14564))); 
exit( -1 );} 
arg1030_254 = 
CAR(pair_503); } 
{ /* Ieee/string.scm 294 */
obj_t arg1032_256;
{ /* Ieee/string.scm 294 */
obj_t pair_504;
if(
PAIRP(list_251))
{ /* Ieee/string.scm 294 */
pair_504 = list_251; }  else 
{ /* Ieee/string.scm 294 */
bigloo_type_error_location_103___error(symbol1561___r4_strings_6_7, string1505___r4_strings_6_7, list_251, string1506___r4_strings_6_7, 
BINT(((long)14581))); 
exit( -1 );} 
arg1032_256 = 
CDR(pair_504); } 
arg1031_255 = 
loop___r4_strings_6_7(arg1032_256); } 
{ /* Ieee/string.scm 294 */
obj_t aux_1985;obj_t aux_1979;
if(
STRINGP(arg1031_255))
{ /* Ieee/string.scm 294 */
aux_1985 = arg1031_255
; }  else 
{ /* Ieee/string.scm 294 */
bigloo_type_error_location_103___error(symbol1561___r4_strings_6_7, string1513___r4_strings_6_7, arg1031_255, string1506___r4_strings_6_7, 
BINT(((long)14546))); 
exit( -1 );} 
if(
STRINGP(arg1030_254))
{ /* Ieee/string.scm 294 */
aux_1979 = arg1030_254
; }  else 
{ /* Ieee/string.scm 294 */
bigloo_type_error_location_103___error(symbol1561___r4_strings_6_7, string1513___r4_strings_6_7, arg1030_254, string1506___r4_strings_6_7, 
BINT(((long)14546))); 
exit( -1 );} 
return 
string_append(aux_1979, aux_1985);} } } } 
}



/* _string-append */
obj_t _string_append_156___r4_strings_6_7(obj_t env_887, obj_t list_888)
{ AN_OBJECT;
{ /* Ieee/string.scm 288 */
return 
string_append_106___r4_strings_6_7(list_888);} 
}



/* list->string */
obj_t list__string_78___r4_strings_6_7(obj_t list_50)
{ AN_OBJECT;
{ /* Ieee/string.scm 299 */
{ /* Ieee/string.scm 300 */
obj_t symbol1259_788;
symbol1259_788 = symbol1562___r4_strings_6_7; 
{ /* Ieee/string.scm 300 */

PUSH_TRACE(symbol1259_788); BUNSPEC; 
{ /* Ieee/string.scm 300 */
obj_t aux1258_789;
{ /* Ieee/string.scm 300 */
long len_258;
len_258 = 
list_length(list_50); 
{ /* Ieee/string.scm 300 */
obj_t string_259;
{ /* Ieee/string.scm 301 */
obj_t res1200_511;
{ /* Ieee/string.scm 145 */
long aux_1995;
{ /* Ieee/string.scm 145 */
int aux_1996;
aux_1996 = 
(int)(len_258); 
aux_1995 = 
(long)(aux_1996); } 
res1200_511 = 
make_string(aux_1995, ((unsigned char)' ')); } 
string_259 = res1200_511; } 
{ /* Ieee/string.scm 301 */

{ 
long i_260;obj_t l_261;
i_260 = ((long)0); 
l_261 = list_50; 
loop_262:
if(
(i_260==len_258))
{ /* Ieee/string.scm 304 */
aux1258_789 = string_259; }  else 
{ /* Ieee/string.scm 304 */
{ /* Ieee/string.scm 307 */
obj_t arg1035_264;
{ /* Ieee/string.scm 307 */
obj_t pair_514;
if(
PAIRP(l_261))
{ /* Ieee/string.scm 307 */
pair_514 = l_261; }  else 
{ /* Ieee/string.scm 307 */
bigloo_type_error_location_103___error(symbol1562___r4_strings_6_7, string1505___r4_strings_6_7, l_261, string1506___r4_strings_6_7, 
BINT(((long)15018))); 
exit( -1 );} 
arg1035_264 = 
CAR(pair_514); } 
{ /* Ieee/string.scm 307 */
unsigned char char_166_517;
{ /* Ieee/string.scm 307 */
obj_t aux_2008;
if(
CHARP(arg1035_264))
{ /* Ieee/string.scm 307 */
aux_2008 = arg1035_264
; }  else 
{ /* Ieee/string.scm 307 */
bigloo_type_error_location_103___error(symbol1562___r4_strings_6_7, string1507___r4_strings_6_7, arg1035_264, string1506___r4_strings_6_7, 
BINT(((long)14995))); 
exit( -1 );} 
char_166_517 = 
(unsigned char)CCHAR(aux_2008); } 
{ /* Ieee/string.scm 172 */
bool_t test_2015;
{ /* Ieee/string.scm 172 */
long aux_2016;
aux_2016 = 
STRING_LENGTH(string_259); 
test_2015 = 
BOUND_CHECK(i_260, aux_2016); } 
if(test_2015)
{ /* Ieee/string.scm 172 */
STRING_SET(string_259, i_260, char_166_517); }  else 
{ /* Ieee/string.scm 172 */
error_c_location_83___error(string1521___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_260), "Ieee/string.scm", ((long)8715)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); } } } } 
{ /* Ieee/string.scm 308 */
long arg1036_265;obj_t arg1038_266;
arg1036_265 = 
(i_260+((long)1)); 
{ /* Ieee/string.scm 308 */
obj_t pair_526;
if(
PAIRP(l_261))
{ /* Ieee/string.scm 308 */
pair_526 = l_261; }  else 
{ /* Ieee/string.scm 308 */
bigloo_type_error_location_103___error(symbol1562___r4_strings_6_7, string1505___r4_strings_6_7, l_261, string1506___r4_strings_6_7, 
BINT(((long)15045))); 
exit( -1 );} 
arg1038_266 = 
CDR(pair_526); } 
{ 
obj_t l_2032;long i_2031;
i_2031 = arg1036_265; 
l_2032 = arg1038_266; 
l_261 = l_2032; 
i_260 = i_2031; 
goto loop_262;} } } } } } } 
POP_TRACE(); 
return aux1258_789;} } } } 
}



/* _list->string */
obj_t _list__string_5___r4_strings_6_7(obj_t env_889, obj_t list_890)
{ AN_OBJECT;
{ /* Ieee/string.scm 299 */
return 
list__string_78___r4_strings_6_7(list_890);} 
}



/* string->list */
obj_t string__list_125___r4_strings_6_7(obj_t string_51)
{ AN_OBJECT;
{ /* Ieee/string.scm 313 */
{ /* Ieee/string.scm 314 */
obj_t symbol1261_790;
symbol1261_790 = symbol1563___r4_strings_6_7; 
{ /* Ieee/string.scm 314 */

PUSH_TRACE(symbol1261_790); BUNSPEC; 
{ /* Ieee/string.scm 314 */
obj_t aux1260_791;
{ 
long i_269;obj_t res_270;
{ /* ./Ieee/fixnum.scm 1819 */
long aux_2060;
aux_2060 = 
STRING_LENGTH(string_51); 
i_269 = 
(aux_2060-((long)1)); } 
res_270 = BNIL; 
loop_271:
if(
(i_269==((long)-1)))
{ /* Ieee/string.scm 317 */
aux1260_791 = res_270; }  else 
{ /* Ieee/string.scm 319 */
long arg1043_275;obj_t arg1044_276;
arg1043_275 = 
(i_269-((long)1)); 
{ /* Ieee/string.scm 320 */
unsigned char arg1045_277;
{ /* Ieee/string.scm 320 */
unsigned char res1201_542;
{ /* Ieee/string.scm 164 */
bool_t test_2039;
{ /* Ieee/string.scm 164 */
long aux_2040;
aux_2040 = 
STRING_LENGTH(string_51); 
test_2039 = 
BOUND_CHECK(i_269, aux_2040); } 
if(test_2039)
{ /* Ieee/string.scm 164 */
res1201_542 = 
STRING_REF(string_51, i_269); }  else 
{ /* Ieee/string.scm 164 */
error_c_location_83___error(string1515___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_269), "Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 601 */
obj_t aux_2046;
{ /* ./Llib/error.scm 601 */
obj_t aux1441_1046;
aux1441_1046 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
if(
CHARP(aux1441_1046))
{ /* ./Llib/error.scm 601 */
aux_2046 = aux1441_1046
; }  else 
{ /* ./Llib/error.scm 601 */
bigloo_type_error_location_103___error(symbol1563___r4_strings_6_7, string1507___r4_strings_6_7, aux1441_1046, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
exit( -1 );} } 
res1201_542 = 
(unsigned char)CCHAR(aux_2046); } } } 
arg1045_277 = res1201_542; } 
{ /* ./Ieee/pair-list.scm 2791 */
obj_t aux_2055;
aux_2055 = 
BCHAR(arg1045_277); 
arg1044_276 = 
MAKE_PAIR(aux_2055, res_270); } } 
{ 
obj_t res_2059;long i_2058;
i_2058 = arg1043_275; 
res_2059 = arg1044_276; 
res_270 = res_2059; 
i_269 = i_2058; 
goto loop_271;} } } 
POP_TRACE(); 
return aux1260_791;} } } } 
}



/* _string->list1307 */
obj_t _string__list1307_156___r4_strings_6_7(obj_t env_891, obj_t string_892)
{ AN_OBJECT;
{ /* Ieee/string.scm 313 */
{ /* Ieee/string.scm 313 */
obj_t aux_2064;
if(
STRINGP(string_892))
{ /* Ieee/string.scm 313 */
aux_2064 = string_892
; }  else 
{ /* Ieee/string.scm 313 */
bigloo_type_error_location_103___error(symbol1564___r4_strings_6_7, string1513___r4_strings_6_7, string_892, string1506___r4_strings_6_7, 
BINT(((long)15281))); 
exit( -1 );} 
return 
string__list_125___r4_strings_6_7(aux_2064);} } 
}



/* string-copy */
obj_t string_copy_207___r4_strings_6_7(obj_t string_52)
{ AN_OBJECT;
{ /* Ieee/string.scm 325 */
{ /* Ieee/string.scm 326 */
obj_t symbol1263_1275;
symbol1263_1275 = symbol1565___r4_strings_6_7; 
{ /* Ieee/string.scm 326 */

PUSH_TRACE(symbol1263_1275); BUNSPEC; 
{ /* Ieee/string.scm 326 */
obj_t aux1262_1276;
{ /* Ieee/string.scm 326 */
char * aux_2072;
aux_2072 = 
BSTRING_TO_STRING(string_52); 
aux1262_1276 = 
string_to_bstring(aux_2072); } 
POP_TRACE(); 
return aux1262_1276;} } } } 
}



/* _string-copy1308 */
obj_t _string_copy1308_66___r4_strings_6_7(obj_t env_893, obj_t string_894)
{ AN_OBJECT;
{ /* Ieee/string.scm 325 */
{ /* Ieee/string.scm 325 */
obj_t string_1277;
if(
STRINGP(string_894))
{ /* Ieee/string.scm 325 */
string_1277 = string_894; }  else 
{ /* Ieee/string.scm 325 */
bigloo_type_error_location_103___error(symbol1566___r4_strings_6_7, string1513___r4_strings_6_7, string_894, string1506___r4_strings_6_7, 
BINT(((long)15714))); 
exit( -1 );} 
{ /* Ieee/string.scm 326 */
obj_t symbol1263_1278;
symbol1263_1278 = symbol1565___r4_strings_6_7; 
{ /* Ieee/string.scm 326 */

PUSH_TRACE(symbol1263_1278); BUNSPEC; 
{ /* Ieee/string.scm 326 */
obj_t aux1262_1279;
{ /* Ieee/string.scm 326 */
char * aux_2082;
aux_2082 = 
BSTRING_TO_STRING(string_1277); 
aux1262_1279 = 
string_to_bstring(aux_2082); } 
POP_TRACE(); 
return aux1262_1279;} } } } } 
}



/* string-fill! */
obj_t string_fill__51___r4_strings_6_7(obj_t string_53, unsigned char char_54)
{ AN_OBJECT;
{ /* Ieee/string.scm 331 */
{ /* Ieee/string.scm 332 */
obj_t symbol1265_794;
symbol1265_794 = symbol1567___r4_strings_6_7; 
{ /* Ieee/string.scm 332 */

PUSH_TRACE(symbol1265_794); BUNSPEC; 
{ /* Ieee/string.scm 332 */
obj_t aux1264_795;
{ /* Ieee/string.scm 332 */
long len_278;
len_278 = 
STRING_LENGTH(string_53); 
{ 
long i_279;
i_279 = ((long)0); 
loop_280:
if(
(i_279==len_278))
{ /* Ieee/string.scm 334 */
aux1264_795 = BUNSPEC; }  else 
{ /* Ieee/string.scm 334 */
{ /* Ieee/string.scm 172 */
bool_t test_2090;
{ /* Ieee/string.scm 172 */
long aux_2091;
aux_2091 = 
STRING_LENGTH(string_53); 
test_2090 = 
BOUND_CHECK(i_279, aux_2091); } 
if(test_2090)
{ /* Ieee/string.scm 172 */
STRING_SET(string_53, i_279, char_54); }  else 
{ /* Ieee/string.scm 172 */
error_c_location_83___error(string1521___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_279), "Ieee/string.scm", ((long)8715)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); } } 
{ 
long i_2099;
i_2099 = 
(i_279+((long)1)); 
i_279 = i_2099; 
goto loop_280;} } } } 
POP_TRACE(); 
return aux1264_795;} } } } 
}



/* _string-fill!1309 */
obj_t _string_fill_1309_109___r4_strings_6_7(obj_t env_895, obj_t string_896, obj_t char_897)
{ AN_OBJECT;
{ /* Ieee/string.scm 331 */
{ /* Ieee/string.scm 331 */
unsigned char aux_2108;obj_t aux_2102;
{ /* Ieee/string.scm 331 */
obj_t aux_2109;
if(
CHARP(char_897))
{ /* Ieee/string.scm 331 */
aux_2109 = char_897
; }  else 
{ /* Ieee/string.scm 331 */
bigloo_type_error_location_103___error(symbol1568___r4_strings_6_7, string1507___r4_strings_6_7, char_897, string1506___r4_strings_6_7, 
BINT(((long)16000))); 
exit( -1 );} 
aux_2108 = 
(unsigned char)CCHAR(aux_2109); } 
if(
STRINGP(string_896))
{ /* Ieee/string.scm 331 */
aux_2102 = string_896
; }  else 
{ /* Ieee/string.scm 331 */
bigloo_type_error_location_103___error(symbol1568___r4_strings_6_7, string1513___r4_strings_6_7, string_896, string1506___r4_strings_6_7, 
BINT(((long)16000))); 
exit( -1 );} 
return 
string_fill__51___r4_strings_6_7(aux_2102, aux_2108);} } 
}



/* string-upcase */
obj_t string_upcase_71___r4_strings_6_7(obj_t string_55)
{ AN_OBJECT;
{ /* Ieee/string.scm 343 */
{ /* Ieee/string.scm 344 */
obj_t symbol1267_796;
symbol1267_796 = symbol1569___r4_strings_6_7; 
{ /* Ieee/string.scm 344 */

PUSH_TRACE(symbol1267_796); BUNSPEC; 
{ /* Ieee/string.scm 344 */
obj_t aux1266_797;
{ /* Ieee/string.scm 344 */
long len_283;
len_283 = 
STRING_LENGTH(string_55); 
{ /* Ieee/string.scm 344 */
obj_t res_284;
{ /* Ieee/string.scm 345 */
obj_t res1202_566;
{ /* Ieee/string.scm 145 */
long aux_2119;
{ /* Ieee/string.scm 145 */
int aux_2120;
aux_2120 = 
(int)(len_283); 
aux_2119 = 
(long)(aux_2120); } 
res1202_566 = 
make_string(aux_2119, ((unsigned char)' ')); } 
res_284 = res1202_566; } 
{ /* Ieee/string.scm 345 */

{ 
long i_285;
i_285 = ((long)0); 
loop_286:
if(
(i_285==len_283))
{ /* Ieee/string.scm 347 */
aux1266_797 = res_284; }  else 
{ /* Ieee/string.scm 347 */
{ /* Ieee/string.scm 350 */
unsigned char arg1049_288;
{ /* Ieee/string.scm 350 */
unsigned char arg1050_289;
{ /* Ieee/string.scm 350 */
unsigned char res1203_577;
{ /* Ieee/string.scm 164 */
bool_t test_2126;
{ /* Ieee/string.scm 164 */
long aux_2127;
aux_2127 = 
STRING_LENGTH(string_55); 
test_2126 = 
BOUND_CHECK(i_285, aux_2127); } 
if(test_2126)
{ /* Ieee/string.scm 164 */
res1203_577 = 
STRING_REF(string_55, i_285); }  else 
{ /* Ieee/string.scm 164 */
error_c_location_83___error(string1515___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_285), "Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 601 */
obj_t aux_2133;
{ /* ./Llib/error.scm 601 */
obj_t aux1455_1060;
aux1455_1060 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
if(
CHARP(aux1455_1060))
{ /* ./Llib/error.scm 601 */
aux_2133 = aux1455_1060
; }  else 
{ /* ./Llib/error.scm 601 */
bigloo_type_error_location_103___error(symbol1569___r4_strings_6_7, string1507___r4_strings_6_7, aux1455_1060, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
exit( -1 );} } 
res1203_577 = 
(unsigned char)CCHAR(aux_2133); } } } 
arg1050_289 = res1203_577; } 
arg1049_288 = 
toupper(arg1050_289); } 
{ /* Ieee/string.scm 172 */
bool_t test_2143;
{ /* Ieee/string.scm 172 */
long aux_2144;
aux_2144 = 
STRING_LENGTH(res_284); 
test_2143 = 
BOUND_CHECK(i_285, aux_2144); } 
if(test_2143)
{ /* Ieee/string.scm 172 */
STRING_SET(res_284, i_285, arg1049_288); }  else 
{ /* Ieee/string.scm 172 */
error_c_location_83___error(string1521___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_285), "Ieee/string.scm", ((long)8715)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); } } } 
{ 
long i_2152;
i_2152 = 
(i_285+((long)1)); 
i_285 = i_2152; 
goto loop_286;} } } } } } 
POP_TRACE(); 
return aux1266_797;} } } } 
}



/* _string-upcase1310 */
obj_t _string_upcase1310_66___r4_strings_6_7(obj_t env_898, obj_t string_899)
{ AN_OBJECT;
{ /* Ieee/string.scm 343 */
{ /* Ieee/string.scm 343 */
obj_t aux_2155;
if(
STRINGP(string_899))
{ /* Ieee/string.scm 343 */
aux_2155 = string_899
; }  else 
{ /* Ieee/string.scm 343 */
bigloo_type_error_location_103___error(symbol1570___r4_strings_6_7, string1513___r4_strings_6_7, string_899, string1506___r4_strings_6_7, 
BINT(((long)16425))); 
exit( -1 );} 
return 
string_upcase_71___r4_strings_6_7(aux_2155);} } 
}



/* string-downcase */
obj_t string_downcase_77___r4_strings_6_7(obj_t string_56)
{ AN_OBJECT;
{ /* Ieee/string.scm 356 */
{ /* Ieee/string.scm 357 */
obj_t symbol1269_798;
symbol1269_798 = symbol1571___r4_strings_6_7; 
{ /* Ieee/string.scm 357 */

PUSH_TRACE(symbol1269_798); BUNSPEC; 
{ /* Ieee/string.scm 357 */
obj_t aux1268_799;
{ /* Ieee/string.scm 357 */
long len_292;
len_292 = 
STRING_LENGTH(string_56); 
{ /* Ieee/string.scm 357 */
obj_t res_293;
{ /* Ieee/string.scm 358 */
obj_t res1204_597;
{ /* Ieee/string.scm 145 */
long aux_2164;
{ /* Ieee/string.scm 145 */
int aux_2165;
aux_2165 = 
(int)(len_292); 
aux_2164 = 
(long)(aux_2165); } 
res1204_597 = 
make_string(aux_2164, ((unsigned char)' ')); } 
res_293 = res1204_597; } 
{ /* Ieee/string.scm 358 */

{ 
long i_294;
i_294 = ((long)0); 
loop_295:
if(
(i_294==len_292))
{ /* Ieee/string.scm 360 */
aux1268_799 = res_293; }  else 
{ /* Ieee/string.scm 360 */
{ /* Ieee/string.scm 363 */
unsigned char arg1054_297;
{ /* Ieee/string.scm 363 */
unsigned char arg1055_298;
{ /* Ieee/string.scm 363 */
unsigned char res1205_608;
{ /* Ieee/string.scm 164 */
bool_t test_2171;
{ /* Ieee/string.scm 164 */
long aux_2172;
aux_2172 = 
STRING_LENGTH(string_56); 
test_2171 = 
BOUND_CHECK(i_294, aux_2172); } 
if(test_2171)
{ /* Ieee/string.scm 164 */
res1205_608 = 
STRING_REF(string_56, i_294); }  else 
{ /* Ieee/string.scm 164 */
error_c_location_83___error(string1515___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_294), "Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 601 */
obj_t aux_2178;
{ /* ./Llib/error.scm 601 */
obj_t aux1463_1068;
aux1463_1068 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
if(
CHARP(aux1463_1068))
{ /* ./Llib/error.scm 601 */
aux_2178 = aux1463_1068
; }  else 
{ /* ./Llib/error.scm 601 */
bigloo_type_error_location_103___error(symbol1571___r4_strings_6_7, string1507___r4_strings_6_7, aux1463_1068, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
exit( -1 );} } 
res1205_608 = 
(unsigned char)CCHAR(aux_2178); } } } 
arg1055_298 = res1205_608; } 
arg1054_297 = 
tolower(arg1055_298); } 
{ /* Ieee/string.scm 172 */
bool_t test_2188;
{ /* Ieee/string.scm 172 */
long aux_2189;
aux_2189 = 
STRING_LENGTH(res_293); 
test_2188 = 
BOUND_CHECK(i_294, aux_2189); } 
if(test_2188)
{ /* Ieee/string.scm 172 */
STRING_SET(res_293, i_294, arg1054_297); }  else 
{ /* Ieee/string.scm 172 */
error_c_location_83___error(string1521___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_294), "Ieee/string.scm", ((long)8715)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); } } } 
{ 
long i_2197;
i_2197 = 
(i_294+((long)1)); 
i_294 = i_2197; 
goto loop_295;} } } } } } 
POP_TRACE(); 
return aux1268_799;} } } } 
}



/* _string-downcase1311 */
obj_t _string_downcase1311_132___r4_strings_6_7(obj_t env_900, obj_t string_901)
{ AN_OBJECT;
{ /* Ieee/string.scm 356 */
{ /* Ieee/string.scm 356 */
obj_t aux_2200;
if(
STRINGP(string_901))
{ /* Ieee/string.scm 356 */
aux_2200 = string_901
; }  else 
{ /* Ieee/string.scm 356 */
bigloo_type_error_location_103___error(symbol1572___r4_strings_6_7, string1513___r4_strings_6_7, string_901, string1506___r4_strings_6_7, 
BINT(((long)16893))); 
exit( -1 );} 
return 
string_downcase_77___r4_strings_6_7(aux_2200);} } 
}



/* string-upcase! */
obj_t string_upcase__158___r4_strings_6_7(obj_t string_57)
{ AN_OBJECT;
{ /* Ieee/string.scm 369 */
{ /* Ieee/string.scm 370 */
obj_t symbol1271_800;
symbol1271_800 = symbol1573___r4_strings_6_7; 
{ /* Ieee/string.scm 370 */

PUSH_TRACE(symbol1271_800); BUNSPEC; 
{ /* Ieee/string.scm 370 */
obj_t aux1270_801;
{ /* Ieee/string.scm 370 */
long len_301;
len_301 = 
STRING_LENGTH(string_57); 
{ 
long i_302;
i_302 = ((long)0); 
loop_303:
if(
(i_302==len_301))
{ /* Ieee/string.scm 372 */
aux1270_801 = string_57; }  else 
{ /* Ieee/string.scm 372 */
{ /* Ieee/string.scm 375 */
unsigned char arg1064_305;
{ /* Ieee/string.scm 375 */
unsigned char arg1065_306;
{ /* Ieee/string.scm 375 */
unsigned char res1206_632;
{ /* Ieee/string.scm 164 */
bool_t test_2211;
{ /* Ieee/string.scm 164 */
long aux_2212;
aux_2212 = 
STRING_LENGTH(string_57); 
test_2211 = 
BOUND_CHECK(i_302, aux_2212); } 
if(test_2211)
{ /* Ieee/string.scm 164 */
res1206_632 = 
STRING_REF(string_57, i_302); }  else 
{ /* Ieee/string.scm 164 */
error_c_location_83___error(string1515___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_302), "Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 601 */
obj_t aux_2218;
{ /* ./Llib/error.scm 601 */
obj_t aux1467_1072;
aux1467_1072 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
if(
CHARP(aux1467_1072))
{ /* ./Llib/error.scm 601 */
aux_2218 = aux1467_1072
; }  else 
{ /* ./Llib/error.scm 601 */
bigloo_type_error_location_103___error(symbol1573___r4_strings_6_7, string1507___r4_strings_6_7, aux1467_1072, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
exit( -1 );} } 
res1206_632 = 
(unsigned char)CCHAR(aux_2218); } } } 
arg1065_306 = res1206_632; } 
arg1064_305 = 
toupper(arg1065_306); } 
{ /* Ieee/string.scm 172 */
bool_t test_2228;
{ /* Ieee/string.scm 172 */
long aux_2229;
aux_2229 = 
STRING_LENGTH(string_57); 
test_2228 = 
BOUND_CHECK(i_302, aux_2229); } 
if(test_2228)
{ /* Ieee/string.scm 172 */
STRING_SET(string_57, i_302, arg1064_305); }  else 
{ /* Ieee/string.scm 172 */
error_c_location_83___error(string1521___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_302), "Ieee/string.scm", ((long)8715)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); } } } 
{ 
long i_2237;
i_2237 = 
(i_302+((long)1)); 
i_302 = i_2237; 
goto loop_303;} } } } 
POP_TRACE(); 
return aux1270_801;} } } } 
}



/* _string-upcase!1312 */
obj_t _string_upcase_1312_143___r4_strings_6_7(obj_t env_902, obj_t string_903)
{ AN_OBJECT;
{ /* Ieee/string.scm 369 */
{ /* Ieee/string.scm 369 */
obj_t aux_2240;
if(
STRINGP(string_903))
{ /* Ieee/string.scm 369 */
aux_2240 = string_903
; }  else 
{ /* Ieee/string.scm 369 */
bigloo_type_error_location_103___error(symbol1574___r4_strings_6_7, string1513___r4_strings_6_7, string_903, string1506___r4_strings_6_7, 
BINT(((long)17365))); 
exit( -1 );} 
return 
string_upcase__158___r4_strings_6_7(aux_2240);} } 
}



/* string-downcase! */
obj_t string_downcase__42___r4_strings_6_7(obj_t string_58)
{ AN_OBJECT;
{ /* Ieee/string.scm 381 */
{ /* Ieee/string.scm 382 */
obj_t symbol1273_802;
symbol1273_802 = symbol1575___r4_strings_6_7; 
{ /* Ieee/string.scm 382 */

PUSH_TRACE(symbol1273_802); BUNSPEC; 
{ /* Ieee/string.scm 382 */
obj_t aux1272_803;
{ /* Ieee/string.scm 382 */
long len_308;
len_308 = 
STRING_LENGTH(string_58); 
{ 
long i_309;
i_309 = ((long)0); 
loop_310:
if(
(i_309==len_308))
{ /* Ieee/string.scm 384 */
aux1272_803 = string_58; }  else 
{ /* Ieee/string.scm 384 */
{ /* Ieee/string.scm 387 */
unsigned char arg1068_312;
{ /* Ieee/string.scm 387 */
unsigned char arg1069_313;
{ /* Ieee/string.scm 387 */
unsigned char res1207_656;
{ /* Ieee/string.scm 164 */
bool_t test_2251;
{ /* Ieee/string.scm 164 */
long aux_2252;
aux_2252 = 
STRING_LENGTH(string_58); 
test_2251 = 
BOUND_CHECK(i_309, aux_2252); } 
if(test_2251)
{ /* Ieee/string.scm 164 */
res1207_656 = 
STRING_REF(string_58, i_309); }  else 
{ /* Ieee/string.scm 164 */
error_c_location_83___error(string1515___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_309), "Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 601 */
obj_t aux_2258;
{ /* ./Llib/error.scm 601 */
obj_t aux1471_1076;
aux1471_1076 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
if(
CHARP(aux1471_1076))
{ /* ./Llib/error.scm 601 */
aux_2258 = aux1471_1076
; }  else 
{ /* ./Llib/error.scm 601 */
bigloo_type_error_location_103___error(symbol1575___r4_strings_6_7, string1507___r4_strings_6_7, aux1471_1076, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
exit( -1 );} } 
res1207_656 = 
(unsigned char)CCHAR(aux_2258); } } } 
arg1069_313 = res1207_656; } 
arg1068_312 = 
tolower(arg1069_313); } 
{ /* Ieee/string.scm 172 */
bool_t test_2268;
{ /* Ieee/string.scm 172 */
long aux_2269;
aux_2269 = 
STRING_LENGTH(string_58); 
test_2268 = 
BOUND_CHECK(i_309, aux_2269); } 
if(test_2268)
{ /* Ieee/string.scm 172 */
STRING_SET(string_58, i_309, arg1068_312); }  else 
{ /* Ieee/string.scm 172 */
error_c_location_83___error(string1521___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_309), "Ieee/string.scm", ((long)8715)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); } } } 
{ 
long i_2277;
i_2277 = 
(i_309+((long)1)); 
i_309 = i_2277; 
goto loop_310;} } } } 
POP_TRACE(); 
return aux1272_803;} } } } 
}



/* _string-downcase!1313 */
obj_t _string_downcase_1313_48___r4_strings_6_7(obj_t env_904, obj_t string_905)
{ AN_OBJECT;
{ /* Ieee/string.scm 381 */
{ /* Ieee/string.scm 381 */
obj_t aux_2280;
if(
STRINGP(string_905))
{ /* Ieee/string.scm 381 */
aux_2280 = string_905
; }  else 
{ /* Ieee/string.scm 381 */
bigloo_type_error_location_103___error(symbol1576___r4_strings_6_7, string1513___r4_strings_6_7, string_905, string1506___r4_strings_6_7, 
BINT(((long)17812))); 
exit( -1 );} 
return 
string_downcase__42___r4_strings_6_7(aux_2280);} } 
}



/* string-capitalize! */
obj_t string_capitalize__136___r4_strings_6_7(obj_t string_59)
{ AN_OBJECT;
{ /* Ieee/string.scm 397 */
{ /* Ieee/string.scm 398 */
obj_t symbol1275_804;
symbol1275_804 = symbol1577___r4_strings_6_7; 
{ /* Ieee/string.scm 398 */

PUSH_TRACE(symbol1275_804); BUNSPEC; 
{ /* Ieee/string.scm 398 */
obj_t aux1274_805;
{ /* Ieee/string.scm 398 */
bool_t non_first_alpha_60_315;long string_len_173_316;
non_first_alpha_60_315 = ((bool_t)0); 
string_len_173_316 = 
STRING_LENGTH(string_59); 
{ 
long i_318;
i_318 = ((long)0); 
_anonymous_1071__94_319:
if(
(i_318==string_len_173_316))
{ /* Ieee/string.scm 400 */
aux1274_805 = string_59; }  else 
{ /* Ieee/string.scm 400 */
{ /* Ieee/string.scm 402 */
unsigned char c_321;
{ /* Ieee/string.scm 402 */
unsigned char res1208_680;
{ /* Ieee/string.scm 164 */
bool_t test_2291;
{ /* Ieee/string.scm 164 */
long aux_2292;
aux_2292 = 
STRING_LENGTH(string_59); 
test_2291 = 
BOUND_CHECK(i_318, aux_2292); } 
if(test_2291)
{ /* Ieee/string.scm 164 */
res1208_680 = 
STRING_REF(string_59, i_318); }  else 
{ /* Ieee/string.scm 164 */
error_c_location_83___error(string1515___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_318), "Ieee/string.scm", ((long)8304)); 
{ /* ./Llib/error.scm 601 */
obj_t aux_2298;
{ /* ./Llib/error.scm 601 */
obj_t aux1475_1080;
aux1475_1080 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
if(
CHARP(aux1475_1080))
{ /* ./Llib/error.scm 601 */
aux_2298 = aux1475_1080
; }  else 
{ /* ./Llib/error.scm 601 */
bigloo_type_error_location_103___error(symbol1577___r4_strings_6_7, string1507___r4_strings_6_7, aux1475_1080, string1517___r4_strings_6_7, 
BINT(((long)7583))); 
exit( -1 );} } 
res1208_680 = 
(unsigned char)CCHAR(aux_2298); } } } 
c_321 = res1208_680; } 
{ /* Ieee/string.scm 403 */
bool_t test_2307;
{ /* ./Ieee/char.scm 2352 */
unsigned char c_682;
c_682 = 
toupper(c_321); 
if(
(c_682>=((unsigned char)'A')))
{ /* ./Ieee/char.scm 2353 */
test_2307 = 
(c_682<=((unsigned char)'Z'))
; }  else 
{ /* ./Ieee/char.scm 2353 */
test_2307 = ((bool_t)0)
; } } 
if(test_2307)
{ /* Ieee/string.scm 403 */
if(non_first_alpha_60_315)
{ /* Ieee/string.scm 172 */
bool_t test_2313;
{ /* Ieee/string.scm 172 */
long aux_2314;
aux_2314 = 
STRING_LENGTH(string_59); 
test_2313 = 
BOUND_CHECK(i_318, aux_2314); } 
if(test_2313)
{ /* Ieee/string.scm 173 */
unsigned char aux_2317;
aux_2317 = 
tolower(c_321); 
STRING_SET(string_59, i_318, aux_2317); }  else 
{ /* Ieee/string.scm 172 */
error_c_location_83___error(string1521___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_318), "Ieee/string.scm", ((long)8715)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); } }  else 
{ /* Ieee/string.scm 404 */
non_first_alpha_60_315 = ((bool_t)1); 
{ /* Ieee/string.scm 172 */
bool_t test_2324;
{ /* Ieee/string.scm 172 */
long aux_2325;
aux_2325 = 
STRING_LENGTH(string_59); 
test_2324 = 
BOUND_CHECK(i_318, aux_2325); } 
if(test_2324)
{ /* Ieee/string.scm 173 */
unsigned char aux_2328;
aux_2328 = 
toupper(c_321); 
STRING_SET(string_59, i_318, aux_2328); }  else 
{ /* Ieee/string.scm 172 */
error_c_location_83___error(string1521___r4_strings_6_7, string1516___r4_strings_6_7, 
BINT(i_318), "Ieee/string.scm", ((long)8715)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); } } } }  else 
{ /* Ieee/string.scm 403 */
non_first_alpha_60_315 = ((bool_t)0); } } } 
{ 
long i_2335;
i_2335 = 
(i_318+((long)1)); 
i_318 = i_2335; 
goto _anonymous_1071__94_319;} } } } 
POP_TRACE(); 
return aux1274_805;} } } } 
}



/* _string-capitalize!1314 */
obj_t _string_capitalize_1314_64___r4_strings_6_7(obj_t env_906, obj_t string_907)
{ AN_OBJECT;
{ /* Ieee/string.scm 397 */
{ /* Ieee/string.scm 397 */
obj_t aux_2338;
if(
STRINGP(string_907))
{ /* Ieee/string.scm 397 */
aux_2338 = string_907
; }  else 
{ /* Ieee/string.scm 397 */
bigloo_type_error_location_103___error(symbol1578___r4_strings_6_7, string1513___r4_strings_6_7, string_907, string1506___r4_strings_6_7, 
BINT(((long)18559))); 
exit( -1 );} 
return 
string_capitalize__136___r4_strings_6_7(aux_2338);} } 
}



/* string-capitalize */
obj_t string_capitalize_230___r4_strings_6_7(obj_t string_60)
{ AN_OBJECT;
{ /* Ieee/string.scm 414 */
{ /* Ieee/string.scm 415 */
obj_t symbol1277_806;
symbol1277_806 = symbol1579___r4_strings_6_7; 
{ /* Ieee/string.scm 415 */

PUSH_TRACE(symbol1277_806); BUNSPEC; 
{ /* Ieee/string.scm 415 */
obj_t aux1276_807;
{ /* Ieee/string.scm 415 */
obj_t arg1077_712;
{ /* Ieee/string.scm 326 */
char * aux_2346;
aux_2346 = 
BSTRING_TO_STRING(string_60); 
arg1077_712 = 
string_to_bstring(aux_2346); } 
aux1276_807 = 
string_capitalize__136___r4_strings_6_7(arg1077_712); } 
POP_TRACE(); 
return aux1276_807;} } } } 
}



/* _string-capitalize1315 */
obj_t _string_capitalize1315_144___r4_strings_6_7(obj_t env_908, obj_t string_909)
{ AN_OBJECT;
{ /* Ieee/string.scm 414 */
{ /* Ieee/string.scm 414 */
obj_t aux_2351;
if(
STRINGP(string_909))
{ /* Ieee/string.scm 414 */
aux_2351 = string_909
; }  else 
{ /* Ieee/string.scm 414 */
bigloo_type_error_location_103___error(symbol1580___r4_strings_6_7, string1513___r4_strings_6_7, string_909, string1506___r4_strings_6_7, 
BINT(((long)19222))); 
exit( -1 );} 
return 
string_capitalize_230___r4_strings_6_7(aux_2351);} } 
}



/* string-for-read */
obj_t string_for_read_25___r4_strings_6_7(obj_t string_61)
{ AN_OBJECT;
{ /* Ieee/string.scm 420 */
{ /* Ieee/string.scm 421 */
obj_t symbol1279_1280;
symbol1279_1280 = symbol1581___r4_strings_6_7; 
{ /* Ieee/string.scm 421 */

PUSH_TRACE(symbol1279_1280); BUNSPEC; 
{ /* Ieee/string.scm 421 */
obj_t aux1278_1281;
aux1278_1281 = 
string_for_read(string_61); 
POP_TRACE(); 
return aux1278_1281;} } } } 
}



/* _string-for-read1316 */
obj_t _string_for_read1316_162___r4_strings_6_7(obj_t env_910, obj_t string_911)
{ AN_OBJECT;
{ /* Ieee/string.scm 420 */
{ /* Ieee/string.scm 420 */
obj_t string_1282;
if(
STRINGP(string_911))
{ /* Ieee/string.scm 420 */
string_1282 = string_911; }  else 
{ /* Ieee/string.scm 420 */
bigloo_type_error_location_103___error(symbol1582___r4_strings_6_7, string1513___r4_strings_6_7, string_911, string1506___r4_strings_6_7, 
BINT(((long)19526))); 
exit( -1 );} 
{ /* Ieee/string.scm 421 */
obj_t symbol1279_1283;
symbol1279_1283 = symbol1581___r4_strings_6_7; 
{ /* Ieee/string.scm 421 */

PUSH_TRACE(symbol1279_1283); BUNSPEC; 
{ /* Ieee/string.scm 421 */
obj_t aux1278_1284;
aux1278_1284 = 
string_for_read(string_1282); 
POP_TRACE(); 
return aux1278_1284;} } } } } 
}



/* blit-string-ur! */
obj_t blit_string_ur__74___r4_strings_6_7(obj_t s1_62, obj_t o1_63, obj_t s2_64, obj_t o2_65, obj_t l_66)
{ AN_OBJECT;
{ /* Ieee/string.scm 426 */
{ /* Ieee/string.scm 427 */
obj_t symbol1281_1285;
symbol1281_1285 = symbol1583___r4_strings_6_7; 
{ /* Ieee/string.scm 427 */

PUSH_TRACE(symbol1281_1285); BUNSPEC; 
{ /* Ieee/string.scm 427 */
obj_t aux1280_1286;
aux1280_1286 = 
blit_string(s1_62, o1_63, s2_64, o2_65, l_66); 
POP_TRACE(); 
return aux1280_1286;} } } } 
}



/* _blit-string-ur!1317 */
obj_t _blit_string_ur_1317_25___r4_strings_6_7(obj_t env_912, obj_t s1_913, obj_t o1_914, obj_t s2_915, obj_t o2_916, obj_t l_917)
{ AN_OBJECT;
{ /* Ieee/string.scm 426 */
{ /* Ieee/string.scm 426 */
obj_t s1_1287;obj_t o1_1288;obj_t s2_1289;obj_t o2_1290;obj_t l_1291;
if(
STRINGP(s1_913))
{ /* Ieee/string.scm 426 */
s1_1287 = s1_913; }  else 
{ /* Ieee/string.scm 426 */
bigloo_type_error_location_103___error(symbol1584___r4_strings_6_7, string1513___r4_strings_6_7, s1_913, string1506___r4_strings_6_7, 
BINT(((long)19820))); 
exit( -1 );} 
if(
INTEGERP(o1_914))
{ /* Ieee/string.scm 426 */
o1_1288 = o1_914; }  else 
{ /* Ieee/string.scm 426 */
bigloo_type_error_location_103___error(symbol1584___r4_strings_6_7, string1585___r4_strings_6_7, o1_914, string1506___r4_strings_6_7, 
BINT(((long)19820))); 
exit( -1 );} 
if(
STRINGP(s2_915))
{ /* Ieee/string.scm 426 */
s2_1289 = s2_915; }  else 
{ /* Ieee/string.scm 426 */
bigloo_type_error_location_103___error(symbol1584___r4_strings_6_7, string1513___r4_strings_6_7, s2_915, string1506___r4_strings_6_7, 
BINT(((long)19820))); 
exit( -1 );} 
if(
INTEGERP(o2_916))
{ /* Ieee/string.scm 426 */
o2_1290 = o2_916; }  else 
{ /* Ieee/string.scm 426 */
bigloo_type_error_location_103___error(symbol1584___r4_strings_6_7, string1585___r4_strings_6_7, o2_916, string1506___r4_strings_6_7, 
BINT(((long)19820))); 
exit( -1 );} 
if(
INTEGERP(l_917))
{ /* Ieee/string.scm 426 */
l_1291 = l_917; }  else 
{ /* Ieee/string.scm 426 */
bigloo_type_error_location_103___error(symbol1584___r4_strings_6_7, string1585___r4_strings_6_7, l_917, string1506___r4_strings_6_7, 
BINT(((long)19820))); 
exit( -1 );} 
{ /* Ieee/string.scm 427 */
obj_t symbol1281_1292;
symbol1281_1292 = symbol1583___r4_strings_6_7; 
{ /* Ieee/string.scm 427 */

PUSH_TRACE(symbol1281_1292); BUNSPEC; 
{ /* Ieee/string.scm 427 */
obj_t aux1280_1293;
aux1280_1293 = 
blit_string(s1_1287, o1_1288, s2_1289, o2_1290, l_1291); 
POP_TRACE(); 
return aux1280_1293;} } } } } 
}



/* blit-string! */
obj_t blit_string__141___r4_strings_6_7(obj_t s1_67, obj_t o1_68, obj_t s2_69, obj_t o2_70, obj_t l_71)
{ AN_OBJECT;
{ /* Ieee/string.scm 432 */
{ /* Ieee/string.scm 433 */
obj_t symbol1283_812;
symbol1283_812 = symbol1586___r4_strings_6_7; 
{ /* Ieee/string.scm 433 */

PUSH_TRACE(symbol1283_812); BUNSPEC; 
{ /* Ieee/string.scm 433 */
obj_t aux1282_813;
{ /* Ieee/string.scm 433 */
bool_t test_2401;
{ /* Ieee/string.scm 433 */
bool_t test_2402;
{ /* Ieee/string.scm 433 */
long aux_2409;long aux_2403;
{ /* ./Ieee/fixnum.scm 1813 */
long aux_2410;
aux_2410 = 
STRING_LENGTH(s1_67); 
aux_2409 = 
(aux_2410+((long)1)); } 
{ /* ./Ieee/fixnum.scm 1813 */
long aux_2406;long aux_2404;
aux_2406 = 
(long)CINT(o1_68); 
aux_2404 = 
(long)CINT(l_71); 
aux_2403 = 
(aux_2404+aux_2406); } 
test_2402 = 
BOUND_CHECK(aux_2403, aux_2409); } 
if(test_2402)
{ /* Ieee/string.scm 434 */
long aux_2420;long aux_2414;
{ /* ./Ieee/fixnum.scm 1813 */
long aux_2421;
aux_2421 = 
STRING_LENGTH(s2_69); 
aux_2420 = 
(aux_2421+((long)1)); } 
{ /* ./Ieee/fixnum.scm 1813 */
long aux_2417;long aux_2415;
aux_2417 = 
(long)CINT(o2_70); 
aux_2415 = 
(long)CINT(l_71); 
aux_2414 = 
(aux_2415+aux_2417); } 
test_2401 = 
BOUND_CHECK(aux_2414, aux_2420); }  else 
{ /* Ieee/string.scm 433 */
test_2401 = ((bool_t)0)
; } } 
if(test_2401)
{ /* Ieee/string.scm 433 */
aux1282_813 = 
blit_string(s1_67, o1_68, s2_69, o2_70, l_71); }  else 
{ /* Ieee/string.scm 433 */
{ /* Ieee/string.scm 436 */
obj_t arg1081_331;
{ /* Ieee/string.scm 437 */
long arg1084_334;long arg1085_335;
arg1084_334 = 
STRING_LENGTH(s1_67); 
arg1085_335 = 
STRING_LENGTH(s2_69); 
{ /* Ieee/string.scm 437 */
obj_t list1086_336;
{ /* Ieee/string.scm 437 */
obj_t arg1087_337;
{ /* Ieee/string.scm 437 */
obj_t arg1088_338;
{ /* Ieee/string.scm 437 */
obj_t arg1089_339;
{ /* Ieee/string.scm 437 */
obj_t arg1090_340;
arg1090_340 = 
MAKE_PAIR(l_71, BNIL); 
arg1089_339 = 
MAKE_PAIR(o2_70, arg1090_340); } 
{ /* Ieee/string.scm 437 */
obj_t aux_2430;
aux_2430 = 
BINT(arg1085_335); 
arg1088_338 = 
MAKE_PAIR(aux_2430, arg1089_339); } } 
arg1087_337 = 
MAKE_PAIR(o1_68, arg1088_338); } 
{ /* Ieee/string.scm 437 */
obj_t aux_2434;
aux_2434 = 
BINT(arg1084_334); 
list1086_336 = 
MAKE_PAIR(aux_2434, arg1087_337); } } 
arg1081_331 = list1086_336; } } 
error_c_location_83___error(string1587___r4_strings_6_7, string1588___r4_strings_6_7, arg1081_331, "Ieee/string.scm", ((long)20339)); } 
aux1282_813 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1517___r4_strings_6_7, 
BINT(((long)7583))); } } 
POP_TRACE(); 
return aux1282_813;} } } } 
}



/* _blit-string!1318 */
obj_t _blit_string_1318_217___r4_strings_6_7(obj_t env_918, obj_t s1_919, obj_t o1_920, obj_t s2_921, obj_t o2_922, obj_t l_923)
{ AN_OBJECT;
{ /* Ieee/string.scm 432 */
{ /* Ieee/string.scm 432 */
obj_t aux_2465;obj_t aux_2459;obj_t aux_2453;obj_t aux_2447;obj_t aux_2441;
if(
INTEGERP(l_923))
{ /* Ieee/string.scm 432 */
aux_2465 = l_923
; }  else 
{ /* Ieee/string.scm 432 */
bigloo_type_error_location_103___error(symbol1589___r4_strings_6_7, string1585___r4_strings_6_7, l_923, string1506___r4_strings_6_7, 
BINT(((long)20124))); 
exit( -1 );} 
if(
INTEGERP(o2_922))
{ /* Ieee/string.scm 432 */
aux_2459 = o2_922
; }  else 
{ /* Ieee/string.scm 432 */
bigloo_type_error_location_103___error(symbol1589___r4_strings_6_7, string1585___r4_strings_6_7, o2_922, string1506___r4_strings_6_7, 
BINT(((long)20124))); 
exit( -1 );} 
if(
STRINGP(s2_921))
{ /* Ieee/string.scm 432 */
aux_2453 = s2_921
; }  else 
{ /* Ieee/string.scm 432 */
bigloo_type_error_location_103___error(symbol1589___r4_strings_6_7, string1513___r4_strings_6_7, s2_921, string1506___r4_strings_6_7, 
BINT(((long)20124))); 
exit( -1 );} 
if(
INTEGERP(o1_920))
{ /* Ieee/string.scm 432 */
aux_2447 = o1_920
; }  else 
{ /* Ieee/string.scm 432 */
bigloo_type_error_location_103___error(symbol1589___r4_strings_6_7, string1585___r4_strings_6_7, o1_920, string1506___r4_strings_6_7, 
BINT(((long)20124))); 
exit( -1 );} 
if(
STRINGP(s1_919))
{ /* Ieee/string.scm 432 */
aux_2441 = s1_919
; }  else 
{ /* Ieee/string.scm 432 */
bigloo_type_error_location_103___error(symbol1589___r4_strings_6_7, string1513___r4_strings_6_7, s1_919, string1506___r4_strings_6_7, 
BINT(((long)20124))); 
exit( -1 );} 
return 
blit_string__141___r4_strings_6_7(aux_2441, aux_2447, aux_2453, aux_2459, aux_2465);} } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___r4_strings_6_7()
{ AN_OBJECT;
{ /* Ieee/string.scm 18 */
{ /* Ieee/string.scm 18 */
obj_t symbol1285_814;
symbol1285_814 = symbol1590___r4_strings_6_7; 
{ /* Ieee/string.scm 18 */

PUSH_TRACE(symbol1285_814); BUNSPEC; 
{ /* Ieee/string.scm 18 */
obj_t aux1284_815;
aux1284_815 = 
module_initialization_70___error(((long)0), "__R4_STRINGS_6_7"); 
POP_TRACE(); 
return aux1284_815;} } } } 
}

