/*===========================================================================*/
/*   (Llib/bigloo.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo2.1a.h>
#include <signal.h>

extern bool_t bigloo_strcmp(obj_t, obj_t);
extern obj_t string_to_symbol(char *);
static obj_t symbol1217___bigloo = BUNSPEC;
static obj_t symbol1216___bigloo = BUNSPEC;
static obj_t symbol1215___bigloo = BUNSPEC;
static obj_t symbol1213___bigloo = BUNSPEC;
static obj_t symbol1212___bigloo = BUNSPEC;
static obj_t symbol1210___bigloo = BUNSPEC;
static obj_t symbol1198___bigloo = BUNSPEC;
static obj_t symbol1197___bigloo = BUNSPEC;
extern obj_t string_append(obj_t, obj_t);
static obj_t toplevel_init_63___bigloo();
static obj_t _release__212___bigloo = BUNSPEC;
static obj_t _level__58___bigloo = BUNSPEC;
extern long closure_arity_107___bigloo(obj_t);
extern obj_t check_version__107___bigloo(obj_t, char *, obj_t);
extern obj_t string_to_bstring(char *);
static obj_t _closure_arity_246___bigloo(obj_t, obj_t);
extern obj_t bigloo_type_error_location_103___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t string_to_bstring(char *);
static obj_t _modules__206___bigloo = BUNSPEC;
extern obj_t debug_error_location_199___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t module_initialization_70___bigloo(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t c_substring(obj_t, long, long);
static obj_t _unspecified___bigloo(obj_t);
extern obj_t error_c_location_83___error(obj_t, obj_t, obj_t, char *, long);
extern obj_t unspecified___bigloo();
static obj_t _cnst__123___bigloo(obj_t, obj_t);
static obj_t imported_modules_init_94___bigloo();
extern long minfx___r4_numbers_6_5_fixnum(long, obj_t);
static obj_t require_initialization_114___bigloo = BUNSPEC;
extern bool_t cnst__120___bigloo(obj_t);
static obj_t _check_version__245___bigloo(obj_t, obj_t, obj_t, obj_t);
static obj_t cnst_init_137___bigloo();
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( check_version__env_23___bigloo, _check_version__245___bigloo1221, _check_version__245___bigloo, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( closure_arity_env_23___bigloo, _closure_arity_246___bigloo1222, _closure_arity_246___bigloo, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( cnst__env_192___bigloo, _cnst__123___bigloo1223, _cnst__123___bigloo, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( unspecified_env_163___bigloo, _unspecified___bigloo1224, _unspecified___bigloo, 0L, 0 );
DEFINE_STRING( string1214___bigloo, string1214___bigloo1225, "PROCEDURE", 9 );
DEFINE_STRING( string1211___bigloo, string1211___bigloo1226, "STRING", 6 );
DEFINE_STRING( string1199___bigloo, string1199___bigloo1227, "BSTRING", 7 );
DEFINE_STRING( string1209___bigloo, string1209___bigloo1228, "and other by: ", 14 );
DEFINE_STRING( string1208___bigloo, string1208___bigloo1229, "Some modules have been compiled by: ", 36 );
DEFINE_STRING( string1207___bigloo, string1207___bigloo1230, "index out of range", 18 );
DEFINE_STRING( string1206___bigloo, string1206___bigloo1231, "string-set!", 11 );
DEFINE_STRING( string1205___bigloo, string1205___bigloo1232, " (level 0)", 10 );
DEFINE_STRING( string1204___bigloo, string1204___bigloo1233, "UCHAR", 5 );
DEFINE_STRING( string1203___bigloo, string1203___bigloo1234, "/home/tahoe2/serrano/tmp/bigloo/runtime/./Llib/error.scm", 56 );
DEFINE_STRING( string1202___bigloo, string1202___bigloo1235, "Illegal index", 13 );
DEFINE_STRING( string1201___bigloo, string1201___bigloo1236, "substring", 9 );
DEFINE_STRING( string1200___bigloo, string1200___bigloo1237, "/home/tahoe2/serrano/tmp/bigloo/runtime/Llib/bigloo.scm", 55 );



/* module-initialization */
obj_t module_initialization_70___bigloo(long checksum_595, char * from_596)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___bigloo))
{ 
require_initialization_114___bigloo = 
BBOOL(((bool_t)0)); 
cnst_init_137___bigloo(); 
imported_modules_init_94___bigloo(); 
toplevel_init_63___bigloo(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___bigloo()
{ AN_OBJECT;
{ /* Llib/bigloo.scm 14 */
symbol1197___bigloo = 
string_to_symbol("@__BIGLOO"); 
symbol1198___bigloo = 
string_to_symbol("CHECK-VERSION!"); 
symbol1210___bigloo = 
string_to_symbol("_CHECK-VERSION!"); 
symbol1212___bigloo = 
string_to_symbol("CLOSURE-ARITY"); 
symbol1213___bigloo = 
string_to_symbol("_CLOSURE-ARITY"); 
symbol1215___bigloo = 
string_to_symbol("UNSPECIFIED"); 
symbol1216___bigloo = 
string_to_symbol("CNST?"); 
return ( 
symbol1217___bigloo = 
string_to_symbol("IMPORTED-MODULES-INIT"), BUNSPEC) ;} 
}



/* toplevel-init */
obj_t toplevel_init_63___bigloo()
{ AN_OBJECT;
{ /* Llib/bigloo.scm 14 */
{ /* Llib/bigloo.scm 14 */
obj_t symbol1160_533;
symbol1160_533 = symbol1197___bigloo; 
{ /* Llib/bigloo.scm 14 */

PUSH_TRACE(symbol1160_533); BUNSPEC; 
{ /* Llib/bigloo.scm 14 */
obj_t aux1159_534;
_release__212___bigloo = BFALSE; 
_level__58___bigloo = BFALSE; 
aux1159_534 = ( 
_modules__206___bigloo = BNIL, BUNSPEC) ; 
POP_TRACE(); 
return aux1159_534;} } } } 
}



/* check-version! */
obj_t check_version__107___bigloo(obj_t module_1, char * release_2, obj_t level_3)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 136 */
{ /* Llib/bigloo.scm 138 */
obj_t symbol1162_535;
symbol1162_535 = symbol1198___bigloo; 
{ /* Llib/bigloo.scm 138 */

PUSH_TRACE(symbol1162_535); BUNSPEC; 
{ /* Llib/bigloo.scm 138 */
obj_t aux1161_536;
{ /* Llib/bigloo.scm 138 */
bool_t test1007_218;
{ /* Llib/bigloo.scm 138 */
obj_t obj_373;
obj_373 = _release__212___bigloo; 
test1007_218 = 
STRINGP(obj_373); } 
if(test1007_218)
{ /* Llib/bigloo.scm 142 */
bool_t test1008_219;
{ /* Llib/bigloo.scm 142 */
bool_t test1020_236;
{ /* Llib/bigloo.scm 142 */
long min_240;
{ /* Llib/bigloo.scm 142 */
long arg1025_244;
{ /* Llib/bigloo.scm 142 */
long arg1027_246;long arg1028_247;
{ /* ./Ieee/string.scm 2946 */
obj_t aux_616;
aux_616 = 
string_to_bstring(release_2); 
arg1027_246 = 
STRING_LENGTH(aux_616); } 
{ /* Llib/bigloo.scm 143 */
obj_t string_375;
{ /* Llib/bigloo.scm 143 */
obj_t aux1171_554;
aux1171_554 = _release__212___bigloo; 
if(
STRINGP(aux1171_554))
{ /* Llib/bigloo.scm 143 */
string_375 = aux1171_554; }  else 
{ /* Llib/bigloo.scm 143 */
bigloo_type_error_location_103___error(symbol1198___bigloo, string1199___bigloo, aux1171_554, string1200___bigloo, 
BINT(((long)6150))); 
exit( -1 );} } 
arg1028_247 = 
STRING_LENGTH(string_375); } 
{ /* Llib/bigloo.scm 142 */
obj_t list1029_248;
{ /* Llib/bigloo.scm 142 */
obj_t aux_625;
aux_625 = 
BINT(arg1028_247); 
list1029_248 = 
MAKE_PAIR(aux_625, BNIL); } 
arg1025_244 = 
minfx___r4_numbers_6_5_fixnum(arg1027_246, list1029_248); } } 
min_240 = 
(arg1025_244-((long)1)); } 
{ /* Llib/bigloo.scm 145 */
bool_t test1022_241;
{ /* Llib/bigloo.scm 145 */
obj_t arg1023_242;obj_t arg1024_243;
{ /* Llib/bigloo.scm 145 */
obj_t res1157_408;
{ /* Llib/bigloo.scm 145 */
obj_t string_378;
string_378 = 
string_to_bstring(release_2); 
{ /* ./Ieee/string.scm 3059 */
bool_t test_631;
if(
(min_240>=((long)0)))
{ /* ./Ieee/string.scm 3060 */
bool_t test_634;
{ /* ./Ieee/string.scm 3060 */
long aux_635;
{ /* ./Ieee/fixnum.scm 1375 */
long aux_636;
aux_636 = 
STRING_LENGTH(string_378); 
aux_635 = 
(aux_636+((long)1)); } 
test_634 = 
BOUND_CHECK(((long)0), aux_635); } 
if(test_634)
{ /* ./Ieee/string.scm 3061 */
long aux_640;
{ /* ./Ieee/fixnum.scm 1375 */
long aux_641;
aux_641 = 
STRING_LENGTH(string_378); 
aux_640 = 
(aux_641+((long)1)); } 
test_631 = 
BOUND_CHECK(min_240, aux_640); }  else 
{ /* ./Ieee/string.scm 3060 */
test_631 = ((bool_t)0)
; } }  else 
{ /* ./Ieee/string.scm 3059 */
test_631 = ((bool_t)0)
; } 
if(test_631)
{ /* ./Ieee/string.scm 3059 */
res1157_408 = 
c_substring(string_378, ((long)0), min_240); }  else 
{ /* ./Ieee/string.scm 3059 */
{ /* ./Ieee/string.scm 3065 */
obj_t arg1038_392;
{ /* ./Ieee/pair-list.scm 1908 */
obj_t aux_648;obj_t aux_646;
aux_648 = 
BINT(min_240); 
aux_646 = 
BINT(((long)0)); 
arg1038_392 = 
MAKE_PAIR(aux_646, aux_648); } 
error_c_location_83___error(string1201___bigloo, string1202___bigloo, arg1038_392, "./Ieee/string.scm", ((long)13819)); } 
{ /* ./Llib/error.scm 350 */
obj_t aux1173_556;
aux1173_556 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1203___bigloo, 
BINT(((long)7583))); 
if(
STRINGP(aux1173_556))
{ /* ./Llib/error.scm 350 */
res1157_408 = aux1173_556; }  else 
{ /* ./Llib/error.scm 350 */
bigloo_type_error_location_103___error(symbol1198___bigloo, string1199___bigloo, aux1173_556, string1203___bigloo, 
BINT(((long)7583))); 
exit( -1 );} } } } } 
arg1023_242 = res1157_408; } 
{ /* Llib/bigloo.scm 146 */
obj_t res1158_439;
{ /* Llib/bigloo.scm 146 */
obj_t string_409;
{ /* Llib/bigloo.scm 146 */
obj_t aux1175_558;
aux1175_558 = _release__212___bigloo; 
if(
STRINGP(aux1175_558))
{ /* Llib/bigloo.scm 146 */
string_409 = aux1175_558; }  else 
{ /* Llib/bigloo.scm 146 */
bigloo_type_error_location_103___error(symbol1198___bigloo, string1199___bigloo, aux1175_558, string1200___bigloo, 
BINT(((long)6244))); 
exit( -1 );} } 
{ /* ./Ieee/string.scm 3059 */
bool_t test_664;
if(
(min_240>=((long)0)))
{ /* ./Ieee/string.scm 3060 */
bool_t test_667;
{ /* ./Ieee/string.scm 3060 */
long aux_668;
{ /* ./Ieee/fixnum.scm 1375 */
long aux_669;
aux_669 = 
STRING_LENGTH(string_409); 
aux_668 = 
(aux_669+((long)1)); } 
test_667 = 
BOUND_CHECK(((long)0), aux_668); } 
if(test_667)
{ /* ./Ieee/string.scm 3061 */
long aux_673;
{ /* ./Ieee/fixnum.scm 1375 */
long aux_674;
aux_674 = 
STRING_LENGTH(string_409); 
aux_673 = 
(aux_674+((long)1)); } 
test_664 = 
BOUND_CHECK(min_240, aux_673); }  else 
{ /* ./Ieee/string.scm 3060 */
test_664 = ((bool_t)0)
; } }  else 
{ /* ./Ieee/string.scm 3059 */
test_664 = ((bool_t)0)
; } 
if(test_664)
{ /* ./Ieee/string.scm 3059 */
res1158_439 = 
c_substring(string_409, ((long)0), min_240); }  else 
{ /* ./Ieee/string.scm 3059 */
{ /* ./Ieee/string.scm 3065 */
obj_t arg1038_423;
{ /* ./Ieee/pair-list.scm 1908 */
obj_t aux_681;obj_t aux_679;
aux_681 = 
BINT(min_240); 
aux_679 = 
BINT(((long)0)); 
arg1038_423 = 
MAKE_PAIR(aux_679, aux_681); } 
error_c_location_83___error(string1201___bigloo, string1202___bigloo, arg1038_423, "./Ieee/string.scm", ((long)13819)); } 
{ /* ./Llib/error.scm 350 */
obj_t aux1177_560;
aux1177_560 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1203___bigloo, 
BINT(((long)7583))); 
if(
STRINGP(aux1177_560))
{ /* ./Llib/error.scm 350 */
res1158_439 = aux1177_560; }  else 
{ /* ./Llib/error.scm 350 */
bigloo_type_error_location_103___error(symbol1198___bigloo, string1199___bigloo, aux1177_560, string1203___bigloo, 
BINT(((long)7583))); 
exit( -1 );} } } } } 
arg1024_243 = res1158_439; } 
test1022_241 = 
bigloo_strcmp(arg1023_242, arg1024_243); } 
if(test1022_241)
{ /* Llib/bigloo.scm 145 */
test1020_236 = ((bool_t)0); }  else 
{ /* Llib/bigloo.scm 145 */
test1020_236 = ((bool_t)1); } } } 
if(test1020_236)
{ /* Llib/bigloo.scm 142 */
test1008_219 = ((bool_t)1); }  else 
{ /* Llib/bigloo.scm 147 */
bool_t _andtest_1002_237;
_andtest_1002_237 = 
CHARP(level_3); 
if(_andtest_1002_237)
{ /* Llib/bigloo.scm 147 */
bool_t _andtest_1003_238;
{ /* Llib/bigloo.scm 147 */
obj_t obj_443;
obj_443 = _level__58___bigloo; 
_andtest_1003_238 = 
CHARP(obj_443); } 
if(_andtest_1003_238)
{ /* Llib/bigloo.scm 147 */
bool_t test1021_239;
{ /* Llib/bigloo.scm 147 */
unsigned char char1_444;unsigned char char2_445;
{ /* Llib/bigloo.scm 147 */
obj_t aux_699;
{ /* Llib/bigloo.scm 147 */
obj_t aux1179_562;
aux1179_562 = _level__58___bigloo; 
if(
CHARP(aux1179_562))
{ /* Llib/bigloo.scm 147 */
aux_699 = aux1179_562
; }  else 
{ /* Llib/bigloo.scm 147 */
bigloo_type_error_location_103___error(symbol1198___bigloo, string1204___bigloo, aux1179_562, string1200___bigloo, 
BINT(((long)6320))); 
exit( -1 );} } 
char1_444 = 
(unsigned char)CCHAR(aux_699); } 
{ /* Llib/bigloo.scm 147 */
obj_t aux_706;
if(_andtest_1002_237)
{ /* Llib/bigloo.scm 147 */
aux_706 = level_3
; }  else 
{ /* Llib/bigloo.scm 147 */
bigloo_type_error_location_103___error(symbol1198___bigloo, string1204___bigloo, level_3, string1200___bigloo, 
BINT(((long)6327))); 
exit( -1 );} 
char2_445 = 
(unsigned char)CCHAR(aux_706); } 
test1021_239 = 
(char1_444==char2_445); } 
if(test1021_239)
{ /* Llib/bigloo.scm 147 */
test1008_219 = ((bool_t)0); }  else 
{ /* Llib/bigloo.scm 147 */
test1008_219 = ((bool_t)1); } }  else 
{ /* Llib/bigloo.scm 147 */
test1008_219 = ((bool_t)0); } }  else 
{ /* Llib/bigloo.scm 147 */
test1008_219 = ((bool_t)0); } } } 
if(test1008_219)
{ /* Llib/bigloo.scm 142 */
{ /* Llib/bigloo.scm 154 */
obj_t arg1009_221;obj_t arg1010_222;obj_t arg1011_223;
{ /* Llib/bigloo.scm 154 */
obj_t arg1015_227;
{ /* Llib/bigloo.scm 155 */
obj_t release_446;obj_t level_447;
release_446 = _release__212___bigloo; 
level_447 = _level__58___bigloo; 
{ /* Llib/bigloo.scm 149 */
bool_t test1019_448;
test1019_448 = 
CHARP(level_447); 
if(test1019_448)
{ /* Llib/bigloo.scm 150 */
obj_t s_449;
{ /* ./Ieee/string.scm 3114 */
char * aux_717;
aux_717 = 
BSTRING_TO_STRING(string1205___bigloo); 
s_449 = 
string_to_bstring(aux_717); } 
{ /* Llib/bigloo.scm 151 */
unsigned char char_166_454;
{ /* Llib/bigloo.scm 151 */
obj_t aux_720;
if(test1019_448)
{ /* Llib/bigloo.scm 151 */
aux_720 = level_447
; }  else 
{ /* Llib/bigloo.scm 151 */
bigloo_type_error_location_103___error(symbol1198___bigloo, string1204___bigloo, level_447, string1200___bigloo, 
BINT(((long)6458))); 
exit( -1 );} 
char_166_454 = 
(unsigned char)CCHAR(aux_720); } 
{ /* ./Ieee/string.scm 2960 */
bool_t test_726;
{ /* ./Ieee/string.scm 2960 */
long aux_727;
aux_727 = 
STRING_LENGTH(s_449); 
test_726 = 
BOUND_CHECK(((long)8), aux_727); } 
if(test_726)
{ /* ./Ieee/string.scm 2960 */
STRING_SET(s_449, ((long)8), char_166_454); }  else 
{ /* ./Ieee/string.scm 2960 */
error_c_location_83___error(string1206___bigloo, string1207___bigloo, 
BINT(((long)8)), "./Ieee/string.scm", ((long)8715)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1203___bigloo, 
BINT(((long)7583))); } } } 
{ /* Llib/bigloo.scm 152 */
obj_t aux_735;
if(
STRINGP(release_446))
{ /* Llib/bigloo.scm 152 */
aux_735 = release_446
; }  else 
{ /* Llib/bigloo.scm 152 */
bigloo_type_error_location_103___error(symbol1198___bigloo, string1199___bigloo, release_446, string1200___bigloo, 
BINT(((long)6485))); 
exit( -1 );} 
arg1015_227 = 
string_append(aux_735, s_449); } }  else 
{ /* Llib/bigloo.scm 149 */
arg1015_227 = release_446; } } } 
{ /* Llib/bigloo.scm 154 */
obj_t aux_742;
if(
STRINGP(arg1015_227))
{ /* Llib/bigloo.scm 154 */
aux_742 = arg1015_227
; }  else 
{ /* Llib/bigloo.scm 154 */
bigloo_type_error_location_103___error(symbol1198___bigloo, string1199___bigloo, arg1015_227, string1200___bigloo, 
BINT(((long)6543))); 
exit( -1 );} 
arg1009_221 = 
string_append(string1208___bigloo, aux_742); } } 
{ /* Llib/bigloo.scm 156 */
obj_t arg1017_229;
{ /* Llib/bigloo.scm 149 */
bool_t test1019_463;
test1019_463 = 
CHARP(level_3); 
if(test1019_463)
{ /* Llib/bigloo.scm 150 */
obj_t s_464;
{ /* ./Ieee/string.scm 3114 */
char * aux_751;
aux_751 = 
BSTRING_TO_STRING(string1205___bigloo); 
s_464 = 
string_to_bstring(aux_751); } 
{ /* Llib/bigloo.scm 151 */
unsigned char char_166_469;
{ /* Llib/bigloo.scm 151 */
obj_t aux_754;
if(test1019_463)
{ /* Llib/bigloo.scm 151 */
aux_754 = level_3
; }  else 
{ /* Llib/bigloo.scm 151 */
bigloo_type_error_location_103___error(symbol1198___bigloo, string1204___bigloo, level_3, string1200___bigloo, 
BINT(((long)6458))); 
exit( -1 );} 
char_166_469 = 
(unsigned char)CCHAR(aux_754); } 
{ /* ./Ieee/string.scm 2960 */
bool_t test_760;
{ /* ./Ieee/string.scm 2960 */
long aux_761;
aux_761 = 
STRING_LENGTH(s_464); 
test_760 = 
BOUND_CHECK(((long)8), aux_761); } 
if(test_760)
{ /* ./Ieee/string.scm 2960 */
STRING_SET(s_464, ((long)8), char_166_469); }  else 
{ /* ./Ieee/string.scm 2960 */
error_c_location_83___error(string1206___bigloo, string1207___bigloo, 
BINT(((long)8)), "./Ieee/string.scm", ((long)8715)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1203___bigloo, 
BINT(((long)7583))); } } } 
{ /* Llib/bigloo.scm 152 */
obj_t aux_769;
aux_769 = 
string_to_bstring(release_2); 
arg1017_229 = 
string_append(aux_769, s_464); } }  else 
{ /* Llib/bigloo.scm 149 */
arg1017_229 = 
string_to_bstring(release_2); } } 
{ /* Llib/bigloo.scm 156 */
obj_t aux_773;
if(
STRINGP(arg1017_229))
{ /* Llib/bigloo.scm 156 */
aux_773 = arg1017_229
; }  else 
{ /* Llib/bigloo.scm 156 */
bigloo_type_error_location_103___error(symbol1198___bigloo, string1199___bigloo, arg1017_229, string1200___bigloo, 
BINT(((long)6646))); 
exit( -1 );} 
arg1010_222 = 
string_append(string1209___bigloo, aux_773); } } 
{ /* Llib/bigloo.scm 158 */
obj_t obj2_477;
obj2_477 = _modules__206___bigloo; 
arg1011_223 = 
MAKE_PAIR(module_1, obj2_477); } 
error_c_location_83___error(arg1009_221, arg1010_222, arg1011_223, "Llib/bigloo.scm", ((long)6536)); } 
aux1161_536 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1203___bigloo, 
BINT(((long)7583))); }  else 
{ /* Llib/bigloo.scm 142 */
{ /* Llib/bigloo.scm 160 */
obj_t obj2_495;
obj2_495 = _modules__206___bigloo; 
aux1161_536 = ( 
_modules__206___bigloo = 
MAKE_PAIR(module_1, obj2_495), BUNSPEC) ; } } }  else 
{ /* Llib/bigloo.scm 138 */
{ /* Llib/bigloo.scm 139 */
obj_t list1030_249;
list1030_249 = 
MAKE_PAIR(module_1, BNIL); 
_modules__206___bigloo = list1030_249; } 
_release__212___bigloo = 
string_to_bstring(release_2); 
aux1161_536 = ( 
_level__58___bigloo = level_3, BUNSPEC) ; } } 
POP_TRACE(); 
return aux1161_536;} } } } 
}



/* _check-version! */
obj_t _check_version__245___bigloo(obj_t env_545, obj_t module_546, obj_t release_547, obj_t level_548)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 136 */
{ /* Llib/bigloo.scm 136 */
char * aux_788;
{ /* Llib/bigloo.scm 136 */
obj_t aux_789;
if(
STRINGP(release_547))
{ /* Llib/bigloo.scm 136 */
aux_789 = release_547
; }  else 
{ /* Llib/bigloo.scm 136 */
bigloo_type_error_location_103___error(symbol1210___bigloo, string1211___bigloo, release_547, string1200___bigloo, 
BINT(((long)5897))); 
exit( -1 );} 
aux_788 = 
BSTRING_TO_STRING(aux_789); } 
return 
check_version__107___bigloo(module_546, aux_788, level_548);} } 
}



/* closure-arity */
long closure_arity_107___bigloo(obj_t proc_4)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 172 */
{ /* Llib/bigloo.scm 173 */
obj_t symbol1164_581;
symbol1164_581 = symbol1212___bigloo; 
{ /* Llib/bigloo.scm 173 */

PUSH_TRACE(symbol1164_581); BUNSPEC; 
{ /* Llib/bigloo.scm 173 */
long aux1163_582;
aux1163_582 = 
PROCEDURE_ARITY(proc_4); 
POP_TRACE(); 
return aux1163_582;} } } } 
}



/* _closure-arity */
obj_t _closure_arity_246___bigloo(obj_t env_549, obj_t proc_550)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 172 */
{ /* Llib/bigloo.scm 172 */
long aux_800;
{ /* Llib/bigloo.scm 172 */
long res1218_586;
{ /* Llib/bigloo.scm 172 */
obj_t proc_583;
if(
PROCEDUREP(proc_550))
{ /* Llib/bigloo.scm 172 */
proc_583 = proc_550; }  else 
{ /* Llib/bigloo.scm 172 */
bigloo_type_error_location_103___error(symbol1213___bigloo, string1214___bigloo, proc_550, string1200___bigloo, 
BINT(((long)7328))); 
exit( -1 );} 
{ /* Llib/bigloo.scm 173 */
obj_t symbol1164_584;
symbol1164_584 = symbol1212___bigloo; 
{ /* Llib/bigloo.scm 173 */

PUSH_TRACE(symbol1164_584); BUNSPEC; 
{ /* Llib/bigloo.scm 173 */
long aux1163_585;
aux1163_585 = 
PROCEDURE_ARITY(proc_583); 
POP_TRACE(); 
res1218_586 = aux1163_585; } } } } 
aux_800 = res1218_586; } 
return 
BINT(aux_800);} } 
}



/* unspecified */
obj_t unspecified___bigloo()
{ AN_OBJECT;
{ /* Llib/bigloo.scm 178 */
{ /* Llib/bigloo.scm 178 */
obj_t symbol1166_587;
symbol1166_587 = symbol1215___bigloo; 
{ /* Llib/bigloo.scm 178 */

PUSH_TRACE(symbol1166_587); BUNSPEC; 
POP_TRACE(); 
return BUNSPEC;} } } 
}



/* _unspecified */
obj_t _unspecified___bigloo(obj_t env_551)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 178 */
{ /* Llib/bigloo.scm 178 */
obj_t symbol1166_588;
symbol1166_588 = symbol1215___bigloo; 
{ /* Llib/bigloo.scm 178 */

PUSH_TRACE(symbol1166_588); BUNSPEC; 
POP_TRACE(); 
return BUNSPEC;} } } 
}



/* cnst? */
bool_t cnst__120___bigloo(obj_t obj_5)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 184 */
{ /* Llib/bigloo.scm 185 */
obj_t symbol1168_589;
symbol1168_589 = symbol1216___bigloo; 
{ /* Llib/bigloo.scm 185 */

PUSH_TRACE(symbol1168_589); BUNSPEC; 
{ /* Llib/bigloo.scm 185 */
bool_t aux1167_590;
aux1167_590 = 
CNSTP(obj_5); 
POP_TRACE(); 
return aux1167_590;} } } } 
}



/* _cnst? */
obj_t _cnst__123___bigloo(obj_t env_552, obj_t obj_553)
{ AN_OBJECT;
{ /* Llib/bigloo.scm 184 */
{ /* Llib/bigloo.scm 184 */
bool_t aux_817;
{ /* Llib/bigloo.scm 184 */
bool_t res1219_594;
{ /* Llib/bigloo.scm 184 */
obj_t obj_591;
obj_591 = obj_553; 
{ /* Llib/bigloo.scm 185 */
obj_t symbol1168_592;
symbol1168_592 = symbol1216___bigloo; 
{ /* Llib/bigloo.scm 185 */

PUSH_TRACE(symbol1168_592); BUNSPEC; 
{ /* Llib/bigloo.scm 185 */
bool_t aux1167_593;
aux1167_593 = 
CNSTP(obj_591); 
POP_TRACE(); 
res1219_594 = aux1167_593; } } } } 
aux_817 = res1219_594; } 
return 
BBOOL(aux_817);} } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___bigloo()
{ AN_OBJECT;
{ /* Llib/bigloo.scm 14 */
{ /* Llib/bigloo.scm 14 */
obj_t symbol1170_543;
symbol1170_543 = symbol1217___bigloo; 
{ /* Llib/bigloo.scm 14 */

PUSH_TRACE(symbol1170_543); BUNSPEC; 
{ /* Llib/bigloo.scm 14 */
obj_t aux1169_544;
aux1169_544 = 
module_initialization_70___error(((long)0), "__BIGLOO"); 
POP_TRACE(); 
return aux1169_544;} } } } 
}

