/*===========================================================================*/
/*   (Llib/binary.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t output_obj_57___binary(obj_t, obj_t);
static obj_t _open_output_binary_file1172_156___binary(obj_t, obj_t);
extern obj_t string_to_symbol(char *);
extern obj_t append_output_binary_file(obj_t);
static obj_t _open_input_binary_file1174_0___binary(obj_t, obj_t);
extern obj_t input_obj(obj_t);
static obj_t symbol1219___binary = BUNSPEC;
static obj_t symbol1218___binary = BUNSPEC;
static obj_t symbol1217___binary = BUNSPEC;
static obj_t symbol1215___binary = BUNSPEC;
static obj_t symbol1214___binary = BUNSPEC;
static obj_t symbol1213___binary = BUNSPEC;
static obj_t symbol1212___binary = BUNSPEC;
static obj_t symbol1211___binary = BUNSPEC;
static obj_t symbol1199___binary = BUNSPEC;
static obj_t symbol1210___binary = BUNSPEC;
static obj_t symbol1198___binary = BUNSPEC;
static obj_t symbol1208___binary = BUNSPEC;
static obj_t symbol1207___binary = BUNSPEC;
static obj_t symbol1206___binary = BUNSPEC;
static obj_t symbol1205___binary = BUNSPEC;
static obj_t symbol1204___binary = BUNSPEC;
static obj_t symbol1203___binary = BUNSPEC;
static obj_t symbol1200___binary = BUNSPEC;
extern obj_t output_obj(obj_t, obj_t);
extern obj_t input_obj_79___binary(obj_t);
extern bool_t binary_port__84___binary(obj_t);
extern obj_t output_char_229___binary(obj_t, char);
static obj_t _append_output_binary_file1173_56___binary(obj_t, obj_t);
extern obj_t open_output_binary_file_193___binary(obj_t);
extern obj_t close_binary_port(obj_t);
extern obj_t open_input_binary_file_64___binary(obj_t);
static obj_t _close_binary_port1175_145___binary(obj_t, obj_t);
extern obj_t bigloo_type_error_location_103___error(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _input_obj1176_35___binary(obj_t, obj_t);
static obj_t _output_obj1177_111___binary(obj_t, obj_t, obj_t);
extern obj_t open_output_binary_file(obj_t);
extern obj_t module_initialization_70___binary(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t open_input_binary_file(obj_t);
extern unsigned char integer__char_140___r4_characters_6_6(long);
extern obj_t append_output_binary_file_44___binary(obj_t);
static obj_t _input_char1179_18___binary(obj_t, obj_t);
extern obj_t close_binary_port_18___binary(obj_t);
static obj_t _binary_port__90___binary(obj_t, obj_t);
extern obj_t input_char_4___binary(obj_t);
static obj_t imported_modules_init_94___binary();
static obj_t require_initialization_114___binary = BUNSPEC;
static obj_t _output_char1178_137___binary(obj_t, obj_t, obj_t);
static obj_t cnst_init_137___binary();
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( output_char_env_218___binary, _output_char1178_137___binary1222, _output_char1178_137___binary, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( binary_port__env_72___binary, _binary_port__90___binary1223, _binary_port__90___binary, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( open_input_binary_file_env_41___binary, _open_input_binary_file1174_0___binary1224, _open_input_binary_file1174_0___binary, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( open_output_binary_file_env_149___binary, _open_output_binary_file1172_156___binary1225, _open_output_binary_file1172_156___binary, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( append_output_binary_file_env_43___binary, _append_output_binary_file1173_56___binary1226, _append_output_binary_file1173_56___binary, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( output_obj_env_240___binary, _output_obj1177_111___binary1227, _output_obj1177_111___binary, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( input_char_env_235___binary, _input_char1179_18___binary1228, _input_char1179_18___binary, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( close_binary_port_env_90___binary, _close_binary_port1175_145___binary1229, _close_binary_port1175_145___binary, 0L, 1 );
DEFINE_STRING( string1216___binary, string1216___binary1230, "CHAR", 4 );
DEFINE_STRING( string1209___binary, string1209___binary1231, "BINARY-PORT", 11 );
DEFINE_STRING( string1202___binary, string1202___binary1232, "/home/tahoe2/serrano/tmp/bigloo/runtime/Llib/binary.scm", 55 );
DEFINE_STRING( string1201___binary, string1201___binary1233, "BSTRING", 7 );
DEFINE_EXPORT_PROCEDURE( input_obj_env_141___binary, _input_obj1176_35___binary1234, _input_obj1176_35___binary, 0L, 1 );



/* module-initialization */
obj_t module_initialization_70___binary(long checksum_607, char * from_608)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___binary))
{ 
require_initialization_114___binary = 
BBOOL(((bool_t)0)); 
cnst_init_137___binary(); 
imported_modules_init_94___binary(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___binary()
{ AN_OBJECT;
{ /* Llib/binary.scm 15 */
symbol1198___binary = 
string_to_symbol("BINARY-PORT?"); 
symbol1199___binary = 
string_to_symbol("OPEN-OUTPUT-BINARY-FILE"); 
symbol1200___binary = 
string_to_symbol("_OPEN-OUTPUT-BINARY-FILE1172"); 
symbol1203___binary = 
string_to_symbol("APPEND-OUTPUT-BINARY-FILE"); 
symbol1204___binary = 
string_to_symbol("_APPEND-OUTPUT-BINARY-FILE1173"); 
symbol1205___binary = 
string_to_symbol("OPEN-INPUT-BINARY-FILE"); 
symbol1206___binary = 
string_to_symbol("_OPEN-INPUT-BINARY-FILE1174"); 
symbol1207___binary = 
string_to_symbol("CLOSE-BINARY-PORT"); 
symbol1208___binary = 
string_to_symbol("_CLOSE-BINARY-PORT1175"); 
symbol1210___binary = 
string_to_symbol("INPUT-OBJ"); 
symbol1211___binary = 
string_to_symbol("_INPUT-OBJ1176"); 
symbol1212___binary = 
string_to_symbol("OUTPUT-OBJ"); 
symbol1213___binary = 
string_to_symbol("_OUTPUT-OBJ1177"); 
symbol1214___binary = 
string_to_symbol("OUTPUT-CHAR"); 
symbol1215___binary = 
string_to_symbol("_OUTPUT-CHAR1178"); 
symbol1217___binary = 
string_to_symbol("INPUT-CHAR"); 
symbol1218___binary = 
string_to_symbol("_INPUT-CHAR1179"); 
return ( 
symbol1219___binary = 
string_to_symbol("IMPORTED-MODULES-INIT"), BUNSPEC) ;} 
}



/* binary-port? */
bool_t binary_port__84___binary(obj_t obj_1)
{ AN_OBJECT;
{ /* Llib/binary.scm 74 */
{ /* Llib/binary.scm 75 */
obj_t symbol1153_553;
symbol1153_553 = symbol1198___binary; 
{ /* Llib/binary.scm 75 */

PUSH_TRACE(symbol1153_553); BUNSPEC; 
{ /* Llib/binary.scm 75 */
bool_t aux1152_554;
aux1152_554 = 
BINARY_PORTP(obj_1); 
POP_TRACE(); 
return aux1152_554;} } } } 
}



/* _binary-port? */
obj_t _binary_port__90___binary(obj_t env_515, obj_t obj_516)
{ AN_OBJECT;
{ /* Llib/binary.scm 74 */
{ /* Llib/binary.scm 74 */
bool_t aux_635;
{ /* Llib/binary.scm 74 */
bool_t res1220_558;
{ /* Llib/binary.scm 74 */
obj_t obj_555;
obj_555 = obj_516; 
{ /* Llib/binary.scm 75 */
obj_t symbol1153_556;
symbol1153_556 = symbol1198___binary; 
{ /* Llib/binary.scm 75 */

PUSH_TRACE(symbol1153_556); BUNSPEC; 
{ /* Llib/binary.scm 75 */
bool_t aux1152_557;
aux1152_557 = 
BINARY_PORTP(obj_555); 
POP_TRACE(); 
res1220_558 = aux1152_557; } } } } 
aux_635 = res1220_558; } 
return 
BBOOL(aux_635);} } 
}



/* open-output-binary-file */
obj_t open_output_binary_file_193___binary(obj_t str_2)
{ AN_OBJECT;
{ /* Llib/binary.scm 80 */
{ /* Llib/binary.scm 81 */
obj_t symbol1155_559;
symbol1155_559 = symbol1199___binary; 
{ /* Llib/binary.scm 81 */

PUSH_TRACE(symbol1155_559); BUNSPEC; 
{ /* Llib/binary.scm 81 */
obj_t aux1154_560;
aux1154_560 = 
open_output_binary_file(str_2); 
POP_TRACE(); 
return aux1154_560;} } } } 
}



/* _open-output-binary-file1172 */
obj_t _open_output_binary_file1172_156___binary(obj_t env_517, obj_t str_518)
{ AN_OBJECT;
{ /* Llib/binary.scm 80 */
{ /* Llib/binary.scm 80 */
obj_t str_561;
if(
STRINGP(str_518))
{ /* Llib/binary.scm 80 */
str_561 = str_518; }  else 
{ /* Llib/binary.scm 80 */
bigloo_type_error_location_103___error(symbol1200___binary, string1201___binary, str_518, string1202___binary, 
BINT(((long)3727))); 
exit( -1 );} 
{ /* Llib/binary.scm 81 */
obj_t symbol1155_562;
symbol1155_562 = symbol1199___binary; 
{ /* Llib/binary.scm 81 */

PUSH_TRACE(symbol1155_562); BUNSPEC; 
{ /* Llib/binary.scm 81 */
obj_t aux1154_563;
aux1154_563 = 
open_output_binary_file(str_561); 
POP_TRACE(); 
return aux1154_563;} } } } } 
}



/* append-output-binary-file */
obj_t append_output_binary_file_44___binary(obj_t str_3)
{ AN_OBJECT;
{ /* Llib/binary.scm 86 */
{ /* Llib/binary.scm 87 */
obj_t symbol1157_564;
symbol1157_564 = symbol1203___binary; 
{ /* Llib/binary.scm 87 */

PUSH_TRACE(symbol1157_564); BUNSPEC; 
{ /* Llib/binary.scm 87 */
obj_t aux1156_565;
aux1156_565 = 
append_output_binary_file(str_3); 
POP_TRACE(); 
return aux1156_565;} } } } 
}



/* _append-output-binary-file1173 */
obj_t _append_output_binary_file1173_56___binary(obj_t env_519, obj_t str_520)
{ AN_OBJECT;
{ /* Llib/binary.scm 86 */
{ /* Llib/binary.scm 86 */
obj_t str_566;
if(
STRINGP(str_520))
{ /* Llib/binary.scm 86 */
str_566 = str_520; }  else 
{ /* Llib/binary.scm 86 */
bigloo_type_error_location_103___error(symbol1204___binary, string1201___binary, str_520, string1202___binary, 
BINT(((long)4031))); 
exit( -1 );} 
{ /* Llib/binary.scm 87 */
obj_t symbol1157_567;
symbol1157_567 = symbol1203___binary; 
{ /* Llib/binary.scm 87 */

PUSH_TRACE(symbol1157_567); BUNSPEC; 
{ /* Llib/binary.scm 87 */
obj_t aux1156_568;
aux1156_568 = 
append_output_binary_file(str_566); 
POP_TRACE(); 
return aux1156_568;} } } } } 
}



/* open-input-binary-file */
obj_t open_input_binary_file_64___binary(obj_t str_4)
{ AN_OBJECT;
{ /* Llib/binary.scm 92 */
{ /* Llib/binary.scm 93 */
obj_t symbol1159_569;
symbol1159_569 = symbol1205___binary; 
{ /* Llib/binary.scm 93 */

PUSH_TRACE(symbol1159_569); BUNSPEC; 
{ /* Llib/binary.scm 93 */
obj_t aux1158_570;
aux1158_570 = 
open_input_binary_file(str_4); 
POP_TRACE(); 
return aux1158_570;} } } } 
}



/* _open-input-binary-file1174 */
obj_t _open_input_binary_file1174_0___binary(obj_t env_521, obj_t str_522)
{ AN_OBJECT;
{ /* Llib/binary.scm 92 */
{ /* Llib/binary.scm 92 */
obj_t str_571;
if(
STRINGP(str_522))
{ /* Llib/binary.scm 92 */
str_571 = str_522; }  else 
{ /* Llib/binary.scm 92 */
bigloo_type_error_location_103___error(symbol1206___binary, string1201___binary, str_522, string1202___binary, 
BINT(((long)4339))); 
exit( -1 );} 
{ /* Llib/binary.scm 93 */
obj_t symbol1159_572;
symbol1159_572 = symbol1205___binary; 
{ /* Llib/binary.scm 93 */

PUSH_TRACE(symbol1159_572); BUNSPEC; 
{ /* Llib/binary.scm 93 */
obj_t aux1158_573;
aux1158_573 = 
open_input_binary_file(str_571); 
POP_TRACE(); 
return aux1158_573;} } } } } 
}



/* close-binary-port */
obj_t close_binary_port_18___binary(obj_t port_5)
{ AN_OBJECT;
{ /* Llib/binary.scm 98 */
{ /* Llib/binary.scm 99 */
obj_t symbol1161_574;
symbol1161_574 = symbol1207___binary; 
{ /* Llib/binary.scm 99 */

PUSH_TRACE(symbol1161_574); BUNSPEC; 
{ /* Llib/binary.scm 99 */
obj_t aux1160_575;
aux1160_575 = 
close_binary_port(port_5); 
POP_TRACE(); 
return aux1160_575;} } } } 
}



/* _close-binary-port1175 */
obj_t _close_binary_port1175_145___binary(obj_t env_523, obj_t port_524)
{ AN_OBJECT;
{ /* Llib/binary.scm 98 */
{ /* Llib/binary.scm 98 */
obj_t port_576;
if(
BINARY_PORTP(port_524))
{ /* Llib/binary.scm 98 */
port_576 = port_524; }  else 
{ /* Llib/binary.scm 98 */
bigloo_type_error_location_103___error(symbol1208___binary, string1209___binary, port_524, string1202___binary, 
BINT(((long)4641))); 
exit( -1 );} 
{ /* Llib/binary.scm 99 */
obj_t symbol1161_577;
symbol1161_577 = symbol1207___binary; 
{ /* Llib/binary.scm 99 */

PUSH_TRACE(symbol1161_577); BUNSPEC; 
{ /* Llib/binary.scm 99 */
obj_t aux1160_578;
aux1160_578 = 
close_binary_port(port_576); 
POP_TRACE(); 
return aux1160_578;} } } } } 
}



/* input-obj */
obj_t input_obj_79___binary(obj_t port_6)
{ AN_OBJECT;
{ /* Llib/binary.scm 104 */
{ /* Llib/binary.scm 105 */
obj_t symbol1163_579;
symbol1163_579 = symbol1210___binary; 
{ /* Llib/binary.scm 105 */

PUSH_TRACE(symbol1163_579); BUNSPEC; 
{ /* Llib/binary.scm 105 */
obj_t aux1162_580;
aux1162_580 = 
input_obj(port_6); 
POP_TRACE(); 
return aux1162_580;} } } } 
}



/* _input-obj1176 */
obj_t _input_obj1176_35___binary(obj_t env_525, obj_t port_526)
{ AN_OBJECT;
{ /* Llib/binary.scm 104 */
{ /* Llib/binary.scm 104 */
obj_t port_581;
if(
BINARY_PORTP(port_526))
{ /* Llib/binary.scm 104 */
port_581 = port_526; }  else 
{ /* Llib/binary.scm 104 */
bigloo_type_error_location_103___error(symbol1211___binary, string1209___binary, port_526, string1202___binary, 
BINT(((long)4935))); 
exit( -1 );} 
{ /* Llib/binary.scm 105 */
obj_t symbol1163_582;
symbol1163_582 = symbol1210___binary; 
{ /* Llib/binary.scm 105 */

PUSH_TRACE(symbol1163_582); BUNSPEC; 
{ /* Llib/binary.scm 105 */
obj_t aux1162_583;
aux1162_583 = 
input_obj(port_581); 
POP_TRACE(); 
return aux1162_583;} } } } } 
}



/* output-obj */
obj_t output_obj_57___binary(obj_t port_7, obj_t obj_8)
{ AN_OBJECT;
{ /* Llib/binary.scm 110 */
{ /* Llib/binary.scm 111 */
obj_t symbol1165_584;
symbol1165_584 = symbol1212___binary; 
{ /* Llib/binary.scm 111 */

PUSH_TRACE(symbol1165_584); BUNSPEC; 
{ /* Llib/binary.scm 111 */
obj_t aux1164_585;
aux1164_585 = 
output_obj(port_7, obj_8); 
POP_TRACE(); 
return aux1164_585;} } } } 
}



/* _output-obj1177 */
obj_t _output_obj1177_111___binary(obj_t env_527, obj_t port_528, obj_t obj_529)
{ AN_OBJECT;
{ /* Llib/binary.scm 110 */
{ /* Llib/binary.scm 110 */
obj_t port_586;obj_t obj_587;
if(
BINARY_PORTP(port_528))
{ /* Llib/binary.scm 110 */
port_586 = port_528; }  else 
{ /* Llib/binary.scm 110 */
bigloo_type_error_location_103___error(symbol1213___binary, string1209___binary, port_528, string1202___binary, 
BINT(((long)5213))); 
exit( -1 );} 
obj_587 = obj_529; 
{ /* Llib/binary.scm 111 */
obj_t symbol1165_588;
symbol1165_588 = symbol1212___binary; 
{ /* Llib/binary.scm 111 */

PUSH_TRACE(symbol1165_588); BUNSPEC; 
{ /* Llib/binary.scm 111 */
obj_t aux1164_589;
aux1164_589 = 
output_obj(port_586, obj_587); 
POP_TRACE(); 
return aux1164_589;} } } } } 
}



/* output-char */
obj_t output_char_229___binary(obj_t port_9, char char_10)
{ AN_OBJECT;
{ /* Llib/binary.scm 116 */
{ /* Llib/binary.scm 117 */
obj_t symbol1167_590;
symbol1167_590 = symbol1214___binary; 
{ /* Llib/binary.scm 117 */

PUSH_TRACE(symbol1167_590); BUNSPEC; 
{ /* Llib/binary.scm 117 */
obj_t aux1166_591;
aux1166_591 = 
(fputc( char_10, BINARY_PORT( port_9 ).file ), BUNSPEC); 
POP_TRACE(); 
return aux1166_591;} } } } 
}



/* _output-char1178 */
obj_t _output_char1178_137___binary(obj_t env_530, obj_t port_531, obj_t char_532)
{ AN_OBJECT;
{ /* Llib/binary.scm 116 */
{ /* Llib/binary.scm 116 */
obj_t port_592;char char_166_593;
if(
BINARY_PORTP(port_531))
{ /* Llib/binary.scm 116 */
port_592 = port_531; }  else 
{ /* Llib/binary.scm 116 */
bigloo_type_error_location_103___error(symbol1215___binary, string1209___binary, port_531, string1202___binary, 
BINT(((long)5506))); 
exit( -1 );} 
{ /* Llib/binary.scm 116 */
obj_t aux_714;
if(
CHARP(char_532))
{ /* Llib/binary.scm 116 */
aux_714 = char_532
; }  else 
{ /* Llib/binary.scm 116 */
bigloo_type_error_location_103___error(symbol1215___binary, string1216___binary, char_532, string1202___binary, 
BINT(((long)5506))); 
exit( -1 );} 
char_166_593 = 
CCHAR(aux_714); } 
{ /* Llib/binary.scm 117 */
obj_t symbol1167_594;
symbol1167_594 = symbol1214___binary; 
{ /* Llib/binary.scm 117 */

PUSH_TRACE(symbol1167_594); BUNSPEC; 
{ /* Llib/binary.scm 117 */
obj_t aux1166_595;
aux1166_595 = 
(fputc( char_166_593, BINARY_PORT( port_592 ).file ), BUNSPEC); 
POP_TRACE(); 
return aux1166_595;} } } } } 
}



/* input-char */
obj_t input_char_4___binary(obj_t port_11)
{ AN_OBJECT;
{ /* Llib/binary.scm 122 */
{ /* Llib/binary.scm 123 */
obj_t symbol1169_596;
symbol1169_596 = symbol1217___binary; 
{ /* Llib/binary.scm 123 */

PUSH_TRACE(symbol1169_596); BUNSPEC; 
{ /* Llib/binary.scm 123 */
obj_t aux1168_597;
{ /* Llib/binary.scm 123 */
int char_598;
char_598 = 
(fgetc( BINARY_PORT( port_11 ).file )); 
{ /* Llib/binary.scm 124 */
bool_t test1006_599;
{ /* Llib/binary.scm 124 */
int arg1007_600;
arg1007_600 = 
EOF; 
{ /* ./Ieee/fixnum.scm 2359 */
long aux_729;long aux_727;
aux_729 = 
(long)(arg1007_600); 
aux_727 = 
(long)(char_598); 
test1006_599 = 
(aux_727==aux_729); } } 
if(test1006_599)
{ /* Llib/binary.scm 124 */
aux1168_597 = BEOF; }  else 
{ /* Llib/binary.scm 126 */
unsigned char aux_733;
aux_733 = 
integer__char_140___r4_characters_6_6(
(long)(char_598)); 
aux1168_597 = 
BCHAR(aux_733); } } } 
POP_TRACE(); 
return aux1168_597;} } } } 
}



/* _input-char1179 */
obj_t _input_char1179_18___binary(obj_t env_533, obj_t port_534)
{ AN_OBJECT;
{ /* Llib/binary.scm 122 */
{ /* Llib/binary.scm 122 */
obj_t port_601;
if(
BINARY_PORTP(port_534))
{ /* Llib/binary.scm 122 */
port_601 = port_534; }  else 
{ /* Llib/binary.scm 122 */
bigloo_type_error_location_103___error(symbol1218___binary, string1209___binary, port_534, string1202___binary, 
BINT(((long)5840))); 
exit( -1 );} 
{ /* Llib/binary.scm 123 */
obj_t symbol1169_602;
symbol1169_602 = symbol1217___binary; 
{ /* Llib/binary.scm 123 */

PUSH_TRACE(symbol1169_602); BUNSPEC; 
{ /* Llib/binary.scm 123 */
obj_t aux1168_603;
{ /* Llib/binary.scm 123 */
int char_604;
char_604 = 
(fgetc( BINARY_PORT( port_601 ).file )); 
{ /* Llib/binary.scm 124 */
bool_t test1006_605;
{ /* Llib/binary.scm 124 */
int arg1007_606;
arg1007_606 = 
EOF; 
{ /* ./Ieee/fixnum.scm 2359 */
long aux_748;long aux_746;
aux_748 = 
(long)(arg1007_606); 
aux_746 = 
(long)(char_604); 
test1006_605 = 
(aux_746==aux_748); } } 
if(test1006_605)
{ /* Llib/binary.scm 124 */
aux1168_603 = BEOF; }  else 
{ /* Llib/binary.scm 126 */
unsigned char aux_752;
aux_752 = 
integer__char_140___r4_characters_6_6(
(long)(char_604)); 
aux1168_603 = 
BCHAR(aux_752); } } } 
POP_TRACE(); 
return aux1168_603;} } } } } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___binary()
{ AN_OBJECT;
{ /* Llib/binary.scm 15 */
{ /* Llib/binary.scm 15 */
obj_t symbol1171_513;
symbol1171_513 = symbol1219___binary; 
{ /* Llib/binary.scm 15 */

PUSH_TRACE(symbol1171_513); BUNSPEC; 
{ /* Llib/binary.scm 15 */
obj_t aux1170_514;
aux1170_514 = 
module_initialization_70___error(((long)0), "__BINARY"); 
POP_TRACE(); 
return aux1170_514;} } } } 
}

