/*===========================================================================*/
/*   (Llib/process.scm)                                                      */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t string_to_keyword(char *);
extern obj_t process_exit_status_63___process(obj_t);
extern bool_t process_wait_122___process(obj_t);
extern obj_t string_to_symbol(char *);
extern obj_t process_input_port_25___process(obj_t);
extern obj_t process_output_port_86___process(obj_t);
static obj_t _process__54___process(obj_t, obj_t);
static obj_t symbol1299___process = BUNSPEC;
extern obj_t process_continue_186___process(obj_t);
static obj_t symbol1297___process = BUNSPEC;
static obj_t symbol1301___process = BUNSPEC;
static obj_t symbol1300___process = BUNSPEC;
static obj_t symbol1284___process = BUNSPEC;
static obj_t symbol1283___process = BUNSPEC;
static obj_t symbol1282___process = BUNSPEC;
static obj_t symbol1281___process = BUNSPEC;
static obj_t symbol1279___process = BUNSPEC;
static obj_t symbol1280___process = BUNSPEC;
static obj_t symbol1278___process = BUNSPEC;
static obj_t symbol1277___process = BUNSPEC;
static obj_t symbol1275___process = BUNSPEC;
static obj_t symbol1274___process = BUNSPEC;
static obj_t symbol1273___process = BUNSPEC;
static obj_t symbol1272___process = BUNSPEC;
static obj_t symbol1271___process = BUNSPEC;
static obj_t symbol1269___process = BUNSPEC;
static obj_t symbol1270___process = BUNSPEC;
static obj_t symbol1268___process = BUNSPEC;
static obj_t symbol1267___process = BUNSPEC;
static obj_t symbol1266___process = BUNSPEC;
static obj_t symbol1265___process = BUNSPEC;
static obj_t symbol1264___process = BUNSPEC;
static obj_t symbol1263___process = BUNSPEC;
static obj_t symbol1262___process = BUNSPEC;
static obj_t symbol1259___process = BUNSPEC;
static obj_t symbol1258___process = BUNSPEC;
static obj_t _process_input_port_248___process(obj_t, obj_t);
static obj_t symbol1257___process = BUNSPEC;
static obj_t _process_list_8___process(obj_t);
static obj_t _process_send_signal_25___process(obj_t, obj_t, obj_t);
extern bool_t process_alive__25___process(obj_t);
extern bool_t process__75___process(obj_t);
static obj_t _process_stop_38___process(obj_t, obj_t);
extern obj_t c_process_continue(obj_t);
static obj_t keyword1296___process = BUNSPEC;
static obj_t keyword1295___process = BUNSPEC;
static obj_t keyword1294___process = BUNSPEC;
static obj_t keyword1293___process = BUNSPEC;
static obj_t keyword1292___process = BUNSPEC;
static obj_t keyword1291___process = BUNSPEC;
static obj_t keyword1287___process = BUNSPEC;
extern obj_t c_process_list();
extern obj_t bigloo_type_error_location_103___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t c_process_stop(obj_t);
extern obj_t c_process_send_signal(obj_t, int);
static obj_t _process_exit_status_230___process(obj_t, obj_t);
static obj_t _process_kill_194___process(obj_t, obj_t);
extern obj_t debug_error_location_199___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t module_initialization_70___process(long, char *);
extern obj_t module_initialization_70___error(long, char *);
static obj_t _process_output_port_146___process(obj_t, obj_t);
extern obj_t process_list_172___process();
static obj_t _process_wait_128___process(obj_t, obj_t);
static obj_t _run_process_4___process(obj_t, obj_t, obj_t);
extern obj_t process_stop_113___process(obj_t);
extern obj_t process_send_signal_117___process(obj_t, int);
extern obj_t error_c_location_83___error(obj_t, obj_t, obj_t, char *, long);
extern obj_t c_unregister_process(obj_t);
extern obj_t c_process_alivep(obj_t);
static obj_t _process_pid_113___process(obj_t, obj_t);
extern obj_t c_process_kill(obj_t);
extern obj_t run_process_29___process(obj_t, obj_t);
static obj_t _process_alive__232___process(obj_t, obj_t);
extern obj_t unregister_process_179___process(obj_t);
extern obj_t process_error_port_133___process(obj_t);
extern obj_t c_process_wait(obj_t);
static obj_t _process_continue_223___process(obj_t, obj_t);
extern obj_t c_process_xstatus(obj_t);
static obj_t imported_modules_init_94___process();
static obj_t _unregister_process_206___process(obj_t, obj_t);
extern obj_t c_run_process(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _process_error_port_135___process(obj_t, obj_t);
static obj_t require_initialization_114___process = BUNSPEC;
extern int process_pid_210___process(obj_t);
extern obj_t process_kill_93___process(obj_t);
static obj_t cnst_init_137___process();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( process_stop_env_39___process, _process_stop_38___process1307, _process_stop_38___process, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( process__env_163___process, _process__54___process1308, _process__54___process, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( process_send_signal_env_135___process, _process_send_signal_25___process1309, _process_send_signal_25___process, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( process_kill_env_209___process, _process_kill_194___process1310, _process_kill_194___process, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( process_error_port_env_248___process, _process_error_port_135___process1311, _process_error_port_135___process, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( process_list_env_224___process, _process_list_8___process1312, _process_list_8___process, 0L, 0 );
DEFINE_EXPORT_PROCEDURE( process_alive__env_47___process, _process_alive__232___process1313, _process_alive__232___process, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( process_output_port_env_138___process, _process_output_port_146___process1314, _process_output_port_146___process, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( run_process_env_117___process, _run_process_4___process1315, va_generic_entry, _run_process_4___process, -2 );
DEFINE_EXPORT_PROCEDURE( process_pid_env_38___process, _process_pid_113___process1316, _process_pid_113___process, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( unregister_process_env_112___process, _unregister_process_206___process1317, _unregister_process_206___process, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( process_continue_env_196___process, _process_continue_223___process1318, _process_continue_223___process, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( process_wait_env_238___process, _process_wait_128___process1319, _process_wait_128___process, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( process_input_port_env_47___process, _process_input_port_248___process1320, _process_input_port_248___process, 0L, 1 );
DEFINE_STRING( string1298___process, string1298___process1321, "BSTRING", 7 );
DEFINE_STRING( string1289___process, string1289___process1322, "Illegal argument", 16 );
DEFINE_STRING( string1290___process, string1290___process1323, "/home/tahoe2/serrano/tmp/bigloo/runtime/./Llib/error.scm", 56 );
DEFINE_STRING( string1288___process, string1288___process1324, "run-process", 11 );
DEFINE_STRING( string1286___process, string1286___process1325, "/home/tahoe2/serrano/tmp/bigloo/runtime/./Ieee/pair-list.scm", 60 );
DEFINE_STRING( string1285___process, string1285___process1326, "PAIR", 4 );
DEFINE_STRING( string1276___process, string1276___process1327, "INT", 3 );
DEFINE_STRING( string1261___process, string1261___process1328, "/home/tahoe2/serrano/tmp/bigloo/runtime/Llib/process.scm", 56 );
DEFINE_STRING( string1260___process, string1260___process1329, "PROCESS", 7 );
DEFINE_EXPORT_PROCEDURE( process_exit_status_env_111___process, _process_exit_status_230___process1330, _process_exit_status_230___process, 0L, 1 );



/* module-initialization */
obj_t module_initialization_70___process(long checksum_731, char * from_732)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___process))
{ 
require_initialization_114___process = 
BBOOL(((bool_t)0)); 
cnst_init_137___process(); 
imported_modules_init_94___process(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___process()
{ AN_OBJECT;
{ /* Llib/process.scm 15 */
symbol1257___process = 
string_to_symbol("PROCESS?"); 
symbol1258___process = 
string_to_symbol("PROCESS-PID"); 
symbol1259___process = 
string_to_symbol("_PROCESS-PID"); 
symbol1262___process = 
string_to_symbol("PROCESS-OUTPUT-PORT"); 
symbol1263___process = 
string_to_symbol("_PROCESS-OUTPUT-PORT"); 
symbol1264___process = 
string_to_symbol("PROCESS-INPUT-PORT"); 
symbol1265___process = 
string_to_symbol("_PROCESS-INPUT-PORT"); 
symbol1266___process = 
string_to_symbol("PROCESS-ERROR-PORT"); 
symbol1267___process = 
string_to_symbol("_PROCESS-ERROR-PORT"); 
symbol1268___process = 
string_to_symbol("PROCESS-ALIVE?"); 
symbol1269___process = 
string_to_symbol("_PROCESS-ALIVE?"); 
symbol1270___process = 
string_to_symbol("PROCESS-WAIT"); 
symbol1271___process = 
string_to_symbol("_PROCESS-WAIT"); 
symbol1272___process = 
string_to_symbol("PROCESS-EXIT-STATUS"); 
symbol1273___process = 
string_to_symbol("_PROCESS-EXIT-STATUS"); 
symbol1274___process = 
string_to_symbol("PROCESS-SEND-SIGNAL"); 
symbol1275___process = 
string_to_symbol("_PROCESS-SEND-SIGNAL"); 
symbol1277___process = 
string_to_symbol("PROCESS-KILL"); 
symbol1278___process = 
string_to_symbol("_PROCESS-KILL"); 
symbol1279___process = 
string_to_symbol("PROCESS-STOP"); 
symbol1280___process = 
string_to_symbol("_PROCESS-STOP"); 
symbol1281___process = 
string_to_symbol("PROCESS-CONTINUE"); 
symbol1282___process = 
string_to_symbol("_PROCESS-CONTINUE"); 
symbol1283___process = 
string_to_symbol("PROCESS-LIST"); 
symbol1284___process = 
string_to_symbol("RUN-PROCESS"); 
keyword1287___process = 
string_to_keyword("WAIT:"); 
keyword1291___process = 
string_to_keyword("FORK:"); 
keyword1292___process = 
string_to_keyword("INPUT:"); 
keyword1293___process = 
string_to_keyword("PIPE:"); 
keyword1294___process = 
string_to_keyword("OUTPUT:"); 
keyword1295___process = 
string_to_keyword("ERROR:"); 
keyword1296___process = 
string_to_keyword("HOST:"); 
symbol1297___process = 
string_to_symbol("_RUN-PROCESS"); 
symbol1299___process = 
string_to_symbol("UNREGISTER-PROCESS"); 
symbol1300___process = 
string_to_symbol("_UNREGISTER-PROCESS"); 
return ( 
symbol1301___process = 
string_to_symbol("IMPORTED-MODULES-INIT"), BUNSPEC) ;} 
}



/* process? */
bool_t process__75___process(obj_t obj_1)
{ AN_OBJECT;
{ /* Llib/process.scm 74 */
{ /* Llib/process.scm 75 */
obj_t symbol1176_657;
symbol1176_657 = symbol1257___process; 
{ /* Llib/process.scm 75 */

PUSH_TRACE(symbol1176_657); BUNSPEC; 
{ /* Llib/process.scm 75 */
bool_t aux1175_658;
aux1175_658 = 
PROCESSP(obj_1); 
POP_TRACE(); 
return aux1175_658;} } } } 
}



/* _process? */
obj_t _process__54___process(obj_t env_576, obj_t obj_577)
{ AN_OBJECT;
{ /* Llib/process.scm 74 */
{ /* Llib/process.scm 74 */
bool_t aux_777;
{ /* Llib/process.scm 74 */
bool_t res1302_662;
{ /* Llib/process.scm 74 */
obj_t obj_659;
obj_659 = obj_577; 
{ /* Llib/process.scm 75 */
obj_t symbol1176_660;
symbol1176_660 = symbol1257___process; 
{ /* Llib/process.scm 75 */

PUSH_TRACE(symbol1176_660); BUNSPEC; 
{ /* Llib/process.scm 75 */
bool_t aux1175_661;
aux1175_661 = 
PROCESSP(obj_659); 
POP_TRACE(); 
res1302_662 = aux1175_661; } } } } 
aux_777 = res1302_662; } 
return 
BBOOL(aux_777);} } 
}



/* process-pid */
int process_pid_210___process(obj_t proc_2)
{ AN_OBJECT;
{ /* Llib/process.scm 80 */
{ /* Llib/process.scm 81 */
obj_t symbol1178_663;
symbol1178_663 = symbol1258___process; 
{ /* Llib/process.scm 81 */

PUSH_TRACE(symbol1178_663); BUNSPEC; 
{ /* Llib/process.scm 81 */
int aux1177_664;
aux1177_664 = 
PROCESS_PID(proc_2); 
POP_TRACE(); 
return aux1177_664;} } } } 
}



/* _process-pid */
obj_t _process_pid_113___process(obj_t env_578, obj_t proc_579)
{ AN_OBJECT;
{ /* Llib/process.scm 80 */
{ /* Llib/process.scm 80 */
int aux_785;
{ /* Llib/process.scm 80 */
int res1303_668;
{ /* Llib/process.scm 80 */
obj_t proc_665;
{ /* Llib/process.scm 80 */
bool_t test1208_608;
test1208_608 = 
PROCESSP(proc_579); 
if(test1208_608)
{ /* Llib/process.scm 80 */
proc_665 = proc_579; }  else 
{ /* Llib/process.scm 80 */
bigloo_type_error_location_103___error(symbol1259___process, string1260___process, proc_579, string1261___process, 
BINT(((long)4170))); 
exit( -1 );} } 
{ /* Llib/process.scm 81 */
obj_t symbol1178_666;
symbol1178_666 = symbol1258___process; 
{ /* Llib/process.scm 81 */

PUSH_TRACE(symbol1178_666); BUNSPEC; 
{ /* Llib/process.scm 81 */
int aux1177_667;
aux1177_667 = 
PROCESS_PID(proc_665); 
POP_TRACE(); 
res1303_668 = aux1177_667; } } } } 
aux_785 = res1303_668; } 
return 
BINT(aux_785);} } 
}



/* process-output-port */
obj_t process_output_port_86___process(obj_t proc_3)
{ AN_OBJECT;
{ /* Llib/process.scm 86 */
{ /* Llib/process.scm 87 */
obj_t symbol1180_669;
symbol1180_669 = symbol1262___process; 
{ /* Llib/process.scm 87 */

PUSH_TRACE(symbol1180_669); BUNSPEC; 
{ /* Llib/process.scm 87 */
obj_t aux1179_670;
aux1179_670 = 
PROCESS_OUTPUT_PORT(proc_3); 
POP_TRACE(); 
return aux1179_670;} } } } 
}



/* _process-output-port */
obj_t _process_output_port_146___process(obj_t env_580, obj_t proc_581)
{ AN_OBJECT;
{ /* Llib/process.scm 86 */
{ /* Llib/process.scm 86 */
obj_t proc_671;
{ /* Llib/process.scm 86 */
bool_t test1210_610;
test1210_610 = 
PROCESSP(proc_581); 
if(test1210_610)
{ /* Llib/process.scm 86 */
proc_671 = proc_581; }  else 
{ /* Llib/process.scm 86 */
bigloo_type_error_location_103___error(symbol1263___process, string1260___process, proc_581, string1261___process, 
BINT(((long)4452))); 
exit( -1 );} } 
{ /* Llib/process.scm 87 */
obj_t symbol1180_672;
symbol1180_672 = symbol1262___process; 
{ /* Llib/process.scm 87 */

PUSH_TRACE(symbol1180_672); BUNSPEC; 
{ /* Llib/process.scm 87 */
obj_t aux1179_673;
aux1179_673 = 
PROCESS_OUTPUT_PORT(proc_671); 
POP_TRACE(); 
return aux1179_673;} } } } } 
}



/* process-input-port */
obj_t process_input_port_25___process(obj_t proc_4)
{ AN_OBJECT;
{ /* Llib/process.scm 92 */
{ /* Llib/process.scm 93 */
obj_t symbol1182_674;
symbol1182_674 = symbol1264___process; 
{ /* Llib/process.scm 93 */

PUSH_TRACE(symbol1182_674); BUNSPEC; 
{ /* Llib/process.scm 93 */
obj_t aux1181_675;
aux1181_675 = 
PROCESS_INPUT_PORT(proc_4); 
POP_TRACE(); 
return aux1181_675;} } } } 
}



/* _process-input-port */
obj_t _process_input_port_248___process(obj_t env_582, obj_t proc_583)
{ AN_OBJECT;
{ /* Llib/process.scm 92 */
{ /* Llib/process.scm 92 */
obj_t proc_676;
{ /* Llib/process.scm 92 */
bool_t test1212_612;
test1212_612 = 
PROCESSP(proc_583); 
if(test1212_612)
{ /* Llib/process.scm 92 */
proc_676 = proc_583; }  else 
{ /* Llib/process.scm 92 */
bigloo_type_error_location_103___error(symbol1265___process, string1260___process, proc_583, string1261___process, 
BINT(((long)4750))); 
exit( -1 );} } 
{ /* Llib/process.scm 93 */
obj_t symbol1182_677;
symbol1182_677 = symbol1264___process; 
{ /* Llib/process.scm 93 */

PUSH_TRACE(symbol1182_677); BUNSPEC; 
{ /* Llib/process.scm 93 */
obj_t aux1181_678;
aux1181_678 = 
PROCESS_INPUT_PORT(proc_676); 
POP_TRACE(); 
return aux1181_678;} } } } } 
}



/* process-error-port */
obj_t process_error_port_133___process(obj_t proc_5)
{ AN_OBJECT;
{ /* Llib/process.scm 98 */
{ /* Llib/process.scm 99 */
obj_t symbol1184_679;
symbol1184_679 = symbol1266___process; 
{ /* Llib/process.scm 99 */

PUSH_TRACE(symbol1184_679); BUNSPEC; 
{ /* Llib/process.scm 99 */
obj_t aux1183_680;
aux1183_680 = 
PROCESS_ERROR_PORT(proc_5); 
POP_TRACE(); 
return aux1183_680;} } } } 
}



/* _process-error-port */
obj_t _process_error_port_135___process(obj_t env_584, obj_t proc_585)
{ AN_OBJECT;
{ /* Llib/process.scm 98 */
{ /* Llib/process.scm 98 */
obj_t proc_681;
{ /* Llib/process.scm 98 */
bool_t test1214_614;
test1214_614 = 
PROCESSP(proc_585); 
if(test1214_614)
{ /* Llib/process.scm 98 */
proc_681 = proc_585; }  else 
{ /* Llib/process.scm 98 */
bigloo_type_error_location_103___error(symbol1267___process, string1260___process, proc_585, string1261___process, 
BINT(((long)5046))); 
exit( -1 );} } 
{ /* Llib/process.scm 99 */
obj_t symbol1184_682;
symbol1184_682 = symbol1266___process; 
{ /* Llib/process.scm 99 */

PUSH_TRACE(symbol1184_682); BUNSPEC; 
{ /* Llib/process.scm 99 */
obj_t aux1183_683;
aux1183_683 = 
PROCESS_ERROR_PORT(proc_681); 
POP_TRACE(); 
return aux1183_683;} } } } } 
}



/* process-alive? */
bool_t process_alive__25___process(obj_t proc_6)
{ AN_OBJECT;
{ /* Llib/process.scm 104 */
{ /* Llib/process.scm 105 */
obj_t symbol1186_684;
symbol1186_684 = symbol1268___process; 
{ /* Llib/process.scm 105 */

PUSH_TRACE(symbol1186_684); BUNSPEC; 
{ /* Llib/process.scm 105 */
bool_t aux1185_685;
{ /* Llib/process.scm 105 */
obj_t aux_829;
aux_829 = 
c_process_alivep(proc_6); 
aux1185_685 = 
CBOOL(aux_829); } 
POP_TRACE(); 
return aux1185_685;} } } } 
}



/* _process-alive? */
obj_t _process_alive__232___process(obj_t env_586, obj_t proc_587)
{ AN_OBJECT;
{ /* Llib/process.scm 104 */
{ /* Llib/process.scm 104 */
bool_t aux_833;
{ /* Llib/process.scm 104 */
bool_t res1304_689;
{ /* Llib/process.scm 104 */
obj_t proc_686;
{ /* Llib/process.scm 104 */
bool_t test1216_616;
test1216_616 = 
PROCESSP(proc_587); 
if(test1216_616)
{ /* Llib/process.scm 104 */
proc_686 = proc_587; }  else 
{ /* Llib/process.scm 104 */
bigloo_type_error_location_103___error(symbol1269___process, string1260___process, proc_587, string1261___process, 
BINT(((long)5342))); 
exit( -1 );} } 
{ /* Llib/process.scm 105 */
obj_t symbol1186_687;
symbol1186_687 = symbol1268___process; 
{ /* Llib/process.scm 105 */

PUSH_TRACE(symbol1186_687); BUNSPEC; 
{ /* Llib/process.scm 105 */
bool_t aux1185_688;
{ /* Llib/process.scm 105 */
obj_t aux_840;
aux_840 = 
c_process_alivep(proc_686); 
aux1185_688 = 
CBOOL(aux_840); } 
POP_TRACE(); 
res1304_689 = aux1185_688; } } } } 
aux_833 = res1304_689; } 
return 
BBOOL(aux_833);} } 
}



/* process-wait */
bool_t process_wait_122___process(obj_t proc_7)
{ AN_OBJECT;
{ /* Llib/process.scm 110 */
{ /* Llib/process.scm 111 */
obj_t symbol1188_690;
symbol1188_690 = symbol1270___process; 
{ /* Llib/process.scm 111 */

PUSH_TRACE(symbol1188_690); BUNSPEC; 
{ /* Llib/process.scm 111 */
bool_t aux1187_691;
{ /* Llib/process.scm 111 */
obj_t aux_846;
aux_846 = 
c_process_wait(proc_7); 
aux1187_691 = 
CBOOL(aux_846); } 
POP_TRACE(); 
return aux1187_691;} } } } 
}



/* _process-wait */
obj_t _process_wait_128___process(obj_t env_588, obj_t proc_589)
{ AN_OBJECT;
{ /* Llib/process.scm 110 */
{ /* Llib/process.scm 110 */
bool_t aux_850;
{ /* Llib/process.scm 110 */
bool_t res1305_695;
{ /* Llib/process.scm 110 */
obj_t proc_692;
{ /* Llib/process.scm 110 */
bool_t test1218_618;
test1218_618 = 
PROCESSP(proc_589); 
if(test1218_618)
{ /* Llib/process.scm 110 */
proc_692 = proc_589; }  else 
{ /* Llib/process.scm 110 */
bigloo_type_error_location_103___error(symbol1271___process, string1260___process, proc_589, string1261___process, 
BINT(((long)5630))); 
exit( -1 );} } 
{ /* Llib/process.scm 111 */
obj_t symbol1188_693;
symbol1188_693 = symbol1270___process; 
{ /* Llib/process.scm 111 */

PUSH_TRACE(symbol1188_693); BUNSPEC; 
{ /* Llib/process.scm 111 */
bool_t aux1187_694;
{ /* Llib/process.scm 111 */
obj_t aux_857;
aux_857 = 
c_process_wait(proc_692); 
aux1187_694 = 
CBOOL(aux_857); } 
POP_TRACE(); 
res1305_695 = aux1187_694; } } } } 
aux_850 = res1305_695; } 
return 
BBOOL(aux_850);} } 
}



/* process-exit-status */
obj_t process_exit_status_63___process(obj_t proc_8)
{ AN_OBJECT;
{ /* Llib/process.scm 116 */
{ /* Llib/process.scm 117 */
obj_t symbol1190_696;
symbol1190_696 = symbol1272___process; 
{ /* Llib/process.scm 117 */

PUSH_TRACE(symbol1190_696); BUNSPEC; 
{ /* Llib/process.scm 117 */
obj_t aux1189_697;
aux1189_697 = 
c_process_xstatus(proc_8); 
POP_TRACE(); 
return aux1189_697;} } } } 
}



/* _process-exit-status */
obj_t _process_exit_status_230___process(obj_t env_590, obj_t proc_591)
{ AN_OBJECT;
{ /* Llib/process.scm 116 */
{ /* Llib/process.scm 116 */
obj_t proc_698;
{ /* Llib/process.scm 116 */
bool_t test1220_620;
test1220_620 = 
PROCESSP(proc_591); 
if(test1220_620)
{ /* Llib/process.scm 116 */
proc_698 = proc_591; }  else 
{ /* Llib/process.scm 116 */
bigloo_type_error_location_103___error(symbol1273___process, string1260___process, proc_591, string1261___process, 
BINT(((long)5914))); 
exit( -1 );} } 
{ /* Llib/process.scm 117 */
obj_t symbol1190_699;
symbol1190_699 = symbol1272___process; 
{ /* Llib/process.scm 117 */

PUSH_TRACE(symbol1190_699); BUNSPEC; 
{ /* Llib/process.scm 117 */
obj_t aux1189_700;
aux1189_700 = 
c_process_xstatus(proc_698); 
POP_TRACE(); 
return aux1189_700;} } } } } 
}



/* process-send-signal */
obj_t process_send_signal_117___process(obj_t proc_9, int signal_10)
{ AN_OBJECT;
{ /* Llib/process.scm 122 */
{ /* Llib/process.scm 123 */
obj_t symbol1192_701;
symbol1192_701 = symbol1274___process; 
{ /* Llib/process.scm 123 */

PUSH_TRACE(symbol1192_701); BUNSPEC; 
{ /* Llib/process.scm 123 */
obj_t aux1191_702;
aux1191_702 = 
c_process_send_signal(proc_9, signal_10); 
POP_TRACE(); 
return aux1191_702;} } } } 
}



/* _process-send-signal */
obj_t _process_send_signal_25___process(obj_t env_592, obj_t proc_593, obj_t signal_594)
{ AN_OBJECT;
{ /* Llib/process.scm 122 */
{ /* Llib/process.scm 122 */
obj_t proc_703;int signal_704;
{ /* Llib/process.scm 122 */
bool_t test1222_622;
test1222_622 = 
PROCESSP(proc_593); 
if(test1222_622)
{ /* Llib/process.scm 122 */
proc_703 = proc_593; }  else 
{ /* Llib/process.scm 122 */
bigloo_type_error_location_103___error(symbol1275___process, string1260___process, proc_593, string1261___process, 
BINT(((long)6212))); 
exit( -1 );} } 
{ /* Llib/process.scm 122 */
obj_t aux_881;
if(
INTEGERP(signal_594))
{ /* Llib/process.scm 122 */
aux_881 = signal_594
; }  else 
{ /* Llib/process.scm 122 */
bigloo_type_error_location_103___error(symbol1275___process, string1276___process, signal_594, string1261___process, 
BINT(((long)6212))); 
exit( -1 );} 
signal_704 = 
CINT(aux_881); } 
{ /* Llib/process.scm 123 */
obj_t symbol1192_705;
symbol1192_705 = symbol1274___process; 
{ /* Llib/process.scm 123 */

PUSH_TRACE(symbol1192_705); BUNSPEC; 
{ /* Llib/process.scm 123 */
obj_t aux1191_706;
aux1191_706 = 
c_process_send_signal(proc_703, signal_704); 
POP_TRACE(); 
return aux1191_706;} } } } } 
}



/* process-kill */
obj_t process_kill_93___process(obj_t proc_11)
{ AN_OBJECT;
{ /* Llib/process.scm 128 */
{ /* Llib/process.scm 129 */
obj_t symbol1194_707;
symbol1194_707 = symbol1277___process; 
{ /* Llib/process.scm 129 */

PUSH_TRACE(symbol1194_707); BUNSPEC; 
{ /* Llib/process.scm 129 */
obj_t aux1193_708;
aux1193_708 = 
c_process_kill(proc_11); 
POP_TRACE(); 
return aux1193_708;} } } } 
}



/* _process-kill */
obj_t _process_kill_194___process(obj_t env_595, obj_t proc_596)
{ AN_OBJECT;
{ /* Llib/process.scm 128 */
{ /* Llib/process.scm 128 */
obj_t proc_709;
{ /* Llib/process.scm 128 */
bool_t test1226_626;
test1226_626 = 
PROCESSP(proc_596); 
if(test1226_626)
{ /* Llib/process.scm 128 */
proc_709 = proc_596; }  else 
{ /* Llib/process.scm 128 */
bigloo_type_error_location_103___error(symbol1278___process, string1260___process, proc_596, string1261___process, 
BINT(((long)6524))); 
exit( -1 );} } 
{ /* Llib/process.scm 129 */
obj_t symbol1194_710;
symbol1194_710 = symbol1277___process; 
{ /* Llib/process.scm 129 */

PUSH_TRACE(symbol1194_710); BUNSPEC; 
{ /* Llib/process.scm 129 */
obj_t aux1193_711;
aux1193_711 = 
c_process_kill(proc_709); 
POP_TRACE(); 
return aux1193_711;} } } } } 
}



/* process-stop */
obj_t process_stop_113___process(obj_t proc_12)
{ AN_OBJECT;
{ /* Llib/process.scm 134 */
{ /* Llib/process.scm 135 */
obj_t symbol1196_712;
symbol1196_712 = symbol1279___process; 
{ /* Llib/process.scm 135 */

PUSH_TRACE(symbol1196_712); BUNSPEC; 
{ /* Llib/process.scm 135 */
obj_t aux1195_713;
aux1195_713 = 
c_process_stop(proc_12); 
POP_TRACE(); 
return aux1195_713;} } } } 
}



/* _process-stop */
obj_t _process_stop_38___process(obj_t env_597, obj_t proc_598)
{ AN_OBJECT;
{ /* Llib/process.scm 134 */
{ /* Llib/process.scm 134 */
obj_t proc_714;
{ /* Llib/process.scm 134 */
bool_t test1228_628;
test1228_628 = 
PROCESSP(proc_598); 
if(test1228_628)
{ /* Llib/process.scm 134 */
proc_714 = proc_598; }  else 
{ /* Llib/process.scm 134 */
bigloo_type_error_location_103___error(symbol1280___process, string1260___process, proc_598, string1261___process, 
BINT(((long)6808))); 
exit( -1 );} } 
{ /* Llib/process.scm 135 */
obj_t symbol1196_715;
symbol1196_715 = symbol1279___process; 
{ /* Llib/process.scm 135 */

PUSH_TRACE(symbol1196_715); BUNSPEC; 
{ /* Llib/process.scm 135 */
obj_t aux1195_716;
aux1195_716 = 
c_process_stop(proc_714); 
POP_TRACE(); 
return aux1195_716;} } } } } 
}



/* process-continue */
obj_t process_continue_186___process(obj_t proc_13)
{ AN_OBJECT;
{ /* Llib/process.scm 140 */
{ /* Llib/process.scm 141 */
obj_t symbol1198_717;
symbol1198_717 = symbol1281___process; 
{ /* Llib/process.scm 141 */

PUSH_TRACE(symbol1198_717); BUNSPEC; 
{ /* Llib/process.scm 141 */
obj_t aux1197_718;
aux1197_718 = 
c_process_continue(proc_13); 
POP_TRACE(); 
return aux1197_718;} } } } 
}



/* _process-continue */
obj_t _process_continue_223___process(obj_t env_599, obj_t proc_600)
{ AN_OBJECT;
{ /* Llib/process.scm 140 */
{ /* Llib/process.scm 140 */
obj_t proc_719;
{ /* Llib/process.scm 140 */
bool_t test1230_630;
test1230_630 = 
PROCESSP(proc_600); 
if(test1230_630)
{ /* Llib/process.scm 140 */
proc_719 = proc_600; }  else 
{ /* Llib/process.scm 140 */
bigloo_type_error_location_103___error(symbol1282___process, string1260___process, proc_600, string1261___process, 
BINT(((long)7092))); 
exit( -1 );} } 
{ /* Llib/process.scm 141 */
obj_t symbol1198_720;
symbol1198_720 = symbol1281___process; 
{ /* Llib/process.scm 141 */

PUSH_TRACE(symbol1198_720); BUNSPEC; 
{ /* Llib/process.scm 141 */
obj_t aux1197_721;
aux1197_721 = 
c_process_continue(proc_719); 
POP_TRACE(); 
return aux1197_721;} } } } } 
}



/* process-list */
obj_t process_list_172___process()
{ AN_OBJECT;
{ /* Llib/process.scm 146 */
{ /* Llib/process.scm 147 */
obj_t symbol1200_722;
symbol1200_722 = symbol1283___process; 
{ /* Llib/process.scm 147 */

PUSH_TRACE(symbol1200_722); BUNSPEC; 
{ /* Llib/process.scm 147 */
obj_t aux1199_723;
aux1199_723 = 
c_process_list(); 
POP_TRACE(); 
return aux1199_723;} } } } 
}



/* _process-list */
obj_t _process_list_8___process(obj_t env_601)
{ AN_OBJECT;
{ /* Llib/process.scm 146 */
{ /* Llib/process.scm 147 */
obj_t symbol1200_724;
symbol1200_724 = symbol1283___process; 
{ /* Llib/process.scm 147 */

PUSH_TRACE(symbol1200_724); BUNSPEC; 
{ /* Llib/process.scm 147 */
obj_t aux1199_725;
aux1199_725 = 
c_process_list(); 
POP_TRACE(); 
return aux1199_725;} } } } 
}



/* run-process */
obj_t run_process_29___process(obj_t command_14, obj_t rest_15)
{ AN_OBJECT;
{ /* Llib/process.scm 155 */
{ /* Llib/process.scm 156 */
obj_t symbol1202_570;
symbol1202_570 = symbol1284___process; 
{ /* Llib/process.scm 156 */

PUSH_TRACE(symbol1202_570); BUNSPEC; 
{ /* Llib/process.scm 156 */
obj_t aux1201_571;
{ /* Llib/process.scm 156 */
obj_t fork_282;obj_t wait_283;obj_t input_284;obj_t output_285;obj_t error_286;obj_t host_287;obj_t args_288;
fork_282 = BTRUE; 
wait_283 = BFALSE; 
input_284 = BUNSPEC; 
output_285 = BUNSPEC; 
error_286 = BUNSPEC; 
host_287 = BUNSPEC; 
args_288 = BNIL; 
{ 
obj_t rest_290;
{ /* Llib/process.scm 165 */
obj_t aux1251_651;
rest_290 = rest_15; 
loop_291:
if(
NULLP(rest_290))
{ /* Llib/process.scm 167 */
{ /* Llib/process.scm 170 */
obj_t arg1007_293;
arg1007_293 = 
reverse__39___r4_pairs_and_lists_6_3(args_288); 
aux1251_651 = 
c_run_process(host_287, fork_282, wait_283, input_284, output_285, error_286, command_14, arg1007_293); } }  else 
{ /* Llib/process.scm 171 */
bool_t test1008_294;
{ /* Llib/process.scm 171 */
bool_t test1030_318;
{ /* Llib/process.scm 171 */
obj_t arg1032_320;
{ /* Llib/process.scm 171 */
obj_t pair_462;
if(
PAIRP(rest_290))
{ /* Llib/process.scm 171 */
pair_462 = rest_290; }  else 
{ /* Llib/process.scm 171 */
bigloo_type_error_location_103___error(symbol1284___process, string1285___process, rest_290, string1261___process, 
BINT(((long)8323))); 
exit( -1 );} 
arg1032_320 = 
CAR(pair_462); } 
test1030_318 = 
KEYWORDP(arg1032_320); } 
if(test1030_318)
{ /* Llib/process.scm 171 */
obj_t arg1031_319;
{ /* Llib/process.scm 171 */
obj_t pair_464;
if(
PAIRP(rest_290))
{ /* Llib/process.scm 171 */
pair_464 = rest_290; }  else 
{ /* Llib/process.scm 171 */
bigloo_type_error_location_103___error(symbol1284___process, string1285___process, rest_290, string1261___process, 
BINT(((long)8342))); 
exit( -1 );} 
arg1031_319 = 
CDR(pair_464); } 
test1008_294 = 
PAIRP(arg1031_319); }  else 
{ /* Llib/process.scm 171 */
test1008_294 = ((bool_t)0); } } 
if(test1008_294)
{ /* Llib/process.scm 171 */
{ /* Llib/process.scm 172 */
obj_t val_295;
{ /* Llib/process.scm 172 */
obj_t pair_466;
if(
PAIRP(rest_290))
{ /* Llib/process.scm 172 */
pair_466 = rest_290; }  else 
{ /* Llib/process.scm 172 */
bigloo_type_error_location_103___error(symbol1284___process, string1285___process, rest_290, string1261___process, 
BINT(((long)8372))); 
exit( -1 );} 
{ /* ./Ieee/pair-list.scm 3034 */
obj_t arg1137_467;
arg1137_467 = 
CDR(pair_466); 
{ /* ./Ieee/pair-list.scm 3034 */
obj_t pair_469;
if(
PAIRP(arg1137_467))
{ /* ./Ieee/pair-list.scm 3034 */
pair_469 = arg1137_467; }  else 
{ /* ./Ieee/pair-list.scm 3034 */
bigloo_type_error_location_103___error(symbol1284___process, string1285___process, arg1137_467, string1286___process, 
BINT(((long)9004))); 
exit( -1 );} 
val_295 = 
CAR(pair_469); } } } 
{ /* Llib/process.scm 173 */
obj_t case_value_58_296;
{ /* Llib/process.scm 173 */
obj_t pair_470;
if(
PAIRP(rest_290))
{ /* Llib/process.scm 173 */
pair_470 = rest_290; }  else 
{ /* Llib/process.scm 173 */
bigloo_type_error_location_103___error(symbol1284___process, string1285___process, rest_290, string1261___process, 
BINT(((long)8394))); 
exit( -1 );} 
case_value_58_296 = 
CAR(pair_470); } 
if(
(case_value_58_296==keyword1287___process))
{ /* Llib/process.scm 173 */
if(
BOOLEANP(val_295))
{ /* Llib/process.scm 175 */
wait_283 = val_295; }  else 
{ /* Llib/process.scm 175 */
error_c_location_83___error(string1288___process, string1289___process, rest_290, "Llib/process.scm", ((long)8100)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1290___process, 
BINT(((long)7583))); } }  else 
{ /* Llib/process.scm 173 */
if(
(case_value_58_296==keyword1291___process))
{ /* Llib/process.scm 173 */
if(
BOOLEANP(val_295))
{ /* Llib/process.scm 179 */
fork_282 = val_295; }  else 
{ /* Llib/process.scm 179 */
error_c_location_83___error(string1288___process, string1289___process, rest_290, "Llib/process.scm", ((long)8100)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1290___process, 
BINT(((long)7583))); } }  else 
{ /* Llib/process.scm 173 */
if(
(case_value_58_296==keyword1292___process))
{ /* Llib/process.scm 183 */
bool_t test_985;
if(
STRINGP(val_295))
{ /* Llib/process.scm 183 */
test_985 = ((bool_t)1)
; }  else 
{ /* Llib/process.scm 183 */
test_985 = 
(val_295==keyword1293___process)
; } 
if(test_985)
{ /* Llib/process.scm 183 */
input_284 = val_295; }  else 
{ /* Llib/process.scm 183 */
error_c_location_83___error(string1288___process, string1289___process, rest_290, "Llib/process.scm", ((long)8100)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1290___process, 
BINT(((long)7583))); } }  else 
{ /* Llib/process.scm 173 */
if(
(case_value_58_296==keyword1294___process))
{ /* Llib/process.scm 187 */
bool_t test_994;
if(
STRINGP(val_295))
{ /* Llib/process.scm 187 */
test_994 = ((bool_t)1)
; }  else 
{ /* Llib/process.scm 187 */
test_994 = 
(val_295==keyword1293___process)
; } 
if(test_994)
{ /* Llib/process.scm 187 */
output_285 = val_295; }  else 
{ /* Llib/process.scm 187 */
error_c_location_83___error(string1288___process, string1289___process, rest_290, "Llib/process.scm", ((long)8100)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1290___process, 
BINT(((long)7583))); } }  else 
{ /* Llib/process.scm 173 */
if(
(case_value_58_296==keyword1295___process))
{ /* Llib/process.scm 191 */
bool_t test_1003;
if(
STRINGP(val_295))
{ /* Llib/process.scm 191 */
test_1003 = ((bool_t)1)
; }  else 
{ /* Llib/process.scm 191 */
test_1003 = 
(val_295==keyword1293___process)
; } 
if(test_1003)
{ /* Llib/process.scm 191 */
error_286 = val_295; }  else 
{ /* Llib/process.scm 191 */
error_c_location_83___error(string1288___process, string1289___process, rest_290, "Llib/process.scm", ((long)8100)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1290___process, 
BINT(((long)7583))); } }  else 
{ /* Llib/process.scm 173 */
if(
(case_value_58_296==keyword1296___process))
{ /* Llib/process.scm 173 */
if(
STRINGP(val_295))
{ /* Llib/process.scm 195 */
host_287 = val_295; }  else 
{ /* Llib/process.scm 195 */
error_c_location_83___error(string1288___process, string1289___process, rest_290, "Llib/process.scm", ((long)8100)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1290___process, 
BINT(((long)7583))); } }  else 
{ /* Llib/process.scm 173 */
error_c_location_83___error(string1288___process, string1289___process, rest_290, "Llib/process.scm", ((long)8100)); 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1290___process, 
BINT(((long)7583))); } } } } } } } 
{ /* Llib/process.scm 200 */
obj_t arg1024_312;
{ /* Llib/process.scm 200 */
obj_t arg1025_313;
{ /* Llib/process.scm 200 */
obj_t pair_523;
if(
PAIRP(rest_290))
{ /* Llib/process.scm 200 */
pair_523 = rest_290; }  else 
{ /* Llib/process.scm 200 */
bigloo_type_error_location_103___error(symbol1284___process, string1285___process, rest_290, string1261___process, 
BINT(((long)9004))); 
exit( -1 );} 
arg1025_313 = 
CDR(pair_523); } 
{ /* Llib/process.scm 200 */
obj_t pair_524;
if(
PAIRP(arg1025_313))
{ /* Llib/process.scm 200 */
pair_524 = arg1025_313; }  else 
{ /* Llib/process.scm 200 */
bigloo_type_error_location_103___error(symbol1284___process, string1285___process, arg1025_313, string1261___process, 
BINT(((long)8998))); 
exit( -1 );} 
arg1024_312 = 
CDR(pair_524); } } 
{ 
obj_t rest_1032;
rest_1032 = arg1024_312; 
rest_290 = rest_1032; 
goto loop_291;} } } }  else 
{ /* Llib/process.scm 201 */
bool_t test1026_314;
{ /* Llib/process.scm 201 */
obj_t arg1029_317;
{ /* Llib/process.scm 201 */
obj_t pair_525;
if(
PAIRP(rest_290))
{ /* Llib/process.scm 201 */
pair_525 = rest_290; }  else 
{ /* Llib/process.scm 201 */
bigloo_type_error_location_103___error(symbol1284___process, string1285___process, rest_290, string1261___process, 
BINT(((long)9034))); 
exit( -1 );} 
arg1029_317 = 
CAR(pair_525); } 
test1026_314 = 
STRINGP(arg1029_317); } 
if(test1026_314)
{ /* Llib/process.scm 201 */
{ /* Llib/process.scm 202 */
obj_t arg1027_315;
{ /* Llib/process.scm 202 */
obj_t pair_527;
if(
PAIRP(rest_290))
{ /* Llib/process.scm 202 */
pair_527 = rest_290; }  else 
{ /* Llib/process.scm 202 */
bigloo_type_error_location_103___error(symbol1284___process, string1285___process, rest_290, string1261___process, 
BINT(((long)9069))); 
exit( -1 );} 
arg1027_315 = 
CAR(pair_527); } 
{ /* Llib/process.scm 202 */
obj_t obj2_529;
obj2_529 = args_288; 
args_288 = 
MAKE_PAIR(arg1027_315, obj2_529); } } 
{ /* Llib/process.scm 203 */
obj_t arg1028_316;
{ /* Llib/process.scm 203 */
obj_t pair_530;
if(
PAIRP(rest_290))
{ /* Llib/process.scm 203 */
pair_530 = rest_290; }  else 
{ /* Llib/process.scm 203 */
bigloo_type_error_location_103___error(symbol1284___process, string1285___process, rest_290, string1261___process, 
BINT(((long)9099))); 
exit( -1 );} 
arg1028_316 = 
CDR(pair_530); } 
{ 
obj_t rest_1054;
rest_1054 = arg1028_316; 
rest_290 = rest_1054; 
goto loop_291;} } }  else 
{ /* Llib/process.scm 201 */
error_c_location_83___error(string1288___process, string1289___process, rest_290, "Llib/process.scm", ((long)8100)); 
aux1251_651 = 
debug_error_location_199___error(BFALSE, BFALSE, BFALSE, string1290___process, 
BINT(((long)7583))); } } } 
{ /* Llib/process.scm 165 */
bool_t test1252_652;
test1252_652 = 
PROCESSP(aux1251_651); 
if(test1252_652)
{ /* Llib/process.scm 165 */
aux1201_571 = aux1251_651; }  else 
{ /* Llib/process.scm 165 */
bigloo_type_error_location_103___error(symbol1284___process, string1260___process, aux1251_651, string1261___process, 
BINT(((long)8155))); 
exit( -1 );} } } } } 
POP_TRACE(); 
return aux1201_571;} } } } 
}



/* _run-process */
obj_t _run_process_4___process(obj_t env_602, obj_t command_603, obj_t rest_604)
{ AN_OBJECT;
{ /* Llib/process.scm 155 */
{ /* Llib/process.scm 155 */
obj_t aux_1064;
if(
STRINGP(command_603))
{ /* Llib/process.scm 155 */
aux_1064 = command_603
; }  else 
{ /* Llib/process.scm 155 */
bigloo_type_error_location_103___error(symbol1297___process, string1298___process, command_603, string1261___process, 
BINT(((long)7880))); 
exit( -1 );} 
return 
run_process_29___process(aux_1064, rest_604);} } 
}



/* unregister-process */
obj_t unregister_process_179___process(obj_t proc_16)
{ AN_OBJECT;
{ /* Llib/process.scm 210 */
{ /* Llib/process.scm 211 */
obj_t symbol1204_726;
symbol1204_726 = symbol1299___process; 
{ /* Llib/process.scm 211 */

PUSH_TRACE(symbol1204_726); BUNSPEC; 
{ /* Llib/process.scm 211 */
obj_t aux1203_727;
aux1203_727 = 
c_unregister_process(proc_16); 
POP_TRACE(); 
return aux1203_727;} } } } 
}



/* _unregister-process */
obj_t _unregister_process_206___process(obj_t env_605, obj_t proc_606)
{ AN_OBJECT;
{ /* Llib/process.scm 210 */
{ /* Llib/process.scm 210 */
obj_t proc_728;
{ /* Llib/process.scm 210 */
bool_t test1256_656;
test1256_656 = 
PROCESSP(proc_606); 
if(test1256_656)
{ /* Llib/process.scm 210 */
proc_728 = proc_606; }  else 
{ /* Llib/process.scm 210 */
bigloo_type_error_location_103___error(symbol1300___process, string1260___process, proc_606, string1261___process, 
BINT(((long)9373))); 
exit( -1 );} } 
{ /* Llib/process.scm 211 */
obj_t symbol1204_729;
symbol1204_729 = symbol1299___process; 
{ /* Llib/process.scm 211 */

PUSH_TRACE(symbol1204_729); BUNSPEC; 
{ /* Llib/process.scm 211 */
obj_t aux1203_730;
aux1203_730 = 
c_unregister_process(proc_728); 
POP_TRACE(); 
return aux1203_730;} } } } } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___process()
{ AN_OBJECT;
{ /* Llib/process.scm 15 */
{ /* Llib/process.scm 15 */
obj_t symbol1206_574;
symbol1206_574 = symbol1301___process; 
{ /* Llib/process.scm 15 */

PUSH_TRACE(symbol1206_574); BUNSPEC; 
{ /* Llib/process.scm 15 */
obj_t aux1205_575;
aux1205_575 = 
module_initialization_70___error(((long)0), "__PROCESS"); 
POP_TRACE(); 
return aux1205_575;} } } } 
}

