/*===========================================================================*/
/*   (Llib/socket.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t socket_host_address_114___socket(obj_t);
extern obj_t string_to_symbol(char *);
extern obj_t socket_port_number_142___socket(obj_t);
static obj_t _socket_port_number_87___socket(obj_t, obj_t);
static obj_t symbol1239___socket = BUNSPEC;
static obj_t symbol1238___socket = BUNSPEC;
static obj_t symbol1237___socket = BUNSPEC;
static obj_t symbol1236___socket = BUNSPEC;
static obj_t symbol1235___socket = BUNSPEC;
static obj_t symbol1234___socket = BUNSPEC;
static obj_t symbol1233___socket = BUNSPEC;
static obj_t symbol1232___socket = BUNSPEC;
static obj_t symbol1231___socket = BUNSPEC;
static obj_t symbol1229___socket = BUNSPEC;
static obj_t symbol1226___socket = BUNSPEC;
static obj_t symbol1225___socket = BUNSPEC;
static obj_t symbol1224___socket = BUNSPEC;
static obj_t symbol1223___socket = BUNSPEC;
static obj_t symbol1222___socket = BUNSPEC;
static obj_t symbol1221___socket = BUNSPEC;
static obj_t symbol1219___socket = BUNSPEC;
static obj_t symbol1220___socket = BUNSPEC;
static obj_t symbol1218___socket = BUNSPEC;
static obj_t symbol1217___socket = BUNSPEC;
static obj_t symbol1216___socket = BUNSPEC;
static obj_t symbol1215___socket = BUNSPEC;
static obj_t symbol1212___socket = BUNSPEC;
static obj_t symbol1211___socket = BUNSPEC;
static obj_t symbol1210___socket = BUNSPEC;
static obj_t _socket_shutdown_189___socket(obj_t, obj_t, obj_t);
extern obj_t socket_output_115___socket(obj_t);
static obj_t _socket_hostname_50___socket(obj_t, obj_t);
extern obj_t socket_shutdown(obj_t, bool_t);
static obj_t _socket_output_22___socket(obj_t, obj_t);
extern obj_t make_server_socket(int);
extern obj_t socket_dup_120___socket(obj_t);
static obj_t _socket_local_address_218___socket(obj_t, obj_t);
extern obj_t bigloo_type_error_location_103___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t socket_down__159___socket(obj_t);
extern obj_t socket_local_addr(obj_t);
extern obj_t make_server_socket_214___socket(obj_t);
extern obj_t socket_dup(obj_t);
static obj_t _make_server_socket_127___socket(obj_t, obj_t);
static obj_t _socket_host_address_221___socket(obj_t, obj_t);
static obj_t _socket_accept_connection_223___socket(obj_t, obj_t);
static obj_t _socket_input_55___socket(obj_t, obj_t);
extern obj_t module_initialization_70___socket(long, char *);
extern obj_t module_initialization_70___error(long, char *);
static obj_t _socket__179___socket(obj_t, obj_t);
extern obj_t make_client_socket(obj_t, int);
extern obj_t socket_accept_connection(obj_t);
extern obj_t socket_shutdown_97___socket(obj_t, obj_t);
extern obj_t make_client_socket_228___socket(obj_t, int);
extern obj_t socket_hostname_170___socket(obj_t);
static obj_t imported_modules_init_94___socket();
extern bool_t socket__65___socket(obj_t);
extern obj_t socket_accept_connection_52___socket(obj_t);
extern obj_t socket_local_address_209___socket(obj_t);
static obj_t _make_client_socket_221___socket(obj_t, obj_t, obj_t);
static obj_t require_initialization_114___socket = BUNSPEC;
static obj_t cnst_init_137___socket();
static obj_t _socket_dup_164___socket(obj_t, obj_t);
static obj_t _socket_down__147___socket(obj_t, obj_t);
extern obj_t socket_input_208___socket(obj_t);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( socket_input_env_54___socket, _socket_input_55___socket1243, _socket_input_55___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( make_client_socket_env_140___socket, _make_client_socket_221___socket1244, _make_client_socket_221___socket, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( socket__env_32___socket, _socket__179___socket1245, _socket__179___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_shutdown_env_247___socket, _socket_shutdown_189___socket1246, va_generic_entry, _socket_shutdown_189___socket, -2 );
DEFINE_EXPORT_PROCEDURE( socket_hostname_env_89___socket, _socket_hostname_50___socket1247, _socket_hostname_50___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_host_address_env_16___socket, _socket_host_address_221___socket1248, _socket_host_address_221___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_local_address_env_78___socket, _socket_local_address_218___socket1249, _socket_local_address_218___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_dup_env_192___socket, _socket_dup_164___socket1250, _socket_dup_164___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_output_env_172___socket, _socket_output_22___socket1251, _socket_output_22___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_accept_connection_env_59___socket, _socket_accept_connection_223___socket1252, _socket_accept_connection_223___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_down__env_139___socket, _socket_down__147___socket1253, _socket_down__147___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( make_server_socket_env_103___socket, _make_server_socket_127___socket1254, va_generic_entry, _make_server_socket_127___socket, -1 );
DEFINE_EXPORT_PROCEDURE( socket_port_number_env_160___socket, _socket_port_number_87___socket1255, _socket_port_number_87___socket, 0L, 1 );
DEFINE_STRING( string1230___socket, string1230___socket1256, "PAIR", 4 );
DEFINE_STRING( string1228___socket, string1228___socket1257, "INT", 3 );
DEFINE_STRING( string1227___socket, string1227___socket1258, "BSTRING", 7 );
DEFINE_STRING( string1214___socket, string1214___socket1259, "/home/tahoe2/serrano/tmp/bigloo/runtime/Llib/socket.scm", 55 );
DEFINE_STRING( string1213___socket, string1213___socket1260, "SOCKET", 6 );



/* module-initialization */
obj_t module_initialization_70___socket(long checksum_598, char * from_599)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___socket))
{ 
require_initialization_114___socket = 
BBOOL(((bool_t)0)); 
cnst_init_137___socket(); 
imported_modules_init_94___socket(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___socket()
{ AN_OBJECT;
{ /* Llib/socket.scm 15 */
symbol1210___socket = 
string_to_symbol("SOCKET?"); 
symbol1211___socket = 
string_to_symbol("SOCKET-HOSTNAME"); 
symbol1212___socket = 
string_to_symbol("_SOCKET-HOSTNAME"); 
symbol1215___socket = 
string_to_symbol("SOCKET-HOST-ADDRESS"); 
symbol1216___socket = 
string_to_symbol("_SOCKET-HOST-ADDRESS"); 
symbol1217___socket = 
string_to_symbol("SOCKET-DOWN?"); 
symbol1218___socket = 
string_to_symbol("_SOCKET-DOWN?"); 
symbol1219___socket = 
string_to_symbol("SOCKET-PORT-NUMBER"); 
symbol1220___socket = 
string_to_symbol("_SOCKET-PORT-NUMBER"); 
symbol1221___socket = 
string_to_symbol("SOCKET-INPUT"); 
symbol1222___socket = 
string_to_symbol("_SOCKET-INPUT"); 
symbol1223___socket = 
string_to_symbol("SOCKET-OUTPUT"); 
symbol1224___socket = 
string_to_symbol("_SOCKET-OUTPUT"); 
symbol1225___socket = 
string_to_symbol("MAKE-CLIENT-SOCKET"); 
symbol1226___socket = 
string_to_symbol("_MAKE-CLIENT-SOCKET"); 
symbol1229___socket = 
string_to_symbol("MAKE-SERVER-SOCKET"); 
symbol1231___socket = 
string_to_symbol("SOCKET-ACCEPT-CONNECTION"); 
symbol1232___socket = 
string_to_symbol("_SOCKET-ACCEPT-CONNECTION"); 
symbol1233___socket = 
string_to_symbol("SOCKET-LOCAL-ADDRESS"); 
symbol1234___socket = 
string_to_symbol("_SOCKET-LOCAL-ADDRESS"); 
symbol1235___socket = 
string_to_symbol("SOCKET-DUP"); 
symbol1236___socket = 
string_to_symbol("_SOCKET-DUP"); 
symbol1237___socket = 
string_to_symbol("SOCKET-SHUTDOWN"); 
symbol1238___socket = 
string_to_symbol("_SOCKET-SHUTDOWN"); 
return ( 
symbol1239___socket = 
string_to_symbol("IMPORTED-MODULES-INIT"), BUNSPEC) ;} 
}



/* socket? */
bool_t socket__65___socket(obj_t obj_1)
{ AN_OBJECT;
{ /* Llib/socket.scm 76 */
{ /* Llib/socket.scm 77 */
obj_t symbol1153_519;
symbol1153_519 = symbol1210___socket; 
{ /* Llib/socket.scm 77 */

PUSH_TRACE(symbol1153_519); BUNSPEC; 
{ /* Llib/socket.scm 77 */
bool_t aux1152_520;
aux1152_520 = 
SOCKETP(obj_1); 
POP_TRACE(); 
return aux1152_520;} } } } 
}



/* _socket? */
obj_t _socket__179___socket(obj_t env_461, obj_t obj_462)
{ AN_OBJECT;
{ /* Llib/socket.scm 76 */
{ /* Llib/socket.scm 76 */
bool_t aux_633;
{ /* Llib/socket.scm 76 */
bool_t res1240_524;
{ /* Llib/socket.scm 76 */
obj_t obj_521;
obj_521 = obj_462; 
{ /* Llib/socket.scm 77 */
obj_t symbol1153_522;
symbol1153_522 = symbol1210___socket; 
{ /* Llib/socket.scm 77 */

PUSH_TRACE(symbol1153_522); BUNSPEC; 
{ /* Llib/socket.scm 77 */
bool_t aux1152_523;
aux1152_523 = 
SOCKETP(obj_521); 
POP_TRACE(); 
res1240_524 = aux1152_523; } } } } 
aux_633 = res1240_524; } 
return 
BBOOL(aux_633);} } 
}



/* socket-hostname */
obj_t socket_hostname_170___socket(obj_t socket_2)
{ AN_OBJECT;
{ /* Llib/socket.scm 82 */
{ /* Llib/socket.scm 83 */
obj_t symbol1155_525;
symbol1155_525 = symbol1211___socket; 
{ /* Llib/socket.scm 83 */

PUSH_TRACE(symbol1155_525); BUNSPEC; 
{ /* Llib/socket.scm 83 */
obj_t aux1154_526;
aux1154_526 = 
SOCKET_HOSTNAME(socket_2); 
POP_TRACE(); 
return aux1154_526;} } } } 
}



/* _socket-hostname */
obj_t _socket_hostname_50___socket(obj_t env_463, obj_t socket_464)
{ AN_OBJECT;
{ /* Llib/socket.scm 82 */
{ /* Llib/socket.scm 82 */
obj_t socket_527;
{ /* Llib/socket.scm 82 */
bool_t test1181_490;
test1181_490 = 
SOCKETP(socket_464); 
if(test1181_490)
{ /* Llib/socket.scm 82 */
socket_527 = socket_464; }  else 
{ /* Llib/socket.scm 82 */
bigloo_type_error_location_103___error(symbol1212___socket, string1213___socket, socket_464, string1214___socket, 
BINT(((long)3948))); 
exit( -1 );} } 
{ /* Llib/socket.scm 83 */
obj_t symbol1155_528;
symbol1155_528 = symbol1211___socket; 
{ /* Llib/socket.scm 83 */

PUSH_TRACE(symbol1155_528); BUNSPEC; 
{ /* Llib/socket.scm 83 */
obj_t aux1154_529;
aux1154_529 = 
SOCKET_HOSTNAME(socket_527); 
POP_TRACE(); 
return aux1154_529;} } } } } 
}



/* socket-host-address */
obj_t socket_host_address_114___socket(obj_t socket_3)
{ AN_OBJECT;
{ /* Llib/socket.scm 88 */
{ /* Llib/socket.scm 89 */
obj_t symbol1157_530;
symbol1157_530 = symbol1215___socket; 
{ /* Llib/socket.scm 89 */

PUSH_TRACE(symbol1157_530); BUNSPEC; 
{ /* Llib/socket.scm 89 */
obj_t aux1156_531;
aux1156_531 = 
SOCKET_HOSTIP(socket_3); 
POP_TRACE(); 
return aux1156_531;} } } } 
}



/* _socket-host-address */
obj_t _socket_host_address_221___socket(obj_t env_465, obj_t socket_466)
{ AN_OBJECT;
{ /* Llib/socket.scm 88 */
{ /* Llib/socket.scm 88 */
obj_t socket_532;
{ /* Llib/socket.scm 88 */
bool_t test1183_492;
test1183_492 = 
SOCKETP(socket_466); 
if(test1183_492)
{ /* Llib/socket.scm 88 */
socket_532 = socket_466; }  else 
{ /* Llib/socket.scm 88 */
bigloo_type_error_location_103___error(symbol1216___socket, string1213___socket, socket_466, string1214___socket, 
BINT(((long)4259))); 
exit( -1 );} } 
{ /* Llib/socket.scm 89 */
obj_t symbol1157_533;
symbol1157_533 = symbol1215___socket; 
{ /* Llib/socket.scm 89 */

PUSH_TRACE(symbol1157_533); BUNSPEC; 
{ /* Llib/socket.scm 89 */
obj_t aux1156_534;
aux1156_534 = 
SOCKET_HOSTIP(socket_532); 
POP_TRACE(); 
return aux1156_534;} } } } } 
}



/* socket-down? */
bool_t socket_down__159___socket(obj_t socket_4)
{ AN_OBJECT;
{ /* Llib/socket.scm 94 */
{ /* Llib/socket.scm 95 */
obj_t symbol1159_535;
symbol1159_535 = symbol1217___socket; 
{ /* Llib/socket.scm 95 */

PUSH_TRACE(symbol1159_535); BUNSPEC; 
{ /* Llib/socket.scm 95 */
bool_t aux1158_536;
aux1158_536 = 
SOCKET_DOWNP(socket_4); 
POP_TRACE(); 
return aux1158_536;} } } } 
}



/* _socket-down? */
obj_t _socket_down__147___socket(obj_t env_467, obj_t socket_468)
{ AN_OBJECT;
{ /* Llib/socket.scm 94 */
{ /* Llib/socket.scm 94 */
bool_t aux_663;
{ /* Llib/socket.scm 94 */
bool_t res1241_540;
{ /* Llib/socket.scm 94 */
obj_t socket_537;
{ /* Llib/socket.scm 94 */
bool_t test1185_494;
test1185_494 = 
SOCKETP(socket_468); 
if(test1185_494)
{ /* Llib/socket.scm 94 */
socket_537 = socket_468; }  else 
{ /* Llib/socket.scm 94 */
bigloo_type_error_location_103___error(symbol1218___socket, string1213___socket, socket_468, string1214___socket, 
BINT(((long)4572))); 
exit( -1 );} } 
{ /* Llib/socket.scm 95 */
obj_t symbol1159_538;
symbol1159_538 = symbol1217___socket; 
{ /* Llib/socket.scm 95 */

PUSH_TRACE(symbol1159_538); BUNSPEC; 
{ /* Llib/socket.scm 95 */
bool_t aux1158_539;
aux1158_539 = 
SOCKET_DOWNP(socket_537); 
POP_TRACE(); 
res1241_540 = aux1158_539; } } } } 
aux_663 = res1241_540; } 
return 
BBOOL(aux_663);} } 
}



/* socket-port-number */
obj_t socket_port_number_142___socket(obj_t socket_5)
{ AN_OBJECT;
{ /* Llib/socket.scm 100 */
{ /* Llib/socket.scm 101 */
obj_t symbol1161_541;
symbol1161_541 = symbol1219___socket; 
{ /* Llib/socket.scm 101 */

PUSH_TRACE(symbol1161_541); BUNSPEC; 
{ /* Llib/socket.scm 101 */
obj_t aux1160_542;
{ /* Llib/socket.scm 101 */
int aux_674;
aux_674 = 
SOCKET_PORT(socket_5); 
aux1160_542 = 
BINT(aux_674); } 
POP_TRACE(); 
return aux1160_542;} } } } 
}



/* _socket-port-number */
obj_t _socket_port_number_87___socket(obj_t env_469, obj_t socket_470)
{ AN_OBJECT;
{ /* Llib/socket.scm 100 */
{ /* Llib/socket.scm 100 */
obj_t socket_543;
{ /* Llib/socket.scm 100 */
bool_t test1187_496;
test1187_496 = 
SOCKETP(socket_470); 
if(test1187_496)
{ /* Llib/socket.scm 100 */
socket_543 = socket_470; }  else 
{ /* Llib/socket.scm 100 */
bigloo_type_error_location_103___error(symbol1220___socket, string1213___socket, socket_470, string1214___socket, 
BINT(((long)4874))); 
exit( -1 );} } 
{ /* Llib/socket.scm 101 */
obj_t symbol1161_544;
symbol1161_544 = symbol1219___socket; 
{ /* Llib/socket.scm 101 */

PUSH_TRACE(symbol1161_544); BUNSPEC; 
{ /* Llib/socket.scm 101 */
obj_t aux1160_545;
{ /* Llib/socket.scm 101 */
int aux_684;
aux_684 = 
SOCKET_PORT(socket_543); 
aux1160_545 = 
BINT(aux_684); } 
POP_TRACE(); 
return aux1160_545;} } } } } 
}



/* socket-input */
obj_t socket_input_208___socket(obj_t socket_6)
{ AN_OBJECT;
{ /* Llib/socket.scm 106 */
{ /* Llib/socket.scm 107 */
obj_t symbol1163_546;
symbol1163_546 = symbol1221___socket; 
{ /* Llib/socket.scm 107 */

PUSH_TRACE(symbol1163_546); BUNSPEC; 
{ /* Llib/socket.scm 107 */
obj_t aux1162_547;
aux1162_547 = 
SOCKET_INPUT(socket_6); 
POP_TRACE(); 
return aux1162_547;} } } } 
}



/* _socket-input */
obj_t _socket_input_55___socket(obj_t env_471, obj_t socket_472)
{ AN_OBJECT;
{ /* Llib/socket.scm 106 */
{ /* Llib/socket.scm 106 */
obj_t socket_548;
{ /* Llib/socket.scm 106 */
bool_t test1189_498;
test1189_498 = 
SOCKETP(socket_472); 
if(test1189_498)
{ /* Llib/socket.scm 106 */
socket_548 = socket_472; }  else 
{ /* Llib/socket.scm 106 */
bigloo_type_error_location_103___error(symbol1222___socket, string1213___socket, socket_472, string1214___socket, 
BINT(((long)5188))); 
exit( -1 );} } 
{ /* Llib/socket.scm 107 */
obj_t symbol1163_549;
symbol1163_549 = symbol1221___socket; 
{ /* Llib/socket.scm 107 */

PUSH_TRACE(symbol1163_549); BUNSPEC; 
{ /* Llib/socket.scm 107 */
obj_t aux1162_550;
aux1162_550 = 
SOCKET_INPUT(socket_548); 
POP_TRACE(); 
return aux1162_550;} } } } } 
}



/* socket-output */
obj_t socket_output_115___socket(obj_t socket_7)
{ AN_OBJECT;
{ /* Llib/socket.scm 112 */
{ /* Llib/socket.scm 113 */
obj_t symbol1165_551;
symbol1165_551 = symbol1223___socket; 
{ /* Llib/socket.scm 113 */

PUSH_TRACE(symbol1165_551); BUNSPEC; 
{ /* Llib/socket.scm 113 */
obj_t aux1164_552;
aux1164_552 = 
SOCKET_OUTPUT(socket_7); 
POP_TRACE(); 
return aux1164_552;} } } } 
}



/* _socket-output */
obj_t _socket_output_22___socket(obj_t env_473, obj_t socket_474)
{ AN_OBJECT;
{ /* Llib/socket.scm 112 */
{ /* Llib/socket.scm 112 */
obj_t socket_553;
{ /* Llib/socket.scm 112 */
bool_t test1191_500;
test1191_500 = 
SOCKETP(socket_474); 
if(test1191_500)
{ /* Llib/socket.scm 112 */
socket_553 = socket_474; }  else 
{ /* Llib/socket.scm 112 */
bigloo_type_error_location_103___error(symbol1224___socket, string1213___socket, socket_474, string1214___socket, 
BINT(((long)5484))); 
exit( -1 );} } 
{ /* Llib/socket.scm 113 */
obj_t symbol1165_554;
symbol1165_554 = symbol1223___socket; 
{ /* Llib/socket.scm 113 */

PUSH_TRACE(symbol1165_554); BUNSPEC; 
{ /* Llib/socket.scm 113 */
obj_t aux1164_555;
aux1164_555 = 
SOCKET_OUTPUT(socket_553); 
POP_TRACE(); 
return aux1164_555;} } } } } 
}



/* make-client-socket */
obj_t make_client_socket_228___socket(obj_t hostname_8, int port_number_220_9)
{ AN_OBJECT;
{ /* Llib/socket.scm 118 */
{ /* Llib/socket.scm 119 */
obj_t symbol1167_556;
symbol1167_556 = symbol1225___socket; 
{ /* Llib/socket.scm 119 */

PUSH_TRACE(symbol1167_556); BUNSPEC; 
{ /* Llib/socket.scm 119 */
obj_t aux1166_557;
aux1166_557 = 
make_client_socket(hostname_8, port_number_220_9); 
POP_TRACE(); 
return aux1166_557;} } } } 
}



/* _make-client-socket */
obj_t _make_client_socket_221___socket(obj_t env_475, obj_t hostname_476, obj_t port_number_220_477)
{ AN_OBJECT;
{ /* Llib/socket.scm 118 */
{ /* Llib/socket.scm 118 */
obj_t hostname_558;int port_number_220_559;
if(
STRINGP(hostname_476))
{ /* Llib/socket.scm 118 */
hostname_558 = hostname_476; }  else 
{ /* Llib/socket.scm 118 */
bigloo_type_error_location_103___error(symbol1226___socket, string1227___socket, hostname_476, string1214___socket, 
BINT(((long)5782))); 
exit( -1 );} 
{ /* Llib/socket.scm 118 */
obj_t aux_718;
if(
INTEGERP(port_number_220_477))
{ /* Llib/socket.scm 118 */
aux_718 = port_number_220_477
; }  else 
{ /* Llib/socket.scm 118 */
bigloo_type_error_location_103___error(symbol1226___socket, string1228___socket, port_number_220_477, string1214___socket, 
BINT(((long)5782))); 
exit( -1 );} 
port_number_220_559 = 
CINT(aux_718); } 
{ /* Llib/socket.scm 119 */
obj_t symbol1167_560;
symbol1167_560 = symbol1225___socket; 
{ /* Llib/socket.scm 119 */

PUSH_TRACE(symbol1167_560); BUNSPEC; 
{ /* Llib/socket.scm 119 */
obj_t aux1166_561;
aux1166_561 = 
make_client_socket(hostname_558, port_number_220_559); 
POP_TRACE(); 
return aux1166_561;} } } } } 
}



/* make-server-socket */
obj_t make_server_socket_214___socket(obj_t port_number_220_10)
{ AN_OBJECT;
{ /* Llib/socket.scm 124 */
{ /* Llib/socket.scm 125 */
obj_t symbol1169_562;
symbol1169_562 = symbol1229___socket; 
{ /* Llib/socket.scm 125 */

PUSH_TRACE(symbol1169_562); BUNSPEC; 
{ /* Llib/socket.scm 125 */
obj_t aux1168_563;
{ /* Llib/socket.scm 125 */
obj_t arg1006_564;
if(
NULLP(port_number_220_10))
{ /* Llib/socket.scm 125 */
arg1006_564 = 
BINT(((long)0)); }  else 
{ /* Llib/socket.scm 125 */
obj_t pair_565;
if(
PAIRP(port_number_220_10))
{ /* Llib/socket.scm 125 */
pair_565 = port_number_220_10; }  else 
{ /* Llib/socket.scm 125 */
bigloo_type_error_location_103___error(symbol1229___socket, string1230___socket, port_number_220_10, string1214___socket, 
BINT(((long)6228))); 
exit( -1 );} 
arg1006_564 = 
CAR(pair_565); } 
{ /* Llib/socket.scm 125 */
int aux_738;
{ /* Llib/socket.scm 125 */
obj_t aux_739;
if(
INTEGERP(arg1006_564))
{ /* Llib/socket.scm 125 */
aux_739 = arg1006_564
; }  else 
{ /* Llib/socket.scm 125 */
bigloo_type_error_location_103___error(symbol1229___socket, string1228___socket, arg1006_564, string1214___socket, 
BINT(((long)6179))); 
exit( -1 );} 
aux_738 = 
CINT(aux_739); } 
aux1168_563 = 
make_server_socket(aux_738); } } 
POP_TRACE(); 
return aux1168_563;} } } } 
}



/* _make-server-socket */
obj_t _make_server_socket_127___socket(obj_t env_478, obj_t port_number_220_479)
{ AN_OBJECT;
{ /* Llib/socket.scm 124 */
{ /* Llib/socket.scm 124 */
obj_t port_number_220_566;
port_number_220_566 = port_number_220_479; 
{ /* Llib/socket.scm 125 */
obj_t symbol1169_567;
symbol1169_567 = symbol1229___socket; 
{ /* Llib/socket.scm 125 */

PUSH_TRACE(symbol1169_567); BUNSPEC; 
{ /* Llib/socket.scm 125 */
obj_t aux1168_568;
{ /* Llib/socket.scm 125 */
obj_t arg1006_569;
if(
NULLP(port_number_220_566))
{ /* Llib/socket.scm 125 */
arg1006_569 = 
BINT(((long)0)); }  else 
{ /* Llib/socket.scm 125 */
obj_t pair_570;
if(
PAIRP(port_number_220_566))
{ /* Llib/socket.scm 125 */
pair_570 = port_number_220_566; }  else 
{ /* Llib/socket.scm 125 */
bigloo_type_error_location_103___error(symbol1229___socket, string1230___socket, port_number_220_566, string1214___socket, 
BINT(((long)6228))); 
exit( -1 );} 
arg1006_569 = 
CAR(pair_570); } 
{ /* Llib/socket.scm 125 */
int aux_758;
{ /* Llib/socket.scm 125 */
obj_t aux_759;
if(
INTEGERP(arg1006_569))
{ /* Llib/socket.scm 125 */
aux_759 = arg1006_569
; }  else 
{ /* Llib/socket.scm 125 */
bigloo_type_error_location_103___error(symbol1229___socket, string1228___socket, arg1006_569, string1214___socket, 
BINT(((long)6179))); 
exit( -1 );} 
aux_758 = 
CINT(aux_759); } 
aux1168_568 = 
make_server_socket(aux_758); } } 
POP_TRACE(); 
return aux1168_568;} } } } } 
}



/* socket-accept-connection */
obj_t socket_accept_connection_52___socket(obj_t socket_11)
{ AN_OBJECT;
{ /* Llib/socket.scm 130 */
{ /* Llib/socket.scm 131 */
obj_t symbol1171_571;
symbol1171_571 = symbol1231___socket; 
{ /* Llib/socket.scm 131 */

PUSH_TRACE(symbol1171_571); BUNSPEC; 
{ /* Llib/socket.scm 131 */
obj_t aux1170_572;
aux1170_572 = 
socket_accept_connection(socket_11); 
POP_TRACE(); 
return aux1170_572;} } } } 
}



/* _socket-accept-connection */
obj_t _socket_accept_connection_223___socket(obj_t env_480, obj_t socket_481)
{ AN_OBJECT;
{ /* Llib/socket.scm 130 */
{ /* Llib/socket.scm 130 */
obj_t socket_573;
{ /* Llib/socket.scm 130 */
bool_t test1201_510;
test1201_510 = 
SOCKETP(socket_481); 
if(test1201_510)
{ /* Llib/socket.scm 130 */
socket_573 = socket_481; }  else 
{ /* Llib/socket.scm 130 */
bigloo_type_error_location_103___error(symbol1232___socket, string1213___socket, socket_481, string1214___socket, 
BINT(((long)6471))); 
exit( -1 );} } 
{ /* Llib/socket.scm 131 */
obj_t symbol1171_574;
symbol1171_574 = symbol1231___socket; 
{ /* Llib/socket.scm 131 */

PUSH_TRACE(symbol1171_574); BUNSPEC; 
{ /* Llib/socket.scm 131 */
obj_t aux1170_575;
aux1170_575 = 
socket_accept_connection(socket_573); 
POP_TRACE(); 
return aux1170_575;} } } } } 
}



/* socket-local-address */
obj_t socket_local_address_209___socket(obj_t socket_12)
{ AN_OBJECT;
{ /* Llib/socket.scm 136 */
{ /* Llib/socket.scm 137 */
obj_t symbol1173_576;
symbol1173_576 = symbol1233___socket; 
{ /* Llib/socket.scm 137 */

PUSH_TRACE(symbol1173_576); BUNSPEC; 
{ /* Llib/socket.scm 137 */
obj_t aux1172_577;
aux1172_577 = 
socket_local_addr(socket_12); 
POP_TRACE(); 
return aux1172_577;} } } } 
}



/* _socket-local-address */
obj_t _socket_local_address_218___socket(obj_t env_482, obj_t socket_483)
{ AN_OBJECT;
{ /* Llib/socket.scm 136 */
{ /* Llib/socket.scm 136 */
obj_t socket_578;
{ /* Llib/socket.scm 136 */
bool_t test1203_512;
test1203_512 = 
SOCKETP(socket_483); 
if(test1203_512)
{ /* Llib/socket.scm 136 */
socket_578 = socket_483; }  else 
{ /* Llib/socket.scm 136 */
bigloo_type_error_location_103___error(symbol1234___socket, string1213___socket, socket_483, string1214___socket, 
BINT(((long)6796))); 
exit( -1 );} } 
{ /* Llib/socket.scm 137 */
obj_t symbol1173_579;
symbol1173_579 = symbol1233___socket; 
{ /* Llib/socket.scm 137 */

PUSH_TRACE(symbol1173_579); BUNSPEC; 
{ /* Llib/socket.scm 137 */
obj_t aux1172_580;
aux1172_580 = 
socket_local_addr(socket_578); 
POP_TRACE(); 
return aux1172_580;} } } } } 
}



/* socket-dup */
obj_t socket_dup_120___socket(obj_t socket_13)
{ AN_OBJECT;
{ /* Llib/socket.scm 142 */
{ /* Llib/socket.scm 143 */
obj_t symbol1175_581;
symbol1175_581 = symbol1235___socket; 
{ /* Llib/socket.scm 143 */

PUSH_TRACE(symbol1175_581); BUNSPEC; 
{ /* Llib/socket.scm 143 */
obj_t aux1174_582;
aux1174_582 = 
socket_dup(socket_13); 
POP_TRACE(); 
return aux1174_582;} } } } 
}



/* _socket-dup */
obj_t _socket_dup_164___socket(obj_t env_484, obj_t socket_485)
{ AN_OBJECT;
{ /* Llib/socket.scm 142 */
{ /* Llib/socket.scm 142 */
obj_t socket_583;
{ /* Llib/socket.scm 142 */
bool_t test1205_514;
test1205_514 = 
SOCKETP(socket_485); 
if(test1205_514)
{ /* Llib/socket.scm 142 */
socket_583 = socket_485; }  else 
{ /* Llib/socket.scm 142 */
bigloo_type_error_location_103___error(symbol1236___socket, string1213___socket, socket_485, string1214___socket, 
BINT(((long)7105))); 
exit( -1 );} } 
{ /* Llib/socket.scm 143 */
obj_t symbol1175_584;
symbol1175_584 = symbol1235___socket; 
{ /* Llib/socket.scm 143 */

PUSH_TRACE(symbol1175_584); BUNSPEC; 
{ /* Llib/socket.scm 143 */
obj_t aux1174_585;
aux1174_585 = 
socket_dup(socket_583); 
POP_TRACE(); 
return aux1174_585;} } } } } 
}



/* socket-shutdown */
obj_t socket_shutdown_97___socket(obj_t socket_14, obj_t close_15)
{ AN_OBJECT;
{ /* Llib/socket.scm 148 */
{ /* Llib/socket.scm 149 */
obj_t symbol1177_586;
symbol1177_586 = symbol1237___socket; 
{ /* Llib/socket.scm 149 */

PUSH_TRACE(symbol1177_586); BUNSPEC; 
{ /* Llib/socket.scm 149 */
obj_t aux1176_587;
{ /* Llib/socket.scm 149 */
obj_t arg1008_588;
{ /* Llib/socket.scm 149 */
bool_t test1009_589;
test1009_589 = 
PAIRP(close_15); 
if(test1009_589)
{ /* Llib/socket.scm 149 */
obj_t pair_590;
if(test1009_589)
{ /* Llib/socket.scm 149 */
pair_590 = close_15; }  else 
{ /* Llib/socket.scm 149 */
bigloo_type_error_location_103___error(symbol1237___socket, string1230___socket, close_15, string1214___socket, 
BINT(((long)7509))); 
exit( -1 );} 
arg1008_588 = 
CAR(pair_590); }  else 
{ /* Llib/socket.scm 149 */
arg1008_588 = BTRUE; } } 
{ /* Llib/socket.scm 149 */
bool_t aux_809;
aux_809 = 
CBOOL(arg1008_588); 
aux1176_587 = 
socket_shutdown(socket_14, aux_809); } } 
POP_TRACE(); 
return aux1176_587;} } } } 
}



/* _socket-shutdown */
obj_t _socket_shutdown_189___socket(obj_t env_486, obj_t socket_487, obj_t close_488)
{ AN_OBJECT;
{ /* Llib/socket.scm 148 */
{ /* Llib/socket.scm 148 */
obj_t socket_591;obj_t close_592;
{ /* Llib/socket.scm 148 */
bool_t test1209_518;
test1209_518 = 
SOCKETP(socket_487); 
if(test1209_518)
{ /* Llib/socket.scm 148 */
socket_591 = socket_487; }  else 
{ /* Llib/socket.scm 148 */
bigloo_type_error_location_103___error(symbol1238___socket, string1213___socket, socket_487, string1214___socket, 
BINT(((long)7405))); 
exit( -1 );} } 
close_592 = close_488; 
{ /* Llib/socket.scm 149 */
obj_t symbol1177_593;
symbol1177_593 = symbol1237___socket; 
{ /* Llib/socket.scm 149 */

PUSH_TRACE(symbol1177_593); BUNSPEC; 
{ /* Llib/socket.scm 149 */
obj_t aux1176_594;
{ /* Llib/socket.scm 149 */
obj_t arg1008_595;
{ /* Llib/socket.scm 149 */
bool_t test1009_596;
test1009_596 = 
PAIRP(close_592); 
if(test1009_596)
{ /* Llib/socket.scm 149 */
obj_t pair_597;
if(test1009_596)
{ /* Llib/socket.scm 149 */
pair_597 = close_592; }  else 
{ /* Llib/socket.scm 149 */
bigloo_type_error_location_103___error(symbol1237___socket, string1230___socket, close_592, string1214___socket, 
BINT(((long)7509))); 
exit( -1 );} 
arg1008_595 = 
CAR(pair_597); }  else 
{ /* Llib/socket.scm 149 */
arg1008_595 = BTRUE; } } 
{ /* Llib/socket.scm 149 */
bool_t aux_826;
aux_826 = 
CBOOL(arg1008_595); 
aux1176_594 = 
socket_shutdown(socket_591, aux_826); } } 
POP_TRACE(); 
return aux1176_594;} } } } } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___socket()
{ AN_OBJECT;
{ /* Llib/socket.scm 15 */
{ /* Llib/socket.scm 15 */
obj_t symbol1179_459;
symbol1179_459 = symbol1239___socket; 
{ /* Llib/socket.scm 15 */

PUSH_TRACE(symbol1179_459); BUNSPEC; 
{ /* Llib/socket.scm 15 */
obj_t aux1178_460;
aux1178_460 = 
module_initialization_70___error(((long)0), "__SOCKET"); 
POP_TRACE(); 
return aux1178_460;} } } } 
}

