/*===========================================================================*/
/*   (Eval/expand.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

static obj_t __identifier_eval_expander__130___expand(obj_t, obj_t, obj_t);
extern obj_t string_to_symbol(char *);
static obj_t initial_expander_162___expand(obj_t, obj_t);
static obj_t symbol1209___expand = BUNSPEC;
extern obj_t expand___expand(obj_t);
extern obj_t parse_formal_ident_54___expand(obj_t);
static obj_t _parse_formal_ident_255___expand(obj_t, obj_t);
static obj_t _anonymous_1020__144___expand(obj_t, obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
static obj_t _anonymous_1007__55___expand(obj_t, obj_t, obj_t);
static obj_t _expand___expand(obj_t, obj_t);
static obj_t loop___expand(obj_t, obj_t);
static obj_t _expand_once_110___expand(obj_t, obj_t);
extern obj_t get_eval_expander_232___macro(obj_t);
static obj_t __application_eval_expander__131___expand(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70___expand(long, char *);
extern obj_t module_initialization_70___macro(long, char *);
extern obj_t module_initialization_70___type(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___bigloo(long, char *);
extern obj_t module_initialization_70___tvector(long, char *);
extern obj_t module_initialization_70___structure(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___os(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_flonum(long, char *);
extern obj_t module_initialization_70___r4_characters_6_6(long, char *);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___r4_booleans_6_1(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_input_6_10_2(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
extern obj_t module_initialization_70___r4_ports_6_10_1(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t c_substring(obj_t, long, long);
extern obj_t expand_once_95___expand(obj_t);
static obj_t _initial_expander_127___expand(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94___expand();
static obj_t require_initialization_114___expand = BUNSPEC;
static obj_t cnst_init_137___expand();
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( expand_once_env_147___expand, _expand_once_110___expand1213, _expand_once_110___expand, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( expand_env_236___expand, _expand___expand1214, _expand___expand, 0L, 1 );
DEFINE_STATIC_PROCEDURE( _application_eval_expander__env_8___expand, __application_eval_expander__131___expand1215, __application_eval_expander__131___expand, 0L, 2 );
DEFINE_STATIC_PROCEDURE( _identifier_eval_expander__env_211___expand, __identifier_eval_expander__130___expand1216, __identifier_eval_expander__130___expand, 0L, 2 );
DEFINE_STATIC_PROCEDURE( initial_expander_env_197___expand, _initial_expander_127___expand1217, _initial_expander_127___expand, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( parse_formal_ident_env_19___expand, _parse_formal_ident_255___expand1218, _parse_formal_ident_255___expand, 0L, 1 );
DEFINE_STATIC_PROCEDURE( proc1204___expand, _anonymous_1020__144___expand1219, _anonymous_1020__144___expand, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1203___expand, _anonymous_1007__55___expand1220, _anonymous_1007__55___expand, 0L, 2 );
DEFINE_STRING( string1211___expand, string1211___expand1221, "Illegal formal identifier", 25 );
DEFINE_STRING( string1210___expand, string1210___expand1222, "", 0 );
DEFINE_STRING( string1208___expand, string1208___expand1223, "Illegal form", 12 );
DEFINE_STRING( string1207___expand, string1207___expand1224, "application", 11 );
DEFINE_STRING( string1206___expand, string1206___expand1225, "Type `extended pair' expected for expression", 44 );
DEFINE_STRING( string1205___expand, string1205___expand1226, "cer", 3 );



/* module-initialization */
obj_t module_initialization_70___expand(long checksum_702, char * from_703)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___expand))
{ 
require_initialization_114___expand = 
BBOOL(((bool_t)0)); 
cnst_init_137___expand(); 
imported_modules_init_94___expand(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___expand()
{ AN_OBJECT;
{ /* Eval/expand.scm 14 */
return ( 
symbol1209___expand = 
string_to_symbol("DSSSL"), BUNSPEC) ;} 
}



/* expand */
obj_t expand___expand(obj_t x_1)
{ AN_OBJECT;
{ /* Eval/expand.scm 50 */
return 
initial_expander_162___expand(x_1, initial_expander_env_197___expand);} 
}



/* _expand */
obj_t _expand___expand(obj_t env_670, obj_t x_671)
{ AN_OBJECT;
{ /* Eval/expand.scm 50 */
return 
expand___expand(x_671);} 
}



/* expand-once */
obj_t expand_once_95___expand(obj_t x_2)
{ AN_OBJECT;
{ /* Eval/expand.scm 56 */
{ /* Eval/expand.scm 57 */
obj_t _anonymous_1007__55_675;
_anonymous_1007__55_675 = proc1203___expand; 
return 
initial_expander_162___expand(x_2, _anonymous_1007__55_675);} } 
}



/* _expand-once */
obj_t _expand_once_110___expand(obj_t env_676, obj_t x_677)
{ AN_OBJECT;
{ /* Eval/expand.scm 56 */
return 
expand_once_95___expand(x_677);} 
}



/* <anonymous:1007> */
obj_t _anonymous_1007__55___expand(obj_t env_678, obj_t x_679, obj_t e_680)
{ AN_OBJECT;
{ /* Eval/expand.scm 57 */
{ /* Eval/expand.scm 57 */
obj_t x_694;
x_694 = x_679; 
return x_694;} } 
}



/* initial-expander */
obj_t initial_expander_162___expand(obj_t x_3, obj_t e_4)
{ AN_OBJECT;
{ /* Eval/expand.scm 62 */
{ /* Eval/expand.scm 63 */
obj_t e1_339;
if(
SYMBOLP(x_3))
{ /* Eval/expand.scm 64 */
e1_339 = _identifier_eval_expander__env_211___expand; }  else 
{ /* Eval/expand.scm 64 */
if(
PAIRP(x_3))
{ /* Eval/expand.scm 68 */
bool_t test_718;
{ /* ./Ieee/symbol.scm 3589 */
obj_t aux_719;
aux_719 = 
CAR(x_3); 
test_718 = 
SYMBOLP(aux_719); } 
if(test_718)
{ /* Eval/expand.scm 68 */
{ /* Eval/expand.scm 69 */
obj_t id_350;
{ /* Eval/expand.scm 69 */
obj_t arg1017_352;
arg1017_352 = 
parse_formal_ident_54___expand(
CAR(x_3)); 
id_350 = 
CAR(arg1017_352); } 
{ /* Eval/expand.scm 70 */
obj_t b_351;
b_351 = 
get_eval_expander_232___macro(id_350); 
if(
CBOOL(b_351))
{ /* Eval/expand.scm 71 */
e1_339 = b_351; }  else 
{ /* Eval/expand.scm 71 */
e1_339 = _application_eval_expander__env_8___expand; } } } }  else 
{ /* Eval/expand.scm 68 */
e1_339 = _application_eval_expander__env_8___expand; } }  else 
{ /* Eval/expand.scm 66 */
{ /* Eval/expand.scm 67 */
obj_t _anonymous_1020__144_681;
_anonymous_1020__144_681 = proc1204___expand; 
e1_339 = _anonymous_1020__144_681; } } } 
{ /* Eval/expand.scm 76 */
obj_t new_340;
new_340 = 
PROCEDURE_ENTRY(e1_339)(e1_339, x_3, e_4, BEOA); 
{ /* Eval/expand.scm 77 */
bool_t test1008_341;
if(
PAIRP(new_340))
{ /* Eval/expand.scm 78 */
bool_t test1013_346;
test1013_346 = 
EXTENDED_PAIRP(new_340); 
if(test1013_346)
{ /* Eval/expand.scm 78 */
test1008_341 = ((bool_t)0); }  else 
{ /* Eval/expand.scm 78 */
test1008_341 = 
EXTENDED_PAIRP(x_3); } }  else 
{ /* Eval/expand.scm 77 */
test1008_341 = ((bool_t)0); } 
if(test1008_341)
{ /* Eval/expand.scm 80 */
obj_t arg1009_342;obj_t arg1010_343;obj_t arg1011_344;
arg1009_342 = 
CAR(new_340); 
arg1010_343 = 
CDR(new_340); 
{ /* ./Ieee/pair-list.scm 4343 */
bool_t test1151_565;
test1151_565 = 
EXTENDED_PAIRP(x_3); 
if(test1151_565)
{ /* ./Ieee/pair-list.scm 4343 */
arg1011_344 = 
CER(x_3); }  else 
{ /* ./Ieee/pair-list.scm 4343 */
FAILURE(string1205___expand,string1206___expand,x_3);} } 
return 
MAKE_EXTENDED_PAIR(arg1009_342, arg1010_343, arg1011_344);}  else 
{ /* Eval/expand.scm 77 */
return new_340;} } } } } 
}



/* _initial-expander */
obj_t _initial_expander_127___expand(obj_t env_672, obj_t x_673, obj_t e_674)
{ AN_OBJECT;
{ /* Eval/expand.scm 62 */
return 
initial_expander_162___expand(x_673, e_674);} 
}



/* <anonymous:1020> */
obj_t _anonymous_1020__144___expand(obj_t env_682, obj_t x_683, obj_t e_684)
{ AN_OBJECT;
{ /* Eval/expand.scm 67 */
{ /* Eval/expand.scm 67 */
obj_t x_696;
x_696 = x_683; 
return x_696;} } 
}



/* _*identifier-eval-expander* */
obj_t __identifier_eval_expander__130___expand(obj_t env_685, obj_t x_686, obj_t e_687)
{ AN_OBJECT;
{ /* Eval/expand.scm 86 */
{ /* Eval/expand.scm 86 */
obj_t x_698;
x_698 = x_686; 
return x_698;} } 
}



/* loop */
obj_t loop___expand(obj_t e_693, obj_t x_358)
{ AN_OBJECT;
{ /* Eval/expand.scm 93 */
if(
NULLP(x_358))
{ /* Eval/expand.scm 95 */
return BNIL;}  else 
{ /* Eval/expand.scm 95 */
if(
PAIRP(x_358))
{ /* Eval/expand.scm 97 */
{ /* Eval/expand.scm 100 */
obj_t arg1023_362;obj_t arg1024_363;
arg1023_362 = 
PROCEDURE_ENTRY(e_693)(e_693, 
CAR(x_358), e_693, BEOA); 
arg1024_363 = 
loop___expand(e_693, 
CDR(x_358)); 
return 
MAKE_PAIR(arg1023_362, arg1024_363);} }  else 
{ /* Eval/expand.scm 97 */
FAILURE(string1207___expand,string1208___expand,x_358);} } } 
}



/* _*application-eval-expander* */
obj_t __application_eval_expander__131___expand(obj_t env_688, obj_t x_689, obj_t e_690)
{ AN_OBJECT;
{ /* Eval/expand.scm 92 */
{ /* Eval/expand.scm 92 */
obj_t x_700;obj_t e_701;
x_700 = x_689; 
e_701 = e_690; 
return 
loop___expand(e_701, x_700);} } 
}



/* parse-formal-ident */
obj_t parse_formal_ident_54___expand(obj_t ident_9)
{ AN_OBJECT;
{ /* Eval/expand.scm 105 */
{ /* Eval/expand.scm 107 */
bool_t test_756;
if(
(ident_9==BCNST(258)))
{ /* Eval/expand.scm 107 */
test_756 = ((bool_t)1)
; }  else 
{ /* Eval/expand.scm 107 */
if(
(ident_9==BCNST(259)))
{ /* Eval/expand.scm 108 */
test_756 = ((bool_t)1)
; }  else 
{ /* Eval/expand.scm 108 */
test_756 = 
(ident_9==BCNST(262))
; } } 
if(test_756)
{ /* Eval/expand.scm 107 */
{ /* Eval/expand.scm 110 */
obj_t arg1028_367;
arg1028_367 = 
PROCEDURE_ENTRY(gensym___r4_symbols_6_4)(gensym___r4_symbols_6_4, symbol1209___expand, BEOA); 
return 
MAKE_PAIR(arg1028_367, BNIL);} }  else 
{ /* Eval/expand.scm 111 */
bool_t test_765;
if(
PAIRP(ident_9))
{ /* ./Ieee/symbol.scm 3589 */
obj_t aux_768;
aux_768 = 
CAR(ident_9); 
test_765 = 
SYMBOLP(aux_768); }  else 
{ /* Eval/expand.scm 111 */
test_765 = ((bool_t)0)
; } 
if(test_765)
{ /* Eval/expand.scm 111 */
return 
MAKE_PAIR(ident_9, BNIL);}  else 
{ /* Eval/expand.scm 111 */
if(
SYMBOLP(ident_9))
{ /* Eval/expand.scm 113 */
{ /* Eval/expand.scm 116 */
obj_t string_371;
string_371 = 
SYMBOL_TO_STRING(ident_9); 
{ /* Eval/expand.scm 116 */
long len_372;
len_372 = 
STRING_LENGTH(string_371); 
{ /* Eval/expand.scm 117 */

{ 
long walker_373;long id_stop_141_374;long type_start_90_375;
walker_373 = ((long)0); 
id_stop_141_374 = ((long)0); 
type_start_90_375 = ((long)0); 
loop_376:
if(
(walker_373==len_372))
{ /* Eval/expand.scm 122 */
{ /* Eval/expand.scm 124 */
bool_t test_778;
if(
(id_stop_141_374==((long)0)))
{ /* Eval/expand.scm 124 */
test_778 = 
(type_start_90_375>((long)0))
; }  else 
{ /* Eval/expand.scm 124 */
test_778 = ((bool_t)0)
; } 
if(test_778)
{ /* Eval/expand.scm 124 */
{ /* Eval/expand.scm 128 */
obj_t arg1034_379;obj_t arg1035_380;
{ /* ./Ieee/symbol.scm 3601 */
char * aux_782;
aux_782 = 
BSTRING_TO_STRING(string1210___expand); 
arg1034_379 = 
string_to_symbol(aux_782); } 
{ /* Eval/expand.scm 129 */
obj_t arg1036_381;
arg1036_381 = 
c_substring(string_371, type_start_90_375, len_372); 
{ /* ./Ieee/symbol.scm 3601 */
char * aux_786;
aux_786 = 
BSTRING_TO_STRING(arg1036_381); 
arg1035_380 = 
string_to_symbol(aux_786); } } 
return 
MAKE_PAIR(arg1034_379, arg1035_380);} }  else 
{ /* Eval/expand.scm 124 */
if(
(id_stop_141_374==((long)0)))
{ /* Eval/expand.scm 130 */
return 
MAKE_PAIR(ident_9, BNIL);}  else 
{ /* Eval/expand.scm 130 */
if(
(type_start_90_375==len_372))
{ /* Eval/expand.scm 132 */
FAILURE(BFALSE,string1211___expand,ident_9);}  else 
{ /* Eval/expand.scm 132 */
{ /* Eval/expand.scm 137 */
obj_t arg1039_384;obj_t arg1040_385;
{ /* Eval/expand.scm 137 */
obj_t arg1041_386;
arg1041_386 = 
c_substring(string_371, ((long)0), id_stop_141_374); 
{ /* ./Ieee/symbol.scm 3601 */
char * aux_797;
aux_797 = 
BSTRING_TO_STRING(arg1041_386); 
arg1039_384 = 
string_to_symbol(aux_797); } } 
{ /* Eval/expand.scm 139 */
obj_t arg1043_387;
arg1043_387 = 
c_substring(string_371, type_start_90_375, len_372); 
{ /* ./Ieee/symbol.scm 3601 */
char * aux_801;
aux_801 = 
BSTRING_TO_STRING(arg1043_387); 
arg1040_385 = 
string_to_symbol(aux_801); } } 
return 
MAKE_PAIR(arg1039_384, arg1040_385);} } } } } }  else 
{ /* Eval/expand.scm 140 */
bool_t test_805;
{ /* Eval/expand.scm 140 */
bool_t test_806;
{ /* ./Ieee/char.scm 3263 */
unsigned char aux_807;
aux_807 = 
STRING_REF(string_371, walker_373); 
test_806 = 
(aux_807==((unsigned char)':')); } 
if(test_806)
{ /* Eval/expand.scm 141 */
bool_t test_810;
{ /* ./Ieee/fixnum.scm 2603 */
long aux_811;
aux_811 = 
(len_372-((long)1)); 
test_810 = 
(walker_373<aux_811); } 
if(test_810)
{ /* ./Ieee/char.scm 3263 */
unsigned char aux_814;
{ /* ./Ieee/string.scm 3899 */
long aux_815;
aux_815 = 
(walker_373+((long)1)); 
aux_814 = 
STRING_REF(string_371, aux_815); } 
test_805 = 
(aux_814==((unsigned char)':')); }  else 
{ /* Eval/expand.scm 141 */
test_805 = ((bool_t)0)
; } }  else 
{ /* Eval/expand.scm 140 */
test_805 = ((bool_t)0)
; } } 
if(test_805)
{ /* Eval/expand.scm 140 */
if(
(type_start_90_375>((long)0)))
{ /* Eval/expand.scm 143 */
FAILURE(BFALSE,string1211___expand,ident_9);}  else 
{ 
long type_start_90_825;long id_stop_141_824;long walker_822;
walker_822 = 
(walker_373+((long)2)); 
id_stop_141_824 = walker_373; 
type_start_90_825 = 
(walker_373+((long)2)); 
type_start_90_375 = type_start_90_825; 
id_stop_141_374 = id_stop_141_824; 
walker_373 = walker_822; 
goto loop_376;} }  else 
{ /* Eval/expand.scm 140 */
{ 
long walker_827;
walker_827 = 
(walker_373+((long)1)); 
walker_373 = walker_827; 
goto loop_376;} } } } } } } }  else 
{ /* Eval/expand.scm 113 */
FAILURE(BFALSE,string1211___expand,ident_9);} } } } } 
}



/* _parse-formal-ident */
obj_t _parse_formal_ident_255___expand(obj_t env_691, obj_t ident_692)
{ AN_OBJECT;
{ /* Eval/expand.scm 105 */
return 
parse_formal_ident_54___expand(ident_692);} 
}



/* imported-modules-init */
obj_t imported_modules_init_94___expand()
{ AN_OBJECT;
{ /* Eval/expand.scm 14 */
module_initialization_70___type(((long)0), "__EXPAND"); 
module_initialization_70___error(((long)0), "__EXPAND"); 
module_initialization_70___bigloo(((long)0), "__EXPAND"); 
module_initialization_70___tvector(((long)0), "__EXPAND"); 
module_initialization_70___structure(((long)0), "__EXPAND"); 
module_initialization_70___bexit(((long)0), "__EXPAND"); 
module_initialization_70___os(((long)0), "__EXPAND"); 
module_initialization_70___r4_numbers_6_5(((long)0), "__EXPAND"); 
module_initialization_70___r4_numbers_6_5_fixnum(((long)0), "__EXPAND"); 
module_initialization_70___r4_numbers_6_5_flonum(((long)0), "__EXPAND"); 
module_initialization_70___r4_characters_6_6(((long)0), "__EXPAND"); 
module_initialization_70___r4_equivalence_6_2(((long)0), "__EXPAND"); 
module_initialization_70___r4_booleans_6_1(((long)0), "__EXPAND"); 
module_initialization_70___r4_symbols_6_4(((long)0), "__EXPAND"); 
module_initialization_70___r4_strings_6_7(((long)0), "__EXPAND"); 
module_initialization_70___r4_pairs_and_lists_6_3(((long)0), "__EXPAND"); 
module_initialization_70___r4_input_6_10_2(((long)0), "__EXPAND"); 
module_initialization_70___r4_control_features_6_9(((long)0), "__EXPAND"); 
module_initialization_70___r4_vectors_6_8(((long)0), "__EXPAND"); 
module_initialization_70___r4_ports_6_10_1(((long)0), "__EXPAND"); 
module_initialization_70___r4_output_6_10_3(((long)0), "__EXPAND"); 
module_initialization_70___evenv(((long)0), "__EXPAND"); 
return 
module_initialization_70___macro(((long)0), "__EXPAND");} 
}

