/*===========================================================================*/
/*   (Eval/expanders.scm)                                                    */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t expand_eval_labels_169___expander_let(obj_t, obj_t);
extern obj_t expand_cond_expand_93___expander_srfi_0_86(obj_t, obj_t);
static obj_t _anonymous_1112__24___install_expanders(obj_t, obj_t, obj_t);
extern obj_t expand_quote_117___expander_quote(obj_t, obj_t);
extern obj_t string_to_symbol(char *);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t _anonymous_1093__137___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1089__9___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1085__120___install_expanders(obj_t, obj_t, obj_t);
static obj_t expand_test_227___install_expanders(obj_t, obj_t);
extern obj_t expand_define_expander_27___eval(obj_t, obj_t);
static obj_t _anonymous_1081__163___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1078__34___install_expanders(obj_t, obj_t, obj_t);
extern obj_t expand_eval_define_struct_250___expander_struct(obj_t, obj_t);
static obj_t _anonymous_1075__203___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1071__94___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1067__239___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1063__74___install_expanders(obj_t, obj_t, obj_t);
extern obj_t install_all_expanders__168___install_expanders();
static obj_t _install_all_expanders__218___install_expanders(obj_t);
static obj_t _anonymous_1056__181___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1337__6___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1052__39___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1334__250___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1049__145___install_expanders(obj_t, obj_t, obj_t);
extern obj_t expand_eval_define_inline_157___expander_define(obj_t, obj_t);
static obj_t _anonymous_1331__35___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1045__125___install_expanders(obj_t, obj_t, obj_t);
extern obj_t expand_eval_lambda_55___expander_define(obj_t, obj_t);
static obj_t _anonymous_1327__121___install_expanders(obj_t, obj_t, obj_t);
extern obj_t install_eval_expander_92___macro(obj_t, obj_t);
static obj_t _anonymous_1042__177___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1324__51___install_expanders(obj_t, obj_t, obj_t);
extern obj_t expand_eval_define_165___expander_define(obj_t, obj_t);
static obj_t _anonymous_1321__117___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1318__101___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1314__206___install_expanders(obj_t, obj_t, obj_t);
extern obj_t expand_eval_letrec_133___expander_let(obj_t, obj_t);
static obj_t _anonymous_1308__51___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1304__33___install_expanders(obj_t, obj_t, obj_t);
extern obj_t install_expander_245___macro(obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
static obj_t _anonymous_1301__198___install_expanders(obj_t, obj_t, obj_t);
extern obj_t expand_eval_let__60___expander_let(obj_t, obj_t);
extern obj_t _nil__217___eval;
extern obj_t quasiquotation___expander_quote(obj_t, obj_t);
extern obj_t expand_or_72___expander_bool(obj_t);
static obj_t _anonymous_1260__161___install_expanders(obj_t, obj_t, obj_t);
static obj_t _anonymous_1257__220___install_expanders(obj_t, obj_t, obj_t);
extern obj_t expand_do_31___expander_do(obj_t, obj_t);
extern obj_t expand_define_hygien_macro_18___eval(obj_t, obj_t);
extern obj_t module_initialization_70___install_expanders(long, char *);
extern obj_t module_initialization_70___match_expand(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___macro(long, char *);
extern obj_t module_initialization_70___expander_quote(long, char *);
extern obj_t module_initialization_70___expander_let(long, char *);
extern obj_t module_initialization_70___expander_bool(long, char *);
extern obj_t module_initialization_70___expander_case(long, char *);
extern obj_t module_initialization_70___expander_define(long, char *);
extern obj_t module_initialization_70___expander_do(long, char *);
extern obj_t module_initialization_70___expander_try(long, char *);
extern obj_t module_initialization_70___expander_struct(long, char *);
extern obj_t module_initialization_70___expander_srfi_0_86(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___progn(long, char *);
extern obj_t module_initialization_70___lalr_expand(long, char *);
extern obj_t module_initialization_70___rgc_expand(long, char *);
static obj_t _anonymous_1238__247___install_expanders(obj_t, obj_t, obj_t);
extern obj_t expand_eval_let_110___expander_let(obj_t, obj_t);
extern obj_t expand_match_case_143___match_expand(obj_t);
extern obj_t expand_and_10___expander_bool(obj_t);
static obj_t _anonymous_1223__79___install_expanders(obj_t, obj_t, obj_t);
extern obj_t expand_match_lambda_130___match_expand(obj_t);
static obj_t _anonymous_1189__81___install_expanders(obj_t, obj_t, obj_t);
extern obj_t expand_eval_case_113___expander_case(obj_t, obj_t);
extern obj_t expand_define_pattern_97___eval(obj_t);
extern obj_t expand_cond_95___expander_bool(obj_t);
static obj_t _anonymous_1171__198___install_expanders(obj_t, obj_t, obj_t);
extern obj_t expand_try_212___expander_try(obj_t, obj_t);
static obj_t imported_modules_init_94___install_expanders();
static obj_t _anonymous_1153__38___install_expanders(obj_t, obj_t, obj_t);
static obj_t require_initialization_114___install_expanders = BUNSPEC;
extern obj_t expand_define_macro_35___eval(obj_t, obj_t);
static obj_t symbol1644___install_expanders = BUNSPEC;
static obj_t symbol1637___install_expanders = BUNSPEC;
static obj_t symbol1631___install_expanders = BUNSPEC;
static obj_t symbol1629___install_expanders = BUNSPEC;
static obj_t symbol1630___install_expanders = BUNSPEC;
static obj_t symbol1625___install_expanders = BUNSPEC;
static obj_t _anonymous_1131__51___install_expanders(obj_t, obj_t, obj_t);
static obj_t symbol1623___install_expanders = BUNSPEC;
static obj_t symbol1621___install_expanders = BUNSPEC;
static obj_t symbol1619___install_expanders = BUNSPEC;
static obj_t symbol1617___install_expanders = BUNSPEC;
static obj_t symbol1615___install_expanders = BUNSPEC;
static obj_t symbol1613___install_expanders = BUNSPEC;
static obj_t symbol1611___install_expanders = BUNSPEC;
static obj_t symbol1599___install_expanders = BUNSPEC;
static obj_t symbol1609___install_expanders = BUNSPEC;
extern obj_t normalize_progn_143___progn(obj_t);
static obj_t symbol1597___install_expanders = BUNSPEC;
static obj_t symbol1607___install_expanders = BUNSPEC;
static obj_t symbol1595___install_expanders = BUNSPEC;
static obj_t symbol1593___install_expanders = BUNSPEC;
static obj_t symbol1603___install_expanders = BUNSPEC;
static obj_t symbol1591___install_expanders = BUNSPEC;
static obj_t symbol1601___install_expanders = BUNSPEC;
static obj_t symbol1589___install_expanders = BUNSPEC;
static obj_t symbol1588___install_expanders = BUNSPEC;
static obj_t symbol1587___install_expanders = BUNSPEC;
static obj_t symbol1586___install_expanders = BUNSPEC;
static obj_t cnst_init_137___install_expanders();
static obj_t symbol1584___install_expanders = BUNSPEC;
static obj_t symbol1582___install_expanders = BUNSPEC;
static obj_t symbol1580___install_expanders = BUNSPEC;
static obj_t symbol1578___install_expanders = BUNSPEC;
static obj_t symbol1576___install_expanders = BUNSPEC;
static obj_t symbol1574___install_expanders = BUNSPEC;
static obj_t symbol1572___install_expanders = BUNSPEC;
static obj_t symbol1570___install_expanders = BUNSPEC;
static obj_t symbol1568___install_expanders = BUNSPEC;
static obj_t symbol1566___install_expanders = BUNSPEC;
static obj_t symbol1564___install_expanders = BUNSPEC;
static obj_t symbol1562___install_expanders = BUNSPEC;
static obj_t symbol1560___install_expanders = BUNSPEC;
static obj_t symbol1558___install_expanders = BUNSPEC;
static obj_t symbol1557___install_expanders = BUNSPEC;
static obj_t symbol1556___install_expanders = BUNSPEC;
static obj_t symbol1555___install_expanders = BUNSPEC;
static obj_t symbol1554___install_expanders = BUNSPEC;
static obj_t *__cnst;

DEFINE_STATIC_PROCEDURE( proc1626___install_expanders, _anonymous_1337__6___install_expanders1647, _anonymous_1337__6___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1624___install_expanders, _anonymous_1334__250___install_expanders1648, _anonymous_1334__250___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1622___install_expanders, _anonymous_1331__35___install_expanders1649, _anonymous_1331__35___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1620___install_expanders, _anonymous_1327__121___install_expanders1650, _anonymous_1327__121___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1618___install_expanders, _anonymous_1324__51___install_expanders1651, _anonymous_1324__51___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1616___install_expanders, _anonymous_1321__117___install_expanders1652, _anonymous_1321__117___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1614___install_expanders, _anonymous_1318__101___install_expanders1653, _anonymous_1318__101___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1612___install_expanders, _anonymous_1314__206___install_expanders1654, _anonymous_1314__206___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1610___install_expanders, _anonymous_1308__51___install_expanders1655, _anonymous_1308__51___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1598___install_expanders, _anonymous_1189__81___install_expanders1656, _anonymous_1189__81___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1608___install_expanders, _anonymous_1304__33___install_expanders1657, _anonymous_1304__33___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1596___install_expanders, _anonymous_1171__198___install_expanders1658, _anonymous_1171__198___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1606___install_expanders, _anonymous_1301__198___install_expanders1659, _anonymous_1301__198___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1605___install_expanders, _anonymous_1260__161___install_expanders1660, _anonymous_1260__161___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1594___install_expanders, _anonymous_1153__38___install_expanders1661, _anonymous_1153__38___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1604___install_expanders, _anonymous_1257__220___install_expanders1662, _anonymous_1257__220___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1592___install_expanders, _anonymous_1131__51___install_expanders1663, _anonymous_1131__51___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1602___install_expanders, _anonymous_1238__247___install_expanders1664, _anonymous_1238__247___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1590___install_expanders, _anonymous_1112__24___install_expanders1665, _anonymous_1112__24___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1600___install_expanders, _anonymous_1223__79___install_expanders1666, _anonymous_1223__79___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1585___install_expanders, _anonymous_1093__137___install_expanders1667, _anonymous_1093__137___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1583___install_expanders, _anonymous_1089__9___install_expanders1668, _anonymous_1089__9___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1581___install_expanders, _anonymous_1085__120___install_expanders1669, _anonymous_1085__120___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1579___install_expanders, _anonymous_1081__163___install_expanders1670, _anonymous_1081__163___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1577___install_expanders, _anonymous_1078__34___install_expanders1671, _anonymous_1078__34___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1575___install_expanders, _anonymous_1075__203___install_expanders1672, _anonymous_1075__203___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1573___install_expanders, _anonymous_1071__94___install_expanders1673, _anonymous_1071__94___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1571___install_expanders, _anonymous_1067__239___install_expanders1674, _anonymous_1067__239___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1569___install_expanders, _anonymous_1063__74___install_expanders1675, _anonymous_1063__74___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1567___install_expanders, _anonymous_1056__181___install_expanders1676, _anonymous_1056__181___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1565___install_expanders, _anonymous_1052__39___install_expanders1677, _anonymous_1052__39___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1563___install_expanders, _anonymous_1049__145___install_expanders1678, _anonymous_1049__145___install_expanders, 0L, 2 );
extern obj_t expand_regular_grammar_env_93___rgc_expand;
DEFINE_STATIC_PROCEDURE( proc1561___install_expanders, _anonymous_1045__125___install_expanders1679, _anonymous_1045__125___install_expanders, 0L, 2 );
DEFINE_STATIC_PROCEDURE( proc1559___install_expanders, _anonymous_1042__177___install_expanders1680, _anonymous_1042__177___install_expanders, 0L, 2 );
extern obj_t expand_string_case_env_105___rgc_expand;
DEFINE_STRING( string1645___install_expanders, string1645___install_expanders1681, "delay", 5 );
DEFINE_STRING( string1643___install_expanders, string1643___install_expanders1682, "begin", 5 );
DEFINE_STRING( string1642___install_expanders, string1642___install_expanders1683, "Illegal `failure' form", 22 );
DEFINE_STRING( string1641___install_expanders, string1641___install_expanders1684, "failure", 7 );
DEFINE_STRING( string1639___install_expanders, string1639___install_expanders1685, "unwind-protect", 14 );
DEFINE_STRING( string1640___install_expanders, string1640___install_expanders1686, "bind-exit", 9 );
DEFINE_STRING( string1638___install_expanders, string1638___install_expanders1687, "multiple-value-bind", 19 );
DEFINE_STRING( string1636___install_expanders, string1636___install_expanders1688, "when", 4 );
DEFINE_STRING( string1635___install_expanders, string1635___install_expanders1689, "unless", 6 );
DEFINE_STRING( string1634___install_expanders, string1634___install_expanders1690, "if", 2 );
DEFINE_STRING( string1633___install_expanders, string1633___install_expanders1691, "Illegal form", 12 );
DEFINE_STRING( string1632___install_expanders, string1632___install_expanders1692, "profile", 7 );
DEFINE_STRING( string1628___install_expanders, string1628___install_expanders1693, "Type `extended pair' expected for expression", 44 );
DEFINE_STRING( string1627___install_expanders, string1627___install_expanders1694, "cer", 3 );
extern obj_t expand_lalr_grammar_env_33___lalr_expand;
DEFINE_EXPORT_PROCEDURE( install_all_expanders__env_132___install_expanders, _install_all_expanders__218___install_expanders1695, _install_all_expanders__218___install_expanders, 0L, 0 );



/* module-initialization */
obj_t module_initialization_70___install_expanders(long checksum_1730, char * from_1731)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___install_expanders))
{ 
require_initialization_114___install_expanders = 
BBOOL(((bool_t)0)); 
cnst_init_137___install_expanders(); 
imported_modules_init_94___install_expanders(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___install_expanders()
{ AN_OBJECT;
{ /* Eval/expanders.scm 14 */
symbol1554___install_expanders = 
string_to_symbol("LAMBDA"); 
symbol1555___install_expanders = 
string_to_symbol("TEST-AUX-FOR-NIL"); 
symbol1556___install_expanders = 
string_to_symbol("IF"); 
symbol1557___install_expanders = 
string_to_symbol("NULL?"); 
symbol1558___install_expanders = 
string_to_symbol("QUOTE"); 
symbol1560___install_expanders = 
string_to_symbol("QUASIQUOTE"); 
symbol1562___install_expanders = 
string_to_symbol("DEFINE-MACRO"); 
symbol1564___install_expanders = 
string_to_symbol("DEFINE-HYGIEN-MACRO"); 
symbol1566___install_expanders = 
string_to_symbol("DEFINE-EXPANDER"); 
symbol1568___install_expanders = 
string_to_symbol("OR"); 
symbol1570___install_expanders = 
string_to_symbol("AND"); 
symbol1572___install_expanders = 
string_to_symbol("COND"); 
symbol1574___install_expanders = 
string_to_symbol("DO"); 
symbol1576___install_expanders = 
string_to_symbol("TRY"); 
symbol1578___install_expanders = 
string_to_symbol("MATCH-CASE"); 
symbol1580___install_expanders = 
string_to_symbol("MATCH-LAMBDA"); 
symbol1582___install_expanders = 
string_to_symbol("DEFINE-PATTERN"); 
symbol1584___install_expanders = 
string_to_symbol("DELAY"); 
symbol1586___install_expanders = 
string_to_symbol("REGULAR-GRAMMAR"); 
symbol1587___install_expanders = 
string_to_symbol("STRING-CASE"); 
symbol1588___install_expanders = 
string_to_symbol("LALR-GRAMMAR"); 
symbol1589___install_expanders = 
string_to_symbol("BEGIN"); 
symbol1591___install_expanders = 
string_to_symbol("FAILURE"); 
symbol1593___install_expanders = 
string_to_symbol("BIND-EXIT"); 
symbol1595___install_expanders = 
string_to_symbol("UNWIND-PROTECT"); 
symbol1597___install_expanders = 
string_to_symbol("MULTIPLE-VALUE-BIND"); 
symbol1599___install_expanders = 
string_to_symbol("WHEN"); 
symbol1601___install_expanders = 
string_to_symbol("UNLESS"); 
symbol1603___install_expanders = 
string_to_symbol("MODULE"); 
symbol1607___install_expanders = 
string_to_symbol("LET"); 
symbol1609___install_expanders = 
string_to_symbol("LET*"); 
symbol1611___install_expanders = 
string_to_symbol("LETREC"); 
symbol1613___install_expanders = 
string_to_symbol("LABELS"); 
symbol1615___install_expanders = 
string_to_symbol("DEFINE"); 
symbol1617___install_expanders = 
string_to_symbol("DEFINE-INLINE"); 
symbol1619___install_expanders = 
string_to_symbol("DEFINE-STRUCT"); 
symbol1621___install_expanders = 
string_to_symbol("CASE"); 
symbol1623___install_expanders = 
string_to_symbol("COND-EXPAND"); 
symbol1625___install_expanders = 
string_to_symbol("PROFILE"); 
symbol1629___install_expanders = 
string_to_symbol("VALUE"); 
symbol1630___install_expanders = 
string_to_symbol("GC-PROFILE-PUSH"); 
symbol1631___install_expanders = 
string_to_symbol("GC-PROFILE-POP"); 
symbol1637___install_expanders = 
string_to_symbol("CALL-WITH-VALUES"); 
return ( 
symbol1644___install_expanders = 
string_to_symbol("MAKE-PROMISE"), BUNSPEC) ;} 
}



/* expand-test */
obj_t expand_test_227___install_expanders(obj_t x_1, obj_t e_2)
{ AN_OBJECT;
{ /* Eval/expanders.scm 64 */
if(
CBOOL(_nil__217___eval))
{ /* Eval/expanders.scm 65 */
return 
PROCEDURE_ENTRY(e_2)(e_2, x_1, e_2, BEOA);}  else 
{ /* Eval/expanders.scm 67 */
obj_t arg1016_327;obj_t arg1017_328;
{ /* Eval/expanders.scm 67 */
obj_t arg1018_329;obj_t arg1019_330;
arg1018_329 = symbol1554___install_expanders; 
{ /* Eval/expanders.scm 67 */
obj_t arg1020_331;obj_t arg1021_332;
arg1020_331 = 
MAKE_PAIR(symbol1555___install_expanders, BNIL); 
{ /* Eval/expanders.scm 68 */
obj_t arg1022_333;
{ /* Eval/expanders.scm 68 */
obj_t arg1024_335;obj_t arg1025_336;
arg1024_335 = symbol1556___install_expanders; 
{ /* Eval/expanders.scm 68 */
obj_t arg1026_337;obj_t arg1027_338;
arg1026_337 = symbol1555___install_expanders; 
{ /* Eval/expanders.scm 69 */
obj_t arg1028_339;obj_t arg1029_340;
{ /* Eval/expanders.scm 69 */
obj_t arg1030_341;obj_t arg1031_342;
arg1030_341 = symbol1556___install_expanders; 
{ /* Eval/expanders.scm 69 */
obj_t arg1032_343;obj_t arg1033_344;
{ /* Eval/expanders.scm 69 */
obj_t arg1034_345;obj_t arg1035_346;
arg1034_345 = symbol1557___install_expanders; 
arg1035_346 = 
MAKE_PAIR(symbol1555___install_expanders, BNIL); 
arg1032_343 = 
MAKE_PAIR(arg1034_345, arg1035_346); } 
{ /* Eval/expanders.scm 69 */
obj_t arg1036_347;
arg1036_347 = 
MAKE_PAIR(BTRUE, BNIL); 
arg1033_344 = 
MAKE_PAIR(BFALSE, arg1036_347); } 
arg1031_342 = 
MAKE_PAIR(arg1032_343, arg1033_344); } 
arg1028_339 = 
MAKE_PAIR(arg1030_341, arg1031_342); } 
arg1029_340 = 
MAKE_PAIR(BFALSE, BNIL); 
arg1027_338 = 
MAKE_PAIR(arg1028_339, arg1029_340); } 
arg1025_336 = 
MAKE_PAIR(arg1026_337, arg1027_338); } 
arg1022_333 = 
MAKE_PAIR(arg1024_335, arg1025_336); } 
arg1021_332 = 
MAKE_PAIR(arg1022_333, BNIL); } 
arg1019_330 = 
MAKE_PAIR(arg1020_331, arg1021_332); } 
arg1016_327 = 
MAKE_PAIR(arg1018_329, arg1019_330); } 
{ /* Eval/expanders.scm 73 */
obj_t arg1038_348;
arg1038_348 = 
PROCEDURE_ENTRY(e_2)(e_2, x_1, e_2, BEOA); 
arg1017_328 = 
MAKE_PAIR(arg1038_348, BNIL); } 
return 
MAKE_PAIR(arg1016_327, arg1017_328);} } 
}



/* install-all-expanders! */
obj_t install_all_expanders__168___install_expanders()
{ AN_OBJECT;
{ /* Eval/expanders.scm 83 */
{ /* Eval/expanders.scm 89 */
obj_t arg1040_350;
arg1040_350 = symbol1558___install_expanders; 
{ /* Eval/expanders.scm 89 */
obj_t _anonymous_1042__177_1583;
_anonymous_1042__177_1583 = proc1559___install_expanders; 
install_expander_245___macro(arg1040_350, _anonymous_1042__177_1583); } } 
{ /* Eval/expanders.scm 92 */
obj_t arg1043_356;
arg1043_356 = symbol1560___install_expanders; 
{ /* Eval/expanders.scm 92 */
obj_t _anonymous_1045__125_1582;
_anonymous_1045__125_1582 = proc1561___install_expanders; 
install_expander_245___macro(arg1043_356, _anonymous_1045__125_1582); } } 
{ /* Eval/expanders.scm 95 */
obj_t arg1047_363;
arg1047_363 = symbol1562___install_expanders; 
{ /* Eval/expanders.scm 96 */
obj_t _anonymous_1049__145_1581;
_anonymous_1049__145_1581 = proc1563___install_expanders; 
install_expander_245___macro(arg1047_363, _anonymous_1049__145_1581); } } 
{ /* Eval/expanders.scm 99 */
obj_t arg1050_369;
arg1050_369 = symbol1564___install_expanders; 
{ /* Eval/expanders.scm 100 */
obj_t _anonymous_1052__39_1580;
_anonymous_1052__39_1580 = proc1565___install_expanders; 
install_expander_245___macro(arg1050_369, _anonymous_1052__39_1580); } } 
{ /* Eval/expanders.scm 103 */
obj_t arg1054_375;
arg1054_375 = symbol1566___install_expanders; 
{ /* Eval/expanders.scm 104 */
obj_t _anonymous_1056__181_1579;
_anonymous_1056__181_1579 = proc1567___install_expanders; 
install_expander_245___macro(arg1054_375, _anonymous_1056__181_1579); } } 
{ /* Eval/expanders.scm 108 */
obj_t arg1061_381;
arg1061_381 = symbol1568___install_expanders; 
{ /* Eval/expanders.scm 108 */
obj_t _anonymous_1063__74_1578;
_anonymous_1063__74_1578 = proc1569___install_expanders; 
install_expander_245___macro(arg1061_381, _anonymous_1063__74_1578); } } 
{ /* Eval/expanders.scm 111 */
obj_t arg1065_388;
arg1065_388 = symbol1570___install_expanders; 
{ /* Eval/expanders.scm 111 */
obj_t _anonymous_1067__239_1577;
_anonymous_1067__239_1577 = proc1571___install_expanders; 
install_expander_245___macro(arg1065_388, _anonymous_1067__239_1577); } } 
{ /* Eval/expanders.scm 114 */
obj_t arg1069_395;
arg1069_395 = symbol1572___install_expanders; 
{ /* Eval/expanders.scm 114 */
obj_t _anonymous_1071__94_1576;
_anonymous_1071__94_1576 = proc1573___install_expanders; 
install_expander_245___macro(arg1069_395, _anonymous_1071__94_1576); } } 
{ /* Eval/expanders.scm 117 */
obj_t arg1073_402;
arg1073_402 = symbol1574___install_expanders; 
{ /* Eval/expanders.scm 117 */
obj_t _anonymous_1075__203_1575;
_anonymous_1075__203_1575 = proc1575___install_expanders; 
install_expander_245___macro(arg1073_402, _anonymous_1075__203_1575); } } 
{ /* Eval/expanders.scm 120 */
obj_t arg1076_408;
arg1076_408 = symbol1576___install_expanders; 
{ /* Eval/expanders.scm 120 */
obj_t _anonymous_1078__34_1574;
_anonymous_1078__34_1574 = proc1577___install_expanders; 
install_expander_245___macro(arg1076_408, _anonymous_1078__34_1574); } } 
{ /* Eval/expanders.scm 123 */
obj_t arg1079_414;
arg1079_414 = symbol1578___install_expanders; 
{ /* Eval/expanders.scm 123 */
obj_t _anonymous_1081__163_1573;
_anonymous_1081__163_1573 = proc1579___install_expanders; 
install_expander_245___macro(arg1079_414, _anonymous_1081__163_1573); } } 
{ /* Eval/expanders.scm 126 */
obj_t arg1083_421;
arg1083_421 = symbol1580___install_expanders; 
{ /* Eval/expanders.scm 127 */
obj_t _anonymous_1085__120_1572;
_anonymous_1085__120_1572 = proc1581___install_expanders; 
install_expander_245___macro(arg1083_421, _anonymous_1085__120_1572); } } 
{ /* Eval/expanders.scm 130 */
obj_t arg1087_428;
arg1087_428 = symbol1582___install_expanders; 
{ /* Eval/expanders.scm 131 */
obj_t _anonymous_1089__9_1571;
_anonymous_1089__9_1571 = proc1583___install_expanders; 
install_expander_245___macro(arg1087_428, _anonymous_1089__9_1571); } } 
{ /* Eval/expanders.scm 134 */
obj_t arg1091_435;
arg1091_435 = symbol1584___install_expanders; 
{ /* Eval/expanders.scm 134 */
obj_t _anonymous_1093__137_1570;
_anonymous_1093__137_1570 = proc1585___install_expanders; 
install_expander_245___macro(arg1091_435, _anonymous_1093__137_1570); } } 
install_expander_245___macro(symbol1586___install_expanders, expand_regular_grammar_env_93___rgc_expand); 
install_expander_245___macro(symbol1587___install_expanders, expand_string_case_env_105___rgc_expand); 
install_expander_245___macro(symbol1588___install_expanders, expand_lalr_grammar_env_33___lalr_expand); 
{ /* Eval/expanders.scm 152 */
obj_t arg1110_462;
arg1110_462 = symbol1589___install_expanders; 
{ /* Eval/expanders.scm 152 */
obj_t _anonymous_1112__24_1569;
_anonymous_1112__24_1569 = proc1590___install_expanders; 
install_expander_245___macro(arg1110_462, _anonymous_1112__24_1569); } } 
{ /* Eval/expanders.scm 176 */
obj_t arg1129_498;
arg1129_498 = symbol1591___install_expanders; 
{ /* Eval/expanders.scm 176 */
obj_t _anonymous_1131__51_1568;
_anonymous_1131__51_1568 = proc1592___install_expanders; 
install_expander_245___macro(arg1129_498, _anonymous_1131__51_1568); } } 
{ /* Eval/expanders.scm 188 */
obj_t arg1151_531;
arg1151_531 = symbol1593___install_expanders; 
{ /* Eval/expanders.scm 188 */
obj_t _anonymous_1153__38_1567;
_anonymous_1153__38_1567 = proc1594___install_expanders; 
install_eval_expander_92___macro(arg1151_531, _anonymous_1153__38_1567); } } 
{ /* Eval/expanders.scm 200 */
obj_t arg1169_560;
arg1169_560 = symbol1595___install_expanders; 
{ /* Eval/expanders.scm 200 */
obj_t _anonymous_1171__198_1566;
_anonymous_1171__198_1566 = proc1596___install_expanders; 
install_eval_expander_92___macro(arg1169_560, _anonymous_1171__198_1566); } } 
{ /* Eval/expanders.scm 214 */
obj_t arg1187_594;
arg1187_594 = symbol1597___install_expanders; 
{ /* Eval/expanders.scm 215 */
obj_t _anonymous_1189__81_1565;
_anonymous_1189__81_1565 = proc1598___install_expanders; 
install_expander_245___macro(arg1187_594, _anonymous_1189__81_1565); } } 
{ /* Eval/expanders.scm 227 */
obj_t arg1220_628;
arg1220_628 = symbol1599___install_expanders; 
{ /* Eval/expanders.scm 228 */
obj_t _anonymous_1223__79_1564;
_anonymous_1223__79_1564 = proc1600___install_expanders; 
install_expander_245___macro(arg1220_628, _anonymous_1223__79_1564); } } 
{ /* Eval/expanders.scm 239 */
obj_t arg1236_652;
arg1236_652 = symbol1601___install_expanders; 
{ /* Eval/expanders.scm 240 */
obj_t _anonymous_1238__247_1563;
_anonymous_1238__247_1563 = proc1602___install_expanders; 
install_expander_245___macro(arg1236_652, _anonymous_1238__247_1563); } } 
{ /* Eval/expanders.scm 254 */
obj_t arg1255_677;
arg1255_677 = symbol1603___install_expanders; 
{ /* Eval/expanders.scm 254 */
obj_t _anonymous_1257__220_1562;
_anonymous_1257__220_1562 = proc1604___install_expanders; 
install_eval_expander_92___macro(arg1255_677, _anonymous_1257__220_1562); } } 
{ /* Eval/expanders.scm 257 */
obj_t arg1258_683;
arg1258_683 = symbol1556___install_expanders; 
{ /* Eval/expanders.scm 257 */
obj_t _anonymous_1260__161_1561;
_anonymous_1260__161_1561 = proc1605___install_expanders; 
install_eval_expander_92___macro(arg1258_683, _anonymous_1260__161_1561); } } 
{ /* Eval/expanders.scm 271 */
obj_t arg1299_735;
arg1299_735 = symbol1554___install_expanders; 
{ /* Eval/expanders.scm 271 */
obj_t _anonymous_1301__198_1560;
_anonymous_1301__198_1560 = proc1606___install_expanders; 
install_eval_expander_92___macro(arg1299_735, _anonymous_1301__198_1560); } } 
{ /* Eval/expanders.scm 274 */
obj_t arg1302_741;
arg1302_741 = symbol1607___install_expanders; 
{ /* Eval/expanders.scm 274 */
obj_t _anonymous_1304__33_1559;
_anonymous_1304__33_1559 = proc1608___install_expanders; 
install_eval_expander_92___macro(arg1302_741, _anonymous_1304__33_1559); } } 
{ /* Eval/expanders.scm 277 */
obj_t arg1305_747;
arg1305_747 = symbol1609___install_expanders; 
{ /* Eval/expanders.scm 277 */
obj_t _anonymous_1308__51_1558;
_anonymous_1308__51_1558 = proc1610___install_expanders; 
install_eval_expander_92___macro(arg1305_747, _anonymous_1308__51_1558); } } 
{ /* Eval/expanders.scm 280 */
obj_t arg1309_753;
arg1309_753 = symbol1611___install_expanders; 
{ /* Eval/expanders.scm 280 */
obj_t _anonymous_1314__206_1557;
_anonymous_1314__206_1557 = proc1612___install_expanders; 
install_eval_expander_92___macro(arg1309_753, _anonymous_1314__206_1557); } } 
{ /* Eval/expanders.scm 283 */
obj_t arg1315_759;
arg1315_759 = symbol1613___install_expanders; 
{ /* Eval/expanders.scm 283 */
obj_t _anonymous_1318__101_1556;
_anonymous_1318__101_1556 = proc1614___install_expanders; 
install_eval_expander_92___macro(arg1315_759, _anonymous_1318__101_1556); } } 
{ /* Eval/expanders.scm 286 */
obj_t arg1319_765;
arg1319_765 = symbol1615___install_expanders; 
{ /* Eval/expanders.scm 286 */
obj_t _anonymous_1321__117_1555;
_anonymous_1321__117_1555 = proc1616___install_expanders; 
install_eval_expander_92___macro(arg1319_765, _anonymous_1321__117_1555); } } 
{ /* Eval/expanders.scm 289 */
obj_t arg1322_771;
arg1322_771 = symbol1617___install_expanders; 
{ /* Eval/expanders.scm 290 */
obj_t _anonymous_1324__51_1554;
_anonymous_1324__51_1554 = proc1618___install_expanders; 
install_eval_expander_92___macro(arg1322_771, _anonymous_1324__51_1554); } } 
{ /* Eval/expanders.scm 293 */
obj_t arg1325_777;
arg1325_777 = symbol1619___install_expanders; 
{ /* Eval/expanders.scm 294 */
obj_t _anonymous_1327__121_1553;
_anonymous_1327__121_1553 = proc1620___install_expanders; 
install_eval_expander_92___macro(arg1325_777, _anonymous_1327__121_1553); } } 
{ /* Eval/expanders.scm 297 */
obj_t arg1329_783;
arg1329_783 = symbol1621___install_expanders; 
{ /* Eval/expanders.scm 297 */
obj_t _anonymous_1331__35_1552;
_anonymous_1331__35_1552 = proc1622___install_expanders; 
install_eval_expander_92___macro(arg1329_783, _anonymous_1331__35_1552); } } 
{ /* Eval/expanders.scm 300 */
obj_t arg1332_789;
arg1332_789 = symbol1623___install_expanders; 
{ /* Eval/expanders.scm 301 */
obj_t _anonymous_1334__250_1551;
_anonymous_1334__250_1551 = proc1624___install_expanders; 
install_eval_expander_92___macro(arg1332_789, _anonymous_1334__250_1551); } } 
{ /* Eval/expanders.scm 304 */
obj_t arg1335_795;
arg1335_795 = symbol1625___install_expanders; 
{ /* Eval/expanders.scm 305 */
obj_t _anonymous_1337__6_1550;
_anonymous_1337__6_1550 = proc1626___install_expanders; 
return 
install_eval_expander_92___macro(arg1335_795, _anonymous_1337__6_1550);} } } 
}



/* _install-all-expanders! */
obj_t _install_all_expanders__218___install_expanders(obj_t env_1584)
{ AN_OBJECT;
{ /* Eval/expanders.scm 83 */
return 
install_all_expanders__168___install_expanders();} 
}



/* <anonymous:1337> */
obj_t _anonymous_1337__6___install_expanders(obj_t env_1585, obj_t x_1586, obj_t e_1587)
{ AN_OBJECT;
{ /* Eval/expanders.scm 305 */
{ 
obj_t x_797;obj_t e_798;
x_797 = x_1586; 
e_798 = e_1587; 
{ 
obj_t lbl_800;obj_t exprs_801;
if(
PAIRP(x_797))
{ /* Eval/expanders.scm 305 */
obj_t cdr_313_221_806;
cdr_313_221_806 = 
CDR(x_797); 
if(
PAIRP(cdr_313_221_806))
{ /* Eval/expanders.scm 305 */
obj_t car_316_200_808;
car_316_200_808 = 
CAR(cdr_313_221_806); 
if(
SYMBOLP(car_316_200_808))
{ /* Eval/expanders.scm 305 */
lbl_800 = car_316_200_808; 
exprs_801 = 
CDR(cdr_313_221_806); 
{ /* Eval/expanders.scm 308 */
obj_t la_811;
{ /* Eval/expanders.scm 308 */
obj_t arg1390_851;obj_t arg1391_852;
arg1390_851 = symbol1554___install_expanders; 
{ /* ./Ieee/pair-list.scm 5721 */
obj_t aux_1849;
aux_1849 = 
append_2_18___r4_pairs_and_lists_6_3(exprs_801, BNIL); 
arg1391_852 = 
MAKE_PAIR(BNIL, aux_1849); } 
la_811 = 
MAKE_PAIR(arg1390_851, arg1391_852); } 
{ /* Eval/expanders.scm 308 */
obj_t lam_812;
{ /* Eval/expanders.scm 309 */
bool_t test1384_847;
test1384_847 = 
EXTENDED_PAIRP(x_797); 
if(test1384_847)
{ /* Eval/expanders.scm 310 */
obj_t arg1385_848;obj_t arg1387_849;obj_t arg1389_850;
arg1385_848 = 
CAR(la_811); 
arg1387_849 = 
CDR(la_811); 
{ /* ./Ieee/pair-list.scm 5745 */
bool_t test1494_1476;
test1494_1476 = 
EXTENDED_PAIRP(x_797); 
if(test1494_1476)
{ /* ./Ieee/pair-list.scm 5745 */
arg1389_850 = 
CER(x_797); }  else 
{ /* ./Ieee/pair-list.scm 5745 */
FAILURE(string1627___install_expanders,string1628___install_expanders,x_797);} } 
lam_812 = 
MAKE_EXTENDED_PAIR(arg1385_848, arg1387_849, arg1389_850); }  else 
{ /* Eval/expanders.scm 309 */
lam_812 = la_811; } } 
{ /* Eval/expanders.scm 309 */
obj_t val_813;
{ /* Eval/expanders.scm 314 */
obj_t sym_846;
sym_846 = 
PROCEDURE_ENTRY(gensym___r4_symbols_6_4)(gensym___r4_symbols_6_4, symbol1629___install_expanders, BEOA); 
val_813 = sym_846; } 
{ /* Eval/expanders.scm 314 */
obj_t aux_814;
{ /* Eval/expanders.scm 316 */
obj_t arg1348_820;obj_t arg1350_821;
arg1348_820 = symbol1607___install_expanders; 
{ /* Eval/expanders.scm 316 */
obj_t arg1354_822;obj_t arg1355_823;
{ /* Eval/expanders.scm 316 */
obj_t arg1356_824;
{ /* Eval/expanders.scm 316 */
obj_t arg1358_826;
arg1358_826 = 
MAKE_PAIR(lam_812, BNIL); 
arg1356_824 = 
MAKE_PAIR(lbl_800, arg1358_826); } 
arg1354_822 = 
MAKE_PAIR(arg1356_824, BNIL); } 
{ /* Eval/expanders.scm 317 */
obj_t arg1359_827;obj_t arg1361_828;
{ /* Eval/expanders.scm 317 */
obj_t arg1363_829;obj_t arg1365_830;
arg1363_829 = symbol1630___install_expanders; 
{ /* Eval/expanders.scm 318 */
obj_t arg1366_831;obj_t arg1367_832;
arg1366_831 = 
SYMBOL_TO_STRING(lbl_800); 
arg1367_832 = 
MAKE_PAIR(lbl_800, BNIL); 
arg1365_830 = 
MAKE_PAIR(arg1366_831, arg1367_832); } 
arg1359_827 = 
MAKE_PAIR(arg1363_829, arg1365_830); } 
{ /* Eval/expanders.scm 320 */
obj_t arg1369_833;
{ /* Eval/expanders.scm 320 */
obj_t arg1372_835;obj_t arg1373_836;
arg1372_835 = symbol1607___install_expanders; 
{ /* Eval/expanders.scm 320 */
obj_t arg1374_837;obj_t arg1375_838;
{ /* Eval/expanders.scm 320 */
obj_t arg1376_839;
{ /* Eval/expanders.scm 320 */
obj_t arg1378_841;
{ /* Eval/expanders.scm 320 */
obj_t arg1379_842;
arg1379_842 = 
MAKE_PAIR(lbl_800, BNIL); 
arg1378_841 = 
MAKE_PAIR(arg1379_842, BNIL); } 
arg1376_839 = 
MAKE_PAIR(val_813, arg1378_841); } 
arg1374_837 = 
MAKE_PAIR(arg1376_839, BNIL); } 
{ /* Eval/expanders.scm 321 */
obj_t arg1381_844;obj_t arg1383_845;
arg1381_844 = 
MAKE_PAIR(symbol1631___install_expanders, BNIL); 
arg1383_845 = 
MAKE_PAIR(val_813, BNIL); 
arg1375_838 = 
MAKE_PAIR(arg1381_844, arg1383_845); } 
arg1373_836 = 
MAKE_PAIR(arg1374_837, arg1375_838); } 
arg1369_833 = 
MAKE_PAIR(arg1372_835, arg1373_836); } 
arg1361_828 = 
MAKE_PAIR(arg1369_833, BNIL); } 
arg1355_823 = 
MAKE_PAIR(arg1359_827, arg1361_828); } 
arg1350_821 = 
MAKE_PAIR(arg1354_822, arg1355_823); } 
aux_814 = 
MAKE_PAIR(arg1348_820, arg1350_821); } 
{ /* Eval/expanders.scm 316 */
obj_t res_815;
{ /* Eval/expanders.scm 323 */
bool_t test1343_816;
test1343_816 = 
EXTENDED_PAIRP(x_797); 
if(test1343_816)
{ /* Eval/expanders.scm 324 */
obj_t arg1344_817;obj_t arg1346_818;obj_t arg1347_819;
arg1344_817 = 
CAR(aux_814); 
arg1346_818 = 
CDR(aux_814); 
{ /* ./Ieee/pair-list.scm 5745 */
bool_t test1494_1527;
test1494_1527 = 
EXTENDED_PAIRP(x_797); 
if(test1494_1527)
{ /* ./Ieee/pair-list.scm 5745 */
arg1347_819 = 
CER(x_797); }  else 
{ /* ./Ieee/pair-list.scm 5745 */
FAILURE(string1627___install_expanders,string1628___install_expanders,x_797);} } 
res_815 = 
MAKE_EXTENDED_PAIR(arg1344_817, arg1346_818, arg1347_819); }  else 
{ /* Eval/expanders.scm 323 */
res_815 = aux_814; } } 
{ /* Eval/expanders.scm 323 */

return 
PROCEDURE_ENTRY(e_798)(e_798, aux_814, e_798, BEOA);} } } } } } }  else 
{ /* Eval/expanders.scm 305 */
FAILURE(string1632___install_expanders,string1633___install_expanders,x_797);} }  else 
{ /* Eval/expanders.scm 305 */
FAILURE(string1632___install_expanders,string1633___install_expanders,x_797);} }  else 
{ /* Eval/expanders.scm 305 */
FAILURE(string1632___install_expanders,string1633___install_expanders,x_797);} } } } 
}



/* <anonymous:1334> */
obj_t _anonymous_1334__250___install_expanders(obj_t env_1588, obj_t x_1589, obj_t e_1590)
{ AN_OBJECT;
{ /* Eval/expanders.scm 300 */
{ /* Eval/expanders.scm 301 */
obj_t x_1696;obj_t e_1697;
x_1696 = x_1589; 
e_1697 = e_1590; 
return 
expand_cond_expand_93___expander_srfi_0_86(x_1696, e_1697);} } 
}



/* <anonymous:1331> */
obj_t _anonymous_1331__35___install_expanders(obj_t env_1591, obj_t x_1592, obj_t e_1593)
{ AN_OBJECT;
{ /* Eval/expanders.scm 297 */
{ /* Eval/expanders.scm 297 */
obj_t x_1698;obj_t e_1699;
x_1698 = x_1592; 
e_1699 = e_1593; 
return 
expand_eval_case_113___expander_case(x_1698, e_1699);} } 
}



/* <anonymous:1327> */
obj_t _anonymous_1327__121___install_expanders(obj_t env_1594, obj_t x_1595, obj_t e_1596)
{ AN_OBJECT;
{ /* Eval/expanders.scm 293 */
{ /* Eval/expanders.scm 294 */
obj_t x_1700;obj_t e_1701;
x_1700 = x_1595; 
e_1701 = e_1596; 
return 
expand_eval_define_struct_250___expander_struct(x_1700, e_1701);} } 
}



/* <anonymous:1324> */
obj_t _anonymous_1324__51___install_expanders(obj_t env_1597, obj_t x_1598, obj_t e_1599)
{ AN_OBJECT;
{ /* Eval/expanders.scm 289 */
{ /* Eval/expanders.scm 290 */
obj_t x_1702;obj_t e_1703;
x_1702 = x_1598; 
e_1703 = e_1599; 
return 
expand_eval_define_inline_157___expander_define(x_1702, e_1703);} } 
}



/* <anonymous:1321> */
obj_t _anonymous_1321__117___install_expanders(obj_t env_1600, obj_t x_1601, obj_t e_1602)
{ AN_OBJECT;
{ /* Eval/expanders.scm 286 */
{ /* Eval/expanders.scm 286 */
obj_t x_1704;obj_t e_1705;
x_1704 = x_1601; 
e_1705 = e_1602; 
return 
expand_eval_define_165___expander_define(x_1704, e_1705);} } 
}



/* <anonymous:1318> */
obj_t _anonymous_1318__101___install_expanders(obj_t env_1603, obj_t x_1604, obj_t e_1605)
{ AN_OBJECT;
{ /* Eval/expanders.scm 283 */
{ /* Eval/expanders.scm 283 */
obj_t x_1706;obj_t e_1707;
x_1706 = x_1604; 
e_1707 = e_1605; 
return 
expand_eval_labels_169___expander_let(x_1706, e_1707);} } 
}



/* <anonymous:1314> */
obj_t _anonymous_1314__206___install_expanders(obj_t env_1606, obj_t x_1607, obj_t e_1608)
{ AN_OBJECT;
{ /* Eval/expanders.scm 280 */
{ /* Eval/expanders.scm 280 */
obj_t x_1708;obj_t e_1709;
x_1708 = x_1607; 
e_1709 = e_1608; 
return 
expand_eval_letrec_133___expander_let(x_1708, e_1709);} } 
}



/* <anonymous:1308> */
obj_t _anonymous_1308__51___install_expanders(obj_t env_1609, obj_t x_1610, obj_t e_1611)
{ AN_OBJECT;
{ /* Eval/expanders.scm 277 */
{ /* Eval/expanders.scm 277 */
obj_t x_1710;obj_t e_1711;
x_1710 = x_1610; 
e_1711 = e_1611; 
return 
expand_eval_let__60___expander_let(x_1710, e_1711);} } 
}



/* <anonymous:1304> */
obj_t _anonymous_1304__33___install_expanders(obj_t env_1612, obj_t x_1613, obj_t e_1614)
{ AN_OBJECT;
{ /* Eval/expanders.scm 274 */
{ /* Eval/expanders.scm 274 */
obj_t x_1712;obj_t e_1713;
x_1712 = x_1613; 
e_1713 = e_1614; 
return 
expand_eval_let_110___expander_let(x_1712, e_1713);} } 
}



/* <anonymous:1301> */
obj_t _anonymous_1301__198___install_expanders(obj_t env_1615, obj_t x_1616, obj_t e_1617)
{ AN_OBJECT;
{ /* Eval/expanders.scm 271 */
{ /* Eval/expanders.scm 271 */
obj_t x_1714;obj_t e_1715;
x_1714 = x_1616; 
e_1715 = e_1617; 
return 
expand_eval_lambda_55___expander_define(x_1714, e_1715);} } 
}



/* <anonymous:1260> */
obj_t _anonymous_1260__161___install_expanders(obj_t env_1618, obj_t x_1619, obj_t e_1620)
{ AN_OBJECT;
{ /* Eval/expanders.scm 257 */
{ 
obj_t x_685;obj_t e_686;
x_685 = x_1619; 
e_686 = e_1620; 
if(
PAIRP(x_685))
{ /* Eval/expanders.scm 257 */
obj_t cdr_244_169_698;
cdr_244_169_698 = 
CDR(x_685); 
{ /* Eval/expanders.scm 257 */
bool_t test_1912;
{ /* ./Ieee/equiv.scm 4854 */
obj_t aux_1913;
aux_1913 = 
CAR(x_685); 
test_1912 = 
(aux_1913==symbol1556___install_expanders); } 
if(test_1912)
{ /* Eval/expanders.scm 257 */
if(
PAIRP(cdr_244_169_698))
{ /* Eval/expanders.scm 257 */
obj_t cdr_249_30_701;
cdr_249_30_701 = 
CDR(cdr_244_169_698); 
if(
PAIRP(cdr_249_30_701))
{ /* Eval/expanders.scm 257 */
obj_t cdr_254_12_703;
cdr_254_12_703 = 
CDR(cdr_249_30_701); 
if(
PAIRP(cdr_254_12_703))
{ /* Eval/expanders.scm 257 */
bool_t test_1924;
{ /* ./Ieee/equiv.scm 4854 */
obj_t aux_1925;
aux_1925 = 
CDR(cdr_254_12_703); 
test_1924 = 
(aux_1925==BNIL); } 
if(test_1924)
{ /* Eval/expanders.scm 260 */
obj_t arg1281_1363;obj_t arg1282_1364;
arg1281_1363 = symbol1556___install_expanders; 
{ /* Eval/expanders.scm 260 */
obj_t arg1286_1365;obj_t arg1287_1366;
arg1286_1365 = 
expand_test_227___install_expanders(
CAR(cdr_244_169_698), e_686); 
{ /* Eval/expanders.scm 261 */
obj_t arg1289_1367;obj_t arg1290_1368;
arg1289_1367 = 
PROCEDURE_ENTRY(e_686)(e_686, 
CAR(cdr_249_30_701), e_686, BEOA); 
{ /* Eval/expanders.scm 262 */
obj_t arg1291_1369;
arg1291_1369 = 
PROCEDURE_ENTRY(e_686)(e_686, 
CAR(cdr_254_12_703), e_686, BEOA); 
arg1290_1368 = 
MAKE_PAIR(arg1291_1369, BNIL); } 
arg1287_1366 = 
MAKE_PAIR(arg1289_1367, arg1290_1368); } 
arg1282_1364 = 
MAKE_PAIR(arg1286_1365, arg1287_1366); } 
return 
MAKE_PAIR(arg1281_1363, arg1282_1364);}  else 
{ /* Eval/expanders.scm 257 */
FAILURE(string1634___install_expanders,string1633___install_expanders,x_685);} }  else 
{ /* Eval/expanders.scm 257 */
obj_t cdr_279_181_712;
cdr_279_181_712 = 
CDR(cdr_244_169_698); 
{ /* Eval/expanders.scm 257 */
bool_t test_1942;
{ /* ./Ieee/equiv.scm 4854 */
obj_t aux_1943;
aux_1943 = 
CDR(cdr_279_181_712); 
test_1942 = 
(aux_1943==BNIL); } 
if(test_1942)
{ /* Eval/expanders.scm 264 */
obj_t arg1293_1391;obj_t arg1294_1392;
arg1293_1391 = symbol1556___install_expanders; 
{ /* Eval/expanders.scm 264 */
obj_t arg1295_1393;obj_t arg1296_1394;
arg1295_1393 = 
expand_test_227___install_expanders(
CAR(cdr_244_169_698), e_686); 
{ /* Eval/expanders.scm 265 */
obj_t arg1297_1395;obj_t arg1298_1396;
arg1297_1395 = 
PROCEDURE_ENTRY(e_686)(e_686, 
CAR(cdr_279_181_712), e_686, BEOA); 
arg1298_1396 = 
MAKE_PAIR(BUNSPEC, BNIL); 
arg1296_1394 = 
MAKE_PAIR(arg1297_1395, arg1298_1396); } 
arg1294_1392 = 
MAKE_PAIR(arg1295_1393, arg1296_1394); } 
return 
MAKE_PAIR(arg1293_1391, arg1294_1392);}  else 
{ /* Eval/expanders.scm 257 */
FAILURE(string1634___install_expanders,string1633___install_expanders,x_685);} } } }  else 
{ /* Eval/expanders.scm 257 */
FAILURE(string1634___install_expanders,string1633___install_expanders,x_685);} }  else 
{ /* Eval/expanders.scm 257 */
FAILURE(string1634___install_expanders,string1633___install_expanders,x_685);} }  else 
{ /* Eval/expanders.scm 257 */
FAILURE(string1634___install_expanders,string1633___install_expanders,x_685);} } }  else 
{ /* Eval/expanders.scm 257 */
FAILURE(string1634___install_expanders,string1633___install_expanders,x_685);} } } 
}



/* <anonymous:1257> */
obj_t _anonymous_1257__220___install_expanders(obj_t env_1621, obj_t x_1622, obj_t e_1623)
{ AN_OBJECT;
{ /* Eval/expanders.scm 254 */
{ /* Eval/expanders.scm 254 */
obj_t x_1716;
x_1716 = x_1622; 
return x_1716;} } 
}



/* <anonymous:1238> */
obj_t _anonymous_1238__247___install_expanders(obj_t env_1624, obj_t x_1625, obj_t e_1626)
{ AN_OBJECT;
{ /* Eval/expanders.scm 240 */
{ 
obj_t x_654;obj_t e_655;
x_654 = x_1625; 
e_655 = e_1626; 
{ 
obj_t si_657;obj_t body_658;
if(
PAIRP(x_654))
{ /* Eval/expanders.scm 240 */
obj_t cdr_226_92_663;
cdr_226_92_663 = 
CDR(x_654); 
if(
PAIRP(cdr_226_92_663))
{ /* Eval/expanders.scm 240 */
si_657 = 
CAR(cdr_226_92_663); 
body_658 = 
CDR(cdr_226_92_663); 
{ /* Eval/expanders.scm 243 */
obj_t arg1245_667;
{ /* Eval/expanders.scm 243 */
obj_t arg1246_668;obj_t arg1248_669;
arg1246_668 = symbol1556___install_expanders; 
{ /* Eval/expanders.scm 245 */
obj_t arg1249_670;
{ /* Eval/expanders.scm 245 */
obj_t arg1250_671;
{ /* Eval/expanders.scm 245 */
obj_t arg1251_672;
{ /* ./Ieee/pair-list.scm 5721 */
obj_t aux_1965;
aux_1965 = 
append_2_18___r4_pairs_and_lists_6_3(body_658, BNIL); 
arg1251_672 = 
MAKE_PAIR(symbol1589___install_expanders, aux_1965); } 
arg1250_671 = 
MAKE_PAIR(arg1251_672, BNIL); } 
arg1249_670 = 
MAKE_PAIR(BUNSPEC, arg1250_671); } 
arg1248_669 = 
MAKE_PAIR(si_657, arg1249_670); } 
arg1245_667 = 
MAKE_PAIR(arg1246_668, arg1248_669); } 
return 
PROCEDURE_ENTRY(e_655)(e_655, arg1245_667, e_655, BEOA);} }  else 
{ /* Eval/expanders.scm 240 */
FAILURE(string1635___install_expanders,string1633___install_expanders,x_654);} }  else 
{ /* Eval/expanders.scm 240 */
FAILURE(string1635___install_expanders,string1633___install_expanders,x_654);} } } } 
}



/* <anonymous:1223> */
obj_t _anonymous_1223__79___install_expanders(obj_t env_1627, obj_t x_1628, obj_t e_1629)
{ AN_OBJECT;
{ /* Eval/expanders.scm 228 */
{ 
obj_t x_630;obj_t e_631;
x_630 = x_1628; 
e_631 = e_1629; 
{ 
obj_t si_633;obj_t body_634;
if(
PAIRP(x_630))
{ /* Eval/expanders.scm 228 */
obj_t cdr_211_2_639;
cdr_211_2_639 = 
CDR(x_630); 
if(
PAIRP(cdr_211_2_639))
{ /* Eval/expanders.scm 228 */
si_633 = 
CAR(cdr_211_2_639); 
body_634 = 
CDR(cdr_211_2_639); 
{ /* Eval/expanders.scm 231 */
obj_t arg1228_643;
{ /* Eval/expanders.scm 231 */
obj_t arg1229_644;obj_t arg1230_645;
arg1229_644 = symbol1556___install_expanders; 
{ /* Eval/expanders.scm 232 */
obj_t arg1231_646;
{ /* Eval/expanders.scm 232 */
obj_t arg1232_647;obj_t arg1233_648;
{ /* ./Ieee/pair-list.scm 5721 */
obj_t aux_1983;
aux_1983 = 
append_2_18___r4_pairs_and_lists_6_3(body_634, BNIL); 
arg1232_647 = 
MAKE_PAIR(symbol1589___install_expanders, aux_1983); } 
arg1233_648 = 
MAKE_PAIR(BUNSPEC, BNIL); 
arg1231_646 = 
MAKE_PAIR(arg1232_647, arg1233_648); } 
arg1230_645 = 
MAKE_PAIR(si_633, arg1231_646); } 
arg1228_643 = 
MAKE_PAIR(arg1229_644, arg1230_645); } 
return 
PROCEDURE_ENTRY(e_631)(e_631, arg1228_643, e_631, BEOA);} }  else 
{ /* Eval/expanders.scm 228 */
FAILURE(string1636___install_expanders,string1633___install_expanders,x_630);} }  else 
{ /* Eval/expanders.scm 228 */
FAILURE(string1636___install_expanders,string1633___install_expanders,x_630);} } } } 
}



/* <anonymous:1189> */
obj_t _anonymous_1189__81___install_expanders(obj_t env_1630, obj_t x_1631, obj_t e_1632)
{ AN_OBJECT;
{ /* Eval/expanders.scm 215 */
{ 
obj_t x_596;obj_t e_597;
x_596 = x_1631; 
e_597 = e_1632; 
{ 
obj_t vars_599;obj_t call_600;obj_t exprs_601;
if(
PAIRP(x_596))
{ /* Eval/expanders.scm 215 */
obj_t cdr_190_184_606;
cdr_190_184_606 = 
CDR(x_596); 
if(
PAIRP(cdr_190_184_606))
{ /* Eval/expanders.scm 215 */
obj_t cdr_195_37_608;
cdr_195_37_608 = 
CDR(cdr_190_184_606); 
if(
PAIRP(cdr_195_37_608))
{ /* Eval/expanders.scm 215 */
vars_599 = 
CAR(cdr_190_184_606); 
call_600 = 
CAR(cdr_195_37_608); 
exprs_601 = 
CDR(cdr_195_37_608); 
{ /* Eval/expanders.scm 218 */
obj_t arg1196_613;
{ /* Eval/expanders.scm 218 */
obj_t arg1198_614;obj_t arg1201_615;
arg1198_614 = symbol1637___install_expanders; 
{ /* Eval/expanders.scm 218 */
obj_t arg1202_616;obj_t arg1204_617;
{ /* Eval/expanders.scm 218 */
obj_t arg1206_618;obj_t arg1207_619;
arg1206_618 = symbol1554___install_expanders; 
{ /* Eval/expanders.scm 218 */
obj_t arg1212_621;
arg1212_621 = 
MAKE_PAIR(call_600, BNIL); 
arg1207_619 = 
MAKE_PAIR(BNIL, arg1212_621); } 
arg1202_616 = 
MAKE_PAIR(arg1206_618, arg1207_619); } 
{ /* Eval/expanders.scm 219 */
obj_t arg1213_622;
{ /* Eval/expanders.scm 219 */
obj_t arg1215_624;obj_t arg1216_625;
arg1215_624 = symbol1554___install_expanders; 
{ /* ./Ieee/pair-list.scm 5721 */
obj_t aux_2007;
aux_2007 = 
append_2_18___r4_pairs_and_lists_6_3(exprs_601, BNIL); 
arg1216_625 = 
MAKE_PAIR(vars_599, aux_2007); } 
arg1213_622 = 
MAKE_PAIR(arg1215_624, arg1216_625); } 
arg1204_617 = 
MAKE_PAIR(arg1213_622, BNIL); } 
arg1201_615 = 
MAKE_PAIR(arg1202_616, arg1204_617); } 
arg1196_613 = 
MAKE_PAIR(arg1198_614, arg1201_615); } 
return 
PROCEDURE_ENTRY(e_597)(e_597, arg1196_613, e_597, BEOA);} }  else 
{ /* Eval/expanders.scm 215 */
FAILURE(string1638___install_expanders,string1633___install_expanders,x_596);} }  else 
{ /* Eval/expanders.scm 215 */
FAILURE(string1638___install_expanders,string1633___install_expanders,x_596);} }  else 
{ /* Eval/expanders.scm 215 */
FAILURE(string1638___install_expanders,string1633___install_expanders,x_596);} } } } 
}



/* <anonymous:1171> */
obj_t _anonymous_1171__198___install_expanders(obj_t env_1633, obj_t x_1634, obj_t e_1635)
{ AN_OBJECT;
{ /* Eval/expanders.scm 200 */
{ 
obj_t x_562;obj_t e_563;
x_562 = x_1634; 
e_563 = e_1635; 
{ 
obj_t body_565;obj_t exp_566;
if(
PAIRP(x_562))
{ /* Eval/expanders.scm 200 */
obj_t cdr_173_176_571;
cdr_173_176_571 = 
CDR(x_562); 
if(
PAIRP(cdr_173_176_571))
{ /* Eval/expanders.scm 200 */
body_565 = 
CAR(cdr_173_176_571); 
exp_566 = 
CDR(cdr_173_176_571); 
{ /* Eval/expanders.scm 203 */
obj_t arg1176_575;obj_t arg1177_576;
arg1176_575 = symbol1595___install_expanders; 
{ /* Eval/expanders.scm 204 */
obj_t arg1178_577;obj_t arg1179_578;
arg1178_577 = 
PROCEDURE_ENTRY(e_563)(e_563, body_565, e_563, BEOA); 
{ /* Eval/expanders.scm 205 */
obj_t arg1180_579;
if(
NULLP(exp_566))
{ /* Eval/expanders.scm 205 */
arg1180_579 = BNIL; }  else 
{ /* Eval/expanders.scm 205 */
obj_t head1009_583;
head1009_583 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t l1007_584;obj_t tail1010_585;
l1007_584 = exp_566; 
tail1010_585 = head1009_583; 
lname1008_586:
if(
NULLP(l1007_584))
{ /* Eval/expanders.scm 205 */
arg1180_579 = 
CDR(head1009_583); }  else 
{ /* Eval/expanders.scm 206 */
obj_t newtail1011_588;
{ /* Eval/expanders.scm 206 */
obj_t arg1185_590;
arg1185_590 = 
PROCEDURE_ENTRY(e_563)(e_563, 
CAR(l1007_584), e_563, BEOA); 
newtail1011_588 = 
MAKE_PAIR(arg1185_590, BNIL); } 
SET_CDR(tail1010_585, newtail1011_588); 
{ 
obj_t tail1010_2042;obj_t l1007_2040;
l1007_2040 = 
CDR(l1007_584); 
tail1010_2042 = newtail1011_588; 
tail1010_585 = tail1010_2042; 
l1007_584 = l1007_2040; 
goto lname1008_586;} } } } 
arg1179_578 = 
append_2_18___r4_pairs_and_lists_6_3(arg1180_579, BNIL); } 
arg1177_576 = 
MAKE_PAIR(arg1178_577, arg1179_578); } 
return 
MAKE_PAIR(arg1176_575, arg1177_576);} }  else 
{ /* Eval/expanders.scm 200 */
FAILURE(string1639___install_expanders,string1633___install_expanders,x_562);} }  else 
{ /* Eval/expanders.scm 200 */
FAILURE(string1639___install_expanders,string1633___install_expanders,x_562);} } } } 
}



/* <anonymous:1153> */
obj_t _anonymous_1153__38___install_expanders(obj_t env_1636, obj_t x_1637, obj_t e_1638)
{ AN_OBJECT;
{ /* Eval/expanders.scm 188 */
{ 
obj_t x_533;obj_t e_534;
x_533 = x_1637; 
e_534 = e_1638; 
if(
PAIRP(x_533))
{ /* Eval/expanders.scm 188 */
obj_t cdr_154_75_542;
cdr_154_75_542 = 
CDR(x_533); 
if(
PAIRP(cdr_154_75_542))
{ /* Eval/expanders.scm 188 */
obj_t car_157_166_544;obj_t cdr_158_238_545;
car_157_166_544 = 
CAR(cdr_154_75_542); 
cdr_158_238_545 = 
CDR(cdr_154_75_542); 
if(
PAIRP(car_157_166_544))
{ /* Eval/expanders.scm 188 */
bool_t test_2059;
{ /* ./Ieee/equiv.scm 4854 */
obj_t aux_2060;
aux_2060 = 
CDR(car_157_166_544); 
test_2059 = 
(aux_2060==BNIL); } 
if(test_2059)
{ /* Eval/expanders.scm 188 */
if(
(cdr_158_238_545==BNIL))
{ /* Eval/expanders.scm 188 */
FAILURE(string1640___install_expanders,string1633___install_expanders,x_533);}  else 
{ /* Eval/expanders.scm 191 */
obj_t arg1162_1186;obj_t arg1163_1187;
arg1162_1186 = symbol1593___install_expanders; 
{ /* Eval/expanders.scm 191 */
obj_t arg1164_1188;obj_t arg1165_1189;
{ /* ./Ieee/pair-list.scm 5721 */
obj_t aux_2066;
aux_2066 = 
CAR(car_157_166_544); 
arg1164_1188 = 
MAKE_PAIR(aux_2066, BNIL); } 
{ /* Eval/expanders.scm 192 */
obj_t arg1166_1190;
{ /* Eval/expanders.scm 192 */
obj_t arg1168_1192;
arg1168_1192 = 
normalize_progn_143___progn(cdr_158_238_545); 
arg1166_1190 = 
PROCEDURE_ENTRY(e_534)(e_534, arg1168_1192, e_534, BEOA); } 
arg1165_1189 = 
MAKE_PAIR(arg1166_1190, BNIL); } 
arg1163_1187 = 
MAKE_PAIR(arg1164_1188, arg1165_1189); } 
return 
MAKE_PAIR(arg1162_1186, arg1163_1187);} }  else 
{ /* Eval/expanders.scm 188 */
FAILURE(string1640___install_expanders,string1633___install_expanders,x_533);} }  else 
{ /* Eval/expanders.scm 188 */
FAILURE(string1640___install_expanders,string1633___install_expanders,x_533);} }  else 
{ /* Eval/expanders.scm 188 */
FAILURE(string1640___install_expanders,string1633___install_expanders,x_533);} }  else 
{ /* Eval/expanders.scm 188 */
FAILURE(string1640___install_expanders,string1633___install_expanders,x_533);} } } 
}



/* <anonymous:1131> */
obj_t _anonymous_1131__51___install_expanders(obj_t env_1639, obj_t x_1640, obj_t e_1641)
{ AN_OBJECT;
{ /* Eval/expanders.scm 176 */
{ 
obj_t x_500;obj_t e_501;
x_500 = x_1640; 
e_501 = e_1641; 
if(
PAIRP(x_500))
{ /* Eval/expanders.scm 176 */
obj_t cdr_130_105_510;
cdr_130_105_510 = 
CDR(x_500); 
if(
PAIRP(cdr_130_105_510))
{ /* Eval/expanders.scm 176 */
obj_t cdr_135_194_512;
cdr_135_194_512 = 
CDR(cdr_130_105_510); 
if(
PAIRP(cdr_135_194_512))
{ /* Eval/expanders.scm 176 */
obj_t cdr_140_144_514;
cdr_140_144_514 = 
CDR(cdr_135_194_512); 
if(
PAIRP(cdr_140_144_514))
{ /* Eval/expanders.scm 176 */
bool_t test_2090;
{ /* ./Ieee/equiv.scm 4854 */
obj_t aux_2091;
aux_2091 = 
CDR(cdr_140_144_514); 
test_2090 = 
(aux_2091==BNIL); } 
if(test_2090)
{ /* Eval/expanders.scm 179 */
obj_t arg1142_1119;obj_t arg1143_1120;
arg1142_1119 = symbol1591___install_expanders; 
{ /* Eval/expanders.scm 179 */
obj_t arg1144_1121;obj_t arg1145_1122;
arg1144_1121 = 
PROCEDURE_ENTRY(e_501)(e_501, 
CAR(cdr_130_105_510), e_501, BEOA); 
{ /* Eval/expanders.scm 180 */
obj_t arg1146_1123;obj_t arg1147_1124;
arg1146_1123 = 
PROCEDURE_ENTRY(e_501)(e_501, 
CAR(cdr_135_194_512), e_501, BEOA); 
{ /* Eval/expanders.scm 181 */
obj_t arg1148_1125;
arg1148_1125 = 
PROCEDURE_ENTRY(e_501)(e_501, 
CAR(cdr_140_144_514), e_501, BEOA); 
arg1147_1124 = 
MAKE_PAIR(arg1148_1125, BNIL); } 
arg1145_1122 = 
MAKE_PAIR(arg1146_1123, arg1147_1124); } 
arg1143_1120 = 
MAKE_PAIR(arg1144_1121, arg1145_1122); } 
return 
MAKE_PAIR(arg1142_1119, arg1143_1120);}  else 
{ /* Eval/expanders.scm 176 */
FAILURE(string1641___install_expanders,string1642___install_expanders,x_500);} }  else 
{ /* Eval/expanders.scm 176 */
FAILURE(string1641___install_expanders,string1642___install_expanders,x_500);} }  else 
{ /* Eval/expanders.scm 176 */
FAILURE(string1641___install_expanders,string1642___install_expanders,x_500);} }  else 
{ /* Eval/expanders.scm 176 */
FAILURE(string1641___install_expanders,string1642___install_expanders,x_500);} }  else 
{ /* Eval/expanders.scm 176 */
FAILURE(string1641___install_expanders,string1642___install_expanders,x_500);} } } 
}



/* <anonymous:1112> */
obj_t _anonymous_1112__24___install_expanders(obj_t env_1642, obj_t x_1643, obj_t e_1644)
{ AN_OBJECT;
{ /* Eval/expanders.scm 152 */
{ 
obj_t x_464;obj_t e_465;
x_464 = x_1643; 
e_465 = e_1644; 
{ 
obj_t body_467;
if(
PAIRP(x_464))
{ /* Eval/expanders.scm 152 */
body_467 = 
CDR(x_464); 
{ 
obj_t l_473;
l_473 = body_467; 
loop_474:
if(
NULLP(l_473))
{ /* Eval/expanders.scm 157 */
{ /* Eval/expanders.scm 158 */
obj_t new_476;
{ /* Eval/expanders.scm 158 */
obj_t arg1118_479;obj_t arg1119_480;
arg1118_479 = symbol1589___install_expanders; 
{ /* Eval/expanders.scm 159 */
obj_t arg1120_481;
if(
NULLP(body_467))
{ /* Eval/expanders.scm 159 */
arg1120_481 = BNIL; }  else 
{ /* Eval/expanders.scm 159 */
obj_t head1004_485;
head1004_485 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t l1002_486;obj_t tail1005_487;
l1002_486 = body_467; 
tail1005_487 = head1004_485; 
lname1003_488:
if(
NULLP(l1002_486))
{ /* Eval/expanders.scm 159 */
arg1120_481 = 
CDR(head1004_485); }  else 
{ /* Eval/expanders.scm 161 */
obj_t newtail1006_490;
{ /* Eval/expanders.scm 161 */
obj_t arg1125_492;
arg1125_492 = 
PROCEDURE_ENTRY(e_465)(e_465, 
CAR(l1002_486), e_465, BEOA); 
newtail1006_490 = 
MAKE_PAIR(arg1125_492, BNIL); } 
SET_CDR(tail1005_487, newtail1006_490); 
{ 
obj_t tail1005_2129;obj_t l1002_2127;
l1002_2127 = 
CDR(l1002_486); 
tail1005_2129 = newtail1006_490; 
tail1005_487 = tail1005_2129; 
l1002_486 = l1002_2127; 
goto lname1003_488;} } } } 
arg1119_480 = 
append_2_18___r4_pairs_and_lists_6_3(arg1120_481, BNIL); } 
new_476 = 
MAKE_PAIR(arg1118_479, arg1119_480); } 
{ /* ./Ieee/pair-list.scm 5922 */
obj_t aux_2132;
aux_2132 = 
CAR(new_476); 
SET_CAR(x_464, aux_2132); } 
{ /* ./Ieee/pair-list.scm 5928 */
obj_t aux_2135;
aux_2135 = 
CDR(new_476); 
SET_CDR(x_464, aux_2135); } 
return x_464;} }  else 
{ /* Eval/expanders.scm 157 */
if(
PAIRP(l_473))
{ /* Eval/expanders.scm 166 */
{ 
obj_t l_2140;
l_2140 = 
CDR(l_473); 
l_473 = l_2140; 
goto loop_474;} }  else 
{ /* Eval/expanders.scm 166 */
FAILURE(string1643___install_expanders,string1633___install_expanders,x_464);} } } }  else 
{ /* Eval/expanders.scm 152 */
FAILURE(string1643___install_expanders,string1633___install_expanders,x_464);} } } } 
}



/* <anonymous:1093> */
obj_t _anonymous_1093__137___install_expanders(obj_t env_1645, obj_t x_1646, obj_t e_1647)
{ AN_OBJECT;
{ /* Eval/expanders.scm 134 */
{ 
obj_t x_437;obj_t e_438;
x_437 = x_1646; 
e_438 = e_1647; 
{ 
obj_t exp_440;
if(
PAIRP(x_437))
{ /* Eval/expanders.scm 134 */
obj_t cdr_107_0_445;
cdr_107_0_445 = 
CDR(x_437); 
if(
PAIRP(cdr_107_0_445))
{ /* Eval/expanders.scm 134 */
bool_t test_2150;
{ /* ./Ieee/equiv.scm 4854 */
obj_t aux_2151;
aux_2151 = 
CDR(cdr_107_0_445); 
test_2150 = 
(aux_2151==BNIL); } 
if(test_2150)
{ /* Eval/expanders.scm 134 */
exp_440 = 
CAR(cdr_107_0_445); 
{ /* Eval/expanders.scm 137 */
obj_t arg1100_451;obj_t arg1101_452;
arg1100_451 = symbol1644___install_expanders; 
{ /* Eval/expanders.scm 137 */
obj_t arg1102_453;
{ /* Eval/expanders.scm 137 */
obj_t arg1104_455;obj_t arg1105_456;
arg1104_455 = symbol1554___install_expanders; 
{ /* Eval/expanders.scm 137 */
obj_t arg1107_458;
{ /* Eval/expanders.scm 137 */
obj_t arg1108_459;
arg1108_459 = 
PROCEDURE_ENTRY(e_438)(e_438, exp_440, e_438, BEOA); 
arg1107_458 = 
MAKE_PAIR(arg1108_459, BNIL); } 
arg1105_456 = 
MAKE_PAIR(BNIL, arg1107_458); } 
arg1102_453 = 
MAKE_PAIR(arg1104_455, arg1105_456); } 
arg1101_452 = 
MAKE_PAIR(arg1102_453, BNIL); } 
return 
MAKE_PAIR(arg1100_451, arg1101_452);} }  else 
{ /* Eval/expanders.scm 134 */
FAILURE(string1645___install_expanders,string1633___install_expanders,x_437);} }  else 
{ /* Eval/expanders.scm 134 */
FAILURE(string1645___install_expanders,string1633___install_expanders,x_437);} }  else 
{ /* Eval/expanders.scm 134 */
FAILURE(string1645___install_expanders,string1633___install_expanders,x_437);} } } } 
}



/* <anonymous:1089> */
obj_t _anonymous_1089__9___install_expanders(obj_t env_1648, obj_t x_1649, obj_t e_1650)
{ AN_OBJECT;
{ /* Eval/expanders.scm 130 */
{ 
obj_t x_430;obj_t e_431;
x_430 = x_1649; 
e_431 = e_1650; 
{ /* Eval/expanders.scm 131 */
obj_t arg1090_1040;
arg1090_1040 = 
expand_define_pattern_97___eval(x_430); 
return 
PROCEDURE_ENTRY(e_431)(e_431, arg1090_1040, e_431, BEOA);} } } 
}



/* <anonymous:1085> */
obj_t _anonymous_1085__120___install_expanders(obj_t env_1651, obj_t x_1652, obj_t e_1653)
{ AN_OBJECT;
{ /* Eval/expanders.scm 126 */
{ 
obj_t x_423;obj_t e_424;
x_423 = x_1652; 
e_424 = e_1653; 
{ /* Eval/expanders.scm 127 */
obj_t arg1086_1039;
arg1086_1039 = 
expand_match_lambda_130___match_expand(x_423); 
return 
PROCEDURE_ENTRY(e_424)(e_424, arg1086_1039, e_424, BEOA);} } } 
}



/* <anonymous:1081> */
obj_t _anonymous_1081__163___install_expanders(obj_t env_1654, obj_t x_1655, obj_t e_1656)
{ AN_OBJECT;
{ /* Eval/expanders.scm 123 */
{ 
obj_t x_416;obj_t e_417;
x_416 = x_1655; 
e_417 = e_1656; 
{ /* Eval/expanders.scm 123 */
obj_t arg1082_1038;
arg1082_1038 = 
expand_match_case_143___match_expand(x_416); 
return 
PROCEDURE_ENTRY(e_417)(e_417, arg1082_1038, e_417, BEOA);} } } 
}



/* <anonymous:1078> */
obj_t _anonymous_1078__34___install_expanders(obj_t env_1657, obj_t x_1658, obj_t e_1659)
{ AN_OBJECT;
{ /* Eval/expanders.scm 120 */
{ /* Eval/expanders.scm 120 */
obj_t x_1718;obj_t e_1719;
x_1718 = x_1658; 
e_1719 = e_1659; 
return 
expand_try_212___expander_try(x_1718, e_1719);} } 
}



/* <anonymous:1075> */
obj_t _anonymous_1075__203___install_expanders(obj_t env_1660, obj_t x_1661, obj_t e_1662)
{ AN_OBJECT;
{ /* Eval/expanders.scm 117 */
{ /* Eval/expanders.scm 117 */
obj_t x_1720;obj_t e_1721;
x_1720 = x_1661; 
e_1721 = e_1662; 
return 
expand_do_31___expander_do(x_1720, e_1721);} } 
}



/* <anonymous:1071> */
obj_t _anonymous_1071__94___install_expanders(obj_t env_1663, obj_t x_1664, obj_t e_1665)
{ AN_OBJECT;
{ /* Eval/expanders.scm 114 */
{ 
obj_t x_397;obj_t e_398;
x_397 = x_1664; 
e_398 = e_1665; 
{ /* Eval/expanders.scm 114 */
obj_t arg1072_1037;
arg1072_1037 = 
expand_cond_95___expander_bool(x_397); 
return 
PROCEDURE_ENTRY(e_398)(e_398, arg1072_1037, e_398, BEOA);} } } 
}



/* <anonymous:1067> */
obj_t _anonymous_1067__239___install_expanders(obj_t env_1666, obj_t x_1667, obj_t e_1668)
{ AN_OBJECT;
{ /* Eval/expanders.scm 111 */
{ 
obj_t x_390;obj_t e_391;
x_390 = x_1667; 
e_391 = e_1668; 
{ /* Eval/expanders.scm 111 */
obj_t arg1068_1036;
arg1068_1036 = 
expand_and_10___expander_bool(x_390); 
return 
PROCEDURE_ENTRY(e_391)(e_391, arg1068_1036, e_391, BEOA);} } } 
}



/* <anonymous:1063> */
obj_t _anonymous_1063__74___install_expanders(obj_t env_1669, obj_t x_1670, obj_t e_1671)
{ AN_OBJECT;
{ /* Eval/expanders.scm 108 */
{ 
obj_t x_383;obj_t e_384;
x_383 = x_1670; 
e_384 = e_1671; 
{ /* Eval/expanders.scm 108 */
obj_t arg1064_1035;
arg1064_1035 = 
expand_or_72___expander_bool(x_383); 
return 
PROCEDURE_ENTRY(e_384)(e_384, arg1064_1035, e_384, BEOA);} } } 
}



/* <anonymous:1056> */
obj_t _anonymous_1056__181___install_expanders(obj_t env_1672, obj_t x_1673, obj_t e_1674)
{ AN_OBJECT;
{ /* Eval/expanders.scm 103 */
{ /* Eval/expanders.scm 104 */
obj_t x_1722;obj_t e_1723;
x_1722 = x_1673; 
e_1723 = e_1674; 
return 
expand_define_expander_27___eval(x_1722, e_1723);} } 
}



/* <anonymous:1052> */
obj_t _anonymous_1052__39___install_expanders(obj_t env_1675, obj_t x_1676, obj_t e_1677)
{ AN_OBJECT;
{ /* Eval/expanders.scm 99 */
{ /* Eval/expanders.scm 100 */
obj_t x_1724;obj_t e_1725;
x_1724 = x_1676; 
e_1725 = e_1677; 
return 
expand_define_hygien_macro_18___eval(x_1724, e_1725);} } 
}



/* <anonymous:1049> */
obj_t _anonymous_1049__145___install_expanders(obj_t env_1678, obj_t x_1679, obj_t e_1680)
{ AN_OBJECT;
{ /* Eval/expanders.scm 95 */
{ /* Eval/expanders.scm 96 */
obj_t x_1726;obj_t e_1727;
x_1726 = x_1679; 
e_1727 = e_1680; 
return 
expand_define_macro_35___eval(x_1726, e_1727);} } 
}



/* <anonymous:1045> */
obj_t _anonymous_1045__125___install_expanders(obj_t env_1681, obj_t x_1682, obj_t e_1683)
{ AN_OBJECT;
{ /* Eval/expanders.scm 92 */
{ 
obj_t x_358;obj_t e_359;
x_358 = x_1682; 
e_359 = e_1683; 
{ /* Eval/expanders.scm 92 */
obj_t arg1046_1034;
arg1046_1034 = 
quasiquotation___expander_quote(
BINT(((long)1)), x_358); 
return 
PROCEDURE_ENTRY(e_359)(e_359, arg1046_1034, e_359, BEOA);} } } 
}



/* <anonymous:1042> */
obj_t _anonymous_1042__177___install_expanders(obj_t env_1684, obj_t x_1685, obj_t e_1686)
{ AN_OBJECT;
{ /* Eval/expanders.scm 89 */
{ /* Eval/expanders.scm 89 */
obj_t x_1728;obj_t e_1729;
x_1728 = x_1685; 
e_1729 = e_1686; 
return 
expand_quote_117___expander_quote(x_1728, e_1729);} } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___install_expanders()
{ AN_OBJECT;
{ /* Eval/expanders.scm 14 */
module_initialization_70___error(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___macro(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___expander_quote(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___expander_let(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___expander_bool(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___expander_case(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___expander_define(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___expander_do(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___expander_try(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___expander_struct(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___expander_srfi_0_86(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___eval(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___progn(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___lalr_expand(((long)0), "__INSTALL_EXPANDERS"); 
module_initialization_70___rgc_expand(((long)0), "__INSTALL_EXPANDERS"); 
return 
module_initialization_70___match_expand(((long)0), "__INSTALL_EXPANDERS");} 
}

