/*===========================================================================*/
/*   (Eval/expd-struct.scm)                                                  */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

static obj_t list1588___expander_struct = BUNSPEC;
static obj_t list1587___expander_struct = BUNSPEC;
extern obj_t string_to_symbol(char *);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t list1555___expander_struct = BUNSPEC;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t expand_eval_define_struct_250___expander_struct(obj_t, obj_t);
static obj_t _expand_eval_define_struct_219___expander_struct(obj_t, obj_t, obj_t);
extern obj_t match_define_structure__81___match_normalize(obj_t);
extern obj_t module_initialization_70___expander_struct(long, char *);
extern obj_t module_initialization_70___progn(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___bigloo(long, char *);
extern obj_t module_initialization_70___tvector(long, char *);
extern obj_t module_initialization_70___structure(long, char *);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___match_normalize(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_flonum(long, char *);
extern obj_t module_initialization_70___r4_characters_6_6(long, char *);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___r4_booleans_6_1(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_input_6_10_2(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
extern obj_t module_initialization_70___r4_ports_6_10_1(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern long list_length(obj_t);
static obj_t imported_modules_init_94___expander_struct();
static obj_t require_initialization_114___expander_struct = BUNSPEC;
static obj_t symbol1589___expander_struct = BUNSPEC;
static obj_t symbol1585___expander_struct = BUNSPEC;
static obj_t cnst_init_137___expander_struct();
static obj_t symbol1584___expander_struct = BUNSPEC;
static obj_t symbol1582___expander_struct = BUNSPEC;
static obj_t symbol1581___expander_struct = BUNSPEC;
static obj_t symbol1579___expander_struct = BUNSPEC;
static obj_t symbol1580___expander_struct = BUNSPEC;
static obj_t symbol1578___expander_struct = BUNSPEC;
static obj_t symbol1577___expander_struct = BUNSPEC;
static obj_t symbol1576___expander_struct = BUNSPEC;
static obj_t symbol1575___expander_struct = BUNSPEC;
static obj_t symbol1574___expander_struct = BUNSPEC;
static obj_t symbol1573___expander_struct = BUNSPEC;
static obj_t symbol1572___expander_struct = BUNSPEC;
static obj_t symbol1569___expander_struct = BUNSPEC;
static obj_t symbol1568___expander_struct = BUNSPEC;
static obj_t symbol1566___expander_struct = BUNSPEC;
static obj_t symbol1565___expander_struct = BUNSPEC;
static obj_t symbol1564___expander_struct = BUNSPEC;
static obj_t symbol1563___expander_struct = BUNSPEC;
static obj_t symbol1562___expander_struct = BUNSPEC;
static obj_t symbol1561___expander_struct = BUNSPEC;
static obj_t symbol1559___expander_struct = BUNSPEC;
static obj_t symbol1560___expander_struct = BUNSPEC;
static obj_t symbol1558___expander_struct = BUNSPEC;
static obj_t symbol1557___expander_struct = BUNSPEC;
static obj_t symbol1556___expander_struct = BUNSPEC;
static obj_t *__cnst;

DEFINE_STRING( string1586___expander_struct, string1586___expander_struct1591, "struct-set!:not an instance of", 30 );
DEFINE_STRING( string1583___expander_struct, string1583___expander_struct1592, "struct-ref:not an instance of", 29 );
DEFINE_STRING( string1571___expander_struct, string1571___expander_struct1593, "Type `extended pair' expected for expression", 44 );
DEFINE_STRING( string1570___expander_struct, string1570___expander_struct1594, "cer", 3 );
DEFINE_STRING( string1567___expander_struct, string1567___expander_struct1595, "Too many argument provided", 26 );
DEFINE_STRING( string1554___expander_struct, string1554___expander_struct1596, "Illegal `define-struct' form", 28 );
DEFINE_STRING( string1553___expander_struct, string1553___expander_struct1597, "define-struct", 13 );
DEFINE_EXPORT_PROCEDURE( expand_eval_define_struct_env_150___expander_struct, _expand_eval_define_struct_219___expander_struct1598, _expand_eval_define_struct_219___expander_struct, 0L, 2 );



/* module-initialization */
obj_t module_initialization_70___expander_struct(long checksum_1383, char * from_1384)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___expander_struct))
{ 
require_initialization_114___expander_struct = 
BBOOL(((bool_t)0)); 
cnst_init_137___expander_struct(); 
imported_modules_init_94___expander_struct(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___expander_struct()
{ AN_OBJECT;
{ /* Eval/expd-struct.scm 14 */
symbol1556___expander_struct = 
string_to_symbol("QUOTE"); 
{ /* Eval/expd-struct.scm 73 */
obj_t aux_1391;
aux_1391 = 
MAKE_PAIR(BNIL, BNIL); 
list1555___expander_struct = 
MAKE_PAIR(symbol1556___expander_struct, aux_1391); } 
symbol1557___expander_struct = 
string_to_symbol("BEGIN"); 
symbol1558___expander_struct = 
string_to_symbol("DEFINE-INLINE"); 
symbol1559___expander_struct = 
string_to_symbol("MAKE-"); 
symbol1560___expander_struct = 
string_to_symbol("INIT"); 
symbol1561___expander_struct = 
string_to_symbol("IF"); 
symbol1562___expander_struct = 
string_to_symbol("PAIR?"); 
symbol1563___expander_struct = 
string_to_symbol("NOT"); 
symbol1564___expander_struct = 
string_to_symbol("NULL?"); 
symbol1565___expander_struct = 
string_to_symbol("CDR"); 
symbol1566___expander_struct = 
string_to_symbol("ERROR"); 
symbol1568___expander_struct = 
string_to_symbol("MAKE-STRUCT"); 
symbol1569___expander_struct = 
string_to_symbol("CAR"); 
symbol1572___expander_struct = 
string_to_symbol("LET"); 
symbol1573___expander_struct = 
string_to_symbol("NEW"); 
symbol1574___expander_struct = 
string_to_symbol("-"); 
symbol1575___expander_struct = 
string_to_symbol("-SET!"); 
symbol1576___expander_struct = 
string_to_symbol("?"); 
symbol1577___expander_struct = 
string_to_symbol("O"); 
symbol1578___expander_struct = 
string_to_symbol("STRUCT?"); 
symbol1579___expander_struct = 
string_to_symbol("EQ?"); 
symbol1580___expander_struct = 
string_to_symbol("STRUCT-KEY"); 
symbol1581___expander_struct = 
string_to_symbol("S"); 
symbol1582___expander_struct = 
string_to_symbol("STRUCT-REF"); 
symbol1584___expander_struct = 
string_to_symbol("V"); 
symbol1585___expander_struct = 
string_to_symbol("STRUCT-SET!"); 
symbol1589___expander_struct = 
string_to_symbol("UNSPECIFIED"); 
list1588___expander_struct = 
MAKE_PAIR(symbol1589___expander_struct, BNIL); 
return ( 
list1587___expander_struct = 
MAKE_PAIR(list1588___expander_struct, BNIL), BUNSPEC) ;} 
}



/* expand-eval-define-struct */
obj_t expand_eval_define_struct_250___expander_struct(obj_t x_1, obj_t e_2)
{ AN_OBJECT;
{ /* Eval/expd-struct.scm 50 */
{ 
obj_t name_326;obj_t slots_327;
if(
PAIRP(x_1))
{ /* Eval/expd-struct.scm 51 */
obj_t cdr_109_69_332;
cdr_109_69_332 = 
CDR(x_1); 
if(
PAIRP(cdr_109_69_332))
{ /* Eval/expd-struct.scm 51 */
name_326 = 
CAR(cdr_109_69_332); 
slots_327 = 
CDR(cdr_109_69_332); 
match_define_structure__81___match_normalize(x_1); 
{ /* Eval/expd-struct.scm 54 */
long len_336;
len_336 = 
list_length(slots_327); 
{ /* Eval/expd-struct.scm 54 */
obj_t slots_name_121_337;
if(
NULLP(slots_327))
{ /* Eval/expd-struct.scm 55 */
slots_name_121_337 = BNIL; }  else 
{ /* Eval/expd-struct.scm 55 */
obj_t head1004_676;
head1004_676 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t l1002_677;obj_t tail1005_678;
l1002_677 = slots_327; 
tail1005_678 = head1004_676; 
lname1003_679:
if(
NULLP(l1002_677))
{ /* Eval/expd-struct.scm 55 */
slots_name_121_337 = 
CDR(head1004_676); }  else 
{ /* Eval/expd-struct.scm 56 */
obj_t newtail1006_681;
{ /* Eval/expd-struct.scm 56 */
obj_t arg1389_683;
{ /* Eval/expd-struct.scm 56 */
obj_t s_685;
s_685 = 
CAR(l1002_677); 
if(
PAIRP(s_685))
{ /* Eval/expd-struct.scm 56 */
obj_t cdr_125_100_693;
cdr_125_100_693 = 
CDR(s_685); 
if(
PAIRP(cdr_125_100_693))
{ /* Eval/expd-struct.scm 56 */
bool_t test_1441;
{ /* ./Ieee/equiv.scm 2702 */
obj_t aux_1442;
aux_1442 = 
CDR(cdr_125_100_693); 
test_1441 = 
(aux_1442==BNIL); } 
if(test_1441)
{ /* Eval/expd-struct.scm 56 */
arg1389_683 = 
CAR(s_685); }  else 
{ /* Eval/expd-struct.scm 56 */
if(
SYMBOLP(s_685))
{ /* Eval/expd-struct.scm 56 */
arg1389_683 = s_685; }  else 
{ /* Eval/expd-struct.scm 56 */
FAILURE(string1553___expander_struct,string1554___expander_struct,x_1);} } }  else 
{ /* Eval/expd-struct.scm 56 */
if(
SYMBOLP(s_685))
{ /* Eval/expd-struct.scm 56 */
arg1389_683 = s_685; }  else 
{ /* Eval/expd-struct.scm 56 */
FAILURE(string1553___expander_struct,string1554___expander_struct,x_1);} } }  else 
{ /* Eval/expd-struct.scm 56 */
if(
SYMBOLP(s_685))
{ /* Eval/expd-struct.scm 56 */
arg1389_683 = s_685; }  else 
{ /* Eval/expd-struct.scm 56 */
FAILURE(string1553___expander_struct,string1554___expander_struct,x_1);} } } 
newtail1006_681 = 
MAKE_PAIR(arg1389_683, BNIL); } 
SET_CDR(tail1005_678, newtail1006_681); 
{ 
obj_t tail1005_1459;obj_t l1002_1457;
l1002_1457 = 
CDR(l1002_677); 
tail1005_1459 = newtail1006_681; 
tail1005_678 = tail1005_1459; 
l1002_677 = l1002_1457; 
goto lname1003_679;} } } } 
{ /* Eval/expd-struct.scm 55 */
bool_t slots_val__167_338;
slots_val__167_338 = ((bool_t)0); 
{ /* Eval/expd-struct.scm 66 */
obj_t slots_val_6_339;
if(
NULLP(slots_327))
{ /* Eval/expd-struct.scm 67 */
slots_val_6_339 = BNIL; }  else 
{ /* Eval/expd-struct.scm 67 */
obj_t head1009_649;
head1009_649 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t l1007_650;obj_t tail1010_651;
l1007_650 = slots_327; 
tail1010_651 = head1009_649; 
lname1008_652:
if(
NULLP(l1007_650))
{ /* Eval/expd-struct.scm 67 */
slots_val_6_339 = 
CDR(head1009_649); }  else 
{ /* Eval/expd-struct.scm 68 */
obj_t newtail1011_654;
{ /* Eval/expd-struct.scm 68 */
obj_t arg1373_656;
{ /* Eval/expd-struct.scm 68 */
obj_t s_658;
s_658 = 
CAR(l1007_650); 
if(
PAIRP(s_658))
{ /* Eval/expd-struct.scm 68 */
obj_t cdr_138_77_665;
cdr_138_77_665 = 
CDR(s_658); 
if(
PAIRP(cdr_138_77_665))
{ /* Eval/expd-struct.scm 68 */
bool_t test_1472;
{ /* ./Ieee/equiv.scm 2702 */
obj_t aux_1473;
aux_1473 = 
CDR(cdr_138_77_665); 
test_1472 = 
(aux_1473==BNIL); } 
if(test_1472)
{ /* Eval/expd-struct.scm 68 */
slots_val__167_338 = ((bool_t)1); 
arg1373_656 = 
CAR(cdr_138_77_665); }  else 
{ /* Eval/expd-struct.scm 68 */
if(
SYMBOLP(s_658))
{ /* Eval/expd-struct.scm 68 */
arg1373_656 = list1555___expander_struct; }  else 
{ /* Eval/expd-struct.scm 68 */
FAILURE(string1553___expander_struct,string1554___expander_struct,x_1);} } }  else 
{ /* Eval/expd-struct.scm 68 */
if(
SYMBOLP(s_658))
{ /* Eval/expd-struct.scm 68 */
arg1373_656 = list1555___expander_struct; }  else 
{ /* Eval/expd-struct.scm 68 */
FAILURE(string1553___expander_struct,string1554___expander_struct,x_1);} } }  else 
{ /* Eval/expd-struct.scm 68 */
if(
SYMBOLP(s_658))
{ /* Eval/expd-struct.scm 68 */
arg1373_656 = list1555___expander_struct; }  else 
{ /* Eval/expd-struct.scm 68 */
FAILURE(string1553___expander_struct,string1554___expander_struct,x_1);} } } 
newtail1011_654 = 
MAKE_PAIR(arg1373_656, BNIL); } 
SET_CDR(tail1010_651, newtail1011_654); 
{ 
obj_t tail1010_1490;obj_t l1007_1488;
l1007_1488 = 
CDR(l1007_650); 
tail1010_1490 = newtail1011_654; 
tail1010_651 = tail1010_1490; 
l1007_650 = l1007_1488; 
goto lname1008_652;} } } } 
{ /* Eval/expd-struct.scm 67 */

{ /* Eval/expd-struct.scm 80 */
obj_t arg1020_340;obj_t arg1021_341;
arg1020_340 = symbol1557___expander_struct; 
{ /* Eval/expd-struct.scm 84 */
obj_t arg1022_342;obj_t arg1023_343;
{ /* Eval/expd-struct.scm 84 */
obj_t arg1024_344;
{ /* Eval/expd-struct.scm 84 */
obj_t arg1025_345;
{ /* Eval/expd-struct.scm 84 */
obj_t arg1026_346;obj_t arg1027_347;
arg1026_346 = symbol1558___expander_struct; 
{ /* Eval/expd-struct.scm 84 */
obj_t arg1028_348;obj_t arg1029_349;
{ /* Eval/expd-struct.scm 84 */
obj_t arg1030_350;obj_t arg1031_351;
{ /* Eval/expd-struct.scm 84 */
obj_t list1032_352;
{ /* Eval/expd-struct.scm 84 */
obj_t arg1033_353;obj_t arg1034_354;
arg1033_353 = symbol1559___expander_struct; 
arg1034_354 = 
MAKE_PAIR(name_326, BNIL); 
list1032_352 = 
MAKE_PAIR(arg1033_353, arg1034_354); } 
arg1030_350 = 
symbol_append_197___r4_symbols_6_4(list1032_352); } 
arg1031_351 = symbol1560___expander_struct; 
arg1028_348 = 
MAKE_PAIR(arg1030_350, arg1031_351); } 
{ /* Eval/expd-struct.scm 85 */
obj_t arg1035_355;
if(slots_val__167_338)
{ /* Eval/expd-struct.scm 86 */
obj_t arg1038_357;obj_t arg1039_358;
arg1038_357 = symbol1561___expander_struct; 
{ /* Eval/expd-struct.scm 86 */
obj_t arg1040_359;obj_t arg1041_360;
{ /* Eval/expd-struct.scm 86 */
obj_t arg1043_361;obj_t arg1044_362;
arg1043_361 = symbol1562___expander_struct; 
arg1044_362 = 
MAKE_PAIR(symbol1560___expander_struct, BNIL); 
arg1040_359 = 
MAKE_PAIR(arg1043_361, arg1044_362); } 
{ /* Eval/expd-struct.scm 87 */
obj_t arg1045_363;obj_t arg1046_364;
{ /* Eval/expd-struct.scm 87 */
obj_t arg1047_365;obj_t arg1048_366;
arg1047_365 = symbol1561___expander_struct; 
{ /* Eval/expd-struct.scm 87 */
obj_t arg1049_367;obj_t arg1050_368;
{ /* Eval/expd-struct.scm 87 */
obj_t arg1051_369;obj_t arg1052_370;
arg1051_369 = symbol1563___expander_struct; 
{ /* Eval/expd-struct.scm 87 */
obj_t arg1054_371;
{ /* Eval/expd-struct.scm 87 */
obj_t arg1061_373;obj_t arg1062_374;
arg1061_373 = symbol1564___expander_struct; 
{ /* Eval/expd-struct.scm 87 */
obj_t arg1063_375;
{ /* Eval/expd-struct.scm 87 */
obj_t arg1065_377;obj_t arg1066_378;
arg1065_377 = symbol1565___expander_struct; 
arg1066_378 = 
MAKE_PAIR(symbol1560___expander_struct, BNIL); 
arg1063_375 = 
MAKE_PAIR(arg1065_377, arg1066_378); } 
arg1062_374 = 
MAKE_PAIR(arg1063_375, BNIL); } 
arg1054_371 = 
MAKE_PAIR(arg1061_373, arg1062_374); } 
arg1052_370 = 
MAKE_PAIR(arg1054_371, BNIL); } 
arg1049_367 = 
MAKE_PAIR(arg1051_369, arg1052_370); } 
{ /* Eval/expd-struct.scm 88 */
obj_t arg1067_379;obj_t arg1068_380;
{ /* Eval/expd-struct.scm 88 */
obj_t arg1069_381;obj_t arg1070_382;
arg1069_381 = symbol1566___expander_struct; 
{ /* Eval/expd-struct.scm 88 */
obj_t arg1071_383;obj_t arg1072_384;
{ /* Eval/expd-struct.scm 88 */
obj_t arg1073_385;obj_t arg1074_386;
arg1073_385 = symbol1556___expander_struct; 
{ /* Eval/expd-struct.scm 88 */
obj_t arg1075_387;
{ /* Eval/expd-struct.scm 88 */
obj_t list1077_389;
{ /* Eval/expd-struct.scm 88 */
obj_t arg1078_390;obj_t arg1079_391;
arg1078_390 = symbol1559___expander_struct; 
arg1079_391 = 
MAKE_PAIR(name_326, BNIL); 
list1077_389 = 
MAKE_PAIR(arg1078_390, arg1079_391); } 
arg1075_387 = 
symbol_append_197___r4_symbols_6_4(list1077_389); } 
arg1074_386 = 
MAKE_PAIR(arg1075_387, BNIL); } 
arg1071_383 = 
MAKE_PAIR(arg1073_385, arg1074_386); } 
{ /* Eval/expd-struct.scm 88 */
obj_t arg1081_393;
arg1081_393 = 
MAKE_PAIR(symbol1560___expander_struct, BNIL); 
arg1072_384 = 
MAKE_PAIR(string1567___expander_struct, arg1081_393); } 
arg1070_382 = 
MAKE_PAIR(arg1071_383, arg1072_384); } 
arg1067_379 = 
MAKE_PAIR(arg1069_381, arg1070_382); } 
{ /* Eval/expd-struct.scm 91 */
obj_t arg1082_394;
{ /* Eval/expd-struct.scm 91 */
obj_t arg1084_396;obj_t arg1085_397;
arg1084_396 = symbol1568___expander_struct; 
{ /* Eval/expd-struct.scm 91 */
obj_t arg1086_398;obj_t arg1087_399;
{ /* Eval/expd-struct.scm 91 */
obj_t arg1088_400;obj_t arg1089_401;
arg1088_400 = symbol1556___expander_struct; 
arg1089_401 = 
MAKE_PAIR(name_326, BNIL); 
arg1086_398 = 
MAKE_PAIR(arg1088_400, arg1089_401); } 
{ /* Eval/expd-struct.scm 91 */
obj_t arg1090_402;
{ /* Eval/expd-struct.scm 91 */
obj_t arg1091_403;
{ /* Eval/expd-struct.scm 91 */
obj_t arg1093_405;obj_t arg1094_406;
arg1093_405 = symbol1569___expander_struct; 
arg1094_406 = 
MAKE_PAIR(symbol1560___expander_struct, BNIL); 
arg1091_403 = 
MAKE_PAIR(arg1093_405, arg1094_406); } 
arg1090_402 = 
MAKE_PAIR(arg1091_403, BNIL); } 
{ /* ./Ieee/pair-list.scm 3569 */
obj_t aux_1518;
aux_1518 = 
BINT(len_336); 
arg1087_399 = 
MAKE_PAIR(aux_1518, arg1090_402); } } 
arg1085_397 = 
MAKE_PAIR(arg1086_398, arg1087_399); } 
arg1082_394 = 
MAKE_PAIR(arg1084_396, arg1085_397); } 
arg1068_380 = 
MAKE_PAIR(arg1082_394, BNIL); } 
arg1050_368 = 
MAKE_PAIR(arg1067_379, arg1068_380); } 
arg1048_366 = 
MAKE_PAIR(arg1049_367, arg1050_368); } 
arg1045_363 = 
MAKE_PAIR(arg1047_365, arg1048_366); } 
{ /* Eval/expd-struct.scm 92 */
obj_t arg1095_407;
{ /* ./Ieee/pair-list.scm 3569 */
obj_t aux_1527;
aux_1527 = 
append_2_18___r4_pairs_and_lists_6_3(slots_val_6_339, BNIL); 
arg1095_407 = 
MAKE_PAIR(name_326, aux_1527); } 
arg1046_364 = 
MAKE_PAIR(arg1095_407, BNIL); } 
arg1041_360 = 
MAKE_PAIR(arg1045_363, arg1046_364); } 
arg1039_358 = 
MAKE_PAIR(arg1040_359, arg1041_360); } 
arg1035_355 = 
MAKE_PAIR(arg1038_357, arg1039_358); }  else 
{ /* Eval/expd-struct.scm 93 */
obj_t arg1098_410;obj_t arg1099_411;
arg1098_410 = symbol1561___expander_struct; 
{ /* Eval/expd-struct.scm 93 */
obj_t arg1100_412;obj_t arg1101_413;
{ /* Eval/expd-struct.scm 93 */
obj_t arg1102_414;obj_t arg1103_415;
arg1102_414 = symbol1562___expander_struct; 
arg1103_415 = 
MAKE_PAIR(symbol1560___expander_struct, BNIL); 
arg1100_412 = 
MAKE_PAIR(arg1102_414, arg1103_415); } 
{ /* Eval/expd-struct.scm 94 */
obj_t arg1104_416;obj_t arg1105_417;
{ /* Eval/expd-struct.scm 94 */
obj_t arg1106_418;obj_t arg1107_419;
arg1106_418 = symbol1561___expander_struct; 
{ /* Eval/expd-struct.scm 94 */
obj_t arg1108_420;obj_t arg1109_421;
{ /* Eval/expd-struct.scm 94 */
obj_t arg1110_422;obj_t arg1111_423;
arg1110_422 = symbol1563___expander_struct; 
{ /* Eval/expd-struct.scm 94 */
obj_t arg1112_424;
{ /* Eval/expd-struct.scm 94 */
obj_t arg1114_426;obj_t arg1115_427;
arg1114_426 = symbol1564___expander_struct; 
{ /* Eval/expd-struct.scm 94 */
obj_t arg1116_428;
{ /* Eval/expd-struct.scm 94 */
obj_t arg1118_430;obj_t arg1119_431;
arg1118_430 = symbol1565___expander_struct; 
arg1119_431 = 
MAKE_PAIR(symbol1560___expander_struct, BNIL); 
arg1116_428 = 
MAKE_PAIR(arg1118_430, arg1119_431); } 
arg1115_427 = 
MAKE_PAIR(arg1116_428, BNIL); } 
arg1112_424 = 
MAKE_PAIR(arg1114_426, arg1115_427); } 
arg1111_423 = 
MAKE_PAIR(arg1112_424, BNIL); } 
arg1108_420 = 
MAKE_PAIR(arg1110_422, arg1111_423); } 
{ /* Eval/expd-struct.scm 95 */
obj_t arg1120_432;obj_t arg1121_433;
{ /* Eval/expd-struct.scm 95 */
obj_t arg1122_434;obj_t arg1123_435;
arg1122_434 = symbol1566___expander_struct; 
{ /* Eval/expd-struct.scm 95 */
obj_t arg1124_436;obj_t arg1125_437;
{ /* Eval/expd-struct.scm 95 */
obj_t arg1126_438;obj_t arg1127_439;
arg1126_438 = symbol1556___expander_struct; 
{ /* Eval/expd-struct.scm 95 */
obj_t arg1128_440;
{ /* Eval/expd-struct.scm 95 */
obj_t list1130_442;
{ /* Eval/expd-struct.scm 95 */
obj_t arg1131_443;obj_t arg1132_444;
arg1131_443 = symbol1559___expander_struct; 
arg1132_444 = 
MAKE_PAIR(name_326, BNIL); 
list1130_442 = 
MAKE_PAIR(arg1131_443, arg1132_444); } 
arg1128_440 = 
symbol_append_197___r4_symbols_6_4(list1130_442); } 
arg1127_439 = 
MAKE_PAIR(arg1128_440, BNIL); } 
arg1124_436 = 
MAKE_PAIR(arg1126_438, arg1127_439); } 
{ /* Eval/expd-struct.scm 95 */
obj_t arg1134_446;
arg1134_446 = 
MAKE_PAIR(symbol1560___expander_struct, BNIL); 
arg1125_437 = 
MAKE_PAIR(string1567___expander_struct, arg1134_446); } 
arg1123_435 = 
MAKE_PAIR(arg1124_436, arg1125_437); } 
arg1120_432 = 
MAKE_PAIR(arg1122_434, arg1123_435); } 
{ /* Eval/expd-struct.scm 98 */
obj_t arg1135_447;
{ /* Eval/expd-struct.scm 98 */
obj_t arg1138_449;obj_t arg1139_450;
arg1138_449 = symbol1568___expander_struct; 
{ /* Eval/expd-struct.scm 98 */
obj_t arg1140_451;obj_t arg1141_452;
{ /* Eval/expd-struct.scm 98 */
obj_t arg1142_453;obj_t arg1143_454;
arg1142_453 = symbol1556___expander_struct; 
arg1143_454 = 
MAKE_PAIR(name_326, BNIL); 
arg1140_451 = 
MAKE_PAIR(arg1142_453, arg1143_454); } 
{ /* Eval/expd-struct.scm 98 */
obj_t arg1144_455;
{ /* Eval/expd-struct.scm 98 */
obj_t arg1145_456;
{ /* Eval/expd-struct.scm 98 */
obj_t arg1147_458;obj_t arg1148_459;
arg1147_458 = symbol1569___expander_struct; 
arg1148_459 = 
MAKE_PAIR(symbol1560___expander_struct, BNIL); 
arg1145_456 = 
MAKE_PAIR(arg1147_458, arg1148_459); } 
arg1144_455 = 
MAKE_PAIR(arg1145_456, BNIL); } 
{ /* ./Ieee/pair-list.scm 3569 */
obj_t aux_1556;
aux_1556 = 
BINT(len_336); 
arg1141_452 = 
MAKE_PAIR(aux_1556, arg1144_455); } } 
arg1139_450 = 
MAKE_PAIR(arg1140_451, arg1141_452); } 
arg1135_447 = 
MAKE_PAIR(arg1138_449, arg1139_450); } 
arg1121_433 = 
MAKE_PAIR(arg1135_447, BNIL); } 
arg1109_421 = 
MAKE_PAIR(arg1120_432, arg1121_433); } 
arg1107_419 = 
MAKE_PAIR(arg1108_420, arg1109_421); } 
arg1104_416 = 
MAKE_PAIR(arg1106_418, arg1107_419); } 
{ /* Eval/expd-struct.scm 99 */
obj_t arg1150_460;
{ /* Eval/expd-struct.scm 99 */
obj_t arg1152_462;obj_t arg1153_463;
arg1152_462 = symbol1568___expander_struct; 
{ /* Eval/expd-struct.scm 99 */
obj_t arg1154_464;obj_t arg1155_465;
{ /* Eval/expd-struct.scm 99 */
obj_t arg1156_466;obj_t arg1157_467;
arg1156_466 = symbol1556___expander_struct; 
arg1157_467 = 
MAKE_PAIR(name_326, BNIL); 
arg1154_464 = 
MAKE_PAIR(arg1156_466, arg1157_467); } 
{ /* Eval/expd-struct.scm 99 */
obj_t arg1158_468;
{ /* Eval/expd-struct.scm 99 */
obj_t arg1159_469;
{ /* Eval/expd-struct.scm 99 */
obj_t arg1161_471;obj_t arg1162_472;
arg1161_471 = symbol1556___expander_struct; 
arg1162_472 = 
MAKE_PAIR(BNIL, BNIL); 
arg1159_469 = 
MAKE_PAIR(arg1161_471, arg1162_472); } 
arg1158_468 = 
MAKE_PAIR(arg1159_469, BNIL); } 
{ /* ./Ieee/pair-list.scm 3569 */
obj_t aux_1570;
aux_1570 = 
BINT(len_336); 
arg1155_465 = 
MAKE_PAIR(aux_1570, arg1158_468); } } 
arg1153_463 = 
MAKE_PAIR(arg1154_464, arg1155_465); } 
arg1150_460 = 
MAKE_PAIR(arg1152_462, arg1153_463); } 
arg1105_417 = 
MAKE_PAIR(arg1150_460, BNIL); } 
arg1101_413 = 
MAKE_PAIR(arg1104_416, arg1105_417); } 
arg1099_411 = 
MAKE_PAIR(arg1100_412, arg1101_413); } 
arg1035_355 = 
MAKE_PAIR(arg1098_410, arg1099_411); } 
arg1029_349 = 
MAKE_PAIR(arg1035_355, BNIL); } 
arg1027_347 = 
MAKE_PAIR(arg1028_348, arg1029_349); } 
arg1025_345 = 
MAKE_PAIR(arg1026_346, arg1027_347); } 
{ /* Eval/expd-struct.scm 179 */
bool_t test1401_1081;
test1401_1081 = 
EXTENDED_PAIRP(x_1); 
if(test1401_1081)
{ /* Eval/expd-struct.scm 180 */
obj_t arg1402_1082;obj_t arg1403_1083;obj_t arg1404_1084;
arg1402_1082 = 
CAR(arg1025_345); 
arg1403_1083 = 
CDR(arg1025_345); 
{ /* ./Ieee/pair-list.scm 3593 */
bool_t test1500_1089;
test1500_1089 = 
EXTENDED_PAIRP(x_1); 
if(test1500_1089)
{ /* ./Ieee/pair-list.scm 3593 */
arg1404_1084 = 
CER(x_1); }  else 
{ /* ./Ieee/pair-list.scm 3593 */
FAILURE(string1570___expander_struct,string1571___expander_struct,x_1);} } 
arg1024_344 = 
MAKE_EXTENDED_PAIR(arg1402_1082, arg1403_1083, arg1404_1084); }  else 
{ /* Eval/expd-struct.scm 179 */
arg1024_344 = arg1025_345; } } } 
arg1022_342 = 
PROCEDURE_ENTRY(e_2)(e_2, arg1024_344, e_2, BEOA); } 
{ /* Eval/expd-struct.scm 104 */
obj_t arg1163_473;obj_t arg1164_474;
{ /* Eval/expd-struct.scm 104 */
obj_t arg1165_475;
{ /* Eval/expd-struct.scm 104 */
obj_t arg1166_476;
{ /* Eval/expd-struct.scm 104 */
obj_t arg1167_477;obj_t arg1168_478;
arg1167_477 = symbol1558___expander_struct; 
{ /* Eval/expd-struct.scm 104 */
obj_t arg1169_479;obj_t arg1170_480;
{ /* ./Ieee/pair-list.scm 3569 */
obj_t aux_1593;
aux_1593 = 
append_2_18___r4_pairs_and_lists_6_3(slots_name_121_337, BNIL); 
arg1169_479 = 
MAKE_PAIR(name_326, aux_1593); } 
{ /* Eval/expd-struct.scm 105 */
obj_t arg1172_482;
{ /* Eval/expd-struct.scm 105 */
obj_t arg1174_484;obj_t arg1175_485;
arg1174_484 = symbol1572___expander_struct; 
{ /* Eval/expd-struct.scm 105 */
obj_t arg1176_486;obj_t arg1177_487;
{ /* Eval/expd-struct.scm 105 */
obj_t arg1178_488;
{ /* Eval/expd-struct.scm 105 */
obj_t arg1180_490;obj_t arg1181_491;
arg1180_490 = symbol1573___expander_struct; 
{ /* Eval/expd-struct.scm 105 */
obj_t arg1182_492;
{ /* Eval/expd-struct.scm 105 */
obj_t arg1184_494;obj_t arg1185_495;
arg1184_494 = symbol1568___expander_struct; 
{ /* Eval/expd-struct.scm 105 */
obj_t arg1186_496;obj_t arg1187_497;
{ /* Eval/expd-struct.scm 105 */
obj_t arg1188_498;obj_t arg1189_499;
arg1188_498 = symbol1556___expander_struct; 
arg1189_499 = 
MAKE_PAIR(name_326, BNIL); 
arg1186_496 = 
MAKE_PAIR(arg1188_498, arg1189_499); } 
{ /* Eval/expd-struct.scm 105 */
obj_t arg1190_500;
{ /* Eval/expd-struct.scm 105 */
obj_t arg1192_501;
{ /* Eval/expd-struct.scm 105 */
obj_t arg1194_503;obj_t arg1195_504;
arg1194_503 = symbol1556___expander_struct; 
arg1195_504 = 
MAKE_PAIR(BNIL, BNIL); 
arg1192_501 = 
MAKE_PAIR(arg1194_503, arg1195_504); } 
arg1190_500 = 
MAKE_PAIR(arg1192_501, BNIL); } 
{ /* ./Ieee/pair-list.scm 3569 */
obj_t aux_1601;
aux_1601 = 
BINT(len_336); 
arg1187_497 = 
MAKE_PAIR(aux_1601, arg1190_500); } } 
arg1185_495 = 
MAKE_PAIR(arg1186_496, arg1187_497); } 
arg1182_492 = 
MAKE_PAIR(arg1184_494, arg1185_495); } 
arg1181_491 = 
MAKE_PAIR(arg1182_492, BNIL); } 
arg1178_488 = 
MAKE_PAIR(arg1180_490, arg1181_491); } 
arg1176_486 = 
MAKE_PAIR(arg1178_488, BNIL); } 
{ /* Eval/expd-struct.scm 106 */
obj_t arg1196_505;obj_t arg1198_506;
{ 
obj_t slots_507;obj_t res_508;
slots_507 = slots_name_121_337; 
res_508 = BNIL; 
loop_509:
if(
NULLP(slots_507))
{ /* Eval/expd-struct.scm 108 */
arg1196_505 = res_508; }  else 
{ /* Eval/expd-struct.scm 110 */
obj_t arg1201_511;obj_t arg1202_512;
arg1201_511 = 
CDR(slots_507); 
{ /* Eval/expd-struct.scm 112 */
obj_t arg1204_513;
{ /* Eval/expd-struct.scm 112 */
obj_t arg1206_514;obj_t arg1207_515;
{ /* Eval/expd-struct.scm 112 */
obj_t arg1209_516;obj_t arg1212_517;
arg1209_516 = symbol1574___expander_struct; 
arg1212_517 = 
CAR(slots_507); 
{ /* Eval/expd-struct.scm 111 */
obj_t list1214_519;
{ /* Eval/expd-struct.scm 111 */
obj_t arg1215_520;
{ /* Eval/expd-struct.scm 111 */
obj_t arg1216_521;
{ /* Eval/expd-struct.scm 111 */
obj_t arg1217_522;
arg1217_522 = 
MAKE_PAIR(symbol1575___expander_struct, BNIL); 
arg1216_521 = 
MAKE_PAIR(arg1212_517, arg1217_522); } 
arg1215_520 = 
MAKE_PAIR(arg1209_516, arg1216_521); } 
list1214_519 = 
MAKE_PAIR(name_326, arg1215_520); } 
arg1206_514 = 
symbol_append_197___r4_symbols_6_4(list1214_519); } } 
{ /* Eval/expd-struct.scm 111 */
obj_t arg1220_523;obj_t arg1222_524;
arg1220_523 = symbol1573___expander_struct; 
{ /* ./Ieee/pair-list.scm 3569 */
obj_t aux_1618;
aux_1618 = 
CAR(slots_507); 
arg1222_524 = 
MAKE_PAIR(aux_1618, BNIL); } 
arg1207_515 = 
MAKE_PAIR(arg1220_523, arg1222_524); } 
arg1204_513 = 
MAKE_PAIR(arg1206_514, arg1207_515); } 
arg1202_512 = 
MAKE_PAIR(arg1204_513, res_508); } 
{ 
obj_t res_1625;obj_t slots_1624;
slots_1624 = arg1201_511; 
res_1625 = arg1202_512; 
res_508 = res_1625; 
slots_507 = slots_1624; 
goto loop_509;} } } 
arg1198_506 = 
MAKE_PAIR(symbol1573___expander_struct, BNIL); 
arg1177_487 = 
append_2_18___r4_pairs_and_lists_6_3(arg1196_505, arg1198_506); } 
arg1175_485 = 
MAKE_PAIR(arg1176_486, arg1177_487); } 
arg1172_482 = 
MAKE_PAIR(arg1174_484, arg1175_485); } 
arg1170_480 = 
MAKE_PAIR(arg1172_482, BNIL); } 
arg1168_478 = 
MAKE_PAIR(arg1169_479, arg1170_480); } 
arg1166_476 = 
MAKE_PAIR(arg1167_477, arg1168_478); } 
{ /* Eval/expd-struct.scm 179 */
bool_t test1401_1147;
test1401_1147 = 
EXTENDED_PAIRP(x_1); 
if(test1401_1147)
{ /* Eval/expd-struct.scm 180 */
obj_t arg1402_1148;obj_t arg1403_1149;obj_t arg1404_1150;
arg1402_1148 = 
CAR(arg1166_476); 
arg1403_1149 = 
CDR(arg1166_476); 
{ /* ./Ieee/pair-list.scm 3593 */
bool_t test1500_1155;
test1500_1155 = 
EXTENDED_PAIRP(x_1); 
if(test1500_1155)
{ /* ./Ieee/pair-list.scm 3593 */
arg1404_1150 = 
CER(x_1); }  else 
{ /* ./Ieee/pair-list.scm 3593 */
FAILURE(string1570___expander_struct,string1571___expander_struct,x_1);} } 
arg1165_475 = 
MAKE_EXTENDED_PAIR(arg1402_1148, arg1403_1149, arg1404_1150); }  else 
{ /* Eval/expd-struct.scm 179 */
arg1165_475 = arg1166_476; } } } 
arg1163_473 = 
PROCEDURE_ENTRY(e_2)(e_2, arg1165_475, e_2, BEOA); } 
{ /* Eval/expd-struct.scm 124 */
obj_t arg1226_527;obj_t arg1227_528;
{ /* Eval/expd-struct.scm 124 */
obj_t arg1228_529;
{ /* Eval/expd-struct.scm 124 */
obj_t arg1229_530;
{ /* Eval/expd-struct.scm 124 */
obj_t arg1230_531;obj_t arg1231_532;
arg1230_531 = symbol1558___expander_struct; 
{ /* Eval/expd-struct.scm 124 */
obj_t arg1232_533;obj_t arg1233_534;
{ /* Eval/expd-struct.scm 124 */
obj_t arg1234_535;obj_t arg1235_536;
{ /* Eval/expd-struct.scm 124 */
obj_t list1236_537;
{ /* Eval/expd-struct.scm 124 */
obj_t arg1237_538;
arg1237_538 = 
MAKE_PAIR(symbol1576___expander_struct, BNIL); 
list1236_537 = 
MAKE_PAIR(name_326, arg1237_538); } 
arg1234_535 = 
symbol_append_197___r4_symbols_6_4(list1236_537); } 
arg1235_536 = 
MAKE_PAIR(symbol1577___expander_struct, BNIL); 
arg1232_533 = 
MAKE_PAIR(arg1234_535, arg1235_536); } 
{ /* Eval/expd-struct.scm 125 */
obj_t arg1238_539;
{ /* Eval/expd-struct.scm 125 */
obj_t arg1241_541;obj_t arg1243_542;
arg1241_541 = symbol1561___expander_struct; 
{ /* Eval/expd-struct.scm 125 */
obj_t arg1245_543;obj_t arg1246_544;
{ /* Eval/expd-struct.scm 125 */
obj_t arg1248_545;obj_t arg1249_546;
arg1248_545 = symbol1578___expander_struct; 
arg1249_546 = 
MAKE_PAIR(symbol1577___expander_struct, BNIL); 
arg1245_543 = 
MAKE_PAIR(arg1248_545, arg1249_546); } 
{ /* Eval/expd-struct.scm 126 */
obj_t arg1250_547;obj_t arg1251_548;
{ /* Eval/expd-struct.scm 126 */
obj_t arg1252_549;obj_t arg1253_550;
arg1252_549 = symbol1579___expander_struct; 
{ /* Eval/expd-struct.scm 126 */
obj_t arg1254_551;obj_t arg1255_552;
{ /* Eval/expd-struct.scm 126 */
obj_t arg1256_553;obj_t arg1257_554;
arg1256_553 = symbol1580___expander_struct; 
arg1257_554 = 
MAKE_PAIR(symbol1577___expander_struct, BNIL); 
arg1254_551 = 
MAKE_PAIR(arg1256_553, arg1257_554); } 
{ /* Eval/expd-struct.scm 126 */
obj_t arg1258_555;
{ /* Eval/expd-struct.scm 126 */
obj_t arg1260_557;obj_t arg1261_558;
arg1260_557 = symbol1556___expander_struct; 
arg1261_558 = 
MAKE_PAIR(name_326, BNIL); 
arg1258_555 = 
MAKE_PAIR(arg1260_557, arg1261_558); } 
arg1255_552 = 
MAKE_PAIR(arg1258_555, BNIL); } 
arg1253_550 = 
MAKE_PAIR(arg1254_551, arg1255_552); } 
arg1250_547 = 
MAKE_PAIR(arg1252_549, arg1253_550); } 
arg1251_548 = 
MAKE_PAIR(BFALSE, BNIL); 
arg1246_544 = 
MAKE_PAIR(arg1250_547, arg1251_548); } 
arg1243_542 = 
MAKE_PAIR(arg1245_543, arg1246_544); } 
arg1238_539 = 
MAKE_PAIR(arg1241_541, arg1243_542); } 
arg1233_534 = 
MAKE_PAIR(arg1238_539, BNIL); } 
arg1231_532 = 
MAKE_PAIR(arg1232_533, arg1233_534); } 
arg1229_530 = 
MAKE_PAIR(arg1230_531, arg1231_532); } 
{ /* Eval/expd-struct.scm 179 */
bool_t test1401_1201;
test1401_1201 = 
EXTENDED_PAIRP(x_1); 
if(test1401_1201)
{ /* Eval/expd-struct.scm 180 */
obj_t arg1402_1202;obj_t arg1403_1203;obj_t arg1404_1204;
arg1402_1202 = 
CAR(arg1229_530); 
arg1403_1203 = 
CDR(arg1229_530); 
{ /* ./Ieee/pair-list.scm 3593 */
bool_t test1500_1209;
test1500_1209 = 
EXTENDED_PAIRP(x_1); 
if(test1500_1209)
{ /* ./Ieee/pair-list.scm 3593 */
arg1404_1204 = 
CER(x_1); }  else 
{ /* ./Ieee/pair-list.scm 3593 */
FAILURE(string1570___expander_struct,string1571___expander_struct,x_1);} } 
arg1228_529 = 
MAKE_EXTENDED_PAIR(arg1402_1202, arg1403_1203, arg1404_1204); }  else 
{ /* Eval/expd-struct.scm 179 */
arg1228_529 = arg1229_530; } } } 
arg1226_527 = 
PROCEDURE_ENTRY(e_2)(e_2, arg1228_529, e_2, BEOA); } 
{ 
long i_559;obj_t slots_560;obj_t res_561;
i_559 = ((long)0); 
slots_560 = slots_name_121_337; 
res_561 = list1587___expander_struct; 
loop_562:
if(
(i_559==len_336))
{ /* Eval/expd-struct.scm 134 */
arg1227_528 = res_561; }  else 
{ /* Eval/expd-struct.scm 136 */
obj_t pr_564;
pr_564 = 
CAR(slots_560); 
{ /* Eval/expd-struct.scm 137 */
long arg1263_565;obj_t arg1264_566;obj_t arg1265_567;
arg1263_565 = 
(i_559+((long)1)); 
arg1264_566 = 
CDR(slots_560); 
{ /* Eval/expd-struct.scm 142 */
obj_t arg1267_568;obj_t arg1268_569;
{ /* Eval/expd-struct.scm 142 */
obj_t arg1269_570;
{ /* Eval/expd-struct.scm 142 */
obj_t arg1270_571;
{ /* Eval/expd-struct.scm 142 */
obj_t arg1271_572;obj_t arg1272_573;
arg1271_572 = symbol1558___expander_struct; 
{ /* Eval/expd-struct.scm 143 */
obj_t arg1273_574;obj_t arg1274_575;
{ /* Eval/expd-struct.scm 143 */
obj_t arg1276_576;obj_t arg1277_577;
{ /* Eval/expd-struct.scm 143 */
obj_t list1278_578;
{ /* Eval/expd-struct.scm 143 */
obj_t arg1280_579;
{ /* Eval/expd-struct.scm 143 */
obj_t arg1281_580;obj_t arg1282_581;
arg1281_580 = symbol1574___expander_struct; 
arg1282_581 = 
MAKE_PAIR(pr_564, BNIL); 
arg1280_579 = 
MAKE_PAIR(arg1281_580, arg1282_581); } 
list1278_578 = 
MAKE_PAIR(name_326, arg1280_579); } 
arg1276_576 = 
symbol_append_197___r4_symbols_6_4(list1278_578); } 
arg1277_577 = 
MAKE_PAIR(symbol1581___expander_struct, BNIL); 
arg1273_574 = 
MAKE_PAIR(arg1276_576, arg1277_577); } 
{ /* Eval/expd-struct.scm 144 */
obj_t arg1286_582;
{ /* Eval/expd-struct.scm 144 */
obj_t arg1289_584;obj_t arg1290_585;
arg1289_584 = symbol1561___expander_struct; 
{ /* Eval/expd-struct.scm 144 */
obj_t arg1291_586;obj_t arg1292_587;
{ /* Eval/expd-struct.scm 144 */
obj_t arg1293_588;obj_t arg1294_589;
{ /* Eval/expd-struct.scm 144 */
obj_t list1295_590;
{ /* Eval/expd-struct.scm 144 */
obj_t arg1296_591;
arg1296_591 = 
MAKE_PAIR(symbol1576___expander_struct, BNIL); 
list1295_590 = 
MAKE_PAIR(name_326, arg1296_591); } 
arg1293_588 = 
symbol_append_197___r4_symbols_6_4(list1295_590); } 
arg1294_589 = 
MAKE_PAIR(symbol1581___expander_struct, BNIL); 
arg1291_586 = 
MAKE_PAIR(arg1293_588, arg1294_589); } 
{ /* Eval/expd-struct.scm 145 */
obj_t arg1297_592;obj_t arg1298_593;
{ /* Eval/expd-struct.scm 145 */
obj_t arg1299_594;obj_t arg1300_595;
arg1299_594 = symbol1582___expander_struct; 
{ /* Eval/expd-struct.scm 145 */
obj_t arg1301_596;obj_t arg1302_597;
arg1301_596 = symbol1581___expander_struct; 
{ /* ./Ieee/pair-list.scm 3569 */
obj_t aux_1692;
aux_1692 = 
BINT(i_559); 
arg1302_597 = 
MAKE_PAIR(aux_1692, BNIL); } 
arg1300_595 = 
MAKE_PAIR(arg1301_596, arg1302_597); } 
arg1297_592 = 
MAKE_PAIR(arg1299_594, arg1300_595); } 
{ /* Eval/expd-struct.scm 146 */
obj_t arg1303_598;
{ /* Eval/expd-struct.scm 146 */
obj_t arg1305_600;obj_t arg1307_601;
arg1305_600 = symbol1566___expander_struct; 
{ /* Eval/expd-struct.scm 146 */
obj_t arg1309_603;
{ /* Eval/expd-struct.scm 148 */
obj_t arg1313_604;obj_t arg1314_605;
arg1313_604 = 
SYMBOL_TO_STRING(name_326); 
arg1314_605 = 
MAKE_PAIR(symbol1581___expander_struct, BNIL); 
arg1309_603 = 
MAKE_PAIR(arg1313_604, arg1314_605); } 
arg1307_601 = 
MAKE_PAIR(string1583___expander_struct, arg1309_603); } 
arg1303_598 = 
MAKE_PAIR(arg1305_600, arg1307_601); } 
arg1298_593 = 
MAKE_PAIR(arg1303_598, BNIL); } 
arg1292_587 = 
MAKE_PAIR(arg1297_592, arg1298_593); } 
arg1290_585 = 
MAKE_PAIR(arg1291_586, arg1292_587); } 
arg1286_582 = 
MAKE_PAIR(arg1289_584, arg1290_585); } 
arg1274_575 = 
MAKE_PAIR(arg1286_582, BNIL); } 
arg1272_573 = 
MAKE_PAIR(arg1273_574, arg1274_575); } 
arg1270_571 = 
MAKE_PAIR(arg1271_572, arg1272_573); } 
{ /* Eval/expd-struct.scm 179 */
bool_t test1401_1262;
test1401_1262 = 
EXTENDED_PAIRP(x_1); 
if(test1401_1262)
{ /* Eval/expd-struct.scm 180 */
obj_t arg1402_1263;obj_t arg1403_1264;obj_t arg1404_1265;
arg1402_1263 = 
CAR(arg1270_571); 
arg1403_1264 = 
CDR(arg1270_571); 
{ /* ./Ieee/pair-list.scm 3593 */
bool_t test1500_1270;
test1500_1270 = 
EXTENDED_PAIRP(x_1); 
if(test1500_1270)
{ /* ./Ieee/pair-list.scm 3593 */
arg1404_1265 = 
CER(x_1); }  else 
{ /* ./Ieee/pair-list.scm 3593 */
FAILURE(string1570___expander_struct,string1571___expander_struct,x_1);} } 
arg1269_570 = 
MAKE_EXTENDED_PAIR(arg1402_1263, arg1403_1264, arg1404_1265); }  else 
{ /* Eval/expd-struct.scm 179 */
arg1269_570 = arg1270_571; } } } 
arg1267_568 = 
PROCEDURE_ENTRY(e_2)(e_2, arg1269_570, e_2, BEOA); } 
{ /* Eval/expd-struct.scm 155 */
obj_t arg1315_606;
{ /* Eval/expd-struct.scm 155 */
obj_t arg1317_607;
{ /* Eval/expd-struct.scm 155 */
obj_t arg1318_608;
{ /* Eval/expd-struct.scm 155 */
obj_t arg1319_609;obj_t arg1320_610;
arg1319_609 = symbol1558___expander_struct; 
{ /* Eval/expd-struct.scm 156 */
obj_t arg1322_611;obj_t arg1323_612;
{ /* Eval/expd-struct.scm 156 */
obj_t arg1325_613;obj_t arg1326_614;
{ /* Eval/expd-struct.scm 156 */
obj_t list1327_615;
{ /* Eval/expd-struct.scm 156 */
obj_t arg1329_616;
{ /* Eval/expd-struct.scm 156 */
obj_t arg1330_617;obj_t arg1331_618;
arg1330_617 = symbol1574___expander_struct; 
{ /* Eval/expd-struct.scm 156 */
obj_t arg1332_619;
arg1332_619 = 
MAKE_PAIR(symbol1575___expander_struct, BNIL); 
arg1331_618 = 
MAKE_PAIR(pr_564, arg1332_619); } 
arg1329_616 = 
MAKE_PAIR(arg1330_617, arg1331_618); } 
list1327_615 = 
MAKE_PAIR(name_326, arg1329_616); } 
arg1325_613 = 
symbol_append_197___r4_symbols_6_4(list1327_615); } 
{ /* Eval/expd-struct.scm 156 */
obj_t arg1333_620;obj_t arg1334_621;
arg1333_620 = symbol1581___expander_struct; 
arg1334_621 = 
MAKE_PAIR(symbol1584___expander_struct, BNIL); 
arg1326_614 = 
MAKE_PAIR(arg1333_620, arg1334_621); } 
arg1322_611 = 
MAKE_PAIR(arg1325_613, arg1326_614); } 
{ /* Eval/expd-struct.scm 157 */
obj_t arg1335_622;
{ /* Eval/expd-struct.scm 157 */
obj_t arg1337_624;obj_t arg1338_625;
arg1337_624 = symbol1561___expander_struct; 
{ /* Eval/expd-struct.scm 157 */
obj_t arg1339_626;obj_t arg1340_627;
{ /* Eval/expd-struct.scm 157 */
obj_t arg1342_628;obj_t arg1343_629;
{ /* Eval/expd-struct.scm 157 */
obj_t list1344_630;
{ /* Eval/expd-struct.scm 157 */
obj_t arg1346_631;
arg1346_631 = 
MAKE_PAIR(symbol1576___expander_struct, BNIL); 
list1344_630 = 
MAKE_PAIR(name_326, arg1346_631); } 
arg1342_628 = 
symbol_append_197___r4_symbols_6_4(list1344_630); } 
arg1343_629 = 
MAKE_PAIR(symbol1581___expander_struct, BNIL); 
arg1339_626 = 
MAKE_PAIR(arg1342_628, arg1343_629); } 
{ /* Eval/expd-struct.scm 158 */
obj_t arg1347_632;obj_t arg1348_633;
{ /* Eval/expd-struct.scm 158 */
obj_t arg1350_634;obj_t arg1354_635;
arg1350_634 = symbol1585___expander_struct; 
{ /* Eval/expd-struct.scm 158 */
obj_t arg1355_636;obj_t arg1356_637;
arg1355_636 = symbol1581___expander_struct; 
{ /* Eval/expd-struct.scm 158 */
obj_t arg1357_638;
arg1357_638 = 
MAKE_PAIR(symbol1584___expander_struct, BNIL); 
{ /* ./Ieee/pair-list.scm 3569 */
obj_t aux_1734;
aux_1734 = 
BINT(i_559); 
arg1356_637 = 
MAKE_PAIR(aux_1734, arg1357_638); } } 
arg1354_635 = 
MAKE_PAIR(arg1355_636, arg1356_637); } 
arg1347_632 = 
MAKE_PAIR(arg1350_634, arg1354_635); } 
{ /* Eval/expd-struct.scm 159 */
obj_t arg1358_639;
{ /* Eval/expd-struct.scm 159 */
obj_t arg1361_641;obj_t arg1363_642;
arg1361_641 = symbol1566___expander_struct; 
{ /* Eval/expd-struct.scm 159 */
obj_t arg1366_644;
{ /* Eval/expd-struct.scm 161 */
obj_t arg1367_645;obj_t arg1369_646;
arg1367_645 = 
SYMBOL_TO_STRING(name_326); 
arg1369_646 = 
MAKE_PAIR(symbol1581___expander_struct, BNIL); 
arg1366_644 = 
MAKE_PAIR(arg1367_645, arg1369_646); } 
arg1363_642 = 
MAKE_PAIR(string1586___expander_struct, arg1366_644); } 
arg1358_639 = 
MAKE_PAIR(arg1361_641, arg1363_642); } 
arg1348_633 = 
MAKE_PAIR(arg1358_639, BNIL); } 
arg1340_627 = 
MAKE_PAIR(arg1347_632, arg1348_633); } 
arg1338_625 = 
MAKE_PAIR(arg1339_626, arg1340_627); } 
arg1335_622 = 
MAKE_PAIR(arg1337_624, arg1338_625); } 
arg1323_612 = 
MAKE_PAIR(arg1335_622, BNIL); } 
arg1320_610 = 
MAKE_PAIR(arg1322_611, arg1323_612); } 
arg1318_608 = 
MAKE_PAIR(arg1319_609, arg1320_610); } 
{ /* Eval/expd-struct.scm 179 */
bool_t test1401_1321;
test1401_1321 = 
EXTENDED_PAIRP(x_1); 
if(test1401_1321)
{ /* Eval/expd-struct.scm 180 */
obj_t arg1402_1322;obj_t arg1403_1323;obj_t arg1404_1324;
arg1402_1322 = 
CAR(arg1318_608); 
arg1403_1323 = 
CDR(arg1318_608); 
{ /* ./Ieee/pair-list.scm 3593 */
bool_t test1500_1329;
test1500_1329 = 
EXTENDED_PAIRP(x_1); 
if(test1500_1329)
{ /* ./Ieee/pair-list.scm 3593 */
arg1404_1324 = 
CER(x_1); }  else 
{ /* ./Ieee/pair-list.scm 3593 */
FAILURE(string1570___expander_struct,string1571___expander_struct,x_1);} } 
arg1317_607 = 
MAKE_EXTENDED_PAIR(arg1402_1322, arg1403_1323, arg1404_1324); }  else 
{ /* Eval/expd-struct.scm 179 */
arg1317_607 = arg1318_608; } } } 
arg1315_606 = 
PROCEDURE_ENTRY(e_2)(e_2, arg1317_607, e_2, BEOA); } 
arg1268_569 = 
MAKE_PAIR(arg1315_606, res_561); } 
arg1265_567 = 
MAKE_PAIR(arg1267_568, arg1268_569); } 
{ 
obj_t res_1766;obj_t slots_1765;long i_1764;
i_1764 = arg1263_565; 
slots_1765 = arg1264_566; 
res_1766 = arg1265_567; 
res_561 = res_1766; 
slots_560 = slots_1765; 
i_559 = i_1764; 
goto loop_562;} } } } 
arg1164_474 = 
MAKE_PAIR(arg1226_527, arg1227_528); } 
arg1023_343 = 
MAKE_PAIR(arg1163_473, arg1164_474); } 
arg1021_341 = 
MAKE_PAIR(arg1022_342, arg1023_343); } 
return 
MAKE_PAIR(arg1020_340, arg1021_341);} } } } } } }  else 
{ /* Eval/expd-struct.scm 51 */
FAILURE(string1553___expander_struct,string1554___expander_struct,x_1);} }  else 
{ /* Eval/expd-struct.scm 51 */
FAILURE(string1553___expander_struct,string1554___expander_struct,x_1);} } } 
}



/* _expand-eval-define-struct */
obj_t _expand_eval_define_struct_219___expander_struct(obj_t env_1380, obj_t x_1381, obj_t e_1382)
{ AN_OBJECT;
{ /* Eval/expd-struct.scm 50 */
return 
expand_eval_define_struct_250___expander_struct(x_1381, e_1382);} 
}



/* imported-modules-init */
obj_t imported_modules_init_94___expander_struct()
{ AN_OBJECT;
{ /* Eval/expd-struct.scm 14 */
module_initialization_70___error(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___bigloo(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___tvector(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___structure(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___bexit(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___match_normalize(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_numbers_6_5(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_numbers_6_5_fixnum(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_numbers_6_5_flonum(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_characters_6_6(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_equivalence_6_2(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_booleans_6_1(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_symbols_6_4(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_strings_6_7(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_pairs_and_lists_6_3(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_input_6_10_2(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_control_features_6_9(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_vectors_6_8(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_ports_6_10_1(((long)0), "__EXPANDER_STRUCT"); 
module_initialization_70___r4_output_6_10_3(((long)0), "__EXPANDER_STRUCT"); 
return 
module_initialization_70___progn(((long)0), "__EXPANDER_STRUCT");} 
}

