/*===========================================================================*/
/*   (Ieee/number.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

static obj_t _2__171___r4_numbers_6_5(obj_t, obj_t, obj_t);
static obj_t _2__242___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern char * number__string_214___r4_numbers_6_5(obj_t, obj_t);
static obj_t _2__101___r4_numbers_6_5(obj_t, obj_t, obj_t);
static obj_t _exp___r4_numbers_6_5(obj_t, obj_t);
extern obj_t exact__inexact_122___r4_numbers_6_5(obj_t);
static obj_t _inexact__exact_215___r4_numbers_6_5(obj_t, obj_t);
static obj_t _floor___r4_numbers_6_5(obj_t, obj_t);
extern obj_t abs___r4_numbers_6_5(obj_t);
static obj_t _ceiling___r4_numbers_6_5(obj_t, obj_t);
extern obj_t make_real(double);
static obj_t _negative__187___r4_numbers_6_5(obj_t, obj_t);
static obj_t _cos___r4_numbers_6_5(obj_t, obj_t);
static obj_t _string__number_250___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern obj_t floor___r4_numbers_6_5(obj_t);
extern long flonum__fixnum_11___r4_numbers_6_5(obj_t);
static obj_t _inexact__53___r4_numbers_6_5(obj_t, obj_t);
extern double atan___r4_numbers_6_5(obj_t, obj_t);
extern double asin___r4_numbers_6_5(obj_t);
static obj_t _expt___r4_numbers_6_5(obj_t, obj_t, obj_t);
static obj_t _rational__24___r4_numbers_6_5(obj_t, obj_t);
static obj_t _complex__176___r4_numbers_6_5(obj_t, obj_t);
static obj_t _number__137___r4_numbers_6_5(obj_t, obj_t);
static obj_t _abs___r4_numbers_6_5(obj_t, obj_t);
extern bool_t inexact__139___r4_numbers_6_5(obj_t);
extern double tan___r4_numbers_6_5(obj_t);
static obj_t _round___r4_numbers_6_5(obj_t, obj_t);
extern double sin___r4_numbers_6_5(obj_t);
extern char * integer__string_135___r4_numbers_6_5_fixnum(long, obj_t);
extern obj_t ceiling___r4_numbers_6_5(obj_t);
extern obj_t string_to_bstring(char *);
extern bool_t complex__118___r4_numbers_6_5(obj_t);
static obj_t _zero__222___r4_numbers_6_5(obj_t, obj_t);
extern bool_t negative__33___r4_numbers_6_5(obj_t);
static obj_t _positive__177___r4_numbers_6_5(obj_t, obj_t);
extern obj_t round___r4_numbers_6_5(obj_t);
extern bool_t exact__189___r4_numbers_6_5(obj_t);
extern obj_t inexact__exact_80___r4_numbers_6_5(obj_t);
static obj_t _acos___r4_numbers_6_5(obj_t, obj_t);
extern bool_t rational__51___r4_numbers_6_5(obj_t);
extern bool_t zero__228___r4_numbers_6_5(obj_t);
static obj_t _sqrt___r4_numbers_6_5(obj_t, obj_t);
extern bool_t number__102___r4_numbers_6_5(obj_t);
static obj_t _truncate___r4_numbers_6_5(obj_t, obj_t);
static obj_t _tan___r4_numbers_6_5(obj_t, obj_t);
static obj_t _sin___r4_numbers_6_5(obj_t, obj_t);
static obj_t ___149___r4_numbers_6_5(obj_t, obj_t, obj_t, obj_t);
static obj_t ___44___r4_numbers_6_5(obj_t, obj_t, obj_t, obj_t);
static obj_t ___38___r4_numbers_6_5(obj_t, obj_t, obj_t, obj_t);
static obj_t ___222___r4_numbers_6_5(obj_t, obj_t, obj_t);
static obj_t ___163___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___error(long, char *);
static obj_t ___219___r4_numbers_6_5(obj_t, obj_t);
static obj_t ___10___r4_numbers_6_5(obj_t, obj_t);
extern obj_t string__number_104___r4_numbers_6_5(obj_t, obj_t);
extern obj_t expt___r4_numbers_6_5(obj_t, obj_t);
extern obj_t min___r4_numbers_6_5(obj_t, obj_t);
static obj_t _fixnum__flonum_153___r4_numbers_6_5(obj_t, obj_t);
static obj_t _number__string_61___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern double log___r4_numbers_6_5(obj_t);
extern obj_t max___r4_numbers_6_5(obj_t, obj_t);
static obj_t _exact__208___r4_numbers_6_5(obj_t, obj_t);
static obj_t _exact__inexact_16___r4_numbers_6_5(obj_t, obj_t);
extern obj_t truncate___r4_numbers_6_5(obj_t);
extern bool_t positive__57___r4_numbers_6_5(obj_t);
extern bool_t ___239___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern bool_t ___161___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern bool_t _2___235___r4_numbers_6_5(obj_t, obj_t);
extern bool_t _2___241___r4_numbers_6_5(obj_t, obj_t);
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern bool_t _2__95___r4_numbers_6_5(obj_t, obj_t);
extern bool_t _2__116___r4_numbers_6_5(obj_t, obj_t);
extern obj_t _2__156___r4_numbers_6_5(obj_t, obj_t);
extern obj_t _2__79___r4_numbers_6_5(obj_t, obj_t);
extern obj_t _2__168___r4_numbers_6_5(obj_t, obj_t);
extern obj_t _2__198___r4_numbers_6_5(obj_t, obj_t);
static obj_t _min___r4_numbers_6_5(obj_t, obj_t, obj_t);
static obj_t _flonum__fixnum_24___r4_numbers_6_5(obj_t, obj_t);
static obj_t _log___r4_numbers_6_5(obj_t, obj_t);
static obj_t _max___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern long string__integer_39___r4_numbers_6_5_fixnum(char *, obj_t);
extern double acos___r4_numbers_6_5(obj_t);
extern double exp___r4_numbers_6_5(obj_t);
extern double sqrt___r4_numbers_6_5(obj_t);
static obj_t imported_modules_init_94___r4_numbers_6_5();
static obj_t _atan___r4_numbers_6_5(obj_t, obj_t, obj_t);
static obj_t _asin___r4_numbers_6_5(obj_t, obj_t);
static obj_t require_initialization_114___r4_numbers_6_5 = BUNSPEC;
static obj_t _2___43___r4_numbers_6_5(obj_t, obj_t, obj_t);
static obj_t _2___117___r4_numbers_6_5(obj_t, obj_t, obj_t);
static obj_t ____251___r4_numbers_6_5(obj_t, obj_t, obj_t, obj_t);
static obj_t ____73___r4_numbers_6_5(obj_t, obj_t, obj_t, obj_t);
extern char * real_to_string(double);
extern double cos___r4_numbers_6_5(obj_t);
extern bool_t __172___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern bool_t __147___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern bool_t __124___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern obj_t __28___r4_numbers_6_5(obj_t, obj_t);
extern obj_t __186___r4_numbers_6_5(obj_t, obj_t);
extern obj_t __2___r4_numbers_6_5(obj_t);
extern obj_t __15___r4_numbers_6_5(obj_t);
static obj_t _2__130___r4_numbers_6_5(obj_t, obj_t, obj_t);
static obj_t _2__245___r4_numbers_6_5(obj_t, obj_t, obj_t);
static obj_t _2__208___r4_numbers_6_5(obj_t, obj_t, obj_t);
extern double fixnum__flonum_13___r4_numbers_6_5(obj_t);
static obj_t _2__11___r4_numbers_6_5(obj_t, obj_t, obj_t);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( exact__env_214___r4_numbers_6_5, _exact__208___r4_numbers_6_51481, _exact__208___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( floor_env_50___r4_numbers_6_5, _floor___r4_numbers_6_51482, _floor___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( _2__env_159___r4_numbers_6_5, _2__208___r4_numbers_6_51483, _2__208___r4_numbers_6_5, 0L, 2 );
DEFINE_REAL( real1471___r4_numbers_6_5, real1471___r4_numbers_6_51484, 1.0 );
DEFINE_EXPORT_PROCEDURE( _2__env_141___r4_numbers_6_5, _2__171___r4_numbers_6_51485, _2__171___r4_numbers_6_5, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( asin_env_88___r4_numbers_6_5, _asin___r4_numbers_6_51486, _asin___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( __env_146___r4_numbers_6_5, ___219___r4_numbers_6_51487, va_generic_entry, ___219___r4_numbers_6_5, -1 );
DEFINE_EXPORT_PROCEDURE( cos_env_114___r4_numbers_6_5, _cos___r4_numbers_6_51488, _cos___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( _2___env_201___r4_numbers_6_5, _2___43___r4_numbers_6_51489, _2___43___r4_numbers_6_5, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( log_env_219___r4_numbers_6_5, _log___r4_numbers_6_51490, _log___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( __env_224___r4_numbers_6_5, ___149___r4_numbers_6_51491, va_generic_entry, ___149___r4_numbers_6_5, -3 );
DEFINE_EXPORT_PROCEDURE( fixnum__flonum_env_34___r4_numbers_6_5, _fixnum__flonum_153___r4_numbers_6_51492, _fixnum__flonum_153___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( atan_env_187___r4_numbers_6_5, _atan___r4_numbers_6_51493, va_generic_entry, _atan___r4_numbers_6_5, -2 );
DEFINE_EXPORT_PROCEDURE( min_env_72___r4_numbers_6_5, _min___r4_numbers_6_51494, va_generic_entry, _min___r4_numbers_6_5, -2 );
DEFINE_EXPORT_PROCEDURE( rational__env_181___r4_numbers_6_5, _rational__24___r4_numbers_6_51495, _rational__24___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( __env_131___r4_numbers_6_5, ___222___r4_numbers_6_51496, va_generic_entry, ___222___r4_numbers_6_5, -2 );
DEFINE_EXPORT_PROCEDURE( zero__env_140___r4_numbers_6_5, _zero__222___r4_numbers_6_51497, _zero__222___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( __env_27___r4_numbers_6_5, ___10___r4_numbers_6_51498, va_generic_entry, ___10___r4_numbers_6_5, -1 );
DEFINE_EXPORT_PROCEDURE( sin_env_239___r4_numbers_6_5, _sin___r4_numbers_6_51499, _sin___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( exp_env_94___r4_numbers_6_5, _exp___r4_numbers_6_51500, _exp___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( inexact__env_116___r4_numbers_6_5, _inexact__53___r4_numbers_6_51501, _inexact__53___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( ceiling_env_45___r4_numbers_6_5, _ceiling___r4_numbers_6_51502, _ceiling___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( flonum__fixnum_env_186___r4_numbers_6_5, _flonum__fixnum_24___r4_numbers_6_51503, _flonum__fixnum_24___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( __env_177___r4_numbers_6_5, ___44___r4_numbers_6_51504, va_generic_entry, ___44___r4_numbers_6_5, -3 );
DEFINE_EXPORT_PROCEDURE( string__number_env_5___r4_numbers_6_5, _string__number_250___r4_numbers_6_51505, va_generic_entry, _string__number_250___r4_numbers_6_5, -2 );
DEFINE_EXPORT_PROCEDURE( _2__env_132___r4_numbers_6_5, _2__242___r4_numbers_6_51506, _2__242___r4_numbers_6_5, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( tan_env_231___r4_numbers_6_5, _tan___r4_numbers_6_51507, _tan___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( ___env_53___r4_numbers_6_5, ____73___r4_numbers_6_51508, va_generic_entry, ____73___r4_numbers_6_5, -3 );
DEFINE_EXPORT_PROCEDURE( sqrt_env_78___r4_numbers_6_5, _sqrt___r4_numbers_6_51509, _sqrt___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( round_env_16___r4_numbers_6_5, _round___r4_numbers_6_51510, _round___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( _2__env_227___r4_numbers_6_5, _2__130___r4_numbers_6_51511, _2__130___r4_numbers_6_5, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( inexact__exact_env_134___r4_numbers_6_5, _inexact__exact_215___r4_numbers_6_51512, _inexact__exact_215___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( __env_55___r4_numbers_6_5, ___38___r4_numbers_6_51513, va_generic_entry, ___38___r4_numbers_6_5, -3 );
DEFINE_EXPORT_PROCEDURE( _2__env_108___r4_numbers_6_5, _2__11___r4_numbers_6_51514, _2__11___r4_numbers_6_5, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( _2__env_207___r4_numbers_6_5, _2__101___r4_numbers_6_51515, _2__101___r4_numbers_6_5, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( __env_196___r4_numbers_6_5, ___163___r4_numbers_6_51516, va_generic_entry, ___163___r4_numbers_6_5, -2 );
DEFINE_STRING( string1478___r4_numbers_6_5, string1478___r4_numbers_6_51517, "Only radix `10' is legal for floating point number", 50 );
DEFINE_STRING( string1477___r4_numbers_6_5, string1477___r4_numbers_6_51518, "Illegal number of optional arguments", 36 );
DEFINE_STRING( string1476___r4_numbers_6_5, string1476___r4_numbers_6_51519, "Illegal radix", 13 );
DEFINE_STRING( string1475___r4_numbers_6_5, string1475___r4_numbers_6_51520, "string->number", 14 );
DEFINE_STRING( string1474___r4_numbers_6_5, string1474___r4_numbers_6_51521, "Argument not a number", 21 );
DEFINE_STRING( string1473___r4_numbers_6_5, string1473___r4_numbers_6_51522, "number->string", 14 );
DEFINE_STRING( string1472___r4_numbers_6_5, string1472___r4_numbers_6_51523, "expt", 4 );
DEFINE_STRING( string1469___r4_numbers_6_5, string1469___r4_numbers_6_51524, "atan", 4 );
DEFINE_STRING( string1470___r4_numbers_6_5, string1470___r4_numbers_6_51525, "sqrt", 4 );
DEFINE_STRING( string1468___r4_numbers_6_5, string1468___r4_numbers_6_51526, "acos", 4 );
DEFINE_STRING( string1467___r4_numbers_6_5, string1467___r4_numbers_6_51527, "asin", 4 );
DEFINE_STRING( string1466___r4_numbers_6_5, string1466___r4_numbers_6_51528, "tan", 3 );
DEFINE_STRING( string1465___r4_numbers_6_5, string1465___r4_numbers_6_51529, "cos", 3 );
DEFINE_STRING( string1464___r4_numbers_6_5, string1464___r4_numbers_6_51530, "sin", 3 );
DEFINE_STRING( string1463___r4_numbers_6_5, string1463___r4_numbers_6_51531, "log", 3 );
DEFINE_STRING( string1462___r4_numbers_6_5, string1462___r4_numbers_6_51532, "exp", 3 );
DEFINE_STRING( string1461___r4_numbers_6_5, string1461___r4_numbers_6_51533, "round", 5 );
DEFINE_STRING( string1459___r4_numbers_6_5, string1459___r4_numbers_6_51534, "ceiling", 7 );
DEFINE_STRING( string1460___r4_numbers_6_5, string1460___r4_numbers_6_51535, "truncate", 8 );
DEFINE_STRING( string1458___r4_numbers_6_5, string1458___r4_numbers_6_51536, "floor", 5 );
DEFINE_STRING( string1457___r4_numbers_6_5, string1457___r4_numbers_6_51537, "abs", 3 );
DEFINE_STRING( string1456___r4_numbers_6_5, string1456___r4_numbers_6_51538, "/", 1 );
DEFINE_STRING( string1455___r4_numbers_6_5, string1455___r4_numbers_6_51539, "-", 1 );
DEFINE_STRING( string1454___r4_numbers_6_5, string1454___r4_numbers_6_51540, "*", 1 );
DEFINE_STRING( string1453___r4_numbers_6_5, string1453___r4_numbers_6_51541, "+", 1 );
DEFINE_STRING( string1452___r4_numbers_6_5, string1452___r4_numbers_6_51542, "negative", 8 );
DEFINE_STRING( string1451___r4_numbers_6_5, string1451___r4_numbers_6_51543, "positive", 8 );
DEFINE_STRING( string1449___r4_numbers_6_5, string1449___r4_numbers_6_51544, ">=", 2 );
DEFINE_STRING( string1450___r4_numbers_6_5, string1450___r4_numbers_6_51545, "zero", 4 );
DEFINE_STRING( string1448___r4_numbers_6_5, string1448___r4_numbers_6_51546, "<=", 2 );
DEFINE_STRING( string1447___r4_numbers_6_5, string1447___r4_numbers_6_51547, ">", 1 );
DEFINE_STRING( string1446___r4_numbers_6_5, string1446___r4_numbers_6_51548, "<", 1 );
DEFINE_STRING( string1445___r4_numbers_6_5, string1445___r4_numbers_6_51549, "not a number", 12 );
DEFINE_STRING( string1444___r4_numbers_6_5, string1444___r4_numbers_6_51550, "=", 1 );
DEFINE_EXPORT_PROCEDURE( truncate_env_98___r4_numbers_6_5, _truncate___r4_numbers_6_51551, _truncate___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( _2__env_147___r4_numbers_6_5, _2__245___r4_numbers_6_51552, _2__245___r4_numbers_6_5, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( ___env_251___r4_numbers_6_5, ____251___r4_numbers_6_51553, va_generic_entry, ____251___r4_numbers_6_5, -3 );
DEFINE_EXPORT_PROCEDURE( complex__env_220___r4_numbers_6_5, _complex__176___r4_numbers_6_51554, _complex__176___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( expt_env_52___r4_numbers_6_5, _expt___r4_numbers_6_51555, _expt___r4_numbers_6_5, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( exact__inexact_env_238___r4_numbers_6_5, _exact__inexact_16___r4_numbers_6_51556, _exact__inexact_16___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( _2___env_180___r4_numbers_6_5, _2___117___r4_numbers_6_51557, _2___117___r4_numbers_6_5, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( negative__env_63___r4_numbers_6_5, _negative__187___r4_numbers_6_51558, _negative__187___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( number__env_153___r4_numbers_6_5, _number__137___r4_numbers_6_51559, _number__137___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( number__string_env_103___r4_numbers_6_5, _number__string_61___r4_numbers_6_51560, va_generic_entry, _number__string_61___r4_numbers_6_5, -2 );
DEFINE_EXPORT_PROCEDURE( positive__env_240___r4_numbers_6_5, _positive__177___r4_numbers_6_51561, _positive__177___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( max_env_47___r4_numbers_6_5, _max___r4_numbers_6_51562, va_generic_entry, _max___r4_numbers_6_5, -2 );
DEFINE_EXPORT_PROCEDURE( acos_env_195___r4_numbers_6_5, _acos___r4_numbers_6_51563, _acos___r4_numbers_6_5, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( abs_env_196___r4_numbers_6_5, _abs___r4_numbers_6_51564, _abs___r4_numbers_6_5, 0L, 1 );



/* module-initialization */
obj_t module_initialization_70___r4_numbers_6_5(long checksum_1979, char * from_1980)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___r4_numbers_6_5))
{ 
require_initialization_114___r4_numbers_6_5 = 
BBOOL(((bool_t)0)); 
imported_modules_init_94___r4_numbers_6_5(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* number? */
bool_t number__102___r4_numbers_6_5(obj_t obj_1)
{ AN_OBJECT;
{ /* Ieee/number.scm 137 */
if(
INTEGERP(obj_1))
{ /* Ieee/number.scm 138 */
return ((bool_t)1);}  else 
{ /* Ieee/number.scm 138 */
return 
REALP(obj_1);} } 
}



/* _number? */
obj_t _number__137___r4_numbers_6_5(obj_t env_1846, obj_t obj_1847)
{ AN_OBJECT;
{ /* Ieee/number.scm 137 */
{ /* Ieee/number.scm 137 */
bool_t aux_1988;
{ /* Ieee/number.scm 137 */
bool_t res1479_1972;
{ /* Ieee/number.scm 137 */
obj_t obj_1971;
obj_1971 = obj_1847; 
if(
INTEGERP(obj_1971))
{ /* Ieee/number.scm 138 */
res1479_1972 = ((bool_t)1); }  else 
{ /* Ieee/number.scm 138 */
res1479_1972 = 
REALP(obj_1971); } } 
aux_1988 = res1479_1972; } 
return 
BBOOL(aux_1988);} } 
}



/* exact? */
bool_t exact__189___r4_numbers_6_5(obj_t z_2)
{ AN_OBJECT;
{ /* Ieee/number.scm 145 */
return 
INTEGERP(z_2);} 
}



/* _exact? */
obj_t _exact__208___r4_numbers_6_5(obj_t env_1848, obj_t z_1849)
{ AN_OBJECT;
{ /* Ieee/number.scm 145 */
{ /* Ieee/number.scm 145 */
bool_t aux_1994;
{ /* Ieee/number.scm 145 */
obj_t z_1973;
z_1973 = z_1849; 
aux_1994 = 
INTEGERP(z_1973); } 
return 
BBOOL(aux_1994);} } 
}



/* inexact? */
bool_t inexact__139___r4_numbers_6_5(obj_t z_3)
{ AN_OBJECT;
{ /* Ieee/number.scm 151 */
return 
REALP(z_3);} 
}



/* _inexact? */
obj_t _inexact__53___r4_numbers_6_5(obj_t env_1850, obj_t z_1851)
{ AN_OBJECT;
{ /* Ieee/number.scm 151 */
{ /* Ieee/number.scm 151 */
bool_t aux_1998;
{ /* Ieee/number.scm 151 */
obj_t z_1974;
z_1974 = z_1851; 
aux_1998 = 
REALP(z_1974); } 
return 
BBOOL(aux_1998);} } 
}



/* complex? */
bool_t complex__118___r4_numbers_6_5(obj_t x_4)
{ AN_OBJECT;
{ /* Ieee/number.scm 157 */
if(
INTEGERP(x_4))
{ /* Ieee/number.scm 138 */
return ((bool_t)1);}  else 
{ /* Ieee/number.scm 138 */
return 
REALP(x_4);} } 
}



/* _complex? */
obj_t _complex__176___r4_numbers_6_5(obj_t env_1852, obj_t x_1853)
{ AN_OBJECT;
{ /* Ieee/number.scm 157 */
{ /* Ieee/number.scm 157 */
bool_t aux_2004;
aux_2004 = 
complex__118___r4_numbers_6_5(x_1853); 
return 
BBOOL(aux_2004);} } 
}



/* rational? */
bool_t rational__51___r4_numbers_6_5(obj_t x_5)
{ AN_OBJECT;
{ /* Ieee/number.scm 163 */
if(
INTEGERP(x_5))
{ /* ./Ieee/flonum.scm 3411 */
return ((bool_t)1);}  else 
{ /* ./Ieee/flonum.scm 3411 */
return 
REALP(x_5);} } 
}



/* _rational? */
obj_t _rational__24___r4_numbers_6_5(obj_t env_1854, obj_t x_1855)
{ AN_OBJECT;
{ /* Ieee/number.scm 163 */
{ /* Ieee/number.scm 163 */
bool_t aux_2010;
aux_2010 = 
rational__51___r4_numbers_6_5(x_1855); 
return 
BBOOL(aux_2010);} } 
}



/* flonum->fixnum */
long flonum__fixnum_11___r4_numbers_6_5(obj_t x_6)
{ AN_OBJECT;
{ /* Ieee/number.scm 169 */
{ /* Ieee/number.scm 170 */
double aux_2013;
aux_2013 = 
REAL_TO_DOUBLE(x_6); 
return 
(long)(aux_2013);} } 
}



/* _flonum->fixnum */
obj_t _flonum__fixnum_24___r4_numbers_6_5(obj_t env_1856, obj_t x_1857)
{ AN_OBJECT;
{ /* Ieee/number.scm 169 */
{ /* Ieee/number.scm 169 */
long aux_2016;
{ /* Ieee/number.scm 169 */
obj_t x_1975;
x_1975 = x_1857; 
{ /* Ieee/number.scm 170 */
double aux_2017;
aux_2017 = 
REAL_TO_DOUBLE(x_1975); 
aux_2016 = 
(long)(aux_2017); } } 
return 
BINT(aux_2016);} } 
}



/* fixnum->flonum */
double fixnum__flonum_13___r4_numbers_6_5(obj_t x_7)
{ AN_OBJECT;
{ /* Ieee/number.scm 175 */
{ /* Ieee/number.scm 176 */
long aux_2021;
aux_2021 = 
(long)CINT(x_7); 
return 
(double)(aux_2021);} } 
}



/* _fixnum->flonum */
obj_t _fixnum__flonum_153___r4_numbers_6_5(obj_t env_1858, obj_t x_1859)
{ AN_OBJECT;
{ /* Ieee/number.scm 175 */
{ /* Ieee/number.scm 175 */
double aux_2024;
{ /* Ieee/number.scm 175 */
obj_t x_1976;
x_1976 = x_1859; 
{ /* Ieee/number.scm 176 */
long aux_2025;
aux_2025 = 
(long)CINT(x_1976); 
aux_2024 = 
(double)(aux_2025); } } 
return 
make_real(aux_2024);} } 
}



/* 2= */
bool_t _2__95___r4_numbers_6_5(obj_t x_8, obj_t y_9)
{ AN_OBJECT;
{ /* Ieee/number.scm 181 */
if(
INTEGERP(x_8))
{ /* Ieee/number.scm 183 */
if(
INTEGERP(y_9))
{ /* Ieee/number.scm 185 */
{ /* ./Ieee/fixnum.scm 2221 */
long aux_2035;long aux_2033;
aux_2035 = 
(long)CINT(y_9); 
aux_2033 = 
(long)CINT(x_8); 
return 
(aux_2033==aux_2035);} }  else 
{ /* Ieee/number.scm 185 */
if(
REALP(y_9))
{ /* Ieee/number.scm 187 */
{ /* Ieee/number.scm 188 */
double arg1016_343;
{ /* Ieee/number.scm 176 */
long aux_2040;
aux_2040 = 
(long)CINT(x_8); 
arg1016_343 = 
(double)(aux_2040); } 
{ /* ./Ieee/flonum.scm 3425 */
double aux_2043;
aux_2043 = 
REAL_TO_DOUBLE(y_9); 
return 
(arg1016_343==aux_2043);} } }  else 
{ /* Ieee/number.scm 187 */
FAILURE(string1444___r4_numbers_6_5,string1445___r4_numbers_6_5,y_9);} } }  else 
{ /* Ieee/number.scm 183 */
if(
REALP(x_8))
{ /* Ieee/number.scm 191 */
if(
REALP(y_9))
{ /* Ieee/number.scm 193 */
{ /* ./Ieee/flonum.scm 3425 */
double aux_2053;double aux_2051;
aux_2053 = 
REAL_TO_DOUBLE(y_9); 
aux_2051 = 
REAL_TO_DOUBLE(x_8); 
return 
(aux_2051==aux_2053);} }  else 
{ /* Ieee/number.scm 193 */
if(
INTEGERP(y_9))
{ /* Ieee/number.scm 195 */
{ /* Ieee/number.scm 196 */
double arg1020_347;
{ /* Ieee/number.scm 176 */
long aux_2058;
aux_2058 = 
(long)CINT(y_9); 
arg1020_347 = 
(double)(aux_2058); } 
{ /* ./Ieee/flonum.scm 3425 */
double aux_2061;
aux_2061 = 
REAL_TO_DOUBLE(x_8); 
return 
(aux_2061==arg1020_347);} } }  else 
{ /* Ieee/number.scm 195 */
FAILURE(string1444___r4_numbers_6_5,string1445___r4_numbers_6_5,y_9);} } }  else 
{ /* Ieee/number.scm 191 */
FAILURE(string1444___r4_numbers_6_5,string1445___r4_numbers_6_5,x_8);} } } 
}



/* _2= */
obj_t _2__245___r4_numbers_6_5(obj_t env_1860, obj_t x_1861, obj_t y_1862)
{ AN_OBJECT;
{ /* Ieee/number.scm 181 */
{ /* Ieee/number.scm 181 */
bool_t aux_2066;
aux_2066 = 
_2__95___r4_numbers_6_5(x_1861, y_1862); 
return 
BBOOL(aux_2066);} } 
}



/* = */
bool_t __147___r4_numbers_6_5(obj_t x_10, obj_t y_11, obj_t z_12)
{ AN_OBJECT;
{ /* Ieee/number.scm 205 */
{ /* Ieee/number.scm 212 */
bool_t _andtest_1002_840;
_andtest_1002_840 = 
_2__95___r4_numbers_6_5(x_10, y_11); 
if(_andtest_1002_840)
{ 
obj_t z_842;
z_842 = z_12; 
__list_168_841:
if(
NULLP(z_842))
{ /* Ieee/number.scm 208 */
return ((bool_t)1);}  else 
{ /* Ieee/number.scm 209 */
bool_t test1023_844;
test1023_844 = 
_2__95___r4_numbers_6_5(y_11, 
CAR(z_842)); 
if(test1023_844)
{ /* Ieee/number.scm 209 */
{ 
obj_t z_2076;
z_2076 = 
CDR(z_842); 
z_842 = z_2076; 
goto __list_168_841;} }  else 
{ /* Ieee/number.scm 209 */
return ((bool_t)0);} } }  else 
{ /* Ieee/number.scm 212 */
return ((bool_t)0);} } } 
}



/* _= */
obj_t ___44___r4_numbers_6_5(obj_t env_1863, obj_t x_1864, obj_t y_1865, obj_t z_1866)
{ AN_OBJECT;
{ /* Ieee/number.scm 205 */
{ /* Ieee/number.scm 205 */
bool_t aux_2078;
aux_2078 = 
__147___r4_numbers_6_5(x_1864, y_1865, z_1866); 
return 
BBOOL(aux_2078);} } 
}



/* 2< */
bool_t _2__116___r4_numbers_6_5(obj_t x_13, obj_t y_14)
{ AN_OBJECT;
{ /* Ieee/number.scm 218 */
if(
INTEGERP(x_13))
{ /* Ieee/number.scm 220 */
if(
INTEGERP(y_14))
{ /* Ieee/number.scm 222 */
{ /* ./Ieee/fixnum.scm 2227 */
long aux_2087;long aux_2085;
aux_2087 = 
(long)CINT(y_14); 
aux_2085 = 
(long)CINT(x_13); 
return 
(aux_2085<aux_2087);} }  else 
{ /* Ieee/number.scm 222 */
if(
REALP(y_14))
{ /* Ieee/number.scm 224 */
{ /* Ieee/number.scm 225 */
double arg1029_361;
{ /* Ieee/number.scm 176 */
long aux_2092;
aux_2092 = 
(long)CINT(x_13); 
arg1029_361 = 
(double)(aux_2092); } 
{ /* ./Ieee/flonum.scm 3431 */
double aux_2095;
aux_2095 = 
REAL_TO_DOUBLE(y_14); 
return 
(arg1029_361<aux_2095);} } }  else 
{ /* Ieee/number.scm 224 */
FAILURE(string1446___r4_numbers_6_5,string1445___r4_numbers_6_5,y_14);} } }  else 
{ /* Ieee/number.scm 220 */
if(
REALP(x_13))
{ /* Ieee/number.scm 228 */
if(
REALP(y_14))
{ /* Ieee/number.scm 230 */
{ /* ./Ieee/flonum.scm 3431 */
double aux_2105;double aux_2103;
aux_2105 = 
REAL_TO_DOUBLE(y_14); 
aux_2103 = 
REAL_TO_DOUBLE(x_13); 
return 
(aux_2103<aux_2105);} }  else 
{ /* Ieee/number.scm 230 */
if(
INTEGERP(y_14))
{ /* Ieee/number.scm 232 */
{ /* Ieee/number.scm 233 */
double arg1033_365;
{ /* Ieee/number.scm 176 */
long aux_2110;
aux_2110 = 
(long)CINT(y_14); 
arg1033_365 = 
(double)(aux_2110); } 
{ /* ./Ieee/flonum.scm 3431 */
double aux_2113;
aux_2113 = 
REAL_TO_DOUBLE(x_13); 
return 
(aux_2113<arg1033_365);} } }  else 
{ /* Ieee/number.scm 232 */
FAILURE(string1446___r4_numbers_6_5,string1445___r4_numbers_6_5,y_14);} } }  else 
{ /* Ieee/number.scm 228 */
FAILURE(string1446___r4_numbers_6_5,string1445___r4_numbers_6_5,x_13);} } } 
}



/* _2< */
obj_t _2__208___r4_numbers_6_5(obj_t env_1867, obj_t x_1868, obj_t y_1869)
{ AN_OBJECT;
{ /* Ieee/number.scm 218 */
{ /* Ieee/number.scm 218 */
bool_t aux_2118;
aux_2118 = 
_2__116___r4_numbers_6_5(x_1868, y_1869); 
return 
BBOOL(aux_2118);} } 
}



/* < */
bool_t __124___r4_numbers_6_5(obj_t x_15, obj_t y_16, obj_t z_17)
{ AN_OBJECT;
{ /* Ieee/number.scm 242 */
{ /* Ieee/number.scm 249 */
bool_t _andtest_1003_899;
_andtest_1003_899 = 
_2__116___r4_numbers_6_5(x_15, y_16); 
if(_andtest_1003_899)
{ 
obj_t x_901;obj_t z_902;
x_901 = y_16; 
z_902 = z_17; 
__list_80_900:
if(
NULLP(z_902))
{ /* Ieee/number.scm 245 */
return ((bool_t)1);}  else 
{ /* Ieee/number.scm 246 */
bool_t test1036_909;
test1036_909 = 
_2__116___r4_numbers_6_5(x_901, 
CAR(z_902)); 
if(test1036_909)
{ /* Ieee/number.scm 246 */
{ 
obj_t z_2130;obj_t x_2128;
x_2128 = 
CAR(z_902); 
z_2130 = 
CDR(z_902); 
z_902 = z_2130; 
x_901 = x_2128; 
goto __list_80_900;} }  else 
{ /* Ieee/number.scm 246 */
return ((bool_t)0);} } }  else 
{ /* Ieee/number.scm 249 */
return ((bool_t)0);} } } 
}



/* _< */
obj_t ___38___r4_numbers_6_5(obj_t env_1870, obj_t x_1871, obj_t y_1872, obj_t z_1873)
{ AN_OBJECT;
{ /* Ieee/number.scm 242 */
{ /* Ieee/number.scm 242 */
bool_t aux_2132;
aux_2132 = 
__124___r4_numbers_6_5(x_1871, y_1872, z_1873); 
return 
BBOOL(aux_2132);} } 
}



/* 2> */
bool_t _2__206___r4_numbers_6_5(obj_t x_18, obj_t y_19)
{ AN_OBJECT;
{ /* Ieee/number.scm 256 */
if(
INTEGERP(x_18))
{ /* Ieee/number.scm 258 */
if(
INTEGERP(y_19))
{ /* Ieee/number.scm 260 */
{ /* ./Ieee/fixnum.scm 2233 */
long aux_2141;long aux_2139;
aux_2141 = 
(long)CINT(y_19); 
aux_2139 = 
(long)CINT(x_18); 
return 
(aux_2139>aux_2141);} }  else 
{ /* Ieee/number.scm 260 */
if(
REALP(y_19))
{ /* Ieee/number.scm 262 */
{ /* Ieee/number.scm 263 */
double arg1044_380;
{ /* Ieee/number.scm 176 */
long aux_2146;
aux_2146 = 
(long)CINT(x_18); 
arg1044_380 = 
(double)(aux_2146); } 
{ /* ./Ieee/flonum.scm 3437 */
double aux_2149;
aux_2149 = 
REAL_TO_DOUBLE(y_19); 
return 
(arg1044_380>aux_2149);} } }  else 
{ /* Ieee/number.scm 262 */
FAILURE(string1447___r4_numbers_6_5,string1445___r4_numbers_6_5,y_19);} } }  else 
{ /* Ieee/number.scm 258 */
if(
REALP(x_18))
{ /* Ieee/number.scm 266 */
if(
REALP(y_19))
{ /* Ieee/number.scm 268 */
{ /* ./Ieee/flonum.scm 3437 */
double aux_2159;double aux_2157;
aux_2159 = 
REAL_TO_DOUBLE(y_19); 
aux_2157 = 
REAL_TO_DOUBLE(x_18); 
return 
(aux_2157>aux_2159);} }  else 
{ /* Ieee/number.scm 268 */
if(
INTEGERP(y_19))
{ /* Ieee/number.scm 270 */
{ /* Ieee/number.scm 271 */
double arg1048_384;
{ /* Ieee/number.scm 176 */
long aux_2164;
aux_2164 = 
(long)CINT(y_19); 
arg1048_384 = 
(double)(aux_2164); } 
{ /* ./Ieee/flonum.scm 3437 */
double aux_2167;
aux_2167 = 
REAL_TO_DOUBLE(x_18); 
return 
(aux_2167>arg1048_384);} } }  else 
{ /* Ieee/number.scm 270 */
FAILURE(string1447___r4_numbers_6_5,string1445___r4_numbers_6_5,y_19);} } }  else 
{ /* Ieee/number.scm 266 */
FAILURE(string1447___r4_numbers_6_5,string1445___r4_numbers_6_5,x_18);} } } 
}



/* _2> */
obj_t _2__130___r4_numbers_6_5(obj_t env_1874, obj_t x_1875, obj_t y_1876)
{ AN_OBJECT;
{ /* Ieee/number.scm 256 */
{ /* Ieee/number.scm 256 */
bool_t aux_2172;
aux_2172 = 
_2__206___r4_numbers_6_5(x_1875, y_1876); 
return 
BBOOL(aux_2172);} } 
}



/* > */
bool_t __172___r4_numbers_6_5(obj_t x_20, obj_t y_21, obj_t z_22)
{ AN_OBJECT;
{ /* Ieee/number.scm 280 */
{ /* Ieee/number.scm 287 */
bool_t _andtest_1004_970;
_andtest_1004_970 = 
_2__206___r4_numbers_6_5(x_20, y_21); 
if(_andtest_1004_970)
{ 
obj_t x_972;obj_t z_973;
x_972 = y_21; 
z_973 = z_22; 
__list_166_971:
if(
NULLP(z_973))
{ /* Ieee/number.scm 283 */
return ((bool_t)1);}  else 
{ /* Ieee/number.scm 284 */
bool_t test1051_980;
test1051_980 = 
_2__206___r4_numbers_6_5(x_972, 
CAR(z_973)); 
if(test1051_980)
{ /* Ieee/number.scm 284 */
{ 
obj_t z_2184;obj_t x_2182;
x_2182 = 
CAR(z_973); 
z_2184 = 
CDR(z_973); 
z_973 = z_2184; 
x_972 = x_2182; 
goto __list_166_971;} }  else 
{ /* Ieee/number.scm 284 */
return ((bool_t)0);} } }  else 
{ /* Ieee/number.scm 287 */
return ((bool_t)0);} } } 
}



/* _> */
obj_t ___149___r4_numbers_6_5(obj_t env_1877, obj_t x_1878, obj_t y_1879, obj_t z_1880)
{ AN_OBJECT;
{ /* Ieee/number.scm 280 */
{ /* Ieee/number.scm 280 */
bool_t aux_2186;
aux_2186 = 
__172___r4_numbers_6_5(x_1878, y_1879, z_1880); 
return 
BBOOL(aux_2186);} } 
}



/* 2<= */
bool_t _2___241___r4_numbers_6_5(obj_t x_23, obj_t y_24)
{ AN_OBJECT;
{ /* Ieee/number.scm 293 */
if(
INTEGERP(x_23))
{ /* Ieee/number.scm 295 */
if(
INTEGERP(y_24))
{ /* Ieee/number.scm 297 */
{ /* ./Ieee/fixnum.scm 2239 */
long aux_2195;long aux_2193;
aux_2195 = 
(long)CINT(y_24); 
aux_2193 = 
(long)CINT(x_23); 
return 
(aux_2193<=aux_2195);} }  else 
{ /* Ieee/number.scm 297 */
if(
REALP(y_24))
{ /* Ieee/number.scm 299 */
{ /* Ieee/number.scm 300 */
double arg1061_399;
{ /* Ieee/number.scm 176 */
long aux_2200;
aux_2200 = 
(long)CINT(x_23); 
arg1061_399 = 
(double)(aux_2200); } 
{ /* ./Ieee/flonum.scm 3443 */
double aux_2203;
aux_2203 = 
REAL_TO_DOUBLE(y_24); 
return 
(arg1061_399<=aux_2203);} } }  else 
{ /* Ieee/number.scm 299 */
FAILURE(string1448___r4_numbers_6_5,string1445___r4_numbers_6_5,y_24);} } }  else 
{ /* Ieee/number.scm 295 */
if(
REALP(x_23))
{ /* Ieee/number.scm 303 */
if(
REALP(y_24))
{ /* Ieee/number.scm 305 */
{ /* ./Ieee/flonum.scm 3443 */
double aux_2213;double aux_2211;
aux_2213 = 
REAL_TO_DOUBLE(y_24); 
aux_2211 = 
REAL_TO_DOUBLE(x_23); 
return 
(aux_2211<=aux_2213);} }  else 
{ /* Ieee/number.scm 305 */
if(
INTEGERP(y_24))
{ /* Ieee/number.scm 307 */
{ /* Ieee/number.scm 308 */
double arg1065_403;
{ /* Ieee/number.scm 176 */
long aux_2218;
aux_2218 = 
(long)CINT(y_24); 
arg1065_403 = 
(double)(aux_2218); } 
{ /* ./Ieee/flonum.scm 3443 */
double aux_2221;
aux_2221 = 
REAL_TO_DOUBLE(x_23); 
return 
(aux_2221<=arg1065_403);} } }  else 
{ /* Ieee/number.scm 307 */
FAILURE(string1448___r4_numbers_6_5,string1445___r4_numbers_6_5,y_24);} } }  else 
{ /* Ieee/number.scm 303 */
FAILURE(string1448___r4_numbers_6_5,string1445___r4_numbers_6_5,x_23);} } } 
}



/* _2<= */
obj_t _2___117___r4_numbers_6_5(obj_t env_1881, obj_t x_1882, obj_t y_1883)
{ AN_OBJECT;
{ /* Ieee/number.scm 293 */
{ /* Ieee/number.scm 293 */
bool_t aux_2226;
aux_2226 = 
_2___241___r4_numbers_6_5(x_1882, y_1883); 
return 
BBOOL(aux_2226);} } 
}



/* <= */
bool_t ___161___r4_numbers_6_5(obj_t x_25, obj_t y_26, obj_t z_27)
{ AN_OBJECT;
{ /* Ieee/number.scm 317 */
{ /* Ieee/number.scm 324 */
bool_t _andtest_1005_1041;
_andtest_1005_1041 = 
_2___241___r4_numbers_6_5(x_25, y_26); 
if(_andtest_1005_1041)
{ 
obj_t x_1043;obj_t z_1044;
x_1043 = y_26; 
z_1044 = z_27; 
___list_79_1042:
if(
NULLP(z_1044))
{ /* Ieee/number.scm 320 */
return ((bool_t)1);}  else 
{ /* Ieee/number.scm 321 */
bool_t test1068_1051;
test1068_1051 = 
_2___241___r4_numbers_6_5(x_1043, 
CAR(z_1044)); 
if(test1068_1051)
{ /* Ieee/number.scm 321 */
{ 
obj_t z_2238;obj_t x_2236;
x_2236 = 
CAR(z_1044); 
z_2238 = 
CDR(z_1044); 
z_1044 = z_2238; 
x_1043 = x_2236; 
goto ___list_79_1042;} }  else 
{ /* Ieee/number.scm 321 */
return ((bool_t)0);} } }  else 
{ /* Ieee/number.scm 324 */
return ((bool_t)0);} } } 
}



/* _<= */
obj_t ____73___r4_numbers_6_5(obj_t env_1884, obj_t x_1885, obj_t y_1886, obj_t z_1887)
{ AN_OBJECT;
{ /* Ieee/number.scm 317 */
{ /* Ieee/number.scm 317 */
bool_t aux_2240;
aux_2240 = 
___161___r4_numbers_6_5(x_1885, y_1886, z_1887); 
return 
BBOOL(aux_2240);} } 
}



/* 2>= */
bool_t _2___235___r4_numbers_6_5(obj_t x_28, obj_t y_29)
{ AN_OBJECT;
{ /* Ieee/number.scm 330 */
if(
INTEGERP(x_28))
{ /* Ieee/number.scm 332 */
if(
INTEGERP(y_29))
{ /* Ieee/number.scm 334 */
{ /* ./Ieee/fixnum.scm 2245 */
long aux_2249;long aux_2247;
aux_2249 = 
(long)CINT(y_29); 
aux_2247 = 
(long)CINT(x_28); 
return 
(aux_2247>=aux_2249);} }  else 
{ /* Ieee/number.scm 334 */
if(
REALP(y_29))
{ /* Ieee/number.scm 336 */
{ /* Ieee/number.scm 337 */
double arg1075_418;
{ /* Ieee/number.scm 176 */
long aux_2254;
aux_2254 = 
(long)CINT(x_28); 
arg1075_418 = 
(double)(aux_2254); } 
{ /* ./Ieee/flonum.scm 3449 */
double aux_2257;
aux_2257 = 
REAL_TO_DOUBLE(y_29); 
return 
(arg1075_418>=aux_2257);} } }  else 
{ /* Ieee/number.scm 336 */
FAILURE(string1449___r4_numbers_6_5,string1445___r4_numbers_6_5,y_29);} } }  else 
{ /* Ieee/number.scm 332 */
if(
REALP(x_28))
{ /* Ieee/number.scm 340 */
if(
REALP(y_29))
{ /* Ieee/number.scm 342 */
{ /* ./Ieee/flonum.scm 3449 */
double aux_2267;double aux_2265;
aux_2267 = 
REAL_TO_DOUBLE(y_29); 
aux_2265 = 
REAL_TO_DOUBLE(x_28); 
return 
(aux_2265>=aux_2267);} }  else 
{ /* Ieee/number.scm 342 */
if(
INTEGERP(y_29))
{ /* Ieee/number.scm 344 */
{ /* Ieee/number.scm 345 */
double arg1079_422;
{ /* Ieee/number.scm 176 */
long aux_2272;
aux_2272 = 
(long)CINT(y_29); 
arg1079_422 = 
(double)(aux_2272); } 
{ /* ./Ieee/flonum.scm 3449 */
double aux_2275;
aux_2275 = 
REAL_TO_DOUBLE(x_28); 
return 
(aux_2275>=arg1079_422);} } }  else 
{ /* Ieee/number.scm 344 */
FAILURE(string1449___r4_numbers_6_5,string1445___r4_numbers_6_5,y_29);} } }  else 
{ /* Ieee/number.scm 340 */
FAILURE(string1449___r4_numbers_6_5,string1445___r4_numbers_6_5,x_28);} } } 
}



/* _2>= */
obj_t _2___43___r4_numbers_6_5(obj_t env_1888, obj_t x_1889, obj_t y_1890)
{ AN_OBJECT;
{ /* Ieee/number.scm 330 */
{ /* Ieee/number.scm 330 */
bool_t aux_2280;
aux_2280 = 
_2___235___r4_numbers_6_5(x_1889, y_1890); 
return 
BBOOL(aux_2280);} } 
}



/* >= */
bool_t ___239___r4_numbers_6_5(obj_t x_30, obj_t y_31, obj_t z_32)
{ AN_OBJECT;
{ /* Ieee/number.scm 354 */
{ /* Ieee/number.scm 361 */
bool_t _andtest_1006_1112;
_andtest_1006_1112 = 
_2___235___r4_numbers_6_5(x_30, y_31); 
if(_andtest_1006_1112)
{ 
obj_t x_1114;obj_t z_1115;
x_1114 = y_31; 
z_1115 = z_32; 
___list_225_1113:
if(
NULLP(z_1115))
{ /* Ieee/number.scm 357 */
return ((bool_t)1);}  else 
{ /* Ieee/number.scm 358 */
bool_t test1082_1122;
test1082_1122 = 
_2___235___r4_numbers_6_5(x_1114, 
CAR(z_1115)); 
if(test1082_1122)
{ /* Ieee/number.scm 358 */
{ 
obj_t z_2292;obj_t x_2290;
x_2290 = 
CAR(z_1115); 
z_2292 = 
CDR(z_1115); 
z_1115 = z_2292; 
x_1114 = x_2290; 
goto ___list_225_1113;} }  else 
{ /* Ieee/number.scm 358 */
return ((bool_t)0);} } }  else 
{ /* Ieee/number.scm 361 */
return ((bool_t)0);} } } 
}



/* _>= */
obj_t ____251___r4_numbers_6_5(obj_t env_1891, obj_t x_1892, obj_t y_1893, obj_t z_1894)
{ AN_OBJECT;
{ /* Ieee/number.scm 354 */
{ /* Ieee/number.scm 354 */
bool_t aux_2294;
aux_2294 = 
___239___r4_numbers_6_5(x_1892, y_1893, z_1894); 
return 
BBOOL(aux_2294);} } 
}



/* zero? */
bool_t zero__228___r4_numbers_6_5(obj_t x_33)
{ AN_OBJECT;
{ /* Ieee/number.scm 367 */
if(
INTEGERP(x_33))
{ /* Ieee/number.scm 369 */
{ /* ./Ieee/fixnum.scm 2221 */
long aux_2299;
aux_2299 = 
(long)CINT(x_33); 
return 
(aux_2299==((long)0));} }  else 
{ /* Ieee/number.scm 369 */
if(
REALP(x_33))
{ /* Ieee/number.scm 371 */
{ /* ./Ieee/flonum.scm 3425 */
double aux_2304;
aux_2304 = 
REAL_TO_DOUBLE(x_33); 
return 
(aux_2304==((double)0.0));} }  else 
{ /* Ieee/number.scm 371 */
FAILURE(string1450___r4_numbers_6_5,string1445___r4_numbers_6_5,x_33);} } } 
}



/* _zero? */
obj_t _zero__222___r4_numbers_6_5(obj_t env_1895, obj_t x_1896)
{ AN_OBJECT;
{ /* Ieee/number.scm 367 */
{ /* Ieee/number.scm 367 */
bool_t aux_2308;
aux_2308 = 
zero__228___r4_numbers_6_5(x_1896); 
return 
BBOOL(aux_2308);} } 
}



/* positive? */
bool_t positive__57___r4_numbers_6_5(obj_t x_34)
{ AN_OBJECT;
{ /* Ieee/number.scm 379 */
if(
INTEGERP(x_34))
{ /* Ieee/number.scm 381 */
{ /* ./Ieee/fixnum.scm 2233 */
long aux_2313;
aux_2313 = 
(long)CINT(x_34); 
return 
(aux_2313>((long)0));} }  else 
{ /* Ieee/number.scm 381 */
if(
REALP(x_34))
{ /* Ieee/number.scm 383 */
{ /* ./Ieee/flonum.scm 3437 */
double aux_2318;
aux_2318 = 
REAL_TO_DOUBLE(x_34); 
return 
(aux_2318>((double)0.0));} }  else 
{ /* Ieee/number.scm 383 */
FAILURE(string1451___r4_numbers_6_5,string1445___r4_numbers_6_5,x_34);} } } 
}



/* _positive? */
obj_t _positive__177___r4_numbers_6_5(obj_t env_1897, obj_t x_1898)
{ AN_OBJECT;
{ /* Ieee/number.scm 379 */
{ /* Ieee/number.scm 379 */
bool_t aux_2322;
aux_2322 = 
positive__57___r4_numbers_6_5(x_1898); 
return 
BBOOL(aux_2322);} } 
}



/* negative? */
bool_t negative__33___r4_numbers_6_5(obj_t x_35)
{ AN_OBJECT;
{ /* Ieee/number.scm 391 */
if(
INTEGERP(x_35))
{ /* Ieee/number.scm 393 */
{ /* ./Ieee/fixnum.scm 2227 */
long aux_2327;
aux_2327 = 
(long)CINT(x_35); 
return 
(aux_2327<((long)0));} }  else 
{ /* Ieee/number.scm 393 */
if(
REALP(x_35))
{ /* Ieee/number.scm 395 */
{ /* ./Ieee/flonum.scm 3431 */
double aux_2332;
aux_2332 = 
REAL_TO_DOUBLE(x_35); 
return 
(aux_2332<((double)0.0));} }  else 
{ /* Ieee/number.scm 395 */
FAILURE(string1452___r4_numbers_6_5,string1445___r4_numbers_6_5,x_35);} } } 
}



/* _negative? */
obj_t _negative__187___r4_numbers_6_5(obj_t env_1899, obj_t x_1900)
{ AN_OBJECT;
{ /* Ieee/number.scm 391 */
{ /* Ieee/number.scm 391 */
bool_t aux_2336;
aux_2336 = 
negative__33___r4_numbers_6_5(x_1900); 
return 
BBOOL(aux_2336);} } 
}



/* max */
obj_t max___r4_numbers_6_5(obj_t x_36, obj_t y_37)
{ AN_OBJECT;
{ /* Ieee/number.scm 403 */
{ 
obj_t x_1184;obj_t y_1185;
x_1184 = x_36; 
y_1185 = y_37; 
loop_1183:
if(
PAIRP(y_1185))
{ /* Ieee/number.scm 407 */
obj_t arg1093_1192;obj_t arg1094_1193;
{ /* Ieee/number.scm 407 */
bool_t test1095_1194;
test1095_1194 = 
_2__206___r4_numbers_6_5(x_1184, 
CAR(y_1185)); 
if(test1095_1194)
{ /* Ieee/number.scm 407 */
arg1093_1192 = x_1184; }  else 
{ /* Ieee/number.scm 407 */
arg1093_1192 = 
CAR(y_1185); } } 
arg1094_1193 = 
CDR(y_1185); 
{ 
obj_t y_2347;obj_t x_2346;
x_2346 = arg1093_1192; 
y_2347 = arg1094_1193; 
y_1185 = y_2347; 
x_1184 = x_2346; 
goto loop_1183;} }  else 
{ /* Ieee/number.scm 406 */
return x_1184;} } } 
}



/* _max */
obj_t _max___r4_numbers_6_5(obj_t env_1901, obj_t x_1902, obj_t y_1903)
{ AN_OBJECT;
{ /* Ieee/number.scm 403 */
return 
max___r4_numbers_6_5(x_1902, y_1903);} 
}



/* min */
obj_t min___r4_numbers_6_5(obj_t x_38, obj_t y_39)
{ AN_OBJECT;
{ /* Ieee/number.scm 416 */
{ 
obj_t x_1221;obj_t y_1222;
x_1221 = x_38; 
y_1222 = y_39; 
loop_1220:
if(
PAIRP(y_1222))
{ /* Ieee/number.scm 420 */
obj_t arg1098_1229;obj_t arg1099_1230;
{ /* Ieee/number.scm 420 */
bool_t test1100_1231;
test1100_1231 = 
_2__116___r4_numbers_6_5(x_1221, 
CAR(y_1222)); 
if(test1100_1231)
{ /* Ieee/number.scm 420 */
arg1098_1229 = x_1221; }  else 
{ /* Ieee/number.scm 420 */
arg1098_1229 = 
CAR(y_1222); } } 
arg1099_1230 = 
CDR(y_1222); 
{ 
obj_t y_2357;obj_t x_2356;
x_2356 = arg1098_1229; 
y_2357 = arg1099_1230; 
y_1222 = y_2357; 
x_1221 = x_2356; 
goto loop_1220;} }  else 
{ /* Ieee/number.scm 419 */
return x_1221;} } } 
}



/* _min */
obj_t _min___r4_numbers_6_5(obj_t env_1904, obj_t x_1905, obj_t y_1906)
{ AN_OBJECT;
{ /* Ieee/number.scm 416 */
return 
min___r4_numbers_6_5(x_1905, y_1906);} 
}



/* 2+ */
obj_t _2__168___r4_numbers_6_5(obj_t x_40, obj_t y_41)
{ AN_OBJECT;
{ /* Ieee/number.scm 429 */
if(
INTEGERP(x_40))
{ /* Ieee/number.scm 431 */
if(
INTEGERP(y_41))
{ /* Ieee/number.scm 433 */
{ /* ./Ieee/fixnum.scm 2305 */
long aux_2363;
{ /* ./Ieee/fixnum.scm 2305 */
long aux_2366;long aux_2364;
aux_2366 = 
(long)CINT(y_41); 
aux_2364 = 
(long)CINT(x_40); 
aux_2363 = 
(aux_2364+aux_2366); } 
return 
BINT(aux_2363);} }  else 
{ /* Ieee/number.scm 433 */
if(
REALP(y_41))
{ /* Ieee/number.scm 435 */
{ /* Ieee/number.scm 436 */
double arg1105_459;
{ /* Ieee/number.scm 176 */
long aux_2372;
aux_2372 = 
(long)CINT(x_40); 
arg1105_459 = 
(double)(aux_2372); } 
{ /* ./Ieee/flonum.scm 3473 */
double aux_2375;
{ /* ./Ieee/flonum.scm 3473 */
double aux_2376;
aux_2376 = 
REAL_TO_DOUBLE(y_41); 
aux_2375 = 
(arg1105_459+aux_2376); } 
return 
make_real(aux_2375);} } }  else 
{ /* Ieee/number.scm 435 */
FAILURE(string1453___r4_numbers_6_5,string1445___r4_numbers_6_5,y_41);} } }  else 
{ /* Ieee/number.scm 431 */
if(
REALP(x_40))
{ /* Ieee/number.scm 439 */
if(
REALP(y_41))
{ /* Ieee/number.scm 441 */
{ /* ./Ieee/flonum.scm 3473 */
double aux_2385;
{ /* ./Ieee/flonum.scm 3473 */
double aux_2388;double aux_2386;
aux_2388 = 
REAL_TO_DOUBLE(y_41); 
aux_2386 = 
REAL_TO_DOUBLE(x_40); 
aux_2385 = 
(aux_2386+aux_2388); } 
return 
make_real(aux_2385);} }  else 
{ /* Ieee/number.scm 441 */
if(
INTEGERP(y_41))
{ /* Ieee/number.scm 443 */
{ /* Ieee/number.scm 444 */
double arg1109_463;
{ /* Ieee/number.scm 176 */
long aux_2394;
aux_2394 = 
(long)CINT(y_41); 
arg1109_463 = 
(double)(aux_2394); } 
{ /* ./Ieee/flonum.scm 3473 */
double aux_2397;
{ /* ./Ieee/flonum.scm 3473 */
double aux_2398;
aux_2398 = 
REAL_TO_DOUBLE(x_40); 
aux_2397 = 
(aux_2398+arg1109_463); } 
return 
make_real(aux_2397);} } }  else 
{ /* Ieee/number.scm 443 */
FAILURE(string1453___r4_numbers_6_5,string1445___r4_numbers_6_5,y_41);} } }  else 
{ /* Ieee/number.scm 439 */
FAILURE(string1453___r4_numbers_6_5,string1445___r4_numbers_6_5,x_40);} } } 
}



/* _2+ */
obj_t _2__242___r4_numbers_6_5(obj_t env_1907, obj_t x_1908, obj_t y_1909)
{ AN_OBJECT;
{ /* Ieee/number.scm 429 */
return 
_2__168___r4_numbers_6_5(x_1908, y_1909);} 
}



/* + */
obj_t __2___r4_numbers_6_5(obj_t x_42)
{ AN_OBJECT;
{ /* Ieee/number.scm 453 */
{ 
obj_t sum_1283;obj_t x_1284;
sum_1283 = 
BINT(((long)0)); 
x_1284 = x_42; 
loop_1282:
if(
PAIRP(x_1284))
{ /* Ieee/number.scm 457 */
obj_t arg1111_1290;obj_t arg1112_1291;
arg1111_1290 = 
_2__168___r4_numbers_6_5(sum_1283, 
CAR(x_1284)); 
arg1112_1291 = 
CDR(x_1284); 
{ 
obj_t x_2411;obj_t sum_2410;
sum_2410 = arg1111_1290; 
x_2411 = arg1112_1291; 
x_1284 = x_2411; 
sum_1283 = sum_2410; 
goto loop_1282;} }  else 
{ /* Ieee/number.scm 456 */
return sum_1283;} } } 
}



/* _+ */
obj_t ___219___r4_numbers_6_5(obj_t env_1910, obj_t x_1911)
{ AN_OBJECT;
{ /* Ieee/number.scm 453 */
return 
__2___r4_numbers_6_5(x_1911);} 
}



/* 2* */
obj_t _2__198___r4_numbers_6_5(obj_t x_43, obj_t y_44)
{ AN_OBJECT;
{ /* Ieee/number.scm 464 */
if(
INTEGERP(x_43))
{ /* Ieee/number.scm 466 */
if(
INTEGERP(y_44))
{ /* Ieee/number.scm 468 */
{ /* ./Ieee/fixnum.scm 2317 */
long aux_2418;
{ /* ./Ieee/fixnum.scm 2317 */
long aux_2421;long aux_2419;
aux_2421 = 
(long)CINT(y_44); 
aux_2419 = 
(long)CINT(x_43); 
aux_2418 = 
(aux_2419*aux_2421); } 
return 
BINT(aux_2418);} }  else 
{ /* Ieee/number.scm 468 */
if(
REALP(y_44))
{ /* Ieee/number.scm 470 */
{ /* Ieee/number.scm 471 */
double arg1117_474;
{ /* Ieee/number.scm 176 */
long aux_2427;
aux_2427 = 
(long)CINT(x_43); 
arg1117_474 = 
(double)(aux_2427); } 
{ /* ./Ieee/flonum.scm 3485 */
double aux_2430;
{ /* ./Ieee/flonum.scm 3485 */
double aux_2431;
aux_2431 = 
REAL_TO_DOUBLE(y_44); 
aux_2430 = 
(arg1117_474*aux_2431); } 
return 
make_real(aux_2430);} } }  else 
{ /* Ieee/number.scm 470 */
FAILURE(string1454___r4_numbers_6_5,string1445___r4_numbers_6_5,y_44);} } }  else 
{ /* Ieee/number.scm 466 */
if(
REALP(x_43))
{ /* Ieee/number.scm 474 */
if(
REALP(y_44))
{ /* Ieee/number.scm 476 */
{ /* ./Ieee/flonum.scm 3485 */
double aux_2440;
{ /* ./Ieee/flonum.scm 3485 */
double aux_2443;double aux_2441;
aux_2443 = 
REAL_TO_DOUBLE(y_44); 
aux_2441 = 
REAL_TO_DOUBLE(x_43); 
aux_2440 = 
(aux_2441*aux_2443); } 
return 
make_real(aux_2440);} }  else 
{ /* Ieee/number.scm 476 */
if(
INTEGERP(y_44))
{ /* Ieee/number.scm 478 */
{ /* Ieee/number.scm 479 */
double arg1121_478;
{ /* Ieee/number.scm 176 */
long aux_2449;
aux_2449 = 
(long)CINT(y_44); 
arg1121_478 = 
(double)(aux_2449); } 
{ /* ./Ieee/flonum.scm 3485 */
double aux_2452;
{ /* ./Ieee/flonum.scm 3485 */
double aux_2453;
aux_2453 = 
REAL_TO_DOUBLE(x_43); 
aux_2452 = 
(aux_2453*arg1121_478); } 
return 
make_real(aux_2452);} } }  else 
{ /* Ieee/number.scm 478 */
FAILURE(string1454___r4_numbers_6_5,string1445___r4_numbers_6_5,y_44);} } }  else 
{ /* Ieee/number.scm 474 */
FAILURE(string1454___r4_numbers_6_5,string1445___r4_numbers_6_5,x_43);} } } 
}



/* _2* */
obj_t _2__101___r4_numbers_6_5(obj_t env_1912, obj_t x_1913, obj_t y_1914)
{ AN_OBJECT;
{ /* Ieee/number.scm 464 */
return 
_2__198___r4_numbers_6_5(x_1913, y_1914);} 
}



/* * */
obj_t __15___r4_numbers_6_5(obj_t x_45)
{ AN_OBJECT;
{ /* Ieee/number.scm 488 */
{ 
obj_t product_1338;obj_t x_1339;
product_1338 = 
BINT(((long)1)); 
x_1339 = x_45; 
loop_1337:
if(
PAIRP(x_1339))
{ /* Ieee/number.scm 492 */
obj_t arg1123_1345;obj_t arg1124_1346;
arg1123_1345 = 
_2__198___r4_numbers_6_5(product_1338, 
CAR(x_1339)); 
arg1124_1346 = 
CDR(x_1339); 
{ 
obj_t x_2466;obj_t product_2465;
product_2465 = arg1123_1345; 
x_2466 = arg1124_1346; 
x_1339 = x_2466; 
product_1338 = product_2465; 
goto loop_1337;} }  else 
{ /* Ieee/number.scm 491 */
return product_1338;} } } 
}



/* _* */
obj_t ___10___r4_numbers_6_5(obj_t env_1915, obj_t x_1916)
{ AN_OBJECT;
{ /* Ieee/number.scm 488 */
return 
__15___r4_numbers_6_5(x_1916);} 
}



/* 2- */
obj_t _2__79___r4_numbers_6_5(obj_t x_46, obj_t y_47)
{ AN_OBJECT;
{ /* Ieee/number.scm 498 */
if(
INTEGERP(x_46))
{ /* Ieee/number.scm 500 */
if(
INTEGERP(y_47))
{ /* Ieee/number.scm 502 */
{ /* ./Ieee/fixnum.scm 2311 */
long aux_2473;
{ /* ./Ieee/fixnum.scm 2311 */
long aux_2476;long aux_2474;
aux_2476 = 
(long)CINT(y_47); 
aux_2474 = 
(long)CINT(x_46); 
aux_2473 = 
(aux_2474-aux_2476); } 
return 
BINT(aux_2473);} }  else 
{ /* Ieee/number.scm 502 */
if(
REALP(y_47))
{ /* Ieee/number.scm 504 */
{ /* Ieee/number.scm 505 */
double arg1129_489;
{ /* Ieee/number.scm 176 */
long aux_2482;
aux_2482 = 
(long)CINT(x_46); 
arg1129_489 = 
(double)(aux_2482); } 
{ /* ./Ieee/flonum.scm 3479 */
double aux_2485;
{ /* ./Ieee/flonum.scm 3479 */
double aux_2486;
aux_2486 = 
REAL_TO_DOUBLE(y_47); 
aux_2485 = 
(arg1129_489-aux_2486); } 
return 
make_real(aux_2485);} } }  else 
{ /* Ieee/number.scm 504 */
FAILURE(string1455___r4_numbers_6_5,string1445___r4_numbers_6_5,y_47);} } }  else 
{ /* Ieee/number.scm 500 */
if(
REALP(x_46))
{ /* Ieee/number.scm 508 */
if(
REALP(y_47))
{ /* Ieee/number.scm 510 */
{ /* ./Ieee/flonum.scm 3479 */
double aux_2495;
{ /* ./Ieee/flonum.scm 3479 */
double aux_2498;double aux_2496;
aux_2498 = 
REAL_TO_DOUBLE(y_47); 
aux_2496 = 
REAL_TO_DOUBLE(x_46); 
aux_2495 = 
(aux_2496-aux_2498); } 
return 
make_real(aux_2495);} }  else 
{ /* Ieee/number.scm 510 */
if(
INTEGERP(y_47))
{ /* Ieee/number.scm 512 */
{ /* Ieee/number.scm 513 */
double arg1133_493;
{ /* Ieee/number.scm 176 */
long aux_2504;
aux_2504 = 
(long)CINT(y_47); 
arg1133_493 = 
(double)(aux_2504); } 
{ /* ./Ieee/flonum.scm 3479 */
double aux_2507;
{ /* ./Ieee/flonum.scm 3479 */
double aux_2508;
aux_2508 = 
REAL_TO_DOUBLE(x_46); 
aux_2507 = 
(aux_2508-arg1133_493); } 
return 
make_real(aux_2507);} } }  else 
{ /* Ieee/number.scm 512 */
FAILURE(string1455___r4_numbers_6_5,string1445___r4_numbers_6_5,y_47);} } }  else 
{ /* Ieee/number.scm 508 */
FAILURE(string1455___r4_numbers_6_5,string1445___r4_numbers_6_5,x_46);} } } 
}



/* _2- */
obj_t _2__171___r4_numbers_6_5(obj_t env_1917, obj_t x_1918, obj_t y_1919)
{ AN_OBJECT;
{ /* Ieee/number.scm 498 */
return 
_2__79___r4_numbers_6_5(x_1918, y_1919);} 
}



/* - */
obj_t __186___r4_numbers_6_5(obj_t x_48, obj_t y_49)
{ AN_OBJECT;
{ /* Ieee/number.scm 522 */
if(
PAIRP(y_49))
{ /* Ieee/number.scm 524 */
obj_t arg1135_498;obj_t arg1137_499;
arg1135_498 = 
_2__79___r4_numbers_6_5(x_48, 
CAR(y_49)); 
arg1137_499 = 
CDR(y_49); 
{ 
obj_t result_1396;obj_t args_1397;
result_1396 = arg1135_498; 
args_1397 = arg1137_499; 
loop_1395:
if(
PAIRP(args_1397))
{ /* Ieee/number.scm 527 */
obj_t arg1140_1403;obj_t arg1141_1404;
arg1140_1403 = 
_2__79___r4_numbers_6_5(result_1396, 
CAR(args_1397)); 
arg1141_1404 = 
CDR(args_1397); 
{ 
obj_t args_2526;obj_t result_2525;
result_2525 = arg1140_1403; 
args_2526 = arg1141_1404; 
args_1397 = args_2526; 
result_1396 = result_2525; 
goto loop_1395;} }  else 
{ /* Ieee/number.scm 526 */
return result_1396;} } }  else 
{ /* Ieee/number.scm 523 */
return 
_2__79___r4_numbers_6_5(
BINT(((long)0)), x_48);} } 
}



/* _- */
obj_t ___163___r4_numbers_6_5(obj_t env_1920, obj_t x_1921, obj_t y_1922)
{ AN_OBJECT;
{ /* Ieee/number.scm 522 */
return 
__186___r4_numbers_6_5(x_1921, y_1922);} 
}



/* 2/ */
obj_t _2__156___r4_numbers_6_5(obj_t x_50, obj_t y_51)
{ AN_OBJECT;
{ /* Ieee/number.scm 534 */
if(
INTEGERP(x_50))
{ /* Ieee/number.scm 536 */
if(
INTEGERP(y_51))
{ /* Ieee/number.scm 538 */
{ /* Ieee/number.scm 539 */
bool_t test1145_507;
{ /* Ieee/number.scm 539 */
long arg1148_510;
{ /* ./Ieee/fixnum.scm 2349 */
long aux_2536;long aux_2534;
aux_2536 = 
(long)CINT(y_51); 
aux_2534 = 
(long)CINT(x_50); 
arg1148_510 = 
(aux_2534%aux_2536); } 
test1145_507 = 
(arg1148_510==((long)0)); } 
if(test1145_507)
{ /* ./Ieee/fixnum.scm 2323 */
long aux_2541;
{ /* ./Ieee/fixnum.scm 2323 */
long aux_2544;long aux_2542;
aux_2544 = 
(long)CINT(y_51); 
aux_2542 = 
(long)CINT(x_50); 
aux_2541 = 
(aux_2542/aux_2544); } 
return 
BINT(aux_2541);}  else 
{ /* Ieee/number.scm 541 */
double arg1146_508;double arg1147_509;
{ /* Ieee/number.scm 176 */
long aux_2548;
aux_2548 = 
(long)CINT(x_50); 
arg1146_508 = 
(double)(aux_2548); } 
{ /* Ieee/number.scm 176 */
long aux_2551;
aux_2551 = 
(long)CINT(y_51); 
arg1147_509 = 
(double)(aux_2551); } 
{ /* ./Ieee/flonum.scm 3491 */
double aux_2554;
aux_2554 = 
(arg1146_508/arg1147_509); 
return 
make_real(aux_2554);} } } }  else 
{ /* Ieee/number.scm 538 */
if(
REALP(y_51))
{ /* Ieee/number.scm 542 */
{ /* Ieee/number.scm 543 */
double arg1152_513;
{ /* Ieee/number.scm 176 */
long aux_2559;
aux_2559 = 
(long)CINT(x_50); 
arg1152_513 = 
(double)(aux_2559); } 
{ /* ./Ieee/flonum.scm 3491 */
double aux_2562;
{ /* ./Ieee/flonum.scm 3491 */
double aux_2563;
aux_2563 = 
REAL_TO_DOUBLE(y_51); 
aux_2562 = 
(arg1152_513/aux_2563); } 
return 
make_real(aux_2562);} } }  else 
{ /* Ieee/number.scm 542 */
FAILURE(string1456___r4_numbers_6_5,string1445___r4_numbers_6_5,y_51);} } }  else 
{ /* Ieee/number.scm 536 */
if(
REALP(x_50))
{ /* Ieee/number.scm 546 */
if(
REALP(y_51))
{ /* Ieee/number.scm 548 */
{ /* ./Ieee/flonum.scm 3491 */
double aux_2572;
{ /* ./Ieee/flonum.scm 3491 */
double aux_2575;double aux_2573;
aux_2575 = 
REAL_TO_DOUBLE(y_51); 
aux_2573 = 
REAL_TO_DOUBLE(x_50); 
aux_2572 = 
(aux_2573/aux_2575); } 
return 
make_real(aux_2572);} }  else 
{ /* Ieee/number.scm 548 */
if(
INTEGERP(y_51))
{ /* Ieee/number.scm 550 */
{ /* Ieee/number.scm 551 */
double arg1156_517;
{ /* Ieee/number.scm 176 */
long aux_2581;
aux_2581 = 
(long)CINT(y_51); 
arg1156_517 = 
(double)(aux_2581); } 
{ /* ./Ieee/flonum.scm 3491 */
double aux_2584;
{ /* ./Ieee/flonum.scm 3491 */
double aux_2585;
aux_2585 = 
REAL_TO_DOUBLE(x_50); 
aux_2584 = 
(aux_2585/arg1156_517); } 
return 
make_real(aux_2584);} } }  else 
{ /* Ieee/number.scm 550 */
FAILURE(string1456___r4_numbers_6_5,string1445___r4_numbers_6_5,y_51);} } }  else 
{ /* Ieee/number.scm 546 */
FAILURE(string1456___r4_numbers_6_5,string1445___r4_numbers_6_5,x_50);} } } 
}



/* _2/ */
obj_t _2__11___r4_numbers_6_5(obj_t env_1923, obj_t x_1924, obj_t y_1925)
{ AN_OBJECT;
{ /* Ieee/number.scm 534 */
return 
_2__156___r4_numbers_6_5(x_1924, y_1925);} 
}



/* / */
obj_t __28___r4_numbers_6_5(obj_t x_52, obj_t y_53)
{ AN_OBJECT;
{ /* Ieee/number.scm 560 */
if(
PAIRP(y_53))
{ /* Ieee/number.scm 562 */
obj_t arg1158_522;obj_t arg1159_523;
arg1158_522 = 
_2__156___r4_numbers_6_5(x_52, 
CAR(y_53)); 
arg1159_523 = 
CDR(y_53); 
{ 
obj_t result_1462;obj_t z_1463;
result_1462 = arg1158_522; 
z_1463 = arg1159_523; 
loop_1461:
if(
PAIRP(z_1463))
{ /* Ieee/number.scm 565 */
obj_t arg1162_1469;obj_t arg1163_1470;
arg1162_1469 = 
_2__156___r4_numbers_6_5(result_1462, 
CAR(z_1463)); 
arg1163_1470 = 
CDR(z_1463); 
{ 
obj_t z_2603;obj_t result_2602;
result_2602 = arg1162_1469; 
z_2603 = arg1163_1470; 
z_1463 = z_2603; 
result_1462 = result_2602; 
goto loop_1461;} }  else 
{ /* Ieee/number.scm 564 */
return result_1462;} } }  else 
{ /* Ieee/number.scm 561 */
return 
_2__156___r4_numbers_6_5(
BINT(((long)1)), x_52);} } 
}



/* _/ */
obj_t ___222___r4_numbers_6_5(obj_t env_1926, obj_t x_1927, obj_t y_1928)
{ AN_OBJECT;
{ /* Ieee/number.scm 560 */
return 
__28___r4_numbers_6_5(x_1927, y_1928);} 
}



/* abs */
obj_t abs___r4_numbers_6_5(obj_t x_54)
{ AN_OBJECT;
{ /* Ieee/number.scm 573 */
if(
INTEGERP(x_54))
{ /* Ieee/number.scm 575 */
{ /* Ieee/number.scm 576 */
long aux_2609;
{ /* Ieee/number.scm 576 */
long n_1492;
n_1492 = 
(long)CINT(x_54); 
if(
(n_1492<((long)0)))
{ /* ./Ieee/fixnum.scm 2335 */
aux_2609 = 
NEG(n_1492)
; }  else 
{ /* ./Ieee/fixnum.scm 2335 */
aux_2609 = n_1492
; } } 
return 
BINT(aux_2609);} }  else 
{ /* Ieee/number.scm 575 */
if(
REALP(x_54))
{ /* Ieee/number.scm 577 */
{ /* Ieee/number.scm 578 */
double aux_2617;
{ /* Ieee/number.scm 578 */
double r_1499;
r_1499 = 
REAL_TO_DOUBLE(x_54); 
if(
(r_1499<((double)0.0)))
{ /* ./Ieee/flonum.scm 3543 */
aux_2617 = 
NEG(r_1499)
; }  else 
{ /* ./Ieee/flonum.scm 3543 */
aux_2617 = r_1499
; } } 
return 
make_real(aux_2617);} }  else 
{ /* Ieee/number.scm 577 */
FAILURE(string1457___r4_numbers_6_5,string1445___r4_numbers_6_5,x_54);} } } 
}



/* _abs */
obj_t _abs___r4_numbers_6_5(obj_t env_1929, obj_t x_1930)
{ AN_OBJECT;
{ /* Ieee/number.scm 573 */
return 
abs___r4_numbers_6_5(x_1930);} 
}



/* floor */
obj_t floor___r4_numbers_6_5(obj_t x_55)
{ AN_OBJECT;
{ /* Ieee/number.scm 585 */
if(
INTEGERP(x_55))
{ /* Ieee/number.scm 587 */
return x_55;}  else 
{ /* Ieee/number.scm 587 */
if(
REALP(x_55))
{ /* Ieee/number.scm 589 */
{ /* ./Ieee/flonum.scm 3551 */
double aux_2629;
{ /* ./Ieee/flonum.scm 3551 */
double aux_2630;
aux_2630 = 
REAL_TO_DOUBLE(x_55); 
aux_2629 = 
floor(aux_2630); } 
return 
make_real(aux_2629);} }  else 
{ /* Ieee/number.scm 589 */
FAILURE(string1458___r4_numbers_6_5,string1445___r4_numbers_6_5,x_55);} } } 
}



/* _floor */
obj_t _floor___r4_numbers_6_5(obj_t env_1931, obj_t x_1932)
{ AN_OBJECT;
{ /* Ieee/number.scm 585 */
return 
floor___r4_numbers_6_5(x_1932);} 
}



/* ceiling */
obj_t ceiling___r4_numbers_6_5(obj_t x_56)
{ AN_OBJECT;
{ /* Ieee/number.scm 597 */
if(
INTEGERP(x_56))
{ /* Ieee/number.scm 599 */
return x_56;}  else 
{ /* Ieee/number.scm 599 */
if(
REALP(x_56))
{ /* Ieee/number.scm 601 */
{ /* ./Ieee/flonum.scm 3557 */
double aux_2640;
{ /* ./Ieee/flonum.scm 3557 */
double aux_2641;
aux_2641 = 
REAL_TO_DOUBLE(x_56); 
aux_2640 = 
ceil(aux_2641); } 
return 
make_real(aux_2640);} }  else 
{ /* Ieee/number.scm 601 */
FAILURE(string1459___r4_numbers_6_5,string1445___r4_numbers_6_5,x_56);} } } 
}



/* _ceiling */
obj_t _ceiling___r4_numbers_6_5(obj_t env_1933, obj_t x_1934)
{ AN_OBJECT;
{ /* Ieee/number.scm 597 */
return 
ceiling___r4_numbers_6_5(x_1934);} 
}



/* truncate */
obj_t truncate___r4_numbers_6_5(obj_t x_57)
{ AN_OBJECT;
{ /* Ieee/number.scm 609 */
if(
INTEGERP(x_57))
{ /* Ieee/number.scm 611 */
return x_57;}  else 
{ /* Ieee/number.scm 611 */
if(
REALP(x_57))
{ /* Ieee/number.scm 613 */
{ /* Ieee/number.scm 614 */
double res1439_1535;
{ /* Ieee/number.scm 614 */
double r_1528;
r_1528 = 
REAL_TO_DOUBLE(x_57); 
if(
(r_1528<((double)0.0)))
{ /* ./Ieee/flonum.scm 3563 */
res1439_1535 = 
ceil(r_1528); }  else 
{ /* ./Ieee/flonum.scm 3563 */
res1439_1535 = 
floor(r_1528); } } 
return 
make_real(res1439_1535);} }  else 
{ /* Ieee/number.scm 613 */
FAILURE(string1460___r4_numbers_6_5,string1445___r4_numbers_6_5,x_57);} } } 
}



/* _truncate */
obj_t _truncate___r4_numbers_6_5(obj_t env_1935, obj_t x_1936)
{ AN_OBJECT;
{ /* Ieee/number.scm 609 */
return 
truncate___r4_numbers_6_5(x_1936);} 
}



/* round */
obj_t round___r4_numbers_6_5(obj_t x_58)
{ AN_OBJECT;
{ /* Ieee/number.scm 621 */
if(
INTEGERP(x_58))
{ /* Ieee/number.scm 623 */
return x_58;}  else 
{ /* Ieee/number.scm 623 */
if(
REALP(x_58))
{ /* Ieee/number.scm 625 */
{ /* Ieee/number.scm 626 */
double res1440_1548;
{ /* ./Ieee/flonum.scm 3551 */
double aux_2663;
{ /* ./Ieee/flonum.scm 3473 */
double aux_2664;
aux_2664 = 
REAL_TO_DOUBLE(x_58); 
aux_2663 = 
(aux_2664+((double)0.5)); } 
res1440_1548 = 
floor(aux_2663); } 
return 
make_real(res1440_1548);} }  else 
{ /* Ieee/number.scm 625 */
FAILURE(string1461___r4_numbers_6_5,string1445___r4_numbers_6_5,x_58);} } } 
}



/* _round */
obj_t _round___r4_numbers_6_5(obj_t env_1937, obj_t x_1938)
{ AN_OBJECT;
{ /* Ieee/number.scm 621 */
return 
round___r4_numbers_6_5(x_1938);} 
}



/* exp */
double exp___r4_numbers_6_5(obj_t x_59)
{ AN_OBJECT;
{ /* Ieee/number.scm 633 */
if(
INTEGERP(x_59))
{ /* Ieee/number.scm 635 */
{ /* Ieee/number.scm 636 */
double arg1176_540;
{ /* Ieee/number.scm 176 */
long aux_2673;
aux_2673 = 
(long)CINT(x_59); 
arg1176_540 = 
(double)(aux_2673); } 
return 
exp(arg1176_540);} }  else 
{ /* Ieee/number.scm 635 */
if(
REALP(x_59))
{ /* Ieee/number.scm 637 */
{ /* ./Ieee/flonum.scm 3577 */
double aux_2679;
aux_2679 = 
REAL_TO_DOUBLE(x_59); 
return 
exp(aux_2679);} }  else 
{ /* Ieee/number.scm 637 */
FAILURE(string1462___r4_numbers_6_5,string1445___r4_numbers_6_5,x_59);} } } 
}



/* _exp */
obj_t _exp___r4_numbers_6_5(obj_t env_1939, obj_t x_1940)
{ AN_OBJECT;
{ /* Ieee/number.scm 633 */
{ /* Ieee/number.scm 633 */
double aux_2683;
aux_2683 = 
exp___r4_numbers_6_5(x_1940); 
return 
make_real(aux_2683);} } 
}



/* log */
double log___r4_numbers_6_5(obj_t x_60)
{ AN_OBJECT;
{ /* Ieee/number.scm 645 */
if(
INTEGERP(x_60))
{ /* Ieee/number.scm 647 */
{ /* Ieee/number.scm 648 */
double arg1179_543;
{ /* Ieee/number.scm 176 */
long aux_2688;
aux_2688 = 
(long)CINT(x_60); 
arg1179_543 = 
(double)(aux_2688); } 
return 
log(arg1179_543);} }  else 
{ /* Ieee/number.scm 647 */
if(
REALP(x_60))
{ /* Ieee/number.scm 649 */
{ /* ./Ieee/flonum.scm 3583 */
double aux_2694;
aux_2694 = 
REAL_TO_DOUBLE(x_60); 
return 
log(aux_2694);} }  else 
{ /* Ieee/number.scm 649 */
FAILURE(string1463___r4_numbers_6_5,string1445___r4_numbers_6_5,x_60);} } } 
}



/* _log */
obj_t _log___r4_numbers_6_5(obj_t env_1941, obj_t x_1942)
{ AN_OBJECT;
{ /* Ieee/number.scm 645 */
{ /* Ieee/number.scm 645 */
double aux_2698;
aux_2698 = 
log___r4_numbers_6_5(x_1942); 
return 
make_real(aux_2698);} } 
}



/* sin */
double sin___r4_numbers_6_5(obj_t x_61)
{ AN_OBJECT;
{ /* Ieee/number.scm 657 */
if(
INTEGERP(x_61))
{ /* Ieee/number.scm 659 */
{ /* Ieee/number.scm 660 */
double arg1182_546;
{ /* Ieee/number.scm 176 */
long aux_2703;
aux_2703 = 
(long)CINT(x_61); 
arg1182_546 = 
(double)(aux_2703); } 
return 
sin(arg1182_546);} }  else 
{ /* Ieee/number.scm 659 */
if(
REALP(x_61))
{ /* Ieee/number.scm 661 */
{ /* ./Ieee/flonum.scm 3589 */
double aux_2709;
aux_2709 = 
REAL_TO_DOUBLE(x_61); 
return 
sin(aux_2709);} }  else 
{ /* Ieee/number.scm 661 */
FAILURE(string1464___r4_numbers_6_5,string1445___r4_numbers_6_5,x_61);} } } 
}



/* _sin */
obj_t _sin___r4_numbers_6_5(obj_t env_1943, obj_t x_1944)
{ AN_OBJECT;
{ /* Ieee/number.scm 657 */
{ /* Ieee/number.scm 657 */
double aux_2713;
aux_2713 = 
sin___r4_numbers_6_5(x_1944); 
return 
make_real(aux_2713);} } 
}



/* cos */
double cos___r4_numbers_6_5(obj_t x_62)
{ AN_OBJECT;
{ /* Ieee/number.scm 669 */
if(
INTEGERP(x_62))
{ /* Ieee/number.scm 671 */
{ /* Ieee/number.scm 672 */
double arg1185_549;
{ /* Ieee/number.scm 176 */
long aux_2718;
aux_2718 = 
(long)CINT(x_62); 
arg1185_549 = 
(double)(aux_2718); } 
return 
cos(arg1185_549);} }  else 
{ /* Ieee/number.scm 671 */
if(
REALP(x_62))
{ /* Ieee/number.scm 673 */
{ /* ./Ieee/flonum.scm 3595 */
double aux_2724;
aux_2724 = 
REAL_TO_DOUBLE(x_62); 
return 
cos(aux_2724);} }  else 
{ /* Ieee/number.scm 673 */
FAILURE(string1465___r4_numbers_6_5,string1445___r4_numbers_6_5,x_62);} } } 
}



/* _cos */
obj_t _cos___r4_numbers_6_5(obj_t env_1945, obj_t x_1946)
{ AN_OBJECT;
{ /* Ieee/number.scm 669 */
{ /* Ieee/number.scm 669 */
double aux_2728;
aux_2728 = 
cos___r4_numbers_6_5(x_1946); 
return 
make_real(aux_2728);} } 
}



/* tan */
double tan___r4_numbers_6_5(obj_t x_63)
{ AN_OBJECT;
{ /* Ieee/number.scm 681 */
if(
INTEGERP(x_63))
{ /* Ieee/number.scm 683 */
{ /* Ieee/number.scm 684 */
double arg1188_552;
{ /* Ieee/number.scm 176 */
long aux_2733;
aux_2733 = 
(long)CINT(x_63); 
arg1188_552 = 
(double)(aux_2733); } 
return 
tan(arg1188_552);} }  else 
{ /* Ieee/number.scm 683 */
if(
REALP(x_63))
{ /* Ieee/number.scm 685 */
{ /* ./Ieee/flonum.scm 3601 */
double aux_2739;
aux_2739 = 
REAL_TO_DOUBLE(x_63); 
return 
tan(aux_2739);} }  else 
{ /* Ieee/number.scm 685 */
FAILURE(string1466___r4_numbers_6_5,string1445___r4_numbers_6_5,x_63);} } } 
}



/* _tan */
obj_t _tan___r4_numbers_6_5(obj_t env_1947, obj_t x_1948)
{ AN_OBJECT;
{ /* Ieee/number.scm 681 */
{ /* Ieee/number.scm 681 */
double aux_2743;
aux_2743 = 
tan___r4_numbers_6_5(x_1948); 
return 
make_real(aux_2743);} } 
}



/* asin */
double asin___r4_numbers_6_5(obj_t x_64)
{ AN_OBJECT;
{ /* Ieee/number.scm 693 */
if(
INTEGERP(x_64))
{ /* Ieee/number.scm 695 */
{ /* Ieee/number.scm 696 */
double arg1192_555;
{ /* Ieee/number.scm 176 */
long aux_2748;
aux_2748 = 
(long)CINT(x_64); 
arg1192_555 = 
(double)(aux_2748); } 
return 
asin(arg1192_555);} }  else 
{ /* Ieee/number.scm 695 */
if(
REALP(x_64))
{ /* Ieee/number.scm 697 */
{ /* ./Ieee/flonum.scm 3607 */
double aux_2754;
aux_2754 = 
REAL_TO_DOUBLE(x_64); 
return 
asin(aux_2754);} }  else 
{ /* Ieee/number.scm 697 */
FAILURE(string1467___r4_numbers_6_5,string1445___r4_numbers_6_5,x_64);} } } 
}



/* _asin */
obj_t _asin___r4_numbers_6_5(obj_t env_1949, obj_t x_1950)
{ AN_OBJECT;
{ /* Ieee/number.scm 693 */
{ /* Ieee/number.scm 693 */
double aux_2758;
aux_2758 = 
asin___r4_numbers_6_5(x_1950); 
return 
make_real(aux_2758);} } 
}



/* acos */
double acos___r4_numbers_6_5(obj_t x_65)
{ AN_OBJECT;
{ /* Ieee/number.scm 705 */
if(
INTEGERP(x_65))
{ /* Ieee/number.scm 707 */
{ /* Ieee/number.scm 708 */
double arg1195_558;
{ /* Ieee/number.scm 176 */
long aux_2763;
aux_2763 = 
(long)CINT(x_65); 
arg1195_558 = 
(double)(aux_2763); } 
return 
acos(arg1195_558);} }  else 
{ /* Ieee/number.scm 707 */
if(
REALP(x_65))
{ /* Ieee/number.scm 709 */
{ /* ./Ieee/flonum.scm 3613 */
double aux_2769;
aux_2769 = 
REAL_TO_DOUBLE(x_65); 
return 
acos(aux_2769);} }  else 
{ /* Ieee/number.scm 709 */
FAILURE(string1468___r4_numbers_6_5,string1445___r4_numbers_6_5,x_65);} } } 
}



/* _acos */
obj_t _acos___r4_numbers_6_5(obj_t env_1951, obj_t x_1952)
{ AN_OBJECT;
{ /* Ieee/number.scm 705 */
{ /* Ieee/number.scm 705 */
double aux_2773;
aux_2773 = 
acos___r4_numbers_6_5(x_1952); 
return 
make_real(aux_2773);} } 
}



/* atan */
double atan___r4_numbers_6_5(obj_t x_66, obj_t y_67)
{ AN_OBJECT;
{ /* Ieee/number.scm 717 */
{ /* Ieee/number.scm 718 */
obj_t y_560;
if(
PAIRP(y_67))
{ /* Ieee/number.scm 719 */
obj_t y_570;
y_570 = 
CAR(y_67); 
if(
INTEGERP(y_570))
{ /* Ieee/number.scm 721 */
{ /* Ieee/number.scm 176 */
double aux_2781;
{ /* Ieee/number.scm 176 */
long aux_2782;
aux_2782 = 
(long)CINT(y_570); 
aux_2781 = 
(double)(aux_2782); } 
y_560 = 
make_real(aux_2781); } }  else 
{ /* Ieee/number.scm 721 */
if(
REALP(y_570))
{ /* Ieee/number.scm 723 */
y_560 = y_570; }  else 
{ /* Ieee/number.scm 723 */
FAILURE(string1469___r4_numbers_6_5,string1445___r4_numbers_6_5,y_570);} } }  else 
{ /* Ieee/number.scm 718 */
y_560 = BFALSE; } 
if(
INTEGERP(x_66))
{ /* Ieee/number.scm 733 */
{ /* Ieee/number.scm 734 */
double arg1198_563;
{ /* Ieee/number.scm 176 */
long aux_2791;
aux_2791 = 
(long)CINT(x_66); 
arg1198_563 = 
(double)(aux_2791); } 
{ /* Ieee/number.scm 729 */
bool_t test_2794;
if(
INTEGERP(y_560))
{ /* Ieee/number.scm 138 */
test_2794 = ((bool_t)1)
; }  else 
{ /* Ieee/number.scm 138 */
test_2794 = 
REALP(y_560)
; } 
if(test_2794)
{ /* ./Ieee/flonum.scm 3648 */
double aux_2798;
aux_2798 = 
REAL_TO_DOUBLE(y_560); 
return 
atan2(arg1198_563, aux_2798);}  else 
{ /* Ieee/number.scm 729 */
return 
atan(arg1198_563);} } } }  else 
{ /* Ieee/number.scm 733 */
if(
REALP(x_66))
{ /* Ieee/number.scm 735 */
{ /* Ieee/number.scm 729 */
bool_t test_2804;
if(
INTEGERP(y_560))
{ /* Ieee/number.scm 138 */
test_2804 = ((bool_t)1)
; }  else 
{ /* Ieee/number.scm 138 */
test_2804 = 
REALP(y_560)
; } 
if(test_2804)
{ /* ./Ieee/flonum.scm 3648 */
double aux_2810;double aux_2808;
aux_2810 = 
REAL_TO_DOUBLE(y_560); 
aux_2808 = 
REAL_TO_DOUBLE(x_66); 
return 
atan2(aux_2808, aux_2810);}  else 
{ /* ./Ieee/flonum.scm 3628 */
double aux_2813;
aux_2813 = 
REAL_TO_DOUBLE(x_66); 
return 
atan(aux_2813);} } }  else 
{ /* Ieee/number.scm 735 */
FAILURE(string1469___r4_numbers_6_5,string1445___r4_numbers_6_5,x_66);} } } } 
}



/* _atan */
obj_t _atan___r4_numbers_6_5(obj_t env_1953, obj_t x_1954, obj_t y_1955)
{ AN_OBJECT;
{ /* Ieee/number.scm 717 */
{ /* Ieee/number.scm 717 */
double aux_2817;
aux_2817 = 
atan___r4_numbers_6_5(x_1954, y_1955); 
return 
make_real(aux_2817);} } 
}



/* sqrt */
double sqrt___r4_numbers_6_5(obj_t x_68)
{ AN_OBJECT;
{ /* Ieee/number.scm 743 */
if(
INTEGERP(x_68))
{ /* Ieee/number.scm 745 */
{ /* Ieee/number.scm 746 */
double arg1206_574;
{ /* Ieee/number.scm 176 */
long aux_2822;
aux_2822 = 
(long)CINT(x_68); 
arg1206_574 = 
(double)(aux_2822); } 
return 
sqrt(arg1206_574);} }  else 
{ /* Ieee/number.scm 745 */
if(
REALP(x_68))
{ /* Ieee/number.scm 747 */
{ /* ./Ieee/flonum.scm 3665 */
double aux_2828;
aux_2828 = 
REAL_TO_DOUBLE(x_68); 
return 
sqrt(aux_2828);} }  else 
{ /* Ieee/number.scm 747 */
FAILURE(string1470___r4_numbers_6_5,string1445___r4_numbers_6_5,x_68);} } } 
}



/* _sqrt */
obj_t _sqrt___r4_numbers_6_5(obj_t env_1956, obj_t x_1957)
{ AN_OBJECT;
{ /* Ieee/number.scm 743 */
{ /* Ieee/number.scm 743 */
double aux_2832;
aux_2832 = 
sqrt___r4_numbers_6_5(x_1957); 
return 
make_real(aux_2832);} } 
}



/* expt */
obj_t expt___r4_numbers_6_5(obj_t x_69, obj_t y_70)
{ AN_OBJECT;
{ /* Ieee/number.scm 755 */
{ /* Ieee/number.scm 756 */
bool_t test_2835;
if(
REALP(x_69))
{ /* Ieee/number.scm 756 */
if(
REALP(y_70))
{ /* Ieee/number.scm 756 */
bool_t test_2840;
{ /* ./Ieee/flonum.scm 3425 */
double aux_2841;
aux_2841 = 
REAL_TO_DOUBLE(x_69); 
test_2840 = 
(aux_2841==((double)0.0)); } 
if(test_2840)
{ /* ./Ieee/flonum.scm 3425 */
double aux_2844;
aux_2844 = 
REAL_TO_DOUBLE(y_70); 
test_2835 = 
(aux_2844==((double)0.0)); }  else 
{ /* Ieee/number.scm 756 */
test_2835 = ((bool_t)0)
; } }  else 
{ /* Ieee/number.scm 756 */
test_2835 = ((bool_t)0)
; } }  else 
{ /* Ieee/number.scm 756 */
test_2835 = ((bool_t)0)
; } 
if(test_2835)
{ /* Ieee/number.scm 756 */
return real1471___r4_numbers_6_5;}  else 
{ /* Ieee/number.scm 759 */
bool_t test_2847;
if(
INTEGERP(x_69))
{ /* Ieee/number.scm 759 */
test_2847 = 
INTEGERP(y_70)
; }  else 
{ /* Ieee/number.scm 759 */
test_2847 = ((bool_t)0)
; } 
if(test_2847)
{ /* Ieee/number.scm 759 */
{ /* Ieee/number.scm 761 */
double arg1212_578;
{ /* Ieee/number.scm 761 */
double arg1213_579;double arg1214_580;
{ /* Ieee/number.scm 176 */
long aux_2851;
aux_2851 = 
(long)CINT(x_69); 
arg1213_579 = 
(double)(aux_2851); } 
{ /* Ieee/number.scm 176 */
long aux_2854;
aux_2854 = 
(long)CINT(y_70); 
arg1214_580 = 
(double)(aux_2854); } 
arg1212_578 = 
pow(arg1213_579, arg1214_580); } 
{ /* Ieee/number.scm 170 */
long aux_2858;
{ /* Ieee/number.scm 170 */
double aux_2859;
{ /* Ieee/number.scm 170 */
obj_t aux_2860;
aux_2860 = 
make_real(arg1212_578); 
aux_2859 = 
REAL_TO_DOUBLE(aux_2860); } 
aux_2858 = 
(long)(aux_2859); } 
return 
BINT(aux_2858);} } }  else 
{ /* Ieee/number.scm 759 */
if(
INTEGERP(x_69))
{ /* Ieee/number.scm 762 */
if(
REALP(y_70))
{ /* Ieee/number.scm 764 */
{ /* Ieee/number.scm 765 */
double arg1217_583;
{ /* Ieee/number.scm 176 */
long aux_2869;
aux_2869 = 
(long)CINT(x_69); 
arg1217_583 = 
(double)(aux_2869); } 
{ /* ./Ieee/flonum.scm 3671 */
double aux_2872;
{ /* ./Ieee/flonum.scm 3671 */
double aux_2873;
aux_2873 = 
REAL_TO_DOUBLE(y_70); 
aux_2872 = 
pow(arg1217_583, aux_2873); } 
return 
make_real(aux_2872);} } }  else 
{ /* Ieee/number.scm 764 */
FAILURE(string1472___r4_numbers_6_5,string1445___r4_numbers_6_5,y_70);} }  else 
{ /* Ieee/number.scm 762 */
if(
REALP(x_69))
{ /* Ieee/number.scm 768 */
if(
REALP(y_70))
{ /* Ieee/number.scm 770 */
{ /* ./Ieee/flonum.scm 3671 */
double aux_2882;
{ /* ./Ieee/flonum.scm 3671 */
double aux_2885;double aux_2883;
aux_2885 = 
REAL_TO_DOUBLE(y_70); 
aux_2883 = 
REAL_TO_DOUBLE(x_69); 
aux_2882 = 
pow(aux_2883, aux_2885); } 
return 
make_real(aux_2882);} }  else 
{ /* Ieee/number.scm 770 */
if(
INTEGERP(y_70))
{ /* Ieee/number.scm 772 */
{ /* Ieee/number.scm 773 */
double arg1222_587;
{ /* Ieee/number.scm 176 */
long aux_2891;
aux_2891 = 
(long)CINT(y_70); 
arg1222_587 = 
(double)(aux_2891); } 
{ /* ./Ieee/flonum.scm 3671 */
double aux_2894;
{ /* ./Ieee/flonum.scm 3671 */
double aux_2895;
aux_2895 = 
REAL_TO_DOUBLE(x_69); 
aux_2894 = 
pow(aux_2895, arg1222_587); } 
return 
make_real(aux_2894);} } }  else 
{ /* Ieee/number.scm 772 */
FAILURE(string1472___r4_numbers_6_5,string1445___r4_numbers_6_5,y_70);} } }  else 
{ /* Ieee/number.scm 768 */
FAILURE(string1472___r4_numbers_6_5,string1445___r4_numbers_6_5,x_69);} } } } } } 
}



/* _expt */
obj_t _expt___r4_numbers_6_5(obj_t env_1958, obj_t x_1959, obj_t y_1960)
{ AN_OBJECT;
{ /* Ieee/number.scm 755 */
return 
expt___r4_numbers_6_5(x_1959, y_1960);} 
}



/* exact->inexact */
obj_t exact__inexact_122___r4_numbers_6_5(obj_t z_71)
{ AN_OBJECT;
{ /* Ieee/number.scm 782 */
if(
INTEGERP(z_71))
{ /* Ieee/number.scm 176 */
double aux_2904;
{ /* Ieee/number.scm 176 */
long aux_2905;
aux_2905 = 
(long)CINT(z_71); 
aux_2904 = 
(double)(aux_2905); } 
return 
make_real(aux_2904);}  else 
{ /* Ieee/number.scm 783 */
return z_71;} } 
}



/* _exact->inexact */
obj_t _exact__inexact_16___r4_numbers_6_5(obj_t env_1961, obj_t z_1962)
{ AN_OBJECT;
{ /* Ieee/number.scm 782 */
{ /* Ieee/number.scm 782 */
obj_t z_1977;
z_1977 = z_1962; 
if(
INTEGERP(z_1977))
{ /* Ieee/number.scm 176 */
double aux_2911;
{ /* Ieee/number.scm 176 */
long aux_2912;
aux_2912 = 
(long)CINT(z_1977); 
aux_2911 = 
(double)(aux_2912); } 
return 
make_real(aux_2911);}  else 
{ /* Ieee/number.scm 783 */
return z_1977;} } } 
}



/* inexact->exact */
obj_t inexact__exact_80___r4_numbers_6_5(obj_t z_72)
{ AN_OBJECT;
{ /* Ieee/number.scm 790 */
if(
REALP(z_72))
{ /* Ieee/number.scm 170 */
long aux_2918;
{ /* Ieee/number.scm 170 */
double aux_2919;
aux_2919 = 
REAL_TO_DOUBLE(z_72); 
aux_2918 = 
(long)(aux_2919); } 
return 
BINT(aux_2918);}  else 
{ /* Ieee/number.scm 791 */
return z_72;} } 
}



/* _inexact->exact */
obj_t _inexact__exact_215___r4_numbers_6_5(obj_t env_1963, obj_t z_1964)
{ AN_OBJECT;
{ /* Ieee/number.scm 790 */
{ /* Ieee/number.scm 790 */
obj_t z_1978;
z_1978 = z_1964; 
if(
REALP(z_1978))
{ /* Ieee/number.scm 170 */
long aux_2925;
{ /* Ieee/number.scm 170 */
double aux_2926;
aux_2926 = 
REAL_TO_DOUBLE(z_1978); 
aux_2925 = 
(long)(aux_2926); } 
return 
BINT(aux_2925);}  else 
{ /* Ieee/number.scm 791 */
return z_1978;} } } 
}



/* number->string */
char * number__string_214___r4_numbers_6_5(obj_t x_73, obj_t radix_74)
{ AN_OBJECT;
{ /* Ieee/number.scm 798 */
{ /* Ieee/number.scm 799 */
bool_t test1229_594;
{ /* Ieee/number.scm 799 */
obj_t obj_1702;
obj_1702 = radix_74; 
test1229_594 = 
NULLP(obj_1702); } 
if(test1229_594)
{ /* Ieee/number.scm 799 */
radix_74 = 
BINT(((long)10)); }  else 
{ /* Ieee/number.scm 801 */
obj_t pair_1703;
pair_1703 = radix_74; 
radix_74 = 
CAR(pair_1703); } } 
if(
INTEGERP(x_73))
{ /* Ieee/number.scm 803 */
{ /* Ieee/number.scm 804 */
obj_t list1231_596;
list1231_596 = 
MAKE_PAIR(radix_74, BNIL); 
return 
integer__string_135___r4_numbers_6_5_fixnum(
(long)CINT(x_73), list1231_596);} }  else 
{ /* Ieee/number.scm 803 */
if(
REALP(x_73))
{ /* Ieee/number.scm 805 */
{ /* ./Ieee/flonum.scm 3683 */
double aux_2941;
aux_2941 = 
REAL_TO_DOUBLE(x_73); 
return 
real_to_string(aux_2941);} }  else 
{ /* Ieee/number.scm 805 */
FAILURE(string1473___r4_numbers_6_5,string1474___r4_numbers_6_5,x_73);} } } 
}



/* _number->string */
obj_t _number__string_61___r4_numbers_6_5(obj_t env_1965, obj_t x_1966, obj_t radix_1967)
{ AN_OBJECT;
{ /* Ieee/number.scm 798 */
{ /* Ieee/number.scm 798 */
char * aux_2945;
aux_2945 = 
number__string_214___r4_numbers_6_5(x_1966, radix_1967); 
return 
string_to_bstring(aux_2945);} } 
}



/* string->number */
obj_t string__number_104___r4_numbers_6_5(obj_t x_75, obj_t radix_76)
{ AN_OBJECT;
{ /* Ieee/number.scm 813 */
{ 
obj_t x_617;obj_t r_618;
{ /* Ieee/number.scm 841 */
obj_t rx_599;
{ 
obj_t val_604;
if(
(radix_76==BNIL))
{ /* Ieee/number.scm 841 */
rx_599 = 
BINT(((long)10)); }  else 
{ /* Ieee/number.scm 841 */
if(
PAIRP(radix_76))
{ /* Ieee/number.scm 841 */
bool_t test_2953;
{ /* ./Ieee/equiv.scm 2047 */
obj_t aux_2954;
aux_2954 = 
CDR(radix_76); 
test_2953 = 
(aux_2954==BNIL); } 
if(test_2953)
{ /* Ieee/number.scm 841 */
val_604 = 
CAR(radix_76); 
if(
INTEGERP(val_604))
{ /* Ieee/number.scm 844 */
switch( 
(long)CINT(val_604)) { case ((long)2) : 
case ((long)8) : 
case ((long)10) : 
case ((long)16) : 

rx_599 = val_604; break;
default: 
FAILURE(string1475___r4_numbers_6_5,string1476___r4_numbers_6_5,val_604);} }  else 
{ /* Ieee/number.scm 844 */
FAILURE(string1475___r4_numbers_6_5,string1476___r4_numbers_6_5,val_604);} }  else 
{ /* Ieee/number.scm 841 */
FAILURE(string1475___r4_numbers_6_5,string1477___r4_numbers_6_5,radix_76);} }  else 
{ /* Ieee/number.scm 841 */
FAILURE(string1475___r4_numbers_6_5,string1477___r4_numbers_6_5,radix_76);} } } 
{ /* Ieee/number.scm 852 */
bool_t test_2966;
x_617 = x_75; 
r_618 = rx_599; 
{ 
long i_620;
{ /* ./Ieee/fixnum.scm 2311 */
long aux_3044;
aux_3044 = 
STRING_LENGTH(x_617); 
i_620 = 
(aux_3044-((long)1)); } 
loop_621:
if(
(((long)-1)==i_620))
{ /* Ieee/number.scm 816 */
test_2966 = ((bool_t)1); }  else 
{ /* Ieee/number.scm 818 */
bool_t test_2969;
{ /* ./Ieee/char.scm 2518 */
unsigned char aux_2970;
aux_2970 = 
STRING_REF(x_617, i_620); 
test_2969 = 
(aux_2970==((unsigned char)'-')); } 
if(test_2969)
{ /* Ieee/number.scm 818 */
test_2966 = 
(i_620==((long)0)); }  else 
{ /* Ieee/number.scm 820 */
bool_t test_2974;
{ /* Ieee/number.scm 820 */
bool_t test_2975;
{ /* ./Ieee/char.scm 2542 */
unsigned char aux_2976;
aux_2976 = 
STRING_REF(x_617, i_620); 
test_2975 = 
(aux_2976>=((unsigned char)'0')); } 
if(test_2975)
{ /* Ieee/number.scm 821 */
bool_t test_2979;
{ /* ./Ieee/char.scm 2536 */
unsigned char aux_2980;
aux_2980 = 
STRING_REF(x_617, i_620); 
test_2979 = 
(aux_2980<=((unsigned char)'1')); } 
if(test_2979)
{ /* ./Ieee/fixnum.scm 2245 */
long aux_2983;
aux_2983 = 
(long)CINT(r_618); 
test_2974 = 
(aux_2983>=((long)2)); }  else 
{ /* Ieee/number.scm 821 */
test_2974 = ((bool_t)0)
; } }  else 
{ /* Ieee/number.scm 820 */
test_2974 = ((bool_t)0)
; } } 
if(test_2974)
{ /* Ieee/number.scm 820 */
{ 
long i_2986;
i_2986 = 
(i_620-((long)1)); 
i_620 = i_2986; 
goto loop_621;} }  else 
{ /* Ieee/number.scm 824 */
bool_t test_2988;
{ /* Ieee/number.scm 824 */
bool_t test_2989;
{ /* ./Ieee/char.scm 2542 */
unsigned char aux_2990;
aux_2990 = 
STRING_REF(x_617, i_620); 
test_2989 = 
(aux_2990>=((unsigned char)'2')); } 
if(test_2989)
{ /* Ieee/number.scm 825 */
bool_t test_2993;
{ /* ./Ieee/char.scm 2536 */
unsigned char aux_2994;
aux_2994 = 
STRING_REF(x_617, i_620); 
test_2993 = 
(aux_2994<=((unsigned char)'7')); } 
if(test_2993)
{ /* ./Ieee/fixnum.scm 2245 */
long aux_2997;
aux_2997 = 
(long)CINT(r_618); 
test_2988 = 
(aux_2997>=((long)8)); }  else 
{ /* Ieee/number.scm 825 */
test_2988 = ((bool_t)0)
; } }  else 
{ /* Ieee/number.scm 824 */
test_2988 = ((bool_t)0)
; } } 
if(test_2988)
{ /* Ieee/number.scm 824 */
{ 
long i_3000;
i_3000 = 
(i_620-((long)1)); 
i_620 = i_3000; 
goto loop_621;} }  else 
{ /* Ieee/number.scm 828 */
bool_t test_3002;
{ /* Ieee/number.scm 828 */
bool_t test_3003;
{ /* ./Ieee/char.scm 2542 */
unsigned char aux_3004;
aux_3004 = 
STRING_REF(x_617, i_620); 
test_3003 = 
(aux_3004>=((unsigned char)'8')); } 
if(test_3003)
{ /* Ieee/number.scm 829 */
bool_t test_3007;
{ /* ./Ieee/char.scm 2536 */
unsigned char aux_3008;
aux_3008 = 
STRING_REF(x_617, i_620); 
test_3007 = 
(aux_3008<=((unsigned char)'9')); } 
if(test_3007)
{ /* ./Ieee/fixnum.scm 2245 */
long aux_3011;
aux_3011 = 
(long)CINT(r_618); 
test_3002 = 
(aux_3011>=((long)10)); }  else 
{ /* Ieee/number.scm 829 */
test_3002 = ((bool_t)0)
; } }  else 
{ /* Ieee/number.scm 828 */
test_3002 = ((bool_t)0)
; } } 
if(test_3002)
{ /* Ieee/number.scm 828 */
{ 
long i_3014;
i_3014 = 
(i_620-((long)1)); 
i_620 = i_3014; 
goto loop_621;} }  else 
{ /* Ieee/number.scm 832 */
bool_t test_3016;
{ /* Ieee/number.scm 832 */
bool_t test_3017;
{ /* ./Ieee/char.scm 2542 */
unsigned char aux_3018;
aux_3018 = 
STRING_REF(x_617, i_620); 
test_3017 = 
(aux_3018>=((unsigned char)'a')); } 
if(test_3017)
{ /* Ieee/number.scm 833 */
bool_t test_3021;
{ /* ./Ieee/char.scm 2536 */
unsigned char aux_3022;
aux_3022 = 
STRING_REF(x_617, i_620); 
test_3021 = 
(aux_3022<=((unsigned char)'f')); } 
if(test_3021)
{ /* ./Ieee/fixnum.scm 2221 */
long aux_3025;
aux_3025 = 
(long)CINT(r_618); 
test_3016 = 
(aux_3025==((long)16)); }  else 
{ /* Ieee/number.scm 833 */
test_3016 = ((bool_t)0)
; } }  else 
{ /* Ieee/number.scm 832 */
test_3016 = ((bool_t)0)
; } } 
if(test_3016)
{ /* Ieee/number.scm 832 */
{ 
long i_3028;
i_3028 = 
(i_620-((long)1)); 
i_620 = i_3028; 
goto loop_621;} }  else 
{ /* Ieee/number.scm 836 */
bool_t test_3030;
{ /* Ieee/number.scm 836 */
bool_t test_3031;
{ /* ./Ieee/char.scm 2542 */
unsigned char aux_3032;
aux_3032 = 
STRING_REF(x_617, i_620); 
test_3031 = 
(aux_3032>=((unsigned char)'A')); } 
if(test_3031)
{ /* Ieee/number.scm 837 */
bool_t test_3035;
{ /* ./Ieee/char.scm 2536 */
unsigned char aux_3036;
aux_3036 = 
STRING_REF(x_617, i_620); 
test_3035 = 
(aux_3036<=((unsigned char)'F')); } 
if(test_3035)
{ /* ./Ieee/fixnum.scm 2221 */
long aux_3039;
aux_3039 = 
(long)CINT(r_618); 
test_3030 = 
(aux_3039==((long)16)); }  else 
{ /* Ieee/number.scm 837 */
test_3030 = ((bool_t)0)
; } }  else 
{ /* Ieee/number.scm 836 */
test_3030 = ((bool_t)0)
; } } 
if(test_3030)
{ /* Ieee/number.scm 836 */
{ 
long i_3042;
i_3042 = 
(i_620-((long)1)); 
i_620 = i_3042; 
goto loop_621;} }  else 
{ /* Ieee/number.scm 836 */
test_2966 = ((bool_t)0); } } } } } } } } 
if(test_2966)
{ /* Ieee/number.scm 853 */
obj_t list1234_601;
list1234_601 = 
MAKE_PAIR(rx_599, BNIL); 
{ /* Ieee/number.scm 853 */
long aux_3048;
aux_3048 = 
string__integer_39___r4_numbers_6_5_fixnum(
BSTRING_TO_STRING(x_75), list1234_601); 
return 
BINT(aux_3048);} }  else 
{ /* Ieee/number.scm 854 */
bool_t test_3052;
{ /* ./Ieee/fixnum.scm 2221 */
long aux_3053;
aux_3053 = 
(long)CINT(rx_599); 
test_3052 = 
(aux_3053==((long)10)); } 
if(test_3052)
{ /* ./Ieee/flonum.scm 3677 */
double aux_3056;
{ /* ./Ieee/flonum.scm 3677 */
char * aux_3057;
aux_3057 = 
BSTRING_TO_STRING(x_75); 
aux_3056 = 
strtod(aux_3057, ((long)0)); } 
return 
make_real(aux_3056);}  else 
{ /* Ieee/number.scm 854 */
FAILURE(string1475___r4_numbers_6_5,string1478___r4_numbers_6_5,rx_599);} } } } } } 
}



/* _string->number */
obj_t _string__number_250___r4_numbers_6_5(obj_t env_1968, obj_t x_1969, obj_t radix_1970)
{ AN_OBJECT;
{ /* Ieee/number.scm 813 */
return 
string__number_104___r4_numbers_6_5(x_1969, radix_1970);} 
}



/* imported-modules-init */
obj_t imported_modules_init_94___r4_numbers_6_5()
{ AN_OBJECT;
{ /* Ieee/number.scm 18 */
return 
module_initialization_70___error(((long)0), "__R4_NUMBERS_6_5");} 
}

