/*===========================================================================*/
/*   (Lalr/driver.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t string_to_symbol(char *);
extern obj_t current_output_port;
static long _stack_size_increment__39___lalr_driver;
static obj_t symbol1199___lalr_driver = BUNSPEC;
static obj_t symbol1195___lalr_driver = BUNSPEC;
static obj_t symbol1200___lalr_driver = BUNSPEC;
extern obj_t string_append(obj_t, obj_t);
extern obj_t assq___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t toplevel_init_63___lalr_driver();
static obj_t grow_stack__56___lalr_driver(obj_t);
obj_t _debug_parser__183___lalr_driver = BUNSPEC;
extern obj_t list__string_78___r4_strings_6_7(obj_t);
extern obj_t __push___lalr_driver(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _anonymous_1014__195___lalr_driver(obj_t, obj_t, obj_t, obj_t);
static obj_t ___push___lalr_driver(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_string(long, unsigned char);
extern obj_t module_initialization_70___lalr_driver(long, char *);
extern obj_t module_initialization_70___error(long, char *);
static long _max_stack_size__150___lalr_driver;
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
extern obj_t __make_parser_228___lalr_driver(obj_t, obj_t);
static obj_t imported_modules_init_94___lalr_driver();
static obj_t require_initialization_114___lalr_driver = BUNSPEC;
static obj_t ___make_parser_139___lalr_driver(obj_t, obj_t, obj_t);
static obj_t cnst_init_137___lalr_driver();
extern obj_t make_vector(long, obj_t);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( __make_parser_env_140___lalr_driver, ___make_parser_139___lalr_driver1204, ___make_parser_139___lalr_driver, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( __push_env_29___lalr_driver, ___push___lalr_driver1205, ___push___lalr_driver, 0L, 5 );
DEFINE_STRING( string1198___lalr_driver, string1198___lalr_driver1206, "  sp=", 5 );
DEFINE_STRING( string1197___lalr_driver, string1197___lalr_driver1207, "  state=", 8 );
DEFINE_STRING( string1196___lalr_driver, string1196___lalr_driver1208, "** PARSER TRACE: input=", 23 );
DEFINE_STRING( string1194___lalr_driver, string1194___lalr_driver1209, "Illegal `#f' token", 18 );
DEFINE_STRING( string1193___lalr_driver, string1193___lalr_driver1210, "parser", 6 );
DEFINE_STRING( string1202___lalr_driver, string1202___lalr_driver1211, "parse error (unexpected token `", 31 );
DEFINE_STRING( string1201___lalr_driver, string1201___lalr_driver1212, "')", 2 );



/* module-initialization */
obj_t module_initialization_70___lalr_driver(long checksum_682, char * from_683)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___lalr_driver))
{ 
require_initialization_114___lalr_driver = 
BBOOL(((bool_t)0)); 
cnst_init_137___lalr_driver(); 
imported_modules_init_94___lalr_driver(); 
toplevel_init_63___lalr_driver(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___lalr_driver()
{ AN_OBJECT;
{ /* Lalr/driver.scm 11 */
symbol1195___lalr_driver = 
string_to_symbol("*EOI*"); 
symbol1199___lalr_driver = 
string_to_symbol("ACCEPT"); 
return ( 
symbol1200___lalr_driver = 
string_to_symbol("*ERROR*"), BUNSPEC) ;} 
}



/* toplevel-init */
obj_t toplevel_init_63___lalr_driver()
{ AN_OBJECT;
{ /* Lalr/driver.scm 11 */
_max_stack_size__150___lalr_driver = ((long)500); 
_stack_size_increment__39___lalr_driver = ((long)200); 
return ( 
_debug_parser__183___lalr_driver = BFALSE, BUNSPEC) ;} 
}



/* grow-stack! */
obj_t grow_stack__56___lalr_driver(obj_t v_1)
{ AN_OBJECT;
{ /* Lalr/driver.scm 45 */
{ /* Lalr/driver.scm 46 */
long len_330;
len_330 = 
VECTOR_LENGTH(v_1); 
{ /* Lalr/driver.scm 46 */
obj_t v2_331;
{ /* Lalr/driver.scm 47 */
obj_t aux_696;long aux_694;
aux_696 = 
BINT(((long)0)); 
aux_694 = 
(len_330+((long)200)); 
v2_331 = 
make_vector(aux_694, aux_696); } 
{ /* Lalr/driver.scm 47 */

{ 
long i_332;
i_332 = ((long)0); 
loop_333:
if(
(i_332<len_330))
{ /* Lalr/driver.scm 49 */
{ /* ./Ieee/vector.scm 4761 */
obj_t aux_701;
aux_701 = 
VECTOR_REF(v_1, i_332); 
VECTOR_SET(v2_331, i_332, aux_701); } 
{ 
long i_704;
i_704 = 
(i_332+((long)1)); 
i_332 = i_704; 
goto loop_333;} }  else 
{ /* Lalr/driver.scm 49 */
return v2_331;} } } } } } 
}



/* __push */
obj_t __push___lalr_driver(obj_t stack_2, obj_t sp_3, obj_t new_cat_213_4, obj_t goto_table_156_5, obj_t lval_6)
{ AN_OBJECT;
{ /* Lalr/driver.scm 55 */
{ /* Lalr/driver.scm 57 */
long new_sp_136_562;
{ /* ./Ieee/fixnum.scm 2468 */
long aux_706;
aux_706 = 
(long)CINT(sp_3); 
new_sp_136_562 = 
(aux_706+((long)2)); } 
{ /* Lalr/driver.scm 58 */

{ /* ./Ieee/vector.scm 4761 */
obj_t aux_709;
{ /* ./Ieee/pair-list.scm 4124 */
obj_t aux_710;
{ /* Lalr/driver.scm 57 */
obj_t aux_711;
{ /* ./Ieee/vector.scm 4755 */
long aux_712;
{ /* Lalr/driver.scm 57 */
obj_t aux_713;
{ /* ./Ieee/vector.scm 4755 */
long aux_714;
aux_714 = 
(long)CINT(sp_3); 
aux_713 = 
VECTOR_REF(stack_2, aux_714); } 
aux_712 = 
(long)CINT(aux_713); } 
aux_711 = 
VECTOR_REF(goto_table_156_5, aux_712); } 
aux_710 = 
assq___r4_pairs_and_lists_6_3(new_cat_213_4, aux_711); } 
aux_709 = 
CDR(aux_710); } 
VECTOR_SET(stack_2, new_sp_136_562, aux_709); } 
{ /* ./Ieee/vector.scm 4761 */
long aux_722;
aux_722 = 
(new_sp_136_562-((long)1)); 
VECTOR_SET(stack_2, aux_722, lval_6); } 
return 
BINT(new_sp_136_562);} } } 
}



/* ___push */
obj_t ___push___lalr_driver(obj_t env_666, obj_t stack_667, obj_t sp_668, obj_t new_cat_213_669, obj_t goto_table_156_670, obj_t lval_671)
{ AN_OBJECT;
{ /* Lalr/driver.scm 55 */
return 
__push___lalr_driver(stack_667, sp_668, new_cat_213_669, goto_table_156_670, lval_671);} 
}



/* __make-parser */
obj_t __make_parser_228___lalr_driver(obj_t action_table_22_7, obj_t reduction_function_42_8)
{ AN_OBJECT;
{ /* Lalr/driver.scm 64 */
{ /* Lalr/driver.scm 65 */
obj_t _anonymous_1014__195_672;
_anonymous_1014__195_672 = 
make_fx_procedure(_anonymous_1014__195___lalr_driver, ((long)3), ((long)2)); 
PROCEDURE_SET(_anonymous_1014__195_672, ((long)0), action_table_22_7); 
PROCEDURE_SET(_anonymous_1014__195_672, ((long)1), reduction_function_42_8); 
return _anonymous_1014__195_672;} } 
}



/* ___make-parser */
obj_t ___make_parser_139___lalr_driver(obj_t env_673, obj_t action_table_22_674, obj_t reduction_function_42_675)
{ AN_OBJECT;
{ /* Lalr/driver.scm 64 */
return 
__make_parser_228___lalr_driver(action_table_22_674, reduction_function_42_675);} 
}



/* <anonymous:1014> */
obj_t _anonymous_1014__195___lalr_driver(obj_t env_676, obj_t rgc_679, obj_t input_port_219_680, obj_t is_eof__68_681)
{ AN_OBJECT;
{ /* Lalr/driver.scm 65 */
{ /* Lalr/driver.scm 73 */
obj_t action_table_22_677;obj_t reduction_function_42_678;
action_table_22_677 = 
PROCEDURE_REF(env_676, ((long)0)); 
reduction_function_42_678 = 
PROCEDURE_REF(env_676, ((long)1)); 
{ 
obj_t rgc_345;obj_t input_port_219_346;obj_t is_eof__68_347;
rgc_345 = rgc_679; 
input_port_219_346 = input_port_219_680; 
is_eof__68_347 = is_eof__68_681; 
{ /* Lalr/driver.scm 73 */
obj_t stack_350;obj_t state_351;obj_t input_352;obj_t in_353;obj_t attr_354;obj_t acts_355;obj_t act_356;bool_t eof__196_357;
{ /* Lalr/driver.scm 73 */
obj_t aux_733;
aux_733 = 
BINT(((long)0)); 
stack_350 = 
make_vector(((long)500), aux_733); } 
state_351 = BFALSE; 
input_352 = BFALSE; 
in_353 = BFALSE; 
attr_354 = BFALSE; 
acts_355 = BFALSE; 
act_356 = BFALSE; 
eof__196_357 = ((bool_t)0); 
{ 
obj_t sp_358;
sp_358 = 
BINT(((long)0)); 
loop_359:
{ /* Lalr/driver.scm 83 */
obj_t vector_579;
vector_579 = stack_350; 
{ /* ./Ieee/vector.scm 4755 */
long aux_736;
aux_736 = 
(long)CINT(sp_358); 
state_351 = 
VECTOR_REF(vector_579, aux_736); } } 
{ /* Lalr/driver.scm 84 */
long k_582;
k_582 = 
(long)CINT(state_351); 
acts_355 = 
VECTOR_REF(action_table_22_677, k_582); } 
{ /* Lalr/driver.scm 86 */
bool_t test1015_360;
{ /* Lalr/driver.scm 86 */
obj_t arg1018_363;
{ /* Lalr/driver.scm 86 */
obj_t pair_583;
pair_583 = acts_355; 
arg1018_363 = 
CDR(pair_583); } 
test1015_360 = 
NULLP(arg1018_363); } 
if(test1015_360)
{ /* Lalr/driver.scm 87 */
obj_t pair_585;
pair_585 = acts_355; 
{ /* ./Ieee/pair-list.scm 4124 */
obj_t aux_744;
aux_744 = 
CAR(pair_585); 
act_356 = 
CDR(aux_744); } }  else 
{ /* Lalr/driver.scm 86 */
if(
CBOOL(input_352))
{ /* Lalr/driver.scm 89 */BUNSPEC; }  else 
{ /* Lalr/driver.scm 89 */
input_352 = 
PROCEDURE_ENTRY(rgc_345)(rgc_345, input_port_219_346, BEOA); } 
if(
CBOOL(input_352))
{ /* Lalr/driver.scm 91 */BUNSPEC; }  else 
{ /* Lalr/driver.scm 91 */
FAILURE(string1193___lalr_driver,string1194___lalr_driver,BFALSE);} 
{ /* Lalr/driver.scm 95 */
bool_t test1016_361;
{ /* Lalr/driver.scm 95 */
obj_t aux_754;
aux_754 = 
PROCEDURE_ENTRY(is_eof__68_347)(is_eof__68_347, input_352, BEOA); 
test1016_361 = 
CBOOL(aux_754); } 
if(test1016_361)
{ /* Lalr/driver.scm 95 */
in_353 = symbol1195___lalr_driver; 
attr_354 = BFALSE; 
eof__196_357 = ((bool_t)1); }  else 
{ /* Lalr/driver.scm 99 */
bool_t test1017_362;
{ /* Lalr/driver.scm 99 */
obj_t obj_594;
obj_594 = input_352; 
test1017_362 = 
PAIRP(obj_594); } 
if(test1017_362)
{ /* Lalr/driver.scm 99 */
{ /* Lalr/driver.scm 100 */
obj_t pair_595;
pair_595 = input_352; 
in_353 = 
CAR(pair_595); } 
{ /* Lalr/driver.scm 101 */
obj_t pair_596;
pair_596 = input_352; 
attr_354 = 
CDR(pair_596); } }  else 
{ /* Lalr/driver.scm 99 */
in_353 = input_352; 
attr_354 = BFALSE; } } } 
{ /* Lalr/driver.scm 106 */
obj_t x_597;obj_t l_598;
x_597 = in_353; 
l_598 = acts_355; 
{ /* Lalr/driver.scm 68 */
obj_t y_599;
y_599 = 
assq___r4_pairs_and_lists_6_3(x_597, l_598); 
if(
CBOOL(y_599))
{ /* Lalr/driver.scm 69 */
act_356 = 
CDR(y_599); }  else 
{ /* ./Ieee/pair-list.scm 4124 */
obj_t aux_767;
aux_767 = 
CAR(l_598); 
act_356 = 
CDR(aux_767); } } } } } 
if(
CBOOL(_debug_parser__183___lalr_driver))
{ /* Lalr/driver.scm 108 */
display_2_122___r4_output_6_10_3(string1196___lalr_driver, current_output_port); 
display_2_122___r4_output_6_10_3(in_353, current_output_port); 
display_2_122___r4_output_6_10_3(string1197___lalr_driver, current_output_port); 
display_2_122___r4_output_6_10_3(state_351, current_output_port); 
display_2_122___r4_output_6_10_3(string1198___lalr_driver, current_output_port); 
display_2_122___r4_output_6_10_3(sp_358, current_output_port); 
{ /* ./Ieee/output.scm 5348 */
unsigned char aux_778;
aux_778 = 
WRITE_CHAR(((unsigned char)'\n'), current_output_port); 
BCHAR(aux_778); } }  else 
{ /* Lalr/driver.scm 108 */BUNSPEC; } 
{ /* Lalr/driver.scm 121 */
bool_t test1029_374;
{ /* Lalr/driver.scm 121 */
obj_t obj1_606;
obj1_606 = act_356; 
test1029_374 = 
(obj1_606==symbol1199___lalr_driver); } 
if(test1029_374)
{ /* Lalr/driver.scm 121 */
{ /* Lalr/driver.scm 122 */
obj_t vector_608;
vector_608 = stack_350; 
return 
VECTOR_REF(vector_608, ((long)1));} }  else 
{ /* Lalr/driver.scm 125 */
bool_t test1030_375;
{ /* Lalr/driver.scm 125 */
obj_t obj1_610;
obj1_610 = act_356; 
test1030_375 = 
(obj1_610==symbol1200___lalr_driver); } 
if(test1030_375)
{ /* Lalr/driver.scm 125 */
{ /* Lalr/driver.scm 126 */
obj_t msg_376;
{ /* Lalr/driver.scm 126 */
obj_t arg1032_378;
{ /* Lalr/driver.scm 129 */
obj_t arg1033_379;
{ /* Lalr/driver.scm 129 */
bool_t test1035_381;
{ /* Lalr/driver.scm 129 */
obj_t obj_612;
obj_612 = in_353; 
test1035_381 = 
SYMBOLP(obj_612); } 
if(test1035_381)
{ /* Lalr/driver.scm 129 */
{ /* Lalr/driver.scm 130 */
obj_t symbol_613;
symbol_613 = in_353; 
arg1033_379 = 
SYMBOL_TO_STRING(symbol_613); } }  else 
{ /* Lalr/driver.scm 131 */
bool_t test1036_382;
{ /* Lalr/driver.scm 131 */
obj_t obj_614;
obj_614 = in_353; 
test1036_382 = 
CHARP(obj_614); } 
if(test1036_382)
{ /* Lalr/driver.scm 131 */
{ /* Lalr/driver.scm 132 */
obj_t list1037_383;
list1037_383 = 
MAKE_PAIR(in_353, BNIL); 
{ /* Lalr/driver.scm 132 */
obj_t res1192_621;
{ /* ./Ieee/string.scm 3652 */
unsigned char aux_796;long aux_792;
{ /* ./Ieee/string.scm 3652 */
obj_t aux_797;
aux_797 = 
CAR(list1037_383); 
aux_796 = 
(unsigned char)CCHAR(aux_797); } 
{ /* ./Ieee/string.scm 3652 */
int aux_793;
aux_793 = 
(int)(((long)1)); 
aux_792 = 
(long)(aux_793); } 
res1192_621 = 
make_string(aux_792, aux_796); } 
arg1033_379 = res1192_621; } } }  else 
{ /* Lalr/driver.scm 131 */
{ /* Lalr/driver.scm 134 */
obj_t arg1038_384;
{ /* Lalr/driver.scm 134 */
obj_t list1039_385;
list1039_385 = 
MAKE_PAIR(in_353, BNIL); 
arg1038_384 = list1039_385; } 
arg1033_379 = 
list__string_78___r4_strings_6_7(arg1038_384); } } } } 
arg1032_378 = 
string_append(arg1033_379, string1201___lalr_driver); } 
msg_376 = 
string_append(string1202___lalr_driver, arg1032_378); } 
{ /* Lalr/driver.scm 136 */
obj_t object_625;
object_625 = input_352; 
FAILURE(string1193___lalr_driver,msg_376,object_625);} } }  else 
{ /* Lalr/driver.scm 139 */
bool_t test1040_386;
{ /* Lalr/driver.scm 139 */
long n1_626;
n1_626 = 
(long)CINT(act_356); 
test1040_386 = 
(n1_626>=((long)0)); } 
if(test1040_386)
{ /* Lalr/driver.scm 139 */
{ /* Lalr/driver.scm 140 */
bool_t test1041_387;
{ /* Lalr/driver.scm 140 */
long arg1043_388;
{ /* Lalr/driver.scm 140 */
long arg1044_389;
{ /* Lalr/driver.scm 140 */
obj_t vector_628;
vector_628 = stack_350; 
arg1044_389 = 
VECTOR_LENGTH(vector_628); } 
arg1043_388 = 
(arg1044_389-((long)2)); } 
{ /* ./Ieee/fixnum.scm 2408 */
long aux_811;
aux_811 = 
(long)CINT(sp_358); 
test1041_387 = 
(aux_811>=arg1043_388); } } 
if(test1041_387)
{ /* Lalr/driver.scm 140 */
stack_350 = 
grow_stack__56___lalr_driver(stack_350); }  else 
{ /* Lalr/driver.scm 140 */BUNSPEC; } } 
{ /* Lalr/driver.scm 142 */
obj_t vector_635;obj_t obj_637;
vector_635 = stack_350; 
obj_637 = attr_354; 
{ /* ./Ieee/vector.scm 4761 */
long aux_816;
{ /* ./Ieee/fixnum.scm 2468 */
long aux_817;
aux_817 = 
(long)CINT(sp_358); 
aux_816 = 
(aux_817+((long)1)); } 
VECTOR_SET(vector_635, aux_816, obj_637); } } 
{ /* Lalr/driver.scm 143 */
obj_t vector_640;obj_t obj_642;
vector_640 = stack_350; 
obj_642 = act_356; 
{ /* ./Ieee/vector.scm 4761 */
long aux_821;
{ /* ./Ieee/fixnum.scm 2468 */
long aux_822;
aux_822 = 
(long)CINT(sp_358); 
aux_821 = 
(aux_822+((long)2)); } 
VECTOR_SET(vector_640, aux_821, obj_642); } } 
if(eof__196_357)
{ /* Lalr/driver.scm 144 */BUNSPEC; }  else 
{ /* Lalr/driver.scm 144 */
input_352 = BFALSE; } 
{ 
obj_t sp_827;
{ /* Lalr/driver.scm 146 */
long aux_828;
{ /* ./Ieee/fixnum.scm 2468 */
long aux_829;
aux_829 = 
(long)CINT(sp_358); 
aux_828 = 
(aux_829+((long)2)); } 
sp_827 = 
BINT(aux_828); } 
sp_358 = sp_827; 
goto loop_359;} }  else 
{ /* Lalr/driver.scm 139 */
{ /* Lalr/driver.scm 150 */
obj_t arg1049_394;
{ /* Lalr/driver.scm 150 */
long arg1050_395;
{ /* Lalr/driver.scm 150 */
long n1_645;
n1_645 = 
(long)CINT(act_356); 
arg1050_395 = 
NEG(n1_645); } 
arg1049_394 = 
PROCEDURE_ENTRY(reduction_function_42_678)(reduction_function_42_678, 
BINT(arg1050_395), stack_350, sp_358, BEOA); } 
{ 
obj_t sp_838;
sp_838 = arg1049_394; 
sp_358 = sp_838; 
goto loop_359;} } } } } } } } } } } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___lalr_driver()
{ AN_OBJECT;
{ /* Lalr/driver.scm 11 */
return 
module_initialization_70___error(((long)0), "__LALR_DRIVER");} 
}

