/*===========================================================================*/
/*   (Lalr/gen.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t _symv__174___lalr_rewrite;
extern obj_t string_to_symbol(char *);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t gen_lalr_code_179___lalr_gen();
static obj_t symbol1383___lalr_gen = BUNSPEC;
static obj_t symbol1382___lalr_gen = BUNSPEC;
static obj_t symbol1381___lalr_gen = BUNSPEC;
static obj_t symbol1379___lalr_gen = BUNSPEC;
static obj_t symbol1380___lalr_gen = BUNSPEC;
static obj_t symbol1378___lalr_gen = BUNSPEC;
static obj_t symbol1377___lalr_gen = BUNSPEC;
static obj_t symbol1376___lalr_gen = BUNSPEC;
static obj_t symbol1375___lalr_gen = BUNSPEC;
static obj_t symbol1374___lalr_gen = BUNSPEC;
static obj_t symbol1373___lalr_gen = BUNSPEC;
static obj_t symbol1372___lalr_gen = BUNSPEC;
static obj_t symbol1371___lalr_gen = BUNSPEC;
static obj_t symbol1369___lalr_gen = BUNSPEC;
static obj_t symbol1370___lalr_gen = BUNSPEC;
static obj_t symbol1368___lalr_gen = BUNSPEC;
static obj_t gen_goto_table_30___lalr_gen();
static obj_t _gen_lalr_code_37___lalr_gen(obj_t);
static obj_t loop_p_143___lalr_gen(obj_t, obj_t, obj_t, long);
static obj_t loop_l_5___lalr_gen(obj_t, long);
static obj_t loop_g_139___lalr_gen(long);
static obj_t loop_a_59___lalr_gen(long);
static obj_t loop___221___lalr_gen(obj_t);
extern obj_t acces_symbol_228___lalr_global;
extern obj_t action_table_22___lalr_global;
static obj_t loop___lalr_gen(long, obj_t);
static obj_t reductions___lalr_gen();
extern obj_t nvars___lalr_global;
extern obj_t module_initialization_70___lalr_gen(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___lalr_global(long, char *);
extern obj_t module_initialization_70___lalr_rewrite(long, char *);
extern obj_t module_initialization_70___type(long, char *);
extern obj_t module_initialization_70___bigloo(long, char *);
extern obj_t module_initialization_70___tvector(long, char *);
extern obj_t module_initialization_70___structure(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_fixnum(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5_flonum(long, char *);
extern obj_t module_initialization_70___r4_characters_6_6(long, char *);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___r4_booleans_6_1(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_input_6_10_2(long, char *);
extern obj_t module_initialization_70___r4_control_features_6_9(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
extern obj_t module_initialization_70___r4_ports_6_10_1(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t nstates___lalr_global;
static obj_t actions___lalr_gen();
extern long list_length(obj_t);
static obj_t gotos___lalr_gen();
extern obj_t grammar___lalr_global;
static obj_t gen_action_table_103___lalr_gen();
extern obj_t list__vector_101___r4_vectors_6_8(obj_t);
extern bool_t _2__95___r4_numbers_6_5(obj_t, obj_t);
static obj_t gen_reduction_table_195___lalr_gen();
extern obj_t shift_table_147___lalr_global;
static obj_t imported_modules_init_94___lalr_gen();
static obj_t require_initialization_114___lalr_gen = BUNSPEC;
static obj_t loop__120___lalr_gen(obj_t);
static obj_t cnst_init_137___lalr_gen();
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( gen_lalr_code_env_112___lalr_gen, _gen_lalr_code_37___lalr_gen1385, _gen_lalr_code_37___lalr_gen, 0L, 0 );



/* module-initialization */
obj_t module_initialization_70___lalr_gen(long checksum_872, char * from_873)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___lalr_gen))
{ 
require_initialization_114___lalr_gen = 
BBOOL(((bool_t)0)); 
cnst_init_137___lalr_gen(); 
imported_modules_init_94___lalr_gen(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t cnst_init_137___lalr_gen()
{ AN_OBJECT;
{ /* Lalr/gen.scm 11 */
symbol1368___lalr_gen = 
string_to_symbol("LET*"); 
symbol1369___lalr_gen = 
string_to_symbol("__MAKE-PARSER"); 
symbol1370___lalr_gen = 
string_to_symbol("__ACTION-TABLE"); 
symbol1371___lalr_gen = 
string_to_symbol("__REDUCE"); 
symbol1372___lalr_gen = 
string_to_symbol("QUOTE"); 
symbol1373___lalr_gen = 
string_to_symbol("__GOTO-TABLE"); 
symbol1374___lalr_gen = 
string_to_symbol("LAMBDA"); 
symbol1375___lalr_gen = 
string_to_symbol("N"); 
symbol1376___lalr_gen = 
string_to_symbol("__STACK"); 
symbol1377___lalr_gen = 
string_to_symbol("__SP"); 
symbol1378___lalr_gen = 
string_to_symbol("CASE"); 
symbol1379___lalr_gen = 
string_to_symbol("*START*"); 
symbol1380___lalr_gen = 
string_to_symbol("__PUSH"); 
symbol1381___lalr_gen = 
string_to_symbol("-FX"); 
symbol1382___lalr_gen = 
string_to_symbol("LET"); 
return ( 
symbol1383___lalr_gen = 
string_to_symbol("VECTOR-REF-UR"), BUNSPEC) ;} 
}



/* gen-lalr-code */
obj_t gen_lalr_code_179___lalr_gen()
{ AN_OBJECT;
{ /* Lalr/gen.scm 43 */
{ /* Lalr/gen.scm 44 */
obj_t arg1034_322;obj_t arg1035_323;
arg1034_322 = symbol1368___lalr_gen; 
{ /* Lalr/gen.scm 44 */
obj_t arg1036_324;obj_t arg1038_325;
{ /* Lalr/gen.scm 44 */
obj_t arg1039_326;obj_t arg1040_327;
arg1039_326 = 
gen_action_table_103___lalr_gen(); 
{ /* Lalr/gen.scm 45 */
obj_t arg1041_328;obj_t arg1043_329;
arg1041_328 = 
gen_goto_table_30___lalr_gen(); 
{ /* Lalr/gen.scm 46 */
obj_t arg1044_330;
arg1044_330 = 
gen_reduction_table_195___lalr_gen(); 
arg1043_329 = 
MAKE_PAIR(arg1044_330, BNIL); } 
arg1040_327 = 
MAKE_PAIR(arg1041_328, arg1043_329); } 
arg1036_324 = 
MAKE_PAIR(arg1039_326, arg1040_327); } 
{ /* Lalr/gen.scm 47 */
obj_t arg1046_332;
{ /* Lalr/gen.scm 47 */
obj_t arg1048_334;obj_t arg1049_335;
arg1048_334 = symbol1369___lalr_gen; 
{ /* Lalr/gen.scm 47 */
obj_t arg1050_336;obj_t arg1051_337;
arg1050_336 = symbol1370___lalr_gen; 
arg1051_337 = 
MAKE_PAIR(symbol1371___lalr_gen, BNIL); 
arg1049_335 = 
MAKE_PAIR(arg1050_336, arg1051_337); } 
arg1046_332 = 
MAKE_PAIR(arg1048_334, arg1049_335); } 
arg1038_325 = 
MAKE_PAIR(arg1046_332, BNIL); } 
arg1035_323 = 
MAKE_PAIR(arg1036_324, arg1038_325); } 
return 
MAKE_PAIR(arg1034_322, arg1035_323);} } 
}



/* _gen-lalr-code */
obj_t _gen_lalr_code_37___lalr_gen(obj_t env_866)
{ AN_OBJECT;
{ /* Lalr/gen.scm 43 */
return 
gen_lalr_code_179___lalr_gen();} 
}



/* gen-action-table */
obj_t gen_action_table_103___lalr_gen()
{ AN_OBJECT;
{ /* Lalr/gen.scm 50 */
{ /* Lalr/gen.scm 67 */
obj_t arg1052_339;obj_t arg1054_340;
arg1052_339 = symbol1370___lalr_gen; 
{ /* Lalr/gen.scm 67 */
obj_t arg1055_341;
{ /* Lalr/gen.scm 67 */
obj_t arg1062_343;obj_t arg1063_344;
arg1062_343 = symbol1372___lalr_gen; 
{ /* Lalr/gen.scm 67 */
obj_t arg1064_345;
{ /* Lalr/gen.scm 67 */
obj_t arg1066_347;
{ /* Lalr/gen.scm 67 */
obj_t arg1067_348;
arg1067_348 = 
actions___lalr_gen(); 
arg1066_347 = 
append_2_18___r4_pairs_and_lists_6_3(arg1067_348, BNIL); } 
arg1064_345 = 
list__vector_101___r4_vectors_6_8(arg1066_347); } 
arg1063_344 = 
MAKE_PAIR(arg1064_345, BNIL); } 
arg1055_341 = 
MAKE_PAIR(arg1062_343, arg1063_344); } 
arg1054_340 = 
MAKE_PAIR(arg1055_341, BNIL); } 
return 
MAKE_PAIR(arg1052_339, arg1054_340);} } 
}



/* loop'' */
obj_t loop___221___lalr_gen(obj_t l_356)
{ AN_OBJECT;
{ /* Lalr/gen.scm 56 */
if(
NULLP(l_356))
{ /* Lalr/gen.scm 57 */
return BNIL;}  else 
{ /* Lalr/gen.scm 59 */
obj_t p_360;
p_360 = 
CAR(l_356); 
{ /* Lalr/gen.scm 59 */
obj_t x_361;
x_361 = 
CAR(p_360); 
{ /* Lalr/gen.scm 59 */
obj_t y_362;
y_362 = 
CDR(p_360); 
{ /* Lalr/gen.scm 59 */

{ /* Lalr/gen.scm 62 */
obj_t arg1075_363;obj_t arg1076_364;
{ /* Lalr/gen.scm 62 */
obj_t arg1077_365;
if(
INTEGERP(x_361))
{ /* Lalr/gen.scm 62 */
long arg1079_367;
{ /* Lalr/gen.scm 62 */
long z1_702;long z2_703;
z1_702 = 
(long)CINT(nvars___lalr_global); 
z2_703 = 
(long)CINT(x_361); 
arg1079_367 = 
(z1_702+z2_703); } 
{ /* Lalr/gen.scm 62 */
obj_t vector_704;
vector_704 = _symv__174___lalr_rewrite; 
arg1077_365 = 
VECTOR_REF(vector_704, arg1079_367); } }  else 
{ /* Lalr/gen.scm 62 */
arg1077_365 = x_361; } 
arg1075_363 = 
MAKE_PAIR(arg1077_365, y_362); } 
arg1076_364 = 
loop___221___lalr_gen(
CDR(l_356)); 
return 
MAKE_PAIR(arg1075_363, arg1076_364);} } } } } } 
}



/* loop-a */
obj_t loop_a_59___lalr_gen(long i_351)
{ AN_OBJECT;
{ /* Lalr/gen.scm 52 */
{ /* Lalr/gen.scm 53 */
bool_t test1070_353;
test1070_353 = 
_2__95___r4_numbers_6_5(
BINT(i_351), nstates___lalr_global); 
if(test1070_353)
{ /* Lalr/gen.scm 53 */
return BNIL;}  else 
{ /* Lalr/gen.scm 56 */
obj_t arg1071_354;obj_t arg1072_355;
{ /* Lalr/gen.scm 56 */
obj_t arg1073_358;
{ /* Lalr/gen.scm 56 */
obj_t vector_695;
vector_695 = action_table_22___lalr_global; 
arg1073_358 = 
VECTOR_REF(vector_695, i_351); } 
arg1071_354 = 
loop___221___lalr_gen(arg1073_358); } 
arg1072_355 = 
loop_a_59___lalr_gen(
(i_351+((long)1))); 
return 
MAKE_PAIR(arg1071_354, arg1072_355);} } } 
}



/* actions */
obj_t actions___lalr_gen()
{ AN_OBJECT;
{ /* Lalr/gen.scm 51 */
return 
loop_a_59___lalr_gen(((long)0));} 
}



/* gen-goto-table */
obj_t gen_goto_table_30___lalr_gen()
{ AN_OBJECT;
{ /* Lalr/gen.scm 69 */
{ /* Lalr/gen.scm 90 */
obj_t arg1082_372;obj_t arg1083_373;
arg1082_372 = symbol1373___lalr_gen; 
{ /* Lalr/gen.scm 90 */
obj_t arg1084_374;
{ /* Lalr/gen.scm 90 */
obj_t arg1086_376;obj_t arg1087_377;
arg1086_376 = symbol1372___lalr_gen; 
{ /* Lalr/gen.scm 90 */
obj_t arg1088_378;
{ /* Lalr/gen.scm 90 */
obj_t arg1090_380;
{ /* Lalr/gen.scm 90 */
obj_t arg1091_381;
arg1091_381 = 
gotos___lalr_gen(); 
arg1090_380 = 
append_2_18___r4_pairs_and_lists_6_3(arg1091_381, BNIL); } 
arg1088_378 = 
list__vector_101___r4_vectors_6_8(arg1090_380); } 
arg1087_377 = 
MAKE_PAIR(arg1088_378, BNIL); } 
arg1084_374 = 
MAKE_PAIR(arg1086_376, arg1087_377); } 
arg1083_373 = 
MAKE_PAIR(arg1084_374, BNIL); } 
return 
MAKE_PAIR(arg1082_372, arg1083_373);} } 
}



/* loop' */
obj_t loop__120___lalr_gen(obj_t l_390)
{ AN_OBJECT;
{ /* Lalr/gen.scm 77 */
loop__120___lalr_gen:
if(
NULLP(l_390))
{ /* Lalr/gen.scm 78 */
return BNIL;}  else 
{ /* Lalr/gen.scm 80 */
obj_t state_394;
state_394 = 
CAR(l_390); 
{ /* Lalr/gen.scm 80 */
obj_t symbol_395;
{ /* Lalr/gen.scm 81 */
obj_t vector_729;
vector_729 = acces_symbol_228___lalr_global; 
{ /* ./Ieee/vector.scm 4940 */
long aux_949;
aux_949 = 
(long)CINT(state_394); 
symbol_395 = 
VECTOR_REF(vector_729, aux_949); } } 
{ /* Lalr/gen.scm 81 */

{ /* Lalr/gen.scm 82 */
bool_t test1099_396;
{ /* Lalr/gen.scm 82 */
long n1_731;long n2_732;
n1_731 = 
(long)CINT(symbol_395); 
n2_732 = 
(long)CINT(nvars___lalr_global); 
test1099_396 = 
(n1_731<n2_732); } 
if(test1099_396)
{ /* Lalr/gen.scm 84 */
obj_t arg1100_397;obj_t arg1101_398;
{ /* Lalr/gen.scm 84 */
obj_t arg1102_399;
{ /* Lalr/gen.scm 84 */
obj_t vector_733;
vector_733 = _symv__174___lalr_rewrite; 
{ /* ./Ieee/vector.scm 4940 */
long aux_956;
aux_956 = 
(long)CINT(symbol_395); 
arg1102_399 = 
VECTOR_REF(vector_733, aux_956); } } 
arg1100_397 = 
MAKE_PAIR(arg1102_399, state_394); } 
arg1101_398 = 
loop__120___lalr_gen(
CDR(l_390)); 
return 
MAKE_PAIR(arg1100_397, arg1101_398);}  else 
{ 
obj_t l_963;
l_963 = 
CDR(l_390); 
l_390 = l_963; 
goto loop__120___lalr_gen;} } } } } } 
}



/* loop-g */
obj_t loop_g_139___lalr_gen(long i_384)
{ AN_OBJECT;
{ /* Lalr/gen.scm 71 */
{ /* Lalr/gen.scm 72 */
bool_t test1094_386;
test1094_386 = 
_2__95___r4_numbers_6_5(
BINT(i_384), nstates___lalr_global); 
if(test1094_386)
{ /* Lalr/gen.scm 72 */
return BNIL;}  else 
{ /* Lalr/gen.scm 75 */
obj_t arg1095_387;obj_t arg1096_388;
{ /* Lalr/gen.scm 75 */
obj_t shifts_389;
{ /* Lalr/gen.scm 75 */
obj_t vector_723;
vector_723 = shift_table_147___lalr_global; 
shifts_389 = 
VECTOR_REF(vector_723, i_384); } 
if(
CBOOL(shifts_389))
{ /* Lalr/gen.scm 76 */
arg1095_387 = 
loop__120___lalr_gen(
VECTOR_REF(shifts_389, ((long)2))); }  else 
{ /* Lalr/gen.scm 76 */
arg1095_387 = BNIL; } } 
arg1096_388 = 
loop_g_139___lalr_gen(
(i_384+((long)1))); 
return 
MAKE_PAIR(arg1095_387, arg1096_388);} } } 
}



/* gotos */
obj_t gotos___lalr_gen()
{ AN_OBJECT;
{ /* Lalr/gen.scm 70 */
return 
loop_g_139___lalr_gen(((long)0));} 
}



/* gen-reduction-table */
obj_t gen_reduction_table_195___lalr_gen()
{ AN_OBJECT;
{ /* Lalr/gen.scm 92 */
{ /* Lalr/gen.scm 129 */
obj_t arg1106_407;obj_t arg1107_408;
arg1106_407 = symbol1371___lalr_gen; 
{ /* Lalr/gen.scm 129 */
obj_t arg1108_409;
{ /* Lalr/gen.scm 129 */
obj_t arg1110_411;obj_t arg1111_412;
arg1110_411 = symbol1374___lalr_gen; 
{ /* Lalr/gen.scm 129 */
obj_t arg1112_413;obj_t arg1113_414;
{ /* Lalr/gen.scm 129 */
obj_t arg1114_415;obj_t arg1115_416;
arg1114_415 = symbol1375___lalr_gen; 
{ /* Lalr/gen.scm 129 */
obj_t arg1116_417;obj_t arg1117_418;
arg1116_417 = symbol1376___lalr_gen; 
arg1117_418 = 
MAKE_PAIR(symbol1377___lalr_gen, BNIL); 
arg1115_416 = 
MAKE_PAIR(arg1116_417, arg1117_418); } 
arg1112_413 = 
MAKE_PAIR(arg1114_415, arg1115_416); } 
{ /* Lalr/gen.scm 130 */
obj_t arg1118_419;
{ /* Lalr/gen.scm 130 */
obj_t arg1120_421;obj_t arg1121_422;
arg1120_421 = symbol1378___lalr_gen; 
{ /* Lalr/gen.scm 130 */
obj_t arg1122_423;obj_t arg1123_424;
arg1122_423 = symbol1375___lalr_gen; 
{ /* Lalr/gen.scm 131 */
obj_t arg1124_425;
arg1124_425 = 
reductions___lalr_gen(); 
arg1123_424 = 
append_2_18___r4_pairs_and_lists_6_3(arg1124_425, BNIL); } 
arg1121_422 = 
MAKE_PAIR(arg1122_423, arg1123_424); } 
arg1118_419 = 
MAKE_PAIR(arg1120_421, arg1121_422); } 
arg1113_414 = 
MAKE_PAIR(arg1118_419, BNIL); } 
arg1111_412 = 
MAKE_PAIR(arg1112_413, arg1113_414); } 
arg1108_409 = 
MAKE_PAIR(arg1110_411, arg1111_412); } 
arg1107_408 = 
MAKE_PAIR(arg1108_409, BNIL); } 
return 
MAKE_PAIR(arg1106_407, arg1107_408);} } 
}



/* loop-l */
obj_t loop_l_5___lalr_gen(obj_t l_428, long no_429)
{ AN_OBJECT;
{ /* Lalr/gen.scm 112 */
if(
NULLP(l_428))
{ /* Lalr/gen.scm 113 */
return BNIL;}  else 
{ /* Lalr/gen.scm 115 */
obj_t def_432;
def_432 = 
CAR(l_428); 
{ /* Lalr/gen.scm 116 */

return 
loop_p_143___lalr_gen(l_428, 
CAR(def_432), 
CDR(def_432), no_429);} } } 
}



/* loop-p */
obj_t loop_p_143___lalr_gen(obj_t l_868, obj_t nt_867, obj_t prods_434, long no_435)
{ AN_OBJECT;
{ /* Lalr/gen.scm 117 */
{ 
obj_t nt_460;long n_461;obj_t act_462;
if(
NULLP(prods_434))
{ /* Lalr/gen.scm 118 */
return 
loop_l_5___lalr_gen(
CDR(l_868), no_435);}  else 
{ /* Lalr/gen.scm 120 */
obj_t rhs_440;
{ /* ./Ieee/pair-list.scm 4303 */
obj_t aux_999;
aux_999 = 
CAR(prods_434); 
rhs_440 = 
CAR(aux_999); } 
{ /* Lalr/gen.scm 120 */
obj_t act_441;
{ /* ./Ieee/pair-list.scm 4309 */
obj_t aux_1002;
aux_1002 = 
CAR(prods_434); 
act_441 = 
CDR(aux_1002); } 
{ /* Lalr/gen.scm 120 */
long n_442;
n_442 = 
list_length(rhs_440); 
{ /* Lalr/gen.scm 120 */

{ /* Lalr/gen.scm 123 */
obj_t arg1131_443;obj_t arg1132_444;
{ /* Lalr/gen.scm 123 */
obj_t arg1133_445;obj_t arg1134_446;
{ /* Lalr/gen.scm 123 */
obj_t list1138_449;
{ /* Lalr/gen.scm 123 */
obj_t aux_1006;
aux_1006 = 
BINT(no_435); 
list1138_449 = 
MAKE_PAIR(aux_1006, BNIL); } 
arg1133_445 = list1138_449; } 
{ /* Lalr/gen.scm 124 */
obj_t arg1139_450;obj_t arg1140_451;
arg1139_450 = symbol1382___lalr_gen; 
{ /* Lalr/gen.scm 124 */
obj_t arg1141_452;obj_t arg1142_453;
{ /* Lalr/gen.scm 124 */
obj_t arg1143_454;
{ /* Lalr/gen.scm 124 */
obj_t rhs_869;long n_871;
rhs_869 = rhs_440; 
n_871 = n_442; 
arg1143_454 = 
loop___lalr_gen(n_871, rhs_869); } 
arg1141_452 = 
append_2_18___r4_pairs_and_lists_6_3(arg1143_454, BNIL); } 
{ /* Lalr/gen.scm 125 */
obj_t arg1145_456;
nt_460 = nt_867; 
n_461 = n_442; 
act_462 = act_441; 
if(
(nt_460==symbol1379___lalr_gen))
{ /* Lalr/gen.scm 105 */
obj_t vector_794;
vector_794 = _symv__174___lalr_rewrite; 
arg1145_456 = 
VECTOR_REF(vector_794, ((long)1)); }  else 
{ /* Lalr/gen.scm 106 */
obj_t arg1151_465;obj_t arg1152_466;
arg1151_465 = symbol1380___lalr_gen; 
{ /* Lalr/gen.scm 106 */
obj_t arg1153_467;obj_t arg1154_468;
arg1153_467 = symbol1376___lalr_gen; 
{ /* Lalr/gen.scm 106 */
obj_t arg1155_469;obj_t arg1156_470;
{ /* Lalr/gen.scm 106 */
obj_t arg1157_471;obj_t arg1158_472;
arg1157_471 = symbol1381___lalr_gen; 
{ /* Lalr/gen.scm 106 */
obj_t arg1159_473;obj_t arg1160_474;
arg1159_473 = symbol1377___lalr_gen; 
{ /* ./Ieee/pair-list.scm 4291 */
obj_t aux_1014;
{ /* Lalr/gen.scm 106 */
long aux_1015;
aux_1015 = 
(((long)2)*n_461); 
aux_1014 = 
BINT(aux_1015); } 
arg1160_474 = 
MAKE_PAIR(aux_1014, BNIL); } 
arg1158_472 = 
MAKE_PAIR(arg1159_473, arg1160_474); } 
arg1155_469 = 
MAKE_PAIR(arg1157_471, arg1158_472); } 
{ /* Lalr/gen.scm 107 */
obj_t arg1163_477;obj_t arg1164_478;
{ /* Lalr/gen.scm 107 */
obj_t arg1165_479;obj_t arg1166_480;
arg1165_479 = symbol1372___lalr_gen; 
arg1166_480 = 
MAKE_PAIR(nt_460, BNIL); 
arg1163_477 = 
MAKE_PAIR(arg1165_479, arg1166_480); } 
{ /* Lalr/gen.scm 106 */
obj_t arg1167_481;obj_t arg1168_482;
arg1167_481 = symbol1373___lalr_gen; 
{ /* Lalr/gen.scm 109 */
obj_t arg1169_483;
{ /* Lalr/gen.scm 109 */
obj_t arg1171_485;obj_t arg1172_486;
arg1171_485 = symbol1382___lalr_gen; 
{ /* ./Ieee/pair-list.scm 4291 */
obj_t aux_1023;
aux_1023 = 
append_2_18___r4_pairs_and_lists_6_3(act_462, BNIL); 
arg1172_486 = 
MAKE_PAIR(BNIL, aux_1023); } 
arg1169_483 = 
MAKE_PAIR(arg1171_485, arg1172_486); } 
arg1168_482 = 
MAKE_PAIR(arg1169_483, BNIL); } 
arg1164_478 = 
MAKE_PAIR(arg1167_481, arg1168_482); } 
arg1156_470 = 
MAKE_PAIR(arg1163_477, arg1164_478); } 
arg1154_468 = 
MAKE_PAIR(arg1155_469, arg1156_470); } 
arg1152_466 = 
MAKE_PAIR(arg1153_467, arg1154_468); } 
arg1145_456 = 
MAKE_PAIR(arg1151_465, arg1152_466); } 
arg1142_453 = 
MAKE_PAIR(arg1145_456, BNIL); } 
arg1140_451 = 
MAKE_PAIR(arg1141_452, arg1142_453); } 
arg1134_446 = 
MAKE_PAIR(arg1139_450, arg1140_451); } 
{ /* Lalr/gen.scm 122 */
obj_t list1135_447;
{ /* Lalr/gen.scm 122 */
obj_t arg1137_448;
arg1137_448 = 
MAKE_PAIR(arg1134_446, BNIL); 
list1135_447 = 
MAKE_PAIR(arg1133_445, arg1137_448); } 
arg1131_443 = list1135_447; } } 
arg1132_444 = 
loop_p_143___lalr_gen(l_868, nt_867, 
CDR(prods_434), 
(no_435+((long)1))); 
return 
MAKE_PAIR(arg1131_443, arg1132_444);} } } } } } } 
}



/* loop */
obj_t loop___lalr_gen(long i_493, obj_t l_494)
{ AN_OBJECT;
{ /* Lalr/gen.scm 94 */
if(
NULLP(l_494))
{ /* Lalr/gen.scm 95 */
return BNIL;}  else 
{ /* Lalr/gen.scm 97 */
obj_t sym_497;
sym_497 = 
CAR(l_494); 
{ /* Lalr/gen.scm 99 */
obj_t arg1177_498;obj_t arg1178_499;
{ /* Lalr/gen.scm 99 */
obj_t arg1179_500;obj_t arg1180_501;
if(
PAIRP(sym_497))
{ /* Lalr/gen.scm 99 */
arg1179_500 = 
CDR(sym_497); }  else 
{ /* Lalr/gen.scm 99 */
arg1179_500 = sym_497; } 
{ /* Lalr/gen.scm 100 */
obj_t arg1182_503;
{ /* Lalr/gen.scm 100 */
obj_t arg1184_505;obj_t arg1185_506;
arg1184_505 = symbol1383___lalr_gen; 
{ /* Lalr/gen.scm 100 */
obj_t arg1186_507;obj_t arg1187_508;
arg1186_507 = symbol1376___lalr_gen; 
{ /* Lalr/gen.scm 100 */
obj_t arg1188_509;
{ /* Lalr/gen.scm 100 */
obj_t arg1190_511;obj_t arg1192_512;
arg1190_511 = symbol1381___lalr_gen; 
{ /* Lalr/gen.scm 100 */
obj_t arg1193_513;obj_t arg1194_514;
arg1193_513 = symbol1377___lalr_gen; 
{ /* ./Ieee/pair-list.scm 4291 */
obj_t aux_1048;
{ /* Lalr/gen.scm 100 */
long aux_1049;
{ /* ./Ieee/fixnum.scm 2659 */
long aux_1050;
aux_1050 = 
(i_493*((long)2)); 
aux_1049 = 
(aux_1050-((long)1)); } 
aux_1048 = 
BINT(aux_1049); } 
arg1194_514 = 
MAKE_PAIR(aux_1048, BNIL); } 
arg1192_512 = 
MAKE_PAIR(arg1193_513, arg1194_514); } 
arg1188_509 = 
MAKE_PAIR(arg1190_511, arg1192_512); } 
arg1187_508 = 
MAKE_PAIR(arg1188_509, BNIL); } 
arg1185_506 = 
MAKE_PAIR(arg1186_507, arg1187_508); } 
arg1182_503 = 
MAKE_PAIR(arg1184_505, arg1185_506); } 
arg1180_501 = 
MAKE_PAIR(arg1182_503, BNIL); } 
arg1177_498 = 
MAKE_PAIR(arg1179_500, arg1180_501); } 
arg1178_499 = 
loop___lalr_gen(
(i_493-((long)1)), 
CDR(l_494)); 
return 
MAKE_PAIR(arg1177_498, arg1178_499);} } } 
}



/* reductions */
obj_t reductions___lalr_gen()
{ AN_OBJECT;
{ /* Lalr/gen.scm 111 */
return 
loop_l_5___lalr_gen(grammar___lalr_global, ((long)1));} 
}



/* imported-modules-init */
obj_t imported_modules_init_94___lalr_gen()
{ AN_OBJECT;
{ /* Lalr/gen.scm 11 */
module_initialization_70___error(((long)0), "__LALR_GEN"); 
module_initialization_70___lalr_global(((long)0), "__LALR_GEN"); 
module_initialization_70___lalr_rewrite(((long)0), "__LALR_GEN"); 
module_initialization_70___type(((long)0), "__LALR_GEN"); 
module_initialization_70___bigloo(((long)0), "__LALR_GEN"); 
module_initialization_70___tvector(((long)0), "__LALR_GEN"); 
module_initialization_70___structure(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_numbers_6_5(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_numbers_6_5_fixnum(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_numbers_6_5_flonum(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_characters_6_6(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_equivalence_6_2(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_booleans_6_1(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_symbols_6_4(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_strings_6_7(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_pairs_and_lists_6_3(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_input_6_10_2(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_control_features_6_9(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_vectors_6_8(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_ports_6_10_1(((long)0), "__LALR_GEN"); 
module_initialization_70___r4_output_6_10_3(((long)0), "__LALR_GEN"); 
return 
module_initialization_70___evenv(((long)0), "__LALR_GEN");} 
}

