/*===========================================================================*/
/*   (Lalr/util.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t filter___lalr_util(obj_t, obj_t);
static obj_t loop___221___lalr_util(obj_t, obj_t);
static obj_t _pos_in_list_3___lalr_util(obj_t, obj_t, obj_t);
static obj_t _filter___lalr_util(obj_t, obj_t, obj_t);
static obj_t loop___lalr_util(obj_t, obj_t);
extern obj_t pos_in_list_75___lalr_util(obj_t, obj_t);
static obj_t _sinsert___lalr_util(obj_t, obj_t, obj_t);
extern obj_t sunion___lalr_util(obj_t, obj_t);
extern obj_t module_initialization_70___lalr_util(long, char *);
extern obj_t module_initialization_70___error(long, char *);
static obj_t _sunion___lalr_util(obj_t, obj_t, obj_t);
extern obj_t sinsert___lalr_util(obj_t, obj_t);
static obj_t imported_modules_init_94___lalr_util();
extern bool_t equal__25___r4_equivalence_6_2(obj_t, obj_t);
static obj_t require_initialization_114___lalr_util = BUNSPEC;
static obj_t loop__120___lalr_util(obj_t, obj_t);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( sinsert_env_69___lalr_util, _sinsert___lalr_util1172, _sinsert___lalr_util, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( pos_in_list_env_163___lalr_util, _pos_in_list_3___lalr_util1173, _pos_in_list_3___lalr_util, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( filter_env_125___lalr_util, _filter___lalr_util1174, _filter___lalr_util, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( sunion_env_183___lalr_util, _sunion___lalr_util1175, _sunion___lalr_util, 0L, 2 );



/* module-initialization */
obj_t module_initialization_70___lalr_util(long checksum_612, char * from_613)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___lalr_util))
{ 
require_initialization_114___lalr_util = 
BBOOL(((bool_t)0)); 
imported_modules_init_94___lalr_util(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* pos-in-list */
obj_t pos_in_list_75___lalr_util(obj_t x_1, obj_t lst_2)
{ AN_OBJECT;
{ /* Lalr/util.scm 43 */
{ 
obj_t lst_513;long i_514;
lst_513 = lst_2; 
i_514 = ((long)0); 
loop_512:
if(
PAIRP(lst_513))
{ /* Lalr/util.scm 45 */
if(
equal__25___r4_equivalence_6_2(
CAR(lst_513), x_1))
{ /* Lalr/util.scm 46 */
return 
BINT(i_514);}  else 
{ /* Lalr/util.scm 46 */
{ 
long i_626;obj_t lst_624;
lst_624 = 
CDR(lst_513); 
i_626 = 
(i_514+((long)1)); 
i_514 = i_626; 
lst_513 = lst_624; 
goto loop_512;} } }  else 
{ /* Lalr/util.scm 45 */
return BFALSE;} } } 
}



/* _pos-in-list */
obj_t _pos_in_list_3___lalr_util(obj_t env_592, obj_t x_593, obj_t lst_594)
{ AN_OBJECT;
{ /* Lalr/util.scm 43 */
return 
pos_in_list_75___lalr_util(x_593, lst_594);} 
}



/* sunion */
obj_t sunion___lalr_util(obj_t lst1_3, obj_t lst2_4)
{ AN_OBJECT;
{ /* Lalr/util.scm 49 */
return 
loop___221___lalr_util(lst1_3, lst2_4);} 
}



/* loop'' */
obj_t loop___221___lalr_util(obj_t l1_338, obj_t l2_339)
{ AN_OBJECT;
{ /* Lalr/util.scm 50 */
loop___221___lalr_util:
if(
NULLP(l1_338))
{ /* Lalr/util.scm 52 */
return l2_339;}  else 
{ /* Lalr/util.scm 52 */
if(
NULLP(l2_339))
{ /* Lalr/util.scm 53 */
return l1_338;}  else 
{ /* Lalr/util.scm 53 */
{ /* Lalr/util.scm 55 */
obj_t x_343;obj_t y_344;
x_343 = 
CAR(l1_338); 
y_344 = 
CAR(l2_339); 
{ /* Lalr/util.scm 57 */
bool_t test_636;
{ /* ./Ieee/fixnum.scm 2331 */
long aux_639;long aux_637;
aux_639 = 
(long)CINT(y_344); 
aux_637 = 
(long)CINT(x_343); 
test_636 = 
(aux_637>aux_639); } 
if(test_636)
{ /* Lalr/util.scm 57 */
{ /* Lalr/util.scm 58 */
obj_t arg1014_346;
arg1014_346 = 
loop___221___lalr_util(l1_338, 
CDR(l2_339)); 
return 
MAKE_PAIR(y_344, arg1014_346);} }  else 
{ /* Lalr/util.scm 59 */
bool_t test_645;
{ /* ./Ieee/fixnum.scm 2325 */
long aux_648;long aux_646;
aux_648 = 
(long)CINT(y_344); 
aux_646 = 
(long)CINT(x_343); 
test_645 = 
(aux_646<aux_648); } 
if(test_645)
{ /* Lalr/util.scm 59 */
{ /* Lalr/util.scm 60 */
obj_t arg1017_349;
arg1017_349 = 
loop___221___lalr_util(
CDR(l1_338), l2_339); 
return 
MAKE_PAIR(x_343, arg1017_349);} }  else 
{ /* Lalr/util.scm 59 */
{ 
obj_t l1_654;
l1_654 = 
CDR(l1_338); 
l1_338 = l1_654; 
goto loop___221___lalr_util;} } } } } } } } 
}



/* _sunion */
obj_t _sunion___lalr_util(obj_t env_595, obj_t lst1_596, obj_t lst2_597)
{ AN_OBJECT;
{ /* Lalr/util.scm 49 */
{ /* Lalr/util.scm 49 */
obj_t lst1_606;obj_t lst2_607;
lst1_606 = lst1_596; 
lst2_607 = lst2_597; 
return 
loop___221___lalr_util(lst1_606, lst2_607);} } 
}



/* sinsert */
obj_t sinsert___lalr_util(obj_t elem_5, obj_t lst_6)
{ AN_OBJECT;
{ /* Lalr/util.scm 65 */
return 
loop__120___lalr_util(elem_5, lst_6);} 
}



/* loop' */
obj_t loop__120___lalr_util(obj_t elem_605, obj_t l1_352)
{ AN_OBJECT;
{ /* Lalr/util.scm 66 */
if(
NULLP(l1_352))
{ /* Lalr/util.scm 67 */
return 
MAKE_PAIR(elem_605, l1_352);}  else 
{ /* Lalr/util.scm 69 */
obj_t x_355;
x_355 = 
CAR(l1_352); 
{ /* Lalr/util.scm 70 */
bool_t test_662;
{ /* ./Ieee/fixnum.scm 2325 */
long aux_665;long aux_663;
aux_665 = 
(long)CINT(x_355); 
aux_663 = 
(long)CINT(elem_605); 
test_662 = 
(aux_663<aux_665); } 
if(test_662)
{ /* Lalr/util.scm 70 */
return 
MAKE_PAIR(elem_605, l1_352);}  else 
{ /* Lalr/util.scm 72 */
bool_t test_669;
{ /* ./Ieee/fixnum.scm 2331 */
long aux_672;long aux_670;
aux_672 = 
(long)CINT(x_355); 
aux_670 = 
(long)CINT(elem_605); 
test_669 = 
(aux_670>aux_672); } 
if(test_669)
{ /* Lalr/util.scm 72 */
{ /* Lalr/util.scm 73 */
obj_t arg1023_358;
arg1023_358 = 
loop__120___lalr_util(elem_605, 
CDR(l1_352)); 
return 
MAKE_PAIR(x_355, arg1023_358);} }  else 
{ /* Lalr/util.scm 72 */
return l1_352;} } } } } 
}



/* _sinsert */
obj_t _sinsert___lalr_util(obj_t env_598, obj_t elem_599, obj_t lst_600)
{ AN_OBJECT;
{ /* Lalr/util.scm 65 */
{ /* Lalr/util.scm 65 */
obj_t elem_608;obj_t lst_609;
elem_608 = elem_599; 
lst_609 = lst_600; 
return 
loop__120___lalr_util(elem_608, lst_609);} } 
}



/* filter */
obj_t filter___lalr_util(obj_t p_7, obj_t lst_8)
{ AN_OBJECT;
{ /* Lalr/util.scm 77 */
return 
loop___lalr_util(p_7, lst_8);} 
}



/* loop */
obj_t loop___lalr_util(obj_t p_604, obj_t l_360)
{ AN_OBJECT;
{ /* Lalr/util.scm 78 */
loop___lalr_util:
if(
NULLP(l_360))
{ /* Lalr/util.scm 79 */
return BNIL;}  else 
{ /* Lalr/util.scm 81 */
obj_t x_363;obj_t y_364;
x_363 = 
CAR(l_360); 
y_364 = 
CDR(l_360); 
{ /* Lalr/util.scm 82 */
bool_t test1026_365;
{ /* Lalr/util.scm 82 */
obj_t aux_684;
aux_684 = 
PROCEDURE_ENTRY(p_604)(p_604, x_363, BEOA); 
test1026_365 = 
CBOOL(aux_684); } 
if(test1026_365)
{ /* Lalr/util.scm 83 */
obj_t arg1027_366;
arg1027_366 = 
loop___lalr_util(p_604, y_364); 
return 
MAKE_PAIR(x_363, arg1027_366);}  else 
{ 
obj_t l_691;
l_691 = y_364; 
l_360 = l_691; 
goto loop___lalr_util;} } } } 
}



/* _filter */
obj_t _filter___lalr_util(obj_t env_601, obj_t p_602, obj_t lst_603)
{ AN_OBJECT;
{ /* Lalr/util.scm 77 */
{ /* Lalr/util.scm 77 */
obj_t p_610;obj_t lst_611;
p_610 = p_602; 
lst_611 = lst_603; 
return 
loop___lalr_util(p_610, lst_611);} } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___lalr_util()
{ AN_OBJECT;
{ /* Lalr/util.scm 11 */
return 
module_initialization_70___error(((long)0), "__LALR_UTIL");} 
}

