/*===========================================================================*/
/*   (Llib/bexit.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t unwind_until__178___bexit(obj_t, obj_t);
static obj_t _unwind_until__238___bexit(obj_t, obj_t, obj_t);
extern obj_t unwind_stack_until(obj_t, obj_t, obj_t, obj_t);
static obj_t _protected_val__170___bexit = BUNSPEC;
obj_t exitd_top = BUNSPEC;
static obj_t toplevel_init_63___bexit();
extern bool_t unwind_stack_value_p(obj_t);
static obj_t _val_from_exit__167___bexit(obj_t, obj_t);
extern obj_t module_initialization_70___bexit(long, char *);
extern obj_t module_initialization_70___error(long, char *);
static obj_t _unwind_stack_until__173___bexit(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _unwind_stack_value__112___bexit(obj_t, obj_t);
static obj_t imported_modules_init_94___bexit();
extern obj_t val_from_exit__100___bexit(obj_t);
static obj_t require_initialization_114___bexit = BUNSPEC;
obj_t exitd_stamp = BUNSPEC;
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( unwind_until__env_204___bexit, _unwind_until__238___bexit1180, _unwind_until__238___bexit, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( val_from_exit__env_189___bexit, _val_from_exit__167___bexit1181, _val_from_exit__167___bexit, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( unwind_stack_value__env_181___bexit, _unwind_stack_value__112___bexit1182, _unwind_stack_value__112___bexit, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( unwind_stack_until__env_164___bexit, _unwind_stack_until__173___bexit1183, _unwind_stack_until__173___bexit, 0L, 4 );
DEFINE_STRING( string1178___bexit, string1178___bexit1184, "exit out of dynamic scope", 25 );
DEFINE_STRING( string1177___bexit, string1177___bexit1185, "unwind-until!", 13 );



/* module-initialization */
obj_t module_initialization_70___bexit(long checksum_452, char * from_453)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___bexit))
{ 
require_initialization_114___bexit = 
BBOOL(((bool_t)0)); 
imported_modules_init_94___bexit(); 
toplevel_init_63___bexit(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* toplevel-init */
obj_t toplevel_init_63___bexit()
{ AN_OBJECT;
{ /* Llib/bexit.scm 14 */
exitd_top = BFALSE; 
exitd_stamp = 
BINT(((long)0)); 
return ( 
_protected_val__170___bexit = 
MAKE_PAIR(BUNSPEC, BUNSPEC), BUNSPEC) ;} 
}



/* val-from-exit? */
obj_t val_from_exit__100___bexit(obj_t val_1)
{ AN_OBJECT;
{ /* Llib/bexit.scm 71 */
{ /* ./Ieee/equiv.scm 1480 */
bool_t aux_461;
aux_461 = 
(val_1==_protected_val__170___bexit); 
return 
BBOOL(aux_461);} } 
}



/* _val-from-exit? */
obj_t _val_from_exit__167___bexit(obj_t env_440, obj_t val_441)
{ AN_OBJECT;
{ /* Llib/bexit.scm 71 */
return 
val_from_exit__100___bexit(val_441);} 
}



/* unwind-stack-value? */
bool_t unwind_stack_value_p(obj_t val_2)
{ AN_OBJECT;
{ /* Llib/bexit.scm 82 */
return 
(val_2==_protected_val__170___bexit);} 
}



/* _unwind-stack-value? */
obj_t _unwind_stack_value__112___bexit(obj_t env_442, obj_t val_443)
{ AN_OBJECT;
{ /* Llib/bexit.scm 82 */
{ /* Llib/bexit.scm 82 */
bool_t aux_466;
aux_466 = 
unwind_stack_value_p(val_443); 
return 
BBOOL(aux_466);} } 
}



/* unwind-until! */
obj_t unwind_until__178___bexit(obj_t exitd_3, obj_t val_4)
{ AN_OBJECT;
{ /* Llib/bexit.scm 92 */
if(
PAIRP(exitd_3))
{ /* Llib/bexit.scm 93 */
return 
unwind_stack_until(
CAR(exitd_3), BFALSE, val_4, 
CDR(exitd_3));}  else 
{ /* Llib/bexit.scm 93 */
return 
unwind_stack_until(exitd_3, BFALSE, val_4, BFALSE);} } 
}



/* _unwind-until! */
obj_t _unwind_until__238___bexit(obj_t env_444, obj_t exitd_445, obj_t val_446)
{ AN_OBJECT;
{ /* Llib/bexit.scm 92 */
return 
unwind_until__178___bexit(exitd_445, val_446);} 
}



/* unwind-stack-until! */
obj_t unwind_stack_until(obj_t exitd_5, obj_t estamp_6, obj_t val_7, obj_t proc_8)
{ AN_OBJECT;
{ /* Llib/bexit.scm 105 */
{ 

loop_240:
{ /* Llib/bexit.scm 107 */
bool_t test1008_241;
{ /* Llib/bexit.scm 107 */
obj_t obj1_420;
obj1_420 = exitd_top; 
test1008_241 = 
(obj1_420==BFALSE); } 
if(test1008_241)
{ /* Llib/bexit.scm 107 */
if(
PROCEDUREP(proc_8))
{ /* Llib/bexit.scm 108 */
return 
PROCEDURE_ENTRY(proc_8)(proc_8, val_7, BEOA);}  else 
{ /* Llib/bexit.scm 108 */
FAILURE(string1177___bexit,string1178___bexit,BUNSPEC);} }  else 
{ /* Llib/bexit.scm 113 */
obj_t exit_top_38_243;
exit_top_38_243 = exitd_top; 
POP_EXIT(); 
{ /* Llib/bexit.scm 116 */
bool_t test1010_244;
if(
(exit_top_38_243==exitd_5))
{ /* Llib/bexit.scm 117 */
bool_t _ortest_1002_248;
if(
INTEGERP(estamp_6))
{ /* Llib/bexit.scm 117 */
_ortest_1002_248 = ((bool_t)0); }  else 
{ /* Llib/bexit.scm 117 */
_ortest_1002_248 = ((bool_t)1); } 
if(_ortest_1002_248)
{ /* Llib/bexit.scm 117 */
test1010_244 = _ortest_1002_248; }  else 
{ /* Llib/bexit.scm 118 */
obj_t arg1014_249;
arg1014_249 = 
EXITD_STAMP(exit_top_38_243); 
{ /* ./Ieee/fixnum.scm 3133 */
long aux_492;long aux_490;
aux_492 = 
(long)CINT(estamp_6); 
aux_490 = 
(long)CINT(arg1014_249); 
test1010_244 = 
(aux_490==aux_492); } } }  else 
{ /* Llib/bexit.scm 116 */
test1010_244 = ((bool_t)0); } 
if(test1010_244)
{ /* Llib/bexit.scm 116 */
JUMP_EXIT( 
EXITD_TO_EXIT(exit_top_38_243),val_7); }  else 
{ /* Llib/bexit.scm 120 */
bool_t test1011_245;
test1011_245 = 
EXITD_USERP(exit_top_38_243); 
if(test1011_245)
{ /* Llib/bexit.scm 120 */
goto loop_240;}  else 
{ /* Llib/bexit.scm 120 */
{ /* Llib/bexit.scm 121 */
obj_t arg1012_246;
arg1012_246 = 
MAKE_PAIR(exitd_5, proc_8); 
SET_CAR(_protected_val__170___bexit, arg1012_246); } 
SET_CDR(_protected_val__170___bexit, val_7); 
JUMP_EXIT( 
EXITD_TO_EXIT(exit_top_38_243),_protected_val__170___bexit); } } } } } } } 
}



/* _unwind-stack-until! */
obj_t _unwind_stack_until__173___bexit(obj_t env_447, obj_t exitd_448, obj_t estamp_449, obj_t val_450, obj_t proc_451)
{ AN_OBJECT;
{ /* Llib/bexit.scm 105 */
return 
unwind_stack_until(exitd_448, estamp_449, val_450, proc_451);} 
}



/* imported-modules-init */
obj_t imported_modules_init_94___bexit()
{ AN_OBJECT;
{ /* Llib/bexit.scm 14 */
return 
module_initialization_70___error(((long)0), "__BEXIT");} 
}

