/*===========================================================================*/
/*   (Llib/custom.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t custom_identifier_set__114___custom(obj_t, char *);
static obj_t _custom_identifier_set__244___custom(obj_t, obj_t, obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t module_initialization_70___custom(long, char *);
extern obj_t module_initialization_70___error(long, char *);
static obj_t _custom_identifier_48___custom(obj_t, obj_t);
static obj_t _custom__16___custom(obj_t, obj_t);
extern bool_t custom_equal__151___custom(obj_t, obj_t);
extern char * custom_identifier_29___custom(obj_t);
static obj_t _custom_hash_56___custom(obj_t, obj_t, obj_t);
static obj_t _custom_equal__83___custom(obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94___custom();
static obj_t require_initialization_114___custom = BUNSPEC;
extern bool_t custom__47___custom(obj_t);
extern obj_t custom_hash_185___custom(obj_t, int);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( custom_hash_env_203___custom, _custom_hash_56___custom1146, _custom_hash_56___custom, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( custom_identifier_set__env_16___custom, _custom_identifier_set__244___custom1147, _custom_identifier_set__244___custom, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( custom_identifier_env_117___custom, _custom_identifier_48___custom1148, _custom_identifier_48___custom, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( custom__env_61___custom, _custom__16___custom1149, _custom__16___custom, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( custom_equal__env_101___custom, _custom_equal__83___custom1150, _custom_equal__83___custom, 0L, 2 );



/* module-initialization */
obj_t module_initialization_70___custom(long checksum_435, char * from_436)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___custom))
{ 
require_initialization_114___custom = 
BBOOL(((bool_t)0)); 
imported_modules_init_94___custom(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* custom? */
bool_t custom__47___custom(obj_t obj_1)
{ AN_OBJECT;
{ /* Llib/custom.scm 55 */
return 
CUSTOMP(obj_1);} 
}



/* _custom? */
obj_t _custom__16___custom(obj_t env_416, obj_t obj_417)
{ AN_OBJECT;
{ /* Llib/custom.scm 55 */
{ /* Llib/custom.scm 55 */
bool_t aux_442;
{ /* Llib/custom.scm 55 */
obj_t obj_429;
obj_429 = obj_417; 
aux_442 = 
CUSTOMP(obj_429); } 
return 
BBOOL(aux_442);} } 
}



/* custom-equal? */
bool_t custom_equal__151___custom(obj_t obj1_2, obj_t obj2_3)
{ AN_OBJECT;
{ /* Llib/custom.scm 61 */
return 
CUSTOM_CMP(obj1_2, obj2_3);} 
}



/* _custom-equal? */
obj_t _custom_equal__83___custom(obj_t env_418, obj_t obj1_419, obj_t obj2_420)
{ AN_OBJECT;
{ /* Llib/custom.scm 61 */
{ /* Llib/custom.scm 61 */
bool_t aux_446;
{ /* Llib/custom.scm 61 */
obj_t obj1_430;obj_t obj2_431;
obj1_430 = obj1_419; 
obj2_431 = obj2_420; 
aux_446 = 
CUSTOM_CMP(obj1_430, obj2_431); } 
return 
BBOOL(aux_446);} } 
}



/* custom-identifier */
char * custom_identifier_29___custom(obj_t custom_4)
{ AN_OBJECT;
{ /* Llib/custom.scm 67 */
return 
CUSTOM_IDENTIFIER(custom_4);} 
}



/* _custom-identifier */
obj_t _custom_identifier_48___custom(obj_t env_421, obj_t custom_422)
{ AN_OBJECT;
{ /* Llib/custom.scm 67 */
{ /* Llib/custom.scm 67 */
char * aux_450;
{ /* Llib/custom.scm 67 */
obj_t custom_432;
custom_432 = custom_422; 
aux_450 = 
CUSTOM_IDENTIFIER(custom_432); } 
return 
string_to_bstring(aux_450);} } 
}



/* custom-identifier-set! */
obj_t custom_identifier_set__114___custom(obj_t custom_5, char * str_6)
{ AN_OBJECT;
{ /* Llib/custom.scm 73 */
return 
CUSTOM_IDENTIFIER_SET(custom_5, str_6);} 
}



/* _custom-identifier-set! */
obj_t _custom_identifier_set__244___custom(obj_t env_423, obj_t custom_424, obj_t str_425)
{ AN_OBJECT;
{ /* Llib/custom.scm 73 */
{ /* Llib/custom.scm 73 */
obj_t custom_433;char * str_434;
custom_433 = custom_424; 
str_434 = 
BSTRING_TO_STRING(str_425); 
return 
CUSTOM_IDENTIFIER_SET(custom_433, str_434);} } 
}



/* custom-hash */
obj_t custom_hash_185___custom(obj_t custom_7, int mod_8)
{ AN_OBJECT;
{ /* Llib/custom.scm 79 */
{ /* Llib/custom.scm 80 */
int num_410;
num_410 = 
CUSTOM_HASH_NUMBER(custom_7); 
{ /* ./Ieee/fixnum.scm 1931 */
long aux_457;
{ /* ./Ieee/fixnum.scm 1931 */
long aux_460;long aux_458;
aux_460 = 
(long)(mod_8); 
aux_458 = 
(long)(num_410); 
aux_457 = 
(aux_458%aux_460); } 
return 
BINT(aux_457);} } } 
}



/* _custom-hash */
obj_t _custom_hash_56___custom(obj_t env_426, obj_t custom_427, obj_t mod_428)
{ AN_OBJECT;
{ /* Llib/custom.scm 79 */
return 
custom_hash_185___custom(custom_427, 
CINT(mod_428));} 
}



/* imported-modules-init */
obj_t imported_modules_init_94___custom()
{ AN_OBJECT;
{ /* Llib/custom.scm 14 */
return 
module_initialization_70___error(((long)0), "__CUSTOM");} 
}

