/*===========================================================================*/
/*   (Llib/socket.scm)                                                       */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*    ---------------------------------------------------------------------  */
/*       A practical implementation for the Scheme programming language      */
/*                                                                           */
/*                                       ,--^,                               */
/*                                 _ ___/ /|/                                */
/*                             ,;'( )__, ) '                                 */
/*                            ;;  //   L__.                                  */
/*                            '   \   /  '                                   */
/*                                 ^   ^                                     */
/*                                                                           */
/*                  Copyright (c) 1992-1999 Manuel Serrano                   */
/*                                                                           */
/*        Bug descriptions, use reports, comments or suggestions are         */
/*        welcome. Send them to                                              */
/*          bigloo@kaolin.unice.fr                                           */
/*          http://kaolin.unice.fr/bigloo                                    */
/*                                                                           */
/*      This program is free software; you can redistribute it               */
/*      and/or modify it under the terms of the GNU General Public           */
/*      License as published by the Free Software Foundation; either         */
/*      version 2 of the License, or (at your option) any later version.     */
/*                                                                           */
/*      This program is distributed in the hope that it will be useful,      */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/*      GNU General Public License for more details.                         */
/*                                                                           */
/*      You should have received a copy of the GNU General Public            */
/*      License along with this program; if not, write to the Free           */
/*      Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,      */
/*      MA 02111-1307, USA.                                                  */
/*   ---------------------------------------------------------------------   */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>
#include <signal.h>

extern obj_t socket_host_address_114___socket(obj_t);
extern obj_t socket_port_number_142___socket(obj_t);
static obj_t _socket_port_number_87___socket(obj_t, obj_t);
static obj_t _socket_shutdown_189___socket(obj_t, obj_t, obj_t);
extern obj_t socket_output_115___socket(obj_t);
static obj_t _socket_hostname_50___socket(obj_t, obj_t);
extern obj_t socket_shutdown(obj_t, bool_t);
static obj_t _socket_output_22___socket(obj_t, obj_t);
extern obj_t make_server_socket(int);
extern obj_t socket_dup_120___socket(obj_t);
static obj_t _socket_local_address_218___socket(obj_t, obj_t);
extern bool_t socket_down__159___socket(obj_t);
extern obj_t socket_local_addr(obj_t);
extern obj_t make_server_socket_214___socket(obj_t);
extern obj_t socket_dup(obj_t);
static obj_t _make_server_socket_127___socket(obj_t, obj_t);
static obj_t _socket_host_address_221___socket(obj_t, obj_t);
static obj_t _socket_accept_connection_223___socket(obj_t, obj_t);
static obj_t _socket_input_55___socket(obj_t, obj_t);
extern obj_t module_initialization_70___socket(long, char *);
extern obj_t module_initialization_70___error(long, char *);
static obj_t _socket__179___socket(obj_t, obj_t);
extern obj_t make_client_socket(obj_t, int);
extern obj_t socket_accept_connection(obj_t);
extern obj_t socket_shutdown_97___socket(obj_t, obj_t);
extern obj_t make_client_socket_228___socket(obj_t, int);
extern obj_t socket_hostname_170___socket(obj_t);
static obj_t imported_modules_init_94___socket();
extern bool_t socket__65___socket(obj_t);
extern obj_t socket_accept_connection_52___socket(obj_t);
extern obj_t socket_local_address_209___socket(obj_t);
static obj_t _make_client_socket_221___socket(obj_t, obj_t, obj_t);
static obj_t require_initialization_114___socket = BUNSPEC;
static obj_t _socket_dup_164___socket(obj_t, obj_t);
static obj_t _socket_down__147___socket(obj_t, obj_t);
extern obj_t socket_input_208___socket(obj_t);
static obj_t *__cnst;

DEFINE_EXPORT_PROCEDURE( socket_input_env_54___socket, _socket_input_55___socket1150, _socket_input_55___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( make_client_socket_env_140___socket, _make_client_socket_221___socket1151, _make_client_socket_221___socket, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( socket__env_32___socket, _socket__179___socket1152, _socket__179___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_shutdown_env_247___socket, _socket_shutdown_189___socket1153, va_generic_entry, _socket_shutdown_189___socket, -2 );
DEFINE_EXPORT_PROCEDURE( socket_hostname_env_89___socket, _socket_hostname_50___socket1154, _socket_hostname_50___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_host_address_env_16___socket, _socket_host_address_221___socket1155, _socket_host_address_221___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_local_address_env_78___socket, _socket_local_address_218___socket1156, _socket_local_address_218___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_dup_env_192___socket, _socket_dup_164___socket1157, _socket_dup_164___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_output_env_172___socket, _socket_output_22___socket1158, _socket_output_22___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_accept_connection_env_59___socket, _socket_accept_connection_223___socket1159, _socket_accept_connection_223___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( socket_down__env_139___socket, _socket_down__147___socket1160, _socket_down__147___socket, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( make_server_socket_env_103___socket, _make_server_socket_127___socket1161, va_generic_entry, _make_server_socket_127___socket, -1 );
DEFINE_EXPORT_PROCEDURE( socket_port_number_env_160___socket, _socket_port_number_87___socket1162, _socket_port_number_87___socket, 0L, 1 );



/* module-initialization */
obj_t module_initialization_70___socket(long checksum_474, char * from_475)
{ AN_OBJECT;
{ 
if(
CBOOL(require_initialization_114___socket))
{ 
require_initialization_114___socket = 
BBOOL(((bool_t)0)); 
imported_modules_init_94___socket(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* socket? */
bool_t socket__65___socket(obj_t obj_1)
{ AN_OBJECT;
{ /* Llib/socket.scm 76 */
return 
SOCKETP(obj_1);} 
}



/* _socket? */
obj_t _socket__179___socket(obj_t env_431, obj_t obj_432)
{ AN_OBJECT;
{ /* Llib/socket.scm 76 */
{ /* Llib/socket.scm 76 */
bool_t aux_481;
{ /* Llib/socket.scm 76 */
obj_t obj_459;
obj_459 = obj_432; 
aux_481 = 
SOCKETP(obj_459); } 
return 
BBOOL(aux_481);} } 
}



/* socket-hostname */
obj_t socket_hostname_170___socket(obj_t socket_2)
{ AN_OBJECT;
{ /* Llib/socket.scm 82 */
return 
SOCKET_HOSTNAME(socket_2);} 
}



/* _socket-hostname */
obj_t _socket_hostname_50___socket(obj_t env_433, obj_t socket_434)
{ AN_OBJECT;
{ /* Llib/socket.scm 82 */
{ /* Llib/socket.scm 82 */
obj_t socket_460;
socket_460 = socket_434; 
return 
SOCKET_HOSTNAME(socket_460);} } 
}



/* socket-host-address */
obj_t socket_host_address_114___socket(obj_t socket_3)
{ AN_OBJECT;
{ /* Llib/socket.scm 88 */
return 
SOCKET_HOSTIP(socket_3);} 
}



/* _socket-host-address */
obj_t _socket_host_address_221___socket(obj_t env_435, obj_t socket_436)
{ AN_OBJECT;
{ /* Llib/socket.scm 88 */
{ /* Llib/socket.scm 88 */
obj_t socket_461;
socket_461 = socket_436; 
return 
SOCKET_HOSTIP(socket_461);} } 
}



/* socket-down? */
bool_t socket_down__159___socket(obj_t socket_4)
{ AN_OBJECT;
{ /* Llib/socket.scm 94 */
return 
SOCKET_DOWNP(socket_4);} 
}



/* _socket-down? */
obj_t _socket_down__147___socket(obj_t env_437, obj_t socket_438)
{ AN_OBJECT;
{ /* Llib/socket.scm 94 */
{ /* Llib/socket.scm 94 */
bool_t aux_489;
{ /* Llib/socket.scm 94 */
obj_t socket_462;
socket_462 = socket_438; 
aux_489 = 
SOCKET_DOWNP(socket_462); } 
return 
BBOOL(aux_489);} } 
}



/* socket-port-number */
obj_t socket_port_number_142___socket(obj_t socket_5)
{ AN_OBJECT;
{ /* Llib/socket.scm 100 */
{ /* Llib/socket.scm 101 */
int aux_492;
aux_492 = 
SOCKET_PORT(socket_5); 
return 
BINT(aux_492);} } 
}



/* _socket-port-number */
obj_t _socket_port_number_87___socket(obj_t env_439, obj_t socket_440)
{ AN_OBJECT;
{ /* Llib/socket.scm 100 */
{ /* Llib/socket.scm 100 */
obj_t socket_463;
socket_463 = socket_440; 
{ /* Llib/socket.scm 101 */
int aux_495;
aux_495 = 
SOCKET_PORT(socket_463); 
return 
BINT(aux_495);} } } 
}



/* socket-input */
obj_t socket_input_208___socket(obj_t socket_6)
{ AN_OBJECT;
{ /* Llib/socket.scm 106 */
return 
SOCKET_INPUT(socket_6);} 
}



/* _socket-input */
obj_t _socket_input_55___socket(obj_t env_441, obj_t socket_442)
{ AN_OBJECT;
{ /* Llib/socket.scm 106 */
{ /* Llib/socket.scm 106 */
obj_t socket_464;
socket_464 = socket_442; 
return 
SOCKET_INPUT(socket_464);} } 
}



/* socket-output */
obj_t socket_output_115___socket(obj_t socket_7)
{ AN_OBJECT;
{ /* Llib/socket.scm 112 */
return 
SOCKET_OUTPUT(socket_7);} 
}



/* _socket-output */
obj_t _socket_output_22___socket(obj_t env_443, obj_t socket_444)
{ AN_OBJECT;
{ /* Llib/socket.scm 112 */
{ /* Llib/socket.scm 112 */
obj_t socket_465;
socket_465 = socket_444; 
return 
SOCKET_OUTPUT(socket_465);} } 
}



/* make-client-socket */
obj_t make_client_socket_228___socket(obj_t hostname_8, int port_number_220_9)
{ AN_OBJECT;
{ /* Llib/socket.scm 118 */
return 
make_client_socket(hostname_8, port_number_220_9);} 
}



/* _make-client-socket */
obj_t _make_client_socket_221___socket(obj_t env_445, obj_t hostname_446, obj_t port_number_220_447)
{ AN_OBJECT;
{ /* Llib/socket.scm 118 */
{ /* Llib/socket.scm 118 */
obj_t hostname_466;int port_number_220_467;
hostname_466 = hostname_446; 
port_number_220_467 = 
CINT(port_number_220_447); 
return 
make_client_socket(hostname_466, port_number_220_467);} } 
}



/* make-server-socket */
obj_t make_server_socket_214___socket(obj_t port_number_220_10)
{ AN_OBJECT;
{ /* Llib/socket.scm 124 */
{ /* Llib/socket.scm 125 */
int aux_505;
{ /* Llib/socket.scm 125 */
obj_t aux_506;
if(
NULLP(port_number_220_10))
{ /* Llib/socket.scm 125 */
aux_506 = 
BINT(((long)0))
; }  else 
{ /* Llib/socket.scm 125 */
aux_506 = 
CAR(port_number_220_10)
; } 
aux_505 = 
CINT(aux_506); } 
return 
make_server_socket(aux_505);} } 
}



/* _make-server-socket */
obj_t _make_server_socket_127___socket(obj_t env_448, obj_t port_number_220_449)
{ AN_OBJECT;
{ /* Llib/socket.scm 124 */
{ /* Llib/socket.scm 124 */
obj_t port_number_220_468;
port_number_220_468 = port_number_220_449; 
{ /* Llib/socket.scm 125 */
int aux_513;
{ /* Llib/socket.scm 125 */
obj_t aux_514;
if(
NULLP(port_number_220_468))
{ /* Llib/socket.scm 125 */
aux_514 = 
BINT(((long)0))
; }  else 
{ /* Llib/socket.scm 125 */
aux_514 = 
CAR(port_number_220_468)
; } 
aux_513 = 
CINT(aux_514); } 
return 
make_server_socket(aux_513);} } } 
}



/* socket-accept-connection */
obj_t socket_accept_connection_52___socket(obj_t socket_11)
{ AN_OBJECT;
{ /* Llib/socket.scm 130 */
return 
socket_accept_connection(socket_11);} 
}



/* _socket-accept-connection */
obj_t _socket_accept_connection_223___socket(obj_t env_450, obj_t socket_451)
{ AN_OBJECT;
{ /* Llib/socket.scm 130 */
{ /* Llib/socket.scm 130 */
obj_t socket_469;
socket_469 = socket_451; 
return 
socket_accept_connection(socket_469);} } 
}



/* socket-local-address */
obj_t socket_local_address_209___socket(obj_t socket_12)
{ AN_OBJECT;
{ /* Llib/socket.scm 136 */
return 
socket_local_addr(socket_12);} 
}



/* _socket-local-address */
obj_t _socket_local_address_218___socket(obj_t env_452, obj_t socket_453)
{ AN_OBJECT;
{ /* Llib/socket.scm 136 */
{ /* Llib/socket.scm 136 */
obj_t socket_470;
socket_470 = socket_453; 
return 
socket_local_addr(socket_470);} } 
}



/* socket-dup */
obj_t socket_dup_120___socket(obj_t socket_13)
{ AN_OBJECT;
{ /* Llib/socket.scm 142 */
return 
socket_dup(socket_13);} 
}



/* _socket-dup */
obj_t _socket_dup_164___socket(obj_t env_454, obj_t socket_455)
{ AN_OBJECT;
{ /* Llib/socket.scm 142 */
{ /* Llib/socket.scm 142 */
obj_t socket_471;
socket_471 = socket_455; 
return 
socket_dup(socket_471);} } 
}



/* socket-shutdown */
obj_t socket_shutdown_97___socket(obj_t socket_14, obj_t close_15)
{ AN_OBJECT;
{ /* Llib/socket.scm 148 */
{ /* Llib/socket.scm 149 */
bool_t aux_527;
{ /* Llib/socket.scm 149 */
obj_t aux_528;
if(
PAIRP(close_15))
{ /* Llib/socket.scm 149 */
aux_528 = 
CAR(close_15)
; }  else 
{ /* Llib/socket.scm 149 */
aux_528 = BTRUE
; } 
aux_527 = 
CBOOL(aux_528); } 
return 
socket_shutdown(socket_14, aux_527);} } 
}



/* _socket-shutdown */
obj_t _socket_shutdown_189___socket(obj_t env_456, obj_t socket_457, obj_t close_458)
{ AN_OBJECT;
{ /* Llib/socket.scm 148 */
{ /* Llib/socket.scm 148 */
obj_t socket_472;obj_t close_473;
socket_472 = socket_457; 
close_473 = close_458; 
{ /* Llib/socket.scm 149 */
bool_t aux_534;
{ /* Llib/socket.scm 149 */
obj_t aux_535;
if(
PAIRP(close_473))
{ /* Llib/socket.scm 149 */
aux_535 = 
CAR(close_473)
; }  else 
{ /* Llib/socket.scm 149 */
aux_535 = BTRUE
; } 
aux_534 = 
CBOOL(aux_535); } 
return 
socket_shutdown(socket_472, aux_534);} } } 
}



/* imported-modules-init */
obj_t imported_modules_init_94___socket()
{ AN_OBJECT;
{ /* Llib/socket.scm 15 */
return 
module_initialization_70___error(((long)0), "__SOCKET");} 
}

